#define OPT_REFR
#define OPT_LEVEL REFR
#define OPT_PREFIX _refr_
#undef __FWJPEG_OPT_H__
#include "fwJPEG_opt.h"
#undef OPT_REFR
#undef OPT_LEVEL
#undef OPT_PREFIX


#define OPT_SSE2
#define OPT_LEVEL SSE2
#define OPT_PREFIX _sse2_
#undef __FWJPEG_OPT_H__
#include "fwJPEG_opt.h"
#undef OPT_SSE2
#undef OPT_LEVEL
#undef OPT_PREFIX


#define OPT_F10H
#define OPT_LEVEL F10H
#define OPT_PREFIX _f10h_
#undef __FWJPEG_OPT_H__
#include "fwJPEG_opt.h"
#undef OPT_F10H
#undef OPT_LEVEL
#undef OPT_PREFIX


#define OPT_SSE3
#define OPT_LEVEL SSE3
#define OPT_PREFIX _sse3_
#undef __FWJPEG_OPT_H__
#include "fwJPEG_opt.h"
#undef OPT_SSE3
#undef OPT_LEVEL
#undef OPT_PREFIX


using namespace REFR;

OREFR       FwStatus STDCALL fwiYCbCrToRGB_JPEG_8u_P3R(const Fw8u* const pSrcYCbCr[3], int srcStep, 
							Fw8u* pDstRGB[3], int dstStep, FwiSize roiSize)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiYCbCrToRGB_JPEG_8u_P3R(pSrcYCbCr, srcStep, pDstRGB, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiYCbCrToRGB_JPEG_8u_P3R(pSrcYCbCr, srcStep, pDstRGB, dstStep, roiSize);
    }
}

OREFR       FwStatus STDCALL fwiYCCK411ToCMYKLS_MCU_16s8u_P4C4R(const Fw16s* pSrcMCU[4],
							Fw8u* pDstCMYK, int dstStep)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiYCCK411ToCMYKLS_MCU_16s8u_P4C4R(pSrcMCU, pDstCMYK, dstStep);
    default:
        assert(false);
        return _refr_fwiYCCK411ToCMYKLS_MCU_16s8u_P4C4R(pSrcMCU, pDstCMYK, dstStep);
    }
}


OREFR       FwStatus STDCALL fwiEncodeHuffman8x8_DCRefine_JPEG_16s1u_C1(const Fw16s* pSrc,
							Fw8u* pDst, int dstLenBytes, int* pDstCurrPos, int Al,
							FwiEncodeHuffmanState* pEncHuffState, int bFlushState)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiEncodeHuffman8x8_DCRefine_JPEG_16s1u_C1(pSrc, pDst, dstLenBytes, pDstCurrPos, Al, pEncHuffState, bFlushState);
    default:
        assert(false);
        return _refr_fwiEncodeHuffman8x8_DCRefine_JPEG_16s1u_C1(pSrc, pDst, dstLenBytes, pDstCurrPos, Al, pEncHuffState, bFlushState);
    }
}


OREFR       FwStatus STDCALL fwiQuantFwd8x8_JPEG_16s_C1I(Fw16s* pSrcDst, const Fw16u* pQuantFwdTable)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiQuantFwd8x8_JPEG_16s_C1I(pSrcDst, pQuantFwdTable);
    default:
        assert(false);
        return _refr_fwiQuantFwd8x8_JPEG_16s_C1I(pSrcDst, pQuantFwdTable);
    }
}


OREFR       FwStatus STDCALL fwiDecodeHuffman8x8_ACRefine_JPEG_1u16s_C1(const Fw8u* pSrc,
							int srcLenBytes, int* pSrcCurrPos, Fw16s* pDst, 
							int* pMarker, int Ss, int Se, int Al, 
							const FwiDecodeHuffmanSpec* pAcTable,
							FwiDecodeHuffmanState* pDecHuffState)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiDecodeHuffman8x8_ACRefine_JPEG_1u16s_C1(pSrc, srcLenBytes, pSrcCurrPos, pDst, pMarker, Ss, Se, Al, pAcTable, pDecHuffState);
    default:
        assert(false);
        return _refr_fwiDecodeHuffman8x8_ACRefine_JPEG_1u16s_C1(pSrc, srcLenBytes, pSrcCurrPos, pDst, pMarker, Ss, Se, Al, pAcTable, pDecHuffState);
    }
}


OREFR OSSE2 FwStatus STDCALL fwiSampleDownRowH2V2_Box_JPEG_8u_C1(const Fw8u* pSrc1, const Fw8u* pSrc2,
							int srcWidth, Fw8u* pDst)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiSampleDownRowH2V2_Box_JPEG_8u_C1(pSrc1, pSrc2, srcWidth, pDst);
    case DT_REFR:
        return _refr_fwiSampleDownRowH2V2_Box_JPEG_8u_C1(pSrc1, pSrc2, srcWidth, pDst);
    default:
        assert(false);
        return _refr_fwiSampleDownRowH2V2_Box_JPEG_8u_C1(pSrc1, pSrc2, srcWidth, pDst);
    }
}


OREFR       FwStatus STDCALL fwiEncodeHuffmanStateGetBufSize_JPEG_8u(int* pSize)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiEncodeHuffmanStateGetBufSize_JPEG_8u(pSize);
    default:
        assert(false);
        return _refr_fwiEncodeHuffmanStateGetBufSize_JPEG_8u(pSize);
    }
}


OREFR       FwStatus STDCALL fwiSub128_JPEG_8u16s_C1R(const Fw8u* pSrc, int srcStep, 
							Fw16s* pDst, int dstStep, FwiSize roiSize)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiSub128_JPEG_8u16s_C1R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiSub128_JPEG_8u16s_C1R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 FwStatus STDCALL fwiYCbCr422ToBGRLS_MCU_16s8u_P3C3R(const Fw16s* pSrcMCU[3],
							Fw8u* pDstBGR, int dstStep)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiYCbCr422ToBGRLS_MCU_16s8u_P3C3R(pSrcMCU, pDstBGR, dstStep);
    case DT_REFR:
        return _refr_fwiYCbCr422ToBGRLS_MCU_16s8u_P3C3R(pSrcMCU, pDstBGR, dstStep);
    default:
        assert(false);
        return _refr_fwiYCbCr422ToBGRLS_MCU_16s8u_P3C3R(pSrcMCU, pDstBGR, dstStep);
    }
}


OREFR       FwStatus STDCALL fwiEncodeHuffmanRawTableInit_JPEG_8u(const int pStatistics[256],
							Fw8u* pListBits, Fw8u* pListVals)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiEncodeHuffmanRawTableInit_JPEG_8u(pStatistics, pListBits, pListVals);
    default:
        assert(false);
        return _refr_fwiEncodeHuffmanRawTableInit_JPEG_8u(pStatistics, pListBits, pListVals);
    }
}


OREFR       FwStatus STDCALL fwiEncodeHuffman8x8_ACRefine_JPEG_16s1u_C1(const Fw16s* pSrc,
							Fw8u* pDst, int dstLenBytes, int* pDstCurrPos, int Ss, 
							int Se, int Al, const FwiEncodeHuffmanSpec* pAcTable, 
							FwiEncodeHuffmanState* pEncHuffState, int bFlushState)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiEncodeHuffman8x8_ACRefine_JPEG_16s1u_C1(pSrc, pDst, dstLenBytes, pDstCurrPos, Ss, Se, Al, pAcTable, pEncHuffState, bFlushState);
    default:
        assert(false);
        return _refr_fwiEncodeHuffman8x8_ACRefine_JPEG_16s1u_C1(pSrc, pDst, dstLenBytes, pDstCurrPos, Ss, Se, Al, pAcTable, pEncHuffState, bFlushState);
    }
}


OREFR OSSE2 FwStatus STDCALL fwiRGBToYCbCr422LS_MCU_8u16s_C3P3R(const Fw8u* pSrcRGB, int srcStep, 
							Fw16s* pDstMCU[3])
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiRGBToYCbCr422LS_MCU_8u16s_C3P3R(pSrcRGB, srcStep, pDstMCU);
    case DT_REFR:
        return _refr_fwiRGBToYCbCr422LS_MCU_8u16s_C3P3R(pSrcRGB, srcStep, pDstMCU);
    default:
        assert(false);
        return _refr_fwiRGBToYCbCr422LS_MCU_8u16s_C3P3R(pSrcRGB, srcStep, pDstMCU);
    }
}

OREFR       FwStatus STDCALL fwiYCCK422ToCMYKLS_MCU_16s8u_P4C4R(const Fw16s* pSrcMCU[4],
							Fw8u* pDstCMYK, int dstStep)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiYCCK422ToCMYKLS_MCU_16s8u_P4C4R(pSrcMCU, pDstCMYK, dstStep);
    default:
        assert(false);
        return _refr_fwiYCCK422ToCMYKLS_MCU_16s8u_P4C4R(pSrcMCU, pDstCMYK, dstStep);
    }
}

OREFR       FwStatus STDCALL fwiSampleUp411LS_MCU_16s8u_P3C3R(const Fw16s* pSrcMCU[3],
							Fw8u* pDst, int dstStep)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiSampleUp411LS_MCU_16s8u_P3C3R(pSrcMCU, pDst, dstStep);
    default:
        assert(false);
        return _refr_fwiSampleUp411LS_MCU_16s8u_P3C3R(pSrcMCU, pDst, dstStep);
    }
}


OREFR OSSE2 FwStatus STDCALL fwiRGBToY_JPEG_8u_P3C1R(const Fw8u* const pSrcRGB[3], int srcStep, 
							Fw8u* pDstY, int dstStep, FwiSize roiSize)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiRGBToY_JPEG_8u_P3C1R(pSrcRGB, srcStep, pDstY, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiRGBToY_JPEG_8u_P3C1R(pSrcRGB, srcStep, pDstY, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiRGBToY_JPEG_8u_P3C1R(pSrcRGB, srcStep, pDstY, dstStep, roiSize);
    }
}


OREFR       FwStatus STDCALL fwiEncodeHuffmanStateFree_JPEG_8u(FwiEncodeHuffmanState* pEncHuffState)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiEncodeHuffmanStateFree_JPEG_8u(pEncHuffState);
    default:
        assert(false);
        return _refr_fwiEncodeHuffmanStateFree_JPEG_8u(pEncHuffState);
    }
}


OREFR       FwStatus STDCALL fwiDecodeHuffmanStateInit_JPEG_8u(FwiDecodeHuffmanState* pDecHuffState)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiDecodeHuffmanStateInit_JPEG_8u(pDecHuffState);
    default:
        assert(false);
        return _refr_fwiDecodeHuffmanStateInit_JPEG_8u(pDecHuffState);
    }
}


OREFR       FwStatus STDCALL fwiEncodeHuffman8x8_Direct_JPEG_16s1u_C1(const Fw16s* pSrc,
							Fw8u* pDst, int* pDstBitsLen, Fw16s* pLastDC,
							const FwiEncodeHuffmanSpec* pDcTable,
							const FwiEncodeHuffmanSpec* pAcTable)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiEncodeHuffman8x8_Direct_JPEG_16s1u_C1(pSrc, pDst, pDstBitsLen, pLastDC, pDcTable, pAcTable);
    default:
        assert(false);
        return _refr_fwiEncodeHuffman8x8_Direct_JPEG_16s1u_C1(pSrc, pDst, pDstBitsLen, pLastDC, pDcTable, pAcTable);
    }
}

OREFR       FwStatus STDCALL fwiBGR555ToYCbCr_JPEG_16u8u_C3P3R(const Fw16u* pSrcBGR, int srcStep, 
							Fw8u* pDstYCbCr[3], int dstStep, FwiSize roiSize)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiBGR555ToYCbCr_JPEG_16u8u_C3P3R(pSrcBGR, srcStep, pDstYCbCr, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiBGR555ToYCbCr_JPEG_16u8u_C3P3R(pSrcBGR, srcStep, pDstYCbCr, dstStep, roiSize);
    }
}


OREFR       FwStatus STDCALL fwiEncodeHuffman8x8_JPEG_16s1u_C1(const Fw16s* pSrc, Fw8u* pDst, 
							int dstLenBytes, int* pDstCurrPos, Fw16s* pLastDC,
							const FwiEncodeHuffmanSpec* pDcTable, 
							const FwiEncodeHuffmanSpec* pAcTable, 
							FwiEncodeHuffmanState* pEncHuffState, int bFlushState)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiEncodeHuffman8x8_JPEG_16s1u_C1(pSrc, pDst, dstLenBytes, pDstCurrPos, pLastDC, pDcTable, pAcTable, pEncHuffState, bFlushState);
    default:
        assert(false);
        return _refr_fwiEncodeHuffman8x8_JPEG_16s1u_C1(pSrc, pDst, dstLenBytes, pDstCurrPos, pLastDC, pDcTable, pAcTable, pEncHuffState, bFlushState);
    }
}


OREFR       FwStatus STDCALL fwiSampleUpH2V2_JPEG_8u_C1R(const Fw8u* pSrc, int srcStep,
							FwiSize srcSize, Fw8u* pDst, int dstStep, FwiSize dstSize)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiSampleUpH2V2_JPEG_8u_C1R(pSrc, srcStep, srcSize, pDst, dstStep, dstSize);
    default:
        assert(false);
        return _refr_fwiSampleUpH2V2_JPEG_8u_C1R(pSrc, srcStep, srcSize, pDst, dstStep, dstSize);
    }
}


OREFR       FwStatus STDCALL fwiDecodeHuffmanStateInitAlloc_JPEG_8u(FwiDecodeHuffmanState** pDecHuffState)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiDecodeHuffmanStateInitAlloc_JPEG_8u(pDecHuffState);
    default:
        assert(false);
        return _refr_fwiDecodeHuffmanStateInitAlloc_JPEG_8u(pDecHuffState);
    }
}


OREFR OSSE2 FwStatus STDCALL fwiDCTQuantFwd8x8LS_JPEG_8u16s_C1R(const Fw8u* pSrc, 
							int srcStep, Fw16s* pDst, const Fw16u* pQuantFwdTable )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiDCTQuantFwd8x8LS_JPEG_8u16s_C1R(pSrc, srcStep, pDst, pQuantFwdTable);
    case DT_REFR:
        return _refr_fwiDCTQuantFwd8x8LS_JPEG_8u16s_C1R(pSrc, srcStep, pDst, pQuantFwdTable);
    default:
        assert(false);
        return _refr_fwiDCTQuantFwd8x8LS_JPEG_8u16s_C1R(pSrc, srcStep, pDst, pQuantFwdTable);
    }
}

OREFR OSSE2 FwStatus STDCALL fwiYCCKToCMYK_JPEG_8u_P4C4R(const Fw8u* const pSrcYCCK[4], int srcStep, 
							Fw8u* pDstCMYK, int dstStep, FwiSize roiSize)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiYCCKToCMYK_JPEG_8u_P4C4R(pSrcYCCK, srcStep, pDstCMYK, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiYCCKToCMYK_JPEG_8u_P4C4R(pSrcYCCK, srcStep, pDstCMYK, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiYCCKToCMYK_JPEG_8u_P4C4R(pSrcYCCK, srcStep, pDstCMYK, dstStep, roiSize);
    }
}


OREFR       FwStatus STDCALL fwiEncodeHuffmanSpecInitAlloc_JPEG_8u(const Fw8u* pListBits, 
							const Fw8u* pListVals, FwiEncodeHuffmanSpec** pEncHuffSpec)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiEncodeHuffmanSpecInitAlloc_JPEG_8u(pListBits, pListVals, pEncHuffSpec);
    default:
        assert(false);
        return _refr_fwiEncodeHuffmanSpecInitAlloc_JPEG_8u(pListBits, pListVals, pEncHuffSpec);
    }
}

OREFR OSSE2 FwStatus STDCALL fwiYCbCrToRGB_JPEG_8u_P3C3R(const Fw8u* const pSrcYCbCr[3], int srcStep, 
							Fw8u* pDstRGB, int dstStep, FwiSize roiSize)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiYCbCrToRGB_JPEG_8u_P3C3R(pSrcYCbCr, srcStep, pDstRGB, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiYCbCrToRGB_JPEG_8u_P3C3R(pSrcYCbCr, srcStep, pDstRGB, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiYCbCrToRGB_JPEG_8u_P3C3R(pSrcYCbCr, srcStep, pDstRGB, dstStep, roiSize);
    }
}


OREFR       FwStatus STDCALL fwiEncodeHuffmanSpecGetBufSize_JPEG_8u(int* pSize)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiEncodeHuffmanSpecGetBufSize_JPEG_8u(pSize);
    default:
        assert(false);
        return _refr_fwiEncodeHuffmanSpecGetBufSize_JPEG_8u(pSize);
    }
}


OREFR       FwStatus STDCALL fwiEncodeHuffmanSpecInit_JPEG_8u(const Fw8u* pListBits,
							const Fw8u* pListVals,  FwiEncodeHuffmanSpec* pEncHuffSpec)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiEncodeHuffmanSpecInit_JPEG_8u(pListBits, pListVals, pEncHuffSpec);
    default:
        assert(false);
        return _refr_fwiEncodeHuffmanSpecInit_JPEG_8u(pListBits, pListVals, pEncHuffSpec);
    }
}

OREFR       FwStatus STDCALL fwiSampleDown422LS_MCU_8u16s_C3P3R(const Fw8u* pSrc, 
							int srcStep, Fw16s* pDstMCU[3])
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiSampleDown422LS_MCU_8u16s_C3P3R(pSrc, srcStep, pDstMCU);
    default:
        assert(false);
        return _refr_fwiSampleDown422LS_MCU_8u16s_C3P3R(pSrc, srcStep, pDstMCU);
    }
}


OREFR       FwStatus STDCALL fwiRGB565ToYCbCr_JPEG_16u8u_C3P3R(const Fw16u* pSrcRGB, int srcStep, 
							Fw8u* pDstYCbCr[3], int dstStep, FwiSize roiSize)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiRGB565ToYCbCr_JPEG_16u8u_C3P3R(pSrcRGB, srcStep, pDstYCbCr, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiRGB565ToYCbCr_JPEG_16u8u_C3P3R(pSrcRGB, srcStep, pDstYCbCr, dstStep, roiSize);
    }
}


OREFR       FwStatus STDCALL fwiSampleUp444LS_MCU_16s8u_P3C3R(const Fw16s* pSrcMCU[3],
							Fw8u* pDst, int dstStep)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiSampleUp444LS_MCU_16s8u_P3C3R(pSrcMCU, pDst, dstStep);
    default:
        assert(false);
        return _refr_fwiSampleUp444LS_MCU_16s8u_P3C3R(pSrcMCU, pDst, dstStep);
    }
}

OREFR OSSE2 FwStatus STDCALL fwiYCbCr411ToBGRLS_MCU_16s8u_P3C3R(const Fw16s* pSrcMCU[3],
							Fw8u* pDstBGR, int dstStep)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiYCbCr411ToBGRLS_MCU_16s8u_P3C3R(pSrcMCU, pDstBGR, dstStep);
    case DT_REFR:
        return _refr_fwiYCbCr411ToBGRLS_MCU_16s8u_P3C3R(pSrcMCU, pDstBGR, dstStep);
    default:
        assert(false);
        return _refr_fwiYCbCr411ToBGRLS_MCU_16s8u_P3C3R(pSrcMCU, pDstBGR, dstStep);
    }
}

OREFR       FwStatus STDCALL fwiBGR565ToYCbCr422LS_MCU_16u16s_C3P3R(const Fw16u* pSrcBGR, int srcStep, 
							Fw16s* pDstMCU[3])
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiBGR565ToYCbCr422LS_MCU_16u16s_C3P3R(pSrcBGR, srcStep, pDstMCU);
    default:
        assert(false);
        return _refr_fwiBGR565ToYCbCr422LS_MCU_16u16s_C3P3R(pSrcBGR, srcStep, pDstMCU);
    }
}

OREFR OSSE2 FwStatus STDCALL fwiYCbCr422ToRGBLS_MCU_16s8u_P3C3R(const Fw16s* pSrcMCU[3],
							Fw8u* pDstRGB, int dstStep)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiYCbCr422ToRGBLS_MCU_16s8u_P3C3R(pSrcMCU, pDstRGB, dstStep);
    case DT_REFR:
        return _refr_fwiYCbCr422ToRGBLS_MCU_16s8u_P3C3R(pSrcMCU, pDstRGB, dstStep);
    default:
        assert(false);
        return _refr_fwiYCbCr422ToRGBLS_MCU_16s8u_P3C3R(pSrcMCU, pDstRGB, dstStep);
    }
}


OREFR       FwStatus STDCALL fwiDecodeHuffman8x8_DCFirst_JPEG_1u16s_C1(const Fw8u* pSrc, 
							int srcLenBytes, int* pSrcCurrPos, Fw16s* pDst, 
							Fw16s* pLastDC, int* pMarker, int Al, 
							const FwiDecodeHuffmanSpec* pDcTable,
							FwiDecodeHuffmanState* pDecHuffState)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiDecodeHuffman8x8_DCFirst_JPEG_1u16s_C1(pSrc, srcLenBytes, pSrcCurrPos, pDst, pLastDC, pMarker, Al, pDcTable, pDecHuffState);
    default:
        assert(false);
        return _refr_fwiDecodeHuffman8x8_DCFirst_JPEG_1u16s_C1(pSrc, srcLenBytes, pSrcCurrPos, pDst, pLastDC, pMarker, Al, pDcTable, pDecHuffState);
    }
}


OREFR       FwStatus STDCALL fwiDecodeHuffman8x8_JPEG_1u16s_C1(const Fw8u *pSrc, 
							int	srcLenBytes, int *pSrcCurrPos, Fw16s *pDst, 
							Fw16s *pLastDC, int *pMarker, 
							const FwiDecodeHuffmanSpec *pDcTable, 
							const FwiDecodeHuffmanSpec *pAcTable, 
							FwiDecodeHuffmanState *pDecHuffState)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiDecodeHuffman8x8_JPEG_1u16s_C1(pSrc, 	srcLenBytes, pSrcCurrPos, pDst, pLastDC, pMarker, pDcTable, pAcTable, pDecHuffState);
    default:
        assert(false);
        return _refr_fwiDecodeHuffman8x8_JPEG_1u16s_C1(pSrc, 	srcLenBytes, pSrcCurrPos, pDst, pLastDC, pMarker, pDcTable, pAcTable, pDecHuffState);
    }
}


OREFR OSSE2 FwStatus STDCALL fwiSampleUpRowH2V1_Triangle_JPEG_8u_C1(const Fw8u* pSrc, 
							int srcWidth, Fw8u* pDst)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiSampleUpRowH2V1_Triangle_JPEG_8u_C1(pSrc, srcWidth, pDst);
    case DT_REFR:
        return _refr_fwiSampleUpRowH2V1_Triangle_JPEG_8u_C1(pSrc, srcWidth, pDst);
    default:
        assert(false);
        return _refr_fwiSampleUpRowH2V1_Triangle_JPEG_8u_C1(pSrc, srcWidth, pDst);
    }
}


OREFR       FwStatus STDCALL fwiCMYKToYCCK_JPEG_8u_P4R(const Fw8u* const pSrcCMYK[4], int srcStep, 
							Fw8u* pDstYCCK[4], int dstStep, FwiSize roiSize)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiCMYKToYCCK_JPEG_8u_P4R(pSrcCMYK, srcStep, pDstYCCK, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiCMYKToYCCK_JPEG_8u_P4R(pSrcCMYK, srcStep, pDstYCCK, dstStep, roiSize);
    }
}

OREFR       FwStatus STDCALL fwiBGR555ToYCbCr411LS_MCU_16u16s_C3P3R(const Fw16u* pSrcBGR, int srcStep, 
							Fw16s* pDstMCU[3])
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiBGR555ToYCbCr411LS_MCU_16u16s_C3P3R(pSrcBGR, srcStep, pDstMCU);
    default:
        assert(false);
        return _refr_fwiBGR555ToYCbCr411LS_MCU_16u16s_C3P3R(pSrcBGR, srcStep, pDstMCU);
    }
}


OREFR OSSE2 FwStatus STDCALL fwiYCbCr444ToBGRLS_MCU_16s8u_P3C3R(const Fw16s* pSrcMCU[3],
							Fw8u* pDstBGR, int dstStep)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiYCbCr444ToBGRLS_MCU_16s8u_P3C3R(pSrcMCU, pDstBGR, dstStep);
    case DT_REFR:
        return _refr_fwiYCbCr444ToBGRLS_MCU_16s8u_P3C3R(pSrcMCU, pDstBGR, dstStep);
    default:
        assert(false);
        return _refr_fwiYCbCr444ToBGRLS_MCU_16s8u_P3C3R(pSrcMCU, pDstBGR, dstStep);
    }
}

OREFR OSSE2 FwStatus STDCALL fwiDCTQuantInv8x8_JPEG_16s_C1I(Fw16s* pDst,  
							const Fw16u* pQuantInvTable )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiDCTQuantInv8x8_JPEG_16s_C1I(pDst, pQuantInvTable);
    case DT_REFR:
        return _refr_fwiDCTQuantInv8x8_JPEG_16s_C1I(pDst, pQuantInvTable);
    default:
        assert(false);
        return _refr_fwiDCTQuantInv8x8_JPEG_16s_C1I(pDst, pQuantInvTable);
    }
}


OREFR OSSE2 FwStatus STDCALL fwiRGBToYCbCr444LS_MCU_8u16s_C3P3R(const Fw8u* pSrcRGB, int srcStep, 
							Fw16s* pDstMCU[3])
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiRGBToYCbCr444LS_MCU_8u16s_C3P3R(pSrcRGB, srcStep, pDstMCU);
    case DT_REFR:
        return _refr_fwiRGBToYCbCr444LS_MCU_8u16s_C3P3R(pSrcRGB, srcStep, pDstMCU);
    default:
        assert(false);
        return _refr_fwiRGBToYCbCr444LS_MCU_8u16s_C3P3R(pSrcRGB, srcStep, pDstMCU);
    }
}


OREFR OSSE2 FwStatus STDCALL fwiDCTQuantInv8x8LS_JPEG_16s8u_C1R(const Fw16s* pSrc, 
							Fw8u* pDst, int dstStep,  const Fw16u* pQuantInvTable )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiDCTQuantInv8x8LS_JPEG_16s8u_C1R(pSrc, pDst, dstStep, pQuantInvTable);
    case DT_REFR:
        return _refr_fwiDCTQuantInv8x8LS_JPEG_16s8u_C1R(pSrc, pDst, dstStep, pQuantInvTable);
    default:
        assert(false);
        return _refr_fwiDCTQuantInv8x8LS_JPEG_16s8u_C1R(pSrc, pDst, dstStep, pQuantInvTable);
    }
}


OREFR       FwStatus STDCALL fwiSampleUpH2V1_JPEG_8u_C1R(const Fw8u* pSrc, int srcStep,
							FwiSize srcSize, Fw8u* pDst, int dstStep, FwiSize dstSize)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiSampleUpH2V1_JPEG_8u_C1R(pSrc, srcStep, srcSize, pDst, dstStep, dstSize);
    default:
        assert(false);
        return _refr_fwiSampleUpH2V1_JPEG_8u_C1R(pSrc, srcStep, srcSize, pDst, dstStep, dstSize);
    }
}


OREFR       FwStatus STDCALL fwiEncodeHuffman8x8_ACFirst_JPEG_16s1u_C1(const Fw16s* pSrc, 
							Fw8u* pDst, int dstLenBytes, int* pDstCurrPos, int Ss, 
							int Se, int Al, const FwiEncodeHuffmanSpec* pAcTable, 
							FwiEncodeHuffmanState* pEncHuffState, int bFlushState)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiEncodeHuffman8x8_ACFirst_JPEG_16s1u_C1(pSrc, pDst, dstLenBytes, pDstCurrPos, Ss, Se, Al, pAcTable, pEncHuffState, bFlushState);
    default:
        assert(false);
        return _refr_fwiEncodeHuffman8x8_ACFirst_JPEG_16s1u_C1(pSrc, pDst, dstLenBytes, pDstCurrPos, Ss, Se, Al, pAcTable, pEncHuffState, bFlushState);
    }
}

OREFR OSSE2 FwStatus STDCALL fwiCMYKToYCCK_JPEG_8u_C4P4R(const Fw8u* const pSrcCMYK, int srcStep, 
							Fw8u* const pDstYCCK[4], int dstStep, FwiSize roiSize)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiCMYKToYCCK_JPEG_8u_C4P4R(pSrcCMYK, srcStep, pDstYCCK, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiCMYKToYCCK_JPEG_8u_C4P4R(pSrcCMYK, srcStep, pDstYCCK, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiCMYKToYCCK_JPEG_8u_C4P4R(pSrcCMYK, srcStep, pDstYCCK, dstStep, roiSize);
    }
}


OREFR       FwStatus STDCALL fwiJoin422LS_MCU_16s8u_P3C2R(const Fw16s* pSrcMCU[3], 
							Fw8u*pDst, int dstStep)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiJoin422LS_MCU_16s8u_P3C2R(pSrcMCU, pDst, dstStep);
    default:
        assert(false);
        return _refr_fwiJoin422LS_MCU_16s8u_P3C2R(pSrcMCU, pDst, dstStep);
    }
}


OREFR       FwStatus STDCALL fwiDecodeHuffmanSpecGetBufSize_JPEG_8u(int* pSize)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiDecodeHuffmanSpecGetBufSize_JPEG_8u(pSize);
    default:
        assert(false);
        return _refr_fwiDecodeHuffmanSpecGetBufSize_JPEG_8u(pSize);
    }
}

OREFR       FwStatus STDCALL fwiBGR555ToYCbCr444LS_MCU_16u16s_C3P3R(const Fw16u* pSrcBGR, int srcStep, 
							Fw16s* pDstMCU[3])
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiBGR555ToYCbCr444LS_MCU_16u16s_C3P3R(pSrcBGR, srcStep, pDstMCU);
    default:
        assert(false);
        return _refr_fwiBGR555ToYCbCr444LS_MCU_16u16s_C3P3R(pSrcBGR, srcStep, pDstMCU);
    }
}


OREFR       FwStatus STDCALL fwiRGBToYCbCr_JPEG_8u_P3R(const Fw8u* const pSrcRGB[3], int srcStep, 
							Fw8u* pDstYCbCr[3], int dstStep, FwiSize roiSize)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiRGBToYCbCr_JPEG_8u_P3R(pSrcRGB, srcStep, pDstYCbCr, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiRGBToYCbCr_JPEG_8u_P3R(pSrcRGB, srcStep, pDstYCbCr, dstStep, roiSize);
    }
}


OREFR OSSE2 FwStatus STDCALL fwiBGRToYCbCr411LS_MCU_8u16s_C3P3R(const Fw8u* pSrcBGR, int srcStep, 
							Fw16s* pDstMCU[3])
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiBGRToYCbCr411LS_MCU_8u16s_C3P3R(pSrcBGR, srcStep, pDstMCU);
    case DT_REFR:
        return _refr_fwiBGRToYCbCr411LS_MCU_8u16s_C3P3R(pSrcBGR, srcStep, pDstMCU);
    default:
        assert(false);
        return _refr_fwiBGRToYCbCr411LS_MCU_8u16s_C3P3R(pSrcBGR, srcStep, pDstMCU);
    }
}

OREFR       FwStatus STDCALL fwiBGR565ToYCbCr411LS_MCU_16u16s_C3P3R(const Fw16u* pSrcBGR, int srcStep, 
							Fw16s* pDstMCU[3])
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiBGR565ToYCbCr411LS_MCU_16u16s_C3P3R(pSrcBGR, srcStep, pDstMCU);
    default:
        assert(false);
        return _refr_fwiBGR565ToYCbCr411LS_MCU_16u16s_C3P3R(pSrcBGR, srcStep, pDstMCU);
    }
}


OREFR OSSE2 FwStatus STDCALL fwiQuantInv8x8_JPEG_16s_C1I(Fw16s* pSrcDst, const Fw16u*
							pQuantInvTable)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiQuantInv8x8_JPEG_16s_C1I(pSrcDst, 	pQuantInvTable);
    case DT_REFR:
        return _refr_fwiQuantInv8x8_JPEG_16s_C1I(pSrcDst, 	pQuantInvTable);
    default:
        assert(false);
        return _refr_fwiQuantInv8x8_JPEG_16s_C1I(pSrcDst, 	pQuantInvTable);
    }
}


OREFR       FwStatus STDCALL fwiDecodeHuffmanSpecFree_JPEG_8u(FwiDecodeHuffmanSpec* pDecHuffSpec)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiDecodeHuffmanSpecFree_JPEG_8u(pDecHuffSpec);
    default:
        assert(false);
        return _refr_fwiDecodeHuffmanSpecFree_JPEG_8u(pDecHuffSpec);
    }
}

OREFR       FwStatus STDCALL fwiBGR565ToYCbCr444LS_MCU_16u16s_C3P3R(const Fw16u* pSrcBGR, int srcStep, 
							Fw16s* pDstMCU[3])
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiBGR565ToYCbCr444LS_MCU_16u16s_C3P3R(pSrcBGR, srcStep, pDstMCU);
    default:
        assert(false);
        return _refr_fwiBGR565ToYCbCr444LS_MCU_16u16s_C3P3R(pSrcBGR, srcStep, pDstMCU);
    }
}

OREFR       FwStatus STDCALL fwiBGR555ToYCbCr422LS_MCU_16u16s_C3P3R(const Fw16u* pSrcBGR, int srcStep, 
							Fw16s* pDstMCU[3])
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiBGR555ToYCbCr422LS_MCU_16u16s_C3P3R(pSrcBGR, srcStep, pDstMCU);
    default:
        assert(false);
        return _refr_fwiBGR555ToYCbCr422LS_MCU_16u16s_C3P3R(pSrcBGR, srcStep, pDstMCU);
    }
}

OREFR       FwStatus STDCALL fwiYCbCr444ToBGR565LS_MCU_16s16u_P3C3R(const Fw16s* pSrcMCU[3],
							Fw16u* pDstBGR, int dstStep)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiYCbCr444ToBGR565LS_MCU_16s16u_P3C3R(pSrcMCU, pDstBGR, dstStep);
    default:
        assert(false);
        return _refr_fwiYCbCr444ToBGR565LS_MCU_16s16u_P3C3R(pSrcMCU, pDstBGR, dstStep);
    }
}


OREFR OSSE2 FwStatus STDCALL fwiSampleUpRowH2V2_Triangle_JPEG_8u_C1(const Fw8u* pSrc1, 
							const Fw8u* pSrc2, int srcWidth, Fw8u* pDst)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiSampleUpRowH2V2_Triangle_JPEG_8u_C1(pSrc1, pSrc2, srcWidth, pDst);
    case DT_REFR:
        return _refr_fwiSampleUpRowH2V2_Triangle_JPEG_8u_C1(pSrc1, pSrc2, srcWidth, pDst);
    default:
        assert(false);
        return _refr_fwiSampleUpRowH2V2_Triangle_JPEG_8u_C1(pSrc1, pSrc2, srcWidth, pDst);
    }
}


OREFR       FwStatus STDCALL fwiYCbCrToBGR565_JPEG_8u16u_P3C3R(const Fw8u* pSrcYCbCr[3], int srcStep, 
							Fw16u* pDstBGR, int dstStep, FwiSize roiSize)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiYCbCrToBGR565_JPEG_8u16u_P3C3R(pSrcYCbCr, srcStep, pDstBGR, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiYCbCrToBGR565_JPEG_8u16u_P3C3R(pSrcYCbCr, srcStep, pDstBGR, dstStep, roiSize);
    }
}


OREFR       FwStatus STDCALL fwiDecodeHuffmanSpecInitAlloc_JPEG_8u(const Fw8u* pListBits, 
							const Fw8u* pListVals, FwiDecodeHuffmanSpec** pDecHuffSpec)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiDecodeHuffmanSpecInitAlloc_JPEG_8u(pListBits, pListVals, pDecHuffSpec);
    default:
        assert(false);
        return _refr_fwiDecodeHuffmanSpecInitAlloc_JPEG_8u(pListBits, pListVals, pDecHuffSpec);
    }
}


OREFR       FwStatus STDCALL fwiQuantFwdRawTableInit_JPEG_8u(Fw8u* pQuantRawTable, int qualityFactor)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiQuantFwdRawTableInit_JPEG_8u(pQuantRawTable, qualityFactor);
    default:
        assert(false);
        return _refr_fwiQuantFwdRawTableInit_JPEG_8u(pQuantRawTable, qualityFactor);
    }
}

OREFR       FwStatus STDCALL fwiYCbCrToRGB555_JPEG_8u16u_P3C3R(const Fw8u* pSrcYCbCr[3], int srcStep, 
							Fw16u* pDstRGB, int dstStep, FwiSize roiSize)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiYCbCrToRGB555_JPEG_8u16u_P3C3R(pSrcYCbCr, srcStep, pDstRGB, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiYCbCrToRGB555_JPEG_8u16u_P3C3R(pSrcYCbCr, srcStep, pDstRGB, dstStep, roiSize);
    }
}


OREFR       FwStatus STDCALL fwiDecodeHuffman8x8_DCRefine_JPEG_1u16s_C1(const Fw8u* pSrc,
							int srcLenBytes, int* pSrcCurrPos, Fw16s* pDst, 
							int* pMarker, int Al,
							FwiDecodeHuffmanState* pDecHuffState)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiDecodeHuffman8x8_DCRefine_JPEG_1u16s_C1(pSrc, srcLenBytes, pSrcCurrPos, pDst, pMarker, Al, pDecHuffState);
    default:
        assert(false);
        return _refr_fwiDecodeHuffman8x8_DCRefine_JPEG_1u16s_C1(pSrc, srcLenBytes, pSrcCurrPos, pDst, pMarker, Al, pDecHuffState);
    }
}


OREFR       FwStatus STDCALL fwiDecodeHuffman8x8_ACFirst_JPEG_1u16s_C1(const Fw8u* pSrc, 
							int srcLenBytes, int* pSrcCurrPos, Fw16s* pDst, 
							int* pMarker, int Ss, int Se, int Al, 
							const FwiDecodeHuffmanSpec* pAcTable,
							FwiDecodeHuffmanState* pDecHuffState)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiDecodeHuffman8x8_ACFirst_JPEG_1u16s_C1(pSrc, srcLenBytes, pSrcCurrPos, pDst, pMarker, Ss, Se, Al, pAcTable, pDecHuffState);
    default:
        assert(false);
        return _refr_fwiDecodeHuffman8x8_ACFirst_JPEG_1u16s_C1(pSrc, srcLenBytes, pSrcCurrPos, pDst, pMarker, Ss, Se, Al, pAcTable, pDecHuffState);
    }
}

OREFR       FwStatus STDCALL fwiSampleUp422LS_MCU_16s8u_P3C3R(const Fw16s* pSrcMCU[3],
							Fw8u* pDst, int dstStep)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiSampleUp422LS_MCU_16s8u_P3C3R(pSrcMCU, pDst, dstStep);
    default:
        assert(false);
        return _refr_fwiSampleUp422LS_MCU_16s8u_P3C3R(pSrcMCU, pDst, dstStep);
    }
}


OREFR       FwStatus STDCALL fwiSampleDownH2V2_JPEG_8u_C1R(const Fw8u* pSrc, int srcStep,
							FwiSize srcSize, Fw8u* pDst, int dstStep, FwiSize dstSize)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiSampleDownH2V2_JPEG_8u_C1R(pSrc, srcStep, srcSize, pDst, dstStep, dstSize);
    default:
        assert(false);
        return _refr_fwiSampleDownH2V2_JPEG_8u_C1R(pSrc, srcStep, srcSize, pDst, dstStep, dstSize);
    }
}


OREFR       FwStatus STDCALL fwiDecodeHuffmanStateGetBufSize_JPEG_8u(int* pSize)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiDecodeHuffmanStateGetBufSize_JPEG_8u(pSize);
    default:
        assert(false);
        return _refr_fwiDecodeHuffmanStateGetBufSize_JPEG_8u(pSize);
    }
}

OREFR OSSE2 FwStatus STDCALL fwiRGBToY_JPEG_8u_C3C1R(const Fw8u* pSrcRGB, int srcStep,
							Fw8u* pDstY, int dstStep, FwiSize roiSize)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiRGBToY_JPEG_8u_C3C1R(pSrcRGB, srcStep, pDstY, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiRGBToY_JPEG_8u_C3C1R(pSrcRGB, srcStep, pDstY, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiRGBToY_JPEG_8u_C3C1R(pSrcRGB, srcStep, pDstY, dstStep, roiSize);
    }
}

OREFR       FwStatus STDCALL fwiYCbCr422ToBGR555LS_MCU_16s16u_P3C3R(const Fw16s* pSrcMCU[3],
							Fw16u* pDstBGR, int dstStep)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiYCbCr422ToBGR555LS_MCU_16s16u_P3C3R(pSrcMCU, pDstBGR, dstStep);
    default:
        assert(false);
        return _refr_fwiYCbCr422ToBGR555LS_MCU_16s16u_P3C3R(pSrcMCU, pDstBGR, dstStep);
    }
}


OREFR       FwStatus STDCALL fwiDecodeHuffmanSpecInit_JPEG_8u(const Fw8u* pListBits,
							const Fw8u* pListVals, FwiDecodeHuffmanSpec* pDecHuffSpec)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiDecodeHuffmanSpecInit_JPEG_8u(pListBits, pListVals, pDecHuffSpec);
    default:
        assert(false);
        return _refr_fwiDecodeHuffmanSpecInit_JPEG_8u(pListBits, pListVals, pDecHuffSpec);
    }
}


OREFR       FwStatus STDCALL fwiGetHuffmanStatistics8x8_DCFirst_JPEG_16s_C1(const Fw16s* pSrc,
							int pDcStatistics[256], Fw16s* pLastDC, int Al)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiGetHuffmanStatistics8x8_DCFirst_JPEG_16s_C1(pSrc, pDcStatistics, pLastDC, Al);
    default:
        assert(false);
        return _refr_fwiGetHuffmanStatistics8x8_DCFirst_JPEG_16s_C1(pSrc, pDcStatistics, pLastDC, Al);
    }
}


OREFR       FwStatus STDCALL fwiCMYKToYCCK444LS_MCU_8u16s_C4P4R(const Fw8u* pSrcCMYK,
							int srcStep, Fw16s* pDstMCU[4])
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiCMYKToYCCK444LS_MCU_8u16s_C4P4R(pSrcCMYK, srcStep, pDstMCU);
    default:
        assert(false);
        return _refr_fwiCMYKToYCCK444LS_MCU_8u16s_C4P4R(pSrcCMYK, srcStep, pDstMCU);
    }
}


OREFR OSSE2 FwStatus STDCALL fwiRGBToYCbCr411LS_MCU_8u16s_C3P3R(const Fw8u* pSrcRGB, int srcStep, 
							Fw16s* pDstMCU[3])
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiRGBToYCbCr411LS_MCU_8u16s_C3P3R(pSrcRGB, srcStep, pDstMCU);
    case DT_REFR:
        return _refr_fwiRGBToYCbCr411LS_MCU_8u16s_C3P3R(pSrcRGB, srcStep, pDstMCU);
    default:
        assert(false);
        return _refr_fwiRGBToYCbCr411LS_MCU_8u16s_C3P3R(pSrcRGB, srcStep, pDstMCU);
    }
}


OREFR       FwStatus STDCALL fwiYCbCrToBGR_JPEG_8u_P3C3R(const Fw8u* const pSrcYCbCr[3], int srcStep, 
							Fw8u* pDstBGR, int dstStep, FwiSize roiSize)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiYCbCrToBGR_JPEG_8u_P3C3R(pSrcYCbCr, srcStep, pDstBGR, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiYCbCrToBGR_JPEG_8u_P3C3R(pSrcYCbCr, srcStep, pDstBGR, dstStep, roiSize);
    }
}


OREFR       FwStatus STDCALL fwiGetHuffmanStatistics8x8_JPEG_16s_C1(const Fw16s* pSrc,
							int pDcStatistics[256], int pAcStatistics[256], 
							Fw16s* pLastDC)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiGetHuffmanStatistics8x8_JPEG_16s_C1(pSrc, pDcStatistics, pAcStatistics, pLastDC);
    default:
        assert(false);
        return _refr_fwiGetHuffmanStatistics8x8_JPEG_16s_C1(pSrc, pDcStatistics, pAcStatistics, pLastDC);
    }
}


OREFR OSSE2 FwStatus STDCALL fwiDCTQuantInv8x8_JPEG_16s_C1(const Fw16s* pSrc, Fw16s* pDst, 
							const Fw16u* pQuantInvTable )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiDCTQuantInv8x8_JPEG_16s_C1(pSrc, pDst, pQuantInvTable);
    case DT_REFR:
        return _refr_fwiDCTQuantInv8x8_JPEG_16s_C1(pSrc, pDst, pQuantInvTable);
    default:
        assert(false);
        return _refr_fwiDCTQuantInv8x8_JPEG_16s_C1(pSrc, pDst, pQuantInvTable);
    }
}



OREFR OSSE2 FwStatus STDCALL fwiBGRToY_JPEG_8u_C3C1R(const Fw8u* pSrcBGR, int srcStep,
							Fw8u* pDstY, int dstStep, FwiSize roiSize)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiBGRToY_JPEG_8u_C3C1R(pSrcBGR, srcStep, pDstY, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiBGRToY_JPEG_8u_C3C1R(pSrcBGR, srcStep, pDstY, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiBGRToY_JPEG_8u_C3C1R(pSrcBGR, srcStep, pDstY, dstStep, roiSize);
    }
}


OREFR OSSE2 FwStatus STDCALL fwiBGRToYCbCr444LS_MCU_8u16s_C3P3R(const Fw8u* pSrcBGR, int srcStep, 
							Fw16s* pDstMCU[3])
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiBGRToYCbCr444LS_MCU_8u16s_C3P3R(pSrcBGR, srcStep, pDstMCU);
    case DT_REFR:
        return _refr_fwiBGRToYCbCr444LS_MCU_8u16s_C3P3R(pSrcBGR, srcStep, pDstMCU);
    default:
        assert(false);
        return _refr_fwiBGRToYCbCr444LS_MCU_8u16s_C3P3R(pSrcBGR, srcStep, pDstMCU);
    }
}


OREFR       FwStatus STDCALL fwiSplit422LS_MCU_8u16s_C2P3R(const Fw8u* pSrc, int srcStep,
							Fw16s* pDstMCU[3])
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiSplit422LS_MCU_8u16s_C2P3R(pSrc, srcStep, pDstMCU);
    default:
        assert(false);
        return _refr_fwiSplit422LS_MCU_8u16s_C2P3R(pSrc, srcStep, pDstMCU);
    }
}


OREFR       FwStatus STDCALL fwiQuantFwdTableInit_JPEG_8u16u(const Fw8u* pQuantRawTable, 
							Fw16u* pQuantFwdTable)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiQuantFwdTableInit_JPEG_8u16u(pQuantRawTable, pQuantFwdTable);
    default:
        assert(false);
        return _refr_fwiQuantFwdTableInit_JPEG_8u16u(pQuantRawTable, pQuantFwdTable);
    }
}


OREFR OSSE2 FwStatus STDCALL fwiAdd128_JPEG_16s8u_C1R(const Fw16s* pSrc, int srcStep,
							Fw8u* pDst, int dstStep, FwiSize roiSize)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiAdd128_JPEG_16s8u_C1R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiAdd128_JPEG_16s8u_C1R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiAdd128_JPEG_16s8u_C1R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}


OREFR       FwStatus STDCALL fwiEncodeHuffman8x8_DCFirst_JPEG_16s1u_C1(const Fw16s* pSrc, 
							Fw8u *pDst, int dstLenBytes, int* pDstCurrPos, 
							Fw16s* pLastDC, int Al, const FwiEncodeHuffmanSpec* pDcTable, 
							FwiEncodeHuffmanState* pEncHuffState, int bFlushState)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiEncodeHuffman8x8_DCFirst_JPEG_16s1u_C1(pSrc, pDst, dstLenBytes, pDstCurrPos, pLastDC, Al, pDcTable, pEncHuffState, bFlushState);
    default:
        assert(false);
        return _refr_fwiEncodeHuffman8x8_DCFirst_JPEG_16s1u_C1(pSrc, pDst, dstLenBytes, pDstCurrPos, pLastDC, Al, pDcTable, pEncHuffState, bFlushState);
    }
}

OREFR       FwStatus STDCALL fwiRGB555ToYCbCr_JPEG_16u8u_C3P3R(const Fw16u* pSrcRGB, int srcStep, 
							Fw8u* pDstYCbCr[3], int dstStep, FwiSize roiSize)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiRGB555ToYCbCr_JPEG_16u8u_C3P3R(pSrcRGB, srcStep, pDstYCbCr, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiRGB555ToYCbCr_JPEG_16u8u_C3P3R(pSrcRGB, srcStep, pDstYCbCr, dstStep, roiSize);
    }
}

OREFR       FwStatus STDCALL fwiSampleDown411LS_MCU_8u16s_C3P3R(const Fw8u* pSrc, 
							int srcStep, Fw16s* pDstMCU[3])
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiSampleDown411LS_MCU_8u16s_C3P3R(pSrc, srcStep, pDstMCU);
    default:
        assert(false);
        return _refr_fwiSampleDown411LS_MCU_8u16s_C3P3R(pSrc, srcStep, pDstMCU);
    }
}

OREFR       FwStatus STDCALL fwiYCbCr411ToBGR555LS_MCU_16s16u_P3C3R(const Fw16s* pSrcMCU[3], Fw16u* pDstBGR, int dstStep)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiYCbCr411ToBGR555LS_MCU_16s16u_P3C3R(pSrcMCU, pDstBGR, dstStep);
    default:
        assert(false);
        return _refr_fwiYCbCr411ToBGR555LS_MCU_16s16u_P3C3R(pSrcMCU, pDstBGR, dstStep);
    }
}


OREFR       FwStatus STDCALL fwiYCCKToCMYK_JPEG_8u_P4R(const Fw8u* const pSrcYCCK[4], int srcStep, 
							Fw8u* pDstCMYK[4], int dstStep, FwiSize roiSize)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiYCCKToCMYK_JPEG_8u_P4R(pSrcYCCK, srcStep, pDstCMYK, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiYCCKToCMYK_JPEG_8u_P4R(pSrcYCCK, srcStep, pDstCMYK, dstStep, roiSize);
    }
}

OREFR OSSE2 FwStatus STDCALL fwiYCbCr411ToRGBLS_MCU_16s8u_P3C3R(const Fw16s* pSrcMCU[3],
							Fw8u* pDstRGB, int dstStep)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiYCbCr411ToRGBLS_MCU_16s8u_P3C3R(pSrcMCU, pDstRGB, dstStep);
    case DT_REFR:
        return _refr_fwiYCbCr411ToRGBLS_MCU_16s8u_P3C3R(pSrcMCU, pDstRGB, dstStep);
    default:
        assert(false);
        return _refr_fwiYCbCr411ToRGBLS_MCU_16s8u_P3C3R(pSrcMCU, pDstRGB, dstStep);
    }
}


OREFR OSSE2 FwStatus STDCALL fwiBGRToYCbCr422LS_MCU_8u16s_C3P3R(const Fw8u* pSrcBGR, int srcStep, 
							Fw16s* pDstMCU[3])
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiBGRToYCbCr422LS_MCU_8u16s_C3P3R(pSrcBGR, srcStep, pDstMCU);
    case DT_REFR:
        return _refr_fwiBGRToYCbCr422LS_MCU_8u16s_C3P3R(pSrcBGR, srcStep, pDstMCU);
    default:
        assert(false);
        return _refr_fwiBGRToYCbCr422LS_MCU_8u16s_C3P3R(pSrcBGR, srcStep, pDstMCU);
    }
}


OREFR       FwStatus STDCALL fwiSampleDown444LS_MCU_8u16s_C3P3R(const Fw8u* pSrc, 
							int srcStep, Fw16s* pDstMCU[3])
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiSampleDown444LS_MCU_8u16s_C3P3R(pSrc, srcStep, pDstMCU);
    default:
        assert(false);
        return _refr_fwiSampleDown444LS_MCU_8u16s_C3P3R(pSrc, srcStep, pDstMCU);
    }
}


OREFR       FwStatus STDCALL fwiCMYKToYCCK422LS_MCU_8u16s_C4P4R(const Fw8u* pSrcCMYK,
							int srcStep, Fw16s* pDstMCU[4])
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiCMYKToYCCK422LS_MCU_8u16s_C4P4R(pSrcCMYK, srcStep, pDstMCU);
    default:
        assert(false);
        return _refr_fwiCMYKToYCCK422LS_MCU_8u16s_C4P4R(pSrcCMYK, srcStep, pDstMCU);
    }
}

OREFR       FwStatus STDCALL fwiYCbCrToBGR555_JPEG_8u16u_P3C3R(const Fw8u* pSrcYCbCr[3], int srcStep, 
							Fw16u* pDstBGR, int dstStep, FwiSize roiSize)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiYCbCrToBGR555_JPEG_8u16u_P3C3R(pSrcYCbCr, srcStep, pDstBGR, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiYCbCrToBGR555_JPEG_8u16u_P3C3R(pSrcYCbCr, srcStep, pDstBGR, dstStep, roiSize);
    }
}

OREFR OSSE2 FwStatus STDCALL fwiRGBToYCbCr_JPEG_8u_C3P3R(const Fw8u* pSrcRGB, int srcStep, 
							Fw8u* const pDstYCbCr[3], int dstStep, FwiSize roiSize)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiRGBToYCbCr_JPEG_8u_C3P3R(pSrcRGB, srcStep, pDstYCbCr, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiRGBToYCbCr_JPEG_8u_C3P3R(pSrcRGB, srcStep, pDstYCbCr, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiRGBToYCbCr_JPEG_8u_C3P3R(pSrcRGB, srcStep, pDstYCbCr, dstStep, roiSize);
    }
}


OREFR       FwStatus STDCALL fwiCMYKToYCCK411LS_MCU_8u16s_C4P4R(const Fw8u* pSrcCMYK,
							int srcStep, Fw16s* pDstMCU[4])
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiCMYKToYCCK411LS_MCU_8u16s_C4P4R(pSrcCMYK, srcStep, pDstMCU);
    default:
        assert(false);
        return _refr_fwiCMYKToYCCK411LS_MCU_8u16s_C4P4R(pSrcCMYK, srcStep, pDstMCU);
    }
}


OREFR       FwStatus STDCALL fwiEncodeHuffmanSpecFree_JPEG_8u(FwiEncodeHuffmanSpec* pEncHuffSpec)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiEncodeHuffmanSpecFree_JPEG_8u(pEncHuffSpec);
    default:
        assert(false);
        return _refr_fwiEncodeHuffmanSpecFree_JPEG_8u(pEncHuffSpec);
    }
}



OREFR       FwStatus STDCALL fwiBGRToYCbCr_JPEG_8u_C3P3R(const Fw8u* pSrcBGR, int srcStep, 
							Fw8u* const pDstYCbCr[3], int dstStep, FwiSize roiSize)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiBGRToYCbCr_JPEG_8u_C3P3R(pSrcBGR, srcStep, pDstYCbCr, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiBGRToYCbCr_JPEG_8u_C3P3R(pSrcBGR, srcStep, pDstYCbCr, dstStep, roiSize);
    }
}


OREFR       FwStatus STDCALL fwiYCCK444ToCMYKLS_MCU_16s8u_P4C4R(const Fw16s* pSrcMCU[4],
							Fw8u* pDstCMYK, int dstStep)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiYCCK444ToCMYKLS_MCU_16s8u_P4C4R(pSrcMCU, pDstCMYK, dstStep);
    default:
        assert(false);
        return _refr_fwiYCCK444ToCMYKLS_MCU_16s8u_P4C4R(pSrcMCU, pDstCMYK, dstStep);
    }
}


OREFR OSSE2 FwStatus STDCALL fwiDCTQuantFwd8x8_JPEG_16s_C1( const Fw16s* pSrc,
							Fw16s* pDst, const Fw16u* pQuantFwdTable )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiDCTQuantFwd8x8_JPEG_16s_C1(pSrc, pDst, pQuantFwdTable);
    case DT_REFR:
        return _refr_fwiDCTQuantFwd8x8_JPEG_16s_C1(pSrc, pDst, pQuantFwdTable);
    default:
        assert(false);
        return _refr_fwiDCTQuantFwd8x8_JPEG_16s_C1(pSrc, pDst, pQuantFwdTable);
    }
}


OREFR       FwStatus STDCALL fwiDecodeHuffmanStateFree_JPEG_8u(FwiDecodeHuffmanState* pDecHuffState)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiDecodeHuffmanStateFree_JPEG_8u(pDecHuffState);
    default:
        assert(false);
        return _refr_fwiDecodeHuffmanStateFree_JPEG_8u(pDecHuffState);
    }
}


OREFR       FwStatus STDCALL fwiEncodeHuffmanStateInitAlloc_JPEG_8u(FwiEncodeHuffmanState** pEncHuffState)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiEncodeHuffmanStateInitAlloc_JPEG_8u(pEncHuffState);
    default:
        assert(false);
        return _refr_fwiEncodeHuffmanStateInitAlloc_JPEG_8u(pEncHuffState);
    }
}


OREFR       FwStatus STDCALL fwiDecodeHuffman8x8_Direct_JPEG_1u16s_C1(const Fw8u* pSrc,
							int* pSrcBitsLen, Fw16s* pDst, Fw16s* pLastDC, 
							int* pMarker, Fw32u* pPrefetchedBits, 
							int* pNumValidPrefetchedBits, 
							const FwiDecodeHuffmanSpec* pDcTable, 
							const FwiDecodeHuffmanSpec* pAcTable)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiDecodeHuffman8x8_Direct_JPEG_1u16s_C1(pSrc, pSrcBitsLen, pDst, pLastDC, pMarker, pPrefetchedBits, pNumValidPrefetchedBits, pDcTable, pAcTable);
    default:
        assert(false);
        return _refr_fwiDecodeHuffman8x8_Direct_JPEG_1u16s_C1(pSrc, pSrcBitsLen, pDst, pLastDC, pMarker, pPrefetchedBits, pNumValidPrefetchedBits, pDcTable, pAcTable);
    }
}


OREFR       FwStatus STDCALL fwiYCbCrToRGB565_JPEG_8u16u_P3C3R(const Fw8u* pSrcYCbCr[3], int srcStep, 
							Fw16u* pDstRGB, int dstStep, FwiSize roiSize)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiYCbCrToRGB565_JPEG_8u16u_P3C3R(pSrcYCbCr, srcStep, pDstRGB, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiYCbCrToRGB565_JPEG_8u16u_P3C3R(pSrcYCbCr, srcStep, pDstRGB, dstStep, roiSize);
    }
}


OREFR       FwStatus STDCALL fwiSampleDownH2V1_JPEG_8u_C1R(const Fw8u* pSrc, int srcStep,
							FwiSize srcSize, Fw8u* pDst, int dstStep, FwiSize dstSize)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiSampleDownH2V1_JPEG_8u_C1R(pSrc, srcStep, srcSize, pDst, dstStep, dstSize);
    default:
        assert(false);
        return _refr_fwiSampleDownH2V1_JPEG_8u_C1R(pSrc, srcStep, srcSize, pDst, dstStep, dstSize);
    }
}


OREFR OSSE2 FwStatus STDCALL fwiSampleDownRowH2V1_Box_JPEG_8u_C1(const Fw8u* pSrc,int srcWidth, 
							Fw8u* pDst)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiSampleDownRowH2V1_Box_JPEG_8u_C1(pSrc, srcWidth, pDst);
    case DT_REFR:
        return _refr_fwiSampleDownRowH2V1_Box_JPEG_8u_C1(pSrc, srcWidth, pDst);
    default:
        assert(false);
        return _refr_fwiSampleDownRowH2V1_Box_JPEG_8u_C1(pSrc, srcWidth, pDst);
    }
}

OREFR       FwStatus STDCALL fwiYCbCr422ToBGR565LS_MCU_16s16u_P3C3R(const Fw16s* pSrcMCU[3],
							Fw16u* pDstBGR, int dstStep)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiYCbCr422ToBGR565LS_MCU_16s16u_P3C3R(pSrcMCU, pDstBGR, dstStep);
    default:
        assert(false);
        return _refr_fwiYCbCr422ToBGR565LS_MCU_16s16u_P3C3R(pSrcMCU, pDstBGR, dstStep);
    }
}

OREFR       FwStatus STDCALL fwiYCbCr411ToBGR565LS_MCU_16s16u_P3C3R(const Fw16s* pSrcMCU[3],
							Fw16u* pDstBGR, int dstStep)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiYCbCr411ToBGR565LS_MCU_16s16u_P3C3R(pSrcMCU, pDstBGR, dstStep);
    default:
        assert(false);
        return _refr_fwiYCbCr411ToBGR565LS_MCU_16s16u_P3C3R(pSrcMCU, pDstBGR, dstStep);
    }
}


OREFR       FwStatus STDCALL fwiQuantInvTableInit_JPEG_8u16u(const Fw8u* pQuantRawTable, 
							Fw16u* pQuantInvTable)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiQuantInvTableInit_JPEG_8u16u(pQuantRawTable, pQuantInvTable);
    default:
        assert(false);
        return _refr_fwiQuantInvTableInit_JPEG_8u16u(pQuantRawTable, pQuantInvTable);
    }
}


OREFR       FwStatus STDCALL fwiBGR565ToYCbCr_JPEG_16u8u_C3P3R(const Fw16u* pSrcBGR, int srcStep, 
							Fw8u* pDstYCbCr[3], int dstStep, FwiSize roiSize)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiBGR565ToYCbCr_JPEG_16u8u_C3P3R(pSrcBGR, srcStep, pDstYCbCr, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiBGR565ToYCbCr_JPEG_16u8u_C3P3R(pSrcBGR, srcStep, pDstYCbCr, dstStep, roiSize);
    }
}


OREFR       FwStatus STDCALL fwiEncodeHuffmanStateInit_JPEG_8u(FwiEncodeHuffmanState* pEncHuffState)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiEncodeHuffmanStateInit_JPEG_8u(pEncHuffState);
    default:
        assert(false);
        return _refr_fwiEncodeHuffmanStateInit_JPEG_8u(pEncHuffState);
    }
}

OREFR OSSE2 FwStatus STDCALL fwiDCTQuantFwd8x8_JPEG_16s_C1I(Fw16s* pDst, 
							const Fw16u* pQuantFwdTable )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiDCTQuantFwd8x8_JPEG_16s_C1I(pDst, pQuantFwdTable);
    case DT_REFR:
        return _refr_fwiDCTQuantFwd8x8_JPEG_16s_C1I(pDst, pQuantFwdTable);
    default:
        assert(false);
        return _refr_fwiDCTQuantFwd8x8_JPEG_16s_C1I(pDst, pQuantFwdTable);
    }
}

OREFR       FwStatus STDCALL fwiYCbCr444ToBGR555LS_MCU_16s16u_P3C3R(const Fw16s* pSrcMCU[3],
							Fw16u* pDstBGR, int dstStep)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiYCbCr444ToBGR555LS_MCU_16s16u_P3C3R(pSrcMCU, pDstBGR, dstStep);
    default:
        assert(false);
        return _refr_fwiYCbCr444ToBGR555LS_MCU_16s16u_P3C3R(pSrcMCU, pDstBGR, dstStep);
    }
}


OREFR OSSE2 FwStatus STDCALL fwiYCbCr444ToRGBLS_MCU_16s8u_P3C3R(const Fw16s* pSrcMCU[3],
							Fw8u* pDstRGB, int dstStep)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiYCbCr444ToRGBLS_MCU_16s8u_P3C3R(pSrcMCU, pDstRGB, dstStep);
    case DT_REFR:
        return _refr_fwiYCbCr444ToRGBLS_MCU_16s8u_P3C3R(pSrcMCU, pDstRGB, dstStep);
    default:
        assert(false);
        return _refr_fwiYCbCr444ToRGBLS_MCU_16s8u_P3C3R(pSrcMCU, pDstRGB, dstStep);
    }
}

