#define OPT_REFR
#define OPT_LEVEL REFR
#define OPT_PREFIX _refr_
#undef __FWVIDEO_OPT_H__
#include "fwVideo_opt.h"
#undef OPT_REFR
#undef OPT_LEVEL
#undef OPT_PREFIX


#define OPT_SSE2
#define OPT_LEVEL SSE2
#define OPT_PREFIX _sse2_
#undef __FWVIDEO_OPT_H__
#include "fwVideo_opt.h"
#undef OPT_SSE2
#undef OPT_LEVEL
#undef OPT_PREFIX


#define OPT_F10H
#define OPT_LEVEL F10H
#define OPT_PREFIX _f10h_
#undef __FWVIDEO_OPT_H__
#include "fwVideo_opt.h"
#undef OPT_F10H
#undef OPT_LEVEL
#undef OPT_PREFIX


#define OPT_SSE3
#define OPT_LEVEL SSE3
#define OPT_PREFIX _sse3_
#undef __FWVIDEO_OPT_H__
#include "fwVideo_opt.h"
#undef OPT_SSE3
#undef OPT_LEVEL
#undef OPT_PREFIX


using namespace REFR;
OREFR OSSE2       FwStatus STDCALL fwiGetDiff8x16B_8u16s_C1(const Fw8u* pSrcCur,  Fw32s srcCurStep, const Fw8u* pSrcRefF, Fw32s srcRefStepF, Fw32s mcTypeF, const Fw8u* pSrcRefB, Fw32s srcRefStepB, Fw32s mcTypeB, Fw16s* pDstDiff, Fw32s dstDiffStep, Fw32s roundControl)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiGetDiff8x16B_8u16s_C1(pSrcCur, srcCurStep, pSrcRefF, srcRefStepF, mcTypeF, pSrcRefB, srcRefStepB, mcTypeB, pDstDiff, dstDiffStep, roundControl);
    case DT_REFR:
        return _refr_fwiGetDiff8x16B_8u16s_C1(pSrcCur, srcCurStep, pSrcRefF, srcRefStepF, mcTypeF, pSrcRefB, srcRefStepB, mcTypeB, pDstDiff, dstDiffStep, roundControl);
    default:
        assert(false);
        return _refr_fwiGetDiff8x16B_8u16s_C1(pSrcCur, srcCurStep, pSrcRefF, srcRefStepF, mcTypeF, pSrcRefB, srcRefStepB, mcTypeB, pDstDiff, dstDiffStep, roundControl);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiSAD4x4_8u32s(const Fw8u *pSrc, Fw32s srcStep, Fw8u *pRef, Fw32s refStep, Fw32s *pSAD, Fw32s mcType)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiSAD4x4_8u32s(pSrc, srcStep, pRef, refStep, pSAD, mcType);
    case DT_REFR:
        return _refr_fwiSAD4x4_8u32s(pSrc, srcStep, pRef, refStep, pSAD, mcType);
    default:
        assert(false);
        return _refr_fwiSAD4x4_8u32s(pSrc, srcStep, pRef, refStep, pSAD, mcType);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiDCT8x8Inv_AANTransposed_16s8u_P2C2R(const Fw16s *pSrcU, const Fw16s *pSrcV, Fw8u  *pDstUV, Fw32s dstStep, Fw32s countU, Fw32s countV )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiDCT8x8Inv_AANTransposed_16s8u_P2C2R(pSrcU, pSrcV, pDstUV, dstStep, countU, countV);
    case DT_REFR:
        return _refr_fwiDCT8x8Inv_AANTransposed_16s8u_P2C2R(pSrcU, pSrcV, pDstUV, dstStep, countU, countV);
    default:
        assert(false);
        return _refr_fwiDCT8x8Inv_AANTransposed_16s8u_P2C2R(pSrcU, pSrcV, pDstUV, dstStep, countU, countV);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiMC2x4_8u_C1( const Fw8u *pSrcRef, Fw32s srcStep, const Fw16s
*pSrcYData, Fw32s srcYDataStep, Fw8u *pDst, Fw32s dstStep, Fw32s mcType, Fw32s roundControl )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiMC2x4_8u_C1(pSrcRef, srcStep, pSrcYData, srcYDataStep, pDst, dstStep, mcType, roundControl);
    case DT_REFR:
        return _refr_fwiMC2x4_8u_C1(pSrcRef, srcStep, pSrcYData, srcYDataStep, pDst, dstStep, mcType, roundControl);
    default:
        assert(false);
        return _refr_fwiMC2x4_8u_C1(pSrcRef, srcStep, pSrcYData, srcYDataStep, pDst, dstStep, mcType, roundControl);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiReconstructDCTBlockIntra_MPEG2_32s(Fw32u **ppBitStream, int *pOffset, const FwVCHuffmanSpec_32s *pDCSizeTable, const FwVCHuffmanSpec_32s *pACTable, Fw32s *pScanMatrix, int QP, Fw16s *pQPMatrix, Fw16s *pDCPred, Fw32s shiftDCVal, Fw16s *pDstBlock, Fw32s *pDstSize)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiReconstructDCTBlockIntra_MPEG2_32s(ppBitStream, pOffset, pDCSizeTable, pACTable, pScanMatrix, QP, pQPMatrix, pDCPred, shiftDCVal, pDstBlock, pDstSize);
    case DT_REFR:
        return _refr_fwiReconstructDCTBlockIntra_MPEG2_32s(ppBitStream, pOffset, pDCSizeTable, pACTable, pScanMatrix, QP, pQPMatrix, pDCPred, shiftDCVal, pDstBlock, pDstSize);
    default:
        assert(false);
        return _refr_fwiReconstructDCTBlockIntra_MPEG2_32s(ppBitStream, pOffset, pDCSizeTable, pACTable, pScanMatrix, QP, pQPMatrix, pDCPred, shiftDCVal, pDstBlock, pDstSize);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiGetDiff16x16B_8u16s_C1(const Fw8u* pSrcCur,  Fw32s srcCurStep,const Fw8u* pSrcRefF, Fw32s srcRefStepF, Fw32s mcTypeF, const Fw8u* pSrcRefB, Fw32s srcRefStepB, Fw32s mcTypeB, Fw16s* pDstDiff, Fw32s dstDiffStep, Fw32s roundControl)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiGetDiff16x16B_8u16s_C1(pSrcCur, srcCurStep, pSrcRefF, srcRefStepF, mcTypeF, pSrcRefB, srcRefStepB, mcTypeB, pDstDiff, dstDiffStep, roundControl);
    case DT_REFR:
        return _refr_fwiGetDiff16x16B_8u16s_C1(pSrcCur, srcCurStep, pSrcRefF, srcRefStepF, mcTypeF, pSrcRefB, srcRefStepB, mcTypeB, pDstDiff, dstDiffStep, roundControl);
    default:
        assert(false);
        return _refr_fwiGetDiff16x16B_8u16s_C1(pSrcCur, srcCurStep, pSrcRefF, srcRefStepF, mcTypeF, pSrcRefB, srcRefStepB, mcTypeB, pDstDiff, dstDiffStep, roundControl);
    }
}

OREFR             FwStatus STDCALL fwiInterpolateChromaBottom_H264_8u_C1R(const Fw8u* pSrc, Fw32s
			srcStep, Fw8u* pDst, Fw32s dstStep, Fw32s dx, Fw32s dy, Fw32s outPixels, FwiSize roiSize)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiInterpolateChromaBottom_H264_8u_C1R(pSrc, 	srcStep, pDst, dstStep, dx, dy, outPixels, roiSize);
    default:
        assert(false);
        return _refr_fwiInterpolateChromaBottom_H264_8u_C1R(pSrc, 	srcStep, pDst, dstStep, dx, dy, outPixels, roiSize);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiVarMeanDiff16x8_8u32s_C1R(const Fw8u* pSrc, Fw32s srcStep, const Fw8u* pRef, Fw32s refStep, Fw32s* pSrcSum, Fw32s* pVar,  Fw32s* pMean, Fw32s mcType)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiVarMeanDiff16x8_8u32s_C1R(pSrc, srcStep, pRef, refStep, pSrcSum, pVar, pMean, mcType);
    case DT_REFR:
        return _refr_fwiVarMeanDiff16x8_8u32s_C1R(pSrc, srcStep, pRef, refStep, pSrcSum, pVar, pMean, mcType);
    default:
        assert(false);
        return _refr_fwiVarMeanDiff16x8_8u32s_C1R(pSrc, srcStep, pRef, refStep, pSrcSum, pVar, pMean, mcType);
    }
}


OREFR OSSE2       FwStatus STDCALL fwiReconstructLumaInterMB_H264_16s8u_C1R(
	Fw16s **ppSrcCoeff, Fw8u  *pSrcDstYPlane, const Fw32u srcDstYStep, const Fw32u cbp4x4, const Fw32s QP)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiReconstructLumaInterMB_H264_16s8u_C1R(ppSrcCoeff, pSrcDstYPlane, srcDstYStep, cbp4x4, QP);
    case DT_REFR:
        return _refr_fwiReconstructLumaInterMB_H264_16s8u_C1R(ppSrcCoeff, pSrcDstYPlane, srcDstYStep, cbp4x4, QP);
    default:
        assert(false);
        return _refr_fwiReconstructLumaInterMB_H264_16s8u_C1R(ppSrcCoeff, pSrcDstYPlane, srcDstYStep, cbp4x4, QP);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiGetDiff8x4_8u16s_C1(const Fw8u* pSrcCur, Fw32s srcCurStep, const Fw8u* pSrcRef, Fw32s srcRefStep, Fw16s* pDstDiff, Fw32s dstDiffStep, Fw16s* pDstPredictor,Fw32s dstPredictorStep, Fw32s mcType,	Fw32s roundControl)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiGetDiff8x4_8u16s_C1(pSrcCur, srcCurStep, pSrcRef, srcRefStep, pDstDiff, dstDiffStep, pDstPredictor, dstPredictorStep, mcType, roundControl);
    case DT_REFR:
        return _refr_fwiGetDiff8x4_8u16s_C1(pSrcCur, srcCurStep, pSrcRef, srcRefStep, pDstDiff, dstDiffStep, pDstPredictor, dstPredictorStep, mcType, roundControl);
    default:
        assert(false);
        return _refr_fwiGetDiff8x4_8u16s_C1(pSrcCur, srcCurStep, pSrcRef, srcRefStep, pDstDiff, dstDiffStep, pDstPredictor, dstPredictorStep, mcType, roundControl);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiGetDiff8x4B_8u16s_C1(const Fw8u* pSrcCur,  Fw32s srcCurStep, const Fw8u* pSrcRefF, Fw32s srcRefStepF, Fw32s mcTypeF, const Fw8u* pSrcRefB, Fw32s srcRefStepB, Fw32s mcTypeB, Fw16s* pDstDiff, Fw32s dstDiffStep, Fw32s roundControl)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiGetDiff8x4B_8u16s_C1(pSrcCur, srcCurStep, pSrcRefF, srcRefStepF, mcTypeF, pSrcRefB, srcRefStepB, mcTypeB, pDstDiff, dstDiffStep, roundControl);
    case DT_REFR:
        return _refr_fwiGetDiff8x4B_8u16s_C1(pSrcCur, srcCurStep, pSrcRefF, srcRefStepF, mcTypeF, pSrcRefB, srcRefStepB, mcTypeB, pDstDiff, dstDiffStep, roundControl);
    default:
        assert(false);
        return _refr_fwiGetDiff8x4B_8u16s_C1(pSrcCur, srcCurStep, pSrcRefF, srcRefStepF, mcTypeF, pSrcRefB, srcRefStepB, mcTypeB, pDstDiff, dstDiffStep, roundControl);
    }
}


OREFR OSSE2       FwStatus STDCALL fwiQuantInvIntra_MPEG2_16s_C1I(Fw16s *pSrcDst, int QP, Fw16s *pQPMatrix)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiQuantInvIntra_MPEG2_16s_C1I(pSrcDst, QP, pQPMatrix);
    case DT_REFR:
        return _refr_fwiQuantInvIntra_MPEG2_16s_C1I(pSrcDst, QP, pQPMatrix);
    default:
        assert(false);
        return _refr_fwiQuantInvIntra_MPEG2_16s_C1I(pSrcDst, QP, pQPMatrix);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiMC16x8UV_8u_C1( const Fw8u *pSrcRef, Fw32s srcStep, const
Fw16s *pSrcYData, Fw32s srcYDataStep, Fw8u *pDst, Fw32s dstStep, Fw32s mcType, Fw32s roundControl )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiMC16x8UV_8u_C1(pSrcRef, srcStep, pSrcYData, srcYDataStep, pDst, dstStep, mcType, roundControl);
    case DT_REFR:
        return _refr_fwiMC16x8UV_8u_C1(pSrcRef, srcStep, pSrcYData, srcYDataStep, pDst, dstStep, mcType, roundControl);
    default:
        assert(false);
        return _refr_fwiMC16x8UV_8u_C1(pSrcRef, srcStep, pSrcYData, srcYDataStep, pDst, dstStep, mcType, roundControl);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiMC16x8B_8u_C1( const Fw8u *pSrcRefF, Fw32s srcStepF, Fw32s
mcTypeF, const Fw8u *pSrcRefB, Fw32s srcStepB, Fw32s mcTypeB, const
Fw16s *pSrcYData, Fw32s srcYDataStep, Fw8u *pDst, Fw32s dstStep, Fw32s roundControl )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiMC16x8B_8u_C1(pSrcRefF, srcStepF, 
mcTypeF, pSrcRefB, srcStepB, mcTypeB, pSrcYData, srcYDataStep, pDst, dstStep, roundControl);
    case DT_REFR:
        return _refr_fwiMC16x8B_8u_C1(pSrcRefF, srcStepF, 
mcTypeF, pSrcRefB, srcStepB, mcTypeB, pSrcYData, srcYDataStep, pDst, dstStep, roundControl);
    default:
        assert(false);
        return _refr_fwiMC16x8B_8u_C1(pSrcRefF, srcStepF, 
mcTypeF, pSrcRefB, srcStepB, mcTypeB, pSrcYData, srcYDataStep, pDst, dstStep, roundControl);
    }
}


OREFR             FwStatus STDCALL fwiHuffmanTableInitAlloc_32s(const Fw32s* pSrcTable, FwVCHuffmanSpec_32s** ppDstSpec)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiHuffmanTableInitAlloc_32s(pSrcTable, ppDstSpec);
    default:
        assert(false);
        return _refr_fwiHuffmanTableInitAlloc_32s(pSrcTable, ppDstSpec);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiGetDiff8x8B_8u16s_C1(const Fw8u* pSrcCur,  Fw32s srcCurStep, const Fw8u* pSrcRefF, Fw32s srcRefStepF, Fw32s mcTypeF, const Fw8u* pSrcRefB, Fw32s srcRefStepB, Fw32s mcTypeB, Fw16s* pDstDiff, Fw32s dstDiffStep, Fw32s roundControl)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiGetDiff8x8B_8u16s_C1(pSrcCur, srcCurStep, pSrcRefF, srcRefStepF, mcTypeF, pSrcRefB, srcRefStepB, mcTypeB, pDstDiff, dstDiffStep, roundControl);
    case DT_REFR:
        return _refr_fwiGetDiff8x8B_8u16s_C1(pSrcCur, srcCurStep, pSrcRefF, srcRefStepF, mcTypeF, pSrcRefB, srcRefStepB, mcTypeB, pDstDiff, dstDiffStep, roundControl);
    default:
        assert(false);
        return _refr_fwiGetDiff8x8B_8u16s_C1(pSrcCur, srcCurStep, pSrcRefF, srcRefStepF, mcTypeF, pSrcRefB, srcRefStepB, mcTypeB, pDstDiff, dstDiffStep, roundControl);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiInterpolateChromaTop_H264_8u_C1R(const Fw8u* pSrc, 
	Fw32s srcStep, Fw8u* pDst, Fw32s dstStep, Fw32s dx, Fw32s dy, 
	Fw32s outPixels, FwiSize roiSize)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiInterpolateChromaTop_H264_8u_C1R(pSrc, srcStep, pDst, dstStep, dx, dy, outPixels, roiSize);
    case DT_REFR:
        return _refr_fwiInterpolateChromaTop_H264_8u_C1R(pSrc, srcStep, pDst, dstStep, dx, dy, outPixels, roiSize);
    default:
        assert(false);
        return _refr_fwiInterpolateChromaTop_H264_8u_C1R(pSrc, srcStep, pDst, dstStep, dx, dy, outPixels, roiSize);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiInterpolateLumaTop_H264_8u_C1R(const Fw8u* pSrc, Fw32s srcStep,
	Fw8u* pDst, Fw32s dstStep, Fw32s dx, Fw32s dy, Fw32s outPixels, FwiSize roiSize)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiInterpolateLumaTop_H264_8u_C1R(pSrc, srcStep, pDst, dstStep, dx, dy, outPixels, roiSize);
    case DT_REFR:
        return _refr_fwiInterpolateLumaTop_H264_8u_C1R(pSrc, srcStep, pDst, dstStep, dx, dy, outPixels, roiSize);
    default:
        assert(false);
        return _refr_fwiInterpolateLumaTop_H264_8u_C1R(pSrc, srcStep, pDst, dstStep, dx, dy, outPixels, roiSize);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiMC8x4B_8u_C1( const Fw8u *pSrcRefF, Fw32s srcStepF, Fw32s
mcTypeF, const Fw8u *pSrcRefB, Fw32s srcStepB, Fw32s mcTypeB, const
Fw16s *pSrcYData, Fw32s srcYDataStep, Fw8u *pDst, Fw32s dstStep, Fw32s roundControl )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiMC8x4B_8u_C1(pSrcRefF, srcStepF, 
mcTypeF, pSrcRefB, srcStepB, mcTypeB, pSrcYData, srcYDataStep, pDst, dstStep, roundControl);
    case DT_REFR:
        return _refr_fwiMC8x4B_8u_C1(pSrcRefF, srcStepF, 
mcTypeF, pSrcRefB, srcStepB, mcTypeB, pSrcYData, srcYDataStep, pDst, dstStep, roundControl);
    default:
        assert(false);
        return _refr_fwiMC8x4B_8u_C1(pSrcRefF, srcStepF, 
mcTypeF, pSrcRefB, srcStepB, mcTypeB, pSrcYData, srcYDataStep, pDst, dstStep, roundControl);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiDCT8x8Inv_AANTransposed_16s_P2C2R(const Fw16s *pSrcU, const Fw16s *pSrcV, Fw16s *pDstUV, Fw32s dstStep, Fw32s countU, Fw32s countV )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiDCT8x8Inv_AANTransposed_16s_P2C2R(pSrcU, pSrcV, pDstUV, dstStep, countU, countV);
    case DT_REFR:
        return _refr_fwiDCT8x8Inv_AANTransposed_16s_P2C2R(pSrcU, pSrcV, pDstUV, dstStep, countU, countV);
    default:
        assert(false);
        return _refr_fwiDCT8x8Inv_AANTransposed_16s_P2C2R(pSrcU, pSrcV, pDstUV, dstStep, countU, countV);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiMC4x2_8u_C1( const Fw8u *pSrcRef, Fw32s srcStep, const Fw16s
*pSrcYData, Fw32s srcYDataStep, Fw8u *pDst, Fw32s dstStep, Fw32s mcType, Fw32s roundControl )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiMC4x2_8u_C1(pSrcRef, srcStep, pSrcYData, srcYDataStep, pDst, dstStep, mcType, roundControl);
    case DT_REFR:
        return _refr_fwiMC4x2_8u_C1(pSrcRef, srcStep, pSrcYData, srcYDataStep, pDst, dstStep, mcType, roundControl);
    default:
        assert(false);
        return _refr_fwiMC4x2_8u_C1(pSrcRef, srcStep, pSrcYData, srcYDataStep, pDst, dstStep, mcType, roundControl);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiPredictIntra_16x16_H264_8u_C1IR(Fw8u* pSrcDst, 
	  Fw32s srcDstStep, FwIntra16x16PredMode_H264 predMode, Fw32s availability)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiPredictIntra_16x16_H264_8u_C1IR(pSrcDst, srcDstStep, predMode, availability);
    case DT_REFR:
        return _refr_fwiPredictIntra_16x16_H264_8u_C1IR(pSrcDst, srcDstStep, predMode, availability);
    default:
        assert(false);
        return _refr_fwiPredictIntra_16x16_H264_8u_C1IR(pSrcDst, srcDstStep, predMode, availability);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiSAD16x16Blocks8x8_8u16u(const Fw8u  *pSrc, Fw32s srcStep, Fw8u  *pRef, Fw32s refStep, Fw16u *pDstSAD, Fw32s mcType)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiSAD16x16Blocks8x8_8u16u(pSrc, srcStep, pRef, refStep, pDstSAD, mcType);
    case DT_REFR:
        return _refr_fwiSAD16x16Blocks8x8_8u16u(pSrc, srcStep, pRef, refStep, pDstSAD, mcType);
    default:
        assert(false);
        return _refr_fwiSAD16x16Blocks8x8_8u16u(pSrc, srcStep, pRef, refStep, pDstSAD, mcType);
    }
}


OREFR             FwStatus STDCALL fwiHuffmanTableFree_32s(FwVCHuffmanSpec_32s** ppDecodeTable)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiHuffmanTableFree_32s(ppDecodeTable);
    default:
        assert(false);
        return _refr_fwiHuffmanTableFree_32s(ppDecodeTable);
    }
}

OREFR             FwStatus STDCALL fwiDecodeHuffmanPair_1u16s(Fw32u** ppBitStream, Fw32s* pOffset, const FwVCHuffmanSpec_32s *pDecodeTable, Fw8s *pFirst, Fw16s *pSecond)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiDecodeHuffmanPair_1u16s(ppBitStream, pOffset, pDecodeTable, pFirst, pSecond);
    default:
        assert(false);
        return _refr_fwiDecodeHuffmanPair_1u16s(ppBitStream, pOffset, pDecodeTable, pFirst, pSecond);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiDCT8x8Inv_AANTransposed_16s8u_C1R(const Fw16s *pSrc, Fw8u  *pDst, Fw32s dstStep, Fw32s count )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiDCT8x8Inv_AANTransposed_16s8u_C1R(pSrc, pDst, dstStep, count);
    case DT_REFR:
        return _refr_fwiDCT8x8Inv_AANTransposed_16s8u_C1R(pSrc, pDst, dstStep, count);
    default:
        assert(false);
        return _refr_fwiDCT8x8Inv_AANTransposed_16s8u_C1R(pSrc, pDst, dstStep, count);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiGetDiff4x4_8u16s_C1(const Fw8u* pSrcCur, Fw32s srcCurStep, const Fw8u* pSrcRef, Fw32s srcRefStep, Fw16s* pDstDiff, Fw32s dstDiffStep, Fw16s* pDstPredictor,Fw32s dstPredictorStep, Fw32s mcType,	Fw32s roundControl)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiGetDiff4x4_8u16s_C1(pSrcCur, srcCurStep, pSrcRef, srcRefStep, pDstDiff, dstDiffStep, pDstPredictor, dstPredictorStep, mcType, roundControl);
    case DT_REFR:
        return _refr_fwiGetDiff4x4_8u16s_C1(pSrcCur, srcCurStep, pSrcRef, srcRefStep, pDstDiff, dstDiffStep, pDstPredictor, dstPredictorStep, mcType, roundControl);
    default:
        assert(false);
        return _refr_fwiGetDiff4x4_8u16s_C1(pSrcCur, srcCurStep, pSrcRef, srcRefStep, pDstDiff, dstDiffStep, pDstPredictor, dstPredictorStep, mcType, roundControl);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiGetDiff8x8_8u16s_C1(const Fw8u* pSrcCur, Fw32s srcCurStep,const Fw8u* pSrcRef, Fw32s srcRefStep, Fw16s* pDstDiff, Fw32s dstDiffStep, Fw16s* pDstPredictor,Fw32s dstPredictorStep, Fw32s mcType,  Fw32s roundControl)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiGetDiff8x8_8u16s_C1(pSrcCur, srcCurStep, pSrcRef, srcRefStep, pDstDiff, dstDiffStep, pDstPredictor, dstPredictorStep, mcType, roundControl);
    case DT_REFR:
        return _refr_fwiGetDiff8x8_8u16s_C1(pSrcCur, srcCurStep, pSrcRef, srcRefStep, pDstDiff, dstDiffStep, pDstPredictor, dstPredictorStep, mcType, roundControl);
    default:
        assert(false);
        return _refr_fwiGetDiff8x8_8u16s_C1(pSrcCur, srcCurStep, pSrcRef, srcRefStep, pDstDiff, dstDiffStep, pDstPredictor, dstPredictorStep, mcType, roundControl);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiReconstructChromaIntraMB_H264_16s8u_P2R(
	Fw16s **ppSrcCoeff, Fw8u *pSrcDstUPlane, Fw8u *pSrcDstVPlane, 
	const Fw32u srcDstUVStep, const FwIntraChromaPredMode_H264 intraChromaMode, const Fw32u cbp4x4, const Fw32u ChromaQP, const Fw8u edgeType)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiReconstructChromaIntraMB_H264_16s8u_P2R(ppSrcCoeff, pSrcDstUPlane, pSrcDstVPlane, srcDstUVStep, intraChromaMode, cbp4x4, ChromaQP, edgeType);
    case DT_REFR:
        return _refr_fwiReconstructChromaIntraMB_H264_16s8u_P2R(ppSrcCoeff, pSrcDstUPlane, pSrcDstVPlane, srcDstUVStep, intraChromaMode, cbp4x4, ChromaQP, edgeType);
    default:
        assert(false);
        return _refr_fwiReconstructChromaIntraMB_H264_16s8u_P2R(ppSrcCoeff, pSrcDstUPlane, pSrcDstVPlane, srcDstUVStep, intraChromaMode, cbp4x4, ChromaQP, edgeType);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiMC8x16_8u_C1( const Fw8u *pSrcRef, Fw32s srcStep, const Fw16s
*pSrcYData, Fw32s srcYDataStep, Fw8u *pDst, Fw32s dstStep, Fw32s mcType, Fw32s roundControl )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiMC8x16_8u_C1(pSrcRef, srcStep, pSrcYData, srcYDataStep, pDst, dstStep, mcType, roundControl);
    case DT_REFR:
        return _refr_fwiMC8x16_8u_C1(pSrcRef, srcStep, pSrcYData, srcYDataStep, pDst, dstStep, mcType, roundControl);
    default:
        assert(false);
        return _refr_fwiMC8x16_8u_C1(pSrcRef, srcStep, pSrcYData, srcYDataStep, pDst, dstStep, mcType, roundControl);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiSumsDiff16x16Blocks4x4_8u16s_C1(Fw8u * pSrc,  Fw32s srcStep,Fw8u * pPred, Fw32s predStep, Fw16s* pSums, Fw16s* pDiff)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiSumsDiff16x16Blocks4x4_8u16s_C1(pSrc, srcStep, pPred, predStep, pSums, pDiff);
    case DT_REFR:
        return _refr_fwiSumsDiff16x16Blocks4x4_8u16s_C1(pSrc, srcStep, pPred, predStep, pSums, pDiff);
    default:
        assert(false);
        return _refr_fwiSumsDiff16x16Blocks4x4_8u16s_C1(pSrc, srcStep, pPred, predStep, pSums, pDiff);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiInterpolateLumaBottom_H264_8u_C1R(const Fw8u* pSrc, Fw32s
	srcStep, Fw8u* pDst, Fw32s dstStep, Fw32s dx, Fw32s dy, Fw32s
			outPixels, FwiSize roiSize)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiInterpolateLumaBottom_H264_8u_C1R(pSrc, 	srcStep, pDst, dstStep, dx, dy, 	outPixels, roiSize);
    case DT_REFR:
        return _refr_fwiInterpolateLumaBottom_H264_8u_C1R(pSrc, 	srcStep, pDst, dstStep, dx, dy, 	outPixels, roiSize);
    default:
        assert(false);
        return _refr_fwiInterpolateLumaBottom_H264_8u_C1R(pSrc, 	srcStep, pDst, dstStep, dx, dy, 	outPixels, roiSize);
    }
}

OREFR             FwStatus STDCALL fwiReconstructDCTBlockIntra_MPEG1_32s(Fw32u **ppBitStream, int *pOffset, const Fw32s *pDCSizeTable, const Fw32s *pACTable, Fw32s *pScanMatrix, int QP, Fw16s *pQPMatrix, Fw16s *pDCPred, Fw16s *pDstBlock, Fw32s *pDstSize)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiReconstructDCTBlockIntra_MPEG1_32s(ppBitStream, pOffset, pDCSizeTable, pACTable, pScanMatrix, QP, pQPMatrix, pDCPred, pDstBlock, pDstSize);
    default:
        assert(false);
        return _refr_fwiReconstructDCTBlockIntra_MPEG1_32s(ppBitStream, pOffset, pDCSizeTable, pACTable, pScanMatrix, QP, pQPMatrix, pDCPred, pDstBlock, pDstSize);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiMC8x8B_8u_C1( const Fw8u *pSrcRefF, Fw32s srcStepF, Fw32s
mcTypeF, const Fw8u *pSrcRefB, Fw32s srcStepB, Fw32s mcTypeB, const
Fw16s *pSrcYData, Fw32s srcYDataStep, Fw8u *pDst, Fw32s dstStep, Fw32s roundControl )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiMC8x8B_8u_C1(pSrcRefF, srcStepF, 
mcTypeF, pSrcRefB, srcStepB, mcTypeB, pSrcYData, srcYDataStep, pDst, dstStep, roundControl);
    case DT_REFR:
        return _refr_fwiMC8x8B_8u_C1(pSrcRefF, srcStepF, 
mcTypeF, pSrcRefB, srcStepB, mcTypeB, pSrcYData, srcYDataStep, pDst, dstStep, roundControl);
    default:
        assert(false);
        return _refr_fwiMC8x8B_8u_C1(pSrcRefF, srcStepF, 
mcTypeF, pSrcRefB, srcStepB, mcTypeB, pSrcYData, srcYDataStep, pDst, dstStep, roundControl);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiGetDiff16x8_8u16s_C1(const Fw8u* pSrcCur, Fw32s srcCurStep,const Fw8u* pSrcRef, Fw32s srcRefStep, Fw16s* pDstDiff, Fw32s dstDiffStep, Fw16s* pDstPredictor,Fw32s dstPredictorStep,  Fw32s mcType, Fw32s roundControl)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiGetDiff16x8_8u16s_C1(pSrcCur, srcCurStep, pSrcRef, srcRefStep, pDstDiff, dstDiffStep, pDstPredictor, dstPredictorStep, mcType, roundControl);
    case DT_REFR:
        return _refr_fwiGetDiff16x8_8u16s_C1(pSrcCur, srcCurStep, pSrcRef, srcRefStep, pDstDiff, dstDiffStep, pDstPredictor, dstPredictorStep, mcType, roundControl);
    default:
        assert(false);
        return _refr_fwiGetDiff16x8_8u16s_C1(pSrcCur, srcCurStep, pSrcRef, srcRefStep, pDstDiff, dstDiffStep, pDstPredictor, dstPredictorStep, mcType, roundControl);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiMC8x4_8u_C1( const Fw8u *pSrcRef, Fw32s srcStep, const Fw16s
*pSrcYData, Fw32s srcYDataStep, Fw8u *pDst, Fw32s dstStep, Fw32s mcType, Fw32s roundControl )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiMC8x4_8u_C1(pSrcRef, srcStep, pSrcYData, srcYDataStep, pDst, dstStep, mcType, roundControl);
    case DT_REFR:
        return _refr_fwiMC8x4_8u_C1(pSrcRef, srcStep, pSrcYData, srcYDataStep, pDst, dstStep, mcType, roundControl);
    default:
        assert(false);
        return _refr_fwiMC8x4_8u_C1(pSrcRef, srcStep, pSrcYData, srcYDataStep, pDst, dstStep, mcType, roundControl);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiVarMean8x8_16s32s_C1R(const Fw16s* pSrc, Fw32s srcStep, Fw32s* pVar, Fw32s* pMean)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiVarMean8x8_16s32s_C1R(pSrc, srcStep, pVar, pMean);
    case DT_REFR:
        return _refr_fwiVarMean8x8_16s32s_C1R(pSrc, srcStep, pVar, pMean);
    default:
        assert(false);
        return _refr_fwiVarMean8x8_16s32s_C1R(pSrc, srcStep, pVar, pMean);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiMC2x2B_8u_C1( const Fw8u *pSrcRefF, Fw32s srcStepF, Fw32s
mcTypeF, const Fw8u *pSrcRefB, Fw32s srcStepB, Fw32s mcTypeB, const
Fw16s *pSrcYData, Fw32s srcYDataStep, Fw8u *pDst, Fw32s dstStep, Fw32s roundControl )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiMC2x2B_8u_C1(pSrcRefF, srcStepF, 
mcTypeF, pSrcRefB, srcStepB, mcTypeB, pSrcYData, srcYDataStep, pDst, dstStep, roundControl);
    case DT_REFR:
        return _refr_fwiMC2x2B_8u_C1(pSrcRefF, srcStepF, 
mcTypeF, pSrcRefB, srcStepB, mcTypeB, pSrcYData, srcYDataStep, pDst, dstStep, roundControl);
    default:
        assert(false);
        return _refr_fwiMC2x2B_8u_C1(pSrcRefF, srcStepF, 
mcTypeF, pSrcRefB, srcStepB, mcTypeB, pSrcYData, srcYDataStep, pDst, dstStep, roundControl);
    }
}


OREFR             FwStatus STDCALL fwiReconstructDCTBlock_MPEG1_32s(Fw32u **ppBitStream, int *pOffset, const Fw32s *pDCSizeTable, const Fw32s *pACTable, Fw32s *pScanMatrix, int QP, Fw16s *pQPMatrix, Fw16s *pDstBlock, Fw32s *pDstSize)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiReconstructDCTBlock_MPEG1_32s(ppBitStream, pOffset, pDCSizeTable, pACTable, pScanMatrix, QP, pQPMatrix, pDstBlock, pDstSize);
    default:
        assert(false);
        return _refr_fwiReconstructDCTBlock_MPEG1_32s(ppBitStream, pOffset, pDCSizeTable, pACTable, pScanMatrix, QP, pQPMatrix, pDstBlock, pDstSize);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiReconstructLumaIntraMB_H264_16s8u_C1R(
	Fw16s **ppSrcCoeff, Fw8u  *pSrcDstYPlane, Fw32s srcDstYStep, 
	const FwIntra4x4PredMode_H264 *pMBIntraTypes, const Fw32u cbp4x4, const Fw32u QP, const Fw8u  edgeType)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiReconstructLumaIntraMB_H264_16s8u_C1R(ppSrcCoeff, pSrcDstYPlane, srcDstYStep, pMBIntraTypes, cbp4x4, QP, edgeType);
    case DT_REFR:
        return _refr_fwiReconstructLumaIntraMB_H264_16s8u_C1R(ppSrcCoeff, pSrcDstYPlane, srcDstYStep, pMBIntraTypes, cbp4x4, QP, edgeType);
    default:
        assert(false);
        return _refr_fwiReconstructLumaIntraMB_H264_16s8u_C1R(ppSrcCoeff, pSrcDstYPlane, srcDstYStep, pMBIntraTypes, cbp4x4, QP, edgeType);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiMC4x4_8u_C1( const Fw8u *pSrcRef, Fw32s srcStep, const Fw16s
*pSrcYData, Fw32s srcYDataStep, Fw8u *pDst, Fw32s dstStep, Fw32s mcType, Fw32s roundControl )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiMC4x4_8u_C1(pSrcRef, srcStep, pSrcYData, srcYDataStep, pDst, dstStep, mcType, roundControl);
    case DT_REFR:
        return _refr_fwiMC4x4_8u_C1(pSrcRef, srcStep, pSrcYData, srcYDataStep, pDst, dstStep, mcType, roundControl);
    default:
        assert(false);
        return _refr_fwiMC4x4_8u_C1(pSrcRef, srcStep, pSrcYData, srcYDataStep, pDst, dstStep, mcType, roundControl);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiGetDiff16x8B_8u16s_C1(const Fw8u* pSrcCur,  Fw32s srcCurStep, const Fw8u* pSrcRefF, Fw32s srcRefStepF, Fw32s mcTypeF, const Fw8u* pSrcRefB, Fw32s srcRefStepB, Fw32s mcTypeB, Fw16s* pDstDiff, Fw32s dstDiffStep, Fw32s roundControl)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiGetDiff16x8B_8u16s_C1(pSrcCur, srcCurStep, pSrcRefF, srcRefStepF, mcTypeF, pSrcRefB, srcRefStepB, mcTypeB, pDstDiff, dstDiffStep, roundControl);
    case DT_REFR:
        return _refr_fwiGetDiff16x8B_8u16s_C1(pSrcCur, srcCurStep, pSrcRefF, srcRefStepF, mcTypeF, pSrcRefB, srcRefStepB, mcTypeB, pDstDiff, dstDiffStep, roundControl);
    default:
        assert(false);
        return _refr_fwiGetDiff16x8B_8u16s_C1(pSrcCur, srcCurStep, pSrcRefF, srcRefStepF, mcTypeF, pSrcRefB, srcRefStepB, mcTypeB, pDstDiff, dstDiffStep, roundControl);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiInterpolateLuma_H264_8u_C1R(
	const Fw8u* pSrc, Fw32s srcStep, Fw8u* pDst, Fw32s dstStep, 
	Fw32s dx,   Fw32s dy, FwiSize roiSize)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiInterpolateLuma_H264_8u_C1R(pSrc, srcStep, pDst, dstStep, dx, dy, roiSize);
    case DT_REFR:
        return _refr_fwiInterpolateLuma_H264_8u_C1R(pSrc, srcStep, pDst, dstStep, dx, dy, roiSize);
    default:
        assert(false);
        return _refr_fwiInterpolateLuma_H264_8u_C1R(pSrc, srcStep, pDst, dstStep, dx, dy, roiSize);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiQuantInv_MPEG2_16s_C1I(Fw16s *pSrcDst, int QP, Fw16s *pQPMatrix)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiQuantInv_MPEG2_16s_C1I(pSrcDst, QP, pQPMatrix);
    case DT_REFR:
        return _refr_fwiQuantInv_MPEG2_16s_C1I(pSrcDst, QP, pQPMatrix);
    default:
        assert(false);
        return _refr_fwiQuantInv_MPEG2_16s_C1I(pSrcDst, QP, pQPMatrix);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiMC4x8B_8u_C1( const Fw8u *pSrcRefF, Fw32s srcStepF, Fw32s
mcTypeF, const Fw8u *pSrcRefB, Fw32s srcStepB, Fw32s mcTypeB, const
Fw16s *pSrcYData, Fw32s srcYDataStep, Fw8u *pDst, Fw32s dstStep, Fw32s roundControl )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiMC4x8B_8u_C1(pSrcRefF, srcStepF, 
mcTypeF, pSrcRefB, srcStepB, mcTypeB, pSrcYData, srcYDataStep, pDst, dstStep, roundControl);
    case DT_REFR:
        return _refr_fwiMC4x8B_8u_C1(pSrcRefF, srcStepF, 
mcTypeF, pSrcRefB, srcStepB, mcTypeB, pSrcYData, srcYDataStep, pDst, dstStep, roundControl);
    default:
        assert(false);
        return _refr_fwiMC4x8B_8u_C1(pSrcRefF, srcStepF, 
mcTypeF, pSrcRefB, srcStepB, mcTypeB, pSrcYData, srcYDataStep, pDst, dstStep, roundControl);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiVarMean8x8_8u32s_C1R(const Fw8u* pSrc, Fw32s srcStep, Fw32s* pVar, Fw32s* pMean)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiVarMean8x8_8u32s_C1R(pSrc, srcStep, pVar, pMean);
    case DT_REFR:
        return _refr_fwiVarMean8x8_8u32s_C1R(pSrc, srcStep, pVar, pMean);
    default:
        assert(false);
        return _refr_fwiVarMean8x8_8u32s_C1R(pSrc, srcStep, pVar, pMean);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiGetDiff8x16_8u16s_C1(const Fw8u* pSrcCur, Fw32s srcCurStep, const Fw8u* pSrcRef, Fw32s srcRefStep, Fw16s* pDstDiff, Fw32s dstDiffStep, Fw16s* pDstPredictor,Fw32s dstPredictorStep, Fw32s mcType,	Fw32s roundControl)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiGetDiff8x16_8u16s_C1(pSrcCur, srcCurStep, pSrcRef, srcRefStep, pDstDiff, dstDiffStep, pDstPredictor, dstPredictorStep, mcType, roundControl);
    case DT_REFR:
        return _refr_fwiGetDiff8x16_8u16s_C1(pSrcCur, srcCurStep, pSrcRef, srcRefStep, pDstDiff, dstDiffStep, pDstPredictor, dstPredictorStep, mcType, roundControl);
    default:
        assert(false);
        return _refr_fwiGetDiff8x16_8u16s_C1(pSrcCur, srcCurStep, pSrcRef, srcRefStep, pDstDiff, dstDiffStep, pDstPredictor, dstPredictorStep, mcType, roundControl);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiMC4x8_8u_C1( const Fw8u *pSrcRef, Fw32s srcStep, const Fw16s
*pSrcYData, Fw32s srcYDataStep, Fw8u *pDst, Fw32s dstStep, Fw32s mcType, Fw32s roundControl )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiMC4x8_8u_C1(pSrcRef, srcStep, pSrcYData, srcYDataStep, pDst, dstStep, mcType, roundControl);
    case DT_REFR:
        return _refr_fwiMC4x8_8u_C1(pSrcRef, srcStep, pSrcYData, srcYDataStep, pDst, dstStep, mcType, roundControl);
    default:
        assert(false);
        return _refr_fwiMC4x8_8u_C1(pSrcRef, srcStep, pSrcYData, srcYDataStep, pDst, dstStep, mcType, roundControl);
    }
}

OREFR             FwStatus STDCALL fwiTransformDequantChromaDC_H264_16s_C1I(Fw16s* pSrcDst, Fw32s QP)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiTransformDequantChromaDC_H264_16s_C1I(pSrcDst, QP);
    default:
        assert(false);
        return _refr_fwiTransformDequantChromaDC_H264_16s_C1I(pSrcDst, QP);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiSAD16x16_8u32s(const Fw8u* pSrc, Fw32s srcStep, const Fw8u* pRef, Fw32s refStep, Fw32s* pSAD, Fw32s mcType)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiSAD16x16_8u32s(pSrc, srcStep, pRef, refStep, pSAD, mcType);
    case DT_REFR:
        return _refr_fwiSAD16x16_8u32s(pSrc, srcStep, pRef, refStep, pSAD, mcType);
    default:
        assert(false);
        return _refr_fwiSAD16x16_8u32s(pSrc, srcStep, pRef, refStep, pSAD, mcType);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiSAD16x16Blocks4x4_8u16u(const Fw8u *pSrc, Fw32s srcStep, Fw8u *pRef, Fw32s refStep, Fw16u *pDstSAD, Fw32s mcType)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiSAD16x16Blocks4x4_8u16u(pSrc, srcStep, pRef, refStep, pDstSAD, mcType);
    case DT_REFR:
        return _refr_fwiSAD16x16Blocks4x4_8u16u(pSrc, srcStep, pRef, refStep, pDstSAD, mcType);
    default:
        assert(false);
        return _refr_fwiSAD16x16Blocks4x4_8u16u(pSrc, srcStep, pRef, refStep, pDstSAD, mcType);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiMC2x4B_8u_C1( const Fw8u *pSrcRefF, Fw32s srcStepF, Fw32s
mcTypeF, const Fw8u *pSrcRefB, Fw32s srcStepB, Fw32s mcTypeB, const
Fw16s *pSrcYData, Fw32s srcYDataStep, Fw8u *pDst, Fw32s dstStep, Fw32s roundControl )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiMC2x4B_8u_C1(pSrcRefF, srcStepF, 
mcTypeF, pSrcRefB, srcStepB, mcTypeB, pSrcYData, srcYDataStep, pDst, dstStep, roundControl);
    case DT_REFR:
        return _refr_fwiMC2x4B_8u_C1(pSrcRefF, srcStepF, 
mcTypeF, pSrcRefB, srcStepB, mcTypeB, pSrcYData, srcYDataStep, pDst, dstStep, roundControl);
    default:
        assert(false);
        return _refr_fwiMC2x4B_8u_C1(pSrcRefF, srcStepF, 
mcTypeF, pSrcRefB, srcStepB, mcTypeB, pSrcYData, srcYDataStep, pDst, dstStep, roundControl);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiMC2x2_8u_C1( const Fw8u *pSrcRef, Fw32s srcStep, const Fw16s
*pSrcYData, Fw32s srcYDataStep, Fw8u *pDst, Fw32s dstStep, Fw32s mcType, Fw32s roundControl )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiMC2x2_8u_C1(pSrcRef, srcStep, pSrcYData, srcYDataStep, pDst, dstStep, mcType, roundControl);
    case DT_REFR:
        return _refr_fwiMC2x2_8u_C1(pSrcRef, srcStep, pSrcYData, srcYDataStep, pDst, dstStep, mcType, roundControl);
    default:
        assert(false);
        return _refr_fwiMC2x2_8u_C1(pSrcRef, srcStep, pSrcYData, srcYDataStep, pDst, dstStep, mcType, roundControl);
    }
}

OREFR             FwStatus STDCALL fwiFilterDeblockingLuma_HorEdge_H264_8u_C1IR( Fw8u* pSrcDst, Fw32s srcDstStep, Fw8u* pAlpha, Fw8u* pBeta, Fw8u* pThresholds, Fw8u* pBS)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiFilterDeblockingLuma_HorEdge_H264_8u_C1IR(pSrcDst, srcDstStep, pAlpha, pBeta, pThresholds, pBS);
    default:
        assert(false);
        return _refr_fwiFilterDeblockingLuma_HorEdge_H264_8u_C1IR(pSrcDst, srcDstStep, pAlpha, pBeta, pThresholds, pBS);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiEdgesDetect16x16_8u_C1R(const Fw8u *pSrc, Fw32u srcStep, Fw8u EdgePelDifference, Fw8u EdgePelCount, Fw8u *pRes)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiEdgesDetect16x16_8u_C1R(pSrc, srcStep, EdgePelDifference, EdgePelCount, pRes);
    case DT_REFR:
        return _refr_fwiEdgesDetect16x16_8u_C1R(pSrc, srcStep, EdgePelDifference, EdgePelCount, pRes);
    default:
        assert(false);
        return _refr_fwiEdgesDetect16x16_8u_C1R(pSrc, srcStep, EdgePelDifference, EdgePelCount, pRes);
    }
}



OREFR             FwStatus STDCALL fwiPredictIntra_4x4_H264_8u_C1IR(Fw8u* pSrcDst, 
		Fw32s srcDstStep,	FwIntra4x4PredMode_H264 predMode, 	Fw32s availability)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiPredictIntra_4x4_H264_8u_C1IR(pSrcDst, srcDstStep, predMode, availability);
    default:
        assert(false);
        return _refr_fwiPredictIntra_4x4_H264_8u_C1IR(pSrcDst, srcDstStep, predMode, availability);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiPredictIntraChroma8x8_H264_8u_C1IR(Fw8u* pSrcDst, 
	 Fw32s srcDstStep, FwIntraChromaPredMode_H264 predMode, Fw32s availability)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiPredictIntraChroma8x8_H264_8u_C1IR(pSrcDst, srcDstStep, predMode, availability);
    case DT_REFR:
        return _refr_fwiPredictIntraChroma8x8_H264_8u_C1IR(pSrcDst, srcDstStep, predMode, availability);
    default:
        assert(false);
        return _refr_fwiPredictIntraChroma8x8_H264_8u_C1IR(pSrcDst, srcDstStep, predMode, availability);
    }
}


OREFR OSSE2       FwStatus STDCALL fwiDecodeExpGolombOne_H264_1u16s(Fw32u **ppBitStream, Fw32s *pBitOffset, Fw16s *pDst, Fw8u isSigned)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiDecodeExpGolombOne_H264_1u16s(ppBitStream, pBitOffset, pDst, isSigned);
    case DT_REFR:
        return _refr_fwiDecodeExpGolombOne_H264_1u16s(ppBitStream, pBitOffset, pDst, isSigned);
    default:
        assert(false);
        return _refr_fwiDecodeExpGolombOne_H264_1u16s(ppBitStream, pBitOffset, pDst, isSigned);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiMC4x4B_8u_C1( const Fw8u *pSrcRefF, Fw32s srcStepF, Fw32s
mcTypeF, const Fw8u *pSrcRefB, Fw32s srcStepB, Fw32s mcTypeB, const
Fw16s *pSrcYData, Fw32s srcYDataStep, Fw8u *pDst, Fw32s dstStep, Fw32s roundControl )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiMC4x4B_8u_C1(pSrcRefF, srcStepF, 
mcTypeF, pSrcRefB, srcStepB, mcTypeB, pSrcYData, srcYDataStep, pDst, dstStep, roundControl);
    case DT_REFR:
        return _refr_fwiMC4x4B_8u_C1(pSrcRefF, srcStepF, 
mcTypeF, pSrcRefB, srcStepB, mcTypeB, pSrcYData, srcYDataStep, pDst, dstStep, roundControl);
    default:
        assert(false);
        return _refr_fwiMC4x4B_8u_C1(pSrcRefF, srcStepF, 
mcTypeF, pSrcRefB, srcStepB, mcTypeB, pSrcYData, srcYDataStep, pDst, dstStep, roundControl);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiSumsDiff8x8Blocks4x4_8u16s_C1(Fw8u* pSrc, Fw32s srcStep,Fw8u* pPred, Fw32s predStep, Fw16s* pSums, Fw16s* pDiff)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiSumsDiff8x8Blocks4x4_8u16s_C1(pSrc, srcStep, pPred, predStep, pSums, pDiff);
    case DT_REFR:
        return _refr_fwiSumsDiff8x8Blocks4x4_8u16s_C1(pSrc, srcStep, pPred, predStep, pSums, pDiff);
    default:
        assert(false);
        return _refr_fwiSumsDiff8x8Blocks4x4_8u16s_C1(pSrc, srcStep, pPred, predStep, pSums, pDiff);
    }
}

OREFR             FwStatus STDCALL fwiHuffmanRunLevelTableInitAlloc_32s(const Fw32s* pSrcTable, FwVCHuffmanSpec_32s** ppDstSpec)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiHuffmanRunLevelTableInitAlloc_32s(pSrcTable, ppDstSpec);
    default:
        assert(false);
        return _refr_fwiHuffmanRunLevelTableInitAlloc_32s(pSrcTable, ppDstSpec);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiMC8x8_8u_C1( const Fw8u *pSrcRef, Fw32s srcStep, const Fw16s
*pSrcYData, Fw32s srcYDataStep, Fw8u *pDst, Fw32s dstStep, Fw32s mcType, Fw32s roundControl )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiMC8x8_8u_C1(pSrcRef, srcStep, pSrcYData, srcYDataStep, pDst, dstStep, mcType, roundControl);
    case DT_REFR:
        return _refr_fwiMC8x8_8u_C1(pSrcRef, srcStep, pSrcYData, srcYDataStep, pDst, dstStep, mcType, roundControl);
    default:
        assert(false);
        return _refr_fwiMC8x8_8u_C1(pSrcRef, srcStep, pSrcYData, srcYDataStep, pDst, dstStep, mcType, roundControl);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiVarMeanDiff16x16_8u32s_C1R(const Fw8u* pSrc, Fw32s srcStep, const Fw8u* pRef, Fw32s refStep, Fw32s* pSrcSum, Fw32s* pVar, Fw32s* pMean, Fw32s mcType)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiVarMeanDiff16x16_8u32s_C1R(pSrc, srcStep, pRef, refStep, pSrcSum, pVar, pMean, mcType);
    case DT_REFR:
        return _refr_fwiVarMeanDiff16x16_8u32s_C1R(pSrc, srcStep, pRef, refStep, pSrcSum, pVar, pMean, mcType);
    default:
        assert(false);
        return _refr_fwiVarMeanDiff16x16_8u32s_C1R(pSrc, srcStep, pRef, refStep, pSrcSum, pVar, pMean, mcType);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiMC4x2B_8u_C1( const Fw8u *pSrcRefF, Fw32s srcStepF, Fw32s
mcTypeF, const Fw8u *pSrcRefB, Fw32s srcStepB, Fw32s mcTypeB, const
Fw16s *pSrcYData, Fw32s srcYDataStep, Fw8u *pDst, Fw32s dstStep, Fw32s roundControl )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiMC4x2B_8u_C1(pSrcRefF, srcStepF, 
mcTypeF, pSrcRefB, srcStepB, mcTypeB, pSrcYData, srcYDataStep, pDst, dstStep, roundControl);
    case DT_REFR:
        return _refr_fwiMC4x2B_8u_C1(pSrcRefF, srcStepF, 
mcTypeF, pSrcRefB, srcStepB, mcTypeB, pSrcYData, srcYDataStep, pDst, dstStep, roundControl);
    default:
        assert(false);
        return _refr_fwiMC4x2B_8u_C1(pSrcRefF, srcStepF, 
mcTypeF, pSrcRefB, srcStepB, mcTypeB, pSrcYData, srcYDataStep, pDst, dstStep, roundControl);
    }
}


OREFR OSSE2       FwStatus STDCALL fwiGetDiff16x16_8u16s_C1(const Fw8u* pSrcCur, Fw32s srcCurStep, const Fw8u* pSrcRef, Fw32s srcRefStep, Fw16s* pDstDiff, Fw32s dstDiffStep, Fw16s* pDstPredictor, Fw32s dstPredictorStep, Fw32s mcType, Fw32s roundControl)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiGetDiff16x16_8u16s_C1(pSrcCur, srcCurStep, pSrcRef, srcRefStep, pDstDiff, dstDiffStep, pDstPredictor, dstPredictorStep, mcType, roundControl);
    case DT_REFR:
        return _refr_fwiGetDiff16x16_8u16s_C1(pSrcCur, srcCurStep, pSrcRef, srcRefStep, pDstDiff, dstDiffStep, pDstPredictor, dstPredictorStep, mcType, roundControl);
    default:
        assert(false);
        return _refr_fwiGetDiff16x16_8u16s_C1(pSrcCur, srcCurStep, pSrcRef, srcRefStep, pDstDiff, dstDiffStep, pDstPredictor, dstPredictorStep, mcType, roundControl);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiDecodeCAVLCChromaDcCoeffs_H264_1u16s(	Fw32u **ppBitStream, Fw32s *pBitOffset, Fw16s *pNumCoeff, Fw16s **ppDstCoeffs, const Fw32s *pTblCoeffToken, const Fw32s **ppTblTotalZerosCR, const Fw32s **ppTblRunBefore)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiDecodeCAVLCChromaDcCoeffs_H264_1u16s(ppBitStream, pBitOffset, pNumCoeff, ppDstCoeffs, pTblCoeffToken, ppTblTotalZerosCR, ppTblRunBefore);
    case DT_REFR:
        return _refr_fwiDecodeCAVLCChromaDcCoeffs_H264_1u16s(ppBitStream, pBitOffset, pNumCoeff, ppDstCoeffs, pTblCoeffToken, ppTblTotalZerosCR, ppTblRunBefore);
    default:
        assert(false);
        return _refr_fwiDecodeCAVLCChromaDcCoeffs_H264_1u16s(ppBitStream, pBitOffset, pNumCoeff, ppDstCoeffs, pTblCoeffToken, ppTblTotalZerosCR, ppTblRunBefore);
    }
}



OREFR OSSE2       FwStatus STDCALL fwiReconstructChromaInterMB_H264_16s8u_P2R(
	Fw16s **ppSrcCoeff, Fw8u *pSrcDstUPlane, Fw8u *pSrcDstVPlane, 
	const Fw32u srcDstStep, const Fw32u cbp4x4, const Fw32s ChromaQP)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiReconstructChromaInterMB_H264_16s8u_P2R(ppSrcCoeff, pSrcDstUPlane, pSrcDstVPlane, srcDstStep, cbp4x4, ChromaQP);
    case DT_REFR:
        return _refr_fwiReconstructChromaInterMB_H264_16s8u_P2R(ppSrcCoeff, pSrcDstUPlane, pSrcDstVPlane, srcDstStep, cbp4x4, ChromaQP);
    default:
        assert(false);
        return _refr_fwiReconstructChromaInterMB_H264_16s8u_P2R(ppSrcCoeff, pSrcDstUPlane, pSrcDstVPlane, srcDstStep, cbp4x4, ChromaQP);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiMC8x16B_8u_C1( const Fw8u *pSrcRefF, Fw32s srcStepF, Fw32s
mcTypeF, const Fw8u *pSrcRefB, Fw32s srcStepB, Fw32s mcTypeB, const
Fw16s *pSrcYData, Fw32s srcYDataStep, Fw8u *pDst, Fw32s dstStep, Fw32s roundControl )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiMC8x16B_8u_C1(pSrcRefF, srcStepF, 
mcTypeF, pSrcRefB, srcStepB, mcTypeB, pSrcYData, srcYDataStep, pDst, dstStep, roundControl);
    case DT_REFR:
        return _refr_fwiMC8x16B_8u_C1(pSrcRefF, srcStepF, 
mcTypeF, pSrcRefB, srcStepB, mcTypeB, pSrcYData, srcYDataStep, pDst, dstStep, roundControl);
    default:
        assert(false);
        return _refr_fwiMC8x16B_8u_C1(pSrcRefF, srcStepF, 
mcTypeF, pSrcRefB, srcStepB, mcTypeB, pSrcYData, srcYDataStep, pDst, dstStep, roundControl);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiSqrDiff16x16_8u32s(const Fw8u* pSrc, Fw32s srcStep, const Fw8u* pRef, Fw32s refStep, Fw32s mcType, Fw32s* pSqrDiff)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiSqrDiff16x16_8u32s(pSrc, srcStep, pRef, refStep, mcType, pSqrDiff);
    case DT_REFR:
        return _refr_fwiSqrDiff16x16_8u32s(pSrc, srcStep, pRef, refStep, mcType, pSqrDiff);
    default:
        assert(false);
        return _refr_fwiSqrDiff16x16_8u32s(pSrc, srcStep, pRef, refStep, mcType, pSqrDiff);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiInterpolateChroma_H264_8u_C1R(
	const Fw8u*	pSrc,	Fw32s	srcStep,  Fw8u*	pDst,	Fw32s	dstStep, 
	Fw32s	dx,		Fw32s	dy,  FwiSize	roiSize)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiInterpolateChroma_H264_8u_C1R(	pSrc, 	srcStep, 	pDst, 	dstStep, 	dx, 	dy, 	roiSize);
    case DT_REFR:
        return _refr_fwiInterpolateChroma_H264_8u_C1R(	pSrc, 	srcStep, 	pDst, 	dstStep, 	dx, 	dy, 	roiSize);
    default:
        assert(false);
        return _refr_fwiInterpolateChroma_H264_8u_C1R(	pSrc, 	srcStep, 	pDst, 	dstStep, 	dx, 	dy, 	roiSize);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiMC16x4_8u_C1( const Fw8u *pSrcRef, Fw32s srcStep, const Fw16s
*pSrcYData, Fw32s srcYDataStep, Fw8u *pDst, Fw32s dstStep, Fw32s mcType, Fw32s roundControl )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiMC16x4_8u_C1(pSrcRef, srcStep, pSrcYData, srcYDataStep, pDst, dstStep, mcType, roundControl);
    case DT_REFR:
        return _refr_fwiMC16x4_8u_C1(pSrcRef, srcStep, pSrcYData, srcYDataStep, pDst, dstStep, mcType, roundControl);
    default:
        assert(false);
        return _refr_fwiMC16x4_8u_C1(pSrcRef, srcStep, pSrcYData, srcYDataStep, pDst, dstStep, mcType, roundControl);
    }
}


OREFR OSSE2       FwStatus STDCALL fwiDecodeCAVLCCoeffs_H264_1u16s( Fw32u **ppBitStream, Fw32s *pBitOffset, Fw16s *pNumCoeff, Fw16s **ppDstCoeffs, Fw32u uVLCSelect, Fw16s uMaxNumCoeff, const Fw32s **ppTblCoeffToken,	const Fw32s **ppTblTotalZeros, const Fw32s **ppTblRunBefore, 	const Fw32s  *pScanMatrix)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiDecodeCAVLCCoeffs_H264_1u16s(ppBitStream, pBitOffset, pNumCoeff, ppDstCoeffs, uVLCSelect, uMaxNumCoeff, ppTblCoeffToken, ppTblTotalZeros, ppTblRunBefore, pScanMatrix);
    case DT_REFR:
        return _refr_fwiDecodeCAVLCCoeffs_H264_1u16s(ppBitStream, pBitOffset, pNumCoeff, ppDstCoeffs, uVLCSelect, uMaxNumCoeff, ppTblCoeffToken, ppTblTotalZeros, ppTblRunBefore, pScanMatrix);
    default:
        assert(false);
        return _refr_fwiDecodeCAVLCCoeffs_H264_1u16s(ppBitStream, pBitOffset, pNumCoeff, ppDstCoeffs, uVLCSelect, uMaxNumCoeff, ppTblCoeffToken, ppTblTotalZeros, ppTblRunBefore, pScanMatrix);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiMC16x8BUV_8u_C1( const Fw8u *pSrcRefF, Fw32s srcStepF, Fw32s
mcTypeF, const Fw8u *pSrcRefB, Fw32s srcStepB, Fw32s mcTypeB, const
Fw16s *pSrcYData, Fw32s srcYDataStep, Fw8u *pDst, Fw32s dstStep, Fw32s roundControl )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiMC16x8BUV_8u_C1(pSrcRefF, srcStepF, 
mcTypeF, pSrcRefB, srcStepB, mcTypeB, pSrcYData, srcYDataStep, pDst, dstStep, roundControl);
    case DT_REFR:
        return _refr_fwiMC16x8BUV_8u_C1(pSrcRefF, srcStepF, 
mcTypeF, pSrcRefB, srcStepB, mcTypeB, pSrcYData, srcYDataStep, pDst, dstStep, roundControl);
    default:
        assert(false);
        return _refr_fwiMC16x8BUV_8u_C1(pSrcRefF, srcStepF, 
mcTypeF, pSrcRefB, srcStepB, mcTypeB, pSrcYData, srcYDataStep, pDst, dstStep, roundControl);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiMC16x16B_8u_C1( const Fw8u *pSrcRefF, Fw32s srcStepF, Fw32s
mcTypeF, const Fw8u *pSrcRefB, Fw32s srcStepB, Fw32s mcTypeB, const
Fw16s *pSrcYData, Fw32s srcYDataStep, Fw8u *pDst, Fw32s dstStep, Fw32s roundControl )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiMC16x16B_8u_C1(pSrcRefF, srcStepF, 
mcTypeF, pSrcRefB, srcStepB, mcTypeB, pSrcYData, srcYDataStep, pDst, dstStep, roundControl);
    case DT_REFR:
        return _refr_fwiMC16x16B_8u_C1(pSrcRefF, srcStepF, 
mcTypeF, pSrcRefB, srcStepB, mcTypeB, pSrcYData, srcYDataStep, pDst, dstStep, roundControl);
    default:
        assert(false);
        return _refr_fwiMC16x16B_8u_C1(pSrcRefF, srcStepF, 
mcTypeF, pSrcRefB, srcStepB, mcTypeB, pSrcYData, srcYDataStep, pDst, dstStep, roundControl);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiVariance16x16_8u32s(const Fw8u* pSrc, Fw32s srcStep, Fw32s* pVar)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiVariance16x16_8u32s(pSrc, srcStep, pVar);
    case DT_REFR:
        return _refr_fwiVariance16x16_8u32s(pSrc, srcStep, pVar);
    default:
        assert(false);
        return _refr_fwiVariance16x16_8u32s(pSrc, srcStep, pVar);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiReconstructDCTBlock_MPEG2_32s(Fw32u **ppBitStream, int *pOffset, const FwVCHuffmanSpec_32s *pDCTable, const FwVCHuffmanSpec_32s *pACTable, Fw32s *pScanMatrix, int QP, Fw16s *pQPMatrix, Fw16s *pDstBlock, Fw32s *pDstSize)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiReconstructDCTBlock_MPEG2_32s(ppBitStream, pOffset, pDCTable, pACTable, pScanMatrix, QP, pQPMatrix, pDstBlock, pDstSize);
    case DT_REFR:
        return _refr_fwiReconstructDCTBlock_MPEG2_32s(ppBitStream, pOffset, pDCTable, pACTable, pScanMatrix, QP, pQPMatrix, pDstBlock, pDstSize);
    default:
        assert(false);
        return _refr_fwiReconstructDCTBlock_MPEG2_32s(ppBitStream, pOffset, pDCTable, pACTable, pScanMatrix, QP, pQPMatrix, pDstBlock, pDstSize);
    }
}



OREFR             FwStatus STDCALL fwiFilterDeblockingLuma_VerEdge_H264_8u_C1IR( Fw8u *pSrcDst, Fw32s  srcDstStep, Fw8u *pAlpha, Fw8u *pBeta, Fw8u *pThresholds, Fw8u *pBS)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiFilterDeblockingLuma_VerEdge_H264_8u_C1IR(pSrcDst, srcDstStep, pAlpha, pBeta, pThresholds, pBS);
    default:
        assert(false);
        return _refr_fwiFilterDeblockingLuma_VerEdge_H264_8u_C1IR(pSrcDst, srcDstStep, pAlpha, pBeta, pThresholds, pBS);
    }
}

OREFR             FwStatus STDCALL fwiFilterDeblockingChroma_VerEdge_H264_8u_C1IR( Fw8u* pSrcDst, Fw32s srcDstStep, Fw8u* pAlpha, Fw8u* pBeta, Fw8u* pThresholds, Fw8u* pBS)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiFilterDeblockingChroma_VerEdge_H264_8u_C1IR(pSrcDst, srcDstStep, pAlpha, pBeta, pThresholds, pBS);
    default:
        assert(false);
        return _refr_fwiFilterDeblockingChroma_VerEdge_H264_8u_C1IR(pSrcDst, srcDstStep, pAlpha, pBeta, pThresholds, pBS);
    }
}


OREFR OSSE2       FwStatus STDCALL fwiDCT8x8Inv_AANTransposed_16s_C1R(const Fw16s *pSrc, Fw16s *pDst, Fw32s dstStep, Fw32s count )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiDCT8x8Inv_AANTransposed_16s_C1R(pSrc, pDst, dstStep, count);
    case DT_REFR:
        return _refr_fwiDCT8x8Inv_AANTransposed_16s_C1R(pSrc, pDst, dstStep, count);
    default:
        assert(false);
        return _refr_fwiDCT8x8Inv_AANTransposed_16s_C1R(pSrc, pDst, dstStep, count);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiMC16x8_8u_C1( const Fw8u *pSrcRef, Fw32s srcStep, const Fw16s
*pSrcYData, Fw32s srcYDataStep, Fw8u *pDst, Fw32s dstStep, Fw32s mcType, Fw32s roundControl )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiMC16x8_8u_C1(pSrcRef, srcStep, pSrcYData, srcYDataStep, pDst, dstStep, mcType, roundControl);
    case DT_REFR:
        return _refr_fwiMC16x8_8u_C1(pSrcRef, srcStep, pSrcYData, srcYDataStep, pDst, dstStep, mcType, roundControl);
    default:
        assert(false);
        return _refr_fwiMC16x8_8u_C1(pSrcRef, srcStep, pSrcYData, srcYDataStep, pDst, dstStep, mcType, roundControl);
    }
}

OREFR             FwStatus STDCALL fwiDecodeHuffmanOne_1u32s(Fw32u** ppBitStream, Fw32s* pOffset, Fw32s* pDst, const FwVCHuffmanSpec_32s *pDecodeTable)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiDecodeHuffmanOne_1u32s(ppBitStream, pOffset, pDst, pDecodeTable);
    default:
        assert(false);
        return _refr_fwiDecodeHuffmanOne_1u32s(ppBitStream, pOffset, pDst, pDecodeTable);
    }
}



OREFR OSSE2       FwStatus STDCALL fwiMC16x16_8u_C1( const Fw8u *pSrcRef, Fw32s srcStep, const Fw16s
*pSrcYData, Fw32s srcYDataStep, Fw8u *pDst, Fw32s dstStep, Fw32s mcType, Fw32s roundControl )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiMC16x16_8u_C1(pSrcRef, srcStep, pSrcYData, srcYDataStep, pDst, dstStep, mcType, roundControl);
    case DT_REFR:
        return _refr_fwiMC16x16_8u_C1(pSrcRef, srcStep, pSrcYData, srcYDataStep, pDst, dstStep, mcType, roundControl);
    default:
        assert(false);
        return _refr_fwiMC16x16_8u_C1(pSrcRef, srcStep, pSrcYData, srcYDataStep, pDst, dstStep, mcType, roundControl);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiSqrDiff16x16B_8u32s(const Fw8u* pSrc,  Fw32s srcStep, const Fw8u* pRefF, Fw32s refStepF, Fw32s mcTypeF, const Fw8u* pRefB, Fw32s refStepB, Fw32s mcTypeB, Fw32s* pSqrDiff)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiSqrDiff16x16B_8u32s(pSrc, srcStep, pRefF, refStepF, mcTypeF, pRefB, refStepB, mcTypeB, pSqrDiff);
    case DT_REFR:
        return _refr_fwiSqrDiff16x16B_8u32s(pSrc, srcStep, pRefF, refStepF, mcTypeF, pRefB, refStepB, mcTypeB, pSqrDiff);
    default:
        assert(false);
        return _refr_fwiSqrDiff16x16B_8u32s(pSrc, srcStep, pRefF, refStepF, mcTypeF, pRefB, refStepB, mcTypeB, pSqrDiff);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiMC16x4B_8u_C1( const Fw8u *pSrcRefF, Fw32s srcStepF, Fw32s
mcTypeF, const Fw8u *pSrcRefB, Fw32s srcStepB, Fw32s mcTypeB, const
Fw16s *pSrcYData, Fw32s srcYDataStep, Fw8u *pDst, Fw32s dstStep, Fw32s roundControl )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiMC16x4B_8u_C1(pSrcRefF, srcStepF, 
mcTypeF, pSrcRefB, srcStepB, mcTypeB, pSrcYData, srcYDataStep, pDst, dstStep, roundControl);
    case DT_REFR:
        return _refr_fwiMC16x4B_8u_C1(pSrcRefF, srcStepF, 
mcTypeF, pSrcRefB, srcStepB, mcTypeB, pSrcYData, srcYDataStep, pDst, dstStep, roundControl);
    default:
        assert(false);
        return _refr_fwiMC16x4B_8u_C1(pSrcRefF, srcStepF, 
mcTypeF, pSrcRefB, srcStepB, mcTypeB, pSrcYData, srcYDataStep, pDst, dstStep, roundControl);
    }
}

OREFR             FwStatus STDCALL fwiFilterDeblockingChroma_HorEdge_H264_8u_C1IR( Fw8u* pSrcDst, Fw32s srcDstStep, Fw8u* pAlpha, Fw8u* pBeta, Fw8u* pThresholds, Fw8u* pBS)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiFilterDeblockingChroma_HorEdge_H264_8u_C1IR(pSrcDst, srcDstStep, pAlpha, pBeta, pThresholds, pBS);
    default:
        assert(false);
        return _refr_fwiFilterDeblockingChroma_HorEdge_H264_8u_C1IR(pSrcDst, srcDstStep, pAlpha, pBeta, pThresholds, pBS);
    }
}

OREFR             FwStatus STDCALL fwiDequantTransformResidual_H264_16s_C1I(Fw16s* pSrcDst, 
	Fw32s  step, Fw16s  *pDC, Fw32s  AC, Fw32s  QP)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiDequantTransformResidual_H264_16s_C1I(pSrcDst, step, pDC, AC, QP);
    default:
        assert(false);
        return _refr_fwiDequantTransformResidual_H264_16s_C1I(pSrcDst, step, pDC, AC, QP);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiSAD8x8_8u32s_C1R(const Fw8u* pSrcCur, int srcCurStep, const Fw8u* pSrcRef, Fw32s srcRefStep, Fw32s * pDst, Fw32s mcType)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiSAD8x8_8u32s_C1R(pSrcCur, srcCurStep, pSrcRef, srcRefStep, pDst, mcType);
    case DT_REFR:
        return _refr_fwiSAD8x8_8u32s_C1R(pSrcCur, srcCurStep, pSrcRef, srcRefStep, pDst, mcType);
    default:
        assert(false);
        return _refr_fwiSAD8x8_8u32s_C1R(pSrcCur, srcCurStep, pSrcRef, srcRefStep, pDst, mcType);
    }
}

