#define OPT_REFR
#define OPT_LEVEL REFR
#define OPT_PREFIX _refr_
#undef __FWIMAGE_OPT_H__
#include "fwImage_opt.h"
#undef OPT_REFR
#undef OPT_LEVEL
#undef OPT_PREFIX


#define OPT_SSE2
#define OPT_LEVEL SSE2
#define OPT_PREFIX _sse2_
#undef __FWIMAGE_OPT_H__
#include "fwImage_opt.h"
#undef OPT_SSE2
#undef OPT_LEVEL
#undef OPT_PREFIX


#define OPT_F10H
#define OPT_LEVEL F10H
#define OPT_PREFIX _f10h_
#undef __FWIMAGE_OPT_H__
#include "fwImage_opt.h"
#undef OPT_F10H
#undef OPT_LEVEL
#undef OPT_PREFIX


#define OPT_SSE3
#define OPT_LEVEL SSE3
#define OPT_PREFIX _sse3_
#undef __FWIMAGE_OPT_H__
#include "fwImage_opt.h"
#undef OPT_SSE3
#undef OPT_LEVEL
#undef OPT_PREFIX


using namespace REFR;
OREFR OSSE2 OF10H FwStatus STDCALL fwiAddC_32sc_AC4RSfs( const Fw32sc *pSrc, int srcStep, const Fw32sc value[3], Fw32sc *pDst, int dstStep, FwiSize roiSize, int scaleFactor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiAddC_32sc_AC4RSfs(pSrc, srcStep, value, pDst, dstStep, roiSize, scaleFactor);
    case DT_SSE2:
        return _sse2_fwiAddC_32sc_AC4RSfs(pSrc, srcStep, value, pDst, dstStep, roiSize, scaleFactor);
    case DT_REFR:
        return _refr_fwiAddC_32sc_AC4RSfs(pSrc, srcStep, value, pDst, dstStep, roiSize, scaleFactor);
    default:
        assert(false);
        return _refr_fwiAddC_32sc_AC4RSfs(pSrc, srcStep, value, pDst, dstStep, roiSize, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiRShiftC_16s_C1IR(       Fw32u value,    Fw16s *pSrcDst, int srcDstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiRShiftC_16s_C1IR(value, pSrcDst, srcDstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiRShiftC_16s_C1IR(value, pSrcDst, srcDstStep, roiSize);
    case DT_REFR:
        return _refr_fwiRShiftC_16s_C1IR(value, pSrcDst, srcDstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiRShiftC_16s_C1IR(value, pSrcDst, srcDstStep, roiSize);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiMirror_16u_C4R( const Fw16u *pSrc, int srcStep, Fw16u *pDst, int dstStep, FwiSize roiSize, FwiAxis flip)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiMirror_16u_C4R(pSrc, srcStep, pDst, dstStep, roiSize, flip);
    case DT_REFR:
        return _refr_fwiMirror_16u_C4R(pSrc, srcStep, pDst, dstStep, roiSize, flip);
    default:
        assert(false);
        return _refr_fwiMirror_16u_C4R(pSrc, srcStep, pDst, dstStep, roiSize, flip);
    }
}

OREFR               FwStatus fwiBGRToHLS_8u_P3R( const A8U* const pSrc[3], int srcStep, A8U* const pDst[3], int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiBGRToHLS_8u_P3R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiBGRToHLS_8u_P3R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 FwStatus STDCALL fwiResize_32f_C3R( const Fw32f* pSrc, FwiSize srcSize, int srcStep, FwiRect srcRoi,
							 Fw32f* pDst, int dstStep, FwiSize dstRoiSize,
							 double xFactor, double yFactor, int interpolation )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiResize_32f_C3R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoiSize, xFactor, yFactor, interpolation);
    case DT_REFR:
        return _refr_fwiResize_32f_C3R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoiSize, xFactor, yFactor, interpolation);
    default:
        assert(false);
        return _refr_fwiResize_32f_C3R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoiSize, xFactor, yFactor, interpolation);
    }
}

OREFR               FwStatus fwiYCCToRGB_8u_AC4R( const Fw8u *pSrc, int srcStep, Fw8u *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiYCCToRGB_8u_AC4R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiYCCToRGB_8u_AC4R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR       FwStatus STDCALL fwiMirror_32f_C4IR(Fw32f *pSrcDst, int srcDstStep, FwiSize roiSize, FwiAxis flip)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiMirror_32f_C4IR(pSrcDst, srcDstStep, roiSize, flip);
    default:
        assert(false);
        return _refr_fwiMirror_32f_C4IR(pSrcDst, srcDstStep, roiSize, flip);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiSet_32f_C3MR( const Fw32f  value[3], Fw32f  * pDst, int dstStep, FwiSize roiSize, const Fw8u * pMask, int maskStep )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiSet_32f_C3MR(value, pDst, dstStep, roiSize, pMask, maskStep);
    case DT_SSE2:
        return _sse2_fwiSet_32f_C3MR(value, pDst, dstStep, roiSize, pMask, maskStep);
    case DT_REFR:
        return _refr_fwiSet_32f_C3MR(value, pDst, dstStep, roiSize, pMask, maskStep);
    default:
        assert(false);
        return _refr_fwiSet_32f_C3MR(value, pDst, dstStep, roiSize, pMask, maskStep);
    }
}

OREFR OSSE2 OF10H   FwStatus fwiRGBToYCbCr_8u_C3R( const Fw8u *pSrc, int srcStep, Fw8u *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiRGBToYCbCr_8u_C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiRGBToYCbCr_8u_C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiRGBToYCbCr_8u_C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiRGBToYCbCr_8u_C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiDiv_32f_AC4IR( const Fw32f  *pSrc,  int srcStep,        Fw32f  *pSrcDst, int srcDstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiDiv_32f_AC4IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiDiv_32f_AC4IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    case DT_REFR:
        return _refr_fwiDiv_32f_AC4IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiDiv_32f_AC4IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiAddC_16s_C3IRSfs( const Fw16s value[3], Fw16s *pSrcDst, int srcDstStep, FwiSize roiSize, int scaleFactor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiAddC_16s_C3IRSfs(value, pSrcDst, srcDstStep, roiSize, scaleFactor);
    case DT_SSE2:
        return _sse2_fwiAddC_16s_C3IRSfs(value, pSrcDst, srcDstStep, roiSize, scaleFactor);
    case DT_REFR:
        return _refr_fwiAddC_16s_C3IRSfs(value, pSrcDst, srcDstStep, roiSize, scaleFactor);
    default:
        assert(false);
        return _refr_fwiAddC_16s_C3IRSfs(value, pSrcDst, srcDstStep, roiSize, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiThreshold_8u_C1R( const Fw8u *pSrc, int srcStep, Fw8u *pDst, int dstStep, FwiSize roiSize, Fw8u threshold, FwCmpOp fwCmpOp)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiThreshold_8u_C1R(pSrc, srcStep, pDst, dstStep, roiSize, threshold, fwCmpOp);
    case DT_SSE2:
        return _sse2_fwiThreshold_8u_C1R(pSrc, srcStep, pDst, dstStep, roiSize, threshold, fwCmpOp);
    case DT_REFR:
        return _refr_fwiThreshold_8u_C1R(pSrc, srcStep, pDst, dstStep, roiSize, threshold, fwCmpOp);
    default:
        assert(false);
        return _refr_fwiThreshold_8u_C1R(pSrc, srcStep, pDst, dstStep, roiSize, threshold, fwCmpOp);
    }
}

OREFR OSSE2 FwStatus STDCALL fwiResize_8u_C3R( const Fw8u* pSrc, FwiSize srcSize, int srcStep, FwiRect srcRoi,
							 Fw8u* pDst, int dstStep, FwiSize dstRoiSize,
							 double xFactor, double yFactor, int interpolation )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiResize_8u_C3R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoiSize, xFactor, yFactor, interpolation);
    case DT_REFR:
        return _refr_fwiResize_8u_C3R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoiSize, xFactor, yFactor, interpolation);
    default:
        assert(false);
        return _refr_fwiResize_8u_C3R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoiSize, xFactor, yFactor, interpolation);
    }
}

OREFR OSSE2 OF10H   FwStatus fwiRGBToYUV_8u_P3R( const Fw8u * const pSrc[3], int srcStep, Fw8u *pDst[3], int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiRGBToYUV_8u_P3R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiRGBToYUV_8u_P3R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiRGBToYUV_8u_P3R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiRGBToYUV_8u_P3R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiSubC_32fc_C1IR(       Fw32fc value,    Fw32fc *pSrcDst, int srcDstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiSubC_32fc_C1IR(value, pSrcDst, srcDstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiSubC_32fc_C1IR(value, pSrcDst, srcDstStep, roiSize);
    case DT_REFR:
        return _refr_fwiSubC_32fc_C1IR(value, pSrcDst, srcDstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiSubC_32fc_C1IR(value, pSrcDst, srcDstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiMulC_32fc_C3R( const Fw32fc *pSrc, int srcStep, const Fw32fc value[3], Fw32fc *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiMulC_32fc_C3R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiMulC_32fc_C3R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiMulC_32fc_C3R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiMulC_32fc_C3R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiMirror_16u_C1IR(Fw16u *pSrcDst, int srcDstStep, FwiSize roiSize, FwiAxis flip)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiMirror_16u_C1IR(pSrcDst, srcDstStep, roiSize, flip);
    case DT_REFR:
        return _refr_fwiMirror_16u_C1IR(pSrcDst, srcDstStep, roiSize, flip);
    default:
        assert(false);
        return _refr_fwiMirror_16u_C1IR(pSrcDst, srcDstStep, roiSize, flip);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiThreshold_LTVal_32f_C3R( const Fw32f *pSrc, int srcStep, Fw32f *pDst, int dstStep, FwiSize roiSize, const Fw32f threshold[3], const Fw32f value[3])
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiThreshold_LTVal_32f_C3R(pSrc, srcStep, pDst, dstStep, roiSize, threshold, value);
    case DT_SSE2:
        return _sse2_fwiThreshold_LTVal_32f_C3R(pSrc, srcStep, pDst, dstStep, roiSize, threshold, value);
    case DT_REFR:
        return _refr_fwiThreshold_LTVal_32f_C3R(pSrc, srcStep, pDst, dstStep, roiSize, threshold, value);
    default:
        assert(false);
        return _refr_fwiThreshold_LTVal_32f_C3R(pSrc, srcStep, pDst, dstStep, roiSize, threshold, value);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiFilterPrewittHoriz_16s_C1R( const Fw16s * pSrc, int srcStep, Fw16s * pDst, int dstStep, FwiSize dstRoiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilterPrewittHoriz_16s_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize);
    case DT_REFR:
        return _refr_fwiFilterPrewittHoriz_16s_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize);
    default:
        assert(false);
        return _refr_fwiFilterPrewittHoriz_16s_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiSubC_32f_C3IR( const Fw32f value[3], Fw32f *pSrcDst, int srcDstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiSubC_32f_C3IR(value, pSrcDst, srcDstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiSubC_32f_C3IR(value, pSrcDst, srcDstStep, roiSize);
    case DT_REFR:
        return _refr_fwiSubC_32f_C3IR(value, pSrcDst, srcDstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiSubC_32f_C3IR(value, pSrcDst, srcDstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiConvert_32f16u_C3R( const Fw32f *pSrc, int srcStep, Fw16u *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiConvert_32f16u_C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiConvert_32f16u_C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiConvert_32f16u_C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiConvert_32f16u_C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2         FwStatus fwiYUV422ToRGB_8u_P3AC4R( const A8U* const pSrc[3], int srcStep[3], A8U* pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiYUV422ToRGB_8u_P3AC4R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiYUV422ToRGB_8u_P3AC4R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiYUV422ToRGB_8u_P3AC4R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2         FwStatus fwiMax_16s_AC4R(const Fw16s* pSrc, int srcStep,FwiSize roiSize, Fw16s max[3])
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiMax_16s_AC4R(pSrc, srcStep, roiSize, max);
    case DT_REFR:
        return _refr_fwiMax_16s_AC4R(pSrc, srcStep, roiSize, max);
    default:
        assert(false);
        return _refr_fwiMax_16s_AC4R(pSrc, srcStep, roiSize, max);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiSqrt_32f_C4IR(       Fw32f *pSrcDst, int srcDstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiSqrt_32f_C4IR(pSrcDst, srcDstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiSqrt_32f_C4IR(pSrcDst, srcDstStep, roiSize);
    case DT_REFR:
        return _refr_fwiSqrt_32f_C4IR(pSrcDst, srcDstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiSqrt_32f_C4IR(pSrcDst, srcDstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiOrC_32s_C1R( const Fw32s  *pSrc, int srcStep,       Fw32s value,    Fw32s *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiOrC_32s_C1R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiOrC_32s_C1R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiOrC_32s_C1R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiOrC_32s_C1R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiFilterSobelHoriz_16s_AC4R( const Fw16s * pSrc, int srcStep, Fw16s * pDst, int dstStep, FwiSize dstRoiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilterSobelHoriz_16s_AC4R(pSrc, srcStep, pDst, dstStep, dstRoiSize);
    case DT_REFR:
        return _refr_fwiFilterSobelHoriz_16s_AC4R(pSrc, srcStep, pDst, dstStep, dstRoiSize);
    default:
        assert(false);
        return _refr_fwiFilterSobelHoriz_16s_AC4R(pSrc, srcStep, pDst, dstStep, dstRoiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiLn_8u_C3IRSfs(       Fw8u  *pSrcDst,  int srcDstStep, FwiSize roiSize, int scaleFactor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiLn_8u_C3IRSfs(pSrcDst, srcDstStep, roiSize, scaleFactor);
    case DT_SSE2:
        return _sse2_fwiLn_8u_C3IRSfs(pSrcDst, srcDstStep, roiSize, scaleFactor);
    case DT_REFR:
        return _refr_fwiLn_8u_C3IRSfs(pSrcDst, srcDstStep, roiSize, scaleFactor);
    default:
        assert(false);
        return _refr_fwiLn_8u_C3IRSfs(pSrcDst, srcDstStep, roiSize, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiSqr_32f_C3IR(       Fw32f *pSrcDst, int srcDstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiSqr_32f_C3IR(pSrcDst, srcDstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiSqr_32f_C3IR(pSrcDst, srcDstStep, roiSize);
    case DT_REFR:
        return _refr_fwiSqr_32f_C3IR(pSrcDst, srcDstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiSqr_32f_C3IR(pSrcDst, srcDstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiAndC_16u_C4IR( const Fw16u value[4], Fw16u *pSrcDst, int srcDstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiAndC_16u_C4IR(value, pSrcDst, srcDstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiAndC_16u_C4IR(value, pSrcDst, srcDstStep, roiSize);
    case DT_REFR:
        return _refr_fwiAndC_16u_C4IR(value, pSrcDst, srcDstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiAndC_16u_C4IR(value, pSrcDst, srcDstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiAnd_32s_C1IR( const Fw32s *pSrc,  int srcStep,        Fw32s *pSrcDst, int srcDstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiAnd_32s_C1IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiAnd_32s_C1IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    case DT_REFR:
        return _refr_fwiAnd_32s_C1IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiAnd_32s_C1IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    }
}

OREFR OSSE2 FwStatus STDCALL fwiWarpAffineBack_32f_P4R( const Fw32f* const pSrc[4], FwiSize srcSize, int srcStep,
								FwiRect srcRoi, Fw32f* const pDst[4], int dstStep, FwiRect dstRoi,
								const double coeffs[2][3], int interpolation )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiWarpAffineBack_32f_P4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, coeffs, interpolation);
    case DT_REFR:
        return _refr_fwiWarpAffineBack_32f_P4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, coeffs, interpolation);
    default:
        assert(false);
        return _refr_fwiWarpAffineBack_32f_P4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, coeffs, interpolation);
    }
}

OREFR OSSE2 FwStatus STDCALL fwiFilterSharpen_16s_C4R( const Fw16s * pSrc, int srcStep, Fw16s * pDst, int dstStep, FwiSize dstRoiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilterSharpen_16s_C4R(pSrc, srcStep, pDst, dstStep, dstRoiSize);
    case DT_REFR:
        return _refr_fwiFilterSharpen_16s_C4R(pSrc, srcStep, pDst, dstStep, dstRoiSize);
    default:
        assert(false);
        return _refr_fwiFilterSharpen_16s_C4R(pSrc, srcStep, pDst, dstStep, dstRoiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiCopy_16s_C3CR( const Fw16s *pSrc, int srcStep, Fw16s *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiCopy_16s_C3CR(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiCopy_16s_C3CR(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiCopy_16s_C3CR(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiCopy_16s_C3CR(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiAdd_32f_C4R( const Fw32f  *pSrc1, int src1Step, const Fw32f  *pSrc2,   int src2Step, Fw32f *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiAdd_32f_C4R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiAdd_32f_C4R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiAdd_32f_C4R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiAdd_32f_C4R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    }
}


OREFR OSSE2       FwStatus STDCALL fwiFilterMedianCross_8u_C1R( const Fw8u * pSrc, int srcStep,
                                                Fw8u * pDst, int dstStep, FwiSize dstRoiSize,
                                                FwiMaskSize maskSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilterMedianCross_8u_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize);
    case DT_REFR:
        return _refr_fwiFilterMedianCross_8u_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize);
    default:
        assert(false);
        return _refr_fwiFilterMedianCross_8u_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiAnd_8u_C3IR( const Fw8u	*pSrc,  int srcStep,        Fw8u *pSrcDst, int srcDstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiAnd_8u_C3IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiAnd_8u_C3IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    case DT_REFR:
        return _refr_fwiAnd_8u_C3IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiAnd_8u_C3IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    }
}

OREFR OSSE2         FwStatus fwiColorToGray_16s_C3C1R(const Fw16s* pSrc, int srcStep, Fw16s* pDst, int dstStep, FwiSize roiSize, const Fw32f coeffs[3])
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiColorToGray_16s_C3C1R(pSrc, srcStep, pDst, dstStep, roiSize, coeffs);
    case DT_REFR:
        return _refr_fwiColorToGray_16s_C3C1R(pSrc, srcStep, pDst, dstStep, roiSize, coeffs);
    default:
        assert(false);
        return _refr_fwiColorToGray_16s_C3C1R(pSrc, srcStep, pDst, dstStep, roiSize, coeffs);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiOr_16u_AC4IR( const Fw16u *pSrc,  int srcStep,        Fw16u *pSrcDst, int srcDstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiOr_16u_AC4IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiOr_16u_AC4IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    case DT_REFR:
        return _refr_fwiOr_16u_AC4IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiOr_16u_AC4IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiCopy_32f_C1C4R( const Fw32f *pSrc, int srcStep, Fw32f *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiCopy_32f_C1C4R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiCopy_32f_C1C4R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiCopy_32f_C1C4R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiCopy_32f_C1C4R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiSqr_32f_C4IR(       Fw32f *pSrcDst, int srcDstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiSqr_32f_C4IR(pSrcDst, srcDstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiSqr_32f_C4IR(pSrcDst, srcDstStep, roiSize);
    case DT_REFR:
        return _refr_fwiSqr_32f_C4IR(pSrcDst, srcDstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiSqr_32f_C4IR(pSrcDst, srcDstStep, roiSize);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiFilter_8u_C3R( const Fw8u * pSrc, int srcStep,
                             Fw8u * pDst, int dstStep, FwiSize dstRoiSize,
                             const Fw32s * pKernel, FwiSize kernelSize,
                             FwiPoint anchor, int divisor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilter_8u_C3R(pSrc, srcStep, pDst, dstStep, dstRoiSize, pKernel, kernelSize, anchor, divisor);
    case DT_REFR:
        return _refr_fwiFilter_8u_C3R(pSrc, srcStep, pDst, dstStep, dstRoiSize, pKernel, kernelSize, anchor, divisor);
    default:
        assert(false);
        return _refr_fwiFilter_8u_C3R(pSrc, srcStep, pDst, dstStep, dstRoiSize, pKernel, kernelSize, anchor, divisor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiAnd_32s_C3R( const Fw32s *pSrc1, int src1Step, const Fw32s *pSrc2,   int src2Step, Fw32s *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiAnd_32s_C3R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiAnd_32s_C3R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiAnd_32s_C3R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiAnd_32s_C3R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 FwStatus STDCALL fwiWarpAffineBack_8u_P4R( const Fw8u* const pSrc[4], FwiSize srcSize, int srcStep,
								FwiRect srcRoi, Fw8u* const pDst[4], int dstStep, FwiRect dstRoi,
								const double coeffs[2][3], int interpolation )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiWarpAffineBack_8u_P4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, coeffs, interpolation);
    case DT_REFR:
        return _refr_fwiWarpAffineBack_8u_P4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, coeffs, interpolation);
    default:
        assert(false);
        return _refr_fwiWarpAffineBack_8u_P4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, coeffs, interpolation);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiLShiftC_8u_C3R( const Fw8u   *pSrc, int srcStep, const Fw32u value[3], Fw8u *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiLShiftC_8u_C3R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiLShiftC_8u_C3R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiLShiftC_8u_C3R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiLShiftC_8u_C3R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 FwStatus STDCALL fwiResizeCenter_16u_C3R( const Fw16u* pSrc, FwiSize srcSize, int srcStep, FwiRect srcRoi,
								   Fw16u* pDst, int dstStep, FwiSize dstRoiSize,
								   double xFactor, double yFactor, double xCenter, double yCenter, int interpolation )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiResizeCenter_16u_C3R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoiSize, xFactor, yFactor, xCenter, yCenter, interpolation);
    case DT_REFR:
        return _refr_fwiResizeCenter_16u_C3R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoiSize, xFactor, yFactor, xCenter, yCenter, interpolation);
    default:
        assert(false);
        return _refr_fwiResizeCenter_16u_C3R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoiSize, xFactor, yFactor, xCenter, yCenter, interpolation);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiSqr_32f_C1IR(       Fw32f *pSrcDst, int srcDstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiSqr_32f_C1IR(pSrcDst, srcDstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiSqr_32f_C1IR(pSrcDst, srcDstStep, roiSize);
    case DT_REFR:
        return _refr_fwiSqr_32f_C1IR(pSrcDst, srcDstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiSqr_32f_C1IR(pSrcDst, srcDstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiDiv_32fc_C1R( const Fw32fc *pSrc1, int src1Step, const Fw32fc *pSrc2,   int src2Step, Fw32fc *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiDiv_32fc_C1R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiDiv_32fc_C1R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiDiv_32fc_C1R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiDiv_32fc_C1R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiConvert_8u32s_C1R( const Fw8u *pSrc, int srcStep, Fw32s *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiConvert_8u32s_C1R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiConvert_8u32s_C1R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiConvert_8u32s_C1R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiConvert_8u32s_C1R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiConvert_32f8u_C3R( const Fw32f *pSrc, int srcStep, Fw8u *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiConvert_32f8u_C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiConvert_32f8u_C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiConvert_32f8u_C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiConvert_32f8u_C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiSqr_16s_C3RSfs( const Fw16s *pSrc,    int srcStep, Fw16s *pDst, int dstStep, FwiSize roiSize, int scaleFactor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiSqr_16s_C3RSfs(pSrc, srcStep, pDst, dstStep, roiSize, scaleFactor);
    case DT_SSE2:
        return _sse2_fwiSqr_16s_C3RSfs(pSrc, srcStep, pDst, dstStep, roiSize, scaleFactor);
    case DT_REFR:
        return _refr_fwiSqr_16s_C3RSfs(pSrc, srcStep, pDst, dstStep, roiSize, scaleFactor);
    default:
        assert(false);
        return _refr_fwiSqr_16s_C3RSfs(pSrc, srcStep, pDst, dstStep, roiSize, scaleFactor);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiFilter_16s_AC4R( const Fw16s * pSrc, int srcStep,
                              Fw16s * pDst, int dstStep, FwiSize dstRoiSize,
                              const Fw32s * pKernel, FwiSize kernelSize,
                              FwiPoint anchor, int divisor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilter_16s_AC4R(pSrc, srcStep, pDst, dstStep, dstRoiSize, pKernel, kernelSize, anchor, divisor);
    case DT_REFR:
        return _refr_fwiFilter_16s_AC4R(pSrc, srcStep, pDst, dstStep, dstRoiSize, pKernel, kernelSize, anchor, divisor);
    default:
        assert(false);
        return _refr_fwiFilter_16s_AC4R(pSrc, srcStep, pDst, dstStep, dstRoiSize, pKernel, kernelSize, anchor, divisor);
    }
}


OREFR OSSE2       FwStatus STDCALL fwiFilterColumn_8u_C1R( const Fw8u * pSrc, int srcStep,
                             Fw8u * pDst, int dstStep, FwiSize dstRoiSize,
                             const Fw32s * pKernel, int kernelSize,
                             int yAnchor, int divisor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilterColumn_8u_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize, pKernel, kernelSize, yAnchor, divisor);
    case DT_REFR:
        return _refr_fwiFilterColumn_8u_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize, pKernel, kernelSize, yAnchor, divisor);
    default:
        assert(false);
        return _refr_fwiFilterColumn_8u_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize, pKernel, kernelSize, yAnchor, divisor);
    }
}

OREFR OSSE2         FwStatus fwiRGBToGray_8u_AC4C1R(const Fw8u* pSrc, int srcStep,Fw8u* pDst, int dstStep, FwiSize roiSize)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiRGBToGray_8u_AC4C1R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiRGBToGray_8u_AC4C1R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiRGBToGray_8u_AC4C1R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiFilterMax_16s_C1R( const Fw16s * pSrc, int srcStep,
                               Fw16s * pDst, int dstStep, FwiSize dstRoiSize,
                               FwiSize maskSize, FwiPoint anchor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilterMax_16s_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize, anchor);
    case DT_REFR:
        return _refr_fwiFilterMax_16s_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize, anchor);
    default:
        assert(false);
        return _refr_fwiFilterMax_16s_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize, anchor);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiFilterGauss_8u_AC4R( const Fw8u * pSrc, int srcStep, Fw8u * pDst, int dstStep, FwiSize dstRoiSize, FwiMaskSize maskSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilterGauss_8u_AC4R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize);
    case DT_REFR:
        return _refr_fwiFilterGauss_8u_AC4R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize);
    default:
        assert(false);
        return _refr_fwiFilterGauss_8u_AC4R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiThreshold_GT_8u_C3IR( Fw8u *pSrcDst, int srcDstStep, FwiSize roiSize, const Fw8u threshold[3])
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiThreshold_GT_8u_C3IR(pSrcDst, srcDstStep, roiSize, threshold);
    case DT_SSE2:
        return _sse2_fwiThreshold_GT_8u_C3IR(pSrcDst, srcDstStep, roiSize, threshold);
    case DT_REFR:
        return _refr_fwiThreshold_GT_8u_C3IR(pSrcDst, srcDstStep, roiSize, threshold);
    default:
        assert(false);
        return _refr_fwiThreshold_GT_8u_C3IR(pSrcDst, srcDstStep, roiSize, threshold);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiFilterColumn_8u_C4R( const Fw8u * pSrc, int srcStep,
                             Fw8u * pDst, int dstStep, FwiSize dstRoiSize,
                             const Fw32s * pKernel, int kernelSize,
                             int yAnchor, int divisor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilterColumn_8u_C4R(pSrc, srcStep, pDst, dstStep, dstRoiSize, pKernel, kernelSize, yAnchor, divisor);
    case DT_REFR:
        return _refr_fwiFilterColumn_8u_C4R(pSrc, srcStep, pDst, dstStep, dstRoiSize, pKernel, kernelSize, yAnchor, divisor);
    default:
        assert(false);
        return _refr_fwiFilterColumn_8u_C4R(pSrc, srcStep, pDst, dstStep, dstRoiSize, pKernel, kernelSize, yAnchor, divisor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiThreshold_LT_16s_C1R( const Fw16s *pSrc, int srcStep, Fw16s *pDst, int dstStep, FwiSize roiSize, Fw16s threshold)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiThreshold_LT_16s_C1R(pSrc, srcStep, pDst, dstStep, roiSize, threshold);
    case DT_SSE2:
        return _sse2_fwiThreshold_LT_16s_C1R(pSrc, srcStep, pDst, dstStep, roiSize, threshold);
    case DT_REFR:
        return _refr_fwiThreshold_LT_16s_C1R(pSrc, srcStep, pDst, dstStep, roiSize, threshold);
    default:
        assert(false);
        return _refr_fwiThreshold_LT_16s_C1R(pSrc, srcStep, pDst, dstStep, roiSize, threshold);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiXorC_16u_C4IR( const Fw16u value[4], Fw16u *pSrcDst, int srcDstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiXorC_16u_C4IR(value, pSrcDst, srcDstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiXorC_16u_C4IR(value, pSrcDst, srcDstStep, roiSize);
    case DT_REFR:
        return _refr_fwiXorC_16u_C4IR(value, pSrcDst, srcDstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiXorC_16u_C4IR(value, pSrcDst, srcDstStep, roiSize);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiFilterRobertsUp_16s_C3R( const Fw16s * pSrc, int srcStep, Fw16s * pDst, int dstStep, FwiSize dstRoiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilterRobertsUp_16s_C3R(pSrc, srcStep, pDst, dstStep, dstRoiSize);
    case DT_REFR:
        return _refr_fwiFilterRobertsUp_16s_C3R(pSrc, srcStep, pDst, dstStep, dstRoiSize);
    default:
        assert(false);
        return _refr_fwiFilterRobertsUp_16s_C3R(pSrc, srcStep, pDst, dstStep, dstRoiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiThreshold_LTVal_32f_C1IR( Fw32f *pSrcDst, int srcDstStep, FwiSize roiSize, Fw32f threshold, Fw32f value)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiThreshold_LTVal_32f_C1IR(pSrcDst, srcDstStep, roiSize, threshold, value);
    case DT_SSE2:
        return _sse2_fwiThreshold_LTVal_32f_C1IR(pSrcDst, srcDstStep, roiSize, threshold, value);
    case DT_REFR:
        return _refr_fwiThreshold_LTVal_32f_C1IR(pSrcDst, srcDstStep, roiSize, threshold, value);
    default:
        assert(false);
        return _refr_fwiThreshold_LTVal_32f_C1IR(pSrcDst, srcDstStep, roiSize, threshold, value);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiLShiftC_8u_C1R( const Fw8u   *pSrc, int srcStep,       Fw32u value,    Fw8u *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiLShiftC_8u_C1R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiLShiftC_8u_C1R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiLShiftC_8u_C1R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiLShiftC_8u_C1R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiMulCScale_8u_AC4R( const Fw8u *pSrc, int srcStep, const Fw8u value[4], Fw8u *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiMulCScale_8u_AC4R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiMulCScale_8u_AC4R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiMulCScale_8u_AC4R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiMulCScale_8u_AC4R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiFilterMax_32f_AC4R( const Fw32f * pSrc, int srcStep,
                               Fw32f * pDst, int dstStep, FwiSize dstRoiSize,
                               FwiSize maskSize, FwiPoint anchor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilterMax_32f_AC4R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize, anchor);
    case DT_REFR:
        return _refr_fwiFilterMax_32f_AC4R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize, anchor);
    default:
        assert(false);
        return _refr_fwiFilterMax_32f_AC4R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize, anchor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiMulCScale_8u_AC4IR( const Fw8u value[3], Fw8u *pSrcDst, int srcDstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiMulCScale_8u_AC4IR(value, pSrcDst, srcDstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiMulCScale_8u_AC4IR(value, pSrcDst, srcDstStep, roiSize);
    case DT_REFR:
        return _refr_fwiMulCScale_8u_AC4IR(value, pSrcDst, srcDstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiMulCScale_8u_AC4IR(value, pSrcDst, srcDstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiAdd_16s_C4IRSfs( const Fw16s  *pSrc,  int srcStep,        Fw16s  *pSrcDst, int srcDstStep, FwiSize roiSize, int scaleFactor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiAdd_16s_C4IRSfs(pSrc, srcStep, pSrcDst, srcDstStep, roiSize, scaleFactor);
    case DT_SSE2:
        return _sse2_fwiAdd_16s_C4IRSfs(pSrc, srcStep, pSrcDst, srcDstStep, roiSize, scaleFactor);
    case DT_REFR:
        return _refr_fwiAdd_16s_C4IRSfs(pSrc, srcStep, pSrcDst, srcDstStep, roiSize, scaleFactor);
    default:
        assert(false);
        return _refr_fwiAdd_16s_C4IRSfs(pSrc, srcStep, pSrcDst, srcDstStep, roiSize, scaleFactor);
    }
}

OREFR OSSE2 OF10H   FwStatus fwiYUVToRGB_8u_P3C3R( const Fw8u * const pSrc[3], int srcStep, Fw8u *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiYUVToRGB_8u_P3C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiYUVToRGB_8u_P3C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiYUVToRGB_8u_P3C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiYUVToRGB_8u_P3C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiSet_32f_C4CR(		Fw32f  value,    Fw32f  * pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiSet_32f_C4CR(value, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiSet_32f_C4CR(value, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiSet_32f_C4CR(value, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiSet_32f_C4CR(value, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiSqrt_16s_C3IRSfs(       Fw16s *pSrcDst, int srcDstStep, FwiSize roiSize, int scaleFactor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiSqrt_16s_C3IRSfs(pSrcDst, srcDstStep, roiSize, scaleFactor);
    case DT_SSE2:
        return _sse2_fwiSqrt_16s_C3IRSfs(pSrcDst, srcDstStep, roiSize, scaleFactor);
    case DT_REFR:
        return _refr_fwiSqrt_16s_C3IRSfs(pSrcDst, srcDstStep, roiSize, scaleFactor);
    default:
        assert(false);
        return _refr_fwiSqrt_16s_C3IRSfs(pSrcDst, srcDstStep, roiSize, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiAnd_16u_C3IR( const Fw16u *pSrc,  int srcStep,        Fw16u *pSrcDst, int srcDstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiAnd_16u_C3IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiAnd_16u_C3IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    case DT_REFR:
        return _refr_fwiAnd_16u_C3IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiAnd_16u_C3IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiSet_32f_AC4MR( const Fw32f  value[3], Fw32f  * pDst, int dstStep, FwiSize roiSize, const Fw8u * pMask, int maskStep )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiSet_32f_AC4MR(value, pDst, dstStep, roiSize, pMask, maskStep);
    case DT_SSE2:
        return _sse2_fwiSet_32f_AC4MR(value, pDst, dstStep, roiSize, pMask, maskStep);
    case DT_REFR:
        return _refr_fwiSet_32f_AC4MR(value, pDst, dstStep, roiSize, pMask, maskStep);
    default:
        assert(false);
        return _refr_fwiSet_32f_AC4MR(value, pDst, dstStep, roiSize, pMask, maskStep);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiFilterGauss_16s_C3R( const Fw16s * pSrc, int srcStep, Fw16s * pDst, int dstStep, FwiSize dstRoiSize, FwiMaskSize maskSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilterGauss_16s_C3R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize);
    case DT_REFR:
        return _refr_fwiFilterGauss_16s_C3R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize);
    default:
        assert(false);
        return _refr_fwiFilterGauss_16s_C3R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiFilterSobelVertSecond_8s16s_C1R( const Fw8s * pSrc, int srcStep, Fw16s * pDst, int dstStep, FwiSize dstRoiSize, FwiMaskSize mask )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilterSobelVertSecond_8s16s_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize, mask);
    case DT_REFR:
        return _refr_fwiFilterSobelVertSecond_8s16s_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize, mask);
    default:
        assert(false);
        return _refr_fwiFilterSobelVertSecond_8s16s_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize, mask);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiXorC_16u_C1R( const Fw16u  *pSrc, int srcStep,       Fw16u value,    Fw16u *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiXorC_16u_C1R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiXorC_16u_C1R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiXorC_16u_C1R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiXorC_16u_C1R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 FwStatus STDCALL fwiWarpPerspectiveBack_32f_P3R( const Fw32f* const pSrc[3], FwiSize srcSize, int srcStep,
								FwiRect srcRoi, Fw32f* const pDst[3], int dstStep, FwiRect dstRoi,
								const double coeffs[3][3], int interpolation )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiWarpPerspectiveBack_32f_P3R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, coeffs, interpolation);
    case DT_REFR:
        return _refr_fwiWarpPerspectiveBack_32f_P3R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, coeffs, interpolation);
    default:
        assert(false);
        return _refr_fwiWarpPerspectiveBack_32f_P3R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, coeffs, interpolation);
    }
}

OREFR OSSE2         FwStatus fwiMax_32f_C4R(const Fw32f* pSrc, int srcStep,FwiSize roiSize, Fw32f max[4])
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiMax_32f_C4R(pSrc, srcStep, roiSize, max);
    case DT_REFR:
        return _refr_fwiMax_32f_C4R(pSrc, srcStep, roiSize, max);
    default:
        assert(false);
        return _refr_fwiMax_32f_C4R(pSrc, srcStep, roiSize, max);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiThreshold_LT_16s_C3IR( Fw16s *pSrcDst, int srcDstStep, FwiSize roiSize, const Fw16s threshold[3])
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiThreshold_LT_16s_C3IR(pSrcDst, srcDstStep, roiSize, threshold);
    case DT_SSE2:
        return _sse2_fwiThreshold_LT_16s_C3IR(pSrcDst, srcDstStep, roiSize, threshold);
    case DT_REFR:
        return _refr_fwiThreshold_LT_16s_C3IR(pSrcDst, srcDstStep, roiSize, threshold);
    default:
        assert(false);
        return _refr_fwiThreshold_LT_16s_C3IR(pSrcDst, srcDstStep, roiSize, threshold);
    }
}

OREFR OSSE2 FwStatus STDCALL fwiDCT8x8Inv_16s_C1I(Fw16s* pSrcDst)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiDCT8x8Inv_16s_C1I(pSrcDst);
    case DT_REFR:
        return _refr_fwiDCT8x8Inv_16s_C1I(pSrcDst);
    default:
        assert(false);
        return _refr_fwiDCT8x8Inv_16s_C1I(pSrcDst);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiCopy_8u_C3R( const Fw8u *pSrc, int srcStep, Fw8u *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiCopy_8u_C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiCopy_8u_C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiCopy_8u_C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiCopy_8u_C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR               FwStatus fwiLUVToRGB_16s_AC4R( const Fw16s* pSrc, int srcStep, Fw16s* pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiLUVToRGB_16s_AC4R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiLUVToRGB_16s_AC4R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiCompareC_8u_AC4R( const Fw8u *pSrc, int srcStep, const Fw8u value[3], Fw8u *pDst, int dstStep, FwiSize roiSize, FwCmpOp fwCmpOp )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiCompareC_8u_AC4R(pSrc, srcStep, value, pDst, dstStep, roiSize, fwCmpOp);
    case DT_SSE2:
        return _sse2_fwiCompareC_8u_AC4R(pSrc, srcStep, value, pDst, dstStep, roiSize, fwCmpOp);
    case DT_REFR:
        return _refr_fwiCompareC_8u_AC4R(pSrc, srcStep, value, pDst, dstStep, roiSize, fwCmpOp);
    default:
        assert(false);
        return _refr_fwiCompareC_8u_AC4R(pSrc, srcStep, value, pDst, dstStep, roiSize, fwCmpOp);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiRShiftC_16s_C3R( const Fw16s  *pSrc, int srcStep, const Fw32u value[3], Fw16s *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiRShiftC_16s_C3R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiRShiftC_16s_C3R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiRShiftC_16s_C3R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiRShiftC_16s_C3R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiFilterBox_32f_C1R( const Fw32f * pSrc, int srcStep,
                               Fw32f * pDst, int dstStep, FwiSize dstRoiSize,
                               FwiSize maskSize, FwiPoint anchor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilterBox_32f_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize, anchor);
    case DT_REFR:
        return _refr_fwiFilterBox_32f_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize, anchor);
    default:
        assert(false);
        return _refr_fwiFilterBox_32f_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize, anchor);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiFilterMedian_8u_AC4R( const Fw8u * pSrc, int srcStep,
                                           Fw8u * pDst, int dstStep, FwiSize dstRoiSize,
                                           FwiSize maskSize, FwiPoint anchor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilterMedian_8u_AC4R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize, anchor);
    case DT_REFR:
        return _refr_fwiFilterMedian_8u_AC4R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize, anchor);
    default:
        assert(false);
        return _refr_fwiFilterMedian_8u_AC4R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize, anchor);
    }
}

OREFR             FwStatus STDCALL fwiScale_8u16s_C4R( const Fw8u * pSrc, int srcStep, Fw16s * pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiScale_8u16s_C4R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiScale_8u16s_C4R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR               FwStatus fwiYCbCrToRGB444_8u16u_C3R( const Fw8u* pSrc, int srcStep, A16U* pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiYCbCrToRGB444_8u16u_C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiYCbCrToRGB444_8u16u_C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiFilterBox_16s_C1IR( Fw16s * pSrcDst, int srcDstStep,
                               FwiSize dstRoiSize, FwiSize maskSize, FwiPoint anchor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilterBox_16s_C1IR(pSrcDst, srcDstStep, dstRoiSize, maskSize, anchor);
    case DT_REFR:
        return _refr_fwiFilterBox_16s_C1IR(pSrcDst, srcDstStep, dstRoiSize, maskSize, anchor);
    default:
        assert(false);
        return _refr_fwiFilterBox_16s_C1IR(pSrcDst, srcDstStep, dstRoiSize, maskSize, anchor);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiFilterRow_32f_C1R( const Fw32f * pSrc, int srcStep,
                              Fw32f * pDst, int dstStep, FwiSize dstRoiSize,
                              const Fw32f * pKernel, int kernelSize,
                              int xAnchor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilterRow_32f_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize, pKernel, kernelSize, xAnchor);
    case DT_REFR:
        return _refr_fwiFilterRow_32f_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize, pKernel, kernelSize, xAnchor);
    default:
        assert(false);
        return _refr_fwiFilterRow_32f_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize, pKernel, kernelSize, xAnchor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiSqrt_32f_C1R( const Fw32f *pSrc, int srcStep, Fw32f *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiSqrt_32f_C1R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiSqrt_32f_C1R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiSqrt_32f_C1R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiSqrt_32f_C1R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiRotate_8u_AC4R( const Fw8u* pSrc, FwiSize srcSize, int srcStep, FwiRect srcRoi, Fw8u* pDst, int dstStep, FwiRect dstRoi, double angle, double xShift, double yShift, int interpolation )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiRotate_8u_AC4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, angle, xShift, yShift, interpolation);
    case DT_REFR:
        return _refr_fwiRotate_8u_AC4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, angle, xShift, yShift, interpolation);
    default:
        assert(false);
        return _refr_fwiRotate_8u_AC4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, angle, xShift, yShift, interpolation);
    }
}

OREFR               FwStatus fwiHLSToBGR_8u_AP4C4R(const A8U* const pSrc[4], int srcStep, A8U* pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiHLSToBGR_8u_AP4C4R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiHLSToBGR_8u_AP4C4R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}


OREFR OSSE2       FwStatus STDCALL fwiFilterRobertsUp_8u_C1R( const Fw8u * pSrc, int srcStep, Fw8u * pDst, int dstStep, FwiSize dstRoiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilterRobertsUp_8u_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize);
    case DT_REFR:
        return _refr_fwiFilterRobertsUp_8u_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize);
    default:
        assert(false);
        return _refr_fwiFilterRobertsUp_8u_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize);
    }
}

OREFR             FwStatus STDCALL fwiScale_32f8u_C3R( const Fw32f * pSrc, int srcStep, Fw8u * pDst, int dstStep, FwiSize roiSize, Fw32f vMin, Fw32f vMax )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiScale_32f8u_C3R(pSrc, srcStep, pDst, dstStep, roiSize, vMin, vMax);
    default:
        assert(false);
        return _refr_fwiScale_32f8u_C3R(pSrc, srcStep, pDst, dstStep, roiSize, vMin, vMax);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiAbs_16s_AC4R( const Fw16s *pSrc, int srcStep, Fw16s *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiAbs_16s_AC4R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiAbs_16s_AC4R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiAbs_16s_AC4R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiAbs_16s_AC4R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}


OREFR       FwStatus STDCALL fwiShear_8u_C1R(const Fw8u* pSrc, FwiSize srcSize, int srcStep, FwiRect srcRoi, Fw8u* pDst, int dstStep, FwiRect dstRoi, double xShear, double yShear, double xShift, double yShift, int interpolation )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiShear_8u_C1R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, xShear, yShear, xShift, yShift, interpolation);
    default:
        assert(false);
        return _refr_fwiShear_8u_C1R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, xShear, yShear, xShift, yShift, interpolation);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiSubC_32fc_C3IR( const Fw32fc value[3], Fw32fc *pSrcDst, int srcDstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiSubC_32fc_C3IR(value, pSrcDst, srcDstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiSubC_32fc_C3IR(value, pSrcDst, srcDstStep, roiSize);
    case DT_REFR:
        return _refr_fwiSubC_32fc_C3IR(value, pSrcDst, srcDstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiSubC_32fc_C3IR(value, pSrcDst, srcDstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiAdd_16sc_C3RSfs( const Fw16sc *pSrc1, int src1Step, const Fw16sc *pSrc2,   int src2Step, Fw16sc *pDst, int dstStep, FwiSize roiSize, int scaleFactor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiAdd_16sc_C3RSfs(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, scaleFactor);
    case DT_SSE2:
        return _sse2_fwiAdd_16sc_C3RSfs(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, scaleFactor);
    case DT_REFR:
        return _refr_fwiAdd_16sc_C3RSfs(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, scaleFactor);
    default:
        assert(false);
        return _refr_fwiAdd_16sc_C3RSfs(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiSubC_16sc_AC4IRSfs( const Fw16sc value[3], Fw16sc *pSrcDst, int srcDstStep, FwiSize roiSize, int scaleFactor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiSubC_16sc_AC4IRSfs(value, pSrcDst, srcDstStep, roiSize, scaleFactor);
    case DT_SSE2:
        return _sse2_fwiSubC_16sc_AC4IRSfs(value, pSrcDst, srcDstStep, roiSize, scaleFactor);
    case DT_REFR:
        return _refr_fwiSubC_16sc_AC4IRSfs(value, pSrcDst, srcDstStep, roiSize, scaleFactor);
    default:
        assert(false);
        return _refr_fwiSubC_16sc_AC4IRSfs(value, pSrcDst, srcDstStep, roiSize, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiAndC_32s_C3R( const Fw32s  *pSrc, int srcStep, const Fw32s value[3], Fw32s *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiAndC_32s_C3R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiAndC_32s_C3R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiAndC_32s_C3R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiAndC_32s_C3R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    }
}

OREFR               FwStatus fwiXYZToRGB_32f_AC4R( const Fw32f* pSrc, int srcStep, Fw32f* pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiXYZToRGB_32f_AC4R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiXYZToRGB_32f_AC4R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR               FwStatus fwiHSVToRGB_16u_C3R( const Fw16u* pSrc, int srcStep, Fw16u* pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiHSVToRGB_16u_C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiHSVToRGB_16u_C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiFilterLowpass_32f_AC4R( const Fw32f * pSrc, int srcStep, Fw32f * pDst, int dstStep, FwiSize dstRoiSize, FwiMaskSize maskSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilterLowpass_32f_AC4R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize);
    case DT_REFR:
        return _refr_fwiFilterLowpass_32f_AC4R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize);
    default:
        assert(false);
        return _refr_fwiFilterLowpass_32f_AC4R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiFilterHipass_32f_C4R( const Fw32f * pSrc, int srcStep, Fw32f * pDst, int dstStep, FwiSize dstRoiSize, FwiMaskSize maskSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilterHipass_32f_C4R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize);
    case DT_REFR:
        return _refr_fwiFilterHipass_32f_C4R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize);
    default:
        assert(false);
        return _refr_fwiFilterHipass_32f_C4R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiSqrt_32f_C3R( const Fw32f *pSrc, int srcStep, Fw32f *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiSqrt_32f_C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiSqrt_32f_C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiSqrt_32f_C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiSqrt_32f_C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiMul_16s_C1IRSfs( const Fw16s  *pSrc,  int srcStep,        Fw16s  *pSrcDst, int srcDstStep, FwiSize roiSize, int scaleFactor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiMul_16s_C1IRSfs(pSrc, srcStep, pSrcDst, srcDstStep, roiSize, scaleFactor);
    case DT_SSE2:
        return _sse2_fwiMul_16s_C1IRSfs(pSrc, srcStep, pSrcDst, srcDstStep, roiSize, scaleFactor);
    case DT_REFR:
        return _refr_fwiMul_16s_C1IRSfs(pSrc, srcStep, pSrcDst, srcDstStep, roiSize, scaleFactor);
    default:
        assert(false);
        return _refr_fwiMul_16s_C1IRSfs(pSrc, srcStep, pSrcDst, srcDstStep, roiSize, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiSubC_32sc_C3IRSfs( const Fw32sc value[3], Fw32sc *pSrcDst, int srcDstStep, FwiSize roiSize, int scaleFactor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiSubC_32sc_C3IRSfs(value, pSrcDst, srcDstStep, roiSize, scaleFactor);
    case DT_SSE2:
        return _sse2_fwiSubC_32sc_C3IRSfs(value, pSrcDst, srcDstStep, roiSize, scaleFactor);
    case DT_REFR:
        return _refr_fwiSubC_32sc_C3IRSfs(value, pSrcDst, srcDstStep, roiSize, scaleFactor);
    default:
        assert(false);
        return _refr_fwiSubC_32sc_C3IRSfs(value, pSrcDst, srcDstStep, roiSize, scaleFactor);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiFilterBox_16s_C3IR( Fw16s * pSrcDst, int srcDstStep,
                               FwiSize dstRoiSize, FwiSize maskSize, FwiPoint anchor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilterBox_16s_C3IR(pSrcDst, srcDstStep, dstRoiSize, maskSize, anchor);
    case DT_REFR:
        return _refr_fwiFilterBox_16s_C3IR(pSrcDst, srcDstStep, dstRoiSize, maskSize, anchor);
    default:
        assert(false);
        return _refr_fwiFilterBox_16s_C3IR(pSrcDst, srcDstStep, dstRoiSize, maskSize, anchor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiSqrt_16u_AC4RSfs( const Fw16u *pSrc,    int srcStep, Fw16u *pDst, int dstStep, FwiSize roiSize, int scaleFactor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiSqrt_16u_AC4RSfs(pSrc, srcStep, pDst, dstStep, roiSize, scaleFactor);
    case DT_SSE2:
        return _sse2_fwiSqrt_16u_AC4RSfs(pSrc, srcStep, pDst, dstStep, roiSize, scaleFactor);
    case DT_REFR:
        return _refr_fwiSqrt_16u_AC4RSfs(pSrc, srcStep, pDst, dstStep, roiSize, scaleFactor);
    default:
        assert(false);
        return _refr_fwiSqrt_16u_AC4RSfs(pSrc, srcStep, pDst, dstStep, roiSize, scaleFactor);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiFilterMedianVert_8u_AC4R( const Fw8u * pSrc, int srcStep,
                                               Fw8u * pDst, int dstStep, FwiSize dstRoiSize,
                                               FwiMaskSize maskSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilterMedianVert_8u_AC4R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize);
    case DT_REFR:
        return _refr_fwiFilterMedianVert_8u_AC4R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize);
    default:
        assert(false);
        return _refr_fwiFilterMedianVert_8u_AC4R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize);
    }
}

OREFR OSSE2 FwStatus STDCALL fwiResizeCenter_16u_P4R( const Fw16u* const pSrc[4], FwiSize srcSize, int srcStep, FwiRect srcRoi,
								   Fw16u* const pDst[4], int dstStep, FwiSize dstRoiSize,
								   double xFactor, double yFactor, double xCenter, double yCenter, int interpolation )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiResizeCenter_16u_P4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoiSize, xFactor, yFactor, xCenter, yCenter, interpolation);
    case DT_REFR:
        return _refr_fwiResizeCenter_16u_P4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoiSize, xFactor, yFactor, xCenter, yCenter, interpolation);
    default:
        assert(false);
        return _refr_fwiResizeCenter_16u_P4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoiSize, xFactor, yFactor, xCenter, yCenter, interpolation);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiMul_32sc_C1RSfs( const Fw32sc *pSrc1, int src1Step, const Fw32sc *pSrc2,   int src2Step, Fw32sc *pDst, int dstStep, FwiSize roiSize, int scaleFactor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiMul_32sc_C1RSfs(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, scaleFactor);
    case DT_SSE2:
        return _sse2_fwiMul_32sc_C1RSfs(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, scaleFactor);
    case DT_REFR:
        return _refr_fwiMul_32sc_C1RSfs(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, scaleFactor);
    default:
        assert(false);
        return _refr_fwiMul_32sc_C1RSfs(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, scaleFactor);
    }
}

OREFR OSSE2 FwStatus STDCALL fwiResizeCenter_32f_C4R( const Fw32f* pSrc, FwiSize srcSize, int srcStep, FwiRect srcRoi,
								   Fw32f* pDst, int dstStep, FwiSize dstRoiSize,
								   double xFactor, double yFactor, double xCenter, double yCenter, int interpolation )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiResizeCenter_32f_C4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoiSize, xFactor, yFactor, xCenter, yCenter, interpolation);
    case DT_REFR:
        return _refr_fwiResizeCenter_32f_C4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoiSize, xFactor, yFactor, xCenter, yCenter, interpolation);
    default:
        assert(false);
        return _refr_fwiResizeCenter_32f_C4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoiSize, xFactor, yFactor, xCenter, yCenter, interpolation);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiFilterSobelVert_8s16s_C1R( const Fw8s * pSrc, int srcStep, Fw16s * pDst, int dstStep, FwiSize dstRoiSize, FwiMaskSize mask )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilterSobelVert_8s16s_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize, mask);
    case DT_REFR:
        return _refr_fwiFilterSobelVert_8s16s_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize, mask);
    default:
        assert(false);
        return _refr_fwiFilterSobelVert_8s16s_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize, mask);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiSubC_32sc_C3RSfs( const Fw32sc *pSrc, int srcStep, const Fw32sc value[3], Fw32sc *pDst, int dstStep, FwiSize roiSize, int scaleFactor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiSubC_32sc_C3RSfs(pSrc, srcStep, value, pDst, dstStep, roiSize, scaleFactor);
    case DT_SSE2:
        return _sse2_fwiSubC_32sc_C3RSfs(pSrc, srcStep, value, pDst, dstStep, roiSize, scaleFactor);
    case DT_REFR:
        return _refr_fwiSubC_32sc_C3RSfs(pSrc, srcStep, value, pDst, dstStep, roiSize, scaleFactor);
    default:
        assert(false);
        return _refr_fwiSubC_32sc_C3RSfs(pSrc, srcStep, value, pDst, dstStep, roiSize, scaleFactor);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiFilterMedianCross_16s_C1R( const Fw16s * pSrc, int srcStep,
                                                Fw16s * pDst, int dstStep, FwiSize dstRoiSize,
                                                FwiMaskSize maskSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilterMedianCross_16s_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize);
    case DT_REFR:
        return _refr_fwiFilterMedianCross_16s_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize);
    default:
        assert(false);
        return _refr_fwiFilterMedianCross_16s_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiAddC_8u_C3RSfs( const Fw8u   *pSrc, int srcStep, const Fw8u value[3], Fw8u *pDst, int dstStep, FwiSize roiSize, int scaleFactor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiAddC_8u_C3RSfs(pSrc, srcStep, value, pDst, dstStep, roiSize, scaleFactor);
    case DT_SSE2:
        return _sse2_fwiAddC_8u_C3RSfs(pSrc, srcStep, value, pDst, dstStep, roiSize, scaleFactor);
    case DT_REFR:
        return _refr_fwiAddC_8u_C3RSfs(pSrc, srcStep, value, pDst, dstStep, roiSize, scaleFactor);
    default:
        assert(false);
        return _refr_fwiAddC_8u_C3RSfs(pSrc, srcStep, value, pDst, dstStep, roiSize, scaleFactor);
    }
}

OREFR OSSE2 FwStatus STDCALL fwiWarpAffineBack_16u_C1R( const Fw16u* pSrc, FwiSize srcSize, int srcStep,
								FwiRect srcRoi, Fw16u* pDst, int dstStep, FwiRect dstRoi,
								const double coeffs[2][3], int interpolation )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiWarpAffineBack_16u_C1R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, coeffs, interpolation);
    case DT_REFR:
        return _refr_fwiWarpAffineBack_16u_C1R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, coeffs, interpolation);
    default:
        assert(false);
        return _refr_fwiWarpAffineBack_16u_C1R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, coeffs, interpolation);
    }
}

OREFR               FwStatus fwiYCbCr422ToBGR444_8u16u_P3C3R(const A8U* const pSrc[3], int srcStep[3], A16U* pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiYCbCr422ToBGR444_8u16u_P3C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiYCbCr422ToBGR444_8u16u_P3C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}


OREFR OSSE2 FwStatus STDCALL fwiGetAffineTransform(FwiRect srcRoi, const double quad[4][2],double coeffs[2][3])
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiGetAffineTransform(srcRoi, quad, coeffs);
    case DT_REFR:
        return _refr_fwiGetAffineTransform(srcRoi, quad, coeffs);
    default:
        assert(false);
        return _refr_fwiGetAffineTransform(srcRoi, quad, coeffs);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiSqrt_16s_C1RSfs( const Fw16s *pSrc,    int srcStep, Fw16s *pDst, int dstStep, FwiSize roiSize, int scaleFactor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiSqrt_16s_C1RSfs(pSrc, srcStep, pDst, dstStep, roiSize, scaleFactor);
    case DT_SSE2:
        return _sse2_fwiSqrt_16s_C1RSfs(pSrc, srcStep, pDst, dstStep, roiSize, scaleFactor);
    case DT_REFR:
        return _refr_fwiSqrt_16s_C1RSfs(pSrc, srcStep, pDst, dstStep, roiSize, scaleFactor);
    default:
        assert(false);
        return _refr_fwiSqrt_16s_C1RSfs(pSrc, srcStep, pDst, dstStep, roiSize, scaleFactor);
    }
}

OREFR               FwStatus fwiRGBToYUV420_8u_P3( const A8U* const pSrc[3], A8U* const pDst[3], FwiSize imgSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiRGBToYUV420_8u_P3(pSrc, pDst, imgSize);
    default:
        assert(false);
        return _refr_fwiRGBToYUV420_8u_P3(pSrc, pDst, imgSize);
    }
}

OREFR OSSE2         FwStatus fwiColorToGray_32f_AC4C1R(const Fw32f* pSrc, int srcStep, Fw32f* pDst, int dstStep, FwiSize roiSize, const Fw32f coeffs[3])
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiColorToGray_32f_AC4C1R(pSrc, srcStep, pDst, dstStep, roiSize, coeffs);
    case DT_REFR:
        return _refr_fwiColorToGray_32f_AC4C1R(pSrc, srcStep, pDst, dstStep, roiSize, coeffs);
    default:
        assert(false);
        return _refr_fwiColorToGray_32f_AC4C1R(pSrc, srcStep, pDst, dstStep, roiSize, coeffs);
    }
}

OREFR       FwStatus STDCALL fwiWarpBilinearBack_8u_C3R(const Fw8u* pSrc, FwiSize srcSize, int srcStep,
								FwiRect srcRoi, Fw8u* pDst, int dstStep, FwiRect dstRoi,
								const double coeffs[2][4], int interpolation)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiWarpBilinearBack_8u_C3R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, coeffs, interpolation);
    default:
        assert(false);
        return _refr_fwiWarpBilinearBack_8u_C3R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, coeffs, interpolation);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiAnd_8u_C1IR( const Fw8u	*pSrc,  int srcStep,        Fw8u *pSrcDst, int srcDstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiAnd_8u_C1IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiAnd_8u_C1IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    case DT_REFR:
        return _refr_fwiAnd_8u_C1IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiAnd_8u_C1IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiRemap_32f_C4R( const Fw32f* pSrc, FwiSize srcSize, int srcStep, FwiRect srcRoi, const Fw32f* pxMap, int xMapStep, const Fw32f* pyMap, int yMapStep, Fw32f* pDst, int dstStep, FwiSize dstRoiSize, int interpolation )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiRemap_32f_C4R(pSrc, srcSize, srcStep, srcRoi, pxMap, xMapStep, pyMap, yMapStep, pDst, dstStep, dstRoiSize, interpolation);
    case DT_REFR:
        return _refr_fwiRemap_32f_C4R(pSrc, srcSize, srcStep, srcRoi, pxMap, xMapStep, pyMap, yMapStep, pDst, dstStep, dstRoiSize, interpolation);
    default:
        assert(false);
        return _refr_fwiRemap_32f_C4R(pSrc, srcSize, srcStep, srcRoi, pxMap, xMapStep, pyMap, yMapStep, pDst, dstStep, dstRoiSize, interpolation);
    }
}



OREFR OSSE2         FwStatus fwiMean_8u_C1R(const Fw8u* pSrc, int srcStep,FwiSize roiSize, Fw64f* pMean)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiMean_8u_C1R(pSrc, srcStep, roiSize, pMean);
    case DT_REFR:
        return _refr_fwiMean_8u_C1R(pSrc, srcStep, roiSize, pMean);
    default:
        assert(false);
        return _refr_fwiMean_8u_C1R(pSrc, srcStep, roiSize, pMean);
    }
}

OREFR               FwStatus fwiRGBToHLS_8u_AC4R( const Fw8u *pSrc, int srcStep, Fw8u *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiRGBToHLS_8u_AC4R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiRGBToHLS_8u_AC4R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiMulC_32f_C1R( const Fw32f *pSrc, int srcStep,       Fw32f value,    Fw32f *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiMulC_32f_C1R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiMulC_32f_C1R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiMulC_32f_C1R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiMulC_32f_C1R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiAbsDiff_8u_C1R( const Fw8u  *pSrc1, int src1Step, const Fw8u  *pSrc2,  int src2Step, Fw8u  *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiAbsDiff_8u_C1R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiAbsDiff_8u_C1R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiAbsDiff_8u_C1R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiAbsDiff_8u_C1R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiCopy_32s_C4MR( const Fw32s *pSrc, int srcStep, Fw32s *pDst, int dstStep, FwiSize roiSize, const Fw8u *pMask, int maskStep )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiCopy_32s_C4MR(pSrc, srcStep, pDst, dstStep, roiSize, pMask, maskStep);
    case DT_SSE2:
        return _sse2_fwiCopy_32s_C4MR(pSrc, srcStep, pDst, dstStep, roiSize, pMask, maskStep);
    case DT_REFR:
        return _refr_fwiCopy_32s_C4MR(pSrc, srcStep, pDst, dstStep, roiSize, pMask, maskStep);
    default:
        assert(false);
        return _refr_fwiCopy_32s_C4MR(pSrc, srcStep, pDst, dstStep, roiSize, pMask, maskStep);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiMul_16s_C3IRSfs( const Fw16s  *pSrc,  int srcStep,        Fw16s  *pSrcDst, int srcDstStep, FwiSize roiSize, int scaleFactor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiMul_16s_C3IRSfs(pSrc, srcStep, pSrcDst, srcDstStep, roiSize, scaleFactor);
    case DT_SSE2:
        return _sse2_fwiMul_16s_C3IRSfs(pSrc, srcStep, pSrcDst, srcDstStep, roiSize, scaleFactor);
    case DT_REFR:
        return _refr_fwiMul_16s_C3IRSfs(pSrc, srcStep, pSrcDst, srcDstStep, roiSize, scaleFactor);
    default:
        assert(false);
        return _refr_fwiMul_16s_C3IRSfs(pSrc, srcStep, pSrcDst, srcDstStep, roiSize, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiMul_32fc_C3IR( const Fw32fc *pSrc,  int srcStep,        Fw32fc *pSrcDst, int srcDstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiMul_32fc_C3IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiMul_32fc_C3IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    case DT_REFR:
        return _refr_fwiMul_32fc_C3IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiMul_32fc_C3IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    }
}

OREFR OSSE2 FwStatus STDCALL fwiWarpPerspectiveQuad_8u_C4R( const Fw8u* pSrc, FwiSize srcSize, int srcStep, FwiRect srcRoi,
							        const double srcQuad[4][2], Fw8u* pDst, int dstStep, FwiRect dstRoi,
									const double dstQuad[4][2], int interpolation )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiWarpPerspectiveQuad_8u_C4R(pSrc, srcSize, srcStep, srcRoi, srcQuad, pDst, dstStep, dstRoi, dstQuad, interpolation);
    case DT_REFR:
        return _refr_fwiWarpPerspectiveQuad_8u_C4R(pSrc, srcSize, srcStep, srcRoi, srcQuad, pDst, dstStep, dstRoi, dstQuad, interpolation);
    default:
        assert(false);
        return _refr_fwiWarpPerspectiveQuad_8u_C4R(pSrc, srcSize, srcStep, srcRoi, srcQuad, pDst, dstStep, dstRoi, dstQuad, interpolation);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiFilter32f_16s_C3R( const Fw16s * pSrc, int srcStep,
                                 Fw16s * pDst, int dstStep, FwiSize dstRoiSize,
                                 const Fw32f * pKernel, FwiSize kernelSize,
                                 FwiPoint anchor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilter32f_16s_C3R(pSrc, srcStep, pDst, dstStep, dstRoiSize, pKernel, kernelSize, anchor);
    case DT_REFR:
        return _refr_fwiFilter32f_16s_C3R(pSrc, srcStep, pDst, dstStep, dstRoiSize, pKernel, kernelSize, anchor);
    default:
        assert(false);
        return _refr_fwiFilter32f_16s_C3R(pSrc, srcStep, pDst, dstStep, dstRoiSize, pKernel, kernelSize, anchor);
    }
}

OREFR OSSE2 FwStatus STDCALL fwiWarpAffine_8u_C3R( const Fw8u* pSrc, FwiSize srcSize, int srcStep,
								FwiRect srcRoi, Fw8u* pDst, int dstStep, FwiRect dstRoi,
								const double coeffs[2][3], int interpolation )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiWarpAffine_8u_C3R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, coeffs, interpolation);
    case DT_REFR:
        return _refr_fwiWarpAffine_8u_C3R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, coeffs, interpolation);
    default:
        assert(false);
        return _refr_fwiWarpAffine_8u_C3R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, coeffs, interpolation);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiOrC_32s_AC4IR( const Fw32s value[3], Fw32s *pSrcDst, int srcDstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiOrC_32s_AC4IR(value, pSrcDst, srcDstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiOrC_32s_AC4IR(value, pSrcDst, srcDstStep, roiSize);
    case DT_REFR:
        return _refr_fwiOrC_32s_AC4IR(value, pSrcDst, srcDstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiOrC_32s_AC4IR(value, pSrcDst, srcDstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiDivC_8u_C3IRSfs( const Fw8u value[3], Fw8u *pSrcDst, int srcDstStep, FwiSize roiSize, int scaleFactor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiDivC_8u_C3IRSfs(value, pSrcDst, srcDstStep, roiSize, scaleFactor);
    case DT_SSE2:
        return _sse2_fwiDivC_8u_C3IRSfs(value, pSrcDst, srcDstStep, roiSize, scaleFactor);
    case DT_REFR:
        return _refr_fwiDivC_8u_C3IRSfs(value, pSrcDst, srcDstStep, roiSize, scaleFactor);
    default:
        assert(false);
        return _refr_fwiDivC_8u_C3IRSfs(value, pSrcDst, srcDstStep, roiSize, scaleFactor);
    }
}

OREFR               FwStatus fwiHSVToRGB_16u_AC4R( const Fw16u* pSrc, int srcStep, Fw16u* pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiHSVToRGB_16u_AC4R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiHSVToRGB_16u_AC4R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiRShiftC_16s_C3IR( const Fw32u value[3], Fw16s *pSrcDst, int srcDstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiRShiftC_16s_C3IR(value, pSrcDst, srcDstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiRShiftC_16s_C3IR(value, pSrcDst, srcDstStep, roiSize);
    case DT_REFR:
        return _refr_fwiRShiftC_16s_C3IR(value, pSrcDst, srcDstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiRShiftC_16s_C3IR(value, pSrcDst, srcDstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiDivC_16sc_AC4IRSfs( const Fw16sc value[3], Fw16sc *pSrcDst, int srcDstStep, FwiSize roiSize, int scaleFactor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiDivC_16sc_AC4IRSfs(value, pSrcDst, srcDstStep, roiSize, scaleFactor);
    case DT_SSE2:
        return _sse2_fwiDivC_16sc_AC4IRSfs(value, pSrcDst, srcDstStep, roiSize, scaleFactor);
    case DT_REFR:
        return _refr_fwiDivC_16sc_AC4IRSfs(value, pSrcDst, srcDstStep, roiSize, scaleFactor);
    default:
        assert(false);
        return _refr_fwiDivC_16sc_AC4IRSfs(value, pSrcDst, srcDstStep, roiSize, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiAbsDiff_32f_C1R( const Fw32f *pSrc1, int src1Step, const Fw32f *pSrc2,  int src2Step, Fw32f *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiAbsDiff_32f_C1R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiAbsDiff_32f_C1R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiAbsDiff_32f_C1R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiAbsDiff_32f_C1R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    }
}

OREFR               FwStatus fwiRGBToLUV_8u_AC4R( const Fw8u*  pSrc, int srcStep, Fw8u*  pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiRGBToLUV_8u_AC4R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiRGBToLUV_8u_AC4R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiRShiftC_32s_AC4IR( const Fw32u value[3], Fw32s *pSrcDst, int srcDstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiRShiftC_32s_AC4IR(value, pSrcDst, srcDstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiRShiftC_32s_AC4IR(value, pSrcDst, srcDstStep, roiSize);
    case DT_REFR:
        return _refr_fwiRShiftC_32s_AC4IR(value, pSrcDst, srcDstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiRShiftC_32s_AC4IR(value, pSrcDst, srcDstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiMul_16s_C1RSfs( const Fw16s  *pSrc1, int src1Step, const Fw16s  *pSrc2,   int src2Step, Fw16s *pDst, int dstStep, FwiSize roiSize, int scaleFactor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiMul_16s_C1RSfs(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, scaleFactor);
    case DT_SSE2:
        return _sse2_fwiMul_16s_C1RSfs(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, scaleFactor);
    case DT_REFR:
        return _refr_fwiMul_16s_C1RSfs(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, scaleFactor);
    default:
        assert(false);
        return _refr_fwiMul_16s_C1RSfs(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiAdd_32fc_C1R( const Fw32fc *pSrc1, int src1Step, const Fw32fc *pSrc2,   int src2Step, Fw32fc *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiAdd_32fc_C1R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiAdd_32fc_C1R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiAdd_32fc_C1R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiAdd_32fc_C1R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    }
}

OREFR             FwStatus STDCALL fwiScale_8u32s_C1R( const Fw8u * pSrc, int srcStep, Fw32s * pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiScale_8u32s_C1R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiScale_8u32s_C1R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2         FwStatus fwiMinMax_16s_C4R(const Fw16s* pSrc, int srcStep,FwiSize roiSize, Fw16s min[4], Fw16s max[4])
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiMinMax_16s_C4R(pSrc, srcStep, roiSize, min, max);
    case DT_REFR:
        return _refr_fwiMinMax_16s_C4R(pSrc, srcStep, roiSize, min, max);
    default:
        assert(false);
        return _refr_fwiMinMax_16s_C4R(pSrc, srcStep, roiSize, min, max);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiDiv_8u_C1IRSfs( const Fw8u   *pSrc,  int srcStep,        Fw8u   *pSrcDst, int srcDstStep, FwiSize roiSize, int scaleFactor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiDiv_8u_C1IRSfs(pSrc, srcStep, pSrcDst, srcDstStep, roiSize, scaleFactor);
    case DT_SSE2:
        return _sse2_fwiDiv_8u_C1IRSfs(pSrc, srcStep, pSrcDst, srcDstStep, roiSize, scaleFactor);
    case DT_REFR:
        return _refr_fwiDiv_8u_C1IRSfs(pSrc, srcStep, pSrcDst, srcDstStep, roiSize, scaleFactor);
    default:
        assert(false);
        return _refr_fwiDiv_8u_C1IRSfs(pSrc, srcStep, pSrcDst, srcDstStep, roiSize, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiAddC_32fc_C1IR(       Fw32fc  value,    Fw32fc *pSrcDst, int srcDstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiAddC_32fc_C1IR(value, pSrcDst, srcDstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiAddC_32fc_C1IR(value, pSrcDst, srcDstStep, roiSize);
    case DT_REFR:
        return _refr_fwiAddC_32fc_C1IR(value, pSrcDst, srcDstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiAddC_32fc_C1IR(value, pSrcDst, srcDstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiConvert_32f16s_C3R( const Fw32f *pSrc, int srcStep, Fw16s *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiConvert_32f16s_C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiConvert_32f16s_C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiConvert_32f16s_C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiConvert_32f16s_C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiRotate_16u_P4R( const Fw16u* const pSrc[4], FwiSize srcSize, int srcStep, FwiRect srcRoi, Fw16u* const pDst[4], int dstStep, FwiRect dstRoi, double angle, double xShift, double yShift, int interpolation )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiRotate_16u_P4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, angle, xShift, yShift, interpolation);
    case DT_REFR:
        return _refr_fwiRotate_16u_P4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, angle, xShift, yShift, interpolation);
    default:
        assert(false);
        return _refr_fwiRotate_16u_P4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, angle, xShift, yShift, interpolation);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiAnd_16u_C1IR( const Fw16u *pSrc,  int srcStep,        Fw16u *pSrcDst, int srcDstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiAnd_16u_C1IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiAnd_16u_C1IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    case DT_REFR:
        return _refr_fwiAnd_16u_C1IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiAnd_16u_C1IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiAddC_32f_C4IR( const Fw32f value[4], Fw32f *pSrcDst, int srcDstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiAddC_32f_C4IR(value, pSrcDst, srcDstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiAddC_32f_C4IR(value, pSrcDst, srcDstStep, roiSize);
    case DT_REFR:
        return _refr_fwiAddC_32f_C4IR(value, pSrcDst, srcDstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiAddC_32f_C4IR(value, pSrcDst, srcDstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiThreshold_LTVal_8u_C3R( const Fw8u *pSrc, int srcStep, Fw8u *pDst, int dstStep, FwiSize roiSize, const Fw8u threshold[3], const Fw8u value[3])
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiThreshold_LTVal_8u_C3R(pSrc, srcStep, pDst, dstStep, roiSize, threshold, value);
    case DT_SSE2:
        return _sse2_fwiThreshold_LTVal_8u_C3R(pSrc, srcStep, pDst, dstStep, roiSize, threshold, value);
    case DT_REFR:
        return _refr_fwiThreshold_LTVal_8u_C3R(pSrc, srcStep, pDst, dstStep, roiSize, threshold, value);
    default:
        assert(false);
        return _refr_fwiThreshold_LTVal_8u_C3R(pSrc, srcStep, pDst, dstStep, roiSize, threshold, value);
    }
}

OREFR               FwStatus fwiYCbCr422ToBGR555_8u16u_P3C3R(const A8U* const pSrc[3], int srcStep[3], A16U* pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiYCbCr422ToBGR555_8u16u_P3C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiYCbCr422ToBGR555_8u16u_P3C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiAdd_32sc_C3RSfs( const Fw32sc *pSrc1, int src1Step, const Fw32sc *pSrc2,   int src2Step, Fw32sc *pDst, int dstStep, FwiSize roiSize, int scaleFactor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiAdd_32sc_C3RSfs(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, scaleFactor);
    case DT_SSE2:
        return _sse2_fwiAdd_32sc_C3RSfs(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, scaleFactor);
    case DT_REFR:
        return _refr_fwiAdd_32sc_C3RSfs(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, scaleFactor);
    default:
        assert(false);
        return _refr_fwiAdd_32sc_C3RSfs(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, scaleFactor);
    }
}

OREFR       FwStatus STDCALL fwiWarpBilinearBack_32f_C1R(const Fw32f* pSrc, FwiSize srcSize, int srcStep,
								FwiRect srcRoi, Fw32f* pDst, int dstStep, FwiRect dstRoi,
								const double coeffs[2][4], int interpolation)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiWarpBilinearBack_32f_C1R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, coeffs, interpolation);
    default:
        assert(false);
        return _refr_fwiWarpBilinearBack_32f_C1R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, coeffs, interpolation);
    }
}

OREFR OSSE2 FwStatus STDCALL fwiResize_16u_C4R( const Fw16u* pSrc, FwiSize srcSize, int srcStep, FwiRect srcRoi,
							 Fw16u* pDst, int dstStep, FwiSize dstRoiSize,
							 double xFactor, double yFactor, int interpolation )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiResize_16u_C4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoiSize, xFactor, yFactor, interpolation);
    case DT_REFR:
        return _refr_fwiResize_16u_C4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoiSize, xFactor, yFactor, interpolation);
    default:
        assert(false);
        return _refr_fwiResize_16u_C4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoiSize, xFactor, yFactor, interpolation);
    }
}

OREFR OSSE2         FwStatus fwiMean_16s_AC4R(const Fw16s* pSrc, int srcStep,FwiSize roiSize, Fw64f mean[3])
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiMean_16s_AC4R(pSrc, srcStep, roiSize, mean);
    case DT_REFR:
        return _refr_fwiMean_16s_AC4R(pSrc, srcStep, roiSize, mean);
    default:
        assert(false);
        return _refr_fwiMean_16s_AC4R(pSrc, srcStep, roiSize, mean);
    }
}

OREFR OSSE2 FwStatus STDCALL fwiWarpPerspectiveBack_32f_AC4R( const Fw32f* pSrc, FwiSize srcSize, int srcStep,
								FwiRect srcRoi, Fw32f* pDst, int dstStep, FwiRect dstRoi,
								const double coeffs[3][3], int interpolation )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiWarpPerspectiveBack_32f_AC4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, coeffs, interpolation);
    case DT_REFR:
        return _refr_fwiWarpPerspectiveBack_32f_AC4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, coeffs, interpolation);
    default:
        assert(false);
        return _refr_fwiWarpPerspectiveBack_32f_AC4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, coeffs, interpolation);
    }
}

OREFR OSSE2         FwStatus fwiColorToGray_16s_AC4C1R(const Fw16s* pSrc, int srcStep, Fw16s* pDst, int dstStep, FwiSize roiSize, const Fw32f coeffs[3])
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiColorToGray_16s_AC4C1R(pSrc, srcStep, pDst, dstStep, roiSize, coeffs);
    case DT_REFR:
        return _refr_fwiColorToGray_16s_AC4C1R(pSrc, srcStep, pDst, dstStep, roiSize, coeffs);
    default:
        assert(false);
        return _refr_fwiColorToGray_16s_AC4C1R(pSrc, srcStep, pDst, dstStep, roiSize, coeffs);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiAbs_16s_AC4IR( Fw16s *pSrcDst, int srcDstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiAbs_16s_AC4IR(pSrcDst, srcDstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiAbs_16s_AC4IR(pSrcDst, srcDstStep, roiSize);
    case DT_REFR:
        return _refr_fwiAbs_16s_AC4IR(pSrcDst, srcDstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiAbs_16s_AC4IR(pSrcDst, srcDstStep, roiSize);
    }
}

OREFR OSSE2 FwStatus STDCALL fwiWarpAffineQuad_32f_P4R( const Fw32f* const pSrc[4], FwiSize srcSize, int srcStep, FwiRect srcRoi,
							        const double srcQuad[4][2], Fw32f* const pDst[4], int dstStep, FwiRect dstRoi,
									const double dstQuad[4][2], int interpolation )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiWarpAffineQuad_32f_P4R(pSrc, srcSize, srcStep, srcRoi, srcQuad, pDst, dstStep, dstRoi, dstQuad, interpolation);
    case DT_REFR:
        return _refr_fwiWarpAffineQuad_32f_P4R(pSrc, srcSize, srcStep, srcRoi, srcQuad, pDst, dstStep, dstRoi, dstQuad, interpolation);
    default:
        assert(false);
        return _refr_fwiWarpAffineQuad_32f_P4R(pSrc, srcSize, srcStep, srcRoi, srcQuad, pDst, dstStep, dstRoi, dstQuad, interpolation);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiMulScale_8u_C4R(  const Fw8u  *pSrc1, int src1Step, const Fw8u  *pSrc2, int src2Step, Fw8u  *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiMulScale_8u_C4R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiMulScale_8u_C4R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiMulScale_8u_C4R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiMulScale_8u_C4R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiFilterSobelCross_8s16s_C1R( const Fw8s * pSrc, int srcStep, Fw16s * pDst, int dstStep, FwiSize dstRoiSize, FwiMaskSize mask )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilterSobelCross_8s16s_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize, mask);
    case DT_REFR:
        return _refr_fwiFilterSobelCross_8s16s_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize, mask);
    default:
        assert(false);
        return _refr_fwiFilterSobelCross_8s16s_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize, mask);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiMul_16sc_C3IRSfs( const Fw16sc *pSrc,  int srcStep,        Fw16sc *pSrcDst, int srcDstStep, FwiSize roiSize, int scaleFactor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiMul_16sc_C3IRSfs(pSrc, srcStep, pSrcDst, srcDstStep, roiSize, scaleFactor);
    case DT_SSE2:
        return _sse2_fwiMul_16sc_C3IRSfs(pSrc, srcStep, pSrcDst, srcDstStep, roiSize, scaleFactor);
    case DT_REFR:
        return _refr_fwiMul_16sc_C3IRSfs(pSrc, srcStep, pSrcDst, srcDstStep, roiSize, scaleFactor);
    default:
        assert(false);
        return _refr_fwiMul_16sc_C3IRSfs(pSrc, srcStep, pSrcDst, srcDstStep, roiSize, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiAbs_32f_C1IR( Fw32f *pSrcDst, int srcDstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiAbs_32f_C1IR(pSrcDst, srcDstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiAbs_32f_C1IR(pSrcDst, srcDstStep, roiSize);
    case DT_REFR:
        return _refr_fwiAbs_32f_C1IR(pSrcDst, srcDstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiAbs_32f_C1IR(pSrcDst, srcDstStep, roiSize);
    }
}

OREFR OSSE2 FwStatus STDCALL fwiResizeShift_32f_C4R( const Fw32f* pSrc, FwiSize srcSize, int srcStep, FwiRect srcRoi,
								  Fw32f* pDst, int dstStep, FwiSize dstRoiSize,
								  double xFr, double yFr, double xShift, double yShift, int interpolation )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiResizeShift_32f_C4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoiSize, xFr, yFr, xShift, yShift, interpolation);
    case DT_REFR:
        return _refr_fwiResizeShift_32f_C4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoiSize, xFr, yFr, xShift, yShift, interpolation);
    default:
        assert(false);
        return _refr_fwiResizeShift_32f_C4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoiSize, xFr, yFr, xShift, yShift, interpolation);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiSqrt_8u_C1RSfs( const Fw8u *pSrc,    int srcStep, Fw8u *pDst, int dstStep, FwiSize roiSize, int scaleFactor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiSqrt_8u_C1RSfs(pSrc, srcStep, pDst, dstStep, roiSize, scaleFactor);
    case DT_SSE2:
        return _sse2_fwiSqrt_8u_C1RSfs(pSrc, srcStep, pDst, dstStep, roiSize, scaleFactor);
    case DT_REFR:
        return _refr_fwiSqrt_8u_C1RSfs(pSrc, srcStep, pDst, dstStep, roiSize, scaleFactor);
    default:
        assert(false);
        return _refr_fwiSqrt_8u_C1RSfs(pSrc, srcStep, pDst, dstStep, roiSize, scaleFactor);
    }
}

OREFR OSSE2 FwStatus STDCALL fwiWarpPerspective_8u_C4R( const Fw8u* pSrc, FwiSize srcSize, int srcStep,
								FwiRect srcRoi, Fw8u* pDst, int dstStep, FwiRect dstRoi,
								const double coeffs[3][3], int interpolation )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiWarpPerspective_8u_C4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, coeffs, interpolation);
    case DT_REFR:
        return _refr_fwiWarpPerspective_8u_C4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, coeffs, interpolation);
    default:
        assert(false);
        return _refr_fwiWarpPerspective_8u_C4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, coeffs, interpolation);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiAndC_16u_AC4R( const Fw16u  *pSrc, int srcStep, const Fw16u value[3], Fw16u *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiAndC_16u_AC4R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiAndC_16u_AC4R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiAndC_16u_AC4R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiAndC_16u_AC4R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiCopy_8u_C1MR( const Fw8u *pSrc, int srcStep, Fw8u *pDst, int dstStep, FwiSize roiSize, const Fw8u *pMask, int maskStep )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiCopy_8u_C1MR(pSrc, srcStep, pDst, dstStep, roiSize, pMask, maskStep);
    case DT_SSE2:
        return _sse2_fwiCopy_8u_C1MR(pSrc, srcStep, pDst, dstStep, roiSize, pMask, maskStep);
    case DT_REFR:
        return _refr_fwiCopy_8u_C1MR(pSrc, srcStep, pDst, dstStep, roiSize, pMask, maskStep);
    default:
        assert(false);
        return _refr_fwiCopy_8u_C1MR(pSrc, srcStep, pDst, dstStep, roiSize, pMask, maskStep);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiFilterMedian_8u_C4R( const Fw8u * pSrc, int srcStep,
                                           Fw8u * pDst, int dstStep, FwiSize dstRoiSize,
                                           FwiSize maskSize, FwiPoint anchor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilterMedian_8u_C4R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize, anchor);
    case DT_REFR:
        return _refr_fwiFilterMedian_8u_C4R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize, anchor);
    default:
        assert(false);
        return _refr_fwiFilterMedian_8u_C4R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize, anchor);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiGetRotateBound(FwiRect srcRoi, double bound[2][2], double angle, double xShift, double yShift)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiGetRotateBound(srcRoi, bound, angle, xShift, yShift);
    case DT_REFR:
        return _refr_fwiGetRotateBound(srcRoi, bound, angle, xShift, yShift);
    default:
        assert(false);
        return _refr_fwiGetRotateBound(srcRoi, bound, angle, xShift, yShift);
    }
}


OREFR               FwStatus fwiRGBToHLS_8u_C3R( const Fw8u *pSrc, int srcStep, Fw8u *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiRGBToHLS_8u_C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiRGBToHLS_8u_C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiAdd_8u_AC4RSfs( const Fw8u   *pSrc1, int src1Step, const Fw8u   *pSrc2,   int src2Step, Fw8u *pDst, int dstStep, FwiSize roiSize, int scaleFactor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiAdd_8u_AC4RSfs(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, scaleFactor);
    case DT_SSE2:
        return _sse2_fwiAdd_8u_AC4RSfs(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, scaleFactor);
    case DT_REFR:
        return _refr_fwiAdd_8u_AC4RSfs(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, scaleFactor);
    default:
        assert(false);
        return _refr_fwiAdd_8u_AC4RSfs(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, scaleFactor);
    }
}


OREFR               FwStatus fwiRGBToLUV_8u_C3R( const Fw8u*  pSrc, int srcStep, Fw8u*  pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiRGBToLUV_8u_C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiRGBToLUV_8u_C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2         FwStatus fwiMinMax_8u_C3R(const Fw8u* pSrc, int srcStep,FwiSize roiSize, Fw8u min[3], Fw8u max[3])
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiMinMax_8u_C3R(pSrc, srcStep, roiSize, min, max);
    case DT_REFR:
        return _refr_fwiMinMax_8u_C3R(pSrc, srcStep, roiSize, min, max);
    default:
        assert(false);
        return _refr_fwiMinMax_8u_C3R(pSrc, srcStep, roiSize, min, max);
    }
}

OREFR               FwStatus fwiYCbCr411ToBGR_8u_P3C3R(const A8U* const pSrc[3], int srcStep[3], A8U* pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiYCbCr411ToBGR_8u_P3C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiYCbCr411ToBGR_8u_P3C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiSqr_16u_C3IRSfs(       Fw16u *pSrcDst, int srcDstStep, FwiSize roiSize, int scaleFactor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiSqr_16u_C3IRSfs(pSrcDst, srcDstStep, roiSize, scaleFactor);
    case DT_SSE2:
        return _sse2_fwiSqr_16u_C3IRSfs(pSrcDst, srcDstStep, roiSize, scaleFactor);
    case DT_REFR:
        return _refr_fwiSqr_16u_C3IRSfs(pSrcDst, srcDstStep, roiSize, scaleFactor);
    default:
        assert(false);
        return _refr_fwiSqr_16u_C3IRSfs(pSrcDst, srcDstStep, roiSize, scaleFactor);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiRotateCenter_8u_AC4R( const Fw8u* pSrc,FwiSize srcSize, int srcStep, FwiRect srcRoi, Fw8u* pDst, int dstStep, FwiRect dstRoi, double angle, double xCenter, double yCenter, int interpolation )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiRotateCenter_8u_AC4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, angle, xCenter, yCenter, interpolation);
    case DT_REFR:
        return _refr_fwiRotateCenter_8u_AC4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, angle, xCenter, yCenter, interpolation);
    default:
        assert(false);
        return _refr_fwiRotateCenter_8u_AC4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, angle, xCenter, yCenter, interpolation);
    }
}

OREFR               FwStatus fwiBGRToYCbCr420_8u_AC4P3R(const A8U* pSrc, int srcStep, A8U* const pDst[3], int dstStep[3], FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiBGRToYCbCr420_8u_AC4P3R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiBGRToYCbCr420_8u_AC4P3R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}


OREFR OSSE2       FwStatus STDCALL fwiFilterRow32f_8u_C1R( const Fw8u * pSrc, int srcStep,
                                Fw8u * pDst, int dstStep, FwiSize dstRoiSize,
                                const Fw32f * pKernel, int kernelSize,
                                int xAnchor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilterRow32f_8u_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize, pKernel, kernelSize, xAnchor);
    case DT_REFR:
        return _refr_fwiFilterRow32f_8u_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize, pKernel, kernelSize, xAnchor);
    default:
        assert(false);
        return _refr_fwiFilterRow32f_8u_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize, pKernel, kernelSize, xAnchor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiMulScale_16u_C1R(  const Fw16u *pSrc1, int src1Step, const Fw16u *pSrc2,   int src2Step, Fw16u *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiMulScale_16u_C1R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiMulScale_16u_C1R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiMulScale_16u_C1R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiMulScale_16u_C1R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiSub_16s_C4RSfs( const Fw16s  *pSrc1, int src1Step, const Fw16s  *pSrc2,   int src2Step, Fw16s *pDst, int dstStep, FwiSize roiSize, int scaleFactor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiSub_16s_C4RSfs(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, scaleFactor);
    case DT_SSE2:
        return _sse2_fwiSub_16s_C4RSfs(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, scaleFactor);
    case DT_REFR:
        return _refr_fwiSub_16s_C4RSfs(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, scaleFactor);
    default:
        assert(false);
        return _refr_fwiSub_16s_C4RSfs(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiSet_8u_AC4R( const Fw8u  value[3], Fw8u  * pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiSet_8u_AC4R(value, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiSet_8u_AC4R(value, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiSet_8u_AC4R(value, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiSet_8u_AC4R(value, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiFilterRobertsDown_32f_AC4R( const Fw32f * pSrc, int srcStep, Fw32f * pDst, int dstStep, FwiSize dstRoiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilterRobertsDown_32f_AC4R(pSrc, srcStep, pDst, dstStep, dstRoiSize);
    case DT_REFR:
        return _refr_fwiFilterRobertsDown_32f_AC4R(pSrc, srcStep, pDst, dstStep, dstRoiSize);
    default:
        assert(false);
        return _refr_fwiFilterRobertsDown_32f_AC4R(pSrc, srcStep, pDst, dstStep, dstRoiSize);
    }
}

OREFR             FwStatus STDCALL fwiScale_8u32f_C1R( const Fw8u * pSrc, int srcStep, Fw32f * pDst, int dstStep, FwiSize roiSize, Fw32f vMin, Fw32f vMax )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiScale_8u32f_C1R(pSrc, srcStep, pDst, dstStep, roiSize, vMin, vMax);
    default:
        assert(false);
        return _refr_fwiScale_8u32f_C1R(pSrc, srcStep, pDst, dstStep, roiSize, vMin, vMax);
    }
}

OREFR             FwStatus STDCALL fwiScale_16u8u_C1R( const Fw16u * pSrc, int srcStep, Fw8u * pDst, int dstStep, FwiSize roiSize, FwHintAlgorithm hint )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiScale_16u8u_C1R(pSrc, srcStep, pDst, dstStep, roiSize, hint);
    default:
        assert(false);
        return _refr_fwiScale_16u8u_C1R(pSrc, srcStep, pDst, dstStep, roiSize, hint);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiCopy_16s_C1R( const Fw16s *pSrc, int srcStep, Fw16s *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiCopy_16s_C1R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiCopy_16s_C1R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiCopy_16s_C1R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiCopy_16s_C1R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR               FwStatus fwiRGBToYCC_16u_C3R( const Fw16u* pSrc, int srcStep, Fw16u* pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiRGBToYCC_16u_C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiRGBToYCC_16u_C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiThreshold_GTVal_32f_C1IR( Fw32f *pSrcDst, int srcDstStep, FwiSize roiSize, Fw32f threshold, Fw32f value)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiThreshold_GTVal_32f_C1IR(pSrcDst, srcDstStep, roiSize, threshold, value);
    case DT_SSE2:
        return _sse2_fwiThreshold_GTVal_32f_C1IR(pSrcDst, srcDstStep, roiSize, threshold, value);
    case DT_REFR:
        return _refr_fwiThreshold_GTVal_32f_C1IR(pSrcDst, srcDstStep, roiSize, threshold, value);
    default:
        assert(false);
        return _refr_fwiThreshold_GTVal_32f_C1IR(pSrcDst, srcDstStep, roiSize, threshold, value);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiThreshold_Val_8u_C3R( const Fw8u *pSrc, int srcStep, Fw8u *pDst, int dstStep, FwiSize roiSize, const Fw8u threshold[3], const Fw8u value[3], FwCmpOp fwCmpOp)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiThreshold_Val_8u_C3R(pSrc, srcStep, pDst, dstStep, roiSize, threshold, value, fwCmpOp);
    case DT_SSE2:
        return _sse2_fwiThreshold_Val_8u_C3R(pSrc, srcStep, pDst, dstStep, roiSize, threshold, value, fwCmpOp);
    case DT_REFR:
        return _refr_fwiThreshold_Val_8u_C3R(pSrc, srcStep, pDst, dstStep, roiSize, threshold, value, fwCmpOp);
    default:
        assert(false);
        return _refr_fwiThreshold_Val_8u_C3R(pSrc, srcStep, pDst, dstStep, roiSize, threshold, value, fwCmpOp);
    }
}


OREFR OSSE2       FwStatus STDCALL fwiFilterMin_8u_C1R( const Fw8u * pSrc, int srcStep,
                               Fw8u * pDst, int dstStep, FwiSize dstRoiSize,
                               FwiSize maskSize, FwiPoint anchor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilterMin_8u_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize, anchor);
    case DT_REFR:
        return _refr_fwiFilterMin_8u_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize, anchor);
    default:
        assert(false);
        return _refr_fwiFilterMin_8u_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize, anchor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiSqrt_16u_AC4IRSfs(       Fw16u *pSrcDst, int srcDstStep, FwiSize roiSize, int scaleFactor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiSqrt_16u_AC4IRSfs(pSrcDst, srcDstStep, roiSize, scaleFactor);
    case DT_SSE2:
        return _sse2_fwiSqrt_16u_AC4IRSfs(pSrcDst, srcDstStep, roiSize, scaleFactor);
    case DT_REFR:
        return _refr_fwiSqrt_16u_AC4IRSfs(pSrcDst, srcDstStep, roiSize, scaleFactor);
    default:
        assert(false);
        return _refr_fwiSqrt_16u_AC4IRSfs(pSrcDst, srcDstStep, roiSize, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiConvert_32s8s_C3R( const Fw32s *pSrc, int srcStep, Fw8s *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiConvert_32s8s_C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiConvert_32s8s_C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiConvert_32s8s_C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiConvert_32s8s_C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiSubC_32f_AC4IR( const Fw32f value[3], Fw32f *pSrcDst, int srcDstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiSubC_32f_AC4IR(value, pSrcDst, srcDstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiSubC_32f_AC4IR(value, pSrcDst, srcDstStep, roiSize);
    case DT_REFR:
        return _refr_fwiSubC_32f_AC4IR(value, pSrcDst, srcDstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiSubC_32f_AC4IR(value, pSrcDst, srcDstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiSub_32sc_AC4RSfs( const Fw32sc *pSrc1, int src1Step, const Fw32sc *pSrc2,   int src2Step, Fw32sc *pDst, int dstStep, FwiSize roiSize, int scaleFactor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiSub_32sc_AC4RSfs(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, scaleFactor);
    case DT_SSE2:
        return _sse2_fwiSub_32sc_AC4RSfs(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, scaleFactor);
    case DT_REFR:
        return _refr_fwiSub_32sc_AC4RSfs(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, scaleFactor);
    default:
        assert(false);
        return _refr_fwiSub_32sc_AC4RSfs(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiSub_8u_C3RSfs( const Fw8u   *pSrc1, int src1Step, const Fw8u   *pSrc2,   int src2Step, Fw8u *pDst, int dstStep, FwiSize roiSize, int scaleFactor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiSub_8u_C3RSfs(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, scaleFactor);
    case DT_SSE2:
        return _sse2_fwiSub_8u_C3RSfs(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, scaleFactor);
    case DT_REFR:
        return _refr_fwiSub_8u_C3RSfs(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, scaleFactor);
    default:
        assert(false);
        return _refr_fwiSub_8u_C3RSfs(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiRShiftC_16s_C4R( const Fw16s  *pSrc, int srcStep, const Fw32u value[4], Fw16s *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiRShiftC_16s_C4R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiRShiftC_16s_C4R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiRShiftC_16s_C4R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiRShiftC_16s_C4R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2         FwStatus fwiMin_32f_AC4R(const Fw32f* pSrc, int srcStep,FwiSize roiSize, Fw32f min[3])
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiMin_32f_AC4R(pSrc, srcStep, roiSize, min);
    case DT_REFR:
        return _refr_fwiMin_32f_AC4R(pSrc, srcStep, roiSize, min);
    default:
        assert(false);
        return _refr_fwiMin_32f_AC4R(pSrc, srcStep, roiSize, min);
    }
}

OREFR OSSE2 FwStatus STDCALL fwiResizeCenter_32f_AC4R( const Fw32f* pSrc, FwiSize srcSize, int srcStep, FwiRect srcRoi,
								   Fw32f* pDst, int dstStep, FwiSize dstRoiSize,
								   double xFactor, double yFactor, double xCenter, double yCenter, int interpolation )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiResizeCenter_32f_AC4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoiSize, xFactor, yFactor, xCenter, yCenter, interpolation);
    case DT_REFR:
        return _refr_fwiResizeCenter_32f_AC4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoiSize, xFactor, yFactor, xCenter, yCenter, interpolation);
    default:
        assert(false);
        return _refr_fwiResizeCenter_32f_AC4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoiSize, xFactor, yFactor, xCenter, yCenter, interpolation);
    }
}

OREFR       FwStatus STDCALL fwiZigzagInv8x8_16s_C1(const Fw16s* pSrc, Fw16s* pDst)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiZigzagInv8x8_16s_C1(pSrc, pDst);
    default:
        assert(false);
        return _refr_fwiZigzagInv8x8_16s_C1(pSrc, pDst);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiThreshold_GTVal_32f_C3IR( Fw32f *pSrcDst, int srcDstStep, FwiSize roiSize, const Fw32f threshold[3], const Fw32f value[3])
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiThreshold_GTVal_32f_C3IR(pSrcDst, srcDstStep, roiSize, threshold, value);
    case DT_SSE2:
        return _sse2_fwiThreshold_GTVal_32f_C3IR(pSrcDst, srcDstStep, roiSize, threshold, value);
    case DT_REFR:
        return _refr_fwiThreshold_GTVal_32f_C3IR(pSrcDst, srcDstStep, roiSize, threshold, value);
    default:
        assert(false);
        return _refr_fwiThreshold_GTVal_32f_C3IR(pSrcDst, srcDstStep, roiSize, threshold, value);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiFilterRobertsDown_16s_C3R( const Fw16s * pSrc, int srcStep, Fw16s * pDst, int dstStep, FwiSize dstRoiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilterRobertsDown_16s_C3R(pSrc, srcStep, pDst, dstStep, dstRoiSize);
    case DT_REFR:
        return _refr_fwiFilterRobertsDown_16s_C3R(pSrc, srcStep, pDst, dstStep, dstRoiSize);
    default:
        assert(false);
        return _refr_fwiFilterRobertsDown_16s_C3R(pSrc, srcStep, pDst, dstStep, dstRoiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiRShiftC_16u_C4IR( const Fw32u value[4], Fw16u *pSrcDst, int srcDstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiRShiftC_16u_C4IR(value, pSrcDst, srcDstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiRShiftC_16u_C4IR(value, pSrcDst, srcDstStep, roiSize);
    case DT_REFR:
        return _refr_fwiRShiftC_16u_C4IR(value, pSrcDst, srcDstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiRShiftC_16u_C4IR(value, pSrcDst, srcDstStep, roiSize);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiFilterLowpass_32f_C3R( const Fw32f * pSrc, int srcStep, Fw32f * pDst, int dstStep, FwiSize dstRoiSize, FwiMaskSize maskSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilterLowpass_32f_C3R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize);
    case DT_REFR:
        return _refr_fwiFilterLowpass_32f_C3R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize);
    default:
        assert(false);
        return _refr_fwiFilterLowpass_32f_C3R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiRemap_32f_AC4R( const Fw32f* pSrc, FwiSize srcSize, int srcStep, FwiRect srcRoi, const Fw32f* pxMap, int xMapStep, const Fw32f* pyMap, int yMapStep, Fw32f* pDst, int dstStep, FwiSize dstRoiSize, int interpolation )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiRemap_32f_AC4R(pSrc, srcSize, srcStep, srcRoi, pxMap, xMapStep, pyMap, yMapStep, pDst, dstStep, dstRoiSize, interpolation);
    case DT_REFR:
        return _refr_fwiRemap_32f_AC4R(pSrc, srcSize, srcStep, srcRoi, pxMap, xMapStep, pyMap, yMapStep, pDst, dstStep, dstRoiSize, interpolation);
    default:
        assert(false);
        return _refr_fwiRemap_32f_AC4R(pSrc, srcSize, srcStep, srcRoi, pxMap, xMapStep, pyMap, yMapStep, pDst, dstStep, dstRoiSize, interpolation);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiXorC_16u_AC4R( const Fw16u  *pSrc, int srcStep, const Fw16u value[3], Fw16u *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiXorC_16u_AC4R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiXorC_16u_AC4R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiXorC_16u_AC4R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiXorC_16u_AC4R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiOrC_16u_C4R( const Fw16u  *pSrc, int srcStep, const Fw16u value[4], Fw16u *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiOrC_16u_C4R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiOrC_16u_C4R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiOrC_16u_C4R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiOrC_16u_C4R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiFilterMedianHoriz_16s_C3R( const Fw16s * pSrc, int srcStep,
                                               Fw16s * pDst, int dstStep, FwiSize dstRoiSize,
                                               FwiMaskSize maskSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilterMedianHoriz_16s_C3R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize);
    case DT_REFR:
        return _refr_fwiFilterMedianHoriz_16s_C3R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize);
    default:
        assert(false);
        return _refr_fwiFilterMedianHoriz_16s_C3R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiLShiftC_16u_C4R( const Fw16u  *pSrc, int srcStep, const Fw32u value[4], Fw16u *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiLShiftC_16u_C4R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiLShiftC_16u_C4R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiLShiftC_16u_C4R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiLShiftC_16u_C4R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiMulC_32sc_C3IRSfs( const Fw32sc value[3], Fw32sc *pSrcDst, int srcDstStep, FwiSize roiSize, int scaleFactor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiMulC_32sc_C3IRSfs(value, pSrcDst, srcDstStep, roiSize, scaleFactor);
    case DT_SSE2:
        return _sse2_fwiMulC_32sc_C3IRSfs(value, pSrcDst, srcDstStep, roiSize, scaleFactor);
    case DT_REFR:
        return _refr_fwiMulC_32sc_C3IRSfs(value, pSrcDst, srcDstStep, roiSize, scaleFactor);
    default:
        assert(false);
        return _refr_fwiMulC_32sc_C3IRSfs(value, pSrcDst, srcDstStep, roiSize, scaleFactor);
    }
}

OREFR OSSE2 FwStatus STDCALL fwiResize_32f_P4R( const Fw32f* const pSrc[4], FwiSize srcSize, int srcStep, FwiRect srcRoi,
							 Fw32f* const pDst[4], int dstStep, FwiSize dstRoiSize,
							 double xFactor, double yFactor, int interpolation )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiResize_32f_P4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoiSize, xFactor, yFactor, interpolation);
    case DT_REFR:
        return _refr_fwiResize_32f_P4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoiSize, xFactor, yFactor, interpolation);
    default:
        assert(false);
        return _refr_fwiResize_32f_P4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoiSize, xFactor, yFactor, interpolation);
    }
}

OREFR               FwStatus fwiRGBToXYZ_32f_AC4R( const Fw32f* pSrc, int srcStep, Fw32f* pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiRGBToXYZ_32f_AC4R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiRGBToXYZ_32f_AC4R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR       FwStatus STDCALL fwiWarpBilinearBack_32f_C4R(const Fw32f* pSrc, FwiSize srcSize, int srcStep,
								FwiRect srcRoi, Fw32f* pDst, int dstStep, FwiRect dstRoi,
								const double coeffs[2][4], int interpolation)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiWarpBilinearBack_32f_C4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, coeffs, interpolation);
    default:
        assert(false);
        return _refr_fwiWarpBilinearBack_32f_C4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, coeffs, interpolation);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiSubC_32sc_AC4RSfs( const Fw32sc *pSrc, int srcStep, const Fw32sc value[3], Fw32sc *pDst, int dstStep, FwiSize roiSize, int scaleFactor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiSubC_32sc_AC4RSfs(pSrc, srcStep, value, pDst, dstStep, roiSize, scaleFactor);
    case DT_SSE2:
        return _sse2_fwiSubC_32sc_AC4RSfs(pSrc, srcStep, value, pDst, dstStep, roiSize, scaleFactor);
    case DT_REFR:
        return _refr_fwiSubC_32sc_AC4RSfs(pSrc, srcStep, value, pDst, dstStep, roiSize, scaleFactor);
    default:
        assert(false);
        return _refr_fwiSubC_32sc_AC4RSfs(pSrc, srcStep, value, pDst, dstStep, roiSize, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiSqr_16u_AC4IRSfs(       Fw16u *pSrcDst, int srcDstStep, FwiSize roiSize, int scaleFactor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiSqr_16u_AC4IRSfs(pSrcDst, srcDstStep, roiSize, scaleFactor);
    case DT_SSE2:
        return _sse2_fwiSqr_16u_AC4IRSfs(pSrcDst, srcDstStep, roiSize, scaleFactor);
    case DT_REFR:
        return _refr_fwiSqr_16u_AC4IRSfs(pSrcDst, srcDstStep, roiSize, scaleFactor);
    default:
        assert(false);
        return _refr_fwiSqr_16u_AC4IRSfs(pSrcDst, srcDstStep, roiSize, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiNot_8u_C3R( const Fw8u   *pSrc, int srcStep,    Fw8u *pDst, int dstStep, FwiSize roiSize)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiNot_8u_C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiNot_8u_C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiNot_8u_C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiNot_8u_C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiFilterRow_16s_C4R( const Fw16s * pSrc, int srcStep,
                              Fw16s * pDst, int dstStep, FwiSize dstRoiSize,
                              const Fw32s * pKernel, int kernelSize,
                              int xAnchor, int divisor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilterRow_16s_C4R(pSrc, srcStep, pDst, dstStep, dstRoiSize, pKernel, kernelSize, xAnchor, divisor);
    case DT_REFR:
        return _refr_fwiFilterRow_16s_C4R(pSrc, srcStep, pDst, dstStep, dstRoiSize, pKernel, kernelSize, xAnchor, divisor);
    default:
        assert(false);
        return _refr_fwiFilterRow_16s_C4R(pSrc, srcStep, pDst, dstStep, dstRoiSize, pKernel, kernelSize, xAnchor, divisor);
    }
}

OREFR       FwStatus STDCALL fwiGetShearBound(FwiRect srcRoi, double bound[2][2], double xShear, double yShear, double xShift, double yShift)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiGetShearBound(srcRoi, bound, xShear, yShear, xShift, yShift);
    default:
        assert(false);
        return _refr_fwiGetShearBound(srcRoi, bound, xShear, yShear, xShift, yShift);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiAdd_16u32f_C1IMR( const Fw16u *pSrc, int srcStep, const Fw8u *pMask, int maskStep, Fw32f *pSrcDst, int srcDstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiAdd_16u32f_C1IMR(pSrc, srcStep, pMask, maskStep, pSrcDst, srcDstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiAdd_16u32f_C1IMR(pSrc, srcStep, pMask, maskStep, pSrcDst, srcDstStep, roiSize);
    case DT_REFR:
        return _refr_fwiAdd_16u32f_C1IMR(pSrc, srcStep, pMask, maskStep, pSrcDst, srcDstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiAdd_16u32f_C1IMR(pSrc, srcStep, pMask, maskStep, pSrcDst, srcDstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiLn_8u_C3RSfs( const Fw8u  *pSrc, int srcStep, Fw8u  *pDst, int dstStep, FwiSize roiSize, int scaleFactor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiLn_8u_C3RSfs(pSrc, srcStep, pDst, dstStep, roiSize, scaleFactor);
    case DT_SSE2:
        return _sse2_fwiLn_8u_C3RSfs(pSrc, srcStep, pDst, dstStep, roiSize, scaleFactor);
    case DT_REFR:
        return _refr_fwiLn_8u_C3RSfs(pSrc, srcStep, pDst, dstStep, roiSize, scaleFactor);
    default:
        assert(false);
        return _refr_fwiLn_8u_C3RSfs(pSrc, srcStep, pDst, dstStep, roiSize, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiSub_32fc_C1R( const Fw32fc *pSrc1, int src1Step, const Fw32fc *pSrc2,   int src2Step, Fw32fc *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiSub_32fc_C1R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiSub_32fc_C1R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiSub_32fc_C1R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiSub_32fc_C1R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiFilterMedianVert_16s_C4R( const Fw16s * pSrc, int srcStep,
                                               Fw16s * pDst, int dstStep, FwiSize dstRoiSize,
                                               FwiMaskSize maskSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilterMedianVert_16s_C4R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize);
    case DT_REFR:
        return _refr_fwiFilterMedianVert_16s_C4R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize);
    default:
        assert(false);
        return _refr_fwiFilterMedianVert_16s_C4R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiThreshold_LTValGTVal_32f_C3IR( Fw32f *pSrcDst, int srcDstStep, FwiSize roiSize, const Fw32f thresholdLT[3], const Fw32f valueLT[3], const Fw32f thresholdGT[3], const Fw32f valueGT[3])
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiThreshold_LTValGTVal_32f_C3IR(pSrcDst, srcDstStep, roiSize, thresholdLT, valueLT, thresholdGT, valueGT);
    case DT_SSE2:
        return _sse2_fwiThreshold_LTValGTVal_32f_C3IR(pSrcDst, srcDstStep, roiSize, thresholdLT, valueLT, thresholdGT, valueGT);
    case DT_REFR:
        return _refr_fwiThreshold_LTValGTVal_32f_C3IR(pSrcDst, srcDstStep, roiSize, thresholdLT, valueLT, thresholdGT, valueGT);
    default:
        assert(false);
        return _refr_fwiThreshold_LTValGTVal_32f_C3IR(pSrcDst, srcDstStep, roiSize, thresholdLT, valueLT, thresholdGT, valueGT);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiSet_16s_C4R( const Fw16s  value[4], Fw16s  * pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiSet_16s_C4R(value, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiSet_16s_C4R(value, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiSet_16s_C4R(value, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiSet_16s_C4R(value, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiFilterColumn_16s_C3R( const Fw16s * pSrc, int srcStep,
                              Fw16s * pDst, int dstStep, FwiSize dstRoiSize,
                              const Fw32s * pKernel, int kernelSize,
                              int yAnchor, int divisor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilterColumn_16s_C3R(pSrc, srcStep, pDst, dstStep, dstRoiSize, pKernel, kernelSize, yAnchor, divisor);
    case DT_REFR:
        return _refr_fwiFilterColumn_16s_C3R(pSrc, srcStep, pDst, dstStep, dstRoiSize, pKernel, kernelSize, yAnchor, divisor);
    default:
        assert(false);
        return _refr_fwiFilterColumn_16s_C3R(pSrc, srcStep, pDst, dstStep, dstRoiSize, pKernel, kernelSize, yAnchor, divisor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiSqrt_8u_AC4RSfs( const Fw8u *pSrc,    int srcStep, Fw8u *pDst, int dstStep, FwiSize roiSize, int scaleFactor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiSqrt_8u_AC4RSfs(pSrc, srcStep, pDst, dstStep, roiSize, scaleFactor);
    case DT_SSE2:
        return _sse2_fwiSqrt_8u_AC4RSfs(pSrc, srcStep, pDst, dstStep, roiSize, scaleFactor);
    case DT_REFR:
        return _refr_fwiSqrt_8u_AC4RSfs(pSrc, srcStep, pDst, dstStep, roiSize, scaleFactor);
    default:
        assert(false);
        return _refr_fwiSqrt_8u_AC4RSfs(pSrc, srcStep, pDst, dstStep, roiSize, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiAddC_16sc_C1RSfs( const Fw16sc *pSrc, int srcStep,       Fw16sc value,    Fw16sc *pDst, int dstStep, FwiSize roiSize, int scaleFactor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiAddC_16sc_C1RSfs(pSrc, srcStep, value, pDst, dstStep, roiSize, scaleFactor);
    case DT_SSE2:
        return _sse2_fwiAddC_16sc_C1RSfs(pSrc, srcStep, value, pDst, dstStep, roiSize, scaleFactor);
    case DT_REFR:
        return _refr_fwiAddC_16sc_C1RSfs(pSrc, srcStep, value, pDst, dstStep, roiSize, scaleFactor);
    default:
        assert(false);
        return _refr_fwiAddC_16sc_C1RSfs(pSrc, srcStep, value, pDst, dstStep, roiSize, scaleFactor);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiMirror_32s_C4R( const Fw32s *pSrc, int srcStep, Fw32s *pDst, int dstStep, FwiSize roiSize, FwiAxis flip)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiMirror_32s_C4R(pSrc, srcStep, pDst, dstStep, roiSize, flip);
    case DT_REFR:
        return _refr_fwiMirror_32s_C4R(pSrc, srcStep, pDst, dstStep, roiSize, flip);
    default:
        assert(false);
        return _refr_fwiMirror_32s_C4R(pSrc, srcStep, pDst, dstStep, roiSize, flip);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiNot_8u_AC4R( const Fw8u   *pSrc, int srcStep,    Fw8u *pDst, int dstStep, FwiSize roiSize)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiNot_8u_AC4R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiNot_8u_AC4R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiNot_8u_AC4R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiNot_8u_AC4R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiOr_16u_AC4R( const Fw16u *pSrc1, int src1Step, const Fw16u *pSrc2,   int src2Step, Fw16u *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiOr_16u_AC4R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiOr_16u_AC4R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiOr_16u_AC4R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiOr_16u_AC4R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2         FwStatus fwiColorToGray_16u_C3C1R(const Fw16u* pSrc, int srcStep, Fw16u* pDst, int dstStep, FwiSize roiSize, const Fw32f coeffs[3])
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiColorToGray_16u_C3C1R(pSrc, srcStep, pDst, dstStep, roiSize, coeffs);
    case DT_REFR:
        return _refr_fwiColorToGray_16u_C3C1R(pSrc, srcStep, pDst, dstStep, roiSize, coeffs);
    default:
        assert(false);
        return _refr_fwiColorToGray_16u_C3C1R(pSrc, srcStep, pDst, dstStep, roiSize, coeffs);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiRemap_32f_C3R( const Fw32f* pSrc, FwiSize srcSize, int srcStep, FwiRect srcRoi, const Fw32f* pxMap, int xMapStep, const Fw32f* pyMap, int yMapStep, Fw32f* pDst, int dstStep, FwiSize dstRoiSize, int interpolation )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiRemap_32f_C3R(pSrc, srcSize, srcStep, srcRoi, pxMap, xMapStep, pyMap, yMapStep, pDst, dstStep, dstRoiSize, interpolation);
    case DT_REFR:
        return _refr_fwiRemap_32f_C3R(pSrc, srcSize, srcStep, srcRoi, pxMap, xMapStep, pyMap, yMapStep, pDst, dstStep, dstRoiSize, interpolation);
    default:
        assert(false);
        return _refr_fwiRemap_32f_C3R(pSrc, srcSize, srcStep, srcRoi, pxMap, xMapStep, pyMap, yMapStep, pDst, dstStep, dstRoiSize, interpolation);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiRotateCenter_8u_P4R( const Fw8u* const pSrc[4],FwiSize srcSize, int srcStep, FwiRect srcRoi, Fw8u* const pDst[4], int dstStep, FwiRect dstRoi, double angle, double xCenter, double yCenter, int interpolation )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiRotateCenter_8u_P4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, angle, xCenter, yCenter, interpolation);
    case DT_REFR:
        return _refr_fwiRotateCenter_8u_P4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, angle, xCenter, yCenter, interpolation);
    default:
        assert(false);
        return _refr_fwiRotateCenter_8u_P4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, angle, xCenter, yCenter, interpolation);
    }
}


OREFR OSSE2 FwStatus STDCALL fwiDilate3x3_8u_C1R(const Fw8u* pSrc, int srcStep, Fw8u* pDst, int dstStep, FwiSize roiSize)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiDilate3x3_8u_C1R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiDilate3x3_8u_C1R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiDilate3x3_8u_C1R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiThreshold_GTVal_32f_C4IR( Fw32f *pSrcDst, int srcDstStep, FwiSize roiSize, const Fw32f threshold[4], const Fw32f value[4])
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiThreshold_GTVal_32f_C4IR(pSrcDst, srcDstStep, roiSize, threshold, value);
    case DT_SSE2:
        return _sse2_fwiThreshold_GTVal_32f_C4IR(pSrcDst, srcDstStep, roiSize, threshold, value);
    case DT_REFR:
        return _refr_fwiThreshold_GTVal_32f_C4IR(pSrcDst, srcDstStep, roiSize, threshold, value);
    default:
        assert(false);
        return _refr_fwiThreshold_GTVal_32f_C4IR(pSrcDst, srcDstStep, roiSize, threshold, value);
    }
}


OREFR OSSE2 FwStatus STDCALL fwiFilterSharpen_8u_C1R( const Fw8u * pSrc, int srcStep, Fw8u * pDst, int dstStep, FwiSize dstRoiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilterSharpen_8u_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize);
    case DT_REFR:
        return _refr_fwiFilterSharpen_8u_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize);
    default:
        assert(false);
        return _refr_fwiFilterSharpen_8u_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize);
    }
}

OREFR OSSE2 FwStatus STDCALL fwiResizeShift_8u_P4R( const Fw8u* const pSrc[4], FwiSize srcSize, int srcStep, FwiRect srcRoi,
								 Fw8u* const pDst[4], int dstStep, FwiSize dstRoiSize,
								 double xFr, double yFr, double xShift, double yShift, int interpolation )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiResizeShift_8u_P4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoiSize, xFr, yFr, xShift, yShift, interpolation);
    case DT_REFR:
        return _refr_fwiResizeShift_8u_P4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoiSize, xFr, yFr, xShift, yShift, interpolation);
    default:
        assert(false);
        return _refr_fwiResizeShift_8u_P4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoiSize, xFr, yFr, xShift, yShift, interpolation);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiFilterSobelVert_8u_AC4R( const Fw8u * pSrc, int srcStep, Fw8u * pDst, int dstStep, FwiSize dstRoiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilterSobelVert_8u_AC4R(pSrc, srcStep, pDst, dstStep, dstRoiSize);
    case DT_REFR:
        return _refr_fwiFilterSobelVert_8u_AC4R(pSrc, srcStep, pDst, dstStep, dstRoiSize);
    default:
        assert(false);
        return _refr_fwiFilterSobelVert_8u_AC4R(pSrc, srcStep, pDst, dstStep, dstRoiSize);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiFilterMax_8u_AC4R( const Fw8u * pSrc, int srcStep,
                               Fw8u * pDst, int dstStep, FwiSize dstRoiSize,
                               FwiSize maskSize, FwiPoint anchor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilterMax_8u_AC4R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize, anchor);
    case DT_REFR:
        return _refr_fwiFilterMax_8u_AC4R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize, anchor);
    default:
        assert(false);
        return _refr_fwiFilterMax_8u_AC4R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize, anchor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiThreshold_LT_32f_C3R( const Fw32f *pSrc, int srcStep, Fw32f *pDst, int dstStep, FwiSize roiSize, const Fw32f threshold[3])
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiThreshold_LT_32f_C3R(pSrc, srcStep, pDst, dstStep, roiSize, threshold);
    case DT_SSE2:
        return _sse2_fwiThreshold_LT_32f_C3R(pSrc, srcStep, pDst, dstStep, roiSize, threshold);
    case DT_REFR:
        return _refr_fwiThreshold_LT_32f_C3R(pSrc, srcStep, pDst, dstStep, roiSize, threshold);
    default:
        assert(false);
        return _refr_fwiThreshold_LT_32f_C3R(pSrc, srcStep, pDst, dstStep, roiSize, threshold);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiRShiftC_8s_C3IR( const Fw32u value[3], Fw8s *pSrcDst, int srcDstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiRShiftC_8s_C3IR(value, pSrcDst, srcDstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiRShiftC_8s_C3IR(value, pSrcDst, srcDstStep, roiSize);
    case DT_REFR:
        return _refr_fwiRShiftC_8s_C3IR(value, pSrcDst, srcDstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiRShiftC_8s_C3IR(value, pSrcDst, srcDstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiXor_8u_C4IR( const Fw8u	*pSrc,  int srcStep,        Fw8u *pSrcDst, int srcDstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiXor_8u_C4IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiXor_8u_C4IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    case DT_REFR:
        return _refr_fwiXor_8u_C4IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiXor_8u_C4IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    }
}

OREFR             FwStatus STDCALL fwiConvert_16u32s_AC4R( const Fw16u *pSrc, int srcStep, Fw32s *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiConvert_16u32s_AC4R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiConvert_16u32s_AC4R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2         FwStatus fwiMax_16s_C1R(const Fw16s* pSrc, int srcStep,FwiSize roiSize, Fw16s* pMax)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiMax_16s_C1R(pSrc, srcStep, roiSize, pMax);
    case DT_REFR:
        return _refr_fwiMax_16s_C1R(pSrc, srcStep, roiSize, pMax);
    default:
        assert(false);
        return _refr_fwiMax_16s_C1R(pSrc, srcStep, roiSize, pMax);
    }
}

OREFR               FwStatus fwiRGBToYCC_32f_C3R( const Fw32f* pSrc, int srcStep, Fw32f* pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiRGBToYCC_32f_C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiRGBToYCC_32f_C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiSumWindowColumn_8u32f_C3R( const Fw8u * pSrc, int srcStep,
                               Fw32f * pDst, int dstStep, FwiSize dstRoiSize,
                               int maskSize, int anchor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiSumWindowColumn_8u32f_C3R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize, anchor);
    case DT_REFR:
        return _refr_fwiSumWindowColumn_8u32f_C3R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize, anchor);
    default:
        assert(false);
        return _refr_fwiSumWindowColumn_8u32f_C3R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize, anchor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiLShiftC_32s_C1IR(       Fw32u value,    Fw32s *pSrcDst, int srcDstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiLShiftC_32s_C1IR(value, pSrcDst, srcDstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiLShiftC_32s_C1IR(value, pSrcDst, srcDstStep, roiSize);
    case DT_REFR:
        return _refr_fwiLShiftC_32s_C1IR(value, pSrcDst, srcDstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiLShiftC_32s_C1IR(value, pSrcDst, srcDstStep, roiSize);
    }
}

OREFR OSSE2         FwStatus fwiMinMax_16s_AC4R(const Fw16s* pSrc, int srcStep,FwiSize roiSize, Fw16s min[3], Fw16s max[3])
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiMinMax_16s_AC4R(pSrc, srcStep, roiSize, min, max);
    case DT_REFR:
        return _refr_fwiMinMax_16s_AC4R(pSrc, srcStep, roiSize, min, max);
    default:
        assert(false);
        return _refr_fwiMinMax_16s_AC4R(pSrc, srcStep, roiSize, min, max);
    }
}

OREFR OSSE2 FwStatus STDCALL fwiWarpPerspectiveBack_32f_P4R( const Fw32f* const pSrc[4], FwiSize srcSize, int srcStep,
								FwiRect srcRoi, Fw32f* const pDst[4], int dstStep, FwiRect dstRoi,
								const double coeffs[3][3], int interpolation )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiWarpPerspectiveBack_32f_P4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, coeffs, interpolation);
    case DT_REFR:
        return _refr_fwiWarpPerspectiveBack_32f_P4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, coeffs, interpolation);
    default:
        assert(false);
        return _refr_fwiWarpPerspectiveBack_32f_P4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, coeffs, interpolation);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiMul_16sc_AC4RSfs( const Fw16sc *pSrc1, int src1Step, const Fw16sc *pSrc2,   int src2Step, Fw16sc *pDst, int dstStep, FwiSize roiSize, int scaleFactor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiMul_16sc_AC4RSfs(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, scaleFactor);
    case DT_SSE2:
        return _sse2_fwiMul_16sc_AC4RSfs(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, scaleFactor);
    case DT_REFR:
        return _refr_fwiMul_16sc_AC4RSfs(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, scaleFactor);
    default:
        assert(false);
        return _refr_fwiMul_16sc_AC4RSfs(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, scaleFactor);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiFilterHipass_32f_AC4R( const Fw32f * pSrc, int srcStep, Fw32f * pDst, int dstStep, FwiSize dstRoiSize, FwiMaskSize maskSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilterHipass_32f_AC4R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize);
    case DT_REFR:
        return _refr_fwiFilterHipass_32f_AC4R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize);
    default:
        assert(false);
        return _refr_fwiFilterHipass_32f_AC4R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiFilterMedianVert_16s_C3R( const Fw16s * pSrc, int srcStep,
                                               Fw16s * pDst, int dstStep, FwiSize dstRoiSize,
                                               FwiMaskSize maskSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilterMedianVert_16s_C3R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize);
    case DT_REFR:
        return _refr_fwiFilterMedianVert_16s_C3R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize);
    default:
        assert(false);
        return _refr_fwiFilterMedianVert_16s_C3R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiSub_32fc_C1IR( const Fw32fc *pSrc,  int srcStep,        Fw32fc *pSrcDst, int srcDstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiSub_32fc_C1IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiSub_32fc_C1IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    case DT_REFR:
        return _refr_fwiSub_32fc_C1IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiSub_32fc_C1IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiCompare_8u_AC4R( const Fw8u *pSrc1, int src1Step, const Fw8u *pSrc2, int src2Step, Fw8u *pDst, int dstStep, FwiSize roiSize, FwCmpOp fwCmpOp )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiCompare_8u_AC4R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, fwCmpOp);
    case DT_SSE2:
        return _sse2_fwiCompare_8u_AC4R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, fwCmpOp);
    case DT_REFR:
        return _refr_fwiCompare_8u_AC4R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, fwCmpOp);
    default:
        assert(false);
        return _refr_fwiCompare_8u_AC4R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, fwCmpOp);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiExp_32f_C1R( const Fw32f *pSrc, int srcStep, Fw32f *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiExp_32f_C1R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiExp_32f_C1R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiExp_32f_C1R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiExp_32f_C1R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiSubC_32f_C3R( const Fw32f *pSrc, int srcStep, const Fw32f value[3], Fw32f *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiSubC_32f_C3R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiSubC_32f_C3R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiSubC_32f_C3R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiSubC_32f_C3R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiThreshold_32f_C3R( const Fw32f *pSrc, int srcStep, Fw32f *pDst, int dstStep, FwiSize roiSize, const Fw32f threshold[3], FwCmpOp fwCmpOp)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiThreshold_32f_C3R(pSrc, srcStep, pDst, dstStep, roiSize, threshold, fwCmpOp);
    case DT_SSE2:
        return _sse2_fwiThreshold_32f_C3R(pSrc, srcStep, pDst, dstStep, roiSize, threshold, fwCmpOp);
    case DT_REFR:
        return _refr_fwiThreshold_32f_C3R(pSrc, srcStep, pDst, dstStep, roiSize, threshold, fwCmpOp);
    default:
        assert(false);
        return _refr_fwiThreshold_32f_C3R(pSrc, srcStep, pDst, dstStep, roiSize, threshold, fwCmpOp);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiSet_8u_C3R( const Fw8u  value[3], Fw8u  * pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiSet_8u_C3R(value, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiSet_8u_C3R(value, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiSet_8u_C3R(value, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiSet_8u_C3R(value, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiCopy_8u_C3MR( const Fw8u *pSrc, int srcStep, Fw8u *pDst, int dstStep, FwiSize roiSize, const Fw8u *pMask, int maskStep )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiCopy_8u_C3MR(pSrc, srcStep, pDst, dstStep, roiSize, pMask, maskStep);
    case DT_SSE2:
        return _sse2_fwiCopy_8u_C3MR(pSrc, srcStep, pDst, dstStep, roiSize, pMask, maskStep);
    case DT_REFR:
        return _refr_fwiCopy_8u_C3MR(pSrc, srcStep, pDst, dstStep, roiSize, pMask, maskStep);
    default:
        assert(false);
        return _refr_fwiCopy_8u_C3MR(pSrc, srcStep, pDst, dstStep, roiSize, pMask, maskStep);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiRotate_16u_P3R( const Fw16u* const pSrc[3], FwiSize srcSize, int srcStep, FwiRect srcRoi, Fw16u* const pDst[3], int dstStep, FwiRect dstRoi, double angle, double xShift, double yShift, int interpolation )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiRotate_16u_P3R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, angle, xShift, yShift, interpolation);
    case DT_REFR:
        return _refr_fwiRotate_16u_P3R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, angle, xShift, yShift, interpolation);
    default:
        assert(false);
        return _refr_fwiRotate_16u_P3R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, angle, xShift, yShift, interpolation);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiOr_8u_AC4R( const Fw8u *pSrc1, int src1Step, const Fw8u *pSrc2,   int src2Step, Fw8u *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiOr_8u_AC4R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiOr_8u_AC4R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiOr_8u_AC4R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiOr_8u_AC4R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    }
}

OREFR               FwStatus fwiLUVToRGB_32f_AC4R( const Fw32f* pSrc, int srcStep, Fw32f* pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiLUVToRGB_32f_AC4R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiLUVToRGB_32f_AC4R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiCopy_16s_C3P3R( const Fw16s *pSrc, int srcStep, Fw16s * const pDst[3], int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiCopy_16s_C3P3R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiCopy_16s_C3P3R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiCopy_16s_C3P3R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiCopy_16s_C3P3R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiSet_32s_AC4MR( const Fw32s  value[3], Fw32s  * pDst, int dstStep, FwiSize roiSize, const Fw8u * pMask, int maskStep )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiSet_32s_AC4MR(value, pDst, dstStep, roiSize, pMask, maskStep);
    case DT_SSE2:
        return _sse2_fwiSet_32s_AC4MR(value, pDst, dstStep, roiSize, pMask, maskStep);
    case DT_REFR:
        return _refr_fwiSet_32s_AC4MR(value, pDst, dstStep, roiSize, pMask, maskStep);
    default:
        assert(false);
        return _refr_fwiSet_32s_AC4MR(value, pDst, dstStep, roiSize, pMask, maskStep);
    }
}

OREFR               FwStatus fwiYCbCr420ToBGR444_8u16u_P3C3R(const A8U* const pSrc[3], int srcStep[3], A16U* pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiYCbCr420ToBGR444_8u16u_P3C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiYCbCr420ToBGR444_8u16u_P3C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiSet_32s_C1MR(       Fw32s  value,    Fw32s  * pDst, int dstStep, FwiSize roiSize, const Fw8u * pMask, int maskStep )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiSet_32s_C1MR(value, pDst, dstStep, roiSize, pMask, maskStep);
    case DT_SSE2:
        return _sse2_fwiSet_32s_C1MR(value, pDst, dstStep, roiSize, pMask, maskStep);
    case DT_REFR:
        return _refr_fwiSet_32s_C1MR(value, pDst, dstStep, roiSize, pMask, maskStep);
    default:
        assert(false);
        return _refr_fwiSet_32s_C1MR(value, pDst, dstStep, roiSize, pMask, maskStep);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiThreshold_LT_8u_AC4IR( Fw8u *pSrcDst, int srcDstStep, FwiSize roiSize, const Fw8u threshold[3])
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiThreshold_LT_8u_AC4IR(pSrcDst, srcDstStep, roiSize, threshold);
    case DT_SSE2:
        return _sse2_fwiThreshold_LT_8u_AC4IR(pSrcDst, srcDstStep, roiSize, threshold);
    case DT_REFR:
        return _refr_fwiThreshold_LT_8u_AC4IR(pSrcDst, srcDstStep, roiSize, threshold);
    default:
        assert(false);
        return _refr_fwiThreshold_LT_8u_AC4IR(pSrcDst, srcDstStep, roiSize, threshold);
    }
}

OREFR       FwStatus STDCALL fwiResizeSqrPixel_16u_C3R(const Fw16u* pSrc, FwiSize srcSize, int srcStep, FwiRect srcRoi,
			Fw16u* pDst, int dstStep, FwiRect dstRoi, double xFactor, double yFactor,
			double xShift, double yShift, int interpolation, Fw8u* pBuffer)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiResizeSqrPixel_16u_C3R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, xFactor, yFactor, xShift, yShift, interpolation, pBuffer);
    default:
        assert(false);
        return _refr_fwiResizeSqrPixel_16u_C3R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, xFactor, yFactor, xShift, yShift, interpolation, pBuffer);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiMulC_8u_AC4IRSfs( const Fw8u value[3], Fw8u *pSrcDst, int srcDstStep, FwiSize roiSize, int scaleFactor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiMulC_8u_AC4IRSfs(value, pSrcDst, srcDstStep, roiSize, scaleFactor);
    case DT_SSE2:
        return _sse2_fwiMulC_8u_AC4IRSfs(value, pSrcDst, srcDstStep, roiSize, scaleFactor);
    case DT_REFR:
        return _refr_fwiMulC_8u_AC4IRSfs(value, pSrcDst, srcDstStep, roiSize, scaleFactor);
    default:
        assert(false);
        return _refr_fwiMulC_8u_AC4IRSfs(value, pSrcDst, srcDstStep, roiSize, scaleFactor);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiFilterRow_16s_AC4R( const Fw16s * pSrc, int srcStep,
                              Fw16s * pDst, int dstStep, FwiSize dstRoiSize,
                              const Fw32s * pKernel, int kernelSize,
                              int xAnchor, int divisor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilterRow_16s_AC4R(pSrc, srcStep, pDst, dstStep, dstRoiSize, pKernel, kernelSize, xAnchor, divisor);
    case DT_REFR:
        return _refr_fwiFilterRow_16s_AC4R(pSrc, srcStep, pDst, dstStep, dstRoiSize, pKernel, kernelSize, xAnchor, divisor);
    default:
        assert(false);
        return _refr_fwiFilterRow_16s_AC4R(pSrc, srcStep, pDst, dstStep, dstRoiSize, pKernel, kernelSize, xAnchor, divisor);
    }
}

OREFR               FwStatus fwiRGBToYUV422_8u_P3R( const A8U* const pSrc[3], int srcStep, A8U* pDst[3], int dstStep[3], FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiRGBToYUV422_8u_P3R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiRGBToYUV422_8u_P3R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiFilterRow32f_16s_AC4R( const Fw16s * pSrc, int srcStep,
                                 Fw16s * pDst, int dstStep, FwiSize dstRoiSize,
                                const Fw32f * pKernel, int kernelSize,
                                int xAnchor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilterRow32f_16s_AC4R(pSrc, srcStep, pDst, dstStep, dstRoiSize, pKernel, kernelSize, xAnchor);
    case DT_REFR:
        return _refr_fwiFilterRow32f_16s_AC4R(pSrc, srcStep, pDst, dstStep, dstRoiSize, pKernel, kernelSize, xAnchor);
    default:
        assert(false);
        return _refr_fwiFilterRow32f_16s_AC4R(pSrc, srcStep, pDst, dstStep, dstRoiSize, pKernel, kernelSize, xAnchor);
    }
}

OREFR             FwStatus STDCALL fwiScale_32s8u_C3R( const Fw32s * pSrc, int srcStep, Fw8u * pDst, int dstStep, FwiSize roiSize, FwHintAlgorithm hint )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiScale_32s8u_C3R(pSrc, srcStep, pDst, dstStep, roiSize, hint);
    default:
        assert(false);
        return _refr_fwiScale_32s8u_C3R(pSrc, srcStep, pDst, dstStep, roiSize, hint);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiRotateCenter_16u_P4R( const Fw16u* const pSrc[4],FwiSize srcSize, int srcStep, FwiRect srcRoi, Fw16u* const pDst[4], int dstStep, FwiRect dstRoi, double angle, double xCenter, double yCenter, int interpolation )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiRotateCenter_16u_P4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, angle, xCenter, yCenter, interpolation);
    case DT_REFR:
        return _refr_fwiRotateCenter_16u_P4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, angle, xCenter, yCenter, interpolation);
    default:
        assert(false);
        return _refr_fwiRotateCenter_16u_P4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, angle, xCenter, yCenter, interpolation);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiMul_32sc_C3IRSfs( const Fw32sc *pSrc,  int srcStep,        Fw32sc *pSrcDst, int srcDstStep, FwiSize roiSize, int scaleFactor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiMul_32sc_C3IRSfs(pSrc, srcStep, pSrcDst, srcDstStep, roiSize, scaleFactor);
    case DT_SSE2:
        return _sse2_fwiMul_32sc_C3IRSfs(pSrc, srcStep, pSrcDst, srcDstStep, roiSize, scaleFactor);
    case DT_REFR:
        return _refr_fwiMul_32sc_C3IRSfs(pSrc, srcStep, pSrcDst, srcDstStep, roiSize, scaleFactor);
    default:
        assert(false);
        return _refr_fwiMul_32sc_C3IRSfs(pSrc, srcStep, pSrcDst, srcDstStep, roiSize, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiAbs_32f_C4IR( Fw32f *pSrcDst, int srcDstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiAbs_32f_C4IR(pSrcDst, srcDstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiAbs_32f_C4IR(pSrcDst, srcDstStep, roiSize);
    case DT_REFR:
        return _refr_fwiAbs_32f_C4IR(pSrcDst, srcDstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiAbs_32f_C4IR(pSrcDst, srcDstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiRShiftC_8s_C1IR(       Fw32u value,    Fw8s *pSrcDst, int srcDstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiRShiftC_8s_C1IR(value, pSrcDst, srcDstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiRShiftC_8s_C1IR(value, pSrcDst, srcDstStep, roiSize);
    case DT_REFR:
        return _refr_fwiRShiftC_8s_C1IR(value, pSrcDst, srcDstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiRShiftC_8s_C1IR(value, pSrcDst, srcDstStep, roiSize);
    }
}

OREFR             FwStatus STDCALL fwiCopy_32f_C3AC4R( const Fw32f *pSrc, int srcStep, Fw32f *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiCopy_32f_C3AC4R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiCopy_32f_C3AC4R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 FwStatus STDCALL fwiResize_32f_C1R( const Fw32f* pSrc, FwiSize srcSize, int srcStep, FwiRect srcRoi,
							 Fw32f* pDst, int dstStep, FwiSize dstRoiSize,
							 double xFactor, double yFactor, int interpolation )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiResize_32f_C1R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoiSize, xFactor, yFactor, interpolation);
    case DT_REFR:
        return _refr_fwiResize_32f_C1R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoiSize, xFactor, yFactor, interpolation);
    default:
        assert(false);
        return _refr_fwiResize_32f_C1R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoiSize, xFactor, yFactor, interpolation);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiAddC_32f_AC4IR( const Fw32f value[3], Fw32f *pSrcDst, int srcDstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiAddC_32f_AC4IR(value, pSrcDst, srcDstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiAddC_32f_AC4IR(value, pSrcDst, srcDstStep, roiSize);
    case DT_REFR:
        return _refr_fwiAddC_32f_AC4IR(value, pSrcDst, srcDstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiAddC_32f_AC4IR(value, pSrcDst, srcDstStep, roiSize);
    }
}

OREFR       FwStatus STDCALL fwiMirror_32f_C1R( const Fw32f *pSrc, int srcStep, Fw32f *pDst, int dstStep, FwiSize roiSize, FwiAxis flip)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiMirror_32f_C1R(pSrc, srcStep, pDst, dstStep, roiSize, flip);
    default:
        assert(false);
        return _refr_fwiMirror_32f_C1R(pSrc, srcStep, pDst, dstStep, roiSize, flip);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiThreshold_32f_C3IR( Fw32f *pSrcDst, int srcDstStep, FwiSize roiSize, const Fw32f threshold[3], FwCmpOp fwCmpOp)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiThreshold_32f_C3IR(pSrcDst, srcDstStep, roiSize, threshold, fwCmpOp);
    case DT_SSE2:
        return _sse2_fwiThreshold_32f_C3IR(pSrcDst, srcDstStep, roiSize, threshold, fwCmpOp);
    case DT_REFR:
        return _refr_fwiThreshold_32f_C3IR(pSrcDst, srcDstStep, roiSize, threshold, fwCmpOp);
    default:
        assert(false);
        return _refr_fwiThreshold_32f_C3IR(pSrcDst, srcDstStep, roiSize, threshold, fwCmpOp);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiFilterHipass_8u_C3R( const Fw8u * pSrc, int srcStep, Fw8u * pDst, int dstStep, FwiSize dstRoiSize, FwiMaskSize maskSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilterHipass_8u_C3R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize);
    case DT_REFR:
        return _refr_fwiFilterHipass_8u_C3R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize);
    default:
        assert(false);
        return _refr_fwiFilterHipass_8u_C3R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiSubC_32f_C1IR(       Fw32f value,    Fw32f *pSrcDst, int srcDstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiSubC_32f_C1IR(value, pSrcDst, srcDstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiSubC_32f_C1IR(value, pSrcDst, srcDstStep, roiSize);
    case DT_REFR:
        return _refr_fwiSubC_32f_C1IR(value, pSrcDst, srcDstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiSubC_32f_C1IR(value, pSrcDst, srcDstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiConvert_32s8s_C4R( const Fw32s *pSrc, int srcStep, Fw8s *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiConvert_32s8s_C4R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiConvert_32s8s_C4R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiConvert_32s8s_C4R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiConvert_32s8s_C4R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 FwStatus STDCALL fwiResizeShift_16u_P3R( const Fw16u* const pSrc[3], FwiSize srcSize, int srcStep, FwiRect srcRoi,
								  Fw16u* const pDst[3], int dstStep, FwiSize dstRoiSize,
								  double xFr, double yFr, double xShift, double yShift, int interpolation )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiResizeShift_16u_P3R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoiSize, xFr, yFr, xShift, yShift, interpolation);
    case DT_REFR:
        return _refr_fwiResizeShift_16u_P3R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoiSize, xFr, yFr, xShift, yShift, interpolation);
    default:
        assert(false);
        return _refr_fwiResizeShift_16u_P3R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoiSize, xFr, yFr, xShift, yShift, interpolation);
    }
}


OREFR OSSE2 FwStatus STDCALL fwiResize_8u_C1R( const Fw8u* pSrc, FwiSize srcSize, int srcStep, FwiRect srcRoi,
							 Fw8u* pDst, int dstStep, FwiSize dstRoiSize,
							 double xFactor, double yFactor, int interpolation )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiResize_8u_C1R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoiSize, xFactor, yFactor, interpolation);
    case DT_REFR:
        return _refr_fwiResize_8u_C1R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoiSize, xFactor, yFactor, interpolation);
    default:
        assert(false);
        return _refr_fwiResize_8u_C1R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoiSize, xFactor, yFactor, interpolation);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiFilterSobelVert_8u_C3R( const Fw8u * pSrc, int srcStep, Fw8u * pDst, int dstStep, FwiSize dstRoiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilterSobelVert_8u_C3R(pSrc, srcStep, pDst, dstStep, dstRoiSize);
    case DT_REFR:
        return _refr_fwiFilterSobelVert_8u_C3R(pSrc, srcStep, pDst, dstStep, dstRoiSize);
    default:
        assert(false);
        return _refr_fwiFilterSobelVert_8u_C3R(pSrc, srcStep, pDst, dstStep, dstRoiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiAdd_16u32f_C1IR( const Fw16u *pSrc, int srcStep, Fw32f *pSrcDst, int srcDstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiAdd_16u32f_C1IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiAdd_16u32f_C1IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    case DT_REFR:
        return _refr_fwiAdd_16u32f_C1IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiAdd_16u32f_C1IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    }
}

OREFR               FwStatus fwiBGRToHLS_8u_AP4R( const A8U* const pSrc[4], int srcStep, A8U* const pDst[4], int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiBGRToHLS_8u_AP4R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiBGRToHLS_8u_AP4R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiCopy_32f_C4P4R( const Fw32f * pSrc, int srcStep, Fw32f * const pDst[4], int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiCopy_32f_C4P4R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiCopy_32f_C4P4R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiCopy_32f_C4P4R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiCopy_32f_C4P4R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiFilterRobertsUp_8u_AC4R( const Fw8u * pSrc, int srcStep, Fw8u * pDst, int dstStep, FwiSize dstRoiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilterRobertsUp_8u_AC4R(pSrc, srcStep, pDst, dstStep, dstRoiSize);
    case DT_REFR:
        return _refr_fwiFilterRobertsUp_8u_AC4R(pSrc, srcStep, pDst, dstStep, dstRoiSize);
    default:
        assert(false);
        return _refr_fwiFilterRobertsUp_8u_AC4R(pSrc, srcStep, pDst, dstStep, dstRoiSize);
    }
}

OREFR               FwStatus fwiLookUp3DSpecFree(FwiLUTSpec* pLUTSpec)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiLookUp3DSpecFree(pLUTSpec);
    default:
        assert(false);
        return _refr_fwiLookUp3DSpecFree(pLUTSpec);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiMulC_32sc_AC4IRSfs( const Fw32sc value[3], Fw32sc *pSrcDst, int srcDstStep, FwiSize roiSize, int scaleFactor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiMulC_32sc_AC4IRSfs(value, pSrcDst, srcDstStep, roiSize, scaleFactor);
    case DT_SSE2:
        return _sse2_fwiMulC_32sc_AC4IRSfs(value, pSrcDst, srcDstStep, roiSize, scaleFactor);
    case DT_REFR:
        return _refr_fwiMulC_32sc_AC4IRSfs(value, pSrcDst, srcDstStep, roiSize, scaleFactor);
    default:
        assert(false);
        return _refr_fwiMulC_32sc_AC4IRSfs(value, pSrcDst, srcDstStep, roiSize, scaleFactor);
    }
}

OREFR OSSE2 FwStatus STDCALL fwiResizeCenter_8u_C1R( const Fw8u* pSrc, FwiSize srcSize, int srcStep, FwiRect srcRoi,
								  Fw8u* pDst, int dstStep, FwiSize dstRoiSize,
								  double xFactor, double yFactor, double xCenter, double yCenter, int interpolation )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiResizeCenter_8u_C1R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoiSize, xFactor, yFactor, xCenter, yCenter, interpolation);
    case DT_REFR:
        return _refr_fwiResizeCenter_8u_C1R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoiSize, xFactor, yFactor, xCenter, yCenter, interpolation);
    default:
        assert(false);
        return _refr_fwiResizeCenter_8u_C1R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoiSize, xFactor, yFactor, xCenter, yCenter, interpolation);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiSqr_16u_C4RSfs( const Fw16u *pSrc,    int srcStep, Fw16u *pDst, int dstStep, FwiSize roiSize, int scaleFactor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiSqr_16u_C4RSfs(pSrc, srcStep, pDst, dstStep, roiSize, scaleFactor);
    case DT_SSE2:
        return _sse2_fwiSqr_16u_C4RSfs(pSrc, srcStep, pDst, dstStep, roiSize, scaleFactor);
    case DT_REFR:
        return _refr_fwiSqr_16u_C4RSfs(pSrc, srcStep, pDst, dstStep, roiSize, scaleFactor);
    default:
        assert(false);
        return _refr_fwiSqr_16u_C4RSfs(pSrc, srcStep, pDst, dstStep, roiSize, scaleFactor);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiFilterPrewittHoriz_16s_C3R( const Fw16s * pSrc, int srcStep, Fw16s * pDst, int dstStep, FwiSize dstRoiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilterPrewittHoriz_16s_C3R(pSrc, srcStep, pDst, dstStep, dstRoiSize);
    case DT_REFR:
        return _refr_fwiFilterPrewittHoriz_16s_C3R(pSrc, srcStep, pDst, dstStep, dstRoiSize);
    default:
        assert(false);
        return _refr_fwiFilterPrewittHoriz_16s_C3R(pSrc, srcStep, pDst, dstStep, dstRoiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiAddC_16s_C4IRSfs( const Fw16s value[4], Fw16s *pSrcDst, int srcDstStep, FwiSize roiSize, int scaleFactor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiAddC_16s_C4IRSfs(value, pSrcDst, srcDstStep, roiSize, scaleFactor);
    case DT_SSE2:
        return _sse2_fwiAddC_16s_C4IRSfs(value, pSrcDst, srcDstStep, roiSize, scaleFactor);
    case DT_REFR:
        return _refr_fwiAddC_16s_C4IRSfs(value, pSrcDst, srcDstStep, roiSize, scaleFactor);
    default:
        assert(false);
        return _refr_fwiAddC_16s_C4IRSfs(value, pSrcDst, srcDstStep, roiSize, scaleFactor);
    }
}

OREFR               FwStatus fwiRGBToXYZ_32f_C3R( const Fw32f* pSrc, int srcStep, Fw32f* pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiRGBToXYZ_32f_C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiRGBToXYZ_32f_C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 FwStatus STDCALL fwiDCT8x8Inv_16s_C1(const Fw16s* pSrc, Fw16s* pDst)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiDCT8x8Inv_16s_C1(pSrc, pDst);
    case DT_REFR:
        return _refr_fwiDCT8x8Inv_16s_C1(pSrc, pDst);
    default:
        assert(false);
        return _refr_fwiDCT8x8Inv_16s_C1(pSrc, pDst);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiThreshold_GTVal_8u_C1R( const Fw8u *pSrc, int srcStep, Fw8u *pDst, int dstStep, FwiSize roiSize, Fw8u threshold, Fw8u value)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiThreshold_GTVal_8u_C1R(pSrc, srcStep, pDst, dstStep, roiSize, threshold, value);
    case DT_SSE2:
        return _sse2_fwiThreshold_GTVal_8u_C1R(pSrc, srcStep, pDst, dstStep, roiSize, threshold, value);
    case DT_REFR:
        return _refr_fwiThreshold_GTVal_8u_C1R(pSrc, srcStep, pDst, dstStep, roiSize, threshold, value);
    default:
        assert(false);
        return _refr_fwiThreshold_GTVal_8u_C1R(pSrc, srcStep, pDst, dstStep, roiSize, threshold, value);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiMulCScale_16u_C1R( const Fw16u *pSrc, int srcStep,       Fw16u value,    Fw16u *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiMulCScale_16u_C1R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiMulCScale_16u_C1R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiMulCScale_16u_C1R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiMulCScale_16u_C1R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiCopy_32s_C3C1R( const Fw32s *pSrc, int srcStep, Fw32s *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiCopy_32s_C3C1R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiCopy_32s_C3C1R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiCopy_32s_C3C1R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiCopy_32s_C3C1R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}


OREFR OSSE2 FwStatus STDCALL fwiWarpPerspectiveQuad_8u_C1R( const Fw8u* pSrc, FwiSize srcSize, int srcStep, FwiRect srcRoi,
							        const double srcQuad[4][2], Fw8u* pDst, int dstStep, FwiRect dstRoi,
									const double dstQuad[4][2], int interpolation )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiWarpPerspectiveQuad_8u_C1R(pSrc, srcSize, srcStep, srcRoi, srcQuad, pDst, dstStep, dstRoi, dstQuad, interpolation);
    case DT_REFR:
        return _refr_fwiWarpPerspectiveQuad_8u_C1R(pSrc, srcSize, srcStep, srcRoi, srcQuad, pDst, dstStep, dstRoi, dstQuad, interpolation);
    default:
        assert(false);
        return _refr_fwiWarpPerspectiveQuad_8u_C1R(pSrc, srcSize, srcStep, srcRoi, srcQuad, pDst, dstStep, dstRoi, dstQuad, interpolation);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiAndC_8u_AC4IR( const Fw8u value[3], Fw8u *pSrcDst, int srcDstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiAndC_8u_AC4IR(value, pSrcDst, srcDstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiAndC_8u_AC4IR(value, pSrcDst, srcDstStep, roiSize);
    case DT_REFR:
        return _refr_fwiAndC_8u_AC4IR(value, pSrcDst, srcDstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiAndC_8u_AC4IR(value, pSrcDst, srcDstStep, roiSize);
    }
}

OREFR OSSE2         FwStatus fwiMin_32f_C3R(const Fw32f* pSrc, int srcStep,FwiSize roiSize, Fw32f min[3])
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiMin_32f_C3R(pSrc, srcStep, roiSize, min);
    case DT_REFR:
        return _refr_fwiMin_32f_C3R(pSrc, srcStep, roiSize, min);
    default:
        assert(false);
        return _refr_fwiMin_32f_C3R(pSrc, srcStep, roiSize, min);
    }
}

OREFR OSSE2 FwStatus STDCALL fwiWarpPerspectiveQuad_32f_C4R( const Fw32f* pSrc, FwiSize srcSize, int srcStep, FwiRect srcRoi,
							        const double srcQuad[4][2], Fw32f* pDst, int dstStep, FwiRect dstRoi,
									const double dstQuad[4][2], int interpolation )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiWarpPerspectiveQuad_32f_C4R(pSrc, srcSize, srcStep, srcRoi, srcQuad, pDst, dstStep, dstRoi, dstQuad, interpolation);
    case DT_REFR:
        return _refr_fwiWarpPerspectiveQuad_32f_C4R(pSrc, srcSize, srcStep, srcRoi, srcQuad, pDst, dstStep, dstRoi, dstQuad, interpolation);
    default:
        assert(false);
        return _refr_fwiWarpPerspectiveQuad_32f_C4R(pSrc, srcSize, srcStep, srcRoi, srcQuad, pDst, dstStep, dstRoi, dstQuad, interpolation);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiRShiftC_8s_C4R( const Fw8s   *pSrc, int srcStep, const Fw32u value[4], Fw8s *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiRShiftC_8s_C4R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiRShiftC_8s_C4R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiRShiftC_8s_C4R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiRShiftC_8s_C4R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiAddProduct_16u32f_C1IMR( const Fw16u *pSrc1, int src1Step, const Fw16u *pSrc2, int src2Step, const Fw8u* pMask, int maskStep, Fw32f *pSrcDst, int srcDstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiAddProduct_16u32f_C1IMR(pSrc1, src1Step, pSrc2, src2Step, pMask, maskStep, pSrcDst, srcDstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiAddProduct_16u32f_C1IMR(pSrc1, src1Step, pSrc2, src2Step, pMask, maskStep, pSrcDst, srcDstStep, roiSize);
    case DT_REFR:
        return _refr_fwiAddProduct_16u32f_C1IMR(pSrc1, src1Step, pSrc2, src2Step, pMask, maskStep, pSrcDst, srcDstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiAddProduct_16u32f_C1IMR(pSrc1, src1Step, pSrc2, src2Step, pMask, maskStep, pSrcDst, srcDstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiXorC_32s_C1R( const Fw32s  *pSrc, int srcStep,       Fw32s value,    Fw32s *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiXorC_32s_C1R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiXorC_32s_C1R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiXorC_32s_C1R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiXorC_32s_C1R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiCopy_32f_C4R( const Fw32f *pSrc, int srcStep, Fw32f *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiCopy_32f_C4R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiCopy_32f_C4R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiCopy_32f_C4R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiCopy_32f_C4R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiRemap_32f_P3R( const Fw32f* const pSrc[3], FwiSize srcSize, int srcStep, FwiRect srcRoi, const Fw32f* pxMap, int xMapStep, const Fw32f* pyMap, int yMapStep, Fw32f* const pDst[3], int dstStep, FwiSize dstRoiSize, int interpolation )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiRemap_32f_P3R(pSrc, srcSize, srcStep, srcRoi, pxMap, xMapStep, pyMap, yMapStep, pDst, dstStep, dstRoiSize, interpolation);
    case DT_REFR:
        return _refr_fwiRemap_32f_P3R(pSrc, srcSize, srcStep, srcRoi, pxMap, xMapStep, pyMap, yMapStep, pDst, dstStep, dstRoiSize, interpolation);
    default:
        assert(false);
        return _refr_fwiRemap_32f_P3R(pSrc, srcSize, srcStep, srcRoi, pxMap, xMapStep, pyMap, yMapStep, pDst, dstStep, dstRoiSize, interpolation);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiThreshold_LT_8u_AC4R( const Fw8u *pSrc, int srcStep, Fw8u *pDst, int dstStep, FwiSize roiSize, const Fw8u threshold[3])
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiThreshold_LT_8u_AC4R(pSrc, srcStep, pDst, dstStep, roiSize, threshold);
    case DT_SSE2:
        return _sse2_fwiThreshold_LT_8u_AC4R(pSrc, srcStep, pDst, dstStep, roiSize, threshold);
    case DT_REFR:
        return _refr_fwiThreshold_LT_8u_AC4R(pSrc, srcStep, pDst, dstStep, roiSize, threshold);
    default:
        assert(false);
        return _refr_fwiThreshold_LT_8u_AC4R(pSrc, srcStep, pDst, dstStep, roiSize, threshold);
    }
}


OREFR OSSE2         FwStatus fwiMax_8u_AC4R(const Fw8u* pSrc, int srcStep,FwiSize roiSize, Fw8u max[3])
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiMax_8u_AC4R(pSrc, srcStep, roiSize, max);
    case DT_REFR:
        return _refr_fwiMax_8u_AC4R(pSrc, srcStep, roiSize, max);
    default:
        assert(false);
        return _refr_fwiMax_8u_AC4R(pSrc, srcStep, roiSize, max);
    }
}

OREFR OSSE2 FwStatus STDCALL fwiWarpAffine_32f_P4R( const Fw32f* const pSrc[4], FwiSize srcSize, int srcStep,
								FwiRect srcRoi, Fw32f* const pDst[4], int dstStep, FwiRect dstRoi,
								const double coeffs[2][3], int interpolation )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiWarpAffine_32f_P4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, coeffs, interpolation);
    case DT_REFR:
        return _refr_fwiWarpAffine_32f_P4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, coeffs, interpolation);
    default:
        assert(false);
        return _refr_fwiWarpAffine_32f_P4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, coeffs, interpolation);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiSubC_32f_AC4R( const Fw32f *pSrc, int srcStep, const Fw32f value[3], Fw32f *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiSubC_32f_AC4R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiSubC_32f_AC4R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiSubC_32f_AC4R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiSubC_32f_AC4R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiFilterColumn32f_16s_C4R( const Fw16s * pSrc, int srcStep,
                                 Fw16s * pDst, int dstStep, FwiSize dstRoiSize,
                                const Fw32f * pKernel, int kernelSize,
                                int yAnchor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilterColumn32f_16s_C4R(pSrc, srcStep, pDst, dstStep, dstRoiSize, pKernel, kernelSize, yAnchor);
    case DT_REFR:
        return _refr_fwiFilterColumn32f_16s_C4R(pSrc, srcStep, pDst, dstStep, dstRoiSize, pKernel, kernelSize, yAnchor);
    default:
        assert(false);
        return _refr_fwiFilterColumn32f_16s_C4R(pSrc, srcStep, pDst, dstStep, dstRoiSize, pKernel, kernelSize, yAnchor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiSet_16s_C3R( const Fw16s  value[3], Fw16s  * pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiSet_16s_C3R(value, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiSet_16s_C3R(value, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiSet_16s_C3R(value, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiSet_16s_C3R(value, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiThreshold_LTVal_16s_C1IR( Fw16s *pSrcDst, int srcDstStep, FwiSize roiSize, Fw16s threshold, Fw16s value)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiThreshold_LTVal_16s_C1IR(pSrcDst, srcDstStep, roiSize, threshold, value);
    case DT_SSE2:
        return _sse2_fwiThreshold_LTVal_16s_C1IR(pSrcDst, srcDstStep, roiSize, threshold, value);
    case DT_REFR:
        return _refr_fwiThreshold_LTVal_16s_C1IR(pSrcDst, srcDstStep, roiSize, threshold, value);
    default:
        assert(false);
        return _refr_fwiThreshold_LTVal_16s_C1IR(pSrcDst, srcDstStep, roiSize, threshold, value);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiOr_32s_AC4IR( const Fw32s *pSrc,  int srcStep,        Fw32s *pSrcDst, int srcDstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiOr_32s_AC4IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiOr_32s_AC4IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    case DT_REFR:
        return _refr_fwiOr_32s_AC4IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiOr_32s_AC4IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiMulC_32fc_C1R( const Fw32fc *pSrc, int srcStep,       Fw32fc value,    Fw32fc *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiMulC_32fc_C1R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiMulC_32fc_C1R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiMulC_32fc_C1R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiMulC_32fc_C1R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    }
}


OREFR OSSE2       FwStatus STDCALL fwiFilterHipass_8u_C1R( const Fw8u * pSrc, int srcStep, Fw8u * pDst, int dstStep, FwiSize dstRoiSize, FwiMaskSize maskSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilterHipass_8u_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize);
    case DT_REFR:
        return _refr_fwiFilterHipass_8u_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize);
    default:
        assert(false);
        return _refr_fwiFilterHipass_8u_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiThreshold_GTVal_16s_C1IR( Fw16s *pSrcDst, int srcDstStep, FwiSize roiSize, Fw16s threshold, Fw16s value)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiThreshold_GTVal_16s_C1IR(pSrcDst, srcDstStep, roiSize, threshold, value);
    case DT_SSE2:
        return _sse2_fwiThreshold_GTVal_16s_C1IR(pSrcDst, srcDstStep, roiSize, threshold, value);
    case DT_REFR:
        return _refr_fwiThreshold_GTVal_16s_C1IR(pSrcDst, srcDstStep, roiSize, threshold, value);
    default:
        assert(false);
        return _refr_fwiThreshold_GTVal_16s_C1IR(pSrcDst, srcDstStep, roiSize, threshold, value);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiConvert_32f8u_C1R( const Fw32f *pSrc, int srcStep, Fw8u *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiConvert_32f8u_C1R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiConvert_32f8u_C1R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiConvert_32f8u_C1R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiConvert_32f8u_C1R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiFilterSobelHorizSecond_8u16s_C1R( const Fw8u * pSrc, int srcStep, Fw16s * pDst, int dstStep, FwiSize dstRoiSize, FwiMaskSize mask )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilterSobelHorizSecond_8u16s_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize, mask);
    case DT_REFR:
        return _refr_fwiFilterSobelHorizSecond_8u16s_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize, mask);
    default:
        assert(false);
        return _refr_fwiFilterSobelHorizSecond_8u16s_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize, mask);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiFilter_32f_C4R( const Fw32f * pSrc, int srcStep,
                              Fw32f * pDst, int dstStep, FwiSize dstRoiSize,
                              const Fw32f * pKernel, FwiSize kernelSize,
                              FwiPoint anchor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilter_32f_C4R(pSrc, srcStep, pDst, dstStep, dstRoiSize, pKernel, kernelSize, anchor);
    case DT_REFR:
        return _refr_fwiFilter_32f_C4R(pSrc, srcStep, pDst, dstStep, dstRoiSize, pKernel, kernelSize, anchor);
    default:
        assert(false);
        return _refr_fwiFilter_32f_C4R(pSrc, srcStep, pDst, dstStep, dstRoiSize, pKernel, kernelSize, anchor);
    }
}

OREFR OSSE2 FwStatus STDCALL fwiResizeShift_8u_AC4R( const Fw8u* pSrc, FwiSize srcSize, int srcStep, FwiRect srcRoi,
								  Fw8u* pDst, int dstStep, FwiSize dstRoiSize,
								  double xFr, double yFr, double xShift, double yShift, int interpolation )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiResizeShift_8u_AC4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoiSize, xFr, yFr, xShift, yShift, interpolation);
    case DT_REFR:
        return _refr_fwiResizeShift_8u_AC4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoiSize, xFr, yFr, xShift, yShift, interpolation);
    default:
        assert(false);
        return _refr_fwiResizeShift_8u_AC4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoiSize, xFr, yFr, xShift, yShift, interpolation);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiLShiftC_32s_C1R( const Fw32s  *pSrc, int srcStep,       Fw32u value,    Fw32s *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiLShiftC_32s_C1R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiLShiftC_32s_C1R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiLShiftC_32s_C1R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiLShiftC_32s_C1R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiConvert_32s8u_AC4R( const Fw32s *pSrc, int srcStep, Fw8u *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiConvert_32s8u_AC4R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiConvert_32s8u_AC4R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiConvert_32s8u_AC4R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiConvert_32s8u_AC4R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiAddC_16s_AC4IRSfs( const Fw16s value[3], Fw16s *pSrcDst, int srcDstStep, FwiSize roiSize, int scaleFactor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiAddC_16s_AC4IRSfs(value, pSrcDst, srcDstStep, roiSize, scaleFactor);
    case DT_SSE2:
        return _sse2_fwiAddC_16s_AC4IRSfs(value, pSrcDst, srcDstStep, roiSize, scaleFactor);
    case DT_REFR:
        return _refr_fwiAddC_16s_AC4IRSfs(value, pSrcDst, srcDstStep, roiSize, scaleFactor);
    default:
        assert(false);
        return _refr_fwiAddC_16s_AC4IRSfs(value, pSrcDst, srcDstStep, roiSize, scaleFactor);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiFilterBox_16s_AC4R( const Fw16s * pSrc, int srcStep,
                               Fw16s * pDst, int dstStep, FwiSize dstRoiSize,
                               FwiSize maskSize, FwiPoint anchor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilterBox_16s_AC4R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize, anchor);
    case DT_REFR:
        return _refr_fwiFilterBox_16s_AC4R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize, anchor);
    default:
        assert(false);
        return _refr_fwiFilterBox_16s_AC4R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize, anchor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiLShiftC_8u_C3IR( const Fw32u value[3], Fw8u *pSrcDst, int srcDstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiLShiftC_8u_C3IR(value, pSrcDst, srcDstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiLShiftC_8u_C3IR(value, pSrcDst, srcDstStep, roiSize);
    case DT_REFR:
        return _refr_fwiLShiftC_8u_C3IR(value, pSrcDst, srcDstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiLShiftC_8u_C3IR(value, pSrcDst, srcDstStep, roiSize);
    }
}

OREFR OSSE2         FwStatus fwiMinMax_8u_C4R(const Fw8u* pSrc, int srcStep,FwiSize roiSize, Fw8u min[4], Fw8u max[4])
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiMinMax_8u_C4R(pSrc, srcStep, roiSize, min, max);
    case DT_REFR:
        return _refr_fwiMinMax_8u_C4R(pSrc, srcStep, roiSize, min, max);
    default:
        assert(false);
        return _refr_fwiMinMax_8u_C4R(pSrc, srcStep, roiSize, min, max);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiXorC_8u_AC4IR( const Fw8u value[3], Fw8u *pSrcDst, int srcDstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiXorC_8u_AC4IR(value, pSrcDst, srcDstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiXorC_8u_AC4IR(value, pSrcDst, srcDstStep, roiSize);
    case DT_REFR:
        return _refr_fwiXorC_8u_AC4IR(value, pSrcDst, srcDstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiXorC_8u_AC4IR(value, pSrcDst, srcDstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiAddC_8u_AC4RSfs( const Fw8u   *pSrc, int srcStep, const Fw8u value[3], Fw8u *pDst, int dstStep, FwiSize roiSize, int scaleFactor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiAddC_8u_AC4RSfs(pSrc, srcStep, value, pDst, dstStep, roiSize, scaleFactor);
    case DT_SSE2:
        return _sse2_fwiAddC_8u_AC4RSfs(pSrc, srcStep, value, pDst, dstStep, roiSize, scaleFactor);
    case DT_REFR:
        return _refr_fwiAddC_8u_AC4RSfs(pSrc, srcStep, value, pDst, dstStep, roiSize, scaleFactor);
    default:
        assert(false);
        return _refr_fwiAddC_8u_AC4RSfs(pSrc, srcStep, value, pDst, dstStep, roiSize, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiMulC_32sc_C3RSfs( const Fw32sc *pSrc, int srcStep, const Fw32sc value[3], Fw32sc *pDst, int dstStep, FwiSize roiSize, int scaleFactor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiMulC_32sc_C3RSfs(pSrc, srcStep, value, pDst, dstStep, roiSize, scaleFactor);
    case DT_SSE2:
        return _sse2_fwiMulC_32sc_C3RSfs(pSrc, srcStep, value, pDst, dstStep, roiSize, scaleFactor);
    case DT_REFR:
        return _refr_fwiMulC_32sc_C3RSfs(pSrc, srcStep, value, pDst, dstStep, roiSize, scaleFactor);
    default:
        assert(false);
        return _refr_fwiMulC_32sc_C3RSfs(pSrc, srcStep, value, pDst, dstStep, roiSize, scaleFactor);
    }
}

OREFR               FwStatus fwiLUVToRGB_32f_C3R( const Fw32f* pSrc, int srcStep, Fw32f* pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiLUVToRGB_32f_C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiLUVToRGB_32f_C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiSub_32f_C1R( const Fw32f  *pSrc1, int src1Step, const Fw32f  *pSrc2,   int src2Step, Fw32f  *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiSub_32f_C1R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiSub_32f_C1R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiSub_32f_C1R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiSub_32f_C1R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiRotate_16u_C3R( const Fw16u* pSrc, FwiSize srcSize, int srcStep, FwiRect srcRoi, Fw16u* pDst, int dstStep, FwiRect dstRoi, double angle, double xShift, double yShift, int interpolation )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiRotate_16u_C3R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, angle, xShift, yShift, interpolation);
    case DT_REFR:
        return _refr_fwiRotate_16u_C3R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, angle, xShift, yShift, interpolation);
    default:
        assert(false);
        return _refr_fwiRotate_16u_C3R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, angle, xShift, yShift, interpolation);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiThreshold_LT_32f_AC4R( const Fw32f *pSrc, int srcStep, Fw32f *pDst, int dstStep, FwiSize roiSize, const Fw32f threshold[3])
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiThreshold_LT_32f_AC4R(pSrc, srcStep, pDst, dstStep, roiSize, threshold);
    case DT_SSE2:
        return _sse2_fwiThreshold_LT_32f_AC4R(pSrc, srcStep, pDst, dstStep, roiSize, threshold);
    case DT_REFR:
        return _refr_fwiThreshold_LT_32f_AC4R(pSrc, srcStep, pDst, dstStep, roiSize, threshold);
    default:
        assert(false);
        return _refr_fwiThreshold_LT_32f_AC4R(pSrc, srcStep, pDst, dstStep, roiSize, threshold);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiAnd_8u_C4R( const Fw8u *pSrc1, int src1Step, const Fw8u *pSrc2,   int src2Step, Fw8u *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiAnd_8u_C4R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiAnd_8u_C4R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiAnd_8u_C4R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiAnd_8u_C4R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiAddC_8u_AC4IRSfs( const Fw8u value[3], Fw8u *pSrcDst, int srcDstStep, FwiSize roiSize, int scaleFactor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiAddC_8u_AC4IRSfs(value, pSrcDst, srcDstStep, roiSize, scaleFactor);
    case DT_SSE2:
        return _sse2_fwiAddC_8u_AC4IRSfs(value, pSrcDst, srcDstStep, roiSize, scaleFactor);
    case DT_REFR:
        return _refr_fwiAddC_8u_AC4IRSfs(value, pSrcDst, srcDstStep, roiSize, scaleFactor);
    default:
        assert(false);
        return _refr_fwiAddC_8u_AC4IRSfs(value, pSrcDst, srcDstStep, roiSize, scaleFactor);
    }
}

OREFR               FwStatus fwiBGRToHLS_8u_C3P3R( const A8U* pSrc, int srcStep, A8U* const pDst[3], int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiBGRToHLS_8u_C3P3R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiBGRToHLS_8u_C3P3R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiSub_32fc_AC4R( const Fw32fc *pSrc1, int src1Step, const Fw32fc *pSrc2,   int src2Step, Fw32fc *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiSub_32fc_AC4R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiSub_32fc_AC4R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiSub_32fc_AC4R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiSub_32fc_AC4R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiThreshold_GTVal_8u_AC4R( const Fw8u *pSrc, int srcStep, Fw8u *pDst, int dstStep, FwiSize roiSize, const Fw8u threshold[3], const Fw8u value[3])
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiThreshold_GTVal_8u_AC4R(pSrc, srcStep, pDst, dstStep, roiSize, threshold, value);
    case DT_SSE2:
        return _sse2_fwiThreshold_GTVal_8u_AC4R(pSrc, srcStep, pDst, dstStep, roiSize, threshold, value);
    case DT_REFR:
        return _refr_fwiThreshold_GTVal_8u_AC4R(pSrc, srcStep, pDst, dstStep, roiSize, threshold, value);
    default:
        assert(false);
        return _refr_fwiThreshold_GTVal_8u_AC4R(pSrc, srcStep, pDst, dstStep, roiSize, threshold, value);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiLShiftC_8u_C1IR(       Fw32u value,    Fw8u *pSrcDst, int srcDstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiLShiftC_8u_C1IR(value, pSrcDst, srcDstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiLShiftC_8u_C1IR(value, pSrcDst, srcDstStep, roiSize);
    case DT_REFR:
        return _refr_fwiLShiftC_8u_C1IR(value, pSrcDst, srcDstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiLShiftC_8u_C1IR(value, pSrcDst, srcDstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiSubC_16sc_C1RSfs( const Fw16sc *pSrc, int srcStep,       Fw16sc value,    Fw16sc *pDst, int dstStep, FwiSize roiSize, int scaleFactor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiSubC_16sc_C1RSfs(pSrc, srcStep, value, pDst, dstStep, roiSize, scaleFactor);
    case DT_SSE2:
        return _sse2_fwiSubC_16sc_C1RSfs(pSrc, srcStep, value, pDst, dstStep, roiSize, scaleFactor);
    case DT_REFR:
        return _refr_fwiSubC_16sc_C1RSfs(pSrc, srcStep, value, pDst, dstStep, roiSize, scaleFactor);
    default:
        assert(false);
        return _refr_fwiSubC_16sc_C1RSfs(pSrc, srcStep, value, pDst, dstStep, roiSize, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiXorC_8u_C3IR( const Fw8u value[3], Fw8u *pSrcDst, int srcDstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiXorC_8u_C3IR(value, pSrcDst, srcDstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiXorC_8u_C3IR(value, pSrcDst, srcDstStep, roiSize);
    case DT_REFR:
        return _refr_fwiXorC_8u_C3IR(value, pSrcDst, srcDstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiXorC_8u_C3IR(value, pSrcDst, srcDstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiSwapChannels_8u_AC4R(const Fw8u *pSrc,int srcStep, Fw8u *pDst, int dstStep, FwiSize roiSize,const int dstOrder[3])
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiSwapChannels_8u_AC4R(pSrc, srcStep, pDst, dstStep, roiSize, dstOrder);
    case DT_SSE2:
        return _sse2_fwiSwapChannels_8u_AC4R(pSrc, srcStep, pDst, dstStep, roiSize, dstOrder);
    case DT_REFR:
        return _refr_fwiSwapChannels_8u_AC4R(pSrc, srcStep, pDst, dstStep, roiSize, dstOrder);
    default:
        assert(false);
        return _refr_fwiSwapChannels_8u_AC4R(pSrc, srcStep, pDst, dstStep, roiSize, dstOrder);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiFilterSobelHoriz_8s16s_C1R( const Fw8s * pSrc, int srcStep, Fw16s * pDst, int dstStep, FwiSize dstRoiSize, FwiMaskSize mask )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilterSobelHoriz_8s16s_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize, mask);
    case DT_REFR:
        return _refr_fwiFilterSobelHoriz_8s16s_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize, mask);
    default:
        assert(false);
        return _refr_fwiFilterSobelHoriz_8s16s_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize, mask);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiMirror_8u_AC4R( const Fw8u  *pSrc, int srcStep, Fw8u  *pDst, int dstStep, FwiSize roiSize, FwiAxis flip)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiMirror_8u_AC4R(pSrc, srcStep, pDst, dstStep, roiSize, flip);
    case DT_REFR:
        return _refr_fwiMirror_8u_AC4R(pSrc, srcStep, pDst, dstStep, roiSize, flip);
    default:
        assert(false);
        return _refr_fwiMirror_8u_AC4R(pSrc, srcStep, pDst, dstStep, roiSize, flip);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiFilterBox_32f_C3R( const Fw32f * pSrc, int srcStep,
                               Fw32f * pDst, int dstStep, FwiSize dstRoiSize,
                               FwiSize maskSize, FwiPoint anchor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilterBox_32f_C3R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize, anchor);
    case DT_REFR:
        return _refr_fwiFilterBox_32f_C3R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize, anchor);
    default:
        assert(false);
        return _refr_fwiFilterBox_32f_C3R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize, anchor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiAnd_16u_AC4R( const Fw16u *pSrc1, int src1Step, const Fw16u *pSrc2,   int src2Step, Fw16u *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiAnd_16u_AC4R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiAnd_16u_AC4R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiAnd_16u_AC4R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiAnd_16u_AC4R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiMul_16s_AC4RSfs( const Fw16s  *pSrc1, int src1Step, const Fw16s  *pSrc2,   int src2Step, Fw16s *pDst, int dstStep, FwiSize roiSize, int scaleFactor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiMul_16s_AC4RSfs(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, scaleFactor);
    case DT_SSE2:
        return _sse2_fwiMul_16s_AC4RSfs(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, scaleFactor);
    case DT_REFR:
        return _refr_fwiMul_16s_AC4RSfs(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, scaleFactor);
    default:
        assert(false);
        return _refr_fwiMul_16s_AC4RSfs(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, scaleFactor);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiFilterRobertsUp_16s_AC4R( const Fw16s * pSrc, int srcStep, Fw16s * pDst, int dstStep, FwiSize dstRoiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilterRobertsUp_16s_AC4R(pSrc, srcStep, pDst, dstStep, dstRoiSize);
    case DT_REFR:
        return _refr_fwiFilterRobertsUp_16s_AC4R(pSrc, srcStep, pDst, dstStep, dstRoiSize);
    default:
        assert(false);
        return _refr_fwiFilterRobertsUp_16s_AC4R(pSrc, srcStep, pDst, dstStep, dstRoiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiCopy_32f_C4CR( const Fw32f *pSrc, int srcStep, Fw32f *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiCopy_32f_C4CR(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiCopy_32f_C4CR(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiCopy_32f_C4CR(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiCopy_32f_C4CR(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiOrC_32s_C3IR( const Fw32s value[3], Fw32s *pSrcDst, int srcDstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiOrC_32s_C3IR(value, pSrcDst, srcDstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiOrC_32s_C3IR(value, pSrcDst, srcDstStep, roiSize);
    case DT_REFR:
        return _refr_fwiOrC_32s_C3IR(value, pSrcDst, srcDstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiOrC_32s_C3IR(value, pSrcDst, srcDstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiAndC_32s_AC4IR( const Fw32s value[3], Fw32s *pSrcDst, int srcDstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiAndC_32s_AC4IR(value, pSrcDst, srcDstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiAndC_32s_AC4IR(value, pSrcDst, srcDstStep, roiSize);
    case DT_REFR:
        return _refr_fwiAndC_32s_AC4IR(value, pSrcDst, srcDstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiAndC_32s_AC4IR(value, pSrcDst, srcDstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiOrC_16u_C3R( const Fw16u  *pSrc, int srcStep, const Fw16u value[3], Fw16u *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiOrC_16u_C3R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiOrC_16u_C3R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiOrC_16u_C3R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiOrC_16u_C3R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiAdd_8u_AC4IRSfs( const Fw8u   *pSrc,  int srcStep,        Fw8u   *pSrcDst, int srcDstStep, FwiSize roiSize, int scaleFactor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiAdd_8u_AC4IRSfs(pSrc, srcStep, pSrcDst, srcDstStep, roiSize, scaleFactor);
    case DT_SSE2:
        return _sse2_fwiAdd_8u_AC4IRSfs(pSrc, srcStep, pSrcDst, srcDstStep, roiSize, scaleFactor);
    case DT_REFR:
        return _refr_fwiAdd_8u_AC4IRSfs(pSrc, srcStep, pSrcDst, srcDstStep, roiSize, scaleFactor);
    default:
        assert(false);
        return _refr_fwiAdd_8u_AC4IRSfs(pSrc, srcStep, pSrcDst, srcDstStep, roiSize, scaleFactor);
    }
}

OREFR             FwStatus STDCALL fwiScale_32f8u_C1R( const Fw32f * pSrc, int srcStep, Fw8u * pDst, int dstStep, FwiSize roiSize, Fw32f vMin, Fw32f vMax )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiScale_32f8u_C1R(pSrc, srcStep, pDst, dstStep, roiSize, vMin, vMax);
    default:
        assert(false);
        return _refr_fwiScale_32f8u_C1R(pSrc, srcStep, pDst, dstStep, roiSize, vMin, vMax);
    }
}

OREFR OSSE2 FwStatus STDCALL fwiWarpAffine_8u_AC4R( const Fw8u* pSrc, FwiSize srcSize, int srcStep,
								FwiRect srcRoi, Fw8u* pDst, int dstStep, FwiRect dstRoi,
								const double coeffs[2][3], int interpolation )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiWarpAffine_8u_AC4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, coeffs, interpolation);
    case DT_REFR:
        return _refr_fwiWarpAffine_8u_AC4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, coeffs, interpolation);
    default:
        assert(false);
        return _refr_fwiWarpAffine_8u_AC4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, coeffs, interpolation);
    }
}

OREFR OSSE2 FwStatus STDCALL fwiResize_32f_P3R( const Fw32f* const pSrc[3], FwiSize srcSize, int srcStep, FwiRect srcRoi,
							 Fw32f* const pDst[3], int dstStep, FwiSize dstRoiSize,
							 double xFactor, double yFactor, int interpolation )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiResize_32f_P3R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoiSize, xFactor, yFactor, interpolation);
    case DT_REFR:
        return _refr_fwiResize_32f_P3R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoiSize, xFactor, yFactor, interpolation);
    default:
        assert(false);
        return _refr_fwiResize_32f_P3R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoiSize, xFactor, yFactor, interpolation);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiSub_8u_C3IRSfs( const Fw8u   *pSrc,  int srcStep,        Fw8u   *pSrcDst, int srcDstStep, FwiSize roiSize, int scaleFactor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiSub_8u_C3IRSfs(pSrc, srcStep, pSrcDst, srcDstStep, roiSize, scaleFactor);
    case DT_SSE2:
        return _sse2_fwiSub_8u_C3IRSfs(pSrc, srcStep, pSrcDst, srcDstStep, roiSize, scaleFactor);
    case DT_REFR:
        return _refr_fwiSub_8u_C3IRSfs(pSrc, srcStep, pSrcDst, srcDstStep, roiSize, scaleFactor);
    default:
        assert(false);
        return _refr_fwiSub_8u_C3IRSfs(pSrc, srcStep, pSrcDst, srcDstStep, roiSize, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiAdd_32f_AC4IR( const Fw32f  *pSrc,  int srcStep,        Fw32f  *pSrcDst, int srcDstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiAdd_32f_AC4IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiAdd_32f_AC4IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    case DT_REFR:
        return _refr_fwiAdd_32f_AC4IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiAdd_32f_AC4IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiFilterRobertsUp_8u_C3R( const Fw8u * pSrc, int srcStep, Fw8u * pDst, int dstStep, FwiSize dstRoiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilterRobertsUp_8u_C3R(pSrc, srcStep, pDst, dstStep, dstRoiSize);
    case DT_REFR:
        return _refr_fwiFilterRobertsUp_8u_C3R(pSrc, srcStep, pDst, dstStep, dstRoiSize);
    default:
        assert(false);
        return _refr_fwiFilterRobertsUp_8u_C3R(pSrc, srcStep, pDst, dstStep, dstRoiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiThreshold_GTVal_8u_C1IR( Fw8u *pSrcDst, int srcDstStep, FwiSize roiSize, Fw8u threshold, Fw8u value)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiThreshold_GTVal_8u_C1IR(pSrcDst, srcDstStep, roiSize, threshold, value);
    case DT_SSE2:
        return _sse2_fwiThreshold_GTVal_8u_C1IR(pSrcDst, srcDstStep, roiSize, threshold, value);
    case DT_REFR:
        return _refr_fwiThreshold_GTVal_8u_C1IR(pSrcDst, srcDstStep, roiSize, threshold, value);
    default:
        assert(false);
        return _refr_fwiThreshold_GTVal_8u_C1IR(pSrcDst, srcDstStep, roiSize, threshold, value);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiAndC_32s_C1R( const Fw32s  *pSrc, int srcStep,       Fw32s value,    Fw32s *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiAndC_32s_C1R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiAndC_32s_C1R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiAndC_32s_C1R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiAndC_32s_C1R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiThreshold_GT_32f_C3R( const Fw32f *pSrc, int srcStep, Fw32f *pDst, int dstStep, FwiSize roiSize, const Fw32f threshold[3])
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiThreshold_GT_32f_C3R(pSrc, srcStep, pDst, dstStep, roiSize, threshold);
    case DT_SSE2:
        return _sse2_fwiThreshold_GT_32f_C3R(pSrc, srcStep, pDst, dstStep, roiSize, threshold);
    case DT_REFR:
        return _refr_fwiThreshold_GT_32f_C3R(pSrc, srcStep, pDst, dstStep, roiSize, threshold);
    default:
        assert(false);
        return _refr_fwiThreshold_GT_32f_C3R(pSrc, srcStep, pDst, dstStep, roiSize, threshold);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiConvert_32f8s_C4R( const Fw32f *pSrc, int srcStep, Fw8s *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiConvert_32f8s_C4R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiConvert_32f8s_C4R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiConvert_32f8s_C4R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiConvert_32f8s_C4R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR               FwStatus fwiRGBToHLS_16u_C3R( const Fw16u* pSrc, int srcStep, Fw16u* pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiRGBToHLS_16u_C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiRGBToHLS_16u_C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiMulC_32f_C3R( const Fw32f *pSrc, int srcStep, const Fw32f value[3], Fw32f *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiMulC_32f_C3R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiMulC_32f_C3R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiMulC_32f_C3R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiMulC_32f_C3R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiRShiftC_16s_C4IR( const Fw32u value[4], Fw16s *pSrcDst, int srcDstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiRShiftC_16s_C4IR(value, pSrcDst, srcDstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiRShiftC_16s_C4IR(value, pSrcDst, srcDstStep, roiSize);
    case DT_REFR:
        return _refr_fwiRShiftC_16s_C4IR(value, pSrcDst, srcDstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiRShiftC_16s_C4IR(value, pSrcDst, srcDstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiAddProduct_8s32f_C1IMR( const Fw8s *pSrc1,  int src1Step, const Fw8s *pSrc2,  int src2Step, const Fw8u* pMask, int maskStep, Fw32f *pSrcDst, int srcDstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiAddProduct_8s32f_C1IMR(pSrc1, src1Step, pSrc2, src2Step, pMask, maskStep, pSrcDst, srcDstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiAddProduct_8s32f_C1IMR(pSrc1, src1Step, pSrc2, src2Step, pMask, maskStep, pSrcDst, srcDstStep, roiSize);
    case DT_REFR:
        return _refr_fwiAddProduct_8s32f_C1IMR(pSrc1, src1Step, pSrc2, src2Step, pMask, maskStep, pSrcDst, srcDstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiAddProduct_8s32f_C1IMR(pSrc1, src1Step, pSrc2, src2Step, pMask, maskStep, pSrcDst, srcDstStep, roiSize);
    }
}


OREFR       FwStatus STDCALL fwiGetPerspectiveQuad(FwiRect srcRoi, double quad[4][2], const double coeffs[3][3])
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiGetPerspectiveQuad(srcRoi, quad, coeffs);
    default:
        assert(false);
        return _refr_fwiGetPerspectiveQuad(srcRoi, quad, coeffs);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiAddProduct_16u32f_C1IR( const Fw16u *pSrc1, int src1Step, const Fw16u *pSrc2, int src2Step, Fw32f *pSrcDst, int srcDstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiAddProduct_16u32f_C1IR(pSrc1, src1Step, pSrc2, src2Step, pSrcDst, srcDstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiAddProduct_16u32f_C1IR(pSrc1, src1Step, pSrc2, src2Step, pSrcDst, srcDstStep, roiSize);
    case DT_REFR:
        return _refr_fwiAddProduct_16u32f_C1IR(pSrc1, src1Step, pSrc2, src2Step, pSrcDst, srcDstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiAddProduct_16u32f_C1IR(pSrc1, src1Step, pSrc2, src2Step, pSrcDst, srcDstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiMulCScale_16u_C4IR( const Fw16u value[4], Fw16u *pSrcDst, int srcDstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiMulCScale_16u_C4IR(value, pSrcDst, srcDstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiMulCScale_16u_C4IR(value, pSrcDst, srcDstStep, roiSize);
    case DT_REFR:
        return _refr_fwiMulCScale_16u_C4IR(value, pSrcDst, srcDstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiMulCScale_16u_C4IR(value, pSrcDst, srcDstStep, roiSize);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiSumWindowRow_8u32f_C3R( const Fw8u * pSrc, int srcStep,
                               Fw32f * pDst, int dstStep, FwiSize dstRoiSize,
                               int maskSize, int anchor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiSumWindowRow_8u32f_C3R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize, anchor);
    case DT_REFR:
        return _refr_fwiSumWindowRow_8u32f_C3R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize, anchor);
    default:
        assert(false);
        return _refr_fwiSumWindowRow_8u32f_C3R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize, anchor);
    }
}

OREFR               FwStatus fwiCountInRange_8u_AC4R(const Fw8u* pSrc, int srcStep,FwiSize roiSize, int counts[3], Fw8u lowerBound[3],Fw8u upperBound[3])
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiCountInRange_8u_AC4R(pSrc, srcStep, roiSize, counts, lowerBound, upperBound);
    default:
        assert(false);
        return _refr_fwiCountInRange_8u_AC4R(pSrc, srcStep, roiSize, counts, lowerBound, upperBound);
    }
}

OREFR OSSE2 FwStatus STDCALL fwiFilterSharpen_32f_C3R( const Fw32f * pSrc, int srcStep, Fw32f * pDst, int dstStep, FwiSize dstRoiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilterSharpen_32f_C3R(pSrc, srcStep, pDst, dstStep, dstRoiSize);
    case DT_REFR:
        return _refr_fwiFilterSharpen_32f_C3R(pSrc, srcStep, pDst, dstStep, dstRoiSize);
    default:
        assert(false);
        return _refr_fwiFilterSharpen_32f_C3R(pSrc, srcStep, pDst, dstStep, dstRoiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiRShiftC_32s_AC4R( const Fw32s  *pSrc, int srcStep, const Fw32u value[3], Fw32s *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiRShiftC_32s_AC4R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiRShiftC_32s_AC4R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiRShiftC_32s_AC4R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiRShiftC_32s_AC4R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiAndC_32s_C1IR(       Fw32s value,    Fw32s *pSrcDst, int srcDstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiAndC_32s_C1IR(value, pSrcDst, srcDstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiAndC_32s_C1IR(value, pSrcDst, srcDstStep, roiSize);
    case DT_REFR:
        return _refr_fwiAndC_32s_C1IR(value, pSrcDst, srcDstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiAndC_32s_C1IR(value, pSrcDst, srcDstStep, roiSize);
    }
}

OREFR               FwStatus fwiHLSToRGB_16s_C3R( const Fw16s* pSrc, int srcStep, Fw16s* pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiHLSToRGB_16s_C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiHLSToRGB_16s_C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiMulC_16s_C3IRSfs( const Fw16s value[3], Fw16s *pSrcDst, int srcDstStep, FwiSize roiSize, int scaleFactor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiMulC_16s_C3IRSfs(value, pSrcDst, srcDstStep, roiSize, scaleFactor);
    case DT_SSE2:
        return _sse2_fwiMulC_16s_C3IRSfs(value, pSrcDst, srcDstStep, roiSize, scaleFactor);
    case DT_REFR:
        return _refr_fwiMulC_16s_C3IRSfs(value, pSrcDst, srcDstStep, roiSize, scaleFactor);
    default:
        assert(false);
        return _refr_fwiMulC_16s_C3IRSfs(value, pSrcDst, srcDstStep, roiSize, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiDiv_8u_C1RSfs( const Fw8u   *pSrc1, int src1Step, const Fw8u   *pSrc2,   int src2Step, Fw8u   *pDst, int dstStep, FwiSize roiSize, int scaleFactor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiDiv_8u_C1RSfs(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, scaleFactor);
    case DT_SSE2:
        return _sse2_fwiDiv_8u_C1RSfs(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, scaleFactor);
    case DT_REFR:
        return _refr_fwiDiv_8u_C1RSfs(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, scaleFactor);
    default:
        assert(false);
        return _refr_fwiDiv_8u_C1RSfs(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, scaleFactor);
    }
}

OREFR OSSE2         FwStatus fwiMean_8u_C3R(const Fw8u* pSrc, int srcStep,FwiSize roiSize, Fw64f mean[3])
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiMean_8u_C3R(pSrc, srcStep, roiSize, mean);
    case DT_REFR:
        return _refr_fwiMean_8u_C3R(pSrc, srcStep, roiSize, mean);
    default:
        assert(false);
        return _refr_fwiMean_8u_C3R(pSrc, srcStep, roiSize, mean);
    }
}

OREFR             FwStatus STDCALL fwiScale_8u16u_C3R( const Fw8u * pSrc, int srcStep, Fw16u * pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiScale_8u16u_C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiScale_8u16u_C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiConvert_8u16s_C1R( const Fw8u *pSrc, int srcStep, Fw16s *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiConvert_8u16s_C1R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiConvert_8u16s_C1R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiConvert_8u16s_C1R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiConvert_8u16s_C1R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiThreshold_LTValGTVal_16s_AC4R( const Fw16s *pSrc, int srcStep, Fw16s *pDst, int dstStep, FwiSize roiSize, const Fw16s thresholdLT[3], const Fw16s valueLT[3], const Fw16s thresholdGT[3], const Fw16s valueGT[3])
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiThreshold_LTValGTVal_16s_AC4R(pSrc, srcStep, pDst, dstStep, roiSize, thresholdLT, valueLT, thresholdGT, valueGT);
    case DT_SSE2:
        return _sse2_fwiThreshold_LTValGTVal_16s_AC4R(pSrc, srcStep, pDst, dstStep, roiSize, thresholdLT, valueLT, thresholdGT, valueGT);
    case DT_REFR:
        return _refr_fwiThreshold_LTValGTVal_16s_AC4R(pSrc, srcStep, pDst, dstStep, roiSize, thresholdLT, valueLT, thresholdGT, valueGT);
    default:
        assert(false);
        return _refr_fwiThreshold_LTValGTVal_16s_AC4R(pSrc, srcStep, pDst, dstStep, roiSize, thresholdLT, valueLT, thresholdGT, valueGT);
    }
}

OREFR OSSE2 FwStatus STDCALL fwiResizeCenter_8u_P4R( const Fw8u* const pSrc[4], FwiSize srcSize, int srcStep, FwiRect srcRoi,
								  Fw8u* const pDst[4], int dstStep, FwiSize dstRoiSize,
								  double xFactor, double yFactor, double xCenter, double yCenter, int interpolation )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiResizeCenter_8u_P4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoiSize, xFactor, yFactor, xCenter, yCenter, interpolation);
    case DT_REFR:
        return _refr_fwiResizeCenter_8u_P4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoiSize, xFactor, yFactor, xCenter, yCenter, interpolation);
    default:
        assert(false);
        return _refr_fwiResizeCenter_8u_P4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoiSize, xFactor, yFactor, xCenter, yCenter, interpolation);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiCompare_32f_AC4R( const Fw32f *pSrc1, int src1Step, const Fw32f *pSrc2, int src2Step, Fw8u *pDst, int dstStep, FwiSize roiSize, FwCmpOp fwCmpOp )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiCompare_32f_AC4R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, fwCmpOp);
    case DT_SSE2:
        return _sse2_fwiCompare_32f_AC4R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, fwCmpOp);
    case DT_REFR:
        return _refr_fwiCompare_32f_AC4R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, fwCmpOp);
    default:
        assert(false);
        return _refr_fwiCompare_32f_AC4R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, fwCmpOp);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiRotate_32f_AC4R( const Fw32f* pSrc, FwiSize srcSize, int srcStep, FwiRect srcRoi, Fw32f* pDst, int dstStep, FwiRect dstRoi, double angle, double xShift, double yShift, int interpolation )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiRotate_32f_AC4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, angle, xShift, yShift, interpolation);
    case DT_REFR:
        return _refr_fwiRotate_32f_AC4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, angle, xShift, yShift, interpolation);
    default:
        assert(false);
        return _refr_fwiRotate_32f_AC4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, angle, xShift, yShift, interpolation);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiAddC_32fc_AC4IR( const Fw32fc  value[3], Fw32fc *pSrcDst, int srcDstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiAddC_32fc_AC4IR(value, pSrcDst, srcDstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiAddC_32fc_AC4IR(value, pSrcDst, srcDstStep, roiSize);
    case DT_REFR:
        return _refr_fwiAddC_32fc_AC4IR(value, pSrcDst, srcDstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiAddC_32fc_AC4IR(value, pSrcDst, srcDstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiDivC_32f_C1IR(       Fw32f value,    Fw32f *pSrcDst, int srcDstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiDivC_32f_C1IR(value, pSrcDst, srcDstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiDivC_32f_C1IR(value, pSrcDst, srcDstStep, roiSize);
    case DT_REFR:
        return _refr_fwiDivC_32f_C1IR(value, pSrcDst, srcDstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiDivC_32f_C1IR(value, pSrcDst, srcDstStep, roiSize);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiRotate_32f_P4R( const Fw32f* const pSrc[4], FwiSize srcSize, int srcStep, FwiRect srcRoi, Fw32f* const pDst[4], int dstStep, FwiRect dstRoi, double angle, double xShift, double yShift, int interpolation )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiRotate_32f_P4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, angle, xShift, yShift, interpolation);
    case DT_REFR:
        return _refr_fwiRotate_32f_P4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, angle, xShift, yShift, interpolation);
    default:
        assert(false);
        return _refr_fwiRotate_32f_P4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, angle, xShift, yShift, interpolation);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiThreshold_Val_32f_C1IR( Fw32f *pSrcDst, int srcDstStep, FwiSize roiSize, Fw32f threshold, Fw32f value, FwCmpOp fwCmpOp)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiThreshold_Val_32f_C1IR(pSrcDst, srcDstStep, roiSize, threshold, value, fwCmpOp);
    case DT_SSE2:
        return _sse2_fwiThreshold_Val_32f_C1IR(pSrcDst, srcDstStep, roiSize, threshold, value, fwCmpOp);
    case DT_REFR:
        return _refr_fwiThreshold_Val_32f_C1IR(pSrcDst, srcDstStep, roiSize, threshold, value, fwCmpOp);
    default:
        assert(false);
        return _refr_fwiThreshold_Val_32f_C1IR(pSrcDst, srcDstStep, roiSize, threshold, value, fwCmpOp);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiFilterMin_32f_AC4R( const Fw32f * pSrc, int srcStep,
                               Fw32f * pDst, int dstStep, FwiSize dstRoiSize,
                               FwiSize maskSize, FwiPoint anchor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilterMin_32f_AC4R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize, anchor);
    case DT_REFR:
        return _refr_fwiFilterMin_32f_AC4R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize, anchor);
    default:
        assert(false);
        return _refr_fwiFilterMin_32f_AC4R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize, anchor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiAddProduct_32f_C1IMR( const Fw32f *pSrc1, int src1Step, const Fw32f *pSrc2, int src2Step, const Fw8u* pMask, int maskStep, Fw32f *pSrcDst, int srcDstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiAddProduct_32f_C1IMR(pSrc1, src1Step, pSrc2, src2Step, pMask, maskStep, pSrcDst, srcDstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiAddProduct_32f_C1IMR(pSrc1, src1Step, pSrc2, src2Step, pMask, maskStep, pSrcDst, srcDstStep, roiSize);
    case DT_REFR:
        return _refr_fwiAddProduct_32f_C1IMR(pSrc1, src1Step, pSrc2, src2Step, pMask, maskStep, pSrcDst, srcDstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiAddProduct_32f_C1IMR(pSrc1, src1Step, pSrc2, src2Step, pMask, maskStep, pSrcDst, srcDstStep, roiSize);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiFilter_32f_C1R( const Fw32f * pSrc, int srcStep,
                              Fw32f * pDst, int dstStep, FwiSize dstRoiSize,
                              const Fw32f * pKernel, FwiSize kernelSize,
                              FwiPoint anchor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilter_32f_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize, pKernel, kernelSize, anchor);
    case DT_REFR:
        return _refr_fwiFilter_32f_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize, pKernel, kernelSize, anchor);
    default:
        assert(false);
        return _refr_fwiFilter_32f_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize, pKernel, kernelSize, anchor);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiSumWindowColumn_16s32f_C4R( const Fw16s * pSrc, int srcStep,
                               Fw32f * pDst, int dstStep, FwiSize dstRoiSize,
                               int maskSize, int anchor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiSumWindowColumn_16s32f_C4R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize, anchor);
    case DT_REFR:
        return _refr_fwiSumWindowColumn_16s32f_C4R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize, anchor);
    default:
        assert(false);
        return _refr_fwiSumWindowColumn_16s32f_C4R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize, anchor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiRShiftC_16u_C4R( const Fw16u  *pSrc, int srcStep, const Fw32u value[4], Fw16u *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiRShiftC_16u_C4R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiRShiftC_16u_C4R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiRShiftC_16u_C4R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiRShiftC_16u_C4R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiSqrt_16u_C3IRSfs(       Fw16u *pSrcDst, int srcDstStep, FwiSize roiSize, int scaleFactor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiSqrt_16u_C3IRSfs(pSrcDst, srcDstStep, roiSize, scaleFactor);
    case DT_SSE2:
        return _sse2_fwiSqrt_16u_C3IRSfs(pSrcDst, srcDstStep, roiSize, scaleFactor);
    case DT_REFR:
        return _refr_fwiSqrt_16u_C3IRSfs(pSrcDst, srcDstStep, roiSize, scaleFactor);
    default:
        assert(false);
        return _refr_fwiSqrt_16u_C3IRSfs(pSrcDst, srcDstStep, roiSize, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiThreshold_LT_8u_C3R( const Fw8u *pSrc, int srcStep, Fw8u *pDst, int dstStep, FwiSize roiSize, const Fw8u threshold[3])
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiThreshold_LT_8u_C3R(pSrc, srcStep, pDst, dstStep, roiSize, threshold);
    case DT_SSE2:
        return _sse2_fwiThreshold_LT_8u_C3R(pSrc, srcStep, pDst, dstStep, roiSize, threshold);
    case DT_REFR:
        return _refr_fwiThreshold_LT_8u_C3R(pSrc, srcStep, pDst, dstStep, roiSize, threshold);
    default:
        assert(false);
        return _refr_fwiThreshold_LT_8u_C3R(pSrc, srcStep, pDst, dstStep, roiSize, threshold);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiMul_16s_C3RSfs( const Fw16s  *pSrc1, int src1Step, const Fw16s  *pSrc2,   int src2Step, Fw16s *pDst, int dstStep, FwiSize roiSize, int scaleFactor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiMul_16s_C3RSfs(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, scaleFactor);
    case DT_SSE2:
        return _sse2_fwiMul_16s_C3RSfs(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, scaleFactor);
    case DT_REFR:
        return _refr_fwiMul_16s_C3RSfs(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, scaleFactor);
    default:
        assert(false);
        return _refr_fwiMul_16s_C3RSfs(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, scaleFactor);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiFilterPrewittHoriz_16s_C4R( const Fw16s * pSrc, int srcStep, Fw16s * pDst, int dstStep, FwiSize dstRoiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilterPrewittHoriz_16s_C4R(pSrc, srcStep, pDst, dstStep, dstRoiSize);
    case DT_REFR:
        return _refr_fwiFilterPrewittHoriz_16s_C4R(pSrc, srcStep, pDst, dstStep, dstRoiSize);
    default:
        assert(false);
        return _refr_fwiFilterPrewittHoriz_16s_C4R(pSrc, srcStep, pDst, dstStep, dstRoiSize);
    }
}

OREFR               FwStatus fwiYCbCr422ToRGB565_8u16u_P3C3R(const A8U* const pSrc[3], int srcStep[3], A16U* pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiYCbCr422ToRGB565_8u16u_P3C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiYCbCr422ToRGB565_8u16u_P3C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 FwStatus STDCALL fwiWarpPerspective_32f_C4R( const Fw32f* pSrc, FwiSize srcSize, int srcStep,
								FwiRect srcRoi, Fw32f* pDst, int dstStep, FwiRect dstRoi,
								const double coeffs[3][3], int interpolation )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiWarpPerspective_32f_C4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, coeffs, interpolation);
    case DT_REFR:
        return _refr_fwiWarpPerspective_32f_C4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, coeffs, interpolation);
    default:
        assert(false);
        return _refr_fwiWarpPerspective_32f_C4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, coeffs, interpolation);
    }
}

OREFR               FwStatus fwiHLSToBGR_8u_AC4P4R(const A8U* pSrc, int srcStep, A8U* const pDst[4], int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiHLSToBGR_8u_AC4P4R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiHLSToBGR_8u_AC4P4R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiRotate_8u_P4R( const Fw8u* const pSrc[4], FwiSize srcSize, int srcStep, FwiRect srcRoi, Fw8u* const pDst[4], int dstStep, FwiRect dstRoi, double angle, double xShift, double yShift, int interpolation )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiRotate_8u_P4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, angle, xShift, yShift, interpolation);
    case DT_REFR:
        return _refr_fwiRotate_8u_P4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, angle, xShift, yShift, interpolation);
    default:
        assert(false);
        return _refr_fwiRotate_8u_P4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, angle, xShift, yShift, interpolation);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiThreshold_LTVal_8u_C4IR( Fw8u *pSrcDst, int srcDstStep, FwiSize roiSize, const Fw8u threshold[4], const Fw8u value[4])
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiThreshold_LTVal_8u_C4IR(pSrcDst, srcDstStep, roiSize, threshold, value);
    case DT_SSE2:
        return _sse2_fwiThreshold_LTVal_8u_C4IR(pSrcDst, srcDstStep, roiSize, threshold, value);
    case DT_REFR:
        return _refr_fwiThreshold_LTVal_8u_C4IR(pSrcDst, srcDstStep, roiSize, threshold, value);
    default:
        assert(false);
        return _refr_fwiThreshold_LTVal_8u_C4IR(pSrcDst, srcDstStep, roiSize, threshold, value);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiOr_16u_C1R( const Fw16u *pSrc1, int src1Step, const Fw16u *pSrc2,   int src2Step, Fw16u *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiOr_16u_C1R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiOr_16u_C1R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiOr_16u_C1R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiOr_16u_C1R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiDivC_32f_C3IR( const Fw32f value[3], Fw32f *pSrcDst, int srcDstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiDivC_32f_C3IR(value, pSrcDst, srcDstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiDivC_32f_C3IR(value, pSrcDst, srcDstStep, roiSize);
    case DT_REFR:
        return _refr_fwiDivC_32f_C3IR(value, pSrcDst, srcDstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiDivC_32f_C3IR(value, pSrcDst, srcDstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiAddC_32fc_C3IR( const Fw32fc  value[3], Fw32fc *pSrcDst, int srcDstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiAddC_32fc_C3IR(value, pSrcDst, srcDstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiAddC_32fc_C3IR(value, pSrcDst, srcDstStep, roiSize);
    case DT_REFR:
        return _refr_fwiAddC_32fc_C3IR(value, pSrcDst, srcDstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiAddC_32fc_C3IR(value, pSrcDst, srcDstStep, roiSize);
    }
}

OREFR OSSE2         FwStatus fwiCountInRange_32f_C1R(const Fw32f* pSrc, int srcStep, FwiSize roiSize, int* counts, Fw32f lowerBound,Fw32f upperBound)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiCountInRange_32f_C1R(pSrc, srcStep, roiSize, counts, lowerBound, upperBound);
    case DT_REFR:
        return _refr_fwiCountInRange_32f_C1R(pSrc, srcStep, roiSize, counts, lowerBound, upperBound);
    default:
        assert(false);
        return _refr_fwiCountInRange_32f_C1R(pSrc, srcStep, roiSize, counts, lowerBound, upperBound);
    }
}

OREFR               FwStatus fwiYCbCrToRGB565_8u16u_C3R( const Fw8u* pSrc, int srcStep, Fw16u* pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiYCbCrToRGB565_8u16u_C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiYCbCrToRGB565_8u16u_C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR       FwStatus STDCALL fwiWarpBilinear_32f_C4R(const Fw32f* pSrc, FwiSize srcSize, int srcStep,
								FwiRect srcRoi, Fw32f* pDst, int dstStep, FwiRect dstRoi,
								const double coeffs[2][4], int interpolation)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiWarpBilinear_32f_C4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, coeffs, interpolation);
    default:
        assert(false);
        return _refr_fwiWarpBilinear_32f_C4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, coeffs, interpolation);
    }
}

OREFR               FwStatus fwiYCbCr420ToRGB444_8u16u_P3C3R(const A8U* const pSrc[3], int srcStep[3], A16U* pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiYCbCr420ToRGB444_8u16u_P3C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiYCbCr420ToRGB444_8u16u_P3C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiFilterSobelHoriz_32f_AC4R( const Fw32f * pSrc, int srcStep, Fw32f * pDst, int dstStep, FwiSize dstRoiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilterSobelHoriz_32f_AC4R(pSrc, srcStep, pDst, dstStep, dstRoiSize);
    case DT_REFR:
        return _refr_fwiFilterSobelHoriz_32f_AC4R(pSrc, srcStep, pDst, dstStep, dstRoiSize);
    default:
        assert(false);
        return _refr_fwiFilterSobelHoriz_32f_AC4R(pSrc, srcStep, pDst, dstStep, dstRoiSize);
    }
}

OREFR       FwStatus STDCALL fwiResizeSqrPixel_32f_P4R(const Fw32f* const pSrc[4], FwiSize srcSize, int srcStep, FwiRect srcRoi,
			Fw32f* const pDst[4], int dstStep, FwiRect dstRoi, double xFactor, double yFactor,
			double xShift, double yShift, int interpolation, Fw8u* pBuffer)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiResizeSqrPixel_32f_P4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, xFactor, yFactor, xShift, yShift, interpolation, pBuffer);
    default:
        assert(false);
        return _refr_fwiResizeSqrPixel_32f_P4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, xFactor, yFactor, xShift, yShift, interpolation, pBuffer);
    }
}

OREFR       FwStatus STDCALL fwiResizeSqrPixel_16u_P3R(const Fw16u* const pSrc[3], FwiSize srcSize, int srcStep, FwiRect srcRoi,
			Fw16u* const pDst[3], int dstStep, FwiRect dstRoi, double xFactor, double yFactor,
			double xShift, double yShift, int interpolation, Fw8u* pBuffer)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiResizeSqrPixel_16u_P3R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, xFactor, yFactor, xShift, yShift, interpolation, pBuffer);
    default:
        assert(false);
        return _refr_fwiResizeSqrPixel_16u_P3R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, xFactor, yFactor, xShift, yShift, interpolation, pBuffer);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiMul_8u_C1RSfs( const Fw8u   *pSrc1, int src1Step, const Fw8u   *pSrc2,   int src2Step, Fw8u *pDst, int dstStep, FwiSize roiSize, int scaleFactor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiMul_8u_C1RSfs(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, scaleFactor);
    case DT_SSE2:
        return _sse2_fwiMul_8u_C1RSfs(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, scaleFactor);
    case DT_REFR:
        return _refr_fwiMul_8u_C1RSfs(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, scaleFactor);
    default:
        assert(false);
        return _refr_fwiMul_8u_C1RSfs(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiConvert_16u8u_C4R( const Fw16u *pSrc, int srcStep, Fw8u *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiConvert_16u8u_C4R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiConvert_16u8u_C4R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiConvert_16u8u_C4R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiConvert_16u8u_C4R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiSwapChannels_8u_C3IR( Fw8u *pSrcDst, int srcDstStep,FwiSize roiSize, const int dstOrder[3])
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiSwapChannels_8u_C3IR(pSrcDst, srcDstStep, roiSize, dstOrder);
    case DT_SSE2:
        return _sse2_fwiSwapChannels_8u_C3IR(pSrcDst, srcDstStep, roiSize, dstOrder);
    case DT_REFR:
        return _refr_fwiSwapChannels_8u_C3IR(pSrcDst, srcDstStep, roiSize, dstOrder);
    default:
        assert(false);
        return _refr_fwiSwapChannels_8u_C3IR(pSrcDst, srcDstStep, roiSize, dstOrder);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiFilterHipass_16s_C1R( const Fw16s * pSrc, int srcStep, Fw16s * pDst, int dstStep, FwiSize dstRoiSize, FwiMaskSize maskSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilterHipass_16s_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize);
    case DT_REFR:
        return _refr_fwiFilterHipass_16s_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize);
    default:
        assert(false);
        return _refr_fwiFilterHipass_16s_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiConvert_16s32f_C4R( const Fw16s *pSrc, int srcStep, Fw32f *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiConvert_16s32f_C4R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiConvert_16s32f_C4R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiConvert_16s32f_C4R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiConvert_16s32f_C4R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiSubC_32sc_C1RSfs( const Fw32sc *pSrc, int srcStep,       Fw32sc value,    Fw32sc *pDst, int dstStep, FwiSize roiSize, int scaleFactor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiSubC_32sc_C1RSfs(pSrc, srcStep, value, pDst, dstStep, roiSize, scaleFactor);
    case DT_SSE2:
        return _sse2_fwiSubC_32sc_C1RSfs(pSrc, srcStep, value, pDst, dstStep, roiSize, scaleFactor);
    case DT_REFR:
        return _refr_fwiSubC_32sc_C1RSfs(pSrc, srcStep, value, pDst, dstStep, roiSize, scaleFactor);
    default:
        assert(false);
        return _refr_fwiSubC_32sc_C1RSfs(pSrc, srcStep, value, pDst, dstStep, roiSize, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiMulCScale_16u_C1IR(       Fw16u value,    Fw16u *pSrcDst, int srcDstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiMulCScale_16u_C1IR(value, pSrcDst, srcDstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiMulCScale_16u_C1IR(value, pSrcDst, srcDstStep, roiSize);
    case DT_REFR:
        return _refr_fwiMulCScale_16u_C1IR(value, pSrcDst, srcDstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiMulCScale_16u_C1IR(value, pSrcDst, srcDstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiThreshold_16s_C3IR( Fw16s *pSrcDst, int srcDstStep, FwiSize roiSize, const Fw16s threshold[3], FwCmpOp fwCmpOp)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiThreshold_16s_C3IR(pSrcDst, srcDstStep, roiSize, threshold, fwCmpOp);
    case DT_SSE2:
        return _sse2_fwiThreshold_16s_C3IR(pSrcDst, srcDstStep, roiSize, threshold, fwCmpOp);
    case DT_REFR:
        return _refr_fwiThreshold_16s_C3IR(pSrcDst, srcDstStep, roiSize, threshold, fwCmpOp);
    default:
        assert(false);
        return _refr_fwiThreshold_16s_C3IR(pSrcDst, srcDstStep, roiSize, threshold, fwCmpOp);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiThreshold_LTVal_8u_C1R( const Fw8u *pSrc, int srcStep, Fw8u *pDst, int dstStep, FwiSize roiSize, Fw8u threshold, Fw8u value)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiThreshold_LTVal_8u_C1R(pSrc, srcStep, pDst, dstStep, roiSize, threshold, value);
    case DT_SSE2:
        return _sse2_fwiThreshold_LTVal_8u_C1R(pSrc, srcStep, pDst, dstStep, roiSize, threshold, value);
    case DT_REFR:
        return _refr_fwiThreshold_LTVal_8u_C1R(pSrc, srcStep, pDst, dstStep, roiSize, threshold, value);
    default:
        assert(false);
        return _refr_fwiThreshold_LTVal_8u_C1R(pSrc, srcStep, pDst, dstStep, roiSize, threshold, value);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiSet_16s_C4CR(		Fw16s  value,    Fw16s  * pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiSet_16s_C4CR(value, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiSet_16s_C4CR(value, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiSet_16s_C4CR(value, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiSet_16s_C4CR(value, pDst, dstStep, roiSize);
    }
}

OREFR             FwStatus STDCALL fwiConvert_8u32s_AC4R( const Fw8u *pSrc, int srcStep, Fw32s *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiConvert_8u32s_AC4R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiConvert_8u32s_AC4R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}


OREFR OSSE2       FwStatus STDCALL fwiFilterColumn32f_8u_C1R( const Fw8u * pSrc, int srcStep,
                                Fw8u * pDst, int dstStep, FwiSize dstRoiSize,
                                const Fw32f * pKernel, int kernelSize,
                                int yAnchor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilterColumn32f_8u_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize, pKernel, kernelSize, yAnchor);
    case DT_REFR:
        return _refr_fwiFilterColumn32f_8u_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize, pKernel, kernelSize, yAnchor);
    default:
        assert(false);
        return _refr_fwiFilterColumn32f_8u_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize, pKernel, kernelSize, yAnchor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiDivC_8u_C3RSfs( const Fw8u *pSrc, int srcStep, const Fw8u value[3], Fw8u *pDst, int dstStep, FwiSize roiSize, int scaleFactor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiDivC_8u_C3RSfs(pSrc, srcStep, value, pDst, dstStep, roiSize, scaleFactor);
    case DT_SSE2:
        return _sse2_fwiDivC_8u_C3RSfs(pSrc, srcStep, value, pDst, dstStep, roiSize, scaleFactor);
    case DT_REFR:
        return _refr_fwiDivC_8u_C3RSfs(pSrc, srcStep, value, pDst, dstStep, roiSize, scaleFactor);
    default:
        assert(false);
        return _refr_fwiDivC_8u_C3RSfs(pSrc, srcStep, value, pDst, dstStep, roiSize, scaleFactor);
    }
}


OREFR               FwStatus fwiYCCToRGB_8u_C3R( const Fw8u *pSrc, int srcStep, Fw8u *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiYCCToRGB_8u_C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiYCCToRGB_8u_C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiSet_32s_AC4R( const Fw32s  value[3], Fw32s  * pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiSet_32s_AC4R(value, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiSet_32s_AC4R(value, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiSet_32s_AC4R(value, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiSet_32s_AC4R(value, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiMulCScale_8u_C4R( const Fw8u *pSrc, int srcStep, const Fw8u value[4], Fw8u *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiMulCScale_8u_C4R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiMulCScale_8u_C4R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiMulCScale_8u_C4R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiMulCScale_8u_C4R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiThreshold_16s_C1R( const Fw16s *pSrc, int srcStep, Fw16s *pDst, int dstStep, FwiSize roiSize, Fw16s threshold, FwCmpOp fwCmpOp)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiThreshold_16s_C1R(pSrc, srcStep, pDst, dstStep, roiSize, threshold, fwCmpOp);
    case DT_SSE2:
        return _sse2_fwiThreshold_16s_C1R(pSrc, srcStep, pDst, dstStep, roiSize, threshold, fwCmpOp);
    case DT_REFR:
        return _refr_fwiThreshold_16s_C1R(pSrc, srcStep, pDst, dstStep, roiSize, threshold, fwCmpOp);
    default:
        assert(false);
        return _refr_fwiThreshold_16s_C1R(pSrc, srcStep, pDst, dstStep, roiSize, threshold, fwCmpOp);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiCopy_8u_C3C1R( const Fw8u *pSrc, int srcStep, Fw8u *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiCopy_8u_C3C1R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiCopy_8u_C3C1R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiCopy_8u_C3C1R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiCopy_8u_C3C1R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiFilterSobelHoriz_8u_AC4R( const Fw8u * pSrc, int srcStep, Fw8u * pDst, int dstStep, FwiSize dstRoiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilterSobelHoriz_8u_AC4R(pSrc, srcStep, pDst, dstStep, dstRoiSize);
    case DT_REFR:
        return _refr_fwiFilterSobelHoriz_8u_AC4R(pSrc, srcStep, pDst, dstStep, dstRoiSize);
    default:
        assert(false);
        return _refr_fwiFilterSobelHoriz_8u_AC4R(pSrc, srcStep, pDst, dstStep, dstRoiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiSub_16sc_C3RSfs( const Fw16sc *pSrc1, int src1Step, const Fw16sc *pSrc2,   int src2Step, Fw16sc *pDst, int dstStep, FwiSize roiSize, int scaleFactor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiSub_16sc_C3RSfs(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, scaleFactor);
    case DT_SSE2:
        return _sse2_fwiSub_16sc_C3RSfs(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, scaleFactor);
    case DT_REFR:
        return _refr_fwiSub_16sc_C3RSfs(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, scaleFactor);
    default:
        assert(false);
        return _refr_fwiSub_16sc_C3RSfs(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiSubC_32fc_AC4R( const Fw32fc *pSrc, int srcStep, const Fw32fc  value[3], Fw32fc *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiSubC_32fc_AC4R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiSubC_32fc_AC4R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiSubC_32fc_AC4R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiSubC_32fc_AC4R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiThreshold_32f_AC4R( const Fw32f *pSrc, int srcStep, Fw32f *pDst, int dstStep, FwiSize roiSize, const Fw32f threshold[3], FwCmpOp fwCmpOp)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiThreshold_32f_AC4R(pSrc, srcStep, pDst, dstStep, roiSize, threshold, fwCmpOp);
    case DT_SSE2:
        return _sse2_fwiThreshold_32f_AC4R(pSrc, srcStep, pDst, dstStep, roiSize, threshold, fwCmpOp);
    case DT_REFR:
        return _refr_fwiThreshold_32f_AC4R(pSrc, srcStep, pDst, dstStep, roiSize, threshold, fwCmpOp);
    default:
        assert(false);
        return _refr_fwiThreshold_32f_AC4R(pSrc, srcStep, pDst, dstStep, roiSize, threshold, fwCmpOp);
    }
}

OREFR       FwStatus STDCALL fwiWarpBilinear_32f_C1R(const Fw32f* pSrc, FwiSize srcSize, int srcStep,
								FwiRect srcRoi, Fw32f* pDst, int dstStep, FwiRect dstRoi,
								const double coeffs[2][4], int interpolation)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiWarpBilinear_32f_C1R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, coeffs, interpolation);
    default:
        assert(false);
        return _refr_fwiWarpBilinear_32f_C1R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, coeffs, interpolation);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiAndC_16u_C3R( const Fw16u  *pSrc, int srcStep, const Fw16u value[3], Fw16u *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiAndC_16u_C3R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiAndC_16u_C3R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiAndC_16u_C3R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiAndC_16u_C3R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiFilterLaplace_8u16s_C1R( const Fw8u * pSrc, int srcStep, Fw16s * pDst, int dstStep, FwiSize dstRoiSize, FwiMaskSize maskSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilterLaplace_8u16s_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize);
    case DT_REFR:
        return _refr_fwiFilterLaplace_8u16s_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize);
    default:
        assert(false);
        return _refr_fwiFilterLaplace_8u16s_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiCompare_16s_C4R( const Fw16s *pSrc1, int src1Step, const Fw16s *pSrc2, int src2Step, Fw8u *pDst, int dstStep, FwiSize roiSize, FwCmpOp fwCmpOp )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiCompare_16s_C4R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, fwCmpOp);
    case DT_SSE2:
        return _sse2_fwiCompare_16s_C4R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, fwCmpOp);
    case DT_REFR:
        return _refr_fwiCompare_16s_C4R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, fwCmpOp);
    default:
        assert(false);
        return _refr_fwiCompare_16s_C4R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, fwCmpOp);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiFilterSobelVert_16s_AC4R( const Fw16s * pSrc, int srcStep, Fw16s * pDst, int dstStep, FwiSize dstRoiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilterSobelVert_16s_AC4R(pSrc, srcStep, pDst, dstStep, dstRoiSize);
    case DT_REFR:
        return _refr_fwiFilterSobelVert_16s_AC4R(pSrc, srcStep, pDst, dstStep, dstRoiSize);
    default:
        assert(false);
        return _refr_fwiFilterSobelVert_16s_AC4R(pSrc, srcStep, pDst, dstStep, dstRoiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiConvert_8u16u_C4R( const Fw8u *pSrc, int srcStep, Fw16u *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiConvert_8u16u_C4R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiConvert_8u16u_C4R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiConvert_8u16u_C4R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiConvert_8u16u_C4R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2         FwStatus fwiSum_16s_AC4R(const Fw16s* pSrc, int srcStep,FwiSize roiSize, Fw64f sum[3])
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiSum_16s_AC4R(pSrc, srcStep, roiSize, sum);
    case DT_REFR:
        return _refr_fwiSum_16s_AC4R(pSrc, srcStep, roiSize, sum);
    default:
        assert(false);
        return _refr_fwiSum_16s_AC4R(pSrc, srcStep, roiSize, sum);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiConvert_8u32f_C1R( const Fw8u *pSrc, int srcStep, Fw32f *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiConvert_8u32f_C1R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiConvert_8u32f_C1R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiConvert_8u32f_C1R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiConvert_8u32f_C1R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiAnd_8u_C4IR( const Fw8u	*pSrc,  int srcStep,        Fw8u *pSrcDst, int srcDstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiAnd_8u_C4IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiAnd_8u_C4IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    case DT_REFR:
        return _refr_fwiAnd_8u_C4IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiAnd_8u_C4IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiXor_16u_C1R( const Fw16u *pSrc1, int src1Step, const Fw16u *pSrc2,   int src2Step, Fw16u *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiXor_16u_C1R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiXor_16u_C1R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiXor_16u_C1R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiXor_16u_C1R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiMulScale_16u_C3R(  const Fw16u *pSrc1, int src1Step, const Fw16u *pSrc2,   int src2Step, Fw16u *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiMulScale_16u_C3R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiMulScale_16u_C3R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiMulScale_16u_C3R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiMulScale_16u_C3R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    }
}

OREFR       FwStatus STDCALL fwiWarpBilinear_8u_P3R(const Fw8u* const pSrc[3], FwiSize srcSize, int srcStep,
								FwiRect srcRoi, Fw8u* const pDst[3], int dstStep, FwiRect dstRoi,
								const double coeffs[2][4], int interpolation)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiWarpBilinear_8u_P3R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, coeffs, interpolation);
    default:
        assert(false);
        return _refr_fwiWarpBilinear_8u_P3R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, coeffs, interpolation);
    }
}

OREFR             FwStatus STDCALL fwiScale_8u32f_C3R( const Fw8u * pSrc, int srcStep, Fw32f * pDst, int dstStep, FwiSize roiSize, Fw32f vMin, Fw32f vMax )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiScale_8u32f_C3R(pSrc, srcStep, pDst, dstStep, roiSize, vMin, vMax);
    default:
        assert(false);
        return _refr_fwiScale_8u32f_C3R(pSrc, srcStep, pDst, dstStep, roiSize, vMin, vMax);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiMirror_16u_C3R( const Fw16u *pSrc, int srcStep, Fw16u *pDst, int dstStep, FwiSize roiSize, FwiAxis flip)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiMirror_16u_C3R(pSrc, srcStep, pDst, dstStep, roiSize, flip);
    case DT_REFR:
        return _refr_fwiMirror_16u_C3R(pSrc, srcStep, pDst, dstStep, roiSize, flip);
    default:
        assert(false);
        return _refr_fwiMirror_16u_C3R(pSrc, srcStep, pDst, dstStep, roiSize, flip);
    }
}

OREFR             FwStatus STDCALL fwiScale_16u8u_C3R( const Fw16u * pSrc, int srcStep, Fw8u * pDst, int dstStep, FwiSize roiSize, FwHintAlgorithm hint )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiScale_16u8u_C3R(pSrc, srcStep, pDst, dstStep, roiSize, hint);
    default:
        assert(false);
        return _refr_fwiScale_16u8u_C3R(pSrc, srcStep, pDst, dstStep, roiSize, hint);
    }
}

OREFR               FwStatus fwiRGBToXYZ_16s_C3R( const Fw16s* pSrc, int srcStep, Fw16s* pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiRGBToXYZ_16s_C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiRGBToXYZ_16s_C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiThreshold_32f_C1IR( Fw32f *pSrcDst, int srcDstStep, FwiSize roiSize, Fw32f threshold, FwCmpOp fwCmpOp)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiThreshold_32f_C1IR(pSrcDst, srcDstStep, roiSize, threshold, fwCmpOp);
    case DT_SSE2:
        return _sse2_fwiThreshold_32f_C1IR(pSrcDst, srcDstStep, roiSize, threshold, fwCmpOp);
    case DT_REFR:
        return _refr_fwiThreshold_32f_C1IR(pSrcDst, srcDstStep, roiSize, threshold, fwCmpOp);
    default:
        assert(false);
        return _refr_fwiThreshold_32f_C1IR(pSrcDst, srcDstStep, roiSize, threshold, fwCmpOp);
    }
}


OREFR OSSE2         FwStatus fwiMin_8u_C1R(const Fw8u* pSrc, int srcStep,FwiSize roiSize, Fw8u* pMin)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiMin_8u_C1R(pSrc, srcStep, roiSize, pMin);
    case DT_REFR:
        return _refr_fwiMin_8u_C1R(pSrc, srcStep, roiSize, pMin);
    default:
        assert(false);
        return _refr_fwiMin_8u_C1R(pSrc, srcStep, roiSize, pMin);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiXorC_32s_AC4IR( const Fw32s value[3], Fw32s *pSrcDst, int srcDstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiXorC_32s_AC4IR(value, pSrcDst, srcDstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiXorC_32s_AC4IR(value, pSrcDst, srcDstStep, roiSize);
    case DT_REFR:
        return _refr_fwiXorC_32s_AC4IR(value, pSrcDst, srcDstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiXorC_32s_AC4IR(value, pSrcDst, srcDstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiSub_16sc_AC4IRSfs( const Fw16sc *pSrc,  int srcStep,        Fw16sc *pSrcDst, int srcDstStep, FwiSize roiSize, int scaleFactor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiSub_16sc_AC4IRSfs(pSrc, srcStep, pSrcDst, srcDstStep, roiSize, scaleFactor);
    case DT_SSE2:
        return _sse2_fwiSub_16sc_AC4IRSfs(pSrc, srcStep, pSrcDst, srcDstStep, roiSize, scaleFactor);
    case DT_REFR:
        return _refr_fwiSub_16sc_AC4IRSfs(pSrc, srcStep, pSrcDst, srcDstStep, roiSize, scaleFactor);
    default:
        assert(false);
        return _refr_fwiSub_16sc_AC4IRSfs(pSrc, srcStep, pSrcDst, srcDstStep, roiSize, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiSet_16s_C3CR(		Fw16s  value,    Fw16s  * pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiSet_16s_C3CR(value, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiSet_16s_C3CR(value, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiSet_16s_C3CR(value, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiSet_16s_C3CR(value, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiThreshold_Val_8u_C1R( const Fw8u *pSrc, int srcStep, Fw8u *pDst, int dstStep, FwiSize roiSize, Fw8u threshold, Fw8u value, FwCmpOp fwCmpOp)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiThreshold_Val_8u_C1R(pSrc, srcStep, pDst, dstStep, roiSize, threshold, value, fwCmpOp);
    case DT_SSE2:
        return _sse2_fwiThreshold_Val_8u_C1R(pSrc, srcStep, pDst, dstStep, roiSize, threshold, value, fwCmpOp);
    case DT_REFR:
        return _refr_fwiThreshold_Val_8u_C1R(pSrc, srcStep, pDst, dstStep, roiSize, threshold, value, fwCmpOp);
    default:
        assert(false);
        return _refr_fwiThreshold_Val_8u_C1R(pSrc, srcStep, pDst, dstStep, roiSize, threshold, value, fwCmpOp);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiXorC_32s_C4R( const Fw32s  *pSrc, int srcStep, const Fw32s value[4], Fw32s *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiXorC_32s_C4R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiXorC_32s_C4R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiXorC_32s_C4R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiXorC_32s_C4R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    }
}

OREFR               FwStatus fwiRGBToLUV_32f_AC4R( const Fw32f* pSrc, int srcStep, Fw32f* pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiRGBToLUV_32f_AC4R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiRGBToLUV_32f_AC4R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiSqrt_8u_AC4IRSfs(       Fw8u *pSrcDst, int srcDstStep, FwiSize roiSize, int scaleFactor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiSqrt_8u_AC4IRSfs(pSrcDst, srcDstStep, roiSize, scaleFactor);
    case DT_SSE2:
        return _sse2_fwiSqrt_8u_AC4IRSfs(pSrcDst, srcDstStep, roiSize, scaleFactor);
    case DT_REFR:
        return _refr_fwiSqrt_8u_AC4IRSfs(pSrcDst, srcDstStep, roiSize, scaleFactor);
    default:
        assert(false);
        return _refr_fwiSqrt_8u_AC4IRSfs(pSrcDst, srcDstStep, roiSize, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiSqr_32f_C3R( const Fw32f *pSrc,    int srcStep, Fw32f *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiSqr_32f_C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiSqr_32f_C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiSqr_32f_C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiSqr_32f_C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR               FwStatus fwiRGBToYCC_8u_AC4R( const Fw8u *pSrc, int srcStep, Fw8u *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiRGBToYCC_8u_AC4R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiRGBToYCC_8u_AC4R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR       FwStatus STDCALL fwiResizeSqrPixel_32f_AC4R(const Fw32f* pSrc, FwiSize srcSize, int srcStep, FwiRect srcRoi,
			Fw32f* pDst, int dstStep, FwiRect dstRoi, double xFactor, double yFactor,
			double xShift, double yShift, int interpolation, Fw8u* pBuffer)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiResizeSqrPixel_32f_AC4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, xFactor, yFactor, xShift, yShift, interpolation, pBuffer);
    default:
        assert(false);
        return _refr_fwiResizeSqrPixel_32f_AC4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, xFactor, yFactor, xShift, yShift, interpolation, pBuffer);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiRemap_8u_P3R( const Fw8u* const pSrc[3], FwiSize srcSize, int srcStep, FwiRect srcRoi, const Fw32f* pxMap, int xMapStep, const Fw32f* pyMap, int yMapStep, Fw8u* const pDst[3], int dstStep, FwiSize dstRoiSize, int interpolation )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiRemap_8u_P3R(pSrc, srcSize, srcStep, srcRoi, pxMap, xMapStep, pyMap, yMapStep, pDst, dstStep, dstRoiSize, interpolation);
    case DT_REFR:
        return _refr_fwiRemap_8u_P3R(pSrc, srcSize, srcStep, srcRoi, pxMap, xMapStep, pyMap, yMapStep, pDst, dstStep, dstRoiSize, interpolation);
    default:
        assert(false);
        return _refr_fwiRemap_8u_P3R(pSrc, srcSize, srcStep, srcRoi, pxMap, xMapStep, pyMap, yMapStep, pDst, dstStep, dstRoiSize, interpolation);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiAdd_8u_C3IRSfs( const Fw8u   *pSrc,  int srcStep,		Fw8u   *pSrcDst, int srcDstStep, FwiSize roiSize, int scaleFactor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiAdd_8u_C3IRSfs(pSrc, srcStep, pSrcDst, srcDstStep, roiSize, scaleFactor);
    case DT_SSE2:
        return _sse2_fwiAdd_8u_C3IRSfs(pSrc, srcStep, pSrcDst, srcDstStep, roiSize, scaleFactor);
    case DT_REFR:
        return _refr_fwiAdd_8u_C3IRSfs(pSrc, srcStep, pSrcDst, srcDstStep, roiSize, scaleFactor);
    default:
        assert(false);
        return _refr_fwiAdd_8u_C3IRSfs(pSrc, srcStep, pSrcDst, srcDstStep, roiSize, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiOr_16u_C4IR( const Fw16u *pSrc,  int srcStep,        Fw16u *pSrcDst, int srcDstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiOr_16u_C4IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiOr_16u_C4IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    case DT_REFR:
        return _refr_fwiOr_16u_C4IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiOr_16u_C4IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    }
}

OREFR OSSE2 FwStatus STDCALL fwiWarpAffine_16u_C3R( const Fw16u* pSrc, FwiSize srcSize, int srcStep,
								FwiRect srcRoi, Fw16u* pDst, int dstStep, FwiRect dstRoi,
								const double coeffs[2][3], int interpolation )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiWarpAffine_16u_C3R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, coeffs, interpolation);
    case DT_REFR:
        return _refr_fwiWarpAffine_16u_C3R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, coeffs, interpolation);
    default:
        assert(false);
        return _refr_fwiWarpAffine_16u_C3R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, coeffs, interpolation);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiThreshold_Val_16s_AC4IR( Fw16s *pSrcDst, int srcDstStep, FwiSize roiSize, const Fw16s threshold[3], const Fw16s value[3], FwCmpOp fwCmpOp)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiThreshold_Val_16s_AC4IR(pSrcDst, srcDstStep, roiSize, threshold, value, fwCmpOp);
    case DT_SSE2:
        return _sse2_fwiThreshold_Val_16s_AC4IR(pSrcDst, srcDstStep, roiSize, threshold, value, fwCmpOp);
    case DT_REFR:
        return _refr_fwiThreshold_Val_16s_AC4IR(pSrcDst, srcDstStep, roiSize, threshold, value, fwCmpOp);
    default:
        assert(false);
        return _refr_fwiThreshold_Val_16s_AC4IR(pSrcDst, srcDstStep, roiSize, threshold, value, fwCmpOp);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiFilterSobelCross_32f_C1R( const Fw32f * pSrc, int srcStep, Fw32f * pDst, int dstStep, FwiSize dstRoiSize, FwiMaskSize mask )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilterSobelCross_32f_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize, mask);
    case DT_REFR:
        return _refr_fwiFilterSobelCross_32f_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize, mask);
    default:
        assert(false);
        return _refr_fwiFilterSobelCross_32f_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize, mask);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiDiv_16s_C1RSfs( const Fw16s  *pSrc1, int src1Step, const Fw16s  *pSrc2,   int src2Step, Fw16s  *pDst, int dstStep, FwiSize roiSize, int scaleFactor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiDiv_16s_C1RSfs(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, scaleFactor);
    case DT_SSE2:
        return _sse2_fwiDiv_16s_C1RSfs(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, scaleFactor);
    case DT_REFR:
        return _refr_fwiDiv_16s_C1RSfs(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, scaleFactor);
    default:
        assert(false);
        return _refr_fwiDiv_16s_C1RSfs(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, scaleFactor);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiMirror_32s_AC4IR(Fw32s *pSrcDst, int srcDstStep, FwiSize roiSize, FwiAxis flip)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiMirror_32s_AC4IR(pSrcDst, srcDstStep, roiSize, flip);
    case DT_REFR:
        return _refr_fwiMirror_32s_AC4IR(pSrcDst, srcDstStep, roiSize, flip);
    default:
        assert(false);
        return _refr_fwiMirror_32s_AC4IR(pSrcDst, srcDstStep, roiSize, flip);
    }
}

OREFR OSSE2 FwStatus STDCALL fwiWarpAffineBack_32f_AC4R( const Fw32f* pSrc, FwiSize srcSize, int srcStep,
								FwiRect srcRoi, Fw32f* pDst, int dstStep, FwiRect dstRoi,
								const double coeffs[2][3], int interpolation )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiWarpAffineBack_32f_AC4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, coeffs, interpolation);
    case DT_REFR:
        return _refr_fwiWarpAffineBack_32f_AC4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, coeffs, interpolation);
    default:
        assert(false);
        return _refr_fwiWarpAffineBack_32f_AC4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, coeffs, interpolation);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiDivC_32fc_C3R( const Fw32fc *pSrc, int srcStep, const Fw32fc value[3], Fw32fc *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiDivC_32fc_C3R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiDivC_32fc_C3R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiDivC_32fc_C3R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiDivC_32fc_C3R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    }
}

OREFR               FwStatus fwiYCbCrToBGR565_8u16u_P3C3R(const A8U* const pSrc[3], int srcStep, A16U* pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiYCbCrToBGR565_8u16u_P3C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiYCbCrToBGR565_8u16u_P3C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiFilterMedianHoriz_8u_C4R( const Fw8u * pSrc, int srcStep,
                                               Fw8u * pDst, int dstStep, FwiSize dstRoiSize,
                                               FwiMaskSize maskSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilterMedianHoriz_8u_C4R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize);
    case DT_REFR:
        return _refr_fwiFilterMedianHoriz_8u_C4R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize);
    default:
        assert(false);
        return _refr_fwiFilterMedianHoriz_8u_C4R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiFilter_8u_C4R( const Fw8u * pSrc, int srcStep,
                             Fw8u * pDst, int dstStep, FwiSize dstRoiSize,
                             const Fw32s * pKernel, FwiSize kernelSize,
                             FwiPoint anchor, int divisor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilter_8u_C4R(pSrc, srcStep, pDst, dstStep, dstRoiSize, pKernel, kernelSize, anchor, divisor);
    case DT_REFR:
        return _refr_fwiFilter_8u_C4R(pSrc, srcStep, pDst, dstStep, dstRoiSize, pKernel, kernelSize, anchor, divisor);
    default:
        assert(false);
        return _refr_fwiFilter_8u_C4R(pSrc, srcStep, pDst, dstStep, dstRoiSize, pKernel, kernelSize, anchor, divisor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiMulScale_16u_AC4IR(  const Fw16u *pSrc,  int srcStep,        Fw16u *pSrcDst, int srcDstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiMulScale_16u_AC4IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiMulScale_16u_AC4IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    case DT_REFR:
        return _refr_fwiMulScale_16u_AC4IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiMulScale_16u_AC4IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    }
}


OREFR OSSE2         FwStatus fwiSum_32f_C3R(const Fw32f* pSrc, int srcStep,FwiSize roiSize, Fw64f sum[3], FwHintAlgorithm hint)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiSum_32f_C3R(pSrc, srcStep, roiSize, sum, hint);
    case DT_REFR:
        return _refr_fwiSum_32f_C3R(pSrc, srcStep, roiSize, sum, hint);
    default:
        assert(false);
        return _refr_fwiSum_32f_C3R(pSrc, srcStep, roiSize, sum, hint);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiCopy_32f_C3R( const Fw32f *pSrc, int srcStep, Fw32f *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiCopy_32f_C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiCopy_32f_C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiCopy_32f_C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiCopy_32f_C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiSubC_8u_C3IRSfs( const Fw8u value[3], Fw8u *pSrcDst, int srcDstStep, FwiSize roiSize, int scaleFactor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiSubC_8u_C3IRSfs(value, pSrcDst, srcDstStep, roiSize, scaleFactor);
    case DT_SSE2:
        return _sse2_fwiSubC_8u_C3IRSfs(value, pSrcDst, srcDstStep, roiSize, scaleFactor);
    case DT_REFR:
        return _refr_fwiSubC_8u_C3IRSfs(value, pSrcDst, srcDstStep, roiSize, scaleFactor);
    default:
        assert(false);
        return _refr_fwiSubC_8u_C3IRSfs(value, pSrcDst, srcDstStep, roiSize, scaleFactor);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiFilterMedian_16s_C3R( const Fw16s * pSrc, int srcStep,
                                           Fw16s * pDst, int dstStep, FwiSize dstRoiSize,
                                           FwiSize maskSize, FwiPoint anchor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilterMedian_16s_C3R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize, anchor);
    case DT_REFR:
        return _refr_fwiFilterMedian_16s_C3R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize, anchor);
    default:
        assert(false);
        return _refr_fwiFilterMedian_16s_C3R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize, anchor);
    }
}

OREFR             FwStatus STDCALL fwiConvert_8s32f_AC4R( const Fw8s *pSrc, int srcStep, Fw32f *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiConvert_8s32f_AC4R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiConvert_8s32f_AC4R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiFilterMedianColor_32f_AC4R( const Fw32f * pSrc, int srcStep,
                                                  Fw32f * pDst, int dstStep, FwiSize dstRoiSize,
                                                  FwiMaskSize maskSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilterMedianColor_32f_AC4R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize);
    case DT_REFR:
        return _refr_fwiFilterMedianColor_32f_AC4R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize);
    default:
        assert(false);
        return _refr_fwiFilterMedianColor_32f_AC4R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize);
    }
}

OREFR OSSE2 OF10H   FwStatus fwiYCbCrToRGB_8u_C3R( const Fw8u* pSrc, int srcStep, Fw8u* pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiYCbCrToRGB_8u_C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiYCbCrToRGB_8u_C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiYCbCrToRGB_8u_C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiYCbCrToRGB_8u_C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiFilter_16s_C1R( const Fw16s * pSrc, int srcStep,
                              Fw16s * pDst, int dstStep, FwiSize dstRoiSize,
                              const Fw32s * pKernel, FwiSize kernelSize,
                              FwiPoint anchor, int divisor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilter_16s_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize, pKernel, kernelSize, anchor, divisor);
    case DT_REFR:
        return _refr_fwiFilter_16s_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize, pKernel, kernelSize, anchor, divisor);
    default:
        assert(false);
        return _refr_fwiFilter_16s_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize, pKernel, kernelSize, anchor, divisor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiOr_32s_C1R( const Fw32s *pSrc1, int src1Step, const Fw32s *pSrc2,   int src2Step, Fw32s *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiOr_32s_C1R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiOr_32s_C1R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiOr_32s_C1R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiOr_32s_C1R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiSub_32fc_C3R( const Fw32fc *pSrc1, int src1Step, const Fw32fc *pSrc2,   int src2Step, Fw32fc *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiSub_32fc_C3R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiSub_32fc_C3R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiSub_32fc_C3R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiSub_32fc_C3R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiMulScale_16u_C3IR(  const Fw16u *pSrc,  int srcStep,        Fw16u *pSrcDst, int srcDstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiMulScale_16u_C3IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiMulScale_16u_C3IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    case DT_REFR:
        return _refr_fwiMulScale_16u_C3IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiMulScale_16u_C3IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    }
}

OREFR               FwStatus fwiYCbCr422ToRGB_8u_C2P3R(const A8U* pSrc, int srcStep, A8U* const pDst[3], int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiYCbCr422ToRGB_8u_C2P3R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiYCbCr422ToRGB_8u_C2P3R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR               FwStatus fwiRGBToHLS_32f_AC4R( const Fw32f* pSrc, int srcStep, Fw32f* pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiRGBToHLS_32f_AC4R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiRGBToHLS_32f_AC4R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiMulC_32sc_C1RSfs( const Fw32sc *pSrc, int srcStep,       Fw32sc value,    Fw32sc *pDst, int dstStep, FwiSize roiSize, int scaleFactor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiMulC_32sc_C1RSfs(pSrc, srcStep, value, pDst, dstStep, roiSize, scaleFactor);
    case DT_SSE2:
        return _sse2_fwiMulC_32sc_C1RSfs(pSrc, srcStep, value, pDst, dstStep, roiSize, scaleFactor);
    case DT_REFR:
        return _refr_fwiMulC_32sc_C1RSfs(pSrc, srcStep, value, pDst, dstStep, roiSize, scaleFactor);
    default:
        assert(false);
        return _refr_fwiMulC_32sc_C1RSfs(pSrc, srcStep, value, pDst, dstStep, roiSize, scaleFactor);
    }
}


OREFR OSSE2 FwStatus STDCALL fwiResizeSqrPixel_8u_C1R(const Fw8u* pSrc, FwiSize srcSize, int srcStep, FwiRect srcRoi,
			Fw8u* pDst, int dstStep, FwiRect dstRoi, double xFactor, double yFactor,
			double xShift, double yShift, int interpolation, Fw8u* pBuffer)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiResizeSqrPixel_8u_C1R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, xFactor, yFactor, xShift, yShift, interpolation, pBuffer);
    case DT_REFR:
        return _refr_fwiResizeSqrPixel_8u_C1R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, xFactor, yFactor, xShift, yShift, interpolation, pBuffer);
    default:
        assert(false);
        return _refr_fwiResizeSqrPixel_8u_C1R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, xFactor, yFactor, xShift, yShift, interpolation, pBuffer);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiFilterMedianCross_8u_AC4R( const Fw8u * pSrc, int srcStep,
                                                Fw8u * pDst, int dstStep, FwiSize dstRoiSize,
                                                FwiMaskSize maskSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilterMedianCross_8u_AC4R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize);
    case DT_REFR:
        return _refr_fwiFilterMedianCross_8u_AC4R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize);
    default:
        assert(false);
        return _refr_fwiFilterMedianCross_8u_AC4R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiDiv_32fc_AC4R( const Fw32fc *pSrc1, int src1Step, const Fw32fc *pSrc2,   int src2Step, Fw32fc *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiDiv_32fc_AC4R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiDiv_32fc_AC4R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiDiv_32fc_AC4R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiDiv_32fc_AC4R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiCopy_8u_C1C3R( const Fw8u *pSrc, int srcStep, Fw8u *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiCopy_8u_C1C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiCopy_8u_C1C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiCopy_8u_C1C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiCopy_8u_C1C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiCopy_16s_P3C3R( const Fw16s * const pSrc[3], int srcStep, Fw16s *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiCopy_16s_P3C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiCopy_16s_P3C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiCopy_16s_P3C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiCopy_16s_P3C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiCompare_8u_C4R( const Fw8u *pSrc1, int src1Step, const Fw8u *pSrc2, int src2Step, Fw8u *pDst, int dstStep, FwiSize roiSize, FwCmpOp fwCmpOp )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiCompare_8u_C4R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, fwCmpOp);
    case DT_SSE2:
        return _sse2_fwiCompare_8u_C4R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, fwCmpOp);
    case DT_REFR:
        return _refr_fwiCompare_8u_C4R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, fwCmpOp);
    default:
        assert(false);
        return _refr_fwiCompare_8u_C4R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, fwCmpOp);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiMul_16sc_C3RSfs( const Fw16sc *pSrc1, int src1Step, const Fw16sc *pSrc2,   int src2Step, Fw16sc *pDst, int dstStep, FwiSize roiSize, int scaleFactor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiMul_16sc_C3RSfs(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, scaleFactor);
    case DT_SSE2:
        return _sse2_fwiMul_16sc_C3RSfs(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, scaleFactor);
    case DT_REFR:
        return _refr_fwiMul_16sc_C3RSfs(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, scaleFactor);
    default:
        assert(false);
        return _refr_fwiMul_16sc_C3RSfs(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, scaleFactor);
    }
}

OREFR       FwStatus STDCALL fwiShear_8u_P3R(const Fw8u* const pSrc[3], FwiSize srcSize, int srcStep, FwiRect srcRoi, Fw8u* const pDst[3], int dstStep, FwiRect dstRoi, double xShear, double yShear, double xShift, double yShift, int interpolation)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiShear_8u_P3R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, xShear, yShear, xShift, yShift, interpolation);
    default:
        assert(false);
        return _refr_fwiShear_8u_P3R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, xShear, yShear, xShift, yShift, interpolation);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiExp_32f_C1IR(       Fw32f *pSrcDst, int srcDstStep,  FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiExp_32f_C1IR(pSrcDst, srcDstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiExp_32f_C1IR(pSrcDst, srcDstStep, roiSize);
    case DT_REFR:
        return _refr_fwiExp_32f_C1IR(pSrcDst, srcDstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiExp_32f_C1IR(pSrcDst, srcDstStep, roiSize);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiRemap_32f_C1R( const Fw32f* pSrc, FwiSize srcSize, int srcStep, FwiRect srcRoi, const Fw32f* pxMap, int xMapStep, const Fw32f* pyMap, int yMapStep, Fw32f* pDst, int dstStep, FwiSize dstRoiSize, int interpolation )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiRemap_32f_C1R(pSrc, srcSize, srcStep, srcRoi, pxMap, xMapStep, pyMap, yMapStep, pDst, dstStep, dstRoiSize, interpolation);
    case DT_REFR:
        return _refr_fwiRemap_32f_C1R(pSrc, srcSize, srcStep, srcRoi, pxMap, xMapStep, pyMap, yMapStep, pDst, dstStep, dstRoiSize, interpolation);
    default:
        assert(false);
        return _refr_fwiRemap_32f_C1R(pSrc, srcSize, srcStep, srcRoi, pxMap, xMapStep, pyMap, yMapStep, pDst, dstStep, dstRoiSize, interpolation);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiSub_32sc_C1IRSfs( const Fw32sc *pSrc,  int srcStep,        Fw32sc *pSrcDst, int srcDstStep, FwiSize roiSize, int scaleFactor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiSub_32sc_C1IRSfs(pSrc, srcStep, pSrcDst, srcDstStep, roiSize, scaleFactor);
    case DT_SSE2:
        return _sse2_fwiSub_32sc_C1IRSfs(pSrc, srcStep, pSrcDst, srcDstStep, roiSize, scaleFactor);
    case DT_REFR:
        return _refr_fwiSub_32sc_C1IRSfs(pSrc, srcStep, pSrcDst, srcDstStep, roiSize, scaleFactor);
    default:
        assert(false);
        return _refr_fwiSub_32sc_C1IRSfs(pSrc, srcStep, pSrcDst, srcDstStep, roiSize, scaleFactor);
    }
}


OREFR OSSE2       FwStatus STDCALL fwiFilterSobelVert_8u_C1R( const Fw8u * pSrc, int srcStep, Fw8u * pDst, int dstStep, FwiSize dstRoiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilterSobelVert_8u_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize);
    case DT_REFR:
        return _refr_fwiFilterSobelVert_8u_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize);
    default:
        assert(false);
        return _refr_fwiFilterSobelVert_8u_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize);
    }
}

OREFR OSSE2 FwStatus STDCALL fwiFilterSharpen_8u_C3R( const Fw8u * pSrc, int srcStep, Fw8u * pDst, int dstStep, FwiSize dstRoiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilterSharpen_8u_C3R(pSrc, srcStep, pDst, dstStep, dstRoiSize);
    case DT_REFR:
        return _refr_fwiFilterSharpen_8u_C3R(pSrc, srcStep, pDst, dstStep, dstRoiSize);
    default:
        assert(false);
        return _refr_fwiFilterSharpen_8u_C3R(pSrc, srcStep, pDst, dstStep, dstRoiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiThreshold_Val_16s_C1IR( Fw16s *pSrcDst, int srcDstStep, FwiSize roiSize, Fw16s threshold, Fw16s value, FwCmpOp fwCmpOp)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiThreshold_Val_16s_C1IR(pSrcDst, srcDstStep, roiSize, threshold, value, fwCmpOp);
    case DT_SSE2:
        return _sse2_fwiThreshold_Val_16s_C1IR(pSrcDst, srcDstStep, roiSize, threshold, value, fwCmpOp);
    case DT_REFR:
        return _refr_fwiThreshold_Val_16s_C1IR(pSrcDst, srcDstStep, roiSize, threshold, value, fwCmpOp);
    default:
        assert(false);
        return _refr_fwiThreshold_Val_16s_C1IR(pSrcDst, srcDstStep, roiSize, threshold, value, fwCmpOp);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiDiv_16sc_AC4IRSfs( const Fw16sc *pSrc,  int srcStep,        Fw16sc *pSrcDst, int srcDstStep, FwiSize roiSize, int scaleFactor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiDiv_16sc_AC4IRSfs(pSrc, srcStep, pSrcDst, srcDstStep, roiSize, scaleFactor);
    case DT_SSE2:
        return _sse2_fwiDiv_16sc_AC4IRSfs(pSrc, srcStep, pSrcDst, srcDstStep, roiSize, scaleFactor);
    case DT_REFR:
        return _refr_fwiDiv_16sc_AC4IRSfs(pSrc, srcStep, pSrcDst, srcDstStep, roiSize, scaleFactor);
    default:
        assert(false);
        return _refr_fwiDiv_16sc_AC4IRSfs(pSrc, srcStep, pSrcDst, srcDstStep, roiSize, scaleFactor);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiFilterPrewittHoriz_8u_C4R( const Fw8u * pSrc, int srcStep, Fw8u * pDst, int dstStep, FwiSize dstRoiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilterPrewittHoriz_8u_C4R(pSrc, srcStep, pDst, dstStep, dstRoiSize);
    case DT_REFR:
        return _refr_fwiFilterPrewittHoriz_8u_C4R(pSrc, srcStep, pDst, dstStep, dstRoiSize);
    default:
        assert(false);
        return _refr_fwiFilterPrewittHoriz_8u_C4R(pSrc, srcStep, pDst, dstStep, dstRoiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiMulCScale_16u_AC4R( const Fw16u *pSrc, int srcStep, const Fw16u value[4], Fw16u *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiMulCScale_16u_AC4R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiMulCScale_16u_AC4R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiMulCScale_16u_AC4R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiMulCScale_16u_AC4R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    }
}

OREFR       FwStatus STDCALL fwiResizeSqrPixel_8u_P4R(const Fw8u* const pSrc[4], FwiSize srcSize, int srcStep, FwiRect srcRoi,
			Fw8u* const pDst[4], int dstStep, FwiRect dstRoi, double xFactor, double yFactor,
			double xShift, double yShift, int interpolation, Fw8u* pBuffer)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiResizeSqrPixel_8u_P4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, xFactor, yFactor, xShift, yShift, interpolation, pBuffer);
    default:
        assert(false);
        return _refr_fwiResizeSqrPixel_8u_P4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, xFactor, yFactor, xShift, yShift, interpolation, pBuffer);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiFilterBox_32f_C3IR( Fw32f * pSrcDst, int srcDstStep,
                               FwiSize dstRoiSize, FwiSize maskSize, FwiPoint anchor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilterBox_32f_C3IR(pSrcDst, srcDstStep, dstRoiSize, maskSize, anchor);
    case DT_REFR:
        return _refr_fwiFilterBox_32f_C3IR(pSrcDst, srcDstStep, dstRoiSize, maskSize, anchor);
    default:
        assert(false);
        return _refr_fwiFilterBox_32f_C3IR(pSrcDst, srcDstStep, dstRoiSize, maskSize, anchor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiAddC_16s_C1RSfs( const Fw16s  *pSrc, int srcStep,       Fw16s value,    Fw16s *pDst, int dstStep, FwiSize roiSize, int scaleFactor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiAddC_16s_C1RSfs(pSrc, srcStep, value, pDst, dstStep, roiSize, scaleFactor);
    case DT_SSE2:
        return _sse2_fwiAddC_16s_C1RSfs(pSrc, srcStep, value, pDst, dstStep, roiSize, scaleFactor);
    case DT_REFR:
        return _refr_fwiAddC_16s_C1RSfs(pSrc, srcStep, value, pDst, dstStep, roiSize, scaleFactor);
    default:
        assert(false);
        return _refr_fwiAddC_16s_C1RSfs(pSrc, srcStep, value, pDst, dstStep, roiSize, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiCompareEqualEps_32f_C4R( const Fw32f *pSrc1, int src1Step, const Fw32f *pSrc2, int src2Step, Fw8u *pDst, int dstStep, FwiSize roiSize, Fw32f eps)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiCompareEqualEps_32f_C4R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, eps);
    case DT_SSE2:
        return _sse2_fwiCompareEqualEps_32f_C4R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, eps);
    case DT_REFR:
        return _refr_fwiCompareEqualEps_32f_C4R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, eps);
    default:
        assert(false);
        return _refr_fwiCompareEqualEps_32f_C4R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, eps);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiFilterBox_16s_AC4IR( Fw16s * pSrcDst, int srcDstStep,
                               FwiSize dstRoiSize, FwiSize maskSize, FwiPoint anchor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilterBox_16s_AC4IR(pSrcDst, srcDstStep, dstRoiSize, maskSize, anchor);
    case DT_REFR:
        return _refr_fwiFilterBox_16s_AC4IR(pSrcDst, srcDstStep, dstRoiSize, maskSize, anchor);
    default:
        assert(false);
        return _refr_fwiFilterBox_16s_AC4IR(pSrcDst, srcDstStep, dstRoiSize, maskSize, anchor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiOrC_16u_C1IR(       Fw16u value,    Fw16u *pSrcDst, int srcDstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiOrC_16u_C1IR(value, pSrcDst, srcDstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiOrC_16u_C1IR(value, pSrcDst, srcDstStep, roiSize);
    case DT_REFR:
        return _refr_fwiOrC_16u_C1IR(value, pSrcDst, srcDstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiOrC_16u_C1IR(value, pSrcDst, srcDstStep, roiSize);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiFilterMedianVert_16s_C1R( const Fw16s * pSrc, int srcStep,
                                               Fw16s * pDst, int dstStep, FwiSize dstRoiSize,
                                               FwiMaskSize maskSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilterMedianVert_16s_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize);
    case DT_REFR:
        return _refr_fwiFilterMedianVert_16s_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize);
    default:
        assert(false);
        return _refr_fwiFilterMedianVert_16s_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiAbs_32f_C3R( const Fw32f *pSrc, int srcStep, Fw32f *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiAbs_32f_C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiAbs_32f_C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiAbs_32f_C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiAbs_32f_C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiLShiftC_8u_AC4R( const Fw8u   *pSrc, int srcStep, const Fw32u value[3], Fw8u *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiLShiftC_8u_AC4R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiLShiftC_8u_AC4R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiLShiftC_8u_AC4R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiLShiftC_8u_AC4R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiCopy_8u_C4R( const Fw8u *pSrc, int srcStep, Fw8u *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiCopy_8u_C4R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiCopy_8u_C4R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiCopy_8u_C4R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiCopy_8u_C4R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiExp_32f_C3R( const Fw32f *pSrc, int srcStep, Fw32f *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiExp_32f_C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiExp_32f_C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiExp_32f_C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiExp_32f_C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiThreshold_GT_8u_C3R( const Fw8u *pSrc, int srcStep, Fw8u *pDst, int dstStep, FwiSize roiSize, const Fw8u threshold[3])
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiThreshold_GT_8u_C3R(pSrc, srcStep, pDst, dstStep, roiSize, threshold);
    case DT_SSE2:
        return _sse2_fwiThreshold_GT_8u_C3R(pSrc, srcStep, pDst, dstStep, roiSize, threshold);
    case DT_REFR:
        return _refr_fwiThreshold_GT_8u_C3R(pSrc, srcStep, pDst, dstStep, roiSize, threshold);
    default:
        assert(false);
        return _refr_fwiThreshold_GT_8u_C3R(pSrc, srcStep, pDst, dstStep, roiSize, threshold);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiSet_8u_C1MR(       Fw8u  value,    Fw8u  * pDst, int dstStep, FwiSize roiSize, const Fw8u * pMask, int maskStep )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiSet_8u_C1MR(value, pDst, dstStep, roiSize, pMask, maskStep);
    case DT_SSE2:
        return _sse2_fwiSet_8u_C1MR(value, pDst, dstStep, roiSize, pMask, maskStep);
    case DT_REFR:
        return _refr_fwiSet_8u_C1MR(value, pDst, dstStep, roiSize, pMask, maskStep);
    default:
        assert(false);
        return _refr_fwiSet_8u_C1MR(value, pDst, dstStep, roiSize, pMask, maskStep);
    }
}


OREFR OSSE2 OF10H FwStatus STDCALL fwiSet_8u_C1R(       Fw8u  value,    Fw8u  * pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiSet_8u_C1R(value, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiSet_8u_C1R(value, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiSet_8u_C1R(value, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiSet_8u_C1R(value, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiFilterPrewittVert_16s_C4R( const Fw16s * pSrc, int srcStep, Fw16s * pDst, int dstStep, FwiSize dstRoiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilterPrewittVert_16s_C4R(pSrc, srcStep, pDst, dstStep, dstRoiSize);
    case DT_REFR:
        return _refr_fwiFilterPrewittVert_16s_C4R(pSrc, srcStep, pDst, dstStep, dstRoiSize);
    default:
        assert(false);
        return _refr_fwiFilterPrewittVert_16s_C4R(pSrc, srcStep, pDst, dstStep, dstRoiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiDiv_8u_C3IRSfs( const Fw8u   *pSrc,  int srcStep,        Fw8u   *pSrcDst, int srcDstStep, FwiSize roiSize, int scaleFactor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiDiv_8u_C3IRSfs(pSrc, srcStep, pSrcDst, srcDstStep, roiSize, scaleFactor);
    case DT_SSE2:
        return _sse2_fwiDiv_8u_C3IRSfs(pSrc, srcStep, pSrcDst, srcDstStep, roiSize, scaleFactor);
    case DT_REFR:
        return _refr_fwiDiv_8u_C3IRSfs(pSrc, srcStep, pSrcDst, srcDstStep, roiSize, scaleFactor);
    default:
        assert(false);
        return _refr_fwiDiv_8u_C3IRSfs(pSrc, srcStep, pSrcDst, srcDstStep, roiSize, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiThreshold_GTVal_16s_C4R( const Fw16s *pSrc, int srcStep, Fw16s *pDst, int dstStep, FwiSize roiSize, const Fw16s threshold[4], const Fw16s value[4])
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiThreshold_GTVal_16s_C4R(pSrc, srcStep, pDst, dstStep, roiSize, threshold, value);
    case DT_SSE2:
        return _sse2_fwiThreshold_GTVal_16s_C4R(pSrc, srcStep, pDst, dstStep, roiSize, threshold, value);
    case DT_REFR:
        return _refr_fwiThreshold_GTVal_16s_C4R(pSrc, srcStep, pDst, dstStep, roiSize, threshold, value);
    default:
        assert(false);
        return _refr_fwiThreshold_GTVal_16s_C4R(pSrc, srcStep, pDst, dstStep, roiSize, threshold, value);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiSubC_16sc_AC4RSfs( const Fw16sc *pSrc, int srcStep, const Fw16sc value[3], Fw16sc *pDst, int dstStep, FwiSize roiSize, int scaleFactor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiSubC_16sc_AC4RSfs(pSrc, srcStep, value, pDst, dstStep, roiSize, scaleFactor);
    case DT_SSE2:
        return _sse2_fwiSubC_16sc_AC4RSfs(pSrc, srcStep, value, pDst, dstStep, roiSize, scaleFactor);
    case DT_REFR:
        return _refr_fwiSubC_16sc_AC4RSfs(pSrc, srcStep, value, pDst, dstStep, roiSize, scaleFactor);
    default:
        assert(false);
        return _refr_fwiSubC_16sc_AC4RSfs(pSrc, srcStep, value, pDst, dstStep, roiSize, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiXorC_32s_C1IR(       Fw32s value,    Fw32s *pSrcDst, int srcDstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiXorC_32s_C1IR(value, pSrcDst, srcDstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiXorC_32s_C1IR(value, pSrcDst, srcDstStep, roiSize);
    case DT_REFR:
        return _refr_fwiXorC_32s_C1IR(value, pSrcDst, srcDstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiXorC_32s_C1IR(value, pSrcDst, srcDstStep, roiSize);
    }
}

OREFR OSSE2 FwStatus STDCALL fwiWarpAffineBack_8u_C1R( const Fw8u* pSrc, FwiSize srcSize, int srcStep,
								FwiRect srcRoi, Fw8u* pDst, int dstStep, FwiRect dstRoi,
								const double coeffs[2][3], int interpolation )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiWarpAffineBack_8u_C1R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, coeffs, interpolation);
    case DT_REFR:
        return _refr_fwiWarpAffineBack_8u_C1R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, coeffs, interpolation);
    default:
        assert(false);
        return _refr_fwiWarpAffineBack_8u_C1R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, coeffs, interpolation);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiThreshold_Val_32f_AC4IR( Fw32f *pSrcDst, int srcDstStep, FwiSize roiSize, const Fw32f threshold[3], const Fw32f value[3], FwCmpOp fwCmpOp)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiThreshold_Val_32f_AC4IR(pSrcDst, srcDstStep, roiSize, threshold, value, fwCmpOp);
    case DT_SSE2:
        return _sse2_fwiThreshold_Val_32f_AC4IR(pSrcDst, srcDstStep, roiSize, threshold, value, fwCmpOp);
    case DT_REFR:
        return _refr_fwiThreshold_Val_32f_AC4IR(pSrcDst, srcDstStep, roiSize, threshold, value, fwCmpOp);
    default:
        assert(false);
        return _refr_fwiThreshold_Val_32f_AC4IR(pSrcDst, srcDstStep, roiSize, threshold, value, fwCmpOp);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiDiv_32sc_AC4IRSfs( const Fw32sc *pSrc,  int srcStep,        Fw32sc *pSrcDst, int srcDstStep, FwiSize roiSize, int scaleFactor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiDiv_32sc_AC4IRSfs(pSrc, srcStep, pSrcDst, srcDstStep, roiSize, scaleFactor);
    case DT_SSE2:
        return _sse2_fwiDiv_32sc_AC4IRSfs(pSrc, srcStep, pSrcDst, srcDstStep, roiSize, scaleFactor);
    case DT_REFR:
        return _refr_fwiDiv_32sc_AC4IRSfs(pSrc, srcStep, pSrcDst, srcDstStep, roiSize, scaleFactor);
    default:
        assert(false);
        return _refr_fwiDiv_32sc_AC4IRSfs(pSrc, srcStep, pSrcDst, srcDstStep, roiSize, scaleFactor);
    }
}

OREFR       FwStatus STDCALL fwiResizeSqrPixel_8u_P3R(const Fw8u* const pSrc[3], FwiSize srcSize, int srcStep, FwiRect srcRoi,
			Fw8u* const pDst[3], int dstStep, FwiRect dstRoi, double xFactor, double yFactor,
			double xShift, double yShift, int interpolation, Fw8u* pBuffer)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiResizeSqrPixel_8u_P3R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, xFactor, yFactor, xShift, yShift, interpolation, pBuffer);
    default:
        assert(false);
        return _refr_fwiResizeSqrPixel_8u_P3R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, xFactor, yFactor, xShift, yShift, interpolation, pBuffer);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiFilterGauss_32f_C4R( const Fw32f * pSrc, int srcStep, Fw32f * pDst, int dstStep, FwiSize dstRoiSize, FwiMaskSize maskSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilterGauss_32f_C4R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize);
    case DT_REFR:
        return _refr_fwiFilterGauss_32f_C4R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize);
    default:
        assert(false);
        return _refr_fwiFilterGauss_32f_C4R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiThreshold_LT_32f_C1R( const Fw32f *pSrc, int srcStep, Fw32f *pDst, int dstStep, FwiSize roiSize, Fw32f threshold)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiThreshold_LT_32f_C1R(pSrc, srcStep, pDst, dstStep, roiSize, threshold);
    case DT_SSE2:
        return _sse2_fwiThreshold_LT_32f_C1R(pSrc, srcStep, pDst, dstStep, roiSize, threshold);
    case DT_REFR:
        return _refr_fwiThreshold_LT_32f_C1R(pSrc, srcStep, pDst, dstStep, roiSize, threshold);
    default:
        assert(false);
        return _refr_fwiThreshold_LT_32f_C1R(pSrc, srcStep, pDst, dstStep, roiSize, threshold);
    }
}

OREFR       FwStatus STDCALL fwiGetShearQuad(FwiRect srcRoi, double quad[4][2], double xShear, double yShear, double xShift, double yShift)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiGetShearQuad(srcRoi, quad, xShear, yShear, xShift, yShift);
    default:
        assert(false);
        return _refr_fwiGetShearQuad(srcRoi, quad, xShear, yShear, xShift, yShift);
    }
}

OREFR       FwStatus STDCALL fwiResizeSqrPixel_16u_C1R(const Fw16u* pSrc, FwiSize srcSize, int srcStep, FwiRect srcRoi,
			Fw16u* pDst, int dstStep, FwiRect dstRoi, double xFactor, double yFactor,
			double xShift, double yShift, int interpolation, Fw8u* pBuffer)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiResizeSqrPixel_16u_C1R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, xFactor, yFactor, xShift, yShift, interpolation, pBuffer);
    default:
        assert(false);
        return _refr_fwiResizeSqrPixel_16u_C1R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, xFactor, yFactor, xShift, yShift, interpolation, pBuffer);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiFilterHipass_32f_C3R( const Fw32f * pSrc, int srcStep, Fw32f * pDst, int dstStep, FwiSize dstRoiSize, FwiMaskSize maskSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilterHipass_32f_C3R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize);
    case DT_REFR:
        return _refr_fwiFilterHipass_32f_C3R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize);
    default:
        assert(false);
        return _refr_fwiFilterHipass_32f_C3R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize);
    }
}

OREFR               FwStatus fwiHLSToBGR_8u_P3C3R(const A8U* const pSrc[3], int srcStep, A8U* pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiHLSToBGR_8u_P3C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiHLSToBGR_8u_P3C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiAdd_32sc_C1RSfs( const Fw32sc *pSrc1, int src1Step, const Fw32sc *pSrc2,   int src2Step, Fw32sc *pDst, int dstStep, FwiSize roiSize, int scaleFactor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiAdd_32sc_C1RSfs(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, scaleFactor);
    case DT_SSE2:
        return _sse2_fwiAdd_32sc_C1RSfs(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, scaleFactor);
    case DT_REFR:
        return _refr_fwiAdd_32sc_C1RSfs(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, scaleFactor);
    default:
        assert(false);
        return _refr_fwiAdd_32sc_C1RSfs(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiCopy_32s_C1C3R( const Fw32s *pSrc, int srcStep, Fw32s *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiCopy_32s_C1C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiCopy_32s_C1C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiCopy_32s_C1C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiCopy_32s_C1C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiMul_16sc_AC4IRSfs( const Fw16sc *pSrc,  int srcStep,        Fw16sc *pSrcDst, int srcDstStep, FwiSize roiSize, int scaleFactor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiMul_16sc_AC4IRSfs(pSrc, srcStep, pSrcDst, srcDstStep, roiSize, scaleFactor);
    case DT_SSE2:
        return _sse2_fwiMul_16sc_AC4IRSfs(pSrc, srcStep, pSrcDst, srcDstStep, roiSize, scaleFactor);
    case DT_REFR:
        return _refr_fwiMul_16sc_AC4IRSfs(pSrc, srcStep, pSrcDst, srcDstStep, roiSize, scaleFactor);
    default:
        assert(false);
        return _refr_fwiMul_16sc_AC4IRSfs(pSrc, srcStep, pSrcDst, srcDstStep, roiSize, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiAndC_8u_AC4R( const Fw8u   *pSrc, int srcStep, const Fw8u value[3], Fw8u *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiAndC_8u_AC4R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiAndC_8u_AC4R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiAndC_8u_AC4R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiAndC_8u_AC4R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiConvert_16s8u_C3R( const Fw16s *pSrc, int srcStep, Fw8u *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiConvert_16s8u_C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiConvert_16s8u_C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiConvert_16s8u_C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiConvert_16s8u_C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiThreshold_LTVal_8u_AC4IR( Fw8u *pSrcDst, int srcDstStep, FwiSize roiSize, const Fw8u threshold[3], const Fw8u value[3])
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiThreshold_LTVal_8u_AC4IR(pSrcDst, srcDstStep, roiSize, threshold, value);
    case DT_SSE2:
        return _sse2_fwiThreshold_LTVal_8u_AC4IR(pSrcDst, srcDstStep, roiSize, threshold, value);
    case DT_REFR:
        return _refr_fwiThreshold_LTVal_8u_AC4IR(pSrcDst, srcDstStep, roiSize, threshold, value);
    default:
        assert(false);
        return _refr_fwiThreshold_LTVal_8u_AC4IR(pSrcDst, srcDstStep, roiSize, threshold, value);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiAddC_32f_C4R( const Fw32f *pSrc, int srcStep,const Fw32f value[4], Fw32f *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiAddC_32f_C4R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiAddC_32f_C4R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiAddC_32f_C4R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiAddC_32f_C4R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiCompareC_16s_AC4R( const Fw16s *pSrc, int srcStep, const Fw16s value[3], Fw8u *pDst, int dstStep, FwiSize roiSize, FwCmpOp fwCmpOp )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiCompareC_16s_AC4R(pSrc, srcStep, value, pDst, dstStep, roiSize, fwCmpOp);
    case DT_SSE2:
        return _sse2_fwiCompareC_16s_AC4R(pSrc, srcStep, value, pDst, dstStep, roiSize, fwCmpOp);
    case DT_REFR:
        return _refr_fwiCompareC_16s_AC4R(pSrc, srcStep, value, pDst, dstStep, roiSize, fwCmpOp);
    default:
        assert(false);
        return _refr_fwiCompareC_16s_AC4R(pSrc, srcStep, value, pDst, dstStep, roiSize, fwCmpOp);
    }
}

OREFR               FwStatus fwiXYZToRGB_32f_C3R( const Fw32f* pSrc, int srcStep, Fw32f* pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiXYZToRGB_32f_C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiXYZToRGB_32f_C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H   FwStatus fwiRGBToYCbCr_8u_AC4R( const Fw8u *pSrc, int srcStep, Fw8u *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiRGBToYCbCr_8u_AC4R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiRGBToYCbCr_8u_AC4R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiRGBToYCbCr_8u_AC4R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiRGBToYCbCr_8u_AC4R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR               FwStatus fwiYCbCr422ToRGB565_8u16u_C2C3R(const A8U* pSrc, int srcStep, A16U* pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiYCbCr422ToRGB565_8u16u_C2C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiYCbCr422ToRGB565_8u16u_C2C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiFilterMax_8u_C3R( const Fw8u * pSrc, int srcStep,
                               Fw8u * pDst, int dstStep, FwiSize dstRoiSize,
                               FwiSize maskSize, FwiPoint anchor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilterMax_8u_C3R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize, anchor);
    case DT_REFR:
        return _refr_fwiFilterMax_8u_C3R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize, anchor);
    default:
        assert(false);
        return _refr_fwiFilterMax_8u_C3R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize, anchor);
    }
}

OREFR               FwStatus fwiYCbCr422ToBGR565_8u16u_P3C3R(const A8U* const pSrc[3], int srcStep[3], A16U* pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiYCbCr422ToBGR565_8u16u_P3C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiYCbCr422ToBGR565_8u16u_P3C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiRShiftC_16u_AC4R( const Fw16u  *pSrc, int srcStep, const Fw32u value[3], Fw16u *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiRShiftC_16u_AC4R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiRShiftC_16u_AC4R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiRShiftC_16u_AC4R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiRShiftC_16u_AC4R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiThreshold_LTValGTVal_8u_AC4R( const Fw8u *pSrc, int srcStep, Fw8u *pDst, int dstStep, FwiSize roiSize, const Fw8u thresholdLT[3], const Fw8u valueLT[3], const Fw8u thresholdGT[3], const Fw8u valueGT[3])
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiThreshold_LTValGTVal_8u_AC4R(pSrc, srcStep, pDst, dstStep, roiSize, thresholdLT, valueLT, thresholdGT, valueGT);
    case DT_SSE2:
        return _sse2_fwiThreshold_LTValGTVal_8u_AC4R(pSrc, srcStep, pDst, dstStep, roiSize, thresholdLT, valueLT, thresholdGT, valueGT);
    case DT_REFR:
        return _refr_fwiThreshold_LTValGTVal_8u_AC4R(pSrc, srcStep, pDst, dstStep, roiSize, thresholdLT, valueLT, thresholdGT, valueGT);
    default:
        assert(false);
        return _refr_fwiThreshold_LTValGTVal_8u_AC4R(pSrc, srcStep, pDst, dstStep, roiSize, thresholdLT, valueLT, thresholdGT, valueGT);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiFilterMin_8u_AC4R( const Fw8u * pSrc, int srcStep,
                               Fw8u * pDst, int dstStep, FwiSize dstRoiSize,
                               FwiSize maskSize, FwiPoint anchor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilterMin_8u_AC4R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize, anchor);
    case DT_REFR:
        return _refr_fwiFilterMin_8u_AC4R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize, anchor);
    default:
        assert(false);
        return _refr_fwiFilterMin_8u_AC4R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize, anchor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiMulScale_8u_C4IR(  const Fw8u  *pSrc,  int srcStep,        Fw8u  *pSrcDst, int srcDstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiMulScale_8u_C4IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiMulScale_8u_C4IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    case DT_REFR:
        return _refr_fwiMulScale_8u_C4IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiMulScale_8u_C4IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiConvert_32f16s_C1R( const Fw32f *pSrc, int srcStep, Fw16s *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiConvert_32f16s_C1R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiConvert_32f16s_C1R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiConvert_32f16s_C1R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiConvert_32f16s_C1R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiDivC_32fc_C1IR(       Fw32fc value,    Fw32fc *pSrcDst, int srcDstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiDivC_32fc_C1IR(value, pSrcDst, srcDstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiDivC_32fc_C1IR(value, pSrcDst, srcDstStep, roiSize);
    case DT_REFR:
        return _refr_fwiDivC_32fc_C1IR(value, pSrcDst, srcDstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiDivC_32fc_C1IR(value, pSrcDst, srcDstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiCopy_32s_C1R( const Fw32s *pSrc, int srcStep, Fw32s *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiCopy_32s_C1R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiCopy_32s_C1R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiCopy_32s_C1R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiCopy_32s_C1R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR       FwStatus STDCALL fwiWarpBilinear_32f_AC4R(const Fw32f* pSrc, FwiSize srcSize, int srcStep,
								FwiRect srcRoi, Fw32f* pDst, int dstStep, FwiRect dstRoi,
								const double coeffs[2][4], int interpolation)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiWarpBilinear_32f_AC4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, coeffs, interpolation);
    default:
        assert(false);
        return _refr_fwiWarpBilinear_32f_AC4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, coeffs, interpolation);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiFilterLowpass_8u_AC4R( const Fw8u * pSrc, int srcStep, Fw8u * pDst, int dstStep, FwiSize dstRoiSize, FwiMaskSize maskSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilterLowpass_8u_AC4R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize);
    case DT_REFR:
        return _refr_fwiFilterLowpass_8u_AC4R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize);
    default:
        assert(false);
        return _refr_fwiFilterLowpass_8u_AC4R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiFilterMedian_16s_C4R( const Fw16s * pSrc, int srcStep,
                                           Fw16s * pDst, int dstStep, FwiSize dstRoiSize,
                                           FwiSize maskSize, FwiPoint anchor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilterMedian_16s_C4R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize, anchor);
    case DT_REFR:
        return _refr_fwiFilterMedian_16s_C4R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize, anchor);
    default:
        assert(false);
        return _refr_fwiFilterMedian_16s_C4R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize, anchor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiThreshold_GTVal_32f_AC4R( const Fw32f *pSrc, int srcStep, Fw32f *pDst, int dstStep, FwiSize roiSize, const Fw32f threshold[3], const Fw32f value[3])
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiThreshold_GTVal_32f_AC4R(pSrc, srcStep, pDst, dstStep, roiSize, threshold, value);
    case DT_SSE2:
        return _sse2_fwiThreshold_GTVal_32f_AC4R(pSrc, srcStep, pDst, dstStep, roiSize, threshold, value);
    case DT_REFR:
        return _refr_fwiThreshold_GTVal_32f_AC4R(pSrc, srcStep, pDst, dstStep, roiSize, threshold, value);
    default:
        assert(false);
        return _refr_fwiThreshold_GTVal_32f_AC4R(pSrc, srcStep, pDst, dstStep, roiSize, threshold, value);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiDivC_32sc_C3RSfs( const Fw32sc *pSrc, int srcStep, const Fw32sc value[3], Fw32sc *pDst, int dstStep, FwiSize roiSize, int scaleFactor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiDivC_32sc_C3RSfs(pSrc, srcStep, value, pDst, dstStep, roiSize, scaleFactor);
    case DT_SSE2:
        return _sse2_fwiDivC_32sc_C3RSfs(pSrc, srcStep, value, pDst, dstStep, roiSize, scaleFactor);
    case DT_REFR:
        return _refr_fwiDivC_32sc_C3RSfs(pSrc, srcStep, value, pDst, dstStep, roiSize, scaleFactor);
    default:
        assert(false);
        return _refr_fwiDivC_32sc_C3RSfs(pSrc, srcStep, value, pDst, dstStep, roiSize, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiMul_32fc_C1IR( const Fw32fc *pSrc,  int srcStep,        Fw32fc *pSrcDst, int srcDstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiMul_32fc_C1IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiMul_32fc_C1IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    case DT_REFR:
        return _refr_fwiMul_32fc_C1IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiMul_32fc_C1IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiAdd_8u32f_C1IR( const Fw8u  *pSrc, int srcStep, Fw32f *pSrcDst, int srcDstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiAdd_8u32f_C1IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiAdd_8u32f_C1IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    case DT_REFR:
        return _refr_fwiAdd_8u32f_C1IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiAdd_8u32f_C1IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiSqr_8u_C3IRSfs(       Fw8u  *pSrcDst, int srcDstStep, FwiSize roiSize, int scaleFactor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiSqr_8u_C3IRSfs(pSrcDst, srcDstStep, roiSize, scaleFactor);
    case DT_SSE2:
        return _sse2_fwiSqr_8u_C3IRSfs(pSrcDst, srcDstStep, roiSize, scaleFactor);
    case DT_REFR:
        return _refr_fwiSqr_8u_C3IRSfs(pSrcDst, srcDstStep, roiSize, scaleFactor);
    default:
        assert(false);
        return _refr_fwiSqr_8u_C3IRSfs(pSrcDst, srcDstStep, roiSize, scaleFactor);
    }
}

OREFR OSSE2 FwStatus STDCALL fwiWarpAffine_8u_C4R( const Fw8u* pSrc, FwiSize srcSize, int srcStep,
								FwiRect srcRoi, Fw8u* pDst, int dstStep, FwiRect dstRoi,
								const double coeffs[2][3], int interpolation )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiWarpAffine_8u_C4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, coeffs, interpolation);
    case DT_REFR:
        return _refr_fwiWarpAffine_8u_C4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, coeffs, interpolation);
    default:
        assert(false);
        return _refr_fwiWarpAffine_8u_C4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, coeffs, interpolation);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiSubC_32sc_AC4IRSfs( const Fw32sc value[3], Fw32sc *pSrcDst, int srcDstStep, FwiSize roiSize, int scaleFactor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiSubC_32sc_AC4IRSfs(value, pSrcDst, srcDstStep, roiSize, scaleFactor);
    case DT_SSE2:
        return _sse2_fwiSubC_32sc_AC4IRSfs(value, pSrcDst, srcDstStep, roiSize, scaleFactor);
    case DT_REFR:
        return _refr_fwiSubC_32sc_AC4IRSfs(value, pSrcDst, srcDstStep, roiSize, scaleFactor);
    default:
        assert(false);
        return _refr_fwiSubC_32sc_AC4IRSfs(value, pSrcDst, srcDstStep, roiSize, scaleFactor);
    }
}

OREFR OSSE2 FwStatus STDCALL fwiResizeCenter_8u_C3R( const Fw8u* pSrc, FwiSize srcSize, int srcStep, FwiRect srcRoi,
								  Fw8u* pDst, int dstStep, FwiSize dstRoiSize,
								  double xFactor, double yFactor, double xCenter, double yCenter, int interpolation )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiResizeCenter_8u_C3R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoiSize, xFactor, yFactor, xCenter, yCenter, interpolation);
    case DT_REFR:
        return _refr_fwiResizeCenter_8u_C3R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoiSize, xFactor, yFactor, xCenter, yCenter, interpolation);
    default:
        assert(false);
        return _refr_fwiResizeCenter_8u_C3R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoiSize, xFactor, yFactor, xCenter, yCenter, interpolation);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiThreshold_GTVal_8u_C3R( const Fw8u *pSrc, int srcStep, Fw8u *pDst, int dstStep, FwiSize roiSize, const Fw8u threshold[3], const Fw8u value[3])
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiThreshold_GTVal_8u_C3R(pSrc, srcStep, pDst, dstStep, roiSize, threshold, value);
    case DT_SSE2:
        return _sse2_fwiThreshold_GTVal_8u_C3R(pSrc, srcStep, pDst, dstStep, roiSize, threshold, value);
    case DT_REFR:
        return _refr_fwiThreshold_GTVal_8u_C3R(pSrc, srcStep, pDst, dstStep, roiSize, threshold, value);
    default:
        assert(false);
        return _refr_fwiThreshold_GTVal_8u_C3R(pSrc, srcStep, pDst, dstStep, roiSize, threshold, value);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiRShiftC_16s_AC4R( const Fw16s  *pSrc, int srcStep, const Fw32u value[3], Fw16s *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiRShiftC_16s_AC4R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiRShiftC_16s_AC4R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiRShiftC_16s_AC4R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiRShiftC_16s_AC4R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiCopy_32f_C3CR( const Fw32f *pSrc, int srcStep, Fw32f *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiCopy_32f_C3CR(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiCopy_32f_C3CR(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiCopy_32f_C3CR(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiCopy_32f_C3CR(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 FwStatus STDCALL fwiResizeShift_16u_AC4R( const Fw16u* pSrc, FwiSize srcSize, int srcStep, FwiRect srcRoi,
								   Fw16u* pDst, int dstStep, FwiSize dstRoiSize,
								   double xFr, double yFr, double xShift, double yShift, int interpolation )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiResizeShift_16u_AC4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoiSize, xFr, yFr, xShift, yShift, interpolation);
    case DT_REFR:
        return _refr_fwiResizeShift_16u_AC4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoiSize, xFr, yFr, xShift, yShift, interpolation);
    default:
        assert(false);
        return _refr_fwiResizeShift_16u_AC4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoiSize, xFr, yFr, xShift, yShift, interpolation);
    }
}

OREFR OSSE2         FwStatus fwiMin_32f_C1R(const Fw32f* pSrc, int srcStep,FwiSize roiSize, Fw32f* pMin)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiMin_32f_C1R(pSrc, srcStep, roiSize, pMin);
    case DT_REFR:
        return _refr_fwiMin_32f_C1R(pSrc, srcStep, roiSize, pMin);
    default:
        assert(false);
        return _refr_fwiMin_32f_C1R(pSrc, srcStep, roiSize, pMin);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiNot_8u_C4R( const Fw8u   *pSrc, int srcStep,    Fw8u *pDst, int dstStep, FwiSize roiSize)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiNot_8u_C4R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiNot_8u_C4R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiNot_8u_C4R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiNot_8u_C4R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR       FwStatus STDCALL fwiWarpBilinearQuad_8u_P3R(const Fw8u* const pSrc[3], FwiSize srcSize, int srcStep, FwiRect srcRoi,
							        const double srcQuad[4][2], Fw8u* const pDst[3], int dstStep, FwiRect dstRoi,
									const double dstQuad[4][2], int interpolation)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiWarpBilinearQuad_8u_P3R(pSrc, srcSize, srcStep, srcRoi, srcQuad, pDst, dstStep, dstRoi, dstQuad, interpolation);
    default:
        assert(false);
        return _refr_fwiWarpBilinearQuad_8u_P3R(pSrc, srcSize, srcStep, srcRoi, srcQuad, pDst, dstStep, dstRoi, dstQuad, interpolation);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiRShiftC_8s_C4IR( const Fw32u value[4], Fw8s *pSrcDst, int srcDstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiRShiftC_8s_C4IR(value, pSrcDst, srcDstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiRShiftC_8s_C4IR(value, pSrcDst, srcDstStep, roiSize);
    case DT_REFR:
        return _refr_fwiRShiftC_8s_C4IR(value, pSrcDst, srcDstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiRShiftC_8s_C4IR(value, pSrcDst, srcDstStep, roiSize);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiFilterColumn_8u_C3R( const Fw8u * pSrc, int srcStep,
                             Fw8u * pDst, int dstStep, FwiSize dstRoiSize,
                             const Fw32s * pKernel, int kernelSize,
                             int yAnchor, int divisor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilterColumn_8u_C3R(pSrc, srcStep, pDst, dstStep, dstRoiSize, pKernel, kernelSize, yAnchor, divisor);
    case DT_REFR:
        return _refr_fwiFilterColumn_8u_C3R(pSrc, srcStep, pDst, dstStep, dstRoiSize, pKernel, kernelSize, yAnchor, divisor);
    default:
        assert(false);
        return _refr_fwiFilterColumn_8u_C3R(pSrc, srcStep, pDst, dstStep, dstRoiSize, pKernel, kernelSize, yAnchor, divisor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiAndC_32s_C4IR( const Fw32s value[4], Fw32s *pSrcDst, int srcDstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiAndC_32s_C4IR(value, pSrcDst, srcDstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiAndC_32s_C4IR(value, pSrcDst, srcDstStep, roiSize);
    case DT_REFR:
        return _refr_fwiAndC_32s_C4IR(value, pSrcDst, srcDstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiAndC_32s_C4IR(value, pSrcDst, srcDstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiSub_16s_AC4RSfs( const Fw16s  *pSrc1, int src1Step, const Fw16s  *pSrc2,   int src2Step, Fw16s *pDst, int dstStep, FwiSize roiSize, int scaleFactor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiSub_16s_AC4RSfs(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, scaleFactor);
    case DT_SSE2:
        return _sse2_fwiSub_16s_AC4RSfs(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, scaleFactor);
    case DT_REFR:
        return _refr_fwiSub_16s_AC4RSfs(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, scaleFactor);
    default:
        assert(false);
        return _refr_fwiSub_16s_AC4RSfs(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, scaleFactor);
    }
}

OREFR       FwStatus STDCALL fwiWarpBilinearQuad_8u_P4R(const Fw8u* const pSrc[4], FwiSize srcSize, int srcStep, FwiRect srcRoi,
							        const double srcQuad[4][2], Fw8u* const pDst[4], int dstStep, FwiRect dstRoi,
									const double dstQuad[4][2], int interpolation)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiWarpBilinearQuad_8u_P4R(pSrc, srcSize, srcStep, srcRoi, srcQuad, pDst, dstStep, dstRoi, dstQuad, interpolation);
    default:
        assert(false);
        return _refr_fwiWarpBilinearQuad_8u_P4R(pSrc, srcSize, srcStep, srcRoi, srcQuad, pDst, dstStep, dstRoi, dstQuad, interpolation);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiDiv_32fc_C1IR( const Fw32fc *pSrc,  int srcStep,        Fw32fc *pSrcDst, int srcDstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiDiv_32fc_C1IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiDiv_32fc_C1IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    case DT_REFR:
        return _refr_fwiDiv_32fc_C1IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiDiv_32fc_C1IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiRotateCenter_16u_C3R( const Fw16u* pSrc,FwiSize srcSize, int srcStep, FwiRect srcRoi, Fw16u* pDst, int dstStep, FwiRect dstRoi, double angle, double xCenter, double yCenter, int interpolation )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiRotateCenter_16u_C3R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, angle, xCenter, yCenter, interpolation);
    case DT_REFR:
        return _refr_fwiRotateCenter_16u_C3R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, angle, xCenter, yCenter, interpolation);
    default:
        assert(false);
        return _refr_fwiRotateCenter_16u_C3R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, angle, xCenter, yCenter, interpolation);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiCopy_32f_AC4R( const Fw32f *pSrc, int srcStep, Fw32f *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiCopy_32f_AC4R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiCopy_32f_AC4R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiCopy_32f_AC4R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiCopy_32f_AC4R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiAddWeighted_8u32f_C1IMR( const Fw8u *pSrc, int srcStep,  const Fw8u* pMask, int maskStep, Fw32f* pSrcDst, int srcDstStep, FwiSize roiSize, Fw32f alpha)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiAddWeighted_8u32f_C1IMR(pSrc, srcStep, pMask, maskStep, pSrcDst, srcDstStep, roiSize, alpha);
    case DT_SSE2:
        return _sse2_fwiAddWeighted_8u32f_C1IMR(pSrc, srcStep, pMask, maskStep, pSrcDst, srcDstStep, roiSize, alpha);
    case DT_REFR:
        return _refr_fwiAddWeighted_8u32f_C1IMR(pSrc, srcStep, pMask, maskStep, pSrcDst, srcDstStep, roiSize, alpha);
    default:
        assert(false);
        return _refr_fwiAddWeighted_8u32f_C1IMR(pSrc, srcStep, pMask, maskStep, pSrcDst, srcDstStep, roiSize, alpha);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiConvert_8u32f_C3R( const Fw8u *pSrc, int srcStep, Fw32f *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiConvert_8u32f_C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiConvert_8u32f_C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiConvert_8u32f_C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiConvert_8u32f_C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiCopy_8u_C3CR( const Fw8u *pSrc, int srcStep, Fw8u *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiCopy_8u_C3CR(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiCopy_8u_C3CR(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiCopy_8u_C3CR(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiCopy_8u_C3CR(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiRotateCenter_32f_C4R( const Fw32f* pSrc,FwiSize srcSize, int srcStep, FwiRect srcRoi, Fw32f* pDst, int dstStep, FwiRect dstRoi, double angle, double xCenter, double yCenter, int interpolation )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiRotateCenter_32f_C4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, angle, xCenter, yCenter, interpolation);
    case DT_REFR:
        return _refr_fwiRotateCenter_32f_C4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, angle, xCenter, yCenter, interpolation);
    default:
        assert(false);
        return _refr_fwiRotateCenter_32f_C4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, angle, xCenter, yCenter, interpolation);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiSet_16s_C1R(       Fw16s  value,    Fw16s  * pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiSet_16s_C1R(value, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiSet_16s_C1R(value, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiSet_16s_C1R(value, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiSet_16s_C1R(value, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiAddC_32sc_C3IRSfs( const Fw32sc value[3], Fw32sc *pSrcDst, int srcDstStep, FwiSize roiSize, int scaleFactor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiAddC_32sc_C3IRSfs(value, pSrcDst, srcDstStep, roiSize, scaleFactor);
    case DT_SSE2:
        return _sse2_fwiAddC_32sc_C3IRSfs(value, pSrcDst, srcDstStep, roiSize, scaleFactor);
    case DT_REFR:
        return _refr_fwiAddC_32sc_C3IRSfs(value, pSrcDst, srcDstStep, roiSize, scaleFactor);
    default:
        assert(false);
        return _refr_fwiAddC_32sc_C3IRSfs(value, pSrcDst, srcDstStep, roiSize, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiSet_8u_C4CR(       Fw8u  value,    Fw8u  * pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiSet_8u_C4CR(value, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiSet_8u_C4CR(value, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiSet_8u_C4CR(value, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiSet_8u_C4CR(value, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiCopy_32f_C3MR( const Fw32f *pSrc, int srcStep, Fw32f *pDst, int dstStep, FwiSize roiSize, const Fw8u *pMask, int maskStep )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiCopy_32f_C3MR(pSrc, srcStep, pDst, dstStep, roiSize, pMask, maskStep);
    case DT_SSE2:
        return _sse2_fwiCopy_32f_C3MR(pSrc, srcStep, pDst, dstStep, roiSize, pMask, maskStep);
    case DT_REFR:
        return _refr_fwiCopy_32f_C3MR(pSrc, srcStep, pDst, dstStep, roiSize, pMask, maskStep);
    default:
        assert(false);
        return _refr_fwiCopy_32f_C3MR(pSrc, srcStep, pDst, dstStep, roiSize, pMask, maskStep);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiAdd_32fc_C1IR( const Fw32fc *pSrc,  int srcStep,        Fw32fc *pSrcDst, int srcDstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiAdd_32fc_C1IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiAdd_32fc_C1IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    case DT_REFR:
        return _refr_fwiAdd_32fc_C1IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiAdd_32fc_C1IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiSqrt_16s_C1IRSfs(       Fw16s *pSrcDst, int srcDstStep, FwiSize roiSize, int scaleFactor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiSqrt_16s_C1IRSfs(pSrcDst, srcDstStep, roiSize, scaleFactor);
    case DT_SSE2:
        return _sse2_fwiSqrt_16s_C1IRSfs(pSrcDst, srcDstStep, roiSize, scaleFactor);
    case DT_REFR:
        return _refr_fwiSqrt_16s_C1IRSfs(pSrcDst, srcDstStep, roiSize, scaleFactor);
    default:
        assert(false);
        return _refr_fwiSqrt_16s_C1IRSfs(pSrcDst, srcDstStep, roiSize, scaleFactor);
    }
}

OREFR OSSE2 FwStatus STDCALL fwiWarpPerspectiveBack_32f_C1R( const Fw32f* pSrc, FwiSize srcSize, int srcStep,
								FwiRect srcRoi, Fw32f* pDst, int dstStep, FwiRect dstRoi,
								const double coeffs[3][3], int interpolation )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiWarpPerspectiveBack_32f_C1R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, coeffs, interpolation);
    case DT_REFR:
        return _refr_fwiWarpPerspectiveBack_32f_C1R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, coeffs, interpolation);
    default:
        assert(false);
        return _refr_fwiWarpPerspectiveBack_32f_C1R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, coeffs, interpolation);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiMulScale_8u_C3R(  const Fw8u  *pSrc1, int src1Step, const Fw8u  *pSrc2, int src2Step, Fw8u  *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiMulScale_8u_C3R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiMulScale_8u_C3R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiMulScale_8u_C3R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiMulScale_8u_C3R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiSet_8u_C4MR( const Fw8u  value[4], Fw8u  * pDst, int dstStep, FwiSize roiSize, const Fw8u * pMask, int maskStep )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiSet_8u_C4MR(value, pDst, dstStep, roiSize, pMask, maskStep);
    case DT_SSE2:
        return _sse2_fwiSet_8u_C4MR(value, pDst, dstStep, roiSize, pMask, maskStep);
    case DT_REFR:
        return _refr_fwiSet_8u_C4MR(value, pDst, dstStep, roiSize, pMask, maskStep);
    default:
        assert(false);
        return _refr_fwiSet_8u_C4MR(value, pDst, dstStep, roiSize, pMask, maskStep);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiFilterScharrHoriz_8s16s_C1R( const Fw8s * pSrc, int srcStep, Fw16s * pDst, int dstStep, FwiSize dstRoiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilterScharrHoriz_8s16s_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize);
    case DT_REFR:
        return _refr_fwiFilterScharrHoriz_8s16s_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize);
    default:
        assert(false);
        return _refr_fwiFilterScharrHoriz_8s16s_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiCopy_16s_C3MR( const Fw16s *pSrc, int srcStep, Fw16s *pDst, int dstStep, FwiSize roiSize, const Fw8u *pMask, int maskStep )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiCopy_16s_C3MR(pSrc, srcStep, pDst, dstStep, roiSize, pMask, maskStep);
    case DT_SSE2:
        return _sse2_fwiCopy_16s_C3MR(pSrc, srcStep, pDst, dstStep, roiSize, pMask, maskStep);
    case DT_REFR:
        return _refr_fwiCopy_16s_C3MR(pSrc, srcStep, pDst, dstStep, roiSize, pMask, maskStep);
    default:
        assert(false);
        return _refr_fwiCopy_16s_C3MR(pSrc, srcStep, pDst, dstStep, roiSize, pMask, maskStep);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiAnd_8u_AC4IR( const Fw8u	*pSrc,  int srcStep,        Fw8u *pSrcDst, int srcDstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiAnd_8u_AC4IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiAnd_8u_AC4IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    case DT_REFR:
        return _refr_fwiAnd_8u_AC4IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiAnd_8u_AC4IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    }
}

OREFR OSSE2 FwStatus STDCALL fwiWarpPerspectiveBack_8u_P4R( const Fw8u* const pSrc[4], FwiSize srcSize, int srcStep,
								FwiRect srcRoi, Fw8u* const pDst[4], int dstStep, FwiRect dstRoi,
								const double coeffs[3][3], int interpolation )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiWarpPerspectiveBack_8u_P4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, coeffs, interpolation);
    case DT_REFR:
        return _refr_fwiWarpPerspectiveBack_8u_P4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, coeffs, interpolation);
    default:
        assert(false);
        return _refr_fwiWarpPerspectiveBack_8u_P4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, coeffs, interpolation);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiThreshold_Val_16s_C1R( const Fw16s *pSrc, int srcStep, Fw16s *pDst, int dstStep, FwiSize roiSize, Fw16s threshold, Fw16s value, FwCmpOp fwCmpOp)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiThreshold_Val_16s_C1R(pSrc, srcStep, pDst, dstStep, roiSize, threshold, value, fwCmpOp);
    case DT_SSE2:
        return _sse2_fwiThreshold_Val_16s_C1R(pSrc, srcStep, pDst, dstStep, roiSize, threshold, value, fwCmpOp);
    case DT_REFR:
        return _refr_fwiThreshold_Val_16s_C1R(pSrc, srcStep, pDst, dstStep, roiSize, threshold, value, fwCmpOp);
    default:
        assert(false);
        return _refr_fwiThreshold_Val_16s_C1R(pSrc, srcStep, pDst, dstStep, roiSize, threshold, value, fwCmpOp);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiExp_8u_C1IRSfs(       Fw8u  *pSrcDst,  int srcDstStep, FwiSize roiSize, int scaleFactor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiExp_8u_C1IRSfs(pSrcDst, srcDstStep, roiSize, scaleFactor);
    case DT_SSE2:
        return _sse2_fwiExp_8u_C1IRSfs(pSrcDst, srcDstStep, roiSize, scaleFactor);
    case DT_REFR:
        return _refr_fwiExp_8u_C1IRSfs(pSrcDst, srcDstStep, roiSize, scaleFactor);
    default:
        assert(false);
        return _refr_fwiExp_8u_C1IRSfs(pSrcDst, srcDstStep, roiSize, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiLShiftC_32s_C3R( const Fw32s  *pSrc, int srcStep, const Fw32u value[3], Fw32s *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiLShiftC_32s_C3R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiLShiftC_32s_C3R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiLShiftC_32s_C3R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiLShiftC_32s_C3R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiLShiftC_8u_AC4IR( const Fw32u value[3], Fw8u *pSrcDst, int srcDstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiLShiftC_8u_AC4IR(value, pSrcDst, srcDstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiLShiftC_8u_AC4IR(value, pSrcDst, srcDstStep, roiSize);
    case DT_REFR:
        return _refr_fwiLShiftC_8u_AC4IR(value, pSrcDst, srcDstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiLShiftC_8u_AC4IR(value, pSrcDst, srcDstStep, roiSize);
    }
}

OREFR               FwStatus fwiRGBToLUV_16u_AC4R( const Fw16u* pSrc, int srcStep, Fw16u* pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiRGBToLUV_16u_AC4R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiRGBToLUV_16u_AC4R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiFilterScharrVert_32f_C1R( const Fw32f * pSrc, int srcStep, Fw32f * pDst, int dstStep, FwiSize dstRoiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilterScharrVert_32f_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize);
    case DT_REFR:
        return _refr_fwiFilterScharrVert_32f_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize);
    default:
        assert(false);
        return _refr_fwiFilterScharrVert_32f_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiFilterRobertsDown_32f_C1R( const Fw32f * pSrc, int srcStep, Fw32f * pDst, int dstStep, FwiSize dstRoiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilterRobertsDown_32f_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize);
    case DT_REFR:
        return _refr_fwiFilterRobertsDown_32f_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize);
    default:
        assert(false);
        return _refr_fwiFilterRobertsDown_32f_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiSubC_16s_C1RSfs( const Fw16s *pSrc, int srcStep,       Fw16s value,    Fw16s *pDst, int dstStep, FwiSize roiSize, int scaleFactor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiSubC_16s_C1RSfs(pSrc, srcStep, value, pDst, dstStep, roiSize, scaleFactor);
    case DT_SSE2:
        return _sse2_fwiSubC_16s_C1RSfs(pSrc, srcStep, value, pDst, dstStep, roiSize, scaleFactor);
    case DT_REFR:
        return _refr_fwiSubC_16s_C1RSfs(pSrc, srcStep, value, pDst, dstStep, roiSize, scaleFactor);
    default:
        assert(false);
        return _refr_fwiSubC_16s_C1RSfs(pSrc, srcStep, value, pDst, dstStep, roiSize, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiCopy_8u_AC4C3R( const Fw8u *pSrc, int srcStep, Fw8u *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiCopy_8u_AC4C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiCopy_8u_AC4C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiCopy_8u_AC4C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiCopy_8u_AC4C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiConvert_8u16u_C3R( const Fw8u *pSrc, int srcStep, Fw16u *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiConvert_8u16u_C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiConvert_8u16u_C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiConvert_8u16u_C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiConvert_8u16u_C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}


OREFR OSSE2       FwStatus STDCALL fwiFilterSobelVertSecond_32f_C1R( const Fw32f * pSrc, int srcStep, Fw32f * pDst, int dstStep, FwiSize dstRoiSize, FwiMaskSize mask )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilterSobelVertSecond_32f_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize, mask);
    case DT_REFR:
        return _refr_fwiFilterSobelVertSecond_32f_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize, mask);
    default:
        assert(false);
        return _refr_fwiFilterSobelVertSecond_32f_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize, mask);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiLShiftC_32s_AC4R( const Fw32s  *pSrc, int srcStep, const Fw32u value[3], Fw32s *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiLShiftC_32s_AC4R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiLShiftC_32s_AC4R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiLShiftC_32s_AC4R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiLShiftC_32s_AC4R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiThreshold_LTVal_8u_C1IR( Fw8u *pSrcDst, int srcDstStep, FwiSize roiSize, Fw8u threshold, Fw8u value)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiThreshold_LTVal_8u_C1IR(pSrcDst, srcDstStep, roiSize, threshold, value);
    case DT_SSE2:
        return _sse2_fwiThreshold_LTVal_8u_C1IR(pSrcDst, srcDstStep, roiSize, threshold, value);
    case DT_REFR:
        return _refr_fwiThreshold_LTVal_8u_C1IR(pSrcDst, srcDstStep, roiSize, threshold, value);
    default:
        assert(false);
        return _refr_fwiThreshold_LTVal_8u_C1IR(pSrcDst, srcDstStep, roiSize, threshold, value);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiFilterMax_32f_C1R( const Fw32f * pSrc, int srcStep,
                               Fw32f * pDst, int dstStep, FwiSize dstRoiSize,
                               FwiSize maskSize, FwiPoint anchor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilterMax_32f_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize, anchor);
    case DT_REFR:
        return _refr_fwiFilterMax_32f_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize, anchor);
    default:
        assert(false);
        return _refr_fwiFilterMax_32f_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize, anchor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiMulC_8u_C3RSfs( const Fw8u *pSrc, int srcStep, const Fw8u value[3], Fw8u *pDst, int dstStep, FwiSize roiSize, int scaleFactor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiMulC_8u_C3RSfs(pSrc, srcStep, value, pDst, dstStep, roiSize, scaleFactor);
    case DT_SSE2:
        return _sse2_fwiMulC_8u_C3RSfs(pSrc, srcStep, value, pDst, dstStep, roiSize, scaleFactor);
    case DT_REFR:
        return _refr_fwiMulC_8u_C3RSfs(pSrc, srcStep, value, pDst, dstStep, roiSize, scaleFactor);
    default:
        assert(false);
        return _refr_fwiMulC_8u_C3RSfs(pSrc, srcStep, value, pDst, dstStep, roiSize, scaleFactor);
    }
}



OREFR OSSE2       FwStatus STDCALL fwiFilterMedian_8u_C1R( const Fw8u * pSrc, int srcStep,
                                           Fw8u * pDst, int dstStep, FwiSize dstRoiSize,
                                           FwiSize maskSize, FwiPoint anchor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilterMedian_8u_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize, anchor);
    case DT_REFR:
        return _refr_fwiFilterMedian_8u_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize, anchor);
    default:
        assert(false);
        return _refr_fwiFilterMedian_8u_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize, anchor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiAdd_32fc_C3IR( const Fw32fc *pSrc,  int srcStep,        Fw32fc *pSrcDst, int srcDstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiAdd_32fc_C3IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiAdd_32fc_C3IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    case DT_REFR:
        return _refr_fwiAdd_32fc_C3IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiAdd_32fc_C3IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiRShiftC_32s_C4R( const Fw32s  *pSrc, int srcStep, const Fw32u value[4], Fw32s *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiRShiftC_32s_C4R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiRShiftC_32s_C4R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiRShiftC_32s_C4R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiRShiftC_32s_C4R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiXor_32s_AC4R( const Fw32s *pSrc1, int src1Step, const Fw32s *pSrc2,   int src2Step, Fw32s *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiXor_32s_AC4R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiXor_32s_AC4R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiXor_32s_AC4R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiXor_32s_AC4R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiSub_32f_C3R( const Fw32f  *pSrc1, int src1Step, const Fw32f  *pSrc2,   int src2Step, Fw32f  *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiSub_32f_C3R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiSub_32f_C3R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiSub_32f_C3R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiSub_32f_C3R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiSqrt_32f_C3IR(       Fw32f *pSrcDst, int srcDstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiSqrt_32f_C3IR(pSrcDst, srcDstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiSqrt_32f_C3IR(pSrcDst, srcDstStep, roiSize);
    case DT_REFR:
        return _refr_fwiSqrt_32f_C3IR(pSrcDst, srcDstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiSqrt_32f_C3IR(pSrcDst, srcDstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiDivC_32sc_C1RSfs( const Fw32sc *pSrc, int srcStep, Fw32sc value, Fw32sc *pDst, int dstStep, FwiSize roiSize, int scaleFactor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiDivC_32sc_C1RSfs(pSrc, srcStep, value, pDst, dstStep, roiSize, scaleFactor);
    case DT_SSE2:
        return _sse2_fwiDivC_32sc_C1RSfs(pSrc, srcStep, value, pDst, dstStep, roiSize, scaleFactor);
    case DT_REFR:
        return _refr_fwiDivC_32sc_C1RSfs(pSrc, srcStep, value, pDst, dstStep, roiSize, scaleFactor);
    default:
        assert(false);
        return _refr_fwiDivC_32sc_C1RSfs(pSrc, srcStep, value, pDst, dstStep, roiSize, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiMul_16s_AC4IRSfs( const Fw16s  *pSrc,  int srcStep,        Fw16s  *pSrcDst, int srcDstStep, FwiSize roiSize, int scaleFactor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiMul_16s_AC4IRSfs(pSrc, srcStep, pSrcDst, srcDstStep, roiSize, scaleFactor);
    case DT_SSE2:
        return _sse2_fwiMul_16s_AC4IRSfs(pSrc, srcStep, pSrcDst, srcDstStep, roiSize, scaleFactor);
    case DT_REFR:
        return _refr_fwiMul_16s_AC4IRSfs(pSrc, srcStep, pSrcDst, srcDstStep, roiSize, scaleFactor);
    default:
        assert(false);
        return _refr_fwiMul_16s_AC4IRSfs(pSrc, srcStep, pSrcDst, srcDstStep, roiSize, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiCompareEqualEps_32f_C3R( const Fw32f *pSrc1, int src1Step, const Fw32f *pSrc2, int src2Step, Fw8u *pDst, int dstStep, FwiSize roiSize, Fw32f eps)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiCompareEqualEps_32f_C3R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, eps);
    case DT_SSE2:
        return _sse2_fwiCompareEqualEps_32f_C3R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, eps);
    case DT_REFR:
        return _refr_fwiCompareEqualEps_32f_C3R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, eps);
    default:
        assert(false);
        return _refr_fwiCompareEqualEps_32f_C3R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, eps);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiFilterLaplace_8u_C3R( const Fw8u * pSrc, int srcStep, Fw8u * pDst, int dstStep, FwiSize dstRoiSize, FwiMaskSize maskSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilterLaplace_8u_C3R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize);
    case DT_REFR:
        return _refr_fwiFilterLaplace_8u_C3R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize);
    default:
        assert(false);
        return _refr_fwiFilterLaplace_8u_C3R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiCopy_16s_C1MR( const Fw16s *pSrc, int srcStep, Fw16s *pDst, int dstStep, FwiSize roiSize, const Fw8u *pMask, int maskStep )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiCopy_16s_C1MR(pSrc, srcStep, pDst, dstStep, roiSize, pMask, maskStep);
    case DT_SSE2:
        return _sse2_fwiCopy_16s_C1MR(pSrc, srcStep, pDst, dstStep, roiSize, pMask, maskStep);
    case DT_REFR:
        return _refr_fwiCopy_16s_C1MR(pSrc, srcStep, pDst, dstStep, roiSize, pMask, maskStep);
    default:
        assert(false);
        return _refr_fwiCopy_16s_C1MR(pSrc, srcStep, pDst, dstStep, roiSize, pMask, maskStep);
    }
}




OREFR               FwStatus fwiYCbCr422ToYCbCr420_8u_P3R( const Fw8u* pSrc[3], int srcStep[3], Fw8u* pDst[3], int dstStep[3], FwiSize roiSize)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiYCbCr422ToYCbCr420_8u_P3R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiYCbCr422ToYCbCr420_8u_P3R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiOrC_16u_C1R( const Fw16u  *pSrc, int srcStep,       Fw16u value,    Fw16u *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiOrC_16u_C1R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiOrC_16u_C1R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiOrC_16u_C1R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiOrC_16u_C1R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiCompare_16s_C3R( const Fw16s *pSrc1, int src1Step, const Fw16s *pSrc2, int src2Step, Fw8u *pDst, int dstStep, FwiSize roiSize, FwCmpOp fwCmpOp )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiCompare_16s_C3R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, fwCmpOp);
    case DT_SSE2:
        return _sse2_fwiCompare_16s_C3R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, fwCmpOp);
    case DT_REFR:
        return _refr_fwiCompare_16s_C3R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, fwCmpOp);
    default:
        assert(false);
        return _refr_fwiCompare_16s_C3R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, fwCmpOp);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiRotate_16u_C1R( const Fw16u* pSrc, FwiSize srcSize, int srcStep, FwiRect srcRoi, Fw16u* pDst, int dstStep, FwiRect dstRoi, double angle, double xShift, double yShift, int interpolation )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiRotate_16u_C1R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, angle, xShift, yShift, interpolation);
    case DT_REFR:
        return _refr_fwiRotate_16u_C1R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, angle, xShift, yShift, interpolation);
    default:
        assert(false);
        return _refr_fwiRotate_16u_C1R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, angle, xShift, yShift, interpolation);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiThreshold_LTVal_8u_C3IR( Fw8u *pSrcDst, int srcDstStep, FwiSize roiSize, const Fw8u threshold[3], const Fw8u value[3])
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiThreshold_LTVal_8u_C3IR(pSrcDst, srcDstStep, roiSize, threshold, value);
    case DT_SSE2:
        return _sse2_fwiThreshold_LTVal_8u_C3IR(pSrcDst, srcDstStep, roiSize, threshold, value);
    case DT_REFR:
        return _refr_fwiThreshold_LTVal_8u_C3IR(pSrcDst, srcDstStep, roiSize, threshold, value);
    default:
        assert(false);
        return _refr_fwiThreshold_LTVal_8u_C3IR(pSrcDst, srcDstStep, roiSize, threshold, value);
    }
}

OREFR               FwStatus fwiYCbCr420ToRGB555_8u16u_P3C3R(const A8U* const pSrc[3], int srcStep[3], A16U* pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiYCbCr420ToRGB555_8u16u_P3C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiYCbCr420ToRGB555_8u16u_P3C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 FwStatus STDCALL fwiWarpAffineBack_16u_AC4R( const Fw16u* pSrc, FwiSize srcSize, int srcStep,
								FwiRect srcRoi, Fw16u* pDst, int dstStep, FwiRect dstRoi,
								const double coeffs[2][3], int interpolation )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiWarpAffineBack_16u_AC4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, coeffs, interpolation);
    case DT_REFR:
        return _refr_fwiWarpAffineBack_16u_AC4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, coeffs, interpolation);
    default:
        assert(false);
        return _refr_fwiWarpAffineBack_16u_AC4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, coeffs, interpolation);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiFilterMedian_16s_AC4R( const Fw16s * pSrc, int srcStep,
                                           Fw16s * pDst, int dstStep, FwiSize dstRoiSize,
                                           FwiSize maskSize, FwiPoint anchor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilterMedian_16s_AC4R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize, anchor);
    case DT_REFR:
        return _refr_fwiFilterMedian_16s_AC4R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize, anchor);
    default:
        assert(false);
        return _refr_fwiFilterMedian_16s_AC4R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize, anchor);
    }
}

OREFR               FwStatus fwiYCbCrToRGB565_8u16u_P3C3R(const A8U* const pSrc[3], int srcStep, A16U* pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiYCbCrToRGB565_8u16u_P3C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiYCbCrToRGB565_8u16u_P3C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiOrC_8u_AC4R( const Fw8u   *pSrc, int srcStep, const Fw8u value[3], Fw8u *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiOrC_8u_AC4R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiOrC_8u_AC4R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiOrC_8u_AC4R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiOrC_8u_AC4R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiRemap_8u_P4R( const Fw8u* const pSrc[4], FwiSize srcSize, int srcStep, FwiRect srcRoi, const Fw32f* pxMap, int xMapStep, const Fw32f* pyMap, int yMapStep, Fw8u* const pDst[4], int dstStep, FwiSize dstRoiSize, int interpolation )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiRemap_8u_P4R(pSrc, srcSize, srcStep, srcRoi, pxMap, xMapStep, pyMap, yMapStep, pDst, dstStep, dstRoiSize, interpolation);
    case DT_REFR:
        return _refr_fwiRemap_8u_P4R(pSrc, srcSize, srcStep, srcRoi, pxMap, xMapStep, pyMap, yMapStep, pDst, dstStep, dstRoiSize, interpolation);
    default:
        assert(false);
        return _refr_fwiRemap_8u_P4R(pSrc, srcSize, srcStep, srcRoi, pxMap, xMapStep, pyMap, yMapStep, pDst, dstStep, dstRoiSize, interpolation);
    }
}

OREFR OSSE2         FwStatus fwiMean_32f_C1R(const Fw32f* pSrc, int srcStep,FwiSize roiSize, Fw64f* pMean, FwHintAlgorithm hint)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiMean_32f_C1R(pSrc, srcStep, roiSize, pMean, hint);
    case DT_REFR:
        return _refr_fwiMean_32f_C1R(pSrc, srcStep, roiSize, pMean, hint);
    default:
        assert(false);
        return _refr_fwiMean_32f_C1R(pSrc, srcStep, roiSize, pMean, hint);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiConvert_32s8u_C1R( const Fw32s *pSrc, int srcStep, Fw8u *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiConvert_32s8u_C1R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiConvert_32s8u_C1R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiConvert_32s8u_C1R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiConvert_32s8u_C1R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiSubC_8u_AC4IRSfs( const Fw8u value[3], Fw8u *pSrcDst, int srcDstStep, FwiSize roiSize, int scaleFactor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiSubC_8u_AC4IRSfs(value, pSrcDst, srcDstStep, roiSize, scaleFactor);
    case DT_SSE2:
        return _sse2_fwiSubC_8u_AC4IRSfs(value, pSrcDst, srcDstStep, roiSize, scaleFactor);
    case DT_REFR:
        return _refr_fwiSubC_8u_AC4IRSfs(value, pSrcDst, srcDstStep, roiSize, scaleFactor);
    default:
        assert(false);
        return _refr_fwiSubC_8u_AC4IRSfs(value, pSrcDst, srcDstStep, roiSize, scaleFactor);
    }
}

OREFR OSSE2 FwStatus STDCALL fwiWarpAffine_16u_C4R( const Fw16u* pSrc, FwiSize srcSize, int srcStep,
								FwiRect srcRoi, Fw16u* pDst, int dstStep, FwiRect dstRoi,
								const double coeffs[2][3], int interpolation )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiWarpAffine_16u_C4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, coeffs, interpolation);
    case DT_REFR:
        return _refr_fwiWarpAffine_16u_C4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, coeffs, interpolation);
    default:
        assert(false);
        return _refr_fwiWarpAffine_16u_C4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, coeffs, interpolation);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiSet_8u_AC4MR( const Fw8u  value[3], Fw8u  * pDst, int dstStep, FwiSize roiSize, const Fw8u * pMask, int maskStep )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiSet_8u_AC4MR(value, pDst, dstStep, roiSize, pMask, maskStep);
    case DT_SSE2:
        return _sse2_fwiSet_8u_AC4MR(value, pDst, dstStep, roiSize, pMask, maskStep);
    case DT_REFR:
        return _refr_fwiSet_8u_AC4MR(value, pDst, dstStep, roiSize, pMask, maskStep);
    default:
        assert(false);
        return _refr_fwiSet_8u_AC4MR(value, pDst, dstStep, roiSize, pMask, maskStep);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiConvert_8s32s_C4R( const Fw8s *pSrc, int srcStep, Fw32s *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiConvert_8s32s_C4R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiConvert_8s32s_C4R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiConvert_8s32s_C4R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiConvert_8s32s_C4R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiFilterMin_32f_C1R( const Fw32f * pSrc, int srcStep,
                               Fw32f * pDst, int dstStep, FwiSize dstRoiSize,
                               FwiSize maskSize, FwiPoint anchor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilterMin_32f_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize, anchor);
    case DT_REFR:
        return _refr_fwiFilterMin_32f_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize, anchor);
    default:
        assert(false);
        return _refr_fwiFilterMin_32f_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize, anchor);
    }
}

OREFR OSSE2 FwStatus STDCALL fwiWarpAffineQuad_8u_AC4R( const Fw8u* pSrc, FwiSize srcSize, int srcStep, FwiRect srcRoi,
							        const double srcQuad[4][2], Fw8u* pDst, int dstStep, FwiRect dstRoi,
									const double dstQuad[4][2], int interpolation )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiWarpAffineQuad_8u_AC4R(pSrc, srcSize, srcStep, srcRoi, srcQuad, pDst, dstStep, dstRoi, dstQuad, interpolation);
    case DT_REFR:
        return _refr_fwiWarpAffineQuad_8u_AC4R(pSrc, srcSize, srcStep, srcRoi, srcQuad, pDst, dstStep, dstRoi, dstQuad, interpolation);
    default:
        assert(false);
        return _refr_fwiWarpAffineQuad_8u_AC4R(pSrc, srcSize, srcStep, srcRoi, srcQuad, pDst, dstStep, dstRoi, dstQuad, interpolation);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiAddSquare_32f_C1IR( const Fw32f *pSrc, int srcStep, Fw32f* pSrcDst, int srcDstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiAddSquare_32f_C1IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiAddSquare_32f_C1IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    case DT_REFR:
        return _refr_fwiAddSquare_32f_C1IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiAddSquare_32f_C1IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiDivC_32fc_C3IR( const Fw32fc value[3], Fw32fc *pSrcDst, int srcDstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiDivC_32fc_C3IR(value, pSrcDst, srcDstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiDivC_32fc_C3IR(value, pSrcDst, srcDstStep, roiSize);
    case DT_REFR:
        return _refr_fwiDivC_32fc_C3IR(value, pSrcDst, srcDstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiDivC_32fc_C3IR(value, pSrcDst, srcDstStep, roiSize);
    }
}

OREFR             FwStatus STDCALL fwiConvert_8u32f_AC4R( const Fw8u *pSrc, int srcStep, Fw32f *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiConvert_8u32f_AC4R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiConvert_8u32f_AC4R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiRotate_32f_C1R( const Fw32f* pSrc, FwiSize srcSize, int srcStep, FwiRect srcRoi, Fw32f* pDst, int dstStep, FwiRect dstRoi, double angle, double xShift, double yShift, int interpolation )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiRotate_32f_C1R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, angle, xShift, yShift, interpolation);
    case DT_REFR:
        return _refr_fwiRotate_32f_C1R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, angle, xShift, yShift, interpolation);
    default:
        assert(false);
        return _refr_fwiRotate_32f_C1R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, angle, xShift, yShift, interpolation);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiSwapChannels_8u_C3R(const Fw8u *pSrc,int srcStep, Fw8u *pDst, int dstStep, FwiSize roiSize,const int dstOrder[3])
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiSwapChannels_8u_C3R(pSrc, srcStep, pDst, dstStep, roiSize, dstOrder);
    case DT_SSE2:
        return _sse2_fwiSwapChannels_8u_C3R(pSrc, srcStep, pDst, dstStep, roiSize, dstOrder);
    case DT_REFR:
        return _refr_fwiSwapChannels_8u_C3R(pSrc, srcStep, pDst, dstStep, roiSize, dstOrder);
    default:
        assert(false);
        return _refr_fwiSwapChannels_8u_C3R(pSrc, srcStep, pDst, dstStep, roiSize, dstOrder);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiSwapChannels_32f_C3R(const Fw32f *pSrc,int srcStep, Fw32f *pDst, int dstStep, FwiSize roiSize,const int dstOrder[3])
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiSwapChannels_32f_C3R(pSrc, srcStep, pDst, dstStep, roiSize, dstOrder);
    case DT_SSE2:
        return _sse2_fwiSwapChannels_32f_C3R(pSrc, srcStep, pDst, dstStep, roiSize, dstOrder);
    case DT_REFR:
        return _refr_fwiSwapChannels_32f_C3R(pSrc, srcStep, pDst, dstStep, roiSize, dstOrder);
    default:
        assert(false);
        return _refr_fwiSwapChannels_32f_C3R(pSrc, srcStep, pDst, dstStep, roiSize, dstOrder);
    }
}


OREFR OSSE2       FwStatus STDCALL fwiFilterMedianColor_8u_C3R( const Fw8u * pSrc, int srcStep,
                                                Fw8u * pDst, int dstStep, FwiSize dstRoiSize,
                                                FwiMaskSize maskSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilterMedianColor_8u_C3R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize);
    case DT_REFR:
        return _refr_fwiFilterMedianColor_8u_C3R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize);
    default:
        assert(false);
        return _refr_fwiFilterMedianColor_8u_C3R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiXor_16u_AC4IR( const Fw16u *pSrc,  int srcStep,        Fw16u *pSrcDst, int srcDstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiXor_16u_AC4IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiXor_16u_AC4IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    case DT_REFR:
        return _refr_fwiXor_16u_AC4IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiXor_16u_AC4IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    }
}

OREFR               FwStatus fwiBGRToHLS_8u_AP4C4R( const A8U* const pSrc[4], int srcStep, A8U* pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiBGRToHLS_8u_AP4C4R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiBGRToHLS_8u_AP4C4R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiAndC_32s_AC4R( const Fw32s  *pSrc, int srcStep, const Fw32s value[3], Fw32s *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiAndC_32s_AC4R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiAndC_32s_AC4R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiAndC_32s_AC4R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiAndC_32s_AC4R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    }
}

OREFR       FwStatus STDCALL fwiShear_32f_C1R(const Fw32f* pSrc, FwiSize srcSize, int srcStep, FwiRect srcRoi, Fw32f* pDst, int dstStep, FwiRect dstRoi, double xShear, double yShear, double xShift, double yShift, int interpolation )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiShear_32f_C1R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, xShear, yShear, xShift, yShift, interpolation);
    default:
        assert(false);
        return _refr_fwiShear_32f_C1R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, xShear, yShear, xShift, yShift, interpolation);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiMulC_32f_C3IR( const Fw32f value[3], Fw32f *pSrcDst, int srcDstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiMulC_32f_C3IR(value, pSrcDst, srcDstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiMulC_32f_C3IR(value, pSrcDst, srcDstStep, roiSize);
    case DT_REFR:
        return _refr_fwiMulC_32f_C3IR(value, pSrcDst, srcDstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiMulC_32f_C3IR(value, pSrcDst, srcDstStep, roiSize);
    }
}

OREFR               FwStatus fwiYCCToRGB_32f_AC4R( const Fw32f* pSrc, int srcStep, Fw32f* pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiYCCToRGB_32f_AC4R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiYCCToRGB_32f_AC4R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiCopy_32s_C1C4R( const Fw32s *pSrc, int srcStep, Fw32s *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiCopy_32s_C1C4R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiCopy_32s_C1C4R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiCopy_32s_C1C4R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiCopy_32s_C1C4R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiAndC_32s_C3IR( const Fw32s value[3], Fw32s *pSrcDst, int srcDstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiAndC_32s_C3IR(value, pSrcDst, srcDstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiAndC_32s_C3IR(value, pSrcDst, srcDstStep, roiSize);
    case DT_REFR:
        return _refr_fwiAndC_32s_C3IR(value, pSrcDst, srcDstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiAndC_32s_C3IR(value, pSrcDst, srcDstStep, roiSize);
    }
}


OREFR OSSE2       FwStatus STDCALL fwiSumWindowRow_8u32f_C1R( const Fw8u * pSrc, int srcStep,
                               Fw32f * pDst, int dstStep, FwiSize dstRoiSize,
                               int maskSize, int anchor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiSumWindowRow_8u32f_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize, anchor);
    case DT_REFR:
        return _refr_fwiSumWindowRow_8u32f_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize, anchor);
    default:
        assert(false);
        return _refr_fwiSumWindowRow_8u32f_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize, anchor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiThreshold_LTVal_16s_C1R( const Fw16s *pSrc, int srcStep, Fw16s *pDst, int dstStep, FwiSize roiSize, Fw16s threshold, Fw16s value)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiThreshold_LTVal_16s_C1R(pSrc, srcStep, pDst, dstStep, roiSize, threshold, value);
    case DT_SSE2:
        return _sse2_fwiThreshold_LTVal_16s_C1R(pSrc, srcStep, pDst, dstStep, roiSize, threshold, value);
    case DT_REFR:
        return _refr_fwiThreshold_LTVal_16s_C1R(pSrc, srcStep, pDst, dstStep, roiSize, threshold, value);
    default:
        assert(false);
        return _refr_fwiThreshold_LTVal_16s_C1R(pSrc, srcStep, pDst, dstStep, roiSize, threshold, value);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiRotateCenter_16u_P3R( const Fw16u* const pSrc[3],FwiSize srcSize, int srcStep, FwiRect srcRoi, Fw16u* const pDst[3], int dstStep, FwiRect dstRoi, double angle, double xCenter, double yCenter, int interpolation )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiRotateCenter_16u_P3R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, angle, xCenter, yCenter, interpolation);
    case DT_REFR:
        return _refr_fwiRotateCenter_16u_P3R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, angle, xCenter, yCenter, interpolation);
    default:
        assert(false);
        return _refr_fwiRotateCenter_16u_P3R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, angle, xCenter, yCenter, interpolation);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiSub_16s_C1RSfs( const Fw16s  *pSrc1, int src1Step, const Fw16s  *pSrc2,   int src2Step, Fw16s *pDst, int dstStep, FwiSize roiSize, int scaleFactor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiSub_16s_C1RSfs(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, scaleFactor);
    case DT_SSE2:
        return _sse2_fwiSub_16s_C1RSfs(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, scaleFactor);
    case DT_REFR:
        return _refr_fwiSub_16s_C1RSfs(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, scaleFactor);
    default:
        assert(false);
        return _refr_fwiSub_16s_C1RSfs(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiAnd_16u_C1R( const Fw16u *pSrc1, int src1Step, const Fw16u *pSrc2,   int src2Step, Fw16u *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiAnd_16u_C1R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiAnd_16u_C1R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiAnd_16u_C1R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiAnd_16u_C1R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 FwStatus STDCALL fwiFilterSharpen_32f_C1R( const Fw32f * pSrc, int srcStep, Fw32f * pDst, int dstStep, FwiSize dstRoiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilterSharpen_32f_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize);
    case DT_REFR:
        return _refr_fwiFilterSharpen_32f_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize);
    default:
        assert(false);
        return _refr_fwiFilterSharpen_32f_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize);
    }
}

OREFR               FwStatus fwiRGBToYCC_16s_AC4R( const Fw16s* pSrc, int srcStep, Fw16s* pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiRGBToYCC_16s_AC4R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiRGBToYCC_16s_AC4R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiMirror_32s_C3R( const Fw32s *pSrc, int srcStep, Fw32s *pDst, int dstStep, FwiSize roiSize, FwiAxis flip)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiMirror_32s_C3R(pSrc, srcStep, pDst, dstStep, roiSize, flip);
    case DT_REFR:
        return _refr_fwiMirror_32s_C3R(pSrc, srcStep, pDst, dstStep, roiSize, flip);
    default:
        assert(false);
        return _refr_fwiMirror_32s_C3R(pSrc, srcStep, pDst, dstStep, roiSize, flip);
    }
}

OREFR       FwStatus STDCALL fwiShear_8u_P4R(const Fw8u* const pSrc[4], FwiSize srcSize, int srcStep, FwiRect srcRoi, Fw8u* const pDst[4], int dstStep, FwiRect dstRoi, double xShear, double yShear, double xShift, double yShift, int interpolation)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiShear_8u_P4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, xShear, yShear, xShift, yShift, interpolation);
    default:
        assert(false);
        return _refr_fwiShear_8u_P4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, xShear, yShear, xShift, yShift, interpolation);
    }
}

OREFR               FwStatus fwiLUVToRGB_16u_AC4R( const Fw16u* pSrc, int srcStep, Fw16u* pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiLUVToRGB_16u_AC4R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiLUVToRGB_16u_AC4R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiFilterMedianColor_16s_AC4R( const Fw16s * pSrc, int srcStep,
                                                  Fw16s * pDst, int dstStep, FwiSize dstRoiSize,
                                                  FwiMaskSize maskSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilterMedianColor_16s_AC4R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize);
    case DT_REFR:
        return _refr_fwiFilterMedianColor_16s_AC4R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize);
    default:
        assert(false);
        return _refr_fwiFilterMedianColor_16s_AC4R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize);
    }
}

OREFR OSSE2 FwStatus STDCALL fwiWarpPerspectiveQuad_8u_AC4R( const Fw8u* pSrc, FwiSize srcSize, int srcStep, FwiRect srcRoi,
							        const double srcQuad[4][2], Fw8u* pDst, int dstStep, FwiRect dstRoi,
									const double dstQuad[4][2], int interpolation )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiWarpPerspectiveQuad_8u_AC4R(pSrc, srcSize, srcStep, srcRoi, srcQuad, pDst, dstStep, dstRoi, dstQuad, interpolation);
    case DT_REFR:
        return _refr_fwiWarpPerspectiveQuad_8u_AC4R(pSrc, srcSize, srcStep, srcRoi, srcQuad, pDst, dstStep, dstRoi, dstQuad, interpolation);
    default:
        assert(false);
        return _refr_fwiWarpPerspectiveQuad_8u_AC4R(pSrc, srcSize, srcStep, srcRoi, srcQuad, pDst, dstStep, dstRoi, dstQuad, interpolation);
    }
}

OREFR             FwStatus STDCALL fwiScale_8u16u_C1R( const Fw8u * pSrc, int srcStep, Fw16u * pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiScale_8u16u_C1R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiScale_8u16u_C1R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiThreshold_LTValGTVal_32f_AC4IR( Fw32f *pSrcDst, int srcDstStep, FwiSize roiSize, const Fw32f thresholdLT[3], const Fw32f valueLT[3], const Fw32f thresholdGT[3], const Fw32f valueGT[3])
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiThreshold_LTValGTVal_32f_AC4IR(pSrcDst, srcDstStep, roiSize, thresholdLT, valueLT, thresholdGT, valueGT);
    case DT_SSE2:
        return _sse2_fwiThreshold_LTValGTVal_32f_AC4IR(pSrcDst, srcDstStep, roiSize, thresholdLT, valueLT, thresholdGT, valueGT);
    case DT_REFR:
        return _refr_fwiThreshold_LTValGTVal_32f_AC4IR(pSrcDst, srcDstStep, roiSize, thresholdLT, valueLT, thresholdGT, valueGT);
    default:
        assert(false);
        return _refr_fwiThreshold_LTValGTVal_32f_AC4IR(pSrcDst, srcDstStep, roiSize, thresholdLT, valueLT, thresholdGT, valueGT);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiConvert_8u16s_C3R( const Fw8u *pSrc, int srcStep, Fw16s *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiConvert_8u16s_C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiConvert_8u16s_C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiConvert_8u16s_C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiConvert_8u16s_C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR       FwStatus STDCALL fwiZigzagFwd8x8_16s_C1(const Fw16s* pSrc, Fw16s* pDst)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiZigzagFwd8x8_16s_C1(pSrc, pDst);
    default:
        assert(false);
        return _refr_fwiZigzagFwd8x8_16s_C1(pSrc, pDst);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiRotate_8u_C3R( const Fw8u* pSrc, FwiSize srcSize, int srcStep, FwiRect srcRoi, Fw8u* pDst, int dstStep, FwiRect dstRoi, double angle, double xShift, double yShift, int interpolation )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiRotate_8u_C3R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, angle, xShift, yShift, interpolation);
    case DT_REFR:
        return _refr_fwiRotate_8u_C3R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, angle, xShift, yShift, interpolation);
    default:
        assert(false);
        return _refr_fwiRotate_8u_C3R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, angle, xShift, yShift, interpolation);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiThreshold_LT_32f_AC4IR( Fw32f *pSrcDst, int srcDstStep, FwiSize roiSize, const Fw32f threshold[3])
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiThreshold_LT_32f_AC4IR(pSrcDst, srcDstStep, roiSize, threshold);
    case DT_SSE2:
        return _sse2_fwiThreshold_LT_32f_AC4IR(pSrcDst, srcDstStep, roiSize, threshold);
    case DT_REFR:
        return _refr_fwiThreshold_LT_32f_AC4IR(pSrcDst, srcDstStep, roiSize, threshold);
    default:
        assert(false);
        return _refr_fwiThreshold_LT_32f_AC4IR(pSrcDst, srcDstStep, roiSize, threshold);
    }
}

OREFR       FwStatus STDCALL fwiShear_8u_AC4R(const Fw8u* pSrc, FwiSize srcSize, int srcStep, FwiRect srcRoi, Fw8u* pDst, int dstStep, FwiRect dstRoi, double xShear, double yShear, double xShift, double yShift, int interpolation )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiShear_8u_AC4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, xShear, yShear, xShift, yShift, interpolation);
    default:
        assert(false);
        return _refr_fwiShear_8u_AC4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, xShear, yShear, xShift, yShift, interpolation);
    }
}

OREFR OSSE2         FwStatus fwiMean_16s_C4R(const Fw16s* pSrc, int srcStep,FwiSize roiSize, Fw64f mean[4])
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiMean_16s_C4R(pSrc, srcStep, roiSize, mean);
    case DT_REFR:
        return _refr_fwiMean_16s_C4R(pSrc, srcStep, roiSize, mean);
    default:
        assert(false);
        return _refr_fwiMean_16s_C4R(pSrc, srcStep, roiSize, mean);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiCopy_16s_C3C1R( const Fw16s *pSrc, int srcStep, Fw16s *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiCopy_16s_C3C1R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiCopy_16s_C3C1R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiCopy_16s_C3C1R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiCopy_16s_C3C1R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiAddC_16s_C4RSfs( const Fw16s  *pSrc, int srcStep, const Fw16s value[4], Fw16s *pDst, int dstStep, FwiSize roiSize, int scaleFactor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiAddC_16s_C4RSfs(pSrc, srcStep, value, pDst, dstStep, roiSize, scaleFactor);
    case DT_SSE2:
        return _sse2_fwiAddC_16s_C4RSfs(pSrc, srcStep, value, pDst, dstStep, roiSize, scaleFactor);
    case DT_REFR:
        return _refr_fwiAddC_16s_C4RSfs(pSrc, srcStep, value, pDst, dstStep, roiSize, scaleFactor);
    default:
        assert(false);
        return _refr_fwiAddC_16s_C4RSfs(pSrc, srcStep, value, pDst, dstStep, roiSize, scaleFactor);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiFilter_32f_C3R( const Fw32f * pSrc, int srcStep,
                              Fw32f * pDst, int dstStep, FwiSize dstRoiSize,
                              const Fw32f * pKernel, FwiSize kernelSize,
                              FwiPoint anchor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilter_32f_C3R(pSrc, srcStep, pDst, dstStep, dstRoiSize, pKernel, kernelSize, anchor);
    case DT_REFR:
        return _refr_fwiFilter_32f_C3R(pSrc, srcStep, pDst, dstStep, dstRoiSize, pKernel, kernelSize, anchor);
    default:
        assert(false);
        return _refr_fwiFilter_32f_C3R(pSrc, srcStep, pDst, dstStep, dstRoiSize, pKernel, kernelSize, anchor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiSwapChannels_16u_C3R(const Fw16u *pSrc,int srcStep, Fw16u *pDst, int dstStep, FwiSize roiSize,const int dstOrder[3])
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiSwapChannels_16u_C3R(pSrc, srcStep, pDst, dstStep, roiSize, dstOrder);
    case DT_SSE2:
        return _sse2_fwiSwapChannels_16u_C3R(pSrc, srcStep, pDst, dstStep, roiSize, dstOrder);
    case DT_REFR:
        return _refr_fwiSwapChannels_16u_C3R(pSrc, srcStep, pDst, dstStep, roiSize, dstOrder);
    default:
        assert(false);
        return _refr_fwiSwapChannels_16u_C3R(pSrc, srcStep, pDst, dstStep, roiSize, dstOrder);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiXorC_32s_AC4R( const Fw32s  *pSrc, int srcStep, const Fw32s value[3], Fw32s *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiXorC_32s_AC4R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiXorC_32s_AC4R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiXorC_32s_AC4R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiXorC_32s_AC4R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2         FwStatus fwiYUV420ToBGR444_8u16u_P3C3R(const A8U* const pSrc[3], int srcStep[3], A16U* pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiYUV420ToBGR444_8u16u_P3C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiYUV420ToBGR444_8u16u_P3C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiYUV420ToBGR444_8u16u_P3C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiThreshold_LT_8u_C1R( const Fw8u *pSrc, int srcStep, Fw8u *pDst, int dstStep, FwiSize roiSize, Fw8u threshold)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiThreshold_LT_8u_C1R(pSrc, srcStep, pDst, dstStep, roiSize, threshold);
    case DT_SSE2:
        return _sse2_fwiThreshold_LT_8u_C1R(pSrc, srcStep, pDst, dstStep, roiSize, threshold);
    case DT_REFR:
        return _refr_fwiThreshold_LT_8u_C1R(pSrc, srcStep, pDst, dstStep, roiSize, threshold);
    default:
        assert(false);
        return _refr_fwiThreshold_LT_8u_C1R(pSrc, srcStep, pDst, dstStep, roiSize, threshold);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiFilterBox_32f_AC4R( const Fw32f * pSrc, int srcStep,
                               Fw32f * pDst, int dstStep, FwiSize dstRoiSize,
                               FwiSize maskSize, FwiPoint anchor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilterBox_32f_AC4R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize, anchor);
    case DT_REFR:
        return _refr_fwiFilterBox_32f_AC4R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize, anchor);
    default:
        assert(false);
        return _refr_fwiFilterBox_32f_AC4R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize, anchor);
    }
}

OREFR               FwStatus fwiRGBToLUV_16s_C3R( const Fw16s* pSrc, int srcStep, Fw16s* pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiRGBToLUV_16s_C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiRGBToLUV_16s_C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiOr_16u_C3R( const Fw16u *pSrc1, int src1Step, const Fw16u *pSrc2,   int src2Step, Fw16u *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiOr_16u_C3R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiOr_16u_C3R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiOr_16u_C3R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiOr_16u_C3R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiMulC_8u_C1RSfs( const Fw8u *pSrc, int srcStep,      Fw8u value,    Fw8u *pDst, int dstStep, FwiSize roiSize, int scaleFactor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiMulC_8u_C1RSfs(pSrc, srcStep, value, pDst, dstStep, roiSize, scaleFactor);
    case DT_SSE2:
        return _sse2_fwiMulC_8u_C1RSfs(pSrc, srcStep, value, pDst, dstStep, roiSize, scaleFactor);
    case DT_REFR:
        return _refr_fwiMulC_8u_C1RSfs(pSrc, srcStep, value, pDst, dstStep, roiSize, scaleFactor);
    default:
        assert(false);
        return _refr_fwiMulC_8u_C1RSfs(pSrc, srcStep, value, pDst, dstStep, roiSize, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiLShiftC_16u_AC4R( const Fw16u  *pSrc, int srcStep, const Fw32u value[3], Fw16u *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiLShiftC_16u_AC4R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiLShiftC_16u_AC4R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiLShiftC_16u_AC4R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiLShiftC_16u_AC4R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiAddProduct_8u32f_C1IMR( const Fw8u *pSrc1,  int src1Step, const Fw8u *pSrc2,  int src2Step, const Fw8u* pMask, int maskStep, Fw32f *pSrcDst, int srcDstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiAddProduct_8u32f_C1IMR(pSrc1, src1Step, pSrc2, src2Step, pMask, maskStep, pSrcDst, srcDstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiAddProduct_8u32f_C1IMR(pSrc1, src1Step, pSrc2, src2Step, pMask, maskStep, pSrcDst, srcDstStep, roiSize);
    case DT_REFR:
        return _refr_fwiAddProduct_8u32f_C1IMR(pSrc1, src1Step, pSrc2, src2Step, pMask, maskStep, pSrcDst, srcDstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiAddProduct_8u32f_C1IMR(pSrc1, src1Step, pSrc2, src2Step, pMask, maskStep, pSrcDst, srcDstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiXorC_32s_C3IR( const Fw32s value[3], Fw32s *pSrcDst, int srcDstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiXorC_32s_C3IR(value, pSrcDst, srcDstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiXorC_32s_C3IR(value, pSrcDst, srcDstStep, roiSize);
    case DT_REFR:
        return _refr_fwiXorC_32s_C3IR(value, pSrcDst, srcDstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiXorC_32s_C3IR(value, pSrcDst, srcDstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiMulCScale_16u_C4R( const Fw16u *pSrc, int srcStep, const Fw16u value[4], Fw16u *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiMulCScale_16u_C4R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiMulCScale_16u_C4R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiMulCScale_16u_C4R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiMulCScale_16u_C4R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiThreshold_16s_AC4R( const Fw16s *pSrc, int srcStep, Fw16s *pDst, int dstStep, FwiSize roiSize, const Fw16s threshold[3], FwCmpOp fwCmpOp)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiThreshold_16s_AC4R(pSrc, srcStep, pDst, dstStep, roiSize, threshold, fwCmpOp);
    case DT_SSE2:
        return _sse2_fwiThreshold_16s_AC4R(pSrc, srcStep, pDst, dstStep, roiSize, threshold, fwCmpOp);
    case DT_REFR:
        return _refr_fwiThreshold_16s_AC4R(pSrc, srcStep, pDst, dstStep, roiSize, threshold, fwCmpOp);
    default:
        assert(false);
        return _refr_fwiThreshold_16s_AC4R(pSrc, srcStep, pDst, dstStep, roiSize, threshold, fwCmpOp);
    }
}

OREFR OSSE2 FwStatus STDCALL fwiWarpAffineBack_32f_P3R( const Fw32f* const pSrc[3], FwiSize srcSize, int srcStep,
								FwiRect srcRoi, Fw32f* const pDst[3], int dstStep, FwiRect dstRoi,
								const double coeffs[2][3], int interpolation )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiWarpAffineBack_32f_P3R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, coeffs, interpolation);
    case DT_REFR:
        return _refr_fwiWarpAffineBack_32f_P3R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, coeffs, interpolation);
    default:
        assert(false);
        return _refr_fwiWarpAffineBack_32f_P3R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, coeffs, interpolation);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiMulC_16sc_C1RSfs( const Fw16sc *pSrc, int srcStep,       Fw16sc value,    Fw16sc *pDst, int dstStep, FwiSize roiSize, int scaleFactor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiMulC_16sc_C1RSfs(pSrc, srcStep, value, pDst, dstStep, roiSize, scaleFactor);
    case DT_SSE2:
        return _sse2_fwiMulC_16sc_C1RSfs(pSrc, srcStep, value, pDst, dstStep, roiSize, scaleFactor);
    case DT_REFR:
        return _refr_fwiMulC_16sc_C1RSfs(pSrc, srcStep, value, pDst, dstStep, roiSize, scaleFactor);
    default:
        assert(false);
        return _refr_fwiMulC_16sc_C1RSfs(pSrc, srcStep, value, pDst, dstStep, roiSize, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiLShiftC_8u_C4IR( const Fw32u value[4], Fw8u *pSrcDst, int srcDstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiLShiftC_8u_C4IR(value, pSrcDst, srcDstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiLShiftC_8u_C4IR(value, pSrcDst, srcDstStep, roiSize);
    case DT_REFR:
        return _refr_fwiLShiftC_8u_C4IR(value, pSrcDst, srcDstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiLShiftC_8u_C4IR(value, pSrcDst, srcDstStep, roiSize);
    }
}

OREFR OSSE2         FwStatus fwiSum_32f_C4R(const Fw32f* pSrc, int srcStep, FwiSize roiSize, Fw64f sum[4], FwHintAlgorithm hint)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiSum_32f_C4R(pSrc, srcStep, roiSize, sum, hint);
    case DT_REFR:
        return _refr_fwiSum_32f_C4R(pSrc, srcStep, roiSize, sum, hint);
    default:
        assert(false);
        return _refr_fwiSum_32f_C4R(pSrc, srcStep, roiSize, sum, hint);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiFilterPrewittVert_16s_C3R( const Fw16s * pSrc, int srcStep, Fw16s * pDst, int dstStep, FwiSize dstRoiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilterPrewittVert_16s_C3R(pSrc, srcStep, pDst, dstStep, dstRoiSize);
    case DT_REFR:
        return _refr_fwiFilterPrewittVert_16s_C3R(pSrc, srcStep, pDst, dstStep, dstRoiSize);
    default:
        assert(false);
        return _refr_fwiFilterPrewittVert_16s_C3R(pSrc, srcStep, pDst, dstStep, dstRoiSize);
    }
}

OREFR OSSE2 FwStatus STDCALL fwiWarpPerspective_32f_P3R( const Fw32f* const pSrc[3], FwiSize srcSize, int srcStep,
								FwiRect srcRoi, Fw32f* const pDst[3], int dstStep, FwiRect dstRoi,
								const double coeffs[3][3], int interpolation )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiWarpPerspective_32f_P3R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, coeffs, interpolation);
    case DT_REFR:
        return _refr_fwiWarpPerspective_32f_P3R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, coeffs, interpolation);
    default:
        assert(false);
        return _refr_fwiWarpPerspective_32f_P3R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, coeffs, interpolation);
    }
}

OREFR       FwStatus STDCALL fwiMirror_32f_C3R( const Fw32f *pSrc, int srcStep, Fw32f *pDst, int dstStep, FwiSize roiSize, FwiAxis flip)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiMirror_32f_C3R(pSrc, srcStep, pDst, dstStep, roiSize, flip);
    default:
        assert(false);
        return _refr_fwiMirror_32f_C3R(pSrc, srcStep, pDst, dstStep, roiSize, flip);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiFilterBox_32f_AC4IR( Fw32f * pSrcDst, int srcDstStep,
                               FwiSize dstRoiSize, FwiSize maskSize, FwiPoint anchor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilterBox_32f_AC4IR(pSrcDst, srcDstStep, dstRoiSize, maskSize, anchor);
    case DT_REFR:
        return _refr_fwiFilterBox_32f_AC4IR(pSrcDst, srcDstStep, dstRoiSize, maskSize, anchor);
    default:
        assert(false);
        return _refr_fwiFilterBox_32f_AC4IR(pSrcDst, srcDstStep, dstRoiSize, maskSize, anchor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiAddC_16sc_C3RSfs( const Fw16sc *pSrc, int srcStep, const Fw16sc value[3], Fw16sc *pDst, int dstStep, FwiSize roiSize, int scaleFactor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiAddC_16sc_C3RSfs(pSrc, srcStep, value, pDst, dstStep, roiSize, scaleFactor);
    case DT_SSE2:
        return _sse2_fwiAddC_16sc_C3RSfs(pSrc, srcStep, value, pDst, dstStep, roiSize, scaleFactor);
    case DT_REFR:
        return _refr_fwiAddC_16sc_C3RSfs(pSrc, srcStep, value, pDst, dstStep, roiSize, scaleFactor);
    default:
        assert(false);
        return _refr_fwiAddC_16sc_C3RSfs(pSrc, srcStep, value, pDst, dstStep, roiSize, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiXor_16u_C4IR( const Fw16u *pSrc,  int srcStep,        Fw16u *pSrcDst, int srcDstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiXor_16u_C4IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiXor_16u_C4IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    case DT_REFR:
        return _refr_fwiXor_16u_C4IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiXor_16u_C4IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    }
}

OREFR               FwStatus fwiYCCToRGB_16s_AC4R( const Fw16s* pSrc, int srcStep, Fw16s* pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiYCCToRGB_16s_AC4R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiYCCToRGB_16s_AC4R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR               FwStatus fwiYCbCr422_8u_C2P3R(const Fw8u* pSrc, int srcStep, Fw8u* pDst[3], int dstStep[3], FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiYCbCr422_8u_C2P3R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiYCbCr422_8u_C2P3R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiMul_16sc_C1IRSfs( const Fw16sc *pSrc,  int srcStep,        Fw16sc *pSrcDst, int srcDstStep, FwiSize roiSize, int scaleFactor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiMul_16sc_C1IRSfs(pSrc, srcStep, pSrcDst, srcDstStep, roiSize, scaleFactor);
    case DT_SSE2:
        return _sse2_fwiMul_16sc_C1IRSfs(pSrc, srcStep, pSrcDst, srcDstStep, roiSize, scaleFactor);
    case DT_REFR:
        return _refr_fwiMul_16sc_C1IRSfs(pSrc, srcStep, pSrcDst, srcDstStep, roiSize, scaleFactor);
    default:
        assert(false);
        return _refr_fwiMul_16sc_C1IRSfs(pSrc, srcStep, pSrcDst, srcDstStep, roiSize, scaleFactor);
    }
}

OREFR               FwStatus fwiCountInRange_32f_C3R(const Fw32f* pSrc, int srcStep,FwiSize roiSize, int counts[3], Fw32f lowerBound[3],Fw32f upperBound[3])
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiCountInRange_32f_C3R(pSrc, srcStep, roiSize, counts, lowerBound, upperBound);
    default:
        assert(false);
        return _refr_fwiCountInRange_32f_C3R(pSrc, srcStep, roiSize, counts, lowerBound, upperBound);
    }
}

OREFR               FwStatus fwiRGBToHLS_16s_C3R( const Fw16s* pSrc, int srcStep, Fw16s* pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiRGBToHLS_16s_C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiRGBToHLS_16s_C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 FwStatus STDCALL fwiWarpAffineQuad_32f_C4R( const Fw32f* pSrc, FwiSize srcSize, int srcStep, FwiRect srcRoi,
							        const double srcQuad[4][2], Fw32f* pDst, int dstStep, FwiRect dstRoi,
									const double dstQuad[4][2], int interpolation )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiWarpAffineQuad_32f_C4R(pSrc, srcSize, srcStep, srcRoi, srcQuad, pDst, dstStep, dstRoi, dstQuad, interpolation);
    case DT_REFR:
        return _refr_fwiWarpAffineQuad_32f_C4R(pSrc, srcSize, srcStep, srcRoi, srcQuad, pDst, dstStep, dstRoi, dstQuad, interpolation);
    default:
        assert(false);
        return _refr_fwiWarpAffineQuad_32f_C4R(pSrc, srcSize, srcStep, srcRoi, srcQuad, pDst, dstStep, dstRoi, dstQuad, interpolation);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiFilterColumn32f_8u_C3R( const Fw8u * pSrc, int srcStep,
                                Fw8u * pDst, int dstStep, FwiSize dstRoiSize,
                                const Fw32f * pKernel, int kernelSize,
                                int yAnchor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilterColumn32f_8u_C3R(pSrc, srcStep, pDst, dstStep, dstRoiSize, pKernel, kernelSize, yAnchor);
    case DT_REFR:
        return _refr_fwiFilterColumn32f_8u_C3R(pSrc, srcStep, pDst, dstStep, dstRoiSize, pKernel, kernelSize, yAnchor);
    default:
        assert(false);
        return _refr_fwiFilterColumn32f_8u_C3R(pSrc, srcStep, pDst, dstStep, dstRoiSize, pKernel, kernelSize, yAnchor);
    }
}

OREFR OSSE2 FwStatus STDCALL fwiResizeShift_16u_C1R( const Fw16u* pSrc, FwiSize srcSize, int srcStep, FwiRect srcRoi,
								  Fw16u* pDst, int dstStep, FwiSize dstRoiSize,
								  double xFr, double yFr, double xShift, double yShift, int interpolation )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiResizeShift_16u_C1R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoiSize, xFr, yFr, xShift, yShift, interpolation);
    case DT_REFR:
        return _refr_fwiResizeShift_16u_C1R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoiSize, xFr, yFr, xShift, yShift, interpolation);
    default:
        assert(false);
        return _refr_fwiResizeShift_16u_C1R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoiSize, xFr, yFr, xShift, yShift, interpolation);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiMul_32f_C3IR( const Fw32f  *pSrc,  int srcStep,        Fw32f  *pSrcDst, int srcDstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiMul_32f_C3IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiMul_32f_C3IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    case DT_REFR:
        return _refr_fwiMul_32f_C3IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiMul_32f_C3IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    }
}

OREFR OSSE2 FwStatus STDCALL fwiWarpPerspectiveQuad_32f_AC4R( const Fw32f* pSrc, FwiSize srcSize, int srcStep, FwiRect srcRoi,
							        const double srcQuad[4][2], Fw32f* pDst, int dstStep, FwiRect dstRoi,
									const double dstQuad[4][2], int interpolation )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiWarpPerspectiveQuad_32f_AC4R(pSrc, srcSize, srcStep, srcRoi, srcQuad, pDst, dstStep, dstRoi, dstQuad, interpolation);
    case DT_REFR:
        return _refr_fwiWarpPerspectiveQuad_32f_AC4R(pSrc, srcSize, srcStep, srcRoi, srcQuad, pDst, dstStep, dstRoi, dstQuad, interpolation);
    default:
        assert(false);
        return _refr_fwiWarpPerspectiveQuad_32f_AC4R(pSrc, srcSize, srcStep, srcRoi, srcQuad, pDst, dstStep, dstRoi, dstQuad, interpolation);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiSubC_32f_C4R( const Fw32f *pSrc, int srcStep, const Fw32f value[4], Fw32f *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiSubC_32f_C4R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiSubC_32f_C4R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiSubC_32f_C4R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiSubC_32f_C4R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    }
}

OREFR               FwStatus fwiBGRToHLS_8u_AC4P4R( const A8U* pSrc, int srcStep, A8U* const pDst[4], int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiBGRToHLS_8u_AC4P4R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiBGRToHLS_8u_AC4P4R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiThreshold_LTVal_8u_AC4R( const Fw8u *pSrc, int srcStep, Fw8u *pDst, int dstStep, FwiSize roiSize, const Fw8u threshold[3], const Fw8u value[3])
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiThreshold_LTVal_8u_AC4R(pSrc, srcStep, pDst, dstStep, roiSize, threshold, value);
    case DT_SSE2:
        return _sse2_fwiThreshold_LTVal_8u_AC4R(pSrc, srcStep, pDst, dstStep, roiSize, threshold, value);
    case DT_REFR:
        return _refr_fwiThreshold_LTVal_8u_AC4R(pSrc, srcStep, pDst, dstStep, roiSize, threshold, value);
    default:
        assert(false);
        return _refr_fwiThreshold_LTVal_8u_AC4R(pSrc, srcStep, pDst, dstStep, roiSize, threshold, value);
    }
}

OREFR OSSE2 OF10H   FwStatus fwiRGBToYUV_8u_C3R( const Fw8u *pSrc, int srcStep, Fw8u *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiRGBToYUV_8u_C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiRGBToYUV_8u_C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiRGBToYUV_8u_C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiRGBToYUV_8u_C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiMulC_32fc_AC4IR( const Fw32fc value[3], Fw32fc *pSrcDst, int srcDstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiMulC_32fc_AC4IR(value, pSrcDst, srcDstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiMulC_32fc_AC4IR(value, pSrcDst, srcDstStep, roiSize);
    case DT_REFR:
        return _refr_fwiMulC_32fc_AC4IR(value, pSrcDst, srcDstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiMulC_32fc_AC4IR(value, pSrcDst, srcDstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiSqr_16u_C1IRSfs(       Fw16u *pSrcDst, int srcDstStep, FwiSize roiSize, int scaleFactor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiSqr_16u_C1IRSfs(pSrcDst, srcDstStep, roiSize, scaleFactor);
    case DT_SSE2:
        return _sse2_fwiSqr_16u_C1IRSfs(pSrcDst, srcDstStep, roiSize, scaleFactor);
    case DT_REFR:
        return _refr_fwiSqr_16u_C1IRSfs(pSrcDst, srcDstStep, roiSize, scaleFactor);
    default:
        assert(false);
        return _refr_fwiSqr_16u_C1IRSfs(pSrcDst, srcDstStep, roiSize, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiConvert_32f8u_C4R( const Fw32f *pSrc, int srcStep, Fw8u *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiConvert_32f8u_C4R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiConvert_32f8u_C4R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiConvert_32f8u_C4R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiConvert_32f8u_C4R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiFilterHipass_8u_C4R( const Fw8u * pSrc, int srcStep, Fw8u * pDst, int dstStep, FwiSize dstRoiSize, FwiMaskSize maskSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilterHipass_8u_C4R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize);
    case DT_REFR:
        return _refr_fwiFilterHipass_8u_C4R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize);
    default:
        assert(false);
        return _refr_fwiFilterHipass_8u_C4R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiRotateCenter_8u_C4R( const Fw8u* pSrc,FwiSize srcSize, int srcStep, FwiRect srcRoi, Fw8u* pDst, int dstStep, FwiRect dstRoi, double angle, double xCenter, double yCenter, int interpolation )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiRotateCenter_8u_C4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, angle, xCenter, yCenter, interpolation);
    case DT_REFR:
        return _refr_fwiRotateCenter_8u_C4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, angle, xCenter, yCenter, interpolation);
    default:
        assert(false);
        return _refr_fwiRotateCenter_8u_C4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, angle, xCenter, yCenter, interpolation);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiThreshold_16s_C3R( const Fw16s *pSrc, int srcStep, Fw16s *pDst, int dstStep, FwiSize roiSize, const Fw16s threshold[3], FwCmpOp fwCmpOp)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiThreshold_16s_C3R(pSrc, srcStep, pDst, dstStep, roiSize, threshold, fwCmpOp);
    case DT_SSE2:
        return _sse2_fwiThreshold_16s_C3R(pSrc, srcStep, pDst, dstStep, roiSize, threshold, fwCmpOp);
    case DT_REFR:
        return _refr_fwiThreshold_16s_C3R(pSrc, srcStep, pDst, dstStep, roiSize, threshold, fwCmpOp);
    default:
        assert(false);
        return _refr_fwiThreshold_16s_C3R(pSrc, srcStep, pDst, dstStep, roiSize, threshold, fwCmpOp);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiCopy_16s_C1C3R( const Fw16s *pSrc, int srcStep, Fw16s *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiCopy_16s_C1C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiCopy_16s_C1C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiCopy_16s_C1C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiCopy_16s_C1C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiOr_8u_C3IR( const Fw8u	*pSrc,  int srcStep,        Fw8u *pSrcDst, int srcDstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiOr_8u_C3IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiOr_8u_C3IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    case DT_REFR:
        return _refr_fwiOr_8u_C3IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiOr_8u_C3IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiFilterPrewittHoriz_32f_C4R( const Fw32f * pSrc, int srcStep, Fw32f * pDst, int dstStep, FwiSize dstRoiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilterPrewittHoriz_32f_C4R(pSrc, srcStep, pDst, dstStep, dstRoiSize);
    case DT_REFR:
        return _refr_fwiFilterPrewittHoriz_32f_C4R(pSrc, srcStep, pDst, dstStep, dstRoiSize);
    default:
        assert(false);
        return _refr_fwiFilterPrewittHoriz_32f_C4R(pSrc, srcStep, pDst, dstStep, dstRoiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiMul_32sc_C3RSfs( const Fw32sc *pSrc1, int src1Step, const Fw32sc *pSrc2,   int src2Step, Fw32sc *pDst, int dstStep, FwiSize roiSize, int scaleFactor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiMul_32sc_C3RSfs(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, scaleFactor);
    case DT_SSE2:
        return _sse2_fwiMul_32sc_C3RSfs(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, scaleFactor);
    case DT_REFR:
        return _refr_fwiMul_32sc_C3RSfs(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, scaleFactor);
    default:
        assert(false);
        return _refr_fwiMul_32sc_C3RSfs(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiAdd_32f_C4IR( const Fw32f  *pSrc,  int srcStep,        Fw32f  *pSrcDst, int srcDstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiAdd_32f_C4IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiAdd_32f_C4IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    case DT_REFR:
        return _refr_fwiAdd_32f_C4IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiAdd_32f_C4IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiAndC_16u_C1R( const Fw16u  *pSrc, int srcStep,       Fw16u value,    Fw16u *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiAndC_16u_C1R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiAndC_16u_C1R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiAndC_16u_C1R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiAndC_16u_C1R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    }
}

OREFR       FwStatus STDCALL fwiWarpBilinear_32f_C3R(const Fw32f* pSrc, FwiSize srcSize, int srcStep,
								FwiRect srcRoi, Fw32f* pDst, int dstStep, FwiRect dstRoi,
								const double coeffs[2][4], int interpolation)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiWarpBilinear_32f_C3R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, coeffs, interpolation);
    default:
        assert(false);
        return _refr_fwiWarpBilinear_32f_C3R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, coeffs, interpolation);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiAbs_32f_C3IR( Fw32f *pSrcDst, int srcDstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiAbs_32f_C3IR(pSrcDst, srcDstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiAbs_32f_C3IR(pSrcDst, srcDstStep, roiSize);
    case DT_REFR:
        return _refr_fwiAbs_32f_C3IR(pSrcDst, srcDstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiAbs_32f_C3IR(pSrcDst, srcDstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiMul_32f_C1IR( const Fw32f  *pSrc,  int srcStep,        Fw32f  *pSrcDst, int srcDstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiMul_32f_C1IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiMul_32f_C1IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    case DT_REFR:
        return _refr_fwiMul_32f_C1IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiMul_32f_C1IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiAbsDiff_16u_C1R( const Fw16u *pSrc1, int src1Step, const Fw16u *pSrc2,  int src2Step, Fw16u *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiAbsDiff_16u_C1R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiAbsDiff_16u_C1R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiAbsDiff_16u_C1R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiAbsDiff_16u_C1R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    }
}

OREFR               FwStatus fwiRGBToLUV_32f_C3R( const Fw32f* pSrc, int srcStep, Fw32f* pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiRGBToLUV_32f_C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiRGBToLUV_32f_C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiExp_16s_C3RSfs( const Fw16s *pSrc, int srcStep, Fw16s *pDst, int dstStep, FwiSize roiSize, int scaleFactor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiExp_16s_C3RSfs(pSrc, srcStep, pDst, dstStep, roiSize, scaleFactor);
    case DT_SSE2:
        return _sse2_fwiExp_16s_C3RSfs(pSrc, srcStep, pDst, dstStep, roiSize, scaleFactor);
    case DT_REFR:
        return _refr_fwiExp_16s_C3RSfs(pSrc, srcStep, pDst, dstStep, roiSize, scaleFactor);
    default:
        assert(false);
        return _refr_fwiExp_16s_C3RSfs(pSrc, srcStep, pDst, dstStep, roiSize, scaleFactor);
    }
}


OREFR               FwStatus fwiRGBToYUV420_8u_P3R( const A8U* const pSrc[3], int srcStep, A8U* const pDst[3], int dstStep[3], FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiRGBToYUV420_8u_P3R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiRGBToYUV420_8u_P3R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiFilterBox_16s_C4IR( Fw16s * pSrcDst, int srcDstStep,
                               FwiSize dstRoiSize, FwiSize maskSize, FwiPoint anchor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilterBox_16s_C4IR(pSrcDst, srcDstStep, dstRoiSize, maskSize, anchor);
    case DT_REFR:
        return _refr_fwiFilterBox_16s_C4IR(pSrcDst, srcDstStep, dstRoiSize, maskSize, anchor);
    default:
        assert(false);
        return _refr_fwiFilterBox_16s_C4IR(pSrcDst, srcDstStep, dstRoiSize, maskSize, anchor);
    }
}

OREFR OSSE2 OF10H   FwStatus fwiYCbCrToRGB_8u_P3R( const Fw8u* const pSrc[3], int srcStep, Fw8u* const pDst[3], int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiYCbCrToRGB_8u_P3R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiYCbCrToRGB_8u_P3R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiYCbCrToRGB_8u_P3R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiYCbCrToRGB_8u_P3R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiSumWindowRow_16s32f_C1R( const Fw16s * pSrc, int srcStep,
                               Fw32f * pDst, int dstStep, FwiSize dstRoiSize,
                               int maskSize, int anchor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiSumWindowRow_16s32f_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize, anchor);
    case DT_REFR:
        return _refr_fwiSumWindowRow_16s32f_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize, anchor);
    default:
        assert(false);
        return _refr_fwiSumWindowRow_16s32f_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize, anchor);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiMirror_16u_C1R( const Fw16u *pSrc, int srcStep, Fw16u *pDst, int dstStep, FwiSize roiSize, FwiAxis flip)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiMirror_16u_C1R(pSrc, srcStep, pDst, dstStep, roiSize, flip);
    case DT_REFR:
        return _refr_fwiMirror_16u_C1R(pSrc, srcStep, pDst, dstStep, roiSize, flip);
    default:
        assert(false);
        return _refr_fwiMirror_16u_C1R(pSrc, srcStep, pDst, dstStep, roiSize, flip);
    }
}

OREFR OSSE2 FwStatus STDCALL fwiResize_32f_C4R( const Fw32f* pSrc, FwiSize srcSize, int srcStep, FwiRect srcRoi,
							 Fw32f* pDst, int dstStep, FwiSize dstRoiSize,
							 double xFactor, double yFactor, int interpolation )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiResize_32f_C4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoiSize, xFactor, yFactor, interpolation);
    case DT_REFR:
        return _refr_fwiResize_32f_C4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoiSize, xFactor, yFactor, interpolation);
    default:
        assert(false);
        return _refr_fwiResize_32f_C4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoiSize, xFactor, yFactor, interpolation);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiSubC_16s_AC4RSfs( const Fw16s *pSrc, int srcStep, const Fw16s value[3], Fw16s *pDst, int dstStep, FwiSize roiSize, int scaleFactor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiSubC_16s_AC4RSfs(pSrc, srcStep, value, pDst, dstStep, roiSize, scaleFactor);
    case DT_SSE2:
        return _sse2_fwiSubC_16s_AC4RSfs(pSrc, srcStep, value, pDst, dstStep, roiSize, scaleFactor);
    case DT_REFR:
        return _refr_fwiSubC_16s_AC4RSfs(pSrc, srcStep, value, pDst, dstStep, roiSize, scaleFactor);
    default:
        assert(false);
        return _refr_fwiSubC_16s_AC4RSfs(pSrc, srcStep, value, pDst, dstStep, roiSize, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiSet_16s_C3MR( const Fw16s  value[3], Fw16s  * pDst, int dstStep, FwiSize roiSize, const Fw8u * pMask, int maskStep )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiSet_16s_C3MR(value, pDst, dstStep, roiSize, pMask, maskStep);
    case DT_SSE2:
        return _sse2_fwiSet_16s_C3MR(value, pDst, dstStep, roiSize, pMask, maskStep);
    case DT_REFR:
        return _refr_fwiSet_16s_C3MR(value, pDst, dstStep, roiSize, pMask, maskStep);
    default:
        assert(false);
        return _refr_fwiSet_16s_C3MR(value, pDst, dstStep, roiSize, pMask, maskStep);
    }
}

OREFR               FwStatus fwiXYZToRGB_16u_AC4R( const Fw16u* pSrc, int srcStep, Fw16u* pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiXYZToRGB_16u_AC4R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiXYZToRGB_16u_AC4R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiCompareEqualEpsC_32f_AC4R( const Fw32f *pSrc, int srcStep, const Fw32f value[3], Fw8u *pDst, int dstStep, FwiSize roiSize, Fw32f eps)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiCompareEqualEpsC_32f_AC4R(pSrc, srcStep, value, pDst, dstStep, roiSize, eps);
    case DT_SSE2:
        return _sse2_fwiCompareEqualEpsC_32f_AC4R(pSrc, srcStep, value, pDst, dstStep, roiSize, eps);
    case DT_REFR:
        return _refr_fwiCompareEqualEpsC_32f_AC4R(pSrc, srcStep, value, pDst, dstStep, roiSize, eps);
    default:
        assert(false);
        return _refr_fwiCompareEqualEpsC_32f_AC4R(pSrc, srcStep, value, pDst, dstStep, roiSize, eps);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiAdd_16sc_AC4RSfs( const Fw16sc *pSrc1, int src1Step, const Fw16sc *pSrc2,   int src2Step, Fw16sc *pDst, int dstStep, FwiSize roiSize, int scaleFactor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiAdd_16sc_AC4RSfs(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, scaleFactor);
    case DT_SSE2:
        return _sse2_fwiAdd_16sc_AC4RSfs(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, scaleFactor);
    case DT_REFR:
        return _refr_fwiAdd_16sc_AC4RSfs(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, scaleFactor);
    default:
        assert(false);
        return _refr_fwiAdd_16sc_AC4RSfs(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, scaleFactor);
    }
}


OREFR OSSE2       FwStatus STDCALL fwiFilterScharrHoriz_8u16s_C1R( const Fw8u * pSrc, int srcStep, Fw16s * pDst, int dstStep, FwiSize dstRoiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilterScharrHoriz_8u16s_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize);
    case DT_REFR:
        return _refr_fwiFilterScharrHoriz_8u16s_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize);
    default:
        assert(false);
        return _refr_fwiFilterScharrHoriz_8u16s_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiCopy_32f_C3P3R( const Fw32f * pSrc, int srcStep, Fw32f * const pDst[3], int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiCopy_32f_C3P3R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiCopy_32f_C3P3R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiCopy_32f_C3P3R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiCopy_32f_C3P3R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiSumWindowColumn_16s32f_C3R( const Fw16s * pSrc, int srcStep,
                               Fw32f * pDst, int dstStep, FwiSize dstRoiSize,
                               int maskSize, int anchor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiSumWindowColumn_16s32f_C3R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize, anchor);
    case DT_REFR:
        return _refr_fwiSumWindowColumn_16s32f_C3R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize, anchor);
    default:
        assert(false);
        return _refr_fwiSumWindowColumn_16s32f_C3R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize, anchor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiXor_16u_C3R( const Fw16u *pSrc1, int src1Step, const Fw16u *pSrc2,   int src2Step, Fw16u *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiXor_16u_C3R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiXor_16u_C3R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiXor_16u_C3R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiXor_16u_C3R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiFilterRobertsDown_16s_C1R( const Fw16s * pSrc, int srcStep, Fw16s * pDst, int dstStep, FwiSize dstRoiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilterRobertsDown_16s_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize);
    case DT_REFR:
        return _refr_fwiFilterRobertsDown_16s_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize);
    default:
        assert(false);
        return _refr_fwiFilterRobertsDown_16s_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiCopy_32s_C4P4R( const Fw32s *pSrc, int srcStep, Fw32s * const pDst[4], int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiCopy_32s_C4P4R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiCopy_32s_C4P4R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiCopy_32s_C4P4R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiCopy_32s_C4P4R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiMulC_32sc_C1IRSfs(       Fw32sc value,    Fw32sc *pSrcDst, int srcDstStep, FwiSize roiSize, int scaleFactor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiMulC_32sc_C1IRSfs(value, pSrcDst, srcDstStep, roiSize, scaleFactor);
    case DT_SSE2:
        return _sse2_fwiMulC_32sc_C1IRSfs(value, pSrcDst, srcDstStep, roiSize, scaleFactor);
    case DT_REFR:
        return _refr_fwiMulC_32sc_C1IRSfs(value, pSrcDst, srcDstStep, roiSize, scaleFactor);
    default:
        assert(false);
        return _refr_fwiMulC_32sc_C1IRSfs(value, pSrcDst, srcDstStep, roiSize, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiCopy_8u_C4CR( const Fw8u *pSrc, int srcStep, Fw8u *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiCopy_8u_C4CR(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiCopy_8u_C4CR(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiCopy_8u_C4CR(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiCopy_8u_C4CR(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiOr_32s_C3R( const Fw32s *pSrc1, int src1Step, const Fw32s *pSrc2,   int src2Step, Fw32s *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiOr_32s_C3R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiOr_32s_C3R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiOr_32s_C3R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiOr_32s_C3R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiCopy_8u_AC4MR( const Fw8u *pSrc, int srcStep, Fw8u *pDst, int dstStep, FwiSize roiSize, const Fw8u *pMask, int maskStep )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiCopy_8u_AC4MR(pSrc, srcStep, pDst, dstStep, roiSize, pMask, maskStep);
    case DT_SSE2:
        return _sse2_fwiCopy_8u_AC4MR(pSrc, srcStep, pDst, dstStep, roiSize, pMask, maskStep);
    case DT_REFR:
        return _refr_fwiCopy_8u_AC4MR(pSrc, srcStep, pDst, dstStep, roiSize, pMask, maskStep);
    default:
        assert(false);
        return _refr_fwiCopy_8u_AC4MR(pSrc, srcStep, pDst, dstStep, roiSize, pMask, maskStep);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiRotateCenter_8u_C1R( const Fw8u* pSrc,FwiSize srcSize, int srcStep, FwiRect srcRoi, Fw8u* pDst, int dstStep, FwiRect dstRoi, double angle, double xCenter, double yCenter, int interpolation )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiRotateCenter_8u_C1R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, angle, xCenter, yCenter, interpolation);
    case DT_REFR:
        return _refr_fwiRotateCenter_8u_C1R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, angle, xCenter, yCenter, interpolation);
    default:
        assert(false);
        return _refr_fwiRotateCenter_8u_C1R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, angle, xCenter, yCenter, interpolation);
    }
}

OREFR OSSE2         FwStatus fwiYUV420ToRGB_8u_P3C3R(const A8U* const pSrc[3], int srcStep[3], A8U* pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiYUV420ToRGB_8u_P3C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiYUV420ToRGB_8u_P3C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiYUV420ToRGB_8u_P3C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiFilterBox_8u_C4IR( Fw8u * pSrcDst, int srcDstStep,
                               FwiSize dstRoiSize, FwiSize maskSize, FwiPoint anchor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilterBox_8u_C4IR(pSrcDst, srcDstStep, dstRoiSize, maskSize, anchor);
    case DT_REFR:
        return _refr_fwiFilterBox_8u_C4IR(pSrcDst, srcDstStep, dstRoiSize, maskSize, anchor);
    default:
        assert(false);
        return _refr_fwiFilterBox_8u_C4IR(pSrcDst, srcDstStep, dstRoiSize, maskSize, anchor);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiFilterBox_8u_C4R( const Fw8u * pSrc, int srcStep,
                               Fw8u * pDst, int dstStep, FwiSize dstRoiSize,
                               FwiSize maskSize, FwiPoint anchor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilterBox_8u_C4R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize, anchor);
    case DT_REFR:
        return _refr_fwiFilterBox_8u_C4R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize, anchor);
    default:
        assert(false);
        return _refr_fwiFilterBox_8u_C4R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize, anchor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiSub_32sc_C1RSfs( const Fw32sc *pSrc1, int src1Step, const Fw32sc *pSrc2,   int src2Step, Fw32sc *pDst, int dstStep, FwiSize roiSize, int scaleFactor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiSub_32sc_C1RSfs(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, scaleFactor);
    case DT_SSE2:
        return _sse2_fwiSub_32sc_C1RSfs(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, scaleFactor);
    case DT_REFR:
        return _refr_fwiSub_32sc_C1RSfs(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, scaleFactor);
    default:
        assert(false);
        return _refr_fwiSub_32sc_C1RSfs(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, scaleFactor);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiMirror_32s_C4IR(Fw32s *pSrcDst, int srcDstStep, FwiSize roiSize, FwiAxis flip)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiMirror_32s_C4IR(pSrcDst, srcDstStep, roiSize, flip);
    case DT_REFR:
        return _refr_fwiMirror_32s_C4IR(pSrcDst, srcDstStep, roiSize, flip);
    default:
        assert(false);
        return _refr_fwiMirror_32s_C4IR(pSrcDst, srcDstStep, roiSize, flip);
    }
}

OREFR OSSE2 FwStatus STDCALL fwiWarpPerspectiveBack_8u_C3R( const Fw8u* pSrc, FwiSize srcSize, int srcStep,
								FwiRect srcRoi, Fw8u* pDst, int dstStep, FwiRect dstRoi,
								const double coeffs[3][3], int interpolation )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiWarpPerspectiveBack_8u_C3R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, coeffs, interpolation);
    case DT_REFR:
        return _refr_fwiWarpPerspectiveBack_8u_C3R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, coeffs, interpolation);
    default:
        assert(false);
        return _refr_fwiWarpPerspectiveBack_8u_C3R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, coeffs, interpolation);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiDivC_32fc_C1R( const Fw32fc *pSrc, int srcStep,       Fw32fc value,    Fw32fc *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiDivC_32fc_C1R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiDivC_32fc_C1R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiDivC_32fc_C1R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiDivC_32fc_C1R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    }
}

OREFR               FwStatus fwiYCbCr422ToBGR565_8u16u_C2C3R(const A8U* pSrc, int srcStep, A16U* pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiYCbCr422ToBGR565_8u16u_C2C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiYCbCr422ToBGR565_8u16u_C2C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2         FwStatus fwiYUV420ToRGB_8u_P3C3(const A8U* const pSrc[3], A8U* pDst, FwiSize imgSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiYUV420ToRGB_8u_P3C3(pSrc, pDst, imgSize);
    case DT_REFR:
        return _refr_fwiYUV420ToRGB_8u_P3C3(pSrc, pDst, imgSize);
    default:
        assert(false);
        return _refr_fwiYUV420ToRGB_8u_P3C3(pSrc, pDst, imgSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiDiv_16sc_C3RSfs( const Fw16sc *pSrc1, int src1Step, const Fw16sc *pSrc2,   int src2Step, Fw16sc *pDst, int dstStep, FwiSize roiSize, int scaleFactor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiDiv_16sc_C3RSfs(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, scaleFactor);
    case DT_SSE2:
        return _sse2_fwiDiv_16sc_C3RSfs(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, scaleFactor);
    case DT_REFR:
        return _refr_fwiDiv_16sc_C3RSfs(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, scaleFactor);
    default:
        assert(false);
        return _refr_fwiDiv_16sc_C3RSfs(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, scaleFactor);
    }
}

OREFR OSSE2 FwStatus STDCALL fwiResizeCenter_32f_P4R( const Fw32f* const pSrc[4], FwiSize srcSize, int srcStep, FwiRect srcRoi,
								   Fw32f* const pDst[4], int dstStep, FwiSize dstRoiSize,
								   double xFactor, double yFactor, double xCenter, double yCenter, int interpolation )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiResizeCenter_32f_P4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoiSize, xFactor, yFactor, xCenter, yCenter, interpolation);
    case DT_REFR:
        return _refr_fwiResizeCenter_32f_P4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoiSize, xFactor, yFactor, xCenter, yCenter, interpolation);
    default:
        assert(false);
        return _refr_fwiResizeCenter_32f_P4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoiSize, xFactor, yFactor, xCenter, yCenter, interpolation);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiSqrt_8u_C3IRSfs(       Fw8u *pSrcDst, int srcDstStep, FwiSize roiSize, int scaleFactor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiSqrt_8u_C3IRSfs(pSrcDst, srcDstStep, roiSize, scaleFactor);
    case DT_SSE2:
        return _sse2_fwiSqrt_8u_C3IRSfs(pSrcDst, srcDstStep, roiSize, scaleFactor);
    case DT_REFR:
        return _refr_fwiSqrt_8u_C3IRSfs(pSrcDst, srcDstStep, roiSize, scaleFactor);
    default:
        assert(false);
        return _refr_fwiSqrt_8u_C3IRSfs(pSrcDst, srcDstStep, roiSize, scaleFactor);
    }
}

OREFR OSSE2 FwStatus STDCALL fwiWarpAffineQuad_8u_P3R( const Fw8u* const pSrc[3], FwiSize srcSize, int srcStep, FwiRect srcRoi,
							        const double srcQuad[4][2], Fw8u* const pDst[3], int dstStep, FwiRect dstRoi,
									const double dstQuad[4][2], int interpolation )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiWarpAffineQuad_8u_P3R(pSrc, srcSize, srcStep, srcRoi, srcQuad, pDst, dstStep, dstRoi, dstQuad, interpolation);
    case DT_REFR:
        return _refr_fwiWarpAffineQuad_8u_P3R(pSrc, srcSize, srcStep, srcRoi, srcQuad, pDst, dstStep, dstRoi, dstQuad, interpolation);
    default:
        assert(false);
        return _refr_fwiWarpAffineQuad_8u_P3R(pSrc, srcSize, srcStep, srcRoi, srcQuad, pDst, dstStep, dstRoi, dstQuad, interpolation);
    }
}


OREFR OSSE2         FwStatus fwiYUV420ToBGR_8u_P3C3R(const A8U* const pSrc[3], int srcStep[3], A8U* pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiYUV420ToBGR_8u_P3C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiYUV420ToBGR_8u_P3C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiYUV420ToBGR_8u_P3C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiOrC_8u_C4IR( const Fw8u value[4], Fw8u *pSrcDst, int srcDstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiOrC_8u_C4IR(value, pSrcDst, srcDstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiOrC_8u_C4IR(value, pSrcDst, srcDstStep, roiSize);
    case DT_REFR:
        return _refr_fwiOrC_8u_C4IR(value, pSrcDst, srcDstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiOrC_8u_C4IR(value, pSrcDst, srcDstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiDivC_32fc_AC4IR( const Fw32fc value[3], Fw32fc *pSrcDst, int srcDstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiDivC_32fc_AC4IR(value, pSrcDst, srcDstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiDivC_32fc_AC4IR(value, pSrcDst, srcDstStep, roiSize);
    case DT_REFR:
        return _refr_fwiDivC_32fc_AC4IR(value, pSrcDst, srcDstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiDivC_32fc_AC4IR(value, pSrcDst, srcDstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiNot_8u_AC4IR( Fw8u *pSrcDst, int srcDstStep, FwiSize roiSize)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiNot_8u_AC4IR(pSrcDst, srcDstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiNot_8u_AC4IR(pSrcDst, srcDstStep, roiSize);
    case DT_REFR:
        return _refr_fwiNot_8u_AC4IR(pSrcDst, srcDstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiNot_8u_AC4IR(pSrcDst, srcDstStep, roiSize);
    }
}


OREFR       FwStatus STDCALL fwiGetPerspectiveTransform(FwiRect srcRoi, const double quad[4][2],double coeffs[3][3])
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiGetPerspectiveTransform(srcRoi, quad, coeffs);
    default:
        assert(false);
        return _refr_fwiGetPerspectiveTransform(srcRoi, quad, coeffs);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiCopy_32f_C1R( const Fw32f *pSrc, int srcStep, Fw32f *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiCopy_32f_C1R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiCopy_32f_C1R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiCopy_32f_C1R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiCopy_32f_C1R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiMul_8u_C3RSfs( const Fw8u   *pSrc1, int src1Step, const Fw8u   *pSrc2,   int src2Step, Fw8u *pDst, int dstStep, FwiSize roiSize, int scaleFactor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiMul_8u_C3RSfs(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, scaleFactor);
    case DT_SSE2:
        return _sse2_fwiMul_8u_C3RSfs(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, scaleFactor);
    case DT_REFR:
        return _refr_fwiMul_8u_C3RSfs(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, scaleFactor);
    default:
        assert(false);
        return _refr_fwiMul_8u_C3RSfs(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiSub_16s_C4IRSfs( const Fw16s  *pSrc,  int srcStep,        Fw16s  *pSrcDst, int srcDstStep, FwiSize roiSize, int scaleFactor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiSub_16s_C4IRSfs(pSrc, srcStep, pSrcDst, srcDstStep, roiSize, scaleFactor);
    case DT_SSE2:
        return _sse2_fwiSub_16s_C4IRSfs(pSrc, srcStep, pSrcDst, srcDstStep, roiSize, scaleFactor);
    case DT_REFR:
        return _refr_fwiSub_16s_C4IRSfs(pSrc, srcStep, pSrcDst, srcDstStep, roiSize, scaleFactor);
    default:
        assert(false);
        return _refr_fwiSub_16s_C4IRSfs(pSrc, srcStep, pSrcDst, srcDstStep, roiSize, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiRShiftC_8s_AC4IR( const Fw32u value[3], Fw8s *pSrcDst, int srcDstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiRShiftC_8s_AC4IR(value, pSrcDst, srcDstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiRShiftC_8s_AC4IR(value, pSrcDst, srcDstStep, roiSize);
    case DT_REFR:
        return _refr_fwiRShiftC_8s_AC4IR(value, pSrcDst, srcDstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiRShiftC_8s_AC4IR(value, pSrcDst, srcDstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiRShiftC_8s_C1R( const Fw8s   *pSrc, int srcStep,       Fw32u value,    Fw8s *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiRShiftC_8s_C1R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiRShiftC_8s_C1R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiRShiftC_8s_C1R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiRShiftC_8s_C1R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiSqr_8u_C4IRSfs(       Fw8u  *pSrcDst, int srcDstStep, FwiSize roiSize, int scaleFactor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiSqr_8u_C4IRSfs(pSrcDst, srcDstStep, roiSize, scaleFactor);
    case DT_SSE2:
        return _sse2_fwiSqr_8u_C4IRSfs(pSrcDst, srcDstStep, roiSize, scaleFactor);
    case DT_REFR:
        return _refr_fwiSqr_8u_C4IRSfs(pSrcDst, srcDstStep, roiSize, scaleFactor);
    default:
        assert(false);
        return _refr_fwiSqr_8u_C4IRSfs(pSrcDst, srcDstStep, roiSize, scaleFactor);
    }
}


OREFR OSSE2         FwStatus fwiYUV422ToRGB_8u_C2C3R( const A8U* pSrc, int srcStep, A8U* pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiYUV422ToRGB_8u_C2C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiYUV422ToRGB_8u_C2C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiYUV422ToRGB_8u_C2C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}


OREFR       FwStatus STDCALL fwiGetBilinearBound(FwiRect srcRoi, double bound[2][2], const double coeffs[2][4])
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiGetBilinearBound(srcRoi, bound, coeffs);
    default:
        assert(false);
        return _refr_fwiGetBilinearBound(srcRoi, bound, coeffs);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiSubC_8u_AC4RSfs( const Fw8u *pSrc, int srcStep, const Fw8u value[3], Fw8u *pDst, int dstStep, FwiSize roiSize, int scaleFactor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiSubC_8u_AC4RSfs(pSrc, srcStep, value, pDst, dstStep, roiSize, scaleFactor);
    case DT_SSE2:
        return _sse2_fwiSubC_8u_AC4RSfs(pSrc, srcStep, value, pDst, dstStep, roiSize, scaleFactor);
    case DT_REFR:
        return _refr_fwiSubC_8u_AC4RSfs(pSrc, srcStep, value, pDst, dstStep, roiSize, scaleFactor);
    default:
        assert(false);
        return _refr_fwiSubC_8u_AC4RSfs(pSrc, srcStep, value, pDst, dstStep, roiSize, scaleFactor);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiFilterMin_8u_C3R( const Fw8u * pSrc, int srcStep,
                               Fw8u * pDst, int dstStep, FwiSize dstRoiSize,
                               FwiSize maskSize, FwiPoint anchor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilterMin_8u_C3R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize, anchor);
    case DT_REFR:
        return _refr_fwiFilterMin_8u_C3R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize, anchor);
    default:
        assert(false);
        return _refr_fwiFilterMin_8u_C3R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize, anchor);
    }
}

OREFR OSSE2 FwStatus STDCALL fwiResizeSqrPixel_8u_C3R(const Fw8u* pSrc, FwiSize srcSize, int srcStep, FwiRect srcRoi,
			Fw8u* pDst, int dstStep, FwiRect dstRoi, double xFactor, double yFactor,
			double xShift, double yShift, int interpolation, Fw8u* pBuffer)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiResizeSqrPixel_8u_C3R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, xFactor, yFactor, xShift, yShift, interpolation, pBuffer);
    case DT_REFR:
        return _refr_fwiResizeSqrPixel_8u_C3R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, xFactor, yFactor, xShift, yShift, interpolation, pBuffer);
    default:
        assert(false);
        return _refr_fwiResizeSqrPixel_8u_C3R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, xFactor, yFactor, xShift, yShift, interpolation, pBuffer);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiAdd_32sc_C1IRSfs( const Fw32sc *pSrc,  int srcStep,        Fw32sc *pSrcDst, int srcDstStep, FwiSize roiSize, int scaleFactor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiAdd_32sc_C1IRSfs(pSrc, srcStep, pSrcDst, srcDstStep, roiSize, scaleFactor);
    case DT_SSE2:
        return _sse2_fwiAdd_32sc_C1IRSfs(pSrc, srcStep, pSrcDst, srcDstStep, roiSize, scaleFactor);
    case DT_REFR:
        return _refr_fwiAdd_32sc_C1IRSfs(pSrc, srcStep, pSrcDst, srcDstStep, roiSize, scaleFactor);
    default:
        assert(false);
        return _refr_fwiAdd_32sc_C1IRSfs(pSrc, srcStep, pSrcDst, srcDstStep, roiSize, scaleFactor);
    }
}

OREFR OSSE2 FwStatus STDCALL fwiWarpPerspectiveQuad_8u_P4R( const Fw8u* const pSrc[4], FwiSize srcSize, int srcStep, FwiRect srcRoi,
							        const double srcQuad[4][2], Fw8u* const pDst[4], int dstStep, FwiRect dstRoi,
									const double dstQuad[4][2], int interpolation )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiWarpPerspectiveQuad_8u_P4R(pSrc, srcSize, srcStep, srcRoi, srcQuad, pDst, dstStep, dstRoi, dstQuad, interpolation);
    case DT_REFR:
        return _refr_fwiWarpPerspectiveQuad_8u_P4R(pSrc, srcSize, srcStep, srcRoi, srcQuad, pDst, dstStep, dstRoi, dstQuad, interpolation);
    default:
        assert(false);
        return _refr_fwiWarpPerspectiveQuad_8u_P4R(pSrc, srcSize, srcStep, srcRoi, srcQuad, pDst, dstStep, dstRoi, dstQuad, interpolation);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiRShiftC_16u_AC4IR( const Fw32u value[3], Fw16u *pSrcDst, int srcDstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiRShiftC_16u_AC4IR(value, pSrcDst, srcDstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiRShiftC_16u_AC4IR(value, pSrcDst, srcDstStep, roiSize);
    case DT_REFR:
        return _refr_fwiRShiftC_16u_AC4IR(value, pSrcDst, srcDstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiRShiftC_16u_AC4IR(value, pSrcDst, srcDstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiThreshold_GT_8u_C1R( const Fw8u *pSrc, int srcStep, Fw8u *pDst, int dstStep, FwiSize roiSize, Fw8u threshold)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiThreshold_GT_8u_C1R(pSrc, srcStep, pDst, dstStep, roiSize, threshold);
    case DT_SSE2:
        return _sse2_fwiThreshold_GT_8u_C1R(pSrc, srcStep, pDst, dstStep, roiSize, threshold);
    case DT_REFR:
        return _refr_fwiThreshold_GT_8u_C1R(pSrc, srcStep, pDst, dstStep, roiSize, threshold);
    default:
        assert(false);
        return _refr_fwiThreshold_GT_8u_C1R(pSrc, srcStep, pDst, dstStep, roiSize, threshold);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiXor_32s_C3IR( const Fw32s *pSrc,  int srcStep,        Fw32s *pSrcDst, int srcDstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiXor_32s_C3IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiXor_32s_C3IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    case DT_REFR:
        return _refr_fwiXor_32s_C3IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiXor_32s_C3IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiFilterScharrVert_8s16s_C1R( const Fw8s * pSrc, int srcStep, Fw16s * pDst, int dstStep, FwiSize dstRoiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilterScharrVert_8s16s_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize);
    case DT_REFR:
        return _refr_fwiFilterScharrVert_8s16s_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize);
    default:
        assert(false);
        return _refr_fwiFilterScharrVert_8s16s_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize);
    }
}

OREFR OSSE2         FwStatus fwiMean_8u_C4R(const Fw8u* pSrc, int srcStep,FwiSize roiSize, Fw64f mean[4])
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiMean_8u_C4R(pSrc, srcStep, roiSize, mean);
    case DT_REFR:
        return _refr_fwiMean_8u_C4R(pSrc, srcStep, roiSize, mean);
    default:
        assert(false);
        return _refr_fwiMean_8u_C4R(pSrc, srcStep, roiSize, mean);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiAbs_32f_AC4IR( Fw32f *pSrcDst, int srcDstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiAbs_32f_AC4IR(pSrcDst, srcDstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiAbs_32f_AC4IR(pSrcDst, srcDstStep, roiSize);
    case DT_REFR:
        return _refr_fwiAbs_32f_AC4IR(pSrcDst, srcDstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiAbs_32f_AC4IR(pSrcDst, srcDstStep, roiSize);
    }
}

OREFR             FwStatus STDCALL fwiScale_8u32s_C4R( const Fw8u * pSrc, int srcStep, Fw32s * pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiScale_8u32s_C4R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiScale_8u32s_C4R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 FwStatus STDCALL fwiWarpAffineBack_16u_C4R( const Fw16u* pSrc, FwiSize srcSize, int srcStep,
								FwiRect srcRoi, Fw16u* pDst, int dstStep, FwiRect dstRoi,
								const double coeffs[2][3], int interpolation )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiWarpAffineBack_16u_C4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, coeffs, interpolation);
    case DT_REFR:
        return _refr_fwiWarpAffineBack_16u_C4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, coeffs, interpolation);
    default:
        assert(false);
        return _refr_fwiWarpAffineBack_16u_C4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, coeffs, interpolation);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiXorC_16u_C4R( const Fw16u  *pSrc, int srcStep, const Fw16u value[4], Fw16u *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiXorC_16u_C4R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiXorC_16u_C4R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiXorC_16u_C4R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiXorC_16u_C4R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiDiv_32fc_AC4IR( const Fw32fc *pSrc,  int srcStep,        Fw32fc *pSrcDst, int srcDstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiDiv_32fc_AC4IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiDiv_32fc_AC4IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    case DT_REFR:
        return _refr_fwiDiv_32fc_AC4IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiDiv_32fc_AC4IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    }
}

OREFR OSSE2 FwStatus STDCALL fwiResizeShift_16u_P4R( const Fw16u* const pSrc[4], FwiSize srcSize, int srcStep, FwiRect srcRoi,
								  Fw16u* const pDst[4], int dstStep, FwiSize dstRoiSize,
								  double xFr, double yFr, double xShift, double yShift, int interpolation )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiResizeShift_16u_P4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoiSize, xFr, yFr, xShift, yShift, interpolation);
    case DT_REFR:
        return _refr_fwiResizeShift_16u_P4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoiSize, xFr, yFr, xShift, yShift, interpolation);
    default:
        assert(false);
        return _refr_fwiResizeShift_16u_P4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoiSize, xFr, yFr, xShift, yShift, interpolation);
    }
}

OREFR             FwStatus STDCALL fwiScale_16s8u_C3R( const Fw16s * pSrc, int srcStep, Fw8u * pDst, int dstStep, FwiSize roiSize, FwHintAlgorithm hint )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiScale_16s8u_C3R(pSrc, srcStep, pDst, dstStep, roiSize, hint);
    default:
        assert(false);
        return _refr_fwiScale_16s8u_C3R(pSrc, srcStep, pDst, dstStep, roiSize, hint);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiAbs_16s_C3R( const Fw16s *pSrc, int srcStep, Fw16s *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiAbs_16s_C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiAbs_16s_C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiAbs_16s_C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiAbs_16s_C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR             FwStatus STDCALL fwiCopy_32s_C3AC4R( const Fw32s *pSrc, int srcStep, Fw32s *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiCopy_32s_C3AC4R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiCopy_32s_C3AC4R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR               FwStatus fwiHLSToRGB_16s_AC4R( const Fw16s* pSrc, int srcStep, Fw16s* pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiHLSToRGB_16s_AC4R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiHLSToRGB_16s_AC4R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiFilterBox_16s_C1R( const Fw16s * pSrc, int srcStep,
                               Fw16s * pDst, int dstStep, FwiSize dstRoiSize,
                               FwiSize maskSize, FwiPoint anchor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilterBox_16s_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize, anchor);
    case DT_REFR:
        return _refr_fwiFilterBox_16s_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize, anchor);
    default:
        assert(false);
        return _refr_fwiFilterBox_16s_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize, anchor);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiFilter32f_8u_C3R( const Fw8u * pSrc, int srcStep,
                                Fw8u * pDst, int dstStep, FwiSize dstRoiSize,
                                const Fw32f * pKernel, FwiSize kernelSize,
                                FwiPoint anchor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilter32f_8u_C3R(pSrc, srcStep, pDst, dstStep, dstRoiSize, pKernel, kernelSize, anchor);
    case DT_REFR:
        return _refr_fwiFilter32f_8u_C3R(pSrc, srcStep, pDst, dstStep, dstRoiSize, pKernel, kernelSize, anchor);
    default:
        assert(false);
        return _refr_fwiFilter32f_8u_C3R(pSrc, srcStep, pDst, dstStep, dstRoiSize, pKernel, kernelSize, anchor);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiFilterRow_32f_C4R( const Fw32f * pSrc, int srcStep,
                              Fw32f * pDst, int dstStep, FwiSize dstRoiSize,
                              const Fw32f * pKernel, int kernelSize,
                              int xAnchor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilterRow_32f_C4R(pSrc, srcStep, pDst, dstStep, dstRoiSize, pKernel, kernelSize, xAnchor);
    case DT_REFR:
        return _refr_fwiFilterRow_32f_C4R(pSrc, srcStep, pDst, dstStep, dstRoiSize, pKernel, kernelSize, xAnchor);
    default:
        assert(false);
        return _refr_fwiFilterRow_32f_C4R(pSrc, srcStep, pDst, dstStep, dstRoiSize, pKernel, kernelSize, xAnchor);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiFilterPrewittHoriz_32f_C3R( const Fw32f * pSrc, int srcStep, Fw32f * pDst, int dstStep, FwiSize dstRoiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilterPrewittHoriz_32f_C3R(pSrc, srcStep, pDst, dstStep, dstRoiSize);
    case DT_REFR:
        return _refr_fwiFilterPrewittHoriz_32f_C3R(pSrc, srcStep, pDst, dstStep, dstRoiSize);
    default:
        assert(false);
        return _refr_fwiFilterPrewittHoriz_32f_C3R(pSrc, srcStep, pDst, dstStep, dstRoiSize);
    }
}

OREFR OSSE2         FwStatus fwiRGBToYCbCr420_8u_C3P3R(const A8U* pSrc, int srcStep, A8U* const pDst[3], int dstStep[3], FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiRGBToYCbCr420_8u_C3P3R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiRGBToYCbCr420_8u_C3P3R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiRGBToYCbCr420_8u_C3P3R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiAdd_32f_AC4R( const Fw32f  *pSrc1, int src1Step, const Fw32f  *pSrc2,   int src2Step, Fw32f *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiAdd_32f_AC4R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiAdd_32f_AC4R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiAdd_32f_AC4R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiAdd_32f_AC4R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiAnd_8u_C1R( const Fw8u *pSrc1, int src1Step, const Fw8u *pSrc2,   int src2Step, Fw8u *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiAnd_8u_C1R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiAnd_8u_C1R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiAnd_8u_C1R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiAnd_8u_C1R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    }
}


OREFR               FwStatus fwiHLSToRGB_8u_C3R( const Fw8u *pSrc, int srcStep, Fw8u *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiHLSToRGB_8u_C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiHLSToRGB_8u_C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR       FwStatus STDCALL fwiWarpBilinearQuad_8u_AC4R(const Fw8u* pSrc, FwiSize srcSize, int srcStep, FwiRect srcRoi,
							        const double srcQuad[4][2], Fw8u* pDst, int dstStep, FwiRect dstRoi,
									const double dstQuad[4][2], int interpolation)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiWarpBilinearQuad_8u_AC4R(pSrc, srcSize, srcStep, srcRoi, srcQuad, pDst, dstStep, dstRoi, dstQuad, interpolation);
    default:
        assert(false);
        return _refr_fwiWarpBilinearQuad_8u_AC4R(pSrc, srcSize, srcStep, srcRoi, srcQuad, pDst, dstStep, dstRoi, dstQuad, interpolation);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiCopy_8u_C4C1R( const Fw8u *pSrc, int srcStep, Fw8u *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiCopy_8u_C4C1R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiCopy_8u_C4C1R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiCopy_8u_C4C1R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiCopy_8u_C4C1R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiAbs_32f_C1R( const Fw32f *pSrc, int srcStep, Fw32f *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiAbs_32f_C1R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiAbs_32f_C1R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiAbs_32f_C1R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiAbs_32f_C1R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiThreshold_GTVal_32f_AC4IR( Fw32f *pSrcDst, int srcDstStep, FwiSize roiSize, const Fw32f threshold[3], const Fw32f value[3])
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiThreshold_GTVal_32f_AC4IR(pSrcDst, srcDstStep, roiSize, threshold, value);
    case DT_SSE2:
        return _sse2_fwiThreshold_GTVal_32f_AC4IR(pSrcDst, srcDstStep, roiSize, threshold, value);
    case DT_REFR:
        return _refr_fwiThreshold_GTVal_32f_AC4IR(pSrcDst, srcDstStep, roiSize, threshold, value);
    default:
        assert(false);
        return _refr_fwiThreshold_GTVal_32f_AC4IR(pSrcDst, srcDstStep, roiSize, threshold, value);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiDiv_16sc_C1RSfs( const Fw16sc *pSrc1, int src1Step, const Fw16sc *pSrc2,   int src2Step, Fw16sc *pDst, int dstStep, FwiSize roiSize, int scaleFactor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiDiv_16sc_C1RSfs(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, scaleFactor);
    case DT_SSE2:
        return _sse2_fwiDiv_16sc_C1RSfs(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, scaleFactor);
    case DT_REFR:
        return _refr_fwiDiv_16sc_C1RSfs(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, scaleFactor);
    default:
        assert(false);
        return _refr_fwiDiv_16sc_C1RSfs(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, scaleFactor);
    }
}

OREFR OSSE2         FwStatus fwiSum_16s_C1R(const Fw16s* pSrc, int srcStep,FwiSize roiSize, Fw64f* pSum)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiSum_16s_C1R(pSrc, srcStep, roiSize, pSum);
    case DT_REFR:
        return _refr_fwiSum_16s_C1R(pSrc, srcStep, roiSize, pSum);
    default:
        assert(false);
        return _refr_fwiSum_16s_C1R(pSrc, srcStep, roiSize, pSum);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiFilterMedianVert_8u_C4R( const Fw8u * pSrc, int srcStep,
                                               Fw8u * pDst, int dstStep, FwiSize dstRoiSize,
                                               FwiMaskSize maskSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilterMedianVert_8u_C4R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize);
    case DT_REFR:
        return _refr_fwiFilterMedianVert_8u_C4R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize);
    default:
        assert(false);
        return _refr_fwiFilterMedianVert_8u_C4R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiMulCScale_16u_AC4IR( const Fw16u value[3], Fw16u *pSrcDst, int srcDstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiMulCScale_16u_AC4IR(value, pSrcDst, srcDstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiMulCScale_16u_AC4IR(value, pSrcDst, srcDstStep, roiSize);
    case DT_REFR:
        return _refr_fwiMulCScale_16u_AC4IR(value, pSrcDst, srcDstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiMulCScale_16u_AC4IR(value, pSrcDst, srcDstStep, roiSize);
    }
}

OREFR OSSE2 FwStatus STDCALL fwiResize_8u_P4R( const Fw8u* const pSrc[4], FwiSize srcSize, int srcStep, FwiRect srcRoi,
							 Fw8u* const pDst[4], int dstStep, FwiSize dstRoiSize,
							 double xFactor, double yFactor, int interpolation )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiResize_8u_P4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoiSize, xFactor, yFactor, interpolation);
    case DT_REFR:
        return _refr_fwiResize_8u_P4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoiSize, xFactor, yFactor, interpolation);
    default:
        assert(false);
        return _refr_fwiResize_8u_P4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoiSize, xFactor, yFactor, interpolation);
    }
}

OREFR OSSE2 OF10H   FwStatus fwiYCbCrToRGB_8u_P3C3R( const Fw8u* const pSrc[3], int srcStep, Fw8u *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiYCbCrToRGB_8u_P3C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiYCbCrToRGB_8u_P3C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiYCbCrToRGB_8u_P3C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiYCbCrToRGB_8u_P3C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiFilterPrewittVert_32f_C4R( const Fw32f * pSrc, int srcStep, Fw32f * pDst, int dstStep, FwiSize dstRoiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilterPrewittVert_32f_C4R(pSrc, srcStep, pDst, dstStep, dstRoiSize);
    case DT_REFR:
        return _refr_fwiFilterPrewittVert_32f_C4R(pSrc, srcStep, pDst, dstStep, dstRoiSize);
    default:
        assert(false);
        return _refr_fwiFilterPrewittVert_32f_C4R(pSrc, srcStep, pDst, dstStep, dstRoiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiSwapChannels_32f_AC4R(const Fw32f *pSrc,int srcStep, Fw32f *pDst, int dstStep, FwiSize roiSize,const int dstOrder[3])
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiSwapChannels_32f_AC4R(pSrc, srcStep, pDst, dstStep, roiSize, dstOrder);
    case DT_SSE2:
        return _sse2_fwiSwapChannels_32f_AC4R(pSrc, srcStep, pDst, dstStep, roiSize, dstOrder);
    case DT_REFR:
        return _refr_fwiSwapChannels_32f_AC4R(pSrc, srcStep, pDst, dstStep, roiSize, dstOrder);
    default:
        assert(false);
        return _refr_fwiSwapChannels_32f_AC4R(pSrc, srcStep, pDst, dstStep, roiSize, dstOrder);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiMulScale_16u_C1IR(  const Fw16u *pSrc,  int srcStep,        Fw16u *pSrcDst, int srcDstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiMulScale_16u_C1IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiMulScale_16u_C1IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    case DT_REFR:
        return _refr_fwiMulScale_16u_C1IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiMulScale_16u_C1IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    }
}

OREFR OSSE2 FwStatus STDCALL fwiWarpPerspectiveBack_8u_P3R( const Fw8u* const pSrc[3], FwiSize srcSize, int srcStep,
								FwiRect srcRoi, Fw8u* const pDst[3], int dstStep, FwiRect dstRoi,
								const double coeffs[3][3], int interpolation )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiWarpPerspectiveBack_8u_P3R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, coeffs, interpolation);
    case DT_REFR:
        return _refr_fwiWarpPerspectiveBack_8u_P3R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, coeffs, interpolation);
    default:
        assert(false);
        return _refr_fwiWarpPerspectiveBack_8u_P3R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, coeffs, interpolation);
    }
}

OREFR             FwStatus STDCALL fwiConvert_8s32s_AC4R( const Fw8s *pSrc, int srcStep, Fw32s *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiConvert_8s32s_AC4R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiConvert_8s32s_AC4R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR       FwStatus STDCALL fwiWarpBilinearQuad_32f_C4R(const Fw32f* pSrc, FwiSize srcSize, int srcStep, FwiRect srcRoi,
							        const double srcQuad[4][2], Fw32f* pDst, int dstStep, FwiRect dstRoi,
									const double dstQuad[4][2], int interpolation)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiWarpBilinearQuad_32f_C4R(pSrc, srcSize, srcStep, srcRoi, srcQuad, pDst, dstStep, dstRoi, dstQuad, interpolation);
    default:
        assert(false);
        return _refr_fwiWarpBilinearQuad_32f_C4R(pSrc, srcSize, srcStep, srcRoi, srcQuad, pDst, dstStep, dstRoi, dstQuad, interpolation);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiRShiftC_8s_AC4R( const Fw8s   *pSrc, int srcStep, const Fw32u value[3], Fw8s *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiRShiftC_8s_AC4R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiRShiftC_8s_AC4R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiRShiftC_8s_AC4R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiRShiftC_8s_AC4R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiAddC_8u_C1RSfs( const Fw8u   *pSrc, int srcStep,       Fw8u value,    Fw8u *pDst, int dstStep, FwiSize roiSize, int scaleFactor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiAddC_8u_C1RSfs(pSrc, srcStep, value, pDst, dstStep, roiSize, scaleFactor);
    case DT_SSE2:
        return _sse2_fwiAddC_8u_C1RSfs(pSrc, srcStep, value, pDst, dstStep, roiSize, scaleFactor);
    case DT_REFR:
        return _refr_fwiAddC_8u_C1RSfs(pSrc, srcStep, value, pDst, dstStep, roiSize, scaleFactor);
    default:
        assert(false);
        return _refr_fwiAddC_8u_C1RSfs(pSrc, srcStep, value, pDst, dstStep, roiSize, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiMulC_8u_C3IRSfs( const Fw8u value[3], Fw8u *pSrcDst, int srcDstStep, FwiSize roiSize, int scaleFactor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiMulC_8u_C3IRSfs(value, pSrcDst, srcDstStep, roiSize, scaleFactor);
    case DT_SSE2:
        return _sse2_fwiMulC_8u_C3IRSfs(value, pSrcDst, srcDstStep, roiSize, scaleFactor);
    case DT_REFR:
        return _refr_fwiMulC_8u_C3IRSfs(value, pSrcDst, srcDstStep, roiSize, scaleFactor);
    default:
        assert(false);
        return _refr_fwiMulC_8u_C3IRSfs(value, pSrcDst, srcDstStep, roiSize, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiConvert_8s32f_C4R( const Fw8s *pSrc, int srcStep, Fw32f *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiConvert_8s32f_C4R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiConvert_8s32f_C4R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiConvert_8s32f_C4R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiConvert_8s32f_C4R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiXor_8u_AC4R( const Fw8u *pSrc1, int src1Step, const Fw8u *pSrc2,   int src2Step, Fw8u *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiXor_8u_AC4R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiXor_8u_AC4R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiXor_8u_AC4R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiXor_8u_AC4R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiThreshold_GT_16s_C1R( const Fw16s *pSrc, int srcStep, Fw16s *pDst, int dstStep, FwiSize roiSize, Fw16s threshold)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiThreshold_GT_16s_C1R(pSrc, srcStep, pDst, dstStep, roiSize, threshold);
    case DT_SSE2:
        return _sse2_fwiThreshold_GT_16s_C1R(pSrc, srcStep, pDst, dstStep, roiSize, threshold);
    case DT_REFR:
        return _refr_fwiThreshold_GT_16s_C1R(pSrc, srcStep, pDst, dstStep, roiSize, threshold);
    default:
        assert(false);
        return _refr_fwiThreshold_GT_16s_C1R(pSrc, srcStep, pDst, dstStep, roiSize, threshold);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiMulC_32f_C1IR(       Fw32f value,    Fw32f *pSrcDst, int srcDstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiMulC_32f_C1IR(value, pSrcDst, srcDstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiMulC_32f_C1IR(value, pSrcDst, srcDstStep, roiSize);
    case DT_REFR:
        return _refr_fwiMulC_32f_C1IR(value, pSrcDst, srcDstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiMulC_32f_C1IR(value, pSrcDst, srcDstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiOrC_8u_C4R( const Fw8u   *pSrc, int srcStep, const Fw8u value[4], Fw8u *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiOrC_8u_C4R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiOrC_8u_C4R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiOrC_8u_C4R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiOrC_8u_C4R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiFilterHipass_32f_C1R( const Fw32f * pSrc, int srcStep, Fw32f * pDst, int dstStep, FwiSize dstRoiSize, FwiMaskSize maskSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilterHipass_32f_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize);
    case DT_REFR:
        return _refr_fwiFilterHipass_32f_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize);
    default:
        assert(false);
        return _refr_fwiFilterHipass_32f_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiAddC_32fc_C1R( const Fw32fc  *pSrc, int srcStep, Fw32fc value, Fw32fc *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiAddC_32fc_C1R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiAddC_32fc_C1R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiAddC_32fc_C1R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiAddC_32fc_C1R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiDivC_32sc_C1IRSfs(       Fw32sc value,    Fw32sc *pSrcDst, int srcDstStep, FwiSize roiSize, int scaleFactor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiDivC_32sc_C1IRSfs(value, pSrcDst, srcDstStep, roiSize, scaleFactor);
    case DT_SSE2:
        return _sse2_fwiDivC_32sc_C1IRSfs(value, pSrcDst, srcDstStep, roiSize, scaleFactor);
    case DT_REFR:
        return _refr_fwiDivC_32sc_C1IRSfs(value, pSrcDst, srcDstStep, roiSize, scaleFactor);
    default:
        assert(false);
        return _refr_fwiDivC_32sc_C1IRSfs(value, pSrcDst, srcDstStep, roiSize, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiCompareC_8u_C4R( const Fw8u *pSrc, int srcStep, const Fw8u value[4], Fw8u *pDst, int dstStep, FwiSize roiSize, FwCmpOp fwCmpOp )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiCompareC_8u_C4R(pSrc, srcStep, value, pDst, dstStep, roiSize, fwCmpOp);
    case DT_SSE2:
        return _sse2_fwiCompareC_8u_C4R(pSrc, srcStep, value, pDst, dstStep, roiSize, fwCmpOp);
    case DT_REFR:
        return _refr_fwiCompareC_8u_C4R(pSrc, srcStep, value, pDst, dstStep, roiSize, fwCmpOp);
    default:
        assert(false);
        return _refr_fwiCompareC_8u_C4R(pSrc, srcStep, value, pDst, dstStep, roiSize, fwCmpOp);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiSub_16sc_C1RSfs( const Fw16sc *pSrc1, int src1Step, const Fw16sc *pSrc2,   int src2Step, Fw16sc *pDst, int dstStep, FwiSize roiSize, int scaleFactor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiSub_16sc_C1RSfs(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, scaleFactor);
    case DT_SSE2:
        return _sse2_fwiSub_16sc_C1RSfs(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, scaleFactor);
    case DT_REFR:
        return _refr_fwiSub_16sc_C1RSfs(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, scaleFactor);
    default:
        assert(false);
        return _refr_fwiSub_16sc_C1RSfs(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, scaleFactor);
    }
}

OREFR OSSE2 OF10H   FwStatus fwiRGBToYCbCr_8u_P3R( const Fw8u * const pSrc[3], int srcStep, Fw8u* const pDst[3], int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiRGBToYCbCr_8u_P3R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiRGBToYCbCr_8u_P3R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiRGBToYCbCr_8u_P3R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiRGBToYCbCr_8u_P3R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 FwStatus STDCALL fwiResizeCenter_16u_P3R( const Fw16u* const pSrc[3], FwiSize srcSize, int srcStep, FwiRect srcRoi,
								   Fw16u* const pDst[3], int dstStep, FwiSize dstRoiSize,
								   double xFactor, double yFactor, double xCenter, double yCenter, int interpolation )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiResizeCenter_16u_P3R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoiSize, xFactor, yFactor, xCenter, yCenter, interpolation);
    case DT_REFR:
        return _refr_fwiResizeCenter_16u_P3R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoiSize, xFactor, yFactor, xCenter, yCenter, interpolation);
    default:
        assert(false);
        return _refr_fwiResizeCenter_16u_P3R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoiSize, xFactor, yFactor, xCenter, yCenter, interpolation);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiConvert_16s8u_C1R( const Fw16s *pSrc, int srcStep, Fw8u *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiConvert_16s8u_C1R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiConvert_16s8u_C1R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiConvert_16s8u_C1R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiConvert_16s8u_C1R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiSubC_16s_C3IRSfs( const Fw16s value[3], Fw16s *pSrcDst, int srcDstStep, FwiSize roiSize, int scaleFactor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiSubC_16s_C3IRSfs(value, pSrcDst, srcDstStep, roiSize, scaleFactor);
    case DT_SSE2:
        return _sse2_fwiSubC_16s_C3IRSfs(value, pSrcDst, srcDstStep, roiSize, scaleFactor);
    case DT_REFR:
        return _refr_fwiSubC_16s_C3IRSfs(value, pSrcDst, srcDstStep, roiSize, scaleFactor);
    default:
        assert(false);
        return _refr_fwiSubC_16s_C3IRSfs(value, pSrcDst, srcDstStep, roiSize, scaleFactor);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiFilterSobelVertSecond_8u16s_C1R( const Fw8u * pSrc, int srcStep, Fw16s * pDst, int dstStep, FwiSize dstRoiSize, FwiMaskSize mask )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilterSobelVertSecond_8u16s_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize, mask);
    case DT_REFR:
        return _refr_fwiFilterSobelVertSecond_8u16s_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize, mask);
    default:
        assert(false);
        return _refr_fwiFilterSobelVertSecond_8u16s_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize, mask);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiMulScale_16u_C4R(  const Fw16u *pSrc1, int src1Step, const Fw16u *pSrc2,   int src2Step, Fw16u *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiMulScale_16u_C4R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiMulScale_16u_C4R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiMulScale_16u_C4R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiMulScale_16u_C4R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    }
}


OREFR OSSE2         FwStatus fwiCbYCr422ToYCbCr420_8u_C2P3R( const Fw8u* pSrc, int srcStep, Fw8u* pDst[3], int dstStep[3], FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiCbYCr422ToYCbCr420_8u_C2P3R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiCbYCr422ToYCbCr420_8u_C2P3R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiCbYCr422ToYCbCr420_8u_C2P3R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}


OREFR       FwStatus STDCALL fwiGetBilinearQuad(FwiRect srcRoi, double quad[4][2], const double coeffs[2][4])
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiGetBilinearQuad(srcRoi, quad, coeffs);
    default:
        assert(false);
        return _refr_fwiGetBilinearQuad(srcRoi, quad, coeffs);
    }
}

OREFR       FwStatus STDCALL fwiWarpBilinear_8u_P4R(const Fw8u* const pSrc[4], FwiSize srcSize, int srcStep,
								FwiRect srcRoi, Fw8u* const pDst[4], int dstStep, FwiRect dstRoi,
								const double coeffs[2][4], int interpolation)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiWarpBilinear_8u_P4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, coeffs, interpolation);
    default:
        assert(false);
        return _refr_fwiWarpBilinear_8u_P4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, coeffs, interpolation);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiFilterSobelHoriz_32f_C4R( const Fw32f * pSrc, int srcStep, Fw32f * pDst, int dstStep, FwiSize dstRoiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilterSobelHoriz_32f_C4R(pSrc, srcStep, pDst, dstStep, dstRoiSize);
    case DT_REFR:
        return _refr_fwiFilterSobelHoriz_32f_C4R(pSrc, srcStep, pDst, dstStep, dstRoiSize);
    default:
        assert(false);
        return _refr_fwiFilterSobelHoriz_32f_C4R(pSrc, srcStep, pDst, dstStep, dstRoiSize);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiFilterMedianCross_16s_AC4R( const Fw16s * pSrc, int srcStep,
                                                Fw16s * pDst, int dstStep, FwiSize dstRoiSize,
                                                FwiMaskSize maskSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilterMedianCross_16s_AC4R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize);
    case DT_REFR:
        return _refr_fwiFilterMedianCross_16s_AC4R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize);
    default:
        assert(false);
        return _refr_fwiFilterMedianCross_16s_AC4R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize);
    }
}


OREFR OSSE2       FwStatus STDCALL fwiFilterMax_8u_C1R( const Fw8u * pSrc, int srcStep,
                               Fw8u * pDst, int dstStep, FwiSize dstRoiSize,
                               FwiSize maskSize, FwiPoint anchor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilterMax_8u_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize, anchor);
    case DT_REFR:
        return _refr_fwiFilterMax_8u_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize, anchor);
    default:
        assert(false);
        return _refr_fwiFilterMax_8u_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize, anchor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiAdd_16sc_C1RSfs( const Fw16sc *pSrc1, int src1Step, const Fw16sc *pSrc2,   int src2Step, Fw16sc *pDst, int dstStep, FwiSize roiSize, int scaleFactor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiAdd_16sc_C1RSfs(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, scaleFactor);
    case DT_SSE2:
        return _sse2_fwiAdd_16sc_C1RSfs(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, scaleFactor);
    case DT_REFR:
        return _refr_fwiAdd_16sc_C1RSfs(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, scaleFactor);
    default:
        assert(false);
        return _refr_fwiAdd_16sc_C1RSfs(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, scaleFactor);
    }
}

OREFR OSSE2         FwStatus fwiYUV422ToRGB_8u_P3( const A8U* const pSrc[3], A8U* const pDst[3], FwiSize imgSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiYUV422ToRGB_8u_P3(pSrc, pDst, imgSize);
    case DT_REFR:
        return _refr_fwiYUV422ToRGB_8u_P3(pSrc, pDst, imgSize);
    default:
        assert(false);
        return _refr_fwiYUV422ToRGB_8u_P3(pSrc, pDst, imgSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiCopy_32s_C3R( const Fw32s *pSrc, int srcStep, Fw32s *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiCopy_32s_C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiCopy_32s_C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiCopy_32s_C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiCopy_32s_C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiThreshold_LTValGTVal_32f_AC4R( const Fw32f *pSrc, int srcStep, Fw32f *pDst, int dstStep, FwiSize roiSize, const Fw32f thresholdLT[3], const Fw32f valueLT[3], const Fw32f thresholdGT[3], const Fw32f valueGT[3])
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiThreshold_LTValGTVal_32f_AC4R(pSrc, srcStep, pDst, dstStep, roiSize, thresholdLT, valueLT, thresholdGT, valueGT);
    case DT_SSE2:
        return _sse2_fwiThreshold_LTValGTVal_32f_AC4R(pSrc, srcStep, pDst, dstStep, roiSize, thresholdLT, valueLT, thresholdGT, valueGT);
    case DT_REFR:
        return _refr_fwiThreshold_LTValGTVal_32f_AC4R(pSrc, srcStep, pDst, dstStep, roiSize, thresholdLT, valueLT, thresholdGT, valueGT);
    default:
        assert(false);
        return _refr_fwiThreshold_LTValGTVal_32f_AC4R(pSrc, srcStep, pDst, dstStep, roiSize, thresholdLT, valueLT, thresholdGT, valueGT);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiMulC_16s_C4IRSfs( const Fw16s value[4], Fw16s *pSrcDst, int srcDstStep, FwiSize roiSize, int scaleFactor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiMulC_16s_C4IRSfs(value, pSrcDst, srcDstStep, roiSize, scaleFactor);
    case DT_SSE2:
        return _sse2_fwiMulC_16s_C4IRSfs(value, pSrcDst, srcDstStep, roiSize, scaleFactor);
    case DT_REFR:
        return _refr_fwiMulC_16s_C4IRSfs(value, pSrcDst, srcDstStep, roiSize, scaleFactor);
    default:
        assert(false);
        return _refr_fwiMulC_16s_C4IRSfs(value, pSrcDst, srcDstStep, roiSize, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiDivC_8u_AC4RSfs( const Fw8u *pSrc, int srcStep, const Fw8u value[3], Fw8u *pDst, int dstStep, FwiSize roiSize, int scaleFactor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiDivC_8u_AC4RSfs(pSrc, srcStep, value, pDst, dstStep, roiSize, scaleFactor);
    case DT_SSE2:
        return _sse2_fwiDivC_8u_AC4RSfs(pSrc, srcStep, value, pDst, dstStep, roiSize, scaleFactor);
    case DT_REFR:
        return _refr_fwiDivC_8u_AC4RSfs(pSrc, srcStep, value, pDst, dstStep, roiSize, scaleFactor);
    default:
        assert(false);
        return _refr_fwiDivC_8u_AC4RSfs(pSrc, srcStep, value, pDst, dstStep, roiSize, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiMulC_16sc_AC4IRSfs( const Fw16sc value[3], Fw16sc *pSrcDst, int srcDstStep, FwiSize roiSize, int scaleFactor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiMulC_16sc_AC4IRSfs(value, pSrcDst, srcDstStep, roiSize, scaleFactor);
    case DT_SSE2:
        return _sse2_fwiMulC_16sc_AC4IRSfs(value, pSrcDst, srcDstStep, roiSize, scaleFactor);
    case DT_REFR:
        return _refr_fwiMulC_16sc_AC4IRSfs(value, pSrcDst, srcDstStep, roiSize, scaleFactor);
    default:
        assert(false);
        return _refr_fwiMulC_16sc_AC4IRSfs(value, pSrcDst, srcDstStep, roiSize, scaleFactor);
    }
}

OREFR               FwStatus fwiYCCToRGB_16u_AC4R( const Fw16u* pSrc, int srcStep, Fw16u* pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiYCCToRGB_16u_AC4R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiYCCToRGB_16u_AC4R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}


OREFR               FwStatus fwiLUVToRGB_8u_C3R( const Fw8u* pSrc, int srcStep, Fw8u *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiLUVToRGB_8u_C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiLUVToRGB_8u_C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiCopy_32s_P4C4R( const Fw32s * const pSrc[4], int srcStep, Fw32s *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiCopy_32s_P4C4R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiCopy_32s_P4C4R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiCopy_32s_P4C4R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiCopy_32s_P4C4R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 FwStatus STDCALL fwiWarpAffineBack_8u_C3R( const Fw8u* pSrc, FwiSize srcSize, int srcStep,
								FwiRect srcRoi, Fw8u* pDst, int dstStep, FwiRect dstRoi,
								const double coeffs[2][3], int interpolation )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiWarpAffineBack_8u_C3R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, coeffs, interpolation);
    case DT_REFR:
        return _refr_fwiWarpAffineBack_8u_C3R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, coeffs, interpolation);
    default:
        assert(false);
        return _refr_fwiWarpAffineBack_8u_C3R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, coeffs, interpolation);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiOr_16u_C3IR( const Fw16u *pSrc,  int srcStep,        Fw16u *pSrcDst, int srcDstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiOr_16u_C3IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiOr_16u_C3IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    case DT_REFR:
        return _refr_fwiOr_16u_C3IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiOr_16u_C3IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    }
}

OREFR       FwStatus STDCALL fwiShear_32f_C3R(const Fw32f* pSrc, FwiSize srcSize, int srcStep, FwiRect srcRoi, Fw32f* pDst, int dstStep, FwiRect dstRoi, double xShear, double yShear, double xShift, double yShift, int interpolation )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiShear_32f_C3R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, xShear, yShear, xShift, yShift, interpolation);
    default:
        assert(false);
        return _refr_fwiShear_32f_C3R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, xShear, yShear, xShift, yShift, interpolation);
    }
}

OREFR OSSE2 FwStatus STDCALL fwiWarpPerspective_32f_C3R( const Fw32f* pSrc, FwiSize srcSize, int srcStep,
								FwiRect srcRoi, Fw32f* pDst, int dstStep, FwiRect dstRoi,
								const double coeffs[3][3], int interpolation )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiWarpPerspective_32f_C3R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, coeffs, interpolation);
    case DT_REFR:
        return _refr_fwiWarpPerspective_32f_C3R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, coeffs, interpolation);
    default:
        assert(false);
        return _refr_fwiWarpPerspective_32f_C3R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, coeffs, interpolation);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiSwapChannels_32s_C3R(const Fw32s *pSrc,int srcStep, Fw32s *pDst, int dstStep, FwiSize roiSize,const int dstOrder[3])
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiSwapChannels_32s_C3R(pSrc, srcStep, pDst, dstStep, roiSize, dstOrder);
    case DT_SSE2:
        return _sse2_fwiSwapChannels_32s_C3R(pSrc, srcStep, pDst, dstStep, roiSize, dstOrder);
    case DT_REFR:
        return _refr_fwiSwapChannels_32s_C3R(pSrc, srcStep, pDst, dstStep, roiSize, dstOrder);
    default:
        assert(false);
        return _refr_fwiSwapChannels_32s_C3R(pSrc, srcStep, pDst, dstStep, roiSize, dstOrder);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiCopy_16s_C4CR( const Fw16s *pSrc, int srcStep, Fw16s *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiCopy_16s_C4CR(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiCopy_16s_C4CR(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiCopy_16s_C4CR(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiCopy_16s_C4CR(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiOr_16u_C4R( const Fw16u *pSrc1, int src1Step, const Fw16u *pSrc2,   int src2Step, Fw16u *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiOr_16u_C4R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiOr_16u_C4R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiOr_16u_C4R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiOr_16u_C4R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiFilterHipass_16s_C3R( const Fw16s * pSrc, int srcStep, Fw16s * pDst, int dstStep, FwiSize dstRoiSize, FwiMaskSize maskSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilterHipass_16s_C3R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize);
    case DT_REFR:
        return _refr_fwiFilterHipass_16s_C3R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize);
    default:
        assert(false);
        return _refr_fwiFilterHipass_16s_C3R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiRotate_8u_P3R( const Fw8u* const pSrc[3], FwiSize srcSize, int srcStep, FwiRect srcRoi, Fw8u* const pDst[3], int dstStep, FwiRect dstRoi, double angle, double xShift, double yShift, int interpolation )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiRotate_8u_P3R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, angle, xShift, yShift, interpolation);
    case DT_REFR:
        return _refr_fwiRotate_8u_P3R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, angle, xShift, yShift, interpolation);
    default:
        assert(false);
        return _refr_fwiRotate_8u_P3R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, angle, xShift, yShift, interpolation);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiFilterPrewittVert_32f_AC4R( const Fw32f * pSrc, int srcStep, Fw32f * pDst, int dstStep, FwiSize dstRoiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilterPrewittVert_32f_AC4R(pSrc, srcStep, pDst, dstStep, dstRoiSize);
    case DT_REFR:
        return _refr_fwiFilterPrewittVert_32f_AC4R(pSrc, srcStep, pDst, dstStep, dstRoiSize);
    default:
        assert(false);
        return _refr_fwiFilterPrewittVert_32f_AC4R(pSrc, srcStep, pDst, dstStep, dstRoiSize);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiFilterLowpass_32f_C1R( const Fw32f * pSrc, int srcStep, Fw32f * pDst, int dstStep, FwiSize dstRoiSize, FwiMaskSize maskSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilterLowpass_32f_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize);
    case DT_REFR:
        return _refr_fwiFilterLowpass_32f_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize);
    default:
        assert(false);
        return _refr_fwiFilterLowpass_32f_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiXor_32s_C4R( const Fw32s *pSrc1, int src1Step, const Fw32s *pSrc2,   int src2Step, Fw32s *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiXor_32s_C4R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiXor_32s_C4R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiXor_32s_C4R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiXor_32s_C4R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiSub_8u_AC4RSfs( const Fw8u   *pSrc1, int src1Step, const Fw8u   *pSrc2,   int src2Step, Fw8u *pDst, int dstStep, FwiSize roiSize, int scaleFactor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiSub_8u_AC4RSfs(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, scaleFactor);
    case DT_SSE2:
        return _sse2_fwiSub_8u_AC4RSfs(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, scaleFactor);
    case DT_REFR:
        return _refr_fwiSub_8u_AC4RSfs(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, scaleFactor);
    default:
        assert(false);
        return _refr_fwiSub_8u_AC4RSfs(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiConvert_8u32f_C4R( const Fw8u *pSrc, int srcStep, Fw32f *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiConvert_8u32f_C4R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiConvert_8u32f_C4R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiConvert_8u32f_C4R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiConvert_8u32f_C4R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR               FwStatus fwiYCbCr420ToBGR555_8u16u_P3C3R(const A8U* const pSrc[3], int srcStep[3], A16U* pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiYCbCr420ToBGR555_8u16u_P3C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiYCbCr420ToBGR555_8u16u_P3C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiFilter_16s_C4R( const Fw16s * pSrc, int srcStep,
                              Fw16s * pDst, int dstStep, FwiSize dstRoiSize,
                              const Fw32s * pKernel, FwiSize kernelSize,
                              FwiPoint anchor, int divisor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilter_16s_C4R(pSrc, srcStep, pDst, dstStep, dstRoiSize, pKernel, kernelSize, anchor, divisor);
    case DT_REFR:
        return _refr_fwiFilter_16s_C4R(pSrc, srcStep, pDst, dstStep, dstRoiSize, pKernel, kernelSize, anchor, divisor);
    default:
        assert(false);
        return _refr_fwiFilter_16s_C4R(pSrc, srcStep, pDst, dstStep, dstRoiSize, pKernel, kernelSize, anchor, divisor);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiFilterPrewittVert_8u_C3R( const Fw8u * pSrc, int srcStep, Fw8u * pDst, int dstStep, FwiSize dstRoiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilterPrewittVert_8u_C3R(pSrc, srcStep, pDst, dstStep, dstRoiSize);
    case DT_REFR:
        return _refr_fwiFilterPrewittVert_8u_C3R(pSrc, srcStep, pDst, dstStep, dstRoiSize);
    default:
        assert(false);
        return _refr_fwiFilterPrewittVert_8u_C3R(pSrc, srcStep, pDst, dstStep, dstRoiSize);
    }
}

OREFR OSSE2         FwStatus fwiSum_8u_C4R(const Fw8u* pSrc, int srcStep,FwiSize roiSize, Fw64f sum[4])
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiSum_8u_C4R(pSrc, srcStep, roiSize, sum);
    case DT_REFR:
        return _refr_fwiSum_8u_C4R(pSrc, srcStep, roiSize, sum);
    default:
        assert(false);
        return _refr_fwiSum_8u_C4R(pSrc, srcStep, roiSize, sum);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiNot_8u_C4IR( Fw8u *pSrcDst, int srcDstStep, FwiSize roiSize)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiNot_8u_C4IR(pSrcDst, srcDstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiNot_8u_C4IR(pSrcDst, srcDstStep, roiSize);
    case DT_REFR:
        return _refr_fwiNot_8u_C4IR(pSrcDst, srcDstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiNot_8u_C4IR(pSrcDst, srcDstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiMul_16sc_C1RSfs( const Fw16sc *pSrc1, int src1Step, const Fw16sc *pSrc2,   int src2Step, Fw16sc *pDst, int dstStep, FwiSize roiSize, int scaleFactor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiMul_16sc_C1RSfs(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, scaleFactor);
    case DT_SSE2:
        return _sse2_fwiMul_16sc_C1RSfs(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, scaleFactor);
    case DT_REFR:
        return _refr_fwiMul_16sc_C1RSfs(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, scaleFactor);
    default:
        assert(false);
        return _refr_fwiMul_16sc_C1RSfs(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, scaleFactor);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiRotateCenter_16u_C1R( const Fw16u* pSrc,FwiSize srcSize, int srcStep, FwiRect srcRoi, Fw16u* pDst, int dstStep, FwiRect dstRoi, double angle, double xCenter, double yCenter, int interpolation )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiRotateCenter_16u_C1R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, angle, xCenter, yCenter, interpolation);
    case DT_REFR:
        return _refr_fwiRotateCenter_16u_C1R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, angle, xCenter, yCenter, interpolation);
    default:
        assert(false);
        return _refr_fwiRotateCenter_16u_C1R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, angle, xCenter, yCenter, interpolation);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiFilterMedianHoriz_8u_C3R( const Fw8u * pSrc, int srcStep,
                                               Fw8u * pDst, int dstStep, FwiSize dstRoiSize,
                                               FwiMaskSize maskSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilterMedianHoriz_8u_C3R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize);
    case DT_REFR:
        return _refr_fwiFilterMedianHoriz_8u_C3R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize);
    default:
        assert(false);
        return _refr_fwiFilterMedianHoriz_8u_C3R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize);
    }
}

OREFR OSSE2 FwStatus STDCALL fwiResizeShift_8u_C4R( const Fw8u* pSrc, FwiSize srcSize, int srcStep, FwiRect srcRoi,
								 Fw8u* pDst, int dstStep, FwiSize dstRoiSize,
								 double xFr, double yFr, double xShift, double yShift, int interpolation )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiResizeShift_8u_C4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoiSize, xFr, yFr, xShift, yShift, interpolation);
    case DT_REFR:
        return _refr_fwiResizeShift_8u_C4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoiSize, xFr, yFr, xShift, yShift, interpolation);
    default:
        assert(false);
        return _refr_fwiResizeShift_8u_C4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoiSize, xFr, yFr, xShift, yShift, interpolation);
    }
}


OREFR OSSE2       FwStatus STDCALL fwiFilterGauss_8u_C1R( const Fw8u * pSrc, int srcStep, Fw8u * pDst, int dstStep, FwiSize dstRoiSize, FwiMaskSize maskSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilterGauss_8u_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize);
    case DT_REFR:
        return _refr_fwiFilterGauss_8u_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize);
    default:
        assert(false);
        return _refr_fwiFilterGauss_8u_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize);
    }
}

OREFR OSSE2 FwStatus STDCALL fwiResizeSqrPixel_8u_C4R(const Fw8u* pSrc, FwiSize srcSize, int srcStep, FwiRect srcRoi,
			Fw8u* pDst, int dstStep, FwiRect dstRoi, double xFactor, double yFactor,
			double xShift, double yShift, int interpolation, Fw8u* pBuffer)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiResizeSqrPixel_8u_C4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, xFactor, yFactor, xShift, yShift, interpolation, pBuffer);
    case DT_REFR:
        return _refr_fwiResizeSqrPixel_8u_C4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, xFactor, yFactor, xShift, yShift, interpolation, pBuffer);
    default:
        assert(false);
        return _refr_fwiResizeSqrPixel_8u_C4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, xFactor, yFactor, xShift, yShift, interpolation, pBuffer);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiSub_32f_C3IR( const Fw32f  *pSrc,  int srcStep,        Fw32f  *pSrcDst, int srcDstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiSub_32f_C3IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiSub_32f_C3IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    case DT_REFR:
        return _refr_fwiSub_32f_C3IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiSub_32f_C3IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    }
}

OREFR OSSE2         FwStatus fwiLookUp3D_16u_C3R(const Fw16u *pSrc, int srcStep, Fw16u *pDst, int dstStep, FwiSize roiSize, const Fw16u *pCube, FwiLUTSpec* pLUTSpec)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiLookUp3D_16u_C3R(pSrc, srcStep, pDst, dstStep, roiSize, pCube, pLUTSpec);
    case DT_REFR:
        return _refr_fwiLookUp3D_16u_C3R(pSrc, srcStep, pDst, dstStep, roiSize, pCube, pLUTSpec);
    default:
        assert(false);
        return _refr_fwiLookUp3D_16u_C3R(pSrc, srcStep, pDst, dstStep, roiSize, pCube, pLUTSpec);
    }
}

OREFR       FwStatus STDCALL fwiWarpBilinearBack_8u_P3R(const Fw8u* const pSrc[3], FwiSize srcSize, int srcStep,
								FwiRect srcRoi, Fw8u* const pDst[3], int dstStep, FwiRect dstRoi,
								const double coeffs[2][4], int interpolation)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiWarpBilinearBack_8u_P3R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, coeffs, interpolation);
    default:
        assert(false);
        return _refr_fwiWarpBilinearBack_8u_P3R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, coeffs, interpolation);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiAnd_32s_C4IR( const Fw32s *pSrc,  int srcStep,        Fw32s *pSrcDst, int srcDstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiAnd_32s_C4IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiAnd_32s_C4IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    case DT_REFR:
        return _refr_fwiAnd_32s_C4IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiAnd_32s_C4IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    }
}

OREFR OSSE2 FwStatus STDCALL fwiWarpAffine_16u_P4R( const Fw16u* const pSrc[4], FwiSize srcSize, int srcStep,
								FwiRect srcRoi, Fw16u* const pDst[4], int dstStep, FwiRect dstRoi,
								const double coeffs[2][3], int interpolation )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiWarpAffine_16u_P4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, coeffs, interpolation);
    case DT_REFR:
        return _refr_fwiWarpAffine_16u_P4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, coeffs, interpolation);
    default:
        assert(false);
        return _refr_fwiWarpAffine_16u_P4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, coeffs, interpolation);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiFilterRobertsDown_8u_C3R( const Fw8u * pSrc, int srcStep, Fw8u * pDst, int dstStep, FwiSize dstRoiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilterRobertsDown_8u_C3R(pSrc, srcStep, pDst, dstStep, dstRoiSize);
    case DT_REFR:
        return _refr_fwiFilterRobertsDown_8u_C3R(pSrc, srcStep, pDst, dstStep, dstRoiSize);
    default:
        assert(false);
        return _refr_fwiFilterRobertsDown_8u_C3R(pSrc, srcStep, pDst, dstStep, dstRoiSize);
    }
}

OREFR OSSE2 FwStatus STDCALL fwiWarpPerspectiveBack_32f_C3R( const Fw32f* pSrc, FwiSize srcSize, int srcStep,
								FwiRect srcRoi, Fw32f* pDst, int dstStep, FwiRect dstRoi,
								const double coeffs[3][3], int interpolation )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiWarpPerspectiveBack_32f_C3R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, coeffs, interpolation);
    case DT_REFR:
        return _refr_fwiWarpPerspectiveBack_32f_C3R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, coeffs, interpolation);
    default:
        assert(false);
        return _refr_fwiWarpPerspectiveBack_32f_C3R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, coeffs, interpolation);
    }
}

OREFR OSSE2 FwStatus STDCALL fwiWarpAffineQuad_32f_P3R( const Fw32f* const pSrc[3], FwiSize srcSize, int srcStep, FwiRect srcRoi,
							        const double srcQuad[4][2], Fw32f* const pDst[3], int dstStep, FwiRect dstRoi,
									const double dstQuad[4][2], int interpolation )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiWarpAffineQuad_32f_P3R(pSrc, srcSize, srcStep, srcRoi, srcQuad, pDst, dstStep, dstRoi, dstQuad, interpolation);
    case DT_REFR:
        return _refr_fwiWarpAffineQuad_32f_P3R(pSrc, srcSize, srcStep, srcRoi, srcQuad, pDst, dstStep, dstRoi, dstQuad, interpolation);
    default:
        assert(false);
        return _refr_fwiWarpAffineQuad_32f_P3R(pSrc, srcSize, srcStep, srcRoi, srcQuad, pDst, dstStep, dstRoi, dstQuad, interpolation);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiThreshold_Val_16s_C3R( const Fw16s *pSrc, int srcStep, Fw16s *pDst, int dstStep, FwiSize roiSize, const Fw16s threshold[3], const Fw16s value[3], FwCmpOp fwCmpOp)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiThreshold_Val_16s_C3R(pSrc, srcStep, pDst, dstStep, roiSize, threshold, value, fwCmpOp);
    case DT_SSE2:
        return _sse2_fwiThreshold_Val_16s_C3R(pSrc, srcStep, pDst, dstStep, roiSize, threshold, value, fwCmpOp);
    case DT_REFR:
        return _refr_fwiThreshold_Val_16s_C3R(pSrc, srcStep, pDst, dstStep, roiSize, threshold, value, fwCmpOp);
    default:
        assert(false);
        return _refr_fwiThreshold_Val_16s_C3R(pSrc, srcStep, pDst, dstStep, roiSize, threshold, value, fwCmpOp);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiMulScale_8u_C1R(  const Fw8u  *pSrc1, int src1Step, const Fw8u  *pSrc2, int src2Step, Fw8u  *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiMulScale_8u_C1R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiMulScale_8u_C1R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiMulScale_8u_C1R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiMulScale_8u_C1R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiSet_32s_C4R( const Fw32s  value[4], Fw32s  * pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiSet_32s_C4R(value, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiSet_32s_C4R(value, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiSet_32s_C4R(value, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiSet_32s_C4R(value, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2         FwStatus fwiLookUp3D_16u_C3IR(Fw16u *pSrcDst, int srcDstStep, FwiSize roiSize, const Fw16u *pCube, FwiLUTSpec* pLUTSpec)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiLookUp3D_16u_C3IR(pSrcDst, srcDstStep, roiSize, pCube, pLUTSpec);
    case DT_REFR:
        return _refr_fwiLookUp3D_16u_C3IR(pSrcDst, srcDstStep, roiSize, pCube, pLUTSpec);
    default:
        assert(false);
        return _refr_fwiLookUp3D_16u_C3IR(pSrcDst, srcDstStep, roiSize, pCube, pLUTSpec);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiThreshold_LT_8u_C1IR( Fw8u *pSrcDst, int srcDstStep, FwiSize roiSize, Fw8u threshold)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiThreshold_LT_8u_C1IR(pSrcDst, srcDstStep, roiSize, threshold);
    case DT_SSE2:
        return _sse2_fwiThreshold_LT_8u_C1IR(pSrcDst, srcDstStep, roiSize, threshold);
    case DT_REFR:
        return _refr_fwiThreshold_LT_8u_C1IR(pSrcDst, srcDstStep, roiSize, threshold);
    default:
        assert(false);
        return _refr_fwiThreshold_LT_8u_C1IR(pSrcDst, srcDstStep, roiSize, threshold);
    }
}



OREFR OSSE2 OF10H FwStatus STDCALL fwiConvert_8u16u_C1R( const Fw8u *pSrc, int srcStep, Fw16u *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiConvert_8u16u_C1R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiConvert_8u16u_C1R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiConvert_8u16u_C1R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiConvert_8u16u_C1R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiThreshold_Val_32f_C3IR( Fw32f *pSrcDst, int srcDstStep, FwiSize roiSize, const Fw32f threshold[3], const Fw32f value[3], FwCmpOp fwCmpOp)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiThreshold_Val_32f_C3IR(pSrcDst, srcDstStep, roiSize, threshold, value, fwCmpOp);
    case DT_SSE2:
        return _sse2_fwiThreshold_Val_32f_C3IR(pSrcDst, srcDstStep, roiSize, threshold, value, fwCmpOp);
    case DT_REFR:
        return _refr_fwiThreshold_Val_32f_C3IR(pSrcDst, srcDstStep, roiSize, threshold, value, fwCmpOp);
    default:
        assert(false);
        return _refr_fwiThreshold_Val_32f_C3IR(pSrcDst, srcDstStep, roiSize, threshold, value, fwCmpOp);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiLShiftC_32s_C4IR( const Fw32u value[4], Fw32s *pSrcDst, int srcDstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiLShiftC_32s_C4IR(value, pSrcDst, srcDstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiLShiftC_32s_C4IR(value, pSrcDst, srcDstStep, roiSize);
    case DT_REFR:
        return _refr_fwiLShiftC_32s_C4IR(value, pSrcDst, srcDstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiLShiftC_32s_C4IR(value, pSrcDst, srcDstStep, roiSize);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiFilterRow_32f_C3R( const Fw32f * pSrc, int srcStep,
                              Fw32f * pDst, int dstStep, FwiSize dstRoiSize,
                              const Fw32f * pKernel, int kernelSize,
                              int xAnchor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilterRow_32f_C3R(pSrc, srcStep, pDst, dstStep, dstRoiSize, pKernel, kernelSize, xAnchor);
    case DT_REFR:
        return _refr_fwiFilterRow_32f_C3R(pSrc, srcStep, pDst, dstStep, dstRoiSize, pKernel, kernelSize, xAnchor);
    default:
        assert(false);
        return _refr_fwiFilterRow_32f_C3R(pSrc, srcStep, pDst, dstStep, dstRoiSize, pKernel, kernelSize, xAnchor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiDiv_32f_C3IR( const Fw32f  *pSrc,  int srcStep,        Fw32f  *pSrcDst, int srcDstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiDiv_32f_C3IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiDiv_32f_C3IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    case DT_REFR:
        return _refr_fwiDiv_32f_C3IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiDiv_32f_C3IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiThreshold_LTValGTVal_8u_C1R( const Fw8u *pSrc, int srcStep, Fw8u *pDst, int dstStep, FwiSize roiSize, Fw8u thresholdLT, Fw8u valueLT, Fw8u thresholdGT, Fw8u valueGT)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiThreshold_LTValGTVal_8u_C1R(pSrc, srcStep, pDst, dstStep, roiSize, thresholdLT, valueLT, thresholdGT, valueGT);
    case DT_SSE2:
        return _sse2_fwiThreshold_LTValGTVal_8u_C1R(pSrc, srcStep, pDst, dstStep, roiSize, thresholdLT, valueLT, thresholdGT, valueGT);
    case DT_REFR:
        return _refr_fwiThreshold_LTValGTVal_8u_C1R(pSrc, srcStep, pDst, dstStep, roiSize, thresholdLT, valueLT, thresholdGT, valueGT);
    default:
        assert(false);
        return _refr_fwiThreshold_LTValGTVal_8u_C1R(pSrc, srcStep, pDst, dstStep, roiSize, thresholdLT, valueLT, thresholdGT, valueGT);
    }
}

OREFR               FwStatus fwiRGBToCbYCr422_8u_C3C2R(const A8U* pSrc, int srcStep, A8U* pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiRGBToCbYCr422_8u_C3C2R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiRGBToCbYCr422_8u_C3C2R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR       FwStatus STDCALL fwiWarpBilinearQuad_32f_AC4R(const Fw32f* pSrc, FwiSize srcSize, int srcStep, FwiRect srcRoi,
							        const double srcQuad[4][2], Fw32f* pDst, int dstStep, FwiRect dstRoi,
									const double dstQuad[4][2], int interpolation)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiWarpBilinearQuad_32f_AC4R(pSrc, srcSize, srcStep, srcRoi, srcQuad, pDst, dstStep, dstRoi, dstQuad, interpolation);
    default:
        assert(false);
        return _refr_fwiWarpBilinearQuad_32f_AC4R(pSrc, srcSize, srcStep, srcRoi, srcQuad, pDst, dstStep, dstRoi, dstQuad, interpolation);
    }
}

OREFR OSSE2 FwStatus STDCALL fwiResizeCenter_32f_C3R( const Fw32f* pSrc, FwiSize srcSize, int srcStep, FwiRect srcRoi,
								   Fw32f* pDst, int dstStep, FwiSize dstRoiSize,
								   double xFactor, double yFactor, double xCenter, double yCenter, int interpolation )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiResizeCenter_32f_C3R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoiSize, xFactor, yFactor, xCenter, yCenter, interpolation);
    case DT_REFR:
        return _refr_fwiResizeCenter_32f_C3R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoiSize, xFactor, yFactor, xCenter, yCenter, interpolation);
    default:
        assert(false);
        return _refr_fwiResizeCenter_32f_C3R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoiSize, xFactor, yFactor, xCenter, yCenter, interpolation);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiSqrt_16u_C1RSfs( const Fw16u *pSrc,    int srcStep, Fw16u *pDst, int dstStep, FwiSize roiSize, int scaleFactor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiSqrt_16u_C1RSfs(pSrc, srcStep, pDst, dstStep, roiSize, scaleFactor);
    case DT_SSE2:
        return _sse2_fwiSqrt_16u_C1RSfs(pSrc, srcStep, pDst, dstStep, roiSize, scaleFactor);
    case DT_REFR:
        return _refr_fwiSqrt_16u_C1RSfs(pSrc, srcStep, pDst, dstStep, roiSize, scaleFactor);
    default:
        assert(false);
        return _refr_fwiSqrt_16u_C1RSfs(pSrc, srcStep, pDst, dstStep, roiSize, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiExp_8u_C3IRSfs(       Fw8u  *pSrcDst,  int srcDstStep, FwiSize roiSize, int scaleFactor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiExp_8u_C3IRSfs(pSrcDst, srcDstStep, roiSize, scaleFactor);
    case DT_SSE2:
        return _sse2_fwiExp_8u_C3IRSfs(pSrcDst, srcDstStep, roiSize, scaleFactor);
    case DT_REFR:
        return _refr_fwiExp_8u_C3IRSfs(pSrcDst, srcDstStep, roiSize, scaleFactor);
    default:
        assert(false);
        return _refr_fwiExp_8u_C3IRSfs(pSrcDst, srcDstStep, roiSize, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiConvert_16u32f_C4R( const Fw16u *pSrc, int srcStep, Fw32f *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiConvert_16u32f_C4R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiConvert_16u32f_C4R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiConvert_16u32f_C4R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiConvert_16u32f_C4R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2         FwStatus fwiColorToGray_16u_AC4C1R(const Fw16u* pSrc, int srcStep, Fw16u* pDst, int dstStep, FwiSize roiSize, const Fw32f coeffs[3])
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiColorToGray_16u_AC4C1R(pSrc, srcStep, pDst, dstStep, roiSize, coeffs);
    case DT_REFR:
        return _refr_fwiColorToGray_16u_AC4C1R(pSrc, srcStep, pDst, dstStep, roiSize, coeffs);
    default:
        assert(false);
        return _refr_fwiColorToGray_16u_AC4C1R(pSrc, srcStep, pDst, dstStep, roiSize, coeffs);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiXorC_8u_C1IR(       Fw8u value,    Fw8u *pSrcDst, int srcDstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiXorC_8u_C1IR(value, pSrcDst, srcDstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiXorC_8u_C1IR(value, pSrcDst, srcDstStep, roiSize);
    case DT_REFR:
        return _refr_fwiXorC_8u_C1IR(value, pSrcDst, srcDstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiXorC_8u_C1IR(value, pSrcDst, srcDstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiCompareEqualEps_32f_C1R( const Fw32f *pSrc1, int src1Step, const Fw32f *pSrc2, int src2Step, Fw8u *pDst, int dstStep, FwiSize roiSize, Fw32f eps)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiCompareEqualEps_32f_C1R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, eps);
    case DT_SSE2:
        return _sse2_fwiCompareEqualEps_32f_C1R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, eps);
    case DT_REFR:
        return _refr_fwiCompareEqualEps_32f_C1R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, eps);
    default:
        assert(false);
        return _refr_fwiCompareEqualEps_32f_C1R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, eps);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiAddC_16sc_C3IRSfs( const Fw16sc value[3], Fw16sc *pSrcDst, int srcDstStep, FwiSize roiSize, int scaleFactor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiAddC_16sc_C3IRSfs(value, pSrcDst, srcDstStep, roiSize, scaleFactor);
    case DT_SSE2:
        return _sse2_fwiAddC_16sc_C3IRSfs(value, pSrcDst, srcDstStep, roiSize, scaleFactor);
    case DT_REFR:
        return _refr_fwiAddC_16sc_C3IRSfs(value, pSrcDst, srcDstStep, roiSize, scaleFactor);
    default:
        assert(false);
        return _refr_fwiAddC_16sc_C3IRSfs(value, pSrcDst, srcDstStep, roiSize, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiSet_32f_C4MR( const Fw32f  value[4], Fw32f  * pDst, int dstStep, FwiSize roiSize, const Fw8u * pMask, int maskStep )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiSet_32f_C4MR(value, pDst, dstStep, roiSize, pMask, maskStep);
    case DT_SSE2:
        return _sse2_fwiSet_32f_C4MR(value, pDst, dstStep, roiSize, pMask, maskStep);
    case DT_REFR:
        return _refr_fwiSet_32f_C4MR(value, pDst, dstStep, roiSize, pMask, maskStep);
    default:
        assert(false);
        return _refr_fwiSet_32f_C4MR(value, pDst, dstStep, roiSize, pMask, maskStep);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiFilterRow_8u_C3R( const Fw8u * pSrc, int srcStep,
                             Fw8u * pDst, int dstStep, FwiSize dstRoiSize,
                             const Fw32s * pKernel, int kernelSize,
                             int xAnchor, int divisor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilterRow_8u_C3R(pSrc, srcStep, pDst, dstStep, dstRoiSize, pKernel, kernelSize, xAnchor, divisor);
    case DT_REFR:
        return _refr_fwiFilterRow_8u_C3R(pSrc, srcStep, pDst, dstStep, dstRoiSize, pKernel, kernelSize, xAnchor, divisor);
    default:
        assert(false);
        return _refr_fwiFilterRow_8u_C3R(pSrc, srcStep, pDst, dstStep, dstRoiSize, pKernel, kernelSize, xAnchor, divisor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiConvert_32s8u_C3R( const Fw32s *pSrc, int srcStep, Fw8u *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiConvert_32s8u_C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiConvert_32s8u_C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiConvert_32s8u_C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiConvert_32s8u_C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiAddC_32f_C1IR(       Fw32f value,    Fw32f *pSrcDst, int srcDstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiAddC_32f_C1IR(value, pSrcDst, srcDstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiAddC_32f_C1IR(value, pSrcDst, srcDstStep, roiSize);
    case DT_REFR:
        return _refr_fwiAddC_32f_C1IR(value, pSrcDst, srcDstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiAddC_32f_C1IR(value, pSrcDst, srcDstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiMulC_32f_AC4R( const Fw32f *pSrc, int srcStep, const Fw32f value[3], Fw32f *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiMulC_32f_AC4R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiMulC_32f_AC4R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiMulC_32f_AC4R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiMulC_32f_AC4R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiDivC_8u_C1RSfs( const Fw8u *pSrc, int srcStep,       Fw8u value,    Fw8u *pDst, int dstStep, FwiSize roiSize, int scaleFactor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiDivC_8u_C1RSfs(pSrc, srcStep, value, pDst, dstStep, roiSize, scaleFactor);
    case DT_SSE2:
        return _sse2_fwiDivC_8u_C1RSfs(pSrc, srcStep, value, pDst, dstStep, roiSize, scaleFactor);
    case DT_REFR:
        return _refr_fwiDivC_8u_C1RSfs(pSrc, srcStep, value, pDst, dstStep, roiSize, scaleFactor);
    default:
        assert(false);
        return _refr_fwiDivC_8u_C1RSfs(pSrc, srcStep, value, pDst, dstStep, roiSize, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiConvert_16u8u_AC4R( const Fw16u *pSrc, int srcStep, Fw8u *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiConvert_16u8u_AC4R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiConvert_16u8u_AC4R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiConvert_16u8u_AC4R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiConvert_16u8u_AC4R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2         FwStatus fwiMin_16s_C3R(const Fw16s* pSrc, int srcStep,FwiSize roiSize, Fw16s min[3])
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiMin_16s_C3R(pSrc, srcStep, roiSize, min);
    case DT_REFR:
        return _refr_fwiMin_16s_C3R(pSrc, srcStep, roiSize, min);
    default:
        assert(false);
        return _refr_fwiMin_16s_C3R(pSrc, srcStep, roiSize, min);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiAdd_16s_AC4RSfs( const Fw16s  *pSrc1, int src1Step, const Fw16s  *pSrc2,   int src2Step, Fw16s *pDst, int dstStep, FwiSize roiSize, int scaleFactor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiAdd_16s_AC4RSfs(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, scaleFactor);
    case DT_SSE2:
        return _sse2_fwiAdd_16s_AC4RSfs(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, scaleFactor);
    case DT_REFR:
        return _refr_fwiAdd_16s_AC4RSfs(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, scaleFactor);
    default:
        assert(false);
        return _refr_fwiAdd_16s_AC4RSfs(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiCompare_32f_C1R( const Fw32f *pSrc1, int src1Step, const Fw32f *pSrc2, int src2Step, Fw8u *pDst, int dstStep, FwiSize roiSize, FwCmpOp fwCmpOp )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiCompare_32f_C1R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, fwCmpOp);
    case DT_SSE2:
        return _sse2_fwiCompare_32f_C1R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, fwCmpOp);
    case DT_REFR:
        return _refr_fwiCompare_32f_C1R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, fwCmpOp);
    default:
        assert(false);
        return _refr_fwiCompare_32f_C1R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, fwCmpOp);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiCompareC_32f_C3R( const Fw32f *pSrc, int srcStep, const Fw32f value[3], Fw8u *pDst, int dstStep, FwiSize roiSize, FwCmpOp fwCmpOp )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiCompareC_32f_C3R(pSrc, srcStep, value, pDst, dstStep, roiSize, fwCmpOp);
    case DT_SSE2:
        return _sse2_fwiCompareC_32f_C3R(pSrc, srcStep, value, pDst, dstStep, roiSize, fwCmpOp);
    case DT_REFR:
        return _refr_fwiCompareC_32f_C3R(pSrc, srcStep, value, pDst, dstStep, roiSize, fwCmpOp);
    default:
        assert(false);
        return _refr_fwiCompareC_32f_C3R(pSrc, srcStep, value, pDst, dstStep, roiSize, fwCmpOp);
    }
}

OREFR       FwStatus STDCALL fwiResizeSqrPixel_32f_C4R(const Fw32f* pSrc, FwiSize srcSize, int srcStep, FwiRect srcRoi,
			Fw32f* pDst, int dstStep, FwiRect dstRoi, double xFactor, double yFactor,
			double xShift, double yShift, int interpolation, Fw8u* pBuffer)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiResizeSqrPixel_32f_C4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, xFactor, yFactor, xShift, yShift, interpolation, pBuffer);
    default:
        assert(false);
        return _refr_fwiResizeSqrPixel_32f_C4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, xFactor, yFactor, xShift, yShift, interpolation, pBuffer);
    }
}

OREFR               FwStatus fwiLUVToRGB_8u_AC4R( const Fw8u* pSrc, int srcStep, Fw8u *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiLUVToRGB_8u_AC4R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiLUVToRGB_8u_AC4R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 FwStatus STDCALL fwiWarpAffineBack_8u_AC4R( const Fw8u* pSrc, FwiSize srcSize, int srcStep,
								FwiRect srcRoi, Fw8u* pDst, int dstStep, FwiRect dstRoi,
								const double coeffs[2][3], int interpolation )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiWarpAffineBack_8u_AC4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, coeffs, interpolation);
    case DT_REFR:
        return _refr_fwiWarpAffineBack_8u_AC4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, coeffs, interpolation);
    default:
        assert(false);
        return _refr_fwiWarpAffineBack_8u_AC4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, coeffs, interpolation);
    }
}


OREFR OSSE2         FwStatus fwiSum_8u_C1R( const Fw8u* pSrc, int srcStep, FwiSize roiSize, Fw64f* pSum )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiSum_8u_C1R(pSrc, srcStep, roiSize, pSum);
    case DT_REFR:
        return _refr_fwiSum_8u_C1R(pSrc, srcStep, roiSize, pSum);
    default:
        assert(false);
        return _refr_fwiSum_8u_C1R(pSrc, srcStep, roiSize, pSum);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiMul_32f_C4IR( const Fw32f  *pSrc,  int srcStep,        Fw32f  *pSrcDst, int srcDstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiMul_32f_C4IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiMul_32f_C4IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    case DT_REFR:
        return _refr_fwiMul_32f_C4IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiMul_32f_C4IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiFilterBox_8u_C3R( const Fw8u * pSrc, int srcStep,
                               Fw8u * pDst, int dstStep, FwiSize dstRoiSize,
                               FwiSize maskSize, FwiPoint anchor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilterBox_8u_C3R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize, anchor);
    case DT_REFR:
        return _refr_fwiFilterBox_8u_C3R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize, anchor);
    default:
        assert(false);
        return _refr_fwiFilterBox_8u_C3R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize, anchor);
    }
}


OREFR       FwStatus STDCALL fwiGetBilinearTransform(FwiRect srcRoi, const double quad[4][2],double coeffs[2][4])
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiGetBilinearTransform(srcRoi, quad, coeffs);
    default:
        assert(false);
        return _refr_fwiGetBilinearTransform(srcRoi, quad, coeffs);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiFilterLaplace_8u_C4R( const Fw8u * pSrc, int srcStep, Fw8u * pDst, int dstStep, FwiSize dstRoiSize, FwiMaskSize maskSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilterLaplace_8u_C4R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize);
    case DT_REFR:
        return _refr_fwiFilterLaplace_8u_C4R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize);
    default:
        assert(false);
        return _refr_fwiFilterLaplace_8u_C4R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiFilterMin_32f_C3R( const Fw32f * pSrc, int srcStep,
                               Fw32f * pDst, int dstStep, FwiSize dstRoiSize,
                               FwiSize maskSize, FwiPoint anchor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilterMin_32f_C3R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize, anchor);
    case DT_REFR:
        return _refr_fwiFilterMin_32f_C3R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize, anchor);
    default:
        assert(false);
        return _refr_fwiFilterMin_32f_C3R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize, anchor);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiRotate_32f_C3R( const Fw32f* pSrc, FwiSize srcSize, int srcStep, FwiRect srcRoi, Fw32f* pDst, int dstStep, FwiRect dstRoi, double angle, double xShift, double yShift, int interpolation )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiRotate_32f_C3R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, angle, xShift, yShift, interpolation);
    case DT_REFR:
        return _refr_fwiRotate_32f_C3R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, angle, xShift, yShift, interpolation);
    default:
        assert(false);
        return _refr_fwiRotate_32f_C3R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, angle, xShift, yShift, interpolation);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiThreshold_8u_AC4IR( Fw8u *pSrcDst, int srcDstStep, FwiSize roiSize, const Fw8u threshold[3], FwCmpOp fwCmpOp)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiThreshold_8u_AC4IR(pSrcDst, srcDstStep, roiSize, threshold, fwCmpOp);
    case DT_SSE2:
        return _sse2_fwiThreshold_8u_AC4IR(pSrcDst, srcDstStep, roiSize, threshold, fwCmpOp);
    case DT_REFR:
        return _refr_fwiThreshold_8u_AC4IR(pSrcDst, srcDstStep, roiSize, threshold, fwCmpOp);
    default:
        assert(false);
        return _refr_fwiThreshold_8u_AC4IR(pSrcDst, srcDstStep, roiSize, threshold, fwCmpOp);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiThreshold_GTVal_16s_C4IR( Fw16s *pSrcDst, int srcDstStep, FwiSize roiSize, const Fw16s threshold[4], const Fw16s value[4])
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiThreshold_GTVal_16s_C4IR(pSrcDst, srcDstStep, roiSize, threshold, value);
    case DT_SSE2:
        return _sse2_fwiThreshold_GTVal_16s_C4IR(pSrcDst, srcDstStep, roiSize, threshold, value);
    case DT_REFR:
        return _refr_fwiThreshold_GTVal_16s_C4IR(pSrcDst, srcDstStep, roiSize, threshold, value);
    default:
        assert(false);
        return _refr_fwiThreshold_GTVal_16s_C4IR(pSrcDst, srcDstStep, roiSize, threshold, value);
    }
}

OREFR               FwStatus fwiXYZToRGB_16s_C3R( const Fw16s* pSrc, int srcStep, Fw16s* pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiXYZToRGB_16s_C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiXYZToRGB_16s_C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiLShiftC_16u_C1R( const Fw16u  *pSrc, int srcStep,       Fw32u value,    Fw16u *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiLShiftC_16u_C1R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiLShiftC_16u_C1R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiLShiftC_16u_C1R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiLShiftC_16u_C1R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2         FwStatus fwiYCbCr420ToRGB_8u_P3C3R(const A8U* const pSrc[3], int srcStep[3], A8U* pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiYCbCr420ToRGB_8u_P3C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiYCbCr420ToRGB_8u_P3C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiYCbCr420ToRGB_8u_P3C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiExp_16s_C3IRSfs(       Fw16s *pSrcDst,  int srcDstStep, FwiSize roiSize, int scaleFactor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiExp_16s_C3IRSfs(pSrcDst, srcDstStep, roiSize, scaleFactor);
    case DT_SSE2:
        return _sse2_fwiExp_16s_C3IRSfs(pSrcDst, srcDstStep, roiSize, scaleFactor);
    case DT_REFR:
        return _refr_fwiExp_16s_C3IRSfs(pSrcDst, srcDstStep, roiSize, scaleFactor);
    default:
        assert(false);
        return _refr_fwiExp_16s_C3IRSfs(pSrcDst, srcDstStep, roiSize, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiAddC_32f_C3IR( const Fw32f value[3], Fw32f *pSrcDst, int srcDstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiAddC_32f_C3IR(value, pSrcDst, srcDstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiAddC_32f_C3IR(value, pSrcDst, srcDstStep, roiSize);
    case DT_REFR:
        return _refr_fwiAddC_32f_C3IR(value, pSrcDst, srcDstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiAddC_32f_C3IR(value, pSrcDst, srcDstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiSubC_16sc_C3IRSfs( const Fw16sc value[3], Fw16sc *pSrcDst, int srcDstStep, FwiSize roiSize, int scaleFactor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiSubC_16sc_C3IRSfs(value, pSrcDst, srcDstStep, roiSize, scaleFactor);
    case DT_SSE2:
        return _sse2_fwiSubC_16sc_C3IRSfs(value, pSrcDst, srcDstStep, roiSize, scaleFactor);
    case DT_REFR:
        return _refr_fwiSubC_16sc_C3IRSfs(value, pSrcDst, srcDstStep, roiSize, scaleFactor);
    default:
        assert(false);
        return _refr_fwiSubC_16sc_C3IRSfs(value, pSrcDst, srcDstStep, roiSize, scaleFactor);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiFilterLaplace_8u_AC4R( const Fw8u * pSrc, int srcStep, Fw8u * pDst, int dstStep, FwiSize dstRoiSize, FwiMaskSize maskSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilterLaplace_8u_AC4R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize);
    case DT_REFR:
        return _refr_fwiFilterLaplace_8u_AC4R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize);
    default:
        assert(false);
        return _refr_fwiFilterLaplace_8u_AC4R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize);
    }
}

OREFR OSSE2 OF10H   FwStatus fwiRGBToXYZ_8u_AC4R( const Fw8u* pSrc, int srcStep, Fw8u* pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiRGBToXYZ_8u_AC4R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiRGBToXYZ_8u_AC4R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiRGBToXYZ_8u_AC4R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiRGBToXYZ_8u_AC4R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 FwStatus STDCALL fwiWarpAffineBack_32f_C4R( const Fw32f* pSrc, FwiSize srcSize, int srcStep,
								FwiRect srcRoi, Fw32f* pDst, int dstStep, FwiRect dstRoi,
								const double coeffs[2][3], int interpolation )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiWarpAffineBack_32f_C4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, coeffs, interpolation);
    case DT_REFR:
        return _refr_fwiWarpAffineBack_32f_C4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, coeffs, interpolation);
    default:
        assert(false);
        return _refr_fwiWarpAffineBack_32f_C4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, coeffs, interpolation);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiMul_32sc_AC4IRSfs( const Fw32sc *pSrc,  int srcStep,        Fw32sc *pSrcDst, int srcDstStep, FwiSize roiSize, int scaleFactor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiMul_32sc_AC4IRSfs(pSrc, srcStep, pSrcDst, srcDstStep, roiSize, scaleFactor);
    case DT_SSE2:
        return _sse2_fwiMul_32sc_AC4IRSfs(pSrc, srcStep, pSrcDst, srcDstStep, roiSize, scaleFactor);
    case DT_REFR:
        return _refr_fwiMul_32sc_AC4IRSfs(pSrc, srcStep, pSrcDst, srcDstStep, roiSize, scaleFactor);
    default:
        assert(false);
        return _refr_fwiMul_32sc_AC4IRSfs(pSrc, srcStep, pSrcDst, srcDstStep, roiSize, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiXor_8u_C4R( const Fw8u *pSrc1, int src1Step, const Fw8u *pSrc2,   int src2Step, Fw8u *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiXor_8u_C4R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiXor_8u_C4R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiXor_8u_C4R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiXor_8u_C4R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiSub_16s_AC4IRSfs( const Fw16s  *pSrc,  int srcStep,        Fw16s  *pSrcDst, int srcDstStep, FwiSize roiSize, int scaleFactor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiSub_16s_AC4IRSfs(pSrc, srcStep, pSrcDst, srcDstStep, roiSize, scaleFactor);
    case DT_SSE2:
        return _sse2_fwiSub_16s_AC4IRSfs(pSrc, srcStep, pSrcDst, srcDstStep, roiSize, scaleFactor);
    case DT_REFR:
        return _refr_fwiSub_16s_AC4IRSfs(pSrc, srcStep, pSrcDst, srcDstStep, roiSize, scaleFactor);
    default:
        assert(false);
        return _refr_fwiSub_16s_AC4IRSfs(pSrc, srcStep, pSrcDst, srcDstStep, roiSize, scaleFactor);
    }
}


OREFR       FwStatus STDCALL fwiWarpBilinear_8u_C1R(const Fw8u* pSrc, FwiSize srcSize, int srcStep,
								FwiRect srcRoi, Fw8u* pDst, int dstStep, FwiRect dstRoi,
								const double coeffs[2][4], int interpolation)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiWarpBilinear_8u_C1R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, coeffs, interpolation);
    default:
        assert(false);
        return _refr_fwiWarpBilinear_8u_C1R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, coeffs, interpolation);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiFilterLaplace_32f_C4R( const Fw32f * pSrc, int srcStep, Fw32f * pDst, int dstStep, FwiSize dstRoiSize, FwiMaskSize maskSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilterLaplace_32f_C4R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize);
    case DT_REFR:
        return _refr_fwiFilterLaplace_32f_C4R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize);
    default:
        assert(false);
        return _refr_fwiFilterLaplace_32f_C4R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiAbs_16s_C1IR( Fw16s *pSrcDst, int srcDstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiAbs_16s_C1IR(pSrcDst, srcDstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiAbs_16s_C1IR(pSrcDst, srcDstStep, roiSize);
    case DT_REFR:
        return _refr_fwiAbs_16s_C1IR(pSrcDst, srcDstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiAbs_16s_C1IR(pSrcDst, srcDstStep, roiSize);
    }
}


OREFR               FwStatus fwiBGRToHLS_8u_AC4R( const Fw8u *pSrc, int srcStep, Fw8u *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiBGRToHLS_8u_AC4R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiBGRToHLS_8u_AC4R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 FwStatus STDCALL fwiResizeCenter_8u_AC4R( const Fw8u* pSrc, FwiSize srcSize, int srcStep, FwiRect srcRoi,
								   Fw8u* pDst, int dstStep, FwiSize dstRoiSize,
								   double xFactor, double yFactor, double xCenter, double yCenter, int interpolation )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiResizeCenter_8u_AC4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoiSize, xFactor, yFactor, xCenter, yCenter, interpolation);
    case DT_REFR:
        return _refr_fwiResizeCenter_8u_AC4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoiSize, xFactor, yFactor, xCenter, yCenter, interpolation);
    default:
        assert(false);
        return _refr_fwiResizeCenter_8u_AC4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoiSize, xFactor, yFactor, xCenter, yCenter, interpolation);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiSqrt_16u_C3RSfs( const Fw16u *pSrc,    int srcStep, Fw16u *pDst, int dstStep, FwiSize roiSize, int scaleFactor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiSqrt_16u_C3RSfs(pSrc, srcStep, pDst, dstStep, roiSize, scaleFactor);
    case DT_SSE2:
        return _sse2_fwiSqrt_16u_C3RSfs(pSrc, srcStep, pDst, dstStep, roiSize, scaleFactor);
    case DT_REFR:
        return _refr_fwiSqrt_16u_C3RSfs(pSrc, srcStep, pDst, dstStep, roiSize, scaleFactor);
    default:
        assert(false);
        return _refr_fwiSqrt_16u_C3RSfs(pSrc, srcStep, pDst, dstStep, roiSize, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiCopy_8u_C1C4R( const Fw8u *pSrc, int srcStep, Fw8u *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiCopy_8u_C1C4R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiCopy_8u_C1C4R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiCopy_8u_C1C4R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiCopy_8u_C1C4R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiMirror_32s_C1R( const Fw32s *pSrc, int srcStep, Fw32s *pDst, int dstStep, FwiSize roiSize, FwiAxis flip)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiMirror_32s_C1R(pSrc, srcStep, pDst, dstStep, roiSize, flip);
    case DT_REFR:
        return _refr_fwiMirror_32s_C1R(pSrc, srcStep, pDst, dstStep, roiSize, flip);
    default:
        assert(false);
        return _refr_fwiMirror_32s_C1R(pSrc, srcStep, pDst, dstStep, roiSize, flip);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiMul_32sc_AC4RSfs( const Fw32sc *pSrc1, int src1Step, const Fw32sc *pSrc2,   int src2Step, Fw32sc *pDst, int dstStep, FwiSize roiSize, int scaleFactor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiMul_32sc_AC4RSfs(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, scaleFactor);
    case DT_SSE2:
        return _sse2_fwiMul_32sc_AC4RSfs(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, scaleFactor);
    case DT_REFR:
        return _refr_fwiMul_32sc_AC4RSfs(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, scaleFactor);
    default:
        assert(false);
        return _refr_fwiMul_32sc_AC4RSfs(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiThreshold_8u_C1IR( Fw8u *pSrcDst, int srcDstStep, FwiSize roiSize, Fw8u threshold, FwCmpOp fwCmpOp)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiThreshold_8u_C1IR(pSrcDst, srcDstStep, roiSize, threshold, fwCmpOp);
    case DT_SSE2:
        return _sse2_fwiThreshold_8u_C1IR(pSrcDst, srcDstStep, roiSize, threshold, fwCmpOp);
    case DT_REFR:
        return _refr_fwiThreshold_8u_C1IR(pSrcDst, srcDstStep, roiSize, threshold, fwCmpOp);
    default:
        assert(false);
        return _refr_fwiThreshold_8u_C1IR(pSrcDst, srcDstStep, roiSize, threshold, fwCmpOp);
    }
}

OREFR OSSE2 OF10H   FwStatus fwiYUVToRGB_8u_AC4R( const Fw8u *pSrc, int srcStep, Fw8u *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiYUVToRGB_8u_AC4R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiYUVToRGB_8u_AC4R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiYUVToRGB_8u_AC4R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiYUVToRGB_8u_AC4R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiRotate_8u_C1R( const Fw8u* pSrc, FwiSize srcSize, int srcStep, FwiRect srcRoi, Fw8u* pDst, int dstStep, FwiRect dstRoi, double angle, double xShift, double yShift, int interpolation )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiRotate_8u_C1R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, angle, xShift, yShift, interpolation);
    case DT_REFR:
        return _refr_fwiRotate_8u_C1R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, angle, xShift, yShift, interpolation);
    default:
        assert(false);
        return _refr_fwiRotate_8u_C1R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, angle, xShift, yShift, interpolation);
    }
}


OREFR OSSE2       FwStatus STDCALL fwiFilterBox_8u_C1IR( Fw8u * pSrcDst, int srcDstStep,
                               FwiSize dstRoiSize, FwiSize maskSize, FwiPoint anchor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilterBox_8u_C1IR(pSrcDst, srcDstStep, dstRoiSize, maskSize, anchor);
    case DT_REFR:
        return _refr_fwiFilterBox_8u_C1IR(pSrcDst, srcDstStep, dstRoiSize, maskSize, anchor);
    default:
        assert(false);
        return _refr_fwiFilterBox_8u_C1IR(pSrcDst, srcDstStep, dstRoiSize, maskSize, anchor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiAnd_16u_C3R( const Fw16u *pSrc1, int src1Step, const Fw16u *pSrc2,   int src2Step, Fw16u *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiAnd_16u_C3R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiAnd_16u_C3R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiAnd_16u_C3R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiAnd_16u_C3R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiFilterGauss_32f_C1R( const Fw32f * pSrc, int srcStep, Fw32f * pDst, int dstStep, FwiSize dstRoiSize, FwiMaskSize maskSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilterGauss_32f_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize);
    case DT_REFR:
        return _refr_fwiFilterGauss_32f_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize);
    default:
        assert(false);
        return _refr_fwiFilterGauss_32f_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiCompareC_16s_C3R( const Fw16s *pSrc, int srcStep, const Fw16s value[3], Fw8u *pDst, int dstStep, FwiSize roiSize, FwCmpOp fwCmpOp )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiCompareC_16s_C3R(pSrc, srcStep, value, pDst, dstStep, roiSize, fwCmpOp);
    case DT_SSE2:
        return _sse2_fwiCompareC_16s_C3R(pSrc, srcStep, value, pDst, dstStep, roiSize, fwCmpOp);
    case DT_REFR:
        return _refr_fwiCompareC_16s_C3R(pSrc, srcStep, value, pDst, dstStep, roiSize, fwCmpOp);
    default:
        assert(false);
        return _refr_fwiCompareC_16s_C3R(pSrc, srcStep, value, pDst, dstStep, roiSize, fwCmpOp);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiSqr_32f_AC4IR(       Fw32f *pSrcDst, int srcDstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiSqr_32f_AC4IR(pSrcDst, srcDstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiSqr_32f_AC4IR(pSrcDst, srcDstStep, roiSize);
    case DT_REFR:
        return _refr_fwiSqr_32f_AC4IR(pSrcDst, srcDstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiSqr_32f_AC4IR(pSrcDst, srcDstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiSet_8u_C3MR( const Fw8u  value[3], Fw8u  * pDst, int dstStep, FwiSize roiSize, const Fw8u * pMask, int maskStep )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiSet_8u_C3MR(value, pDst, dstStep, roiSize, pMask, maskStep);
    case DT_SSE2:
        return _sse2_fwiSet_8u_C3MR(value, pDst, dstStep, roiSize, pMask, maskStep);
    case DT_REFR:
        return _refr_fwiSet_8u_C3MR(value, pDst, dstStep, roiSize, pMask, maskStep);
    default:
        assert(false);
        return _refr_fwiSet_8u_C3MR(value, pDst, dstStep, roiSize, pMask, maskStep);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiThreshold_16s_C1IR( Fw16s *pSrcDst, int srcDstStep, FwiSize roiSize, Fw16s threshold, FwCmpOp fwCmpOp)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiThreshold_16s_C1IR(pSrcDst, srcDstStep, roiSize, threshold, fwCmpOp);
    case DT_SSE2:
        return _sse2_fwiThreshold_16s_C1IR(pSrcDst, srcDstStep, roiSize, threshold, fwCmpOp);
    case DT_REFR:
        return _refr_fwiThreshold_16s_C1IR(pSrcDst, srcDstStep, roiSize, threshold, fwCmpOp);
    default:
        assert(false);
        return _refr_fwiThreshold_16s_C1IR(pSrcDst, srcDstStep, roiSize, threshold, fwCmpOp);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiAdd_8s32f_C1IMR( const Fw8s  *pSrc, int srcStep, const Fw8u *pMask, int maskStep, Fw32f *pSrcDst, int srcDstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiAdd_8s32f_C1IMR(pSrc, srcStep, pMask, maskStep, pSrcDst, srcDstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiAdd_8s32f_C1IMR(pSrc, srcStep, pMask, maskStep, pSrcDst, srcDstStep, roiSize);
    case DT_REFR:
        return _refr_fwiAdd_8s32f_C1IMR(pSrc, srcStep, pMask, maskStep, pSrcDst, srcDstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiAdd_8s32f_C1IMR(pSrc, srcStep, pMask, maskStep, pSrcDst, srcDstStep, roiSize);
    }
}

OREFR OSSE2 FwStatus STDCALL fwiWarpAffineBack_8u_C4R( const Fw8u* pSrc, FwiSize srcSize, int srcStep,
								FwiRect srcRoi, Fw8u* pDst, int dstStep, FwiRect dstRoi,
								const double coeffs[2][3], int interpolation )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiWarpAffineBack_8u_C4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, coeffs, interpolation);
    case DT_REFR:
        return _refr_fwiWarpAffineBack_8u_C4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, coeffs, interpolation);
    default:
        assert(false);
        return _refr_fwiWarpAffineBack_8u_C4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, coeffs, interpolation);
    }
}

OREFR               FwStatus fwiYCbCr411ToBGR_8u_P3C4R(const A8U* const pSrc[3], int srcStep[3], A8U* pDst, int dstStep, FwiSize roiSize, A8U aval )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiYCbCr411ToBGR_8u_P3C4R(pSrc, srcStep, pDst, dstStep, roiSize, aval);
    default:
        assert(false);
        return _refr_fwiYCbCr411ToBGR_8u_P3C4R(pSrc, srcStep, pDst, dstStep, roiSize, aval);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiMul_8u_C4RSfs( const Fw8u   *pSrc1, int src1Step, const Fw8u   *pSrc2,   int src2Step, Fw8u *pDst, int dstStep, FwiSize roiSize, int scaleFactor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiMul_8u_C4RSfs(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, scaleFactor);
    case DT_SSE2:
        return _sse2_fwiMul_8u_C4RSfs(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, scaleFactor);
    case DT_REFR:
        return _refr_fwiMul_8u_C4RSfs(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, scaleFactor);
    default:
        assert(false);
        return _refr_fwiMul_8u_C4RSfs(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, scaleFactor);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiFilterBox_32f_C4IR( Fw32f * pSrcDst, int srcDstStep,
                               FwiSize dstRoiSize, FwiSize maskSize, FwiPoint anchor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilterBox_32f_C4IR(pSrcDst, srcDstStep, dstRoiSize, maskSize, anchor);
    case DT_REFR:
        return _refr_fwiFilterBox_32f_C4IR(pSrcDst, srcDstStep, dstRoiSize, maskSize, anchor);
    default:
        assert(false);
        return _refr_fwiFilterBox_32f_C4IR(pSrcDst, srcDstStep, dstRoiSize, maskSize, anchor);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiMirror_16u_C4IR(Fw16u *pSrcDst, int srcDstStep, FwiSize roiSize, FwiAxis flip)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiMirror_16u_C4IR(pSrcDst, srcDstStep, roiSize, flip);
    case DT_REFR:
        return _refr_fwiMirror_16u_C4IR(pSrcDst, srcDstStep, roiSize, flip);
    default:
        assert(false);
        return _refr_fwiMirror_16u_C4IR(pSrcDst, srcDstStep, roiSize, flip);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiSubC_8u_C4IRSfs( const Fw8u value[4], Fw8u *pSrcDst, int srcDstStep, FwiSize roiSize, int scaleFactor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiSubC_8u_C4IRSfs(value, pSrcDst, srcDstStep, roiSize, scaleFactor);
    case DT_SSE2:
        return _sse2_fwiSubC_8u_C4IRSfs(value, pSrcDst, srcDstStep, roiSize, scaleFactor);
    case DT_REFR:
        return _refr_fwiSubC_8u_C4IRSfs(value, pSrcDst, srcDstStep, roiSize, scaleFactor);
    default:
        assert(false);
        return _refr_fwiSubC_8u_C4IRSfs(value, pSrcDst, srcDstStep, roiSize, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiConvert_32s8s_C1R( const Fw32s *pSrc, int srcStep, Fw8s *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiConvert_32s8s_C1R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiConvert_32s8s_C1R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiConvert_32s8s_C1R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiConvert_32s8s_C1R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiSubC_16sc_C1IRSfs(       Fw16sc value,    Fw16sc *pSrcDst, int srcDstStep, FwiSize roiSize, int scaleFactor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiSubC_16sc_C1IRSfs(value, pSrcDst, srcDstStep, roiSize, scaleFactor);
    case DT_SSE2:
        return _sse2_fwiSubC_16sc_C1IRSfs(value, pSrcDst, srcDstStep, roiSize, scaleFactor);
    case DT_REFR:
        return _refr_fwiSubC_16sc_C1IRSfs(value, pSrcDst, srcDstStep, roiSize, scaleFactor);
    default:
        assert(false);
        return _refr_fwiSubC_16sc_C1IRSfs(value, pSrcDst, srcDstStep, roiSize, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiAddWeighted_32f_C1IMR( const Fw32f *pSrc, int srcStep, const Fw8u* pMask, int maskStep, Fw32f* pSrcDst, int srcDstStep, FwiSize roiSize, Fw32f alpha)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiAddWeighted_32f_C1IMR(pSrc, srcStep, pMask, maskStep, pSrcDst, srcDstStep, roiSize, alpha);
    case DT_SSE2:
        return _sse2_fwiAddWeighted_32f_C1IMR(pSrc, srcStep, pMask, maskStep, pSrcDst, srcDstStep, roiSize, alpha);
    case DT_REFR:
        return _refr_fwiAddWeighted_32f_C1IMR(pSrc, srcStep, pMask, maskStep, pSrcDst, srcDstStep, roiSize, alpha);
    default:
        assert(false);
        return _refr_fwiAddWeighted_32f_C1IMR(pSrc, srcStep, pMask, maskStep, pSrcDst, srcDstStep, roiSize, alpha);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiDiv_8u_C3RSfs( const Fw8u   *pSrc1, int src1Step, const Fw8u   *pSrc2,   int src2Step, Fw8u   *pDst, int dstStep, FwiSize roiSize, int scaleFactor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiDiv_8u_C3RSfs(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, scaleFactor);
    case DT_SSE2:
        return _sse2_fwiDiv_8u_C3RSfs(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, scaleFactor);
    case DT_REFR:
        return _refr_fwiDiv_8u_C3RSfs(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, scaleFactor);
    default:
        assert(false);
        return _refr_fwiDiv_8u_C3RSfs(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, scaleFactor);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiFilterBox_8u_C3IR( Fw8u * pSrcDst, int srcDstStep,
                               FwiSize dstRoiSize, FwiSize maskSize, FwiPoint anchor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilterBox_8u_C3IR(pSrcDst, srcDstStep, dstRoiSize, maskSize, anchor);
    case DT_REFR:
        return _refr_fwiFilterBox_8u_C3IR(pSrcDst, srcDstStep, dstRoiSize, maskSize, anchor);
    default:
        assert(false);
        return _refr_fwiFilterBox_8u_C3IR(pSrcDst, srcDstStep, dstRoiSize, maskSize, anchor);
    }
}

OREFR OSSE2         FwStatus fwiMin_32f_C4R(const Fw32f* pSrc, int srcStep,FwiSize roiSize, Fw32f min[4])
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiMin_32f_C4R(pSrc, srcStep, roiSize, min);
    case DT_REFR:
        return _refr_fwiMin_32f_C4R(pSrc, srcStep, roiSize, min);
    default:
        assert(false);
        return _refr_fwiMin_32f_C4R(pSrc, srcStep, roiSize, min);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiSet_32s_C3MR( const Fw32s  value[3], Fw32s  * pDst, int dstStep, FwiSize roiSize, const Fw8u * pMask, int maskStep )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiSet_32s_C3MR(value, pDst, dstStep, roiSize, pMask, maskStep);
    case DT_SSE2:
        return _sse2_fwiSet_32s_C3MR(value, pDst, dstStep, roiSize, pMask, maskStep);
    case DT_REFR:
        return _refr_fwiSet_32s_C3MR(value, pDst, dstStep, roiSize, pMask, maskStep);
    default:
        assert(false);
        return _refr_fwiSet_32s_C3MR(value, pDst, dstStep, roiSize, pMask, maskStep);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiAdd_16sc_C1IRSfs( const Fw16sc *pSrc,  int srcStep,        Fw16sc *pSrcDst, int srcDstStep, FwiSize roiSize, int scaleFactor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiAdd_16sc_C1IRSfs(pSrc, srcStep, pSrcDst, srcDstStep, roiSize, scaleFactor);
    case DT_SSE2:
        return _sse2_fwiAdd_16sc_C1IRSfs(pSrc, srcStep, pSrcDst, srcDstStep, roiSize, scaleFactor);
    case DT_REFR:
        return _refr_fwiAdd_16sc_C1IRSfs(pSrc, srcStep, pSrcDst, srcDstStep, roiSize, scaleFactor);
    default:
        assert(false);
        return _refr_fwiAdd_16sc_C1IRSfs(pSrc, srcStep, pSrcDst, srcDstStep, roiSize, scaleFactor);
    }
}

OREFR       FwStatus STDCALL fwiShear_32f_P4R(const Fw32f* const pSrc[4], FwiSize srcSize, int srcStep, FwiRect srcRoi, Fw32f* const pDst[4], int dstStep, FwiRect dstRoi, double xShear, double yShear, double xShift, double yShift, int interpolation)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiShear_32f_P4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, xShear, yShear, xShift, yShift, interpolation);
    default:
        assert(false);
        return _refr_fwiShear_32f_P4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, xShear, yShear, xShift, yShift, interpolation);
    }
}

OREFR OSSE2         FwStatus fwiColorToGray_32f_C3C1R(const Fw32f* pSrc, int srcStep, Fw32f* pDst, int dstStep, FwiSize roiSize, const Fw32f coeffs[3])
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiColorToGray_32f_C3C1R(pSrc, srcStep, pDst, dstStep, roiSize, coeffs);
    case DT_REFR:
        return _refr_fwiColorToGray_32f_C3C1R(pSrc, srcStep, pDst, dstStep, roiSize, coeffs);
    default:
        assert(false);
        return _refr_fwiColorToGray_32f_C3C1R(pSrc, srcStep, pDst, dstStep, roiSize, coeffs);
    }
}

OREFR               FwStatus fwiYCbCrToBGR565_8u16u_C3R(const A8U* pSrc, int srcStep, A16U* pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiYCbCrToBGR565_8u16u_C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiYCbCrToBGR565_8u16u_C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiFilterMedianVert_8u_C3R( const Fw8u * pSrc, int srcStep,
                                               Fw8u * pDst, int dstStep, FwiSize dstRoiSize,
                                               FwiMaskSize maskSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilterMedianVert_8u_C3R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize);
    case DT_REFR:
        return _refr_fwiFilterMedianVert_8u_C3R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize);
    default:
        assert(false);
        return _refr_fwiFilterMedianVert_8u_C3R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiMulScale_8u_AC4R(  const Fw8u  *pSrc1, int src1Step, const Fw8u  *pSrc2, int src2Step, Fw8u  *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiMulScale_8u_AC4R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiMulScale_8u_AC4R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiMulScale_8u_AC4R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiMulScale_8u_AC4R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiThreshold_LTVal_16s_C3R( const Fw16s *pSrc, int srcStep, Fw16s *pDst, int dstStep, FwiSize roiSize, const Fw16s threshold[3], const Fw16s value[3])
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiThreshold_LTVal_16s_C3R(pSrc, srcStep, pDst, dstStep, roiSize, threshold, value);
    case DT_SSE2:
        return _sse2_fwiThreshold_LTVal_16s_C3R(pSrc, srcStep, pDst, dstStep, roiSize, threshold, value);
    case DT_REFR:
        return _refr_fwiThreshold_LTVal_16s_C3R(pSrc, srcStep, pDst, dstStep, roiSize, threshold, value);
    default:
        assert(false);
        return _refr_fwiThreshold_LTVal_16s_C3R(pSrc, srcStep, pDst, dstStep, roiSize, threshold, value);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiRemap_8u_C1R( const Fw8u* pSrc, FwiSize srcSize, int srcStep, FwiRect srcRoi, const Fw32f* pxMap, int xMapStep, const Fw32f* pyMap, int yMapStep, Fw8u* pDst, int dstStep, FwiSize dstRoiSize, int interpolation )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiRemap_8u_C1R(pSrc, srcSize, srcStep, srcRoi, pxMap, xMapStep, pyMap, yMapStep, pDst, dstStep, dstRoiSize, interpolation);
    case DT_REFR:
        return _refr_fwiRemap_8u_C1R(pSrc, srcSize, srcStep, srcRoi, pxMap, xMapStep, pyMap, yMapStep, pDst, dstStep, dstRoiSize, interpolation);
    default:
        assert(false);
        return _refr_fwiRemap_8u_C1R(pSrc, srcSize, srcStep, srcRoi, pxMap, xMapStep, pyMap, yMapStep, pDst, dstStep, dstRoiSize, interpolation);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiFilterPrewittVert_16s_C1R( const Fw16s * pSrc, int srcStep, Fw16s * pDst, int dstStep, FwiSize dstRoiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilterPrewittVert_16s_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize);
    case DT_REFR:
        return _refr_fwiFilterPrewittVert_16s_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize);
    default:
        assert(false);
        return _refr_fwiFilterPrewittVert_16s_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiThreshold_GTVal_16s_C1R( const Fw16s *pSrc, int srcStep, Fw16s *pDst, int dstStep, FwiSize roiSize, Fw16s threshold, Fw16s value)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiThreshold_GTVal_16s_C1R(pSrc, srcStep, pDst, dstStep, roiSize, threshold, value);
    case DT_SSE2:
        return _sse2_fwiThreshold_GTVal_16s_C1R(pSrc, srcStep, pDst, dstStep, roiSize, threshold, value);
    case DT_REFR:
        return _refr_fwiThreshold_GTVal_16s_C1R(pSrc, srcStep, pDst, dstStep, roiSize, threshold, value);
    default:
        assert(false);
        return _refr_fwiThreshold_GTVal_16s_C1R(pSrc, srcStep, pDst, dstStep, roiSize, threshold, value);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiFilterHipass_8u_AC4R( const Fw8u * pSrc, int srcStep, Fw8u * pDst, int dstStep, FwiSize dstRoiSize, FwiMaskSize maskSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilterHipass_8u_AC4R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize);
    case DT_REFR:
        return _refr_fwiFilterHipass_8u_AC4R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize);
    default:
        assert(false);
        return _refr_fwiFilterHipass_8u_AC4R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize);
    }
}

OREFR OSSE2 FwStatus STDCALL fwiResizeShift_16u_C3R( const Fw16u* pSrc, FwiSize srcSize, int srcStep, FwiRect srcRoi,
								  Fw16u* pDst, int dstStep, FwiSize dstRoiSize,
								  double xFr, double yFr, double xShift, double yShift, int interpolation )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiResizeShift_16u_C3R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoiSize, xFr, yFr, xShift, yShift, interpolation);
    case DT_REFR:
        return _refr_fwiResizeShift_16u_C3R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoiSize, xFr, yFr, xShift, yShift, interpolation);
    default:
        assert(false);
        return _refr_fwiResizeShift_16u_C3R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoiSize, xFr, yFr, xShift, yShift, interpolation);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiMulCScale_16u_C3IR( const Fw16u value[3], Fw16u *pSrcDst, int srcDstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiMulCScale_16u_C3IR(value, pSrcDst, srcDstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiMulCScale_16u_C3IR(value, pSrcDst, srcDstStep, roiSize);
    case DT_REFR:
        return _refr_fwiMulCScale_16u_C3IR(value, pSrcDst, srcDstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiMulCScale_16u_C3IR(value, pSrcDst, srcDstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiDivC_16sc_C1IRSfs(       Fw16sc value,    Fw16sc *pSrcDst, int srcDstStep, FwiSize roiSize, int scaleFactor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiDivC_16sc_C1IRSfs(value, pSrcDst, srcDstStep, roiSize, scaleFactor);
    case DT_SSE2:
        return _sse2_fwiDivC_16sc_C1IRSfs(value, pSrcDst, srcDstStep, roiSize, scaleFactor);
    case DT_REFR:
        return _refr_fwiDivC_16sc_C1IRSfs(value, pSrcDst, srcDstStep, roiSize, scaleFactor);
    default:
        assert(false);
        return _refr_fwiDivC_16sc_C1IRSfs(value, pSrcDst, srcDstStep, roiSize, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiSet_8u_C4R( const Fw8u  value[4], Fw8u  * pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiSet_8u_C4R(value, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiSet_8u_C4R(value, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiSet_8u_C4R(value, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiSet_8u_C4R(value, pDst, dstStep, roiSize);
    }
}

OREFR             FwStatus STDCALL fwiScale_32f8u_AC4R( const Fw32f * pSrc, int srcStep, Fw8u * pDst, int dstStep, FwiSize roiSize, Fw32f vMin, Fw32f vMax )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiScale_32f8u_AC4R(pSrc, srcStep, pDst, dstStep, roiSize, vMin, vMax);
    default:
        assert(false);
        return _refr_fwiScale_32f8u_AC4R(pSrc, srcStep, pDst, dstStep, roiSize, vMin, vMax);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiFilterSobelVert_8u_C4R( const Fw8u * pSrc, int srcStep, Fw8u * pDst, int dstStep, FwiSize dstRoiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilterSobelVert_8u_C4R(pSrc, srcStep, pDst, dstStep, dstRoiSize);
    case DT_REFR:
        return _refr_fwiFilterSobelVert_8u_C4R(pSrc, srcStep, pDst, dstStep, dstRoiSize);
    default:
        assert(false);
        return _refr_fwiFilterSobelVert_8u_C4R(pSrc, srcStep, pDst, dstStep, dstRoiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiSqr_16u_C3RSfs( const Fw16u *pSrc,    int srcStep, Fw16u *pDst, int dstStep, FwiSize roiSize, int scaleFactor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiSqr_16u_C3RSfs(pSrc, srcStep, pDst, dstStep, roiSize, scaleFactor);
    case DT_SSE2:
        return _sse2_fwiSqr_16u_C3RSfs(pSrc, srcStep, pDst, dstStep, roiSize, scaleFactor);
    case DT_REFR:
        return _refr_fwiSqr_16u_C3RSfs(pSrc, srcStep, pDst, dstStep, roiSize, scaleFactor);
    default:
        assert(false);
        return _refr_fwiSqr_16u_C3RSfs(pSrc, srcStep, pDst, dstStep, roiSize, scaleFactor);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiFilterColumn32f_8u_AC4R( const Fw8u * pSrc, int srcStep,
                                Fw8u * pDst, int dstStep, FwiSize dstRoiSize,
                                const Fw32f * pKernel, int kernelSize,
                                int yAnchor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilterColumn32f_8u_AC4R(pSrc, srcStep, pDst, dstStep, dstRoiSize, pKernel, kernelSize, yAnchor);
    case DT_REFR:
        return _refr_fwiFilterColumn32f_8u_AC4R(pSrc, srcStep, pDst, dstStep, dstRoiSize, pKernel, kernelSize, yAnchor);
    default:
        assert(false);
        return _refr_fwiFilterColumn32f_8u_AC4R(pSrc, srcStep, pDst, dstStep, dstRoiSize, pKernel, kernelSize, yAnchor);
    }
}

OREFR OSSE2 OF10H   FwStatus fwiYUVToRGB_8u_P3R( const Fw8u * const pSrc[3], int srcStep, Fw8u *pDst[3], int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiYUVToRGB_8u_P3R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiYUVToRGB_8u_P3R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiYUVToRGB_8u_P3R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiYUVToRGB_8u_P3R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiRShiftC_8u_C4R( const Fw8u   *pSrc, int srcStep, const Fw32u value[4], Fw8u *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiRShiftC_8u_C4R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiRShiftC_8u_C4R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiRShiftC_8u_C4R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiRShiftC_8u_C4R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiOr_8u_C1R( const Fw8u *pSrc1, int src1Step, const Fw8u *pSrc2,   int src2Step, Fw8u *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiOr_8u_C1R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiOr_8u_C1R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiOr_8u_C1R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiOr_8u_C1R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiAndC_8u_C3IR( const Fw8u value[3], Fw8u *pSrcDst, int srcDstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiAndC_8u_C3IR(value, pSrcDst, srcDstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiAndC_8u_C3IR(value, pSrcDst, srcDstStep, roiSize);
    case DT_REFR:
        return _refr_fwiAndC_8u_C3IR(value, pSrcDst, srcDstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiAndC_8u_C3IR(value, pSrcDst, srcDstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiXorC_8u_C1R( const Fw8u   *pSrc, int srcStep,       Fw8u value,    Fw8u *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiXorC_8u_C1R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiXorC_8u_C1R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiXorC_8u_C1R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiXorC_8u_C1R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2         FwStatus fwiMinMax_16s_C1R(const Fw16s* pSrc, int srcStep,FwiSize roiSize, Fw16s* pMin, Fw16s* pMax)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiMinMax_16s_C1R(pSrc, srcStep, roiSize, pMin, pMax);
    case DT_REFR:
        return _refr_fwiMinMax_16s_C1R(pSrc, srcStep, roiSize, pMin, pMax);
    default:
        assert(false);
        return _refr_fwiMinMax_16s_C1R(pSrc, srcStep, roiSize, pMin, pMax);
    }
}

OREFR               FwStatus fwiRGBToYCC_16s_C3R( const Fw16s* pSrc, int srcStep, Fw16s* pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiRGBToYCC_16s_C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiRGBToYCC_16s_C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiCopy_16s_C4P4R( const Fw16s *pSrc, int srcStep, Fw16s * const pDst[4], int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiCopy_16s_C4P4R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiCopy_16s_C4P4R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiCopy_16s_C4P4R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiCopy_16s_C4P4R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiThreshold_GT_32f_C3IR( Fw32f *pSrcDst, int srcDstStep, FwiSize roiSize, const Fw32f threshold[3])
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiThreshold_GT_32f_C3IR(pSrcDst, srcDstStep, roiSize, threshold);
    case DT_SSE2:
        return _sse2_fwiThreshold_GT_32f_C3IR(pSrcDst, srcDstStep, roiSize, threshold);
    case DT_REFR:
        return _refr_fwiThreshold_GT_32f_C3IR(pSrcDst, srcDstStep, roiSize, threshold);
    default:
        assert(false);
        return _refr_fwiThreshold_GT_32f_C3IR(pSrcDst, srcDstStep, roiSize, threshold);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiSumWindowRow_16s32f_C3R( const Fw16s * pSrc, int srcStep,
                               Fw32f * pDst, int dstStep, FwiSize dstRoiSize,
                               int maskSize, int anchor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiSumWindowRow_16s32f_C3R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize, anchor);
    case DT_REFR:
        return _refr_fwiSumWindowRow_16s32f_C3R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize, anchor);
    default:
        assert(false);
        return _refr_fwiSumWindowRow_16s32f_C3R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize, anchor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiSub_8u_C4IRSfs( const Fw8u   *pSrc,  int srcStep,        Fw8u   *pSrcDst, int srcDstStep, FwiSize roiSize, int scaleFactor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiSub_8u_C4IRSfs(pSrc, srcStep, pSrcDst, srcDstStep, roiSize, scaleFactor);
    case DT_SSE2:
        return _sse2_fwiSub_8u_C4IRSfs(pSrc, srcStep, pSrcDst, srcDstStep, roiSize, scaleFactor);
    case DT_REFR:
        return _refr_fwiSub_8u_C4IRSfs(pSrc, srcStep, pSrcDst, srcDstStep, roiSize, scaleFactor);
    default:
        assert(false);
        return _refr_fwiSub_8u_C4IRSfs(pSrc, srcStep, pSrcDst, srcDstStep, roiSize, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiMulC_16sc_C3RSfs( const Fw16sc *pSrc, int srcStep, const Fw16sc value[3], Fw16sc *pDst, int dstStep, FwiSize roiSize, int scaleFactor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiMulC_16sc_C3RSfs(pSrc, srcStep, value, pDst, dstStep, roiSize, scaleFactor);
    case DT_SSE2:
        return _sse2_fwiMulC_16sc_C3RSfs(pSrc, srcStep, value, pDst, dstStep, roiSize, scaleFactor);
    case DT_REFR:
        return _refr_fwiMulC_16sc_C3RSfs(pSrc, srcStep, value, pDst, dstStep, roiSize, scaleFactor);
    default:
        assert(false);
        return _refr_fwiMulC_16sc_C3RSfs(pSrc, srcStep, value, pDst, dstStep, roiSize, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiAddWeighted_8s32f_C1IMR( const Fw8s *pSrc,  int srcStep,  const Fw8u* pMask, int maskStep, Fw32f* pSrcDst, int srcDstStep, FwiSize roiSize, Fw32f alpha)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiAddWeighted_8s32f_C1IMR(pSrc, srcStep, pMask, maskStep, pSrcDst, srcDstStep, roiSize, alpha);
    case DT_SSE2:
        return _sse2_fwiAddWeighted_8s32f_C1IMR(pSrc, srcStep, pMask, maskStep, pSrcDst, srcDstStep, roiSize, alpha);
    case DT_REFR:
        return _refr_fwiAddWeighted_8s32f_C1IMR(pSrc, srcStep, pMask, maskStep, pSrcDst, srcDstStep, roiSize, alpha);
    default:
        assert(false);
        return _refr_fwiAddWeighted_8s32f_C1IMR(pSrc, srcStep, pMask, maskStep, pSrcDst, srcDstStep, roiSize, alpha);
    }
}

OREFR             FwStatus STDCALL fwiConvert_8u16u_AC4R( const Fw8u *pSrc, int srcStep, Fw16u *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiConvert_8u16u_AC4R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiConvert_8u16u_AC4R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiCopy_32s_C4R( const Fw32s *pSrc, int srcStep, Fw32s *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiCopy_32s_C4R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiCopy_32s_C4R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiCopy_32s_C4R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiCopy_32s_C4R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiAddWeighted_32f_C1IR( const Fw32f *pSrc, int srcStep, Fw32f* pSrcDst, int srcDstStep, FwiSize roiSize, Fw32f alpha)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiAddWeighted_32f_C1IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize, alpha);
    case DT_SSE2:
        return _sse2_fwiAddWeighted_32f_C1IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize, alpha);
    case DT_REFR:
        return _refr_fwiAddWeighted_32f_C1IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize, alpha);
    default:
        assert(false);
        return _refr_fwiAddWeighted_32f_C1IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize, alpha);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiSet_8u_C3CR(       Fw8u  value,    Fw8u  * pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiSet_8u_C3CR(value, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiSet_8u_C3CR(value, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiSet_8u_C3CR(value, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiSet_8u_C3CR(value, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiSumWindowColumn_16s32f_C1R( const Fw16s * pSrc, int srcStep,
                               Fw32f * pDst, int dstStep, FwiSize dstRoiSize,
                               int maskSize, int anchor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiSumWindowColumn_16s32f_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize, anchor);
    case DT_REFR:
        return _refr_fwiSumWindowColumn_16s32f_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize, anchor);
    default:
        assert(false);
        return _refr_fwiSumWindowColumn_16s32f_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize, anchor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiLn_16s_C1IRSfs(       Fw16s *pSrcDst,  int srcDstStep, FwiSize roiSize, int scaleFactor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiLn_16s_C1IRSfs(pSrcDst, srcDstStep, roiSize, scaleFactor);
    case DT_SSE2:
        return _sse2_fwiLn_16s_C1IRSfs(pSrcDst, srcDstStep, roiSize, scaleFactor);
    case DT_REFR:
        return _refr_fwiLn_16s_C1IRSfs(pSrcDst, srcDstStep, roiSize, scaleFactor);
    default:
        assert(false);
        return _refr_fwiLn_16s_C1IRSfs(pSrcDst, srcDstStep, roiSize, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiCopy_32s_C3MR( const Fw32s *pSrc, int srcStep, Fw32s *pDst, int dstStep, FwiSize roiSize, const Fw8u *pMask, int maskStep )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiCopy_32s_C3MR(pSrc, srcStep, pDst, dstStep, roiSize, pMask, maskStep);
    case DT_SSE2:
        return _sse2_fwiCopy_32s_C3MR(pSrc, srcStep, pDst, dstStep, roiSize, pMask, maskStep);
    case DT_REFR:
        return _refr_fwiCopy_32s_C3MR(pSrc, srcStep, pDst, dstStep, roiSize, pMask, maskStep);
    default:
        assert(false);
        return _refr_fwiCopy_32s_C3MR(pSrc, srcStep, pDst, dstStep, roiSize, pMask, maskStep);
    }
}


OREFR OSSE2         FwStatus fwiMax_8u_C4R(const Fw8u* pSrc, int srcStep,FwiSize roiSize, Fw8u max[4])
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiMax_8u_C4R(pSrc, srcStep, roiSize, max);
    case DT_REFR:
        return _refr_fwiMax_8u_C4R(pSrc, srcStep, roiSize, max);
    default:
        assert(false);
        return _refr_fwiMax_8u_C4R(pSrc, srcStep, roiSize, max);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiFilterSobelVert_8u16s_C1R( const Fw8u * pSrc, int srcStep, Fw16s * pDst, int dstStep, FwiSize dstRoiSize, FwiMaskSize mask )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilterSobelVert_8u16s_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize, mask);
    case DT_REFR:
        return _refr_fwiFilterSobelVert_8u16s_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize, mask);
    default:
        assert(false);
        return _refr_fwiFilterSobelVert_8u16s_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize, mask);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiFilterRow_8u_C4R( const Fw8u * pSrc, int srcStep,
                             Fw8u * pDst, int dstStep, FwiSize dstRoiSize,
                             const Fw32s * pKernel, int kernelSize,
                             int xAnchor, int divisor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilterRow_8u_C4R(pSrc, srcStep, pDst, dstStep, dstRoiSize, pKernel, kernelSize, xAnchor, divisor);
    case DT_REFR:
        return _refr_fwiFilterRow_8u_C4R(pSrc, srcStep, pDst, dstStep, dstRoiSize, pKernel, kernelSize, xAnchor, divisor);
    default:
        assert(false);
        return _refr_fwiFilterRow_8u_C4R(pSrc, srcStep, pDst, dstStep, dstRoiSize, pKernel, kernelSize, xAnchor, divisor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiCopy_8u_AC4R( const Fw8u *pSrc, int srcStep, Fw8u *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiCopy_8u_AC4R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiCopy_8u_AC4R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiCopy_8u_AC4R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiCopy_8u_AC4R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiFilterRow_32f_AC4R( const Fw32f * pSrc, int srcStep,
                              Fw32f * pDst, int dstStep, FwiSize dstRoiSize,
                              const Fw32f * pKernel, int kernelSize,
                              int xAnchor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilterRow_32f_AC4R(pSrc, srcStep, pDst, dstStep, dstRoiSize, pKernel, kernelSize, xAnchor);
    case DT_REFR:
        return _refr_fwiFilterRow_32f_AC4R(pSrc, srcStep, pDst, dstStep, dstRoiSize, pKernel, kernelSize, xAnchor);
    default:
        assert(false);
        return _refr_fwiFilterRow_32f_AC4R(pSrc, srcStep, pDst, dstStep, dstRoiSize, pKernel, kernelSize, xAnchor);
    }
}


OREFR               FwStatus fwiHLSToBGR_8u_C3P3R(const A8U* pSrc, int srcStep, A8U* const pDst[3], int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiHLSToBGR_8u_C3P3R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiHLSToBGR_8u_C3P3R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}


OREFR OSSE2 FwStatus STDCALL fwiWarpPerspectiveBack_8u_C1R( const Fw8u* pSrc, FwiSize srcSize, int srcStep,
								FwiRect srcRoi, Fw8u* pDst, int dstStep, FwiRect dstRoi,
								const double coeffs[3][3], int interpolation )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiWarpPerspectiveBack_8u_C1R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, coeffs, interpolation);
    case DT_REFR:
        return _refr_fwiWarpPerspectiveBack_8u_C1R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, coeffs, interpolation);
    default:
        assert(false);
        return _refr_fwiWarpPerspectiveBack_8u_C1R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, coeffs, interpolation);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiConvert_8s32s_C1R( const Fw8s *pSrc, int srcStep, Fw32s *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiConvert_8s32s_C1R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiConvert_8s32s_C1R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiConvert_8s32s_C1R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiConvert_8s32s_C1R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiSqr_32f_C1R( const Fw32f *pSrc,    int srcStep, Fw32f *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiSqr_32f_C1R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiSqr_32f_C1R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiSqr_32f_C1R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiSqr_32f_C1R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiFilterSobelVert_32f_C4R( const Fw32f * pSrc, int srcStep, Fw32f * pDst, int dstStep, FwiSize dstRoiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilterSobelVert_32f_C4R(pSrc, srcStep, pDst, dstStep, dstRoiSize);
    case DT_REFR:
        return _refr_fwiFilterSobelVert_32f_C4R(pSrc, srcStep, pDst, dstStep, dstRoiSize);
    default:
        assert(false);
        return _refr_fwiFilterSobelVert_32f_C4R(pSrc, srcStep, pDst, dstStep, dstRoiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiAddProduct_8s32f_C1IR( const Fw8s *pSrc1, int src1Step, const Fw8s *pSrc2,   int src2Step, Fw32f *pSrcDst, int srcDstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiAddProduct_8s32f_C1IR(pSrc1, src1Step, pSrc2, src2Step, pSrcDst, srcDstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiAddProduct_8s32f_C1IR(pSrc1, src1Step, pSrc2, src2Step, pSrcDst, srcDstStep, roiSize);
    case DT_REFR:
        return _refr_fwiAddProduct_8s32f_C1IR(pSrc1, src1Step, pSrc2, src2Step, pSrcDst, srcDstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiAddProduct_8s32f_C1IR(pSrc1, src1Step, pSrc2, src2Step, pSrcDst, srcDstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiCopy_32s_C1MR( const Fw32s *pSrc, int srcStep, Fw32s *pDst, int dstStep, FwiSize roiSize, const Fw8u *pMask, int maskStep )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiCopy_32s_C1MR(pSrc, srcStep, pDst, dstStep, roiSize, pMask, maskStep);
    case DT_SSE2:
        return _sse2_fwiCopy_32s_C1MR(pSrc, srcStep, pDst, dstStep, roiSize, pMask, maskStep);
    case DT_REFR:
        return _refr_fwiCopy_32s_C1MR(pSrc, srcStep, pDst, dstStep, roiSize, pMask, maskStep);
    default:
        assert(false);
        return _refr_fwiCopy_32s_C1MR(pSrc, srcStep, pDst, dstStep, roiSize, pMask, maskStep);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiThreshold_GTVal_32f_C1R( const Fw32f *pSrc, int srcStep, Fw32f *pDst, int dstStep, FwiSize roiSize, Fw32f threshold, Fw32f value)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiThreshold_GTVal_32f_C1R(pSrc, srcStep, pDst, dstStep, roiSize, threshold, value);
    case DT_SSE2:
        return _sse2_fwiThreshold_GTVal_32f_C1R(pSrc, srcStep, pDst, dstStep, roiSize, threshold, value);
    case DT_REFR:
        return _refr_fwiThreshold_GTVal_32f_C1R(pSrc, srcStep, pDst, dstStep, roiSize, threshold, value);
    default:
        assert(false);
        return _refr_fwiThreshold_GTVal_32f_C1R(pSrc, srcStep, pDst, dstStep, roiSize, threshold, value);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiOr_8u_C1IR( const Fw8u	*pSrc,  int srcStep,        Fw8u *pSrcDst, int srcDstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiOr_8u_C1IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiOr_8u_C1IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    case DT_REFR:
        return _refr_fwiOr_8u_C1IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiOr_8u_C1IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    }
}

OREFR             FwStatus STDCALL fwiScale_32f8u_C4R( const Fw32f * pSrc, int srcStep, Fw8u * pDst, int dstStep, FwiSize roiSize, Fw32f vMin, Fw32f vMax )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiScale_32f8u_C4R(pSrc, srcStep, pDst, dstStep, roiSize, vMin, vMax);
    default:
        assert(false);
        return _refr_fwiScale_32f8u_C4R(pSrc, srcStep, pDst, dstStep, roiSize, vMin, vMax);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiAndC_16u_C1IR(       Fw16u value,    Fw16u *pSrcDst, int srcDstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiAndC_16u_C1IR(value, pSrcDst, srcDstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiAndC_16u_C1IR(value, pSrcDst, srcDstStep, roiSize);
    case DT_REFR:
        return _refr_fwiAndC_16u_C1IR(value, pSrcDst, srcDstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiAndC_16u_C1IR(value, pSrcDst, srcDstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiSubC_16sc_C3RSfs( const Fw16sc *pSrc, int srcStep, const Fw16sc value[3], Fw16sc *pDst, int dstStep, FwiSize roiSize, int scaleFactor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiSubC_16sc_C3RSfs(pSrc, srcStep, value, pDst, dstStep, roiSize, scaleFactor);
    case DT_SSE2:
        return _sse2_fwiSubC_16sc_C3RSfs(pSrc, srcStep, value, pDst, dstStep, roiSize, scaleFactor);
    case DT_REFR:
        return _refr_fwiSubC_16sc_C3RSfs(pSrc, srcStep, value, pDst, dstStep, roiSize, scaleFactor);
    default:
        assert(false);
        return _refr_fwiSubC_16sc_C3RSfs(pSrc, srcStep, value, pDst, dstStep, roiSize, scaleFactor);
    }
}

OREFR OSSE2         FwStatus fwiRGBToGray_16s_AC4C1R(const Fw16s* pSrc, int srcStep,Fw16s* pDst, int dstStep, FwiSize roiSize)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiRGBToGray_16s_AC4C1R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiRGBToGray_16s_AC4C1R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiRGBToGray_16s_AC4C1R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiCopy_16s_C4C1R( const Fw16s *pSrc, int srcStep, Fw16s *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiCopy_16s_C4C1R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiCopy_16s_C4C1R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiCopy_16s_C4C1R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiCopy_16s_C4C1R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiRShiftC_32s_C1IR(       Fw32u value,    Fw32s *pSrcDst, int srcDstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiRShiftC_32s_C1IR(value, pSrcDst, srcDstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiRShiftC_32s_C1IR(value, pSrcDst, srcDstStep, roiSize);
    case DT_REFR:
        return _refr_fwiRShiftC_32s_C1IR(value, pSrcDst, srcDstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiRShiftC_32s_C1IR(value, pSrcDst, srcDstStep, roiSize);
    }
}


OREFR OSSE2         FwStatus fwiYUV420ToRGB565_8u16u_P3C3R(const A8U* const pSrc[3], int srcStep[3], A16U* pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiYUV420ToRGB565_8u16u_P3C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiYUV420ToRGB565_8u16u_P3C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiYUV420ToRGB565_8u16u_P3C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiDivC_16s_AC4IRSfs( const Fw16s value[3], Fw16s *pSrcDst, int srcDstStep, FwiSize roiSize, int scaleFactor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiDivC_16s_AC4IRSfs(value, pSrcDst, srcDstStep, roiSize, scaleFactor);
    case DT_SSE2:
        return _sse2_fwiDivC_16s_AC4IRSfs(value, pSrcDst, srcDstStep, roiSize, scaleFactor);
    case DT_REFR:
        return _refr_fwiDivC_16s_AC4IRSfs(value, pSrcDst, srcDstStep, roiSize, scaleFactor);
    default:
        assert(false);
        return _refr_fwiDivC_16s_AC4IRSfs(value, pSrcDst, srcDstStep, roiSize, scaleFactor);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiFilterColumn_16s_C4R( const Fw16s * pSrc, int srcStep,
                              Fw16s * pDst, int dstStep, FwiSize dstRoiSize,
                              const Fw32s * pKernel, int kernelSize,
                              int yAnchor, int divisor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilterColumn_16s_C4R(pSrc, srcStep, pDst, dstStep, dstRoiSize, pKernel, kernelSize, yAnchor, divisor);
    case DT_REFR:
        return _refr_fwiFilterColumn_16s_C4R(pSrc, srcStep, pDst, dstStep, dstRoiSize, pKernel, kernelSize, yAnchor, divisor);
    default:
        assert(false);
        return _refr_fwiFilterColumn_16s_C4R(pSrc, srcStep, pDst, dstStep, dstRoiSize, pKernel, kernelSize, yAnchor, divisor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiRShiftC_8s_C3R( const Fw8s   *pSrc, int srcStep, const Fw32u value[3], Fw8s *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiRShiftC_8s_C3R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiRShiftC_8s_C3R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiRShiftC_8s_C3R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiRShiftC_8s_C3R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    }
}

OREFR               FwStatus fwiRGBToHSV_16u_C3R( const Fw16u* pSrc, int srcStep, Fw16u* pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiRGBToHSV_16u_C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiRGBToHSV_16u_C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiRemap_32f_P4R( const Fw32f* const pSrc[4], FwiSize srcSize, int srcStep, FwiRect srcRoi, const Fw32f* pxMap, int xMapStep, const Fw32f* pyMap, int yMapStep, Fw32f* const pDst[4], int dstStep, FwiSize dstRoiSize, int interpolation )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiRemap_32f_P4R(pSrc, srcSize, srcStep, srcRoi, pxMap, xMapStep, pyMap, yMapStep, pDst, dstStep, dstRoiSize, interpolation);
    case DT_REFR:
        return _refr_fwiRemap_32f_P4R(pSrc, srcSize, srcStep, srcRoi, pxMap, xMapStep, pyMap, yMapStep, pDst, dstStep, dstRoiSize, interpolation);
    default:
        assert(false);
        return _refr_fwiRemap_32f_P4R(pSrc, srcSize, srcStep, srcRoi, pxMap, xMapStep, pyMap, yMapStep, pDst, dstStep, dstRoiSize, interpolation);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiAddC_16s_C1IRSfs(       Fw16s value,    Fw16s *pSrcDst, int srcDstStep, FwiSize roiSize, int scaleFactor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiAddC_16s_C1IRSfs(value, pSrcDst, srcDstStep, roiSize, scaleFactor);
    case DT_SSE2:
        return _sse2_fwiAddC_16s_C1IRSfs(value, pSrcDst, srcDstStep, roiSize, scaleFactor);
    case DT_REFR:
        return _refr_fwiAddC_16s_C1IRSfs(value, pSrcDst, srcDstStep, roiSize, scaleFactor);
    default:
        assert(false);
        return _refr_fwiAddC_16s_C1IRSfs(value, pSrcDst, srcDstStep, roiSize, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiSet_16s_AC4MR( const Fw16s  value[3], Fw16s  * pDst, int dstStep, FwiSize roiSize, const Fw8u * pMask, int maskStep )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiSet_16s_AC4MR(value, pDst, dstStep, roiSize, pMask, maskStep);
    case DT_SSE2:
        return _sse2_fwiSet_16s_AC4MR(value, pDst, dstStep, roiSize, pMask, maskStep);
    case DT_REFR:
        return _refr_fwiSet_16s_AC4MR(value, pDst, dstStep, roiSize, pMask, maskStep);
    default:
        assert(false);
        return _refr_fwiSet_16s_AC4MR(value, pDst, dstStep, roiSize, pMask, maskStep);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiDivC_16sc_C3IRSfs( const Fw16sc value[3], Fw16sc *pSrcDst, int srcDstStep, FwiSize roiSize, int scaleFactor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiDivC_16sc_C3IRSfs(value, pSrcDst, srcDstStep, roiSize, scaleFactor);
    case DT_SSE2:
        return _sse2_fwiDivC_16sc_C3IRSfs(value, pSrcDst, srcDstStep, roiSize, scaleFactor);
    case DT_REFR:
        return _refr_fwiDivC_16sc_C3IRSfs(value, pSrcDst, srcDstStep, roiSize, scaleFactor);
    default:
        assert(false);
        return _refr_fwiDivC_16sc_C3IRSfs(value, pSrcDst, srcDstStep, roiSize, scaleFactor);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiFilterBox_8u_AC4R( const Fw8u * pSrc, int srcStep,
                               Fw8u * pDst, int dstStep, FwiSize dstRoiSize,
                               FwiSize maskSize, FwiPoint anchor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilterBox_8u_AC4R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize, anchor);
    case DT_REFR:
        return _refr_fwiFilterBox_8u_AC4R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize, anchor);
    default:
        assert(false);
        return _refr_fwiFilterBox_8u_AC4R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize, anchor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiAddC_8u_C4IRSfs( const Fw8u value[4], Fw8u *pSrcDst, int srcDstStep, FwiSize roiSize, int scaleFactor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiAddC_8u_C4IRSfs(value, pSrcDst, srcDstStep, roiSize, scaleFactor);
    case DT_SSE2:
        return _sse2_fwiAddC_8u_C4IRSfs(value, pSrcDst, srcDstStep, roiSize, scaleFactor);
    case DT_REFR:
        return _refr_fwiAddC_8u_C4IRSfs(value, pSrcDst, srcDstStep, roiSize, scaleFactor);
    default:
        assert(false);
        return _refr_fwiAddC_8u_C4IRSfs(value, pSrcDst, srcDstStep, roiSize, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiThreshold_LTVal_16s_C3IR( Fw16s *pSrcDst, int srcDstStep, FwiSize roiSize, const Fw16s threshold[3], const Fw16s value[3])
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiThreshold_LTVal_16s_C3IR(pSrcDst, srcDstStep, roiSize, threshold, value);
    case DT_SSE2:
        return _sse2_fwiThreshold_LTVal_16s_C3IR(pSrcDst, srcDstStep, roiSize, threshold, value);
    case DT_REFR:
        return _refr_fwiThreshold_LTVal_16s_C3IR(pSrcDst, srcDstStep, roiSize, threshold, value);
    default:
        assert(false);
        return _refr_fwiThreshold_LTVal_16s_C3IR(pSrcDst, srcDstStep, roiSize, threshold, value);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiRShiftC_32s_C3IR( const Fw32u value[3], Fw32s *pSrcDst, int srcDstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiRShiftC_32s_C3IR(value, pSrcDst, srcDstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiRShiftC_32s_C3IR(value, pSrcDst, srcDstStep, roiSize);
    case DT_REFR:
        return _refr_fwiRShiftC_32s_C3IR(value, pSrcDst, srcDstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiRShiftC_32s_C3IR(value, pSrcDst, srcDstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiAdd_8u_C4RSfs( const Fw8u   *pSrc1, int src1Step, const Fw8u   *pSrc2,   int src2Step, Fw8u *pDst, int dstStep, FwiSize roiSize, int scaleFactor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiAdd_8u_C4RSfs(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, scaleFactor);
    case DT_SSE2:
        return _sse2_fwiAdd_8u_C4RSfs(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, scaleFactor);
    case DT_REFR:
        return _refr_fwiAdd_8u_C4RSfs(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, scaleFactor);
    default:
        assert(false);
        return _refr_fwiAdd_8u_C4RSfs(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiAbs_16s_C1R( const Fw16s *pSrc, int srcStep, Fw16s *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiAbs_16s_C1R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiAbs_16s_C1R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiAbs_16s_C1R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiAbs_16s_C1R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR             FwStatus STDCALL fwiScale_16s8u_C1R( const Fw16s * pSrc, int srcStep, Fw8u * pDst, int dstStep, FwiSize roiSize, FwHintAlgorithm hint )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiScale_16s8u_C1R(pSrc, srcStep, pDst, dstStep, roiSize, hint);
    default:
        assert(false);
        return _refr_fwiScale_16s8u_C1R(pSrc, srcStep, pDst, dstStep, roiSize, hint);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiSubC_16s_C1IRSfs(       Fw16s value,    Fw16s *pSrcDst, int srcDstStep, FwiSize roiSize, int scaleFactor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiSubC_16s_C1IRSfs(value, pSrcDst, srcDstStep, roiSize, scaleFactor);
    case DT_SSE2:
        return _sse2_fwiSubC_16s_C1IRSfs(value, pSrcDst, srcDstStep, roiSize, scaleFactor);
    case DT_REFR:
        return _refr_fwiSubC_16s_C1IRSfs(value, pSrcDst, srcDstStep, roiSize, scaleFactor);
    default:
        assert(false);
        return _refr_fwiSubC_16s_C1IRSfs(value, pSrcDst, srcDstStep, roiSize, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiAddSquare_8s32f_C1IMR( const Fw8s *pSrc,  int srcStep, const Fw8u* pMask, int maskStep, Fw32f* pSrcDst, int srcDstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiAddSquare_8s32f_C1IMR(pSrc, srcStep, pMask, maskStep, pSrcDst, srcDstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiAddSquare_8s32f_C1IMR(pSrc, srcStep, pMask, maskStep, pSrcDst, srcDstStep, roiSize);
    case DT_REFR:
        return _refr_fwiAddSquare_8s32f_C1IMR(pSrc, srcStep, pMask, maskStep, pSrcDst, srcDstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiAddSquare_8s32f_C1IMR(pSrc, srcStep, pMask, maskStep, pSrcDst, srcDstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiRShiftC_8u_AC4IR( const Fw32u value[3], Fw8u *pSrcDst, int srcDstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiRShiftC_8u_AC4IR(value, pSrcDst, srcDstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiRShiftC_8u_AC4IR(value, pSrcDst, srcDstStep, roiSize);
    case DT_REFR:
        return _refr_fwiRShiftC_8u_AC4IR(value, pSrcDst, srcDstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiRShiftC_8u_AC4IR(value, pSrcDst, srcDstStep, roiSize);
    }
}



OREFR OSSE2       FwStatus STDCALL fwiFilter32f_8u_C1R( const Fw8u * pSrc, int srcStep,
                                Fw8u * pDst, int dstStep, FwiSize dstRoiSize,
                                const Fw32f * pKernel, FwiSize kernelSize,
                                FwiPoint anchor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilter32f_8u_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize, pKernel, kernelSize, anchor);
    case DT_REFR:
        return _refr_fwiFilter32f_8u_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize, pKernel, kernelSize, anchor);
    default:
        assert(false);
        return _refr_fwiFilter32f_8u_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize, pKernel, kernelSize, anchor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiThreshold_GTVal_8u_C4IR( Fw8u *pSrcDst, int srcDstStep, FwiSize roiSize, const Fw8u threshold[4], const Fw8u value[4])
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiThreshold_GTVal_8u_C4IR(pSrcDst, srcDstStep, roiSize, threshold, value);
    case DT_SSE2:
        return _sse2_fwiThreshold_GTVal_8u_C4IR(pSrcDst, srcDstStep, roiSize, threshold, value);
    case DT_REFR:
        return _refr_fwiThreshold_GTVal_8u_C4IR(pSrcDst, srcDstStep, roiSize, threshold, value);
    default:
        assert(false);
        return _refr_fwiThreshold_GTVal_8u_C4IR(pSrcDst, srcDstStep, roiSize, threshold, value);
    }
}

OREFR OSSE2         FwStatus fwiMax_32f_AC4R(const Fw32f* pSrc, int srcStep,FwiSize roiSize, Fw32f max[3])
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiMax_32f_AC4R(pSrc, srcStep, roiSize, max);
    case DT_REFR:
        return _refr_fwiMax_32f_AC4R(pSrc, srcStep, roiSize, max);
    default:
        assert(false);
        return _refr_fwiMax_32f_AC4R(pSrc, srcStep, roiSize, max);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiXorC_16u_C1IR(       Fw16u value,    Fw16u *pSrcDst, int srcDstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiXorC_16u_C1IR(value, pSrcDst, srcDstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiXorC_16u_C1IR(value, pSrcDst, srcDstStep, roiSize);
    case DT_REFR:
        return _refr_fwiXorC_16u_C1IR(value, pSrcDst, srcDstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiXorC_16u_C1IR(value, pSrcDst, srcDstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiCopy_32f_C1C3R( const Fw32f *pSrc, int srcStep, Fw32f *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiCopy_32f_C1C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiCopy_32f_C1C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiCopy_32f_C1C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiCopy_32f_C1C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 FwStatus STDCALL fwiResize_16u_P4R( const Fw16u* const pSrc[4], FwiSize srcSize, int srcStep, FwiRect srcRoi,
							 Fw16u* const pDst[4], int dstStep, FwiSize dstRoiSize,
							 double xFactor, double yFactor, int interpolation )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiResize_16u_P4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoiSize, xFactor, yFactor, interpolation);
    case DT_REFR:
        return _refr_fwiResize_16u_P4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoiSize, xFactor, yFactor, interpolation);
    default:
        assert(false);
        return _refr_fwiResize_16u_P4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoiSize, xFactor, yFactor, interpolation);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiSubC_16s_C4RSfs( const Fw16s *pSrc, int srcStep, const Fw16s value[4], Fw16s *pDst, int dstStep, FwiSize roiSize, int scaleFactor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiSubC_16s_C4RSfs(pSrc, srcStep, value, pDst, dstStep, roiSize, scaleFactor);
    case DT_SSE2:
        return _sse2_fwiSubC_16s_C4RSfs(pSrc, srcStep, value, pDst, dstStep, roiSize, scaleFactor);
    case DT_REFR:
        return _refr_fwiSubC_16s_C4RSfs(pSrc, srcStep, value, pDst, dstStep, roiSize, scaleFactor);
    default:
        assert(false);
        return _refr_fwiSubC_16s_C4RSfs(pSrc, srcStep, value, pDst, dstStep, roiSize, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiSqr_16u_AC4RSfs( const Fw16u *pSrc,    int srcStep, Fw16u *pDst, int dstStep, FwiSize roiSize, int scaleFactor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiSqr_16u_AC4RSfs(pSrc, srcStep, pDst, dstStep, roiSize, scaleFactor);
    case DT_SSE2:
        return _sse2_fwiSqr_16u_AC4RSfs(pSrc, srcStep, pDst, dstStep, roiSize, scaleFactor);
    case DT_REFR:
        return _refr_fwiSqr_16u_AC4RSfs(pSrc, srcStep, pDst, dstStep, roiSize, scaleFactor);
    default:
        assert(false);
        return _refr_fwiSqr_16u_AC4RSfs(pSrc, srcStep, pDst, dstStep, roiSize, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiAnd_8u_C3R( const Fw8u *pSrc1, int src1Step, const Fw8u *pSrc2,   int src2Step, Fw8u *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiAnd_8u_C3R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiAnd_8u_C3R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiAnd_8u_C3R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiAnd_8u_C3R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiRShiftC_32s_C3R( const Fw32s  *pSrc, int srcStep, const Fw32u value[3], Fw32s *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiRShiftC_32s_C3R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiRShiftC_32s_C3R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiRShiftC_32s_C3R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiRShiftC_32s_C3R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2         FwStatus fwiYUV422ToRGB_8u_P3C3R( const A8U* const pSrc[3], int srcStep[3], A8U* pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiYUV422ToRGB_8u_P3C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiYUV422ToRGB_8u_P3C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiYUV422ToRGB_8u_P3C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiMulC_32fc_C3IR( const Fw32fc value[3], Fw32fc *pSrcDst, int srcDstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiMulC_32fc_C3IR(value, pSrcDst, srcDstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiMulC_32fc_C3IR(value, pSrcDst, srcDstStep, roiSize);
    case DT_REFR:
        return _refr_fwiMulC_32fc_C3IR(value, pSrcDst, srcDstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiMulC_32fc_C3IR(value, pSrcDst, srcDstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiConvert_16u32f_C3R( const Fw16u *pSrc, int srcStep, Fw32f *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiConvert_16u32f_C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiConvert_16u32f_C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiConvert_16u32f_C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiConvert_16u32f_C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 FwStatus STDCALL fwiResizeCenter_16u_C4R( const Fw16u* pSrc, FwiSize srcSize, int srcStep, FwiRect srcRoi,
								   Fw16u* pDst, int dstStep, FwiSize dstRoiSize,
								   double xFactor, double yFactor, double xCenter, double yCenter, int interpolation )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiResizeCenter_16u_C4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoiSize, xFactor, yFactor, xCenter, yCenter, interpolation);
    case DT_REFR:
        return _refr_fwiResizeCenter_16u_C4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoiSize, xFactor, yFactor, xCenter, yCenter, interpolation);
    default:
        assert(false);
        return _refr_fwiResizeCenter_16u_C4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoiSize, xFactor, yFactor, xCenter, yCenter, interpolation);
    }
}

OREFR               FwStatus fwiYCbCr422ToRGB444_8u16u_C2C3R(const A8U* pSrc, int srcStep, A16U* pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiYCbCr422ToRGB444_8u16u_C2C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiYCbCr422ToRGB444_8u16u_C2C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiFilterBox_32f_C1IR( Fw32f * pSrcDst, int srcDstStep,
                               FwiSize dstRoiSize, FwiSize maskSize, FwiPoint anchor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilterBox_32f_C1IR(pSrcDst, srcDstStep, dstRoiSize, maskSize, anchor);
    case DT_REFR:
        return _refr_fwiFilterBox_32f_C1IR(pSrcDst, srcDstStep, dstRoiSize, maskSize, anchor);
    default:
        assert(false);
        return _refr_fwiFilterBox_32f_C1IR(pSrcDst, srcDstStep, dstRoiSize, maskSize, anchor);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiRotate_16u_C4R( const Fw16u* pSrc, FwiSize srcSize, int srcStep, FwiRect srcRoi, Fw16u* pDst, int dstStep, FwiRect dstRoi, double angle, double xShift, double yShift, int interpolation )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiRotate_16u_C4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, angle, xShift, yShift, interpolation);
    case DT_REFR:
        return _refr_fwiRotate_16u_C4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, angle, xShift, yShift, interpolation);
    default:
        assert(false);
        return _refr_fwiRotate_16u_C4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, angle, xShift, yShift, interpolation);
    }
}

OREFR OSSE2         FwStatus fwiYUV420ToRGB_8u_P3(const A8U* const pSrc[3], A8U* const pDst[3], FwiSize imgSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiYUV420ToRGB_8u_P3(pSrc, pDst, imgSize);
    case DT_REFR:
        return _refr_fwiYUV420ToRGB_8u_P3(pSrc, pDst, imgSize);
    default:
        assert(false);
        return _refr_fwiYUV420ToRGB_8u_P3(pSrc, pDst, imgSize);
    }
}

OREFR OSSE2 OF10H   FwStatus fwiYCbCrToRGB_8u_AC4R( const Fw8u* pSrc, int srcStep, Fw8u* pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiYCbCrToRGB_8u_AC4R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiYCbCrToRGB_8u_AC4R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiYCbCrToRGB_8u_AC4R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiYCbCrToRGB_8u_AC4R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiAnd_32s_C4R( const Fw32s *pSrc1, int src1Step, const Fw32s *pSrc2,   int src2Step, Fw32s *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiAnd_32s_C4R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiAnd_32s_C4R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiAnd_32s_C4R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiAnd_32s_C4R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2         FwStatus fwiSum_16s_C3R(const Fw16s* pSrc, int srcStep,FwiSize roiSize, Fw64f sum[3])
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiSum_16s_C3R(pSrc, srcStep, roiSize, sum);
    case DT_REFR:
        return _refr_fwiSum_16s_C3R(pSrc, srcStep, roiSize, sum);
    default:
        assert(false);
        return _refr_fwiSum_16s_C3R(pSrc, srcStep, roiSize, sum);
    }
}

OREFR               FwStatus fwiRGBToHSV_8u_AC4R( const Fw8u *pSrc, int srcStep, Fw8u *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiRGBToHSV_8u_AC4R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiRGBToHSV_8u_AC4R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiFilterGauss_16s_C1R( const Fw16s * pSrc, int srcStep, Fw16s * pDst, int dstStep, FwiSize dstRoiSize, FwiMaskSize maskSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilterGauss_16s_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize);
    case DT_REFR:
        return _refr_fwiFilterGauss_16s_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize);
    default:
        assert(false);
        return _refr_fwiFilterGauss_16s_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiSqr_16s_AC4IRSfs(       Fw16s *pSrcDst, int srcDstStep, FwiSize roiSize, int scaleFactor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiSqr_16s_AC4IRSfs(pSrcDst, srcDstStep, roiSize, scaleFactor);
    case DT_SSE2:
        return _sse2_fwiSqr_16s_AC4IRSfs(pSrcDst, srcDstStep, roiSize, scaleFactor);
    case DT_REFR:
        return _refr_fwiSqr_16s_AC4IRSfs(pSrcDst, srcDstStep, roiSize, scaleFactor);
    default:
        assert(false);
        return _refr_fwiSqr_16s_AC4IRSfs(pSrcDst, srcDstStep, roiSize, scaleFactor);
    }
}

OREFR               FwStatus fwiYCbCr422ToRGB_8u_P3C3R(const A8U* const pSrc[3], int srcStep[3], A8U* pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiYCbCr422ToRGB_8u_P3C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiYCbCr422ToRGB_8u_P3C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiSumWindowRow_8u32f_C4R( const Fw8u * pSrc, int srcStep,
                               Fw32f * pDst, int dstStep, FwiSize dstRoiSize,
                               int maskSize, int anchor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiSumWindowRow_8u32f_C4R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize, anchor);
    case DT_REFR:
        return _refr_fwiSumWindowRow_8u32f_C4R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize, anchor);
    default:
        assert(false);
        return _refr_fwiSumWindowRow_8u32f_C4R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize, anchor);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiFilterRobertsDown_16s_AC4R( const Fw16s * pSrc, int srcStep, Fw16s * pDst, int dstStep, FwiSize dstRoiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilterRobertsDown_16s_AC4R(pSrc, srcStep, pDst, dstStep, dstRoiSize);
    case DT_REFR:
        return _refr_fwiFilterRobertsDown_16s_AC4R(pSrc, srcStep, pDst, dstStep, dstRoiSize);
    default:
        assert(false);
        return _refr_fwiFilterRobertsDown_16s_AC4R(pSrc, srcStep, pDst, dstStep, dstRoiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiThreshold_LTVal_16s_C4R( const Fw16s *pSrc, int srcStep, Fw16s *pDst, int dstStep, FwiSize roiSize, const Fw16s threshold[4], const Fw16s value[4])
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiThreshold_LTVal_16s_C4R(pSrc, srcStep, pDst, dstStep, roiSize, threshold, value);
    case DT_SSE2:
        return _sse2_fwiThreshold_LTVal_16s_C4R(pSrc, srcStep, pDst, dstStep, roiSize, threshold, value);
    case DT_REFR:
        return _refr_fwiThreshold_LTVal_16s_C4R(pSrc, srcStep, pDst, dstStep, roiSize, threshold, value);
    default:
        assert(false);
        return _refr_fwiThreshold_LTVal_16s_C4R(pSrc, srcStep, pDst, dstStep, roiSize, threshold, value);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiThreshold_GT_8u_AC4IR( Fw8u *pSrcDst, int srcDstStep, FwiSize roiSize, const Fw8u threshold[3])
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiThreshold_GT_8u_AC4IR(pSrcDst, srcDstStep, roiSize, threshold);
    case DT_SSE2:
        return _sse2_fwiThreshold_GT_8u_AC4IR(pSrcDst, srcDstStep, roiSize, threshold);
    case DT_REFR:
        return _refr_fwiThreshold_GT_8u_AC4IR(pSrcDst, srcDstStep, roiSize, threshold);
    default:
        assert(false);
        return _refr_fwiThreshold_GT_8u_AC4IR(pSrcDst, srcDstStep, roiSize, threshold);
    }
}

OREFR OSSE2         FwStatus fwiColorToGray_8u_AC4C1R(const Fw8u* pSrc, int srcStep, Fw8u* pDst, int dstStep, FwiSize roiSize, const Fw32f coeffs[3])
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiColorToGray_8u_AC4C1R(pSrc, srcStep, pDst, dstStep, roiSize, coeffs);
    case DT_REFR:
        return _refr_fwiColorToGray_8u_AC4C1R(pSrc, srcStep, pDst, dstStep, roiSize, coeffs);
    default:
        assert(false);
        return _refr_fwiColorToGray_8u_AC4C1R(pSrc, srcStep, pDst, dstStep, roiSize, coeffs);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiMulC_32fc_C1IR(       Fw32fc value,    Fw32fc *pSrcDst, int srcDstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiMulC_32fc_C1IR(value, pSrcDst, srcDstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiMulC_32fc_C1IR(value, pSrcDst, srcDstStep, roiSize);
    case DT_REFR:
        return _refr_fwiMulC_32fc_C1IR(value, pSrcDst, srcDstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiMulC_32fc_C1IR(value, pSrcDst, srcDstStep, roiSize);
    }
}

OREFR       FwStatus STDCALL fwiResizeSqrPixel_32f_P3R(const Fw32f* const pSrc[3], FwiSize srcSize, int srcStep, FwiRect srcRoi,
			Fw32f* const pDst[3], int dstStep, FwiRect dstRoi, double xFactor, double yFactor,
			double xShift, double yShift, int interpolation, Fw8u* pBuffer)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiResizeSqrPixel_32f_P3R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, xFactor, yFactor, xShift, yShift, interpolation, pBuffer);
    default:
        assert(false);
        return _refr_fwiResizeSqrPixel_32f_P3R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, xFactor, yFactor, xShift, yShift, interpolation, pBuffer);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiMirror_8u_C4IR(Fw8u  *pSrcDst, int srcDstStep, FwiSize roiSize, FwiAxis flip)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiMirror_8u_C4IR(pSrcDst, srcDstStep, roiSize, flip);
    case DT_REFR:
        return _refr_fwiMirror_8u_C4IR(pSrcDst, srcDstStep, roiSize, flip);
    default:
        assert(false);
        return _refr_fwiMirror_8u_C4IR(pSrcDst, srcDstStep, roiSize, flip);
    }
}

OREFR OSSE2 FwStatus STDCALL fwiWarpPerspectiveQuad_32f_P3R( const Fw32f* const pSrc[3], FwiSize srcSize, int srcStep, FwiRect srcRoi,
							        const double srcQuad[4][2], Fw32f* const pDst[3], int dstStep, FwiRect dstRoi,
									const double dstQuad[4][2], int interpolation )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiWarpPerspectiveQuad_32f_P3R(pSrc, srcSize, srcStep, srcRoi, srcQuad, pDst, dstStep, dstRoi, dstQuad, interpolation);
    case DT_REFR:
        return _refr_fwiWarpPerspectiveQuad_32f_P3R(pSrc, srcSize, srcStep, srcRoi, srcQuad, pDst, dstStep, dstRoi, dstQuad, interpolation);
    default:
        assert(false);
        return _refr_fwiWarpPerspectiveQuad_32f_P3R(pSrc, srcSize, srcStep, srcRoi, srcQuad, pDst, dstStep, dstRoi, dstQuad, interpolation);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiThreshold_LTVal_16s_C4IR( Fw16s *pSrcDst, int srcDstStep, FwiSize roiSize, const Fw16s threshold[4], const Fw16s value[4])
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiThreshold_LTVal_16s_C4IR(pSrcDst, srcDstStep, roiSize, threshold, value);
    case DT_SSE2:
        return _sse2_fwiThreshold_LTVal_16s_C4IR(pSrcDst, srcDstStep, roiSize, threshold, value);
    case DT_REFR:
        return _refr_fwiThreshold_LTVal_16s_C4IR(pSrcDst, srcDstStep, roiSize, threshold, value);
    default:
        assert(false);
        return _refr_fwiThreshold_LTVal_16s_C4IR(pSrcDst, srcDstStep, roiSize, threshold, value);
    }
}

OREFR OSSE2 FwStatus STDCALL fwiWarpPerspectiveQuad_8u_C3R( const Fw8u* pSrc, FwiSize srcSize, int srcStep, FwiRect srcRoi,
							        const double srcQuad[4][2], Fw8u* pDst, int dstStep, FwiRect dstRoi,
									const double dstQuad[4][2], int interpolation )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiWarpPerspectiveQuad_8u_C3R(pSrc, srcSize, srcStep, srcRoi, srcQuad, pDst, dstStep, dstRoi, dstQuad, interpolation);
    case DT_REFR:
        return _refr_fwiWarpPerspectiveQuad_8u_C3R(pSrc, srcSize, srcStep, srcRoi, srcQuad, pDst, dstStep, dstRoi, dstQuad, interpolation);
    default:
        assert(false);
        return _refr_fwiWarpPerspectiveQuad_8u_C3R(pSrc, srcSize, srcStep, srcRoi, srcQuad, pDst, dstStep, dstRoi, dstQuad, interpolation);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiExp_8u_C1RSfs( const Fw8u  *pSrc, int srcStep, Fw8u  *pDst, int dstStep, FwiSize roiSize, int scaleFactor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiExp_8u_C1RSfs(pSrc, srcStep, pDst, dstStep, roiSize, scaleFactor);
    case DT_SSE2:
        return _sse2_fwiExp_8u_C1RSfs(pSrc, srcStep, pDst, dstStep, roiSize, scaleFactor);
    case DT_REFR:
        return _refr_fwiExp_8u_C1RSfs(pSrc, srcStep, pDst, dstStep, roiSize, scaleFactor);
    default:
        assert(false);
        return _refr_fwiExp_8u_C1RSfs(pSrc, srcStep, pDst, dstStep, roiSize, scaleFactor);
    }
}



OREFR OSSE2         FwStatus fwiCountInRange_8u_C1R(const Fw8u* pSrc, int srcStep, FwiSize roiSize, int* counts, Fw8u lowerBound,Fw8u upperBound)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiCountInRange_8u_C1R(pSrc, srcStep, roiSize, counts, lowerBound, upperBound);
    case DT_REFR:
        return _refr_fwiCountInRange_8u_C1R(pSrc, srcStep, roiSize, counts, lowerBound, upperBound);
    default:
        assert(false);
        return _refr_fwiCountInRange_8u_C1R(pSrc, srcStep, roiSize, counts, lowerBound, upperBound);
    }
}


OREFR OSSE2 FwStatus STDCALL fwiGetAffineBound(FwiRect srcRoi, double bound[2][2], const double coeffs[2][3])
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiGetAffineBound(srcRoi, bound, coeffs);
    case DT_REFR:
        return _refr_fwiGetAffineBound(srcRoi, bound, coeffs);
    default:
        assert(false);
        return _refr_fwiGetAffineBound(srcRoi, bound, coeffs);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiSqr_8u_C1RSfs( const Fw8u  *pSrc,    int srcStep, Fw8u *pDst, int dstStep, FwiSize roiSize, int scaleFactor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiSqr_8u_C1RSfs(pSrc, srcStep, pDst, dstStep, roiSize, scaleFactor);
    case DT_SSE2:
        return _sse2_fwiSqr_8u_C1RSfs(pSrc, srcStep, pDst, dstStep, roiSize, scaleFactor);
    case DT_REFR:
        return _refr_fwiSqr_8u_C1RSfs(pSrc, srcStep, pDst, dstStep, roiSize, scaleFactor);
    default:
        assert(false);
        return _refr_fwiSqr_8u_C1RSfs(pSrc, srcStep, pDst, dstStep, roiSize, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiSet_32s_C3CR(		Fw32s  value,    Fw32s  * pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiSet_32s_C3CR(value, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiSet_32s_C3CR(value, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiSet_32s_C3CR(value, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiSet_32s_C3CR(value, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiDivC_32fc_AC4R( const Fw32fc *pSrc, int srcStep, const Fw32fc value[3], Fw32fc *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiDivC_32fc_AC4R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiDivC_32fc_AC4R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiDivC_32fc_AC4R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiDivC_32fc_AC4R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiMulC_32sc_AC4RSfs( const Fw32sc *pSrc, int srcStep, const Fw32sc value[3], Fw32sc *pDst, int dstStep, FwiSize roiSize, int scaleFactor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiMulC_32sc_AC4RSfs(pSrc, srcStep, value, pDst, dstStep, roiSize, scaleFactor);
    case DT_SSE2:
        return _sse2_fwiMulC_32sc_AC4RSfs(pSrc, srcStep, value, pDst, dstStep, roiSize, scaleFactor);
    case DT_REFR:
        return _refr_fwiMulC_32sc_AC4RSfs(pSrc, srcStep, value, pDst, dstStep, roiSize, scaleFactor);
    default:
        assert(false);
        return _refr_fwiMulC_32sc_AC4RSfs(pSrc, srcStep, value, pDst, dstStep, roiSize, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiAddC_8u_C4RSfs( const Fw8u   *pSrc, int srcStep, const Fw8u value[4], Fw8u *pDst, int dstStep, FwiSize roiSize, int scaleFactor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiAddC_8u_C4RSfs(pSrc, srcStep, value, pDst, dstStep, roiSize, scaleFactor);
    case DT_SSE2:
        return _sse2_fwiAddC_8u_C4RSfs(pSrc, srcStep, value, pDst, dstStep, roiSize, scaleFactor);
    case DT_REFR:
        return _refr_fwiAddC_8u_C4RSfs(pSrc, srcStep, value, pDst, dstStep, roiSize, scaleFactor);
    default:
        assert(false);
        return _refr_fwiAddC_8u_C4RSfs(pSrc, srcStep, value, pDst, dstStep, roiSize, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiSqr_8u_AC4RSfs( const Fw8u  *pSrc,    int srcStep, Fw8u *pDst, int dstStep, FwiSize roiSize, int scaleFactor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiSqr_8u_AC4RSfs(pSrc, srcStep, pDst, dstStep, roiSize, scaleFactor);
    case DT_SSE2:
        return _sse2_fwiSqr_8u_AC4RSfs(pSrc, srcStep, pDst, dstStep, roiSize, scaleFactor);
    case DT_REFR:
        return _refr_fwiSqr_8u_AC4RSfs(pSrc, srcStep, pDst, dstStep, roiSize, scaleFactor);
    default:
        assert(false);
        return _refr_fwiSqr_8u_AC4RSfs(pSrc, srcStep, pDst, dstStep, roiSize, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiOrC_32s_AC4R( const Fw32s  *pSrc, int srcStep, const Fw32s value[3], Fw32s *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiOrC_32s_AC4R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiOrC_32s_AC4R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiOrC_32s_AC4R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiOrC_32s_AC4R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    }
}

OREFR               FwStatus fwiXYZToRGB_16s_AC4R( const Fw16s* pSrc, int srcStep, Fw16s* pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiXYZToRGB_16s_AC4R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiXYZToRGB_16s_AC4R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiThreshold_GT_16s_C3R( const Fw16s *pSrc, int srcStep, Fw16s *pDst, int dstStep, FwiSize roiSize, const Fw16s threshold[3])
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiThreshold_GT_16s_C3R(pSrc, srcStep, pDst, dstStep, roiSize, threshold);
    case DT_SSE2:
        return _sse2_fwiThreshold_GT_16s_C3R(pSrc, srcStep, pDst, dstStep, roiSize, threshold);
    case DT_REFR:
        return _refr_fwiThreshold_GT_16s_C3R(pSrc, srcStep, pDst, dstStep, roiSize, threshold);
    default:
        assert(false);
        return _refr_fwiThreshold_GT_16s_C3R(pSrc, srcStep, pDst, dstStep, roiSize, threshold);
    }
}

OREFR OSSE2         FwStatus fwiMax_16s_C3R(const Fw16s* pSrc, int srcStep,FwiSize roiSize, Fw16s max[3])
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiMax_16s_C3R(pSrc, srcStep, roiSize, max);
    case DT_REFR:
        return _refr_fwiMax_16s_C3R(pSrc, srcStep, roiSize, max);
    default:
        assert(false);
        return _refr_fwiMax_16s_C3R(pSrc, srcStep, roiSize, max);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiConvert_32f8s_C1R( const Fw32f *pSrc, int srcStep, Fw8s *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiConvert_32f8s_C1R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiConvert_32f8s_C1R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiConvert_32f8s_C1R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiConvert_32f8s_C1R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 FwStatus STDCALL fwiResizeSqrPixel_8u_AC4R(const Fw8u* pSrc, FwiSize srcSize, int srcStep, FwiRect srcRoi,
			Fw8u* pDst, int dstStep, FwiRect dstRoi, double xFactor, double yFactor,
			double xShift, double yShift, int interpolation, Fw8u* pBuffer)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiResizeSqrPixel_8u_AC4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, xFactor, yFactor, xShift, yShift, interpolation, pBuffer);
    case DT_REFR:
        return _refr_fwiResizeSqrPixel_8u_AC4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, xFactor, yFactor, xShift, yShift, interpolation, pBuffer);
    default:
        assert(false);
        return _refr_fwiResizeSqrPixel_8u_AC4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, xFactor, yFactor, xShift, yShift, interpolation, pBuffer);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiFilterMedianHoriz_8u_AC4R( const Fw8u * pSrc, int srcStep,
                                               Fw8u * pDst, int dstStep, FwiSize dstRoiSize,
                                               FwiMaskSize maskSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilterMedianHoriz_8u_AC4R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize);
    case DT_REFR:
        return _refr_fwiFilterMedianHoriz_8u_AC4R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize);
    default:
        assert(false);
        return _refr_fwiFilterMedianHoriz_8u_AC4R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiFilterRow_8u_AC4R( const Fw8u * pSrc, int srcStep,
                             Fw8u * pDst, int dstStep, FwiSize dstRoiSize,
                             const Fw32s * pKernel, int kernelSize,
                             int xAnchor, int divisor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilterRow_8u_AC4R(pSrc, srcStep, pDst, dstStep, dstRoiSize, pKernel, kernelSize, xAnchor, divisor);
    case DT_REFR:
        return _refr_fwiFilterRow_8u_AC4R(pSrc, srcStep, pDst, dstStep, dstRoiSize, pKernel, kernelSize, xAnchor, divisor);
    default:
        assert(false);
        return _refr_fwiFilterRow_8u_AC4R(pSrc, srcStep, pDst, dstStep, dstRoiSize, pKernel, kernelSize, xAnchor, divisor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiAndC_32s_C4R( const Fw32s  *pSrc, int srcStep, const Fw32s value[4], Fw32s *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiAndC_32s_C4R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiAndC_32s_C4R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiAndC_32s_C4R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiAndC_32s_C4R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiAddSquare_8s32f_C1IR( const Fw8s *pSrc,  int srcStep, Fw32f* pSrcDst, int srcDstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiAddSquare_8s32f_C1IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiAddSquare_8s32f_C1IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    case DT_REFR:
        return _refr_fwiAddSquare_8s32f_C1IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiAddSquare_8s32f_C1IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    }
}


OREFR OSSE2         FwStatus fwiSum_8u_AC4R(const Fw8u* pSrc, int srcStep,FwiSize roiSize, Fw64f sum[3])
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiSum_8u_AC4R(pSrc, srcStep, roiSize, sum);
    case DT_REFR:
        return _refr_fwiSum_8u_AC4R(pSrc, srcStep, roiSize, sum);
    default:
        assert(false);
        return _refr_fwiSum_8u_AC4R(pSrc, srcStep, roiSize, sum);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiThreshold_32f_AC4IR( Fw32f *pSrcDst, int srcDstStep, FwiSize roiSize, const Fw32f threshold[3], FwCmpOp fwCmpOp)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiThreshold_32f_AC4IR(pSrcDst, srcDstStep, roiSize, threshold, fwCmpOp);
    case DT_SSE2:
        return _sse2_fwiThreshold_32f_AC4IR(pSrcDst, srcDstStep, roiSize, threshold, fwCmpOp);
    case DT_REFR:
        return _refr_fwiThreshold_32f_AC4IR(pSrcDst, srcDstStep, roiSize, threshold, fwCmpOp);
    default:
        assert(false);
        return _refr_fwiThreshold_32f_AC4IR(pSrcDst, srcDstStep, roiSize, threshold, fwCmpOp);
    }
}

OREFR OSSE2 OF10H   FwStatus fwiRGBToYUV_8u_AC4R( const Fw8u *pSrc, int srcStep, Fw8u *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiRGBToYUV_8u_AC4R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiRGBToYUV_8u_AC4R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiRGBToYUV_8u_AC4R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiRGBToYUV_8u_AC4R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiMirror_16u_AC4IR(Fw16u *pSrcDst, int srcDstStep, FwiSize roiSize, FwiAxis flip)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiMirror_16u_AC4IR(pSrcDst, srcDstStep, roiSize, flip);
    case DT_REFR:
        return _refr_fwiMirror_16u_AC4IR(pSrcDst, srcDstStep, roiSize, flip);
    default:
        assert(false);
        return _refr_fwiMirror_16u_AC4IR(pSrcDst, srcDstStep, roiSize, flip);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiThreshold_LTValGTVal_8u_C1IR( Fw8u *pSrcDst, int srcDstStep, FwiSize roiSize, Fw8u thresholdLT, Fw8u valueLT, Fw8u thresholdGT, Fw8u valueGT)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiThreshold_LTValGTVal_8u_C1IR(pSrcDst, srcDstStep, roiSize, thresholdLT, valueLT, thresholdGT, valueGT);
    case DT_SSE2:
        return _sse2_fwiThreshold_LTValGTVal_8u_C1IR(pSrcDst, srcDstStep, roiSize, thresholdLT, valueLT, thresholdGT, valueGT);
    case DT_REFR:
        return _refr_fwiThreshold_LTValGTVal_8u_C1IR(pSrcDst, srcDstStep, roiSize, thresholdLT, valueLT, thresholdGT, valueGT);
    default:
        assert(false);
        return _refr_fwiThreshold_LTValGTVal_8u_C1IR(pSrcDst, srcDstStep, roiSize, thresholdLT, valueLT, thresholdGT, valueGT);
    }
}


OREFR OSSE2       FwStatus STDCALL fwiFilterLaplace_8u_C1R( const Fw8u * pSrc, int srcStep, Fw8u * pDst, int dstStep, FwiSize dstRoiSize, FwiMaskSize maskSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilterLaplace_8u_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize);
    case DT_REFR:
        return _refr_fwiFilterLaplace_8u_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize);
    default:
        assert(false);
        return _refr_fwiFilterLaplace_8u_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiSet_32f_C4R( const Fw32f  value[4], Fw32f  * pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiSet_32f_C4R(value, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiSet_32f_C4R(value, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiSet_32f_C4R(value, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiSet_32f_C4R(value, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiFilterMin_16s_C1R( const Fw16s * pSrc, int srcStep,
                               Fw16s * pDst, int dstStep, FwiSize dstRoiSize,
                               FwiSize maskSize, FwiPoint anchor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilterMin_16s_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize, anchor);
    case DT_REFR:
        return _refr_fwiFilterMin_16s_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize, anchor);
    default:
        assert(false);
        return _refr_fwiFilterMin_16s_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize, anchor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiMul_8u_C3IRSfs( const Fw8u   *pSrc,  int srcStep,        Fw8u   *pSrcDst, int srcDstStep, FwiSize roiSize, int scaleFactor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiMul_8u_C3IRSfs(pSrc, srcStep, pSrcDst, srcDstStep, roiSize, scaleFactor);
    case DT_SSE2:
        return _sse2_fwiMul_8u_C3IRSfs(pSrc, srcStep, pSrcDst, srcDstStep, roiSize, scaleFactor);
    case DT_REFR:
        return _refr_fwiMul_8u_C3IRSfs(pSrc, srcStep, pSrcDst, srcDstStep, roiSize, scaleFactor);
    default:
        assert(false);
        return _refr_fwiMul_8u_C3IRSfs(pSrc, srcStep, pSrcDst, srcDstStep, roiSize, scaleFactor);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiFilterLowpass_16s_C3R( const Fw16s * pSrc, int srcStep, Fw16s * pDst, int dstStep, FwiSize dstRoiSize, FwiMaskSize maskSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilterLowpass_16s_C3R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize);
    case DT_REFR:
        return _refr_fwiFilterLowpass_16s_C3R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize);
    default:
        assert(false);
        return _refr_fwiFilterLowpass_16s_C3R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiFilterRow32f_16s_C1R( const Fw16s * pSrc, int srcStep,
                                 Fw16s * pDst, int dstStep, FwiSize dstRoiSize,
                                const Fw32f * pKernel, int kernelSize,
                                int xAnchor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilterRow32f_16s_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize, pKernel, kernelSize, xAnchor);
    case DT_REFR:
        return _refr_fwiFilterRow32f_16s_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize, pKernel, kernelSize, xAnchor);
    default:
        assert(false);
        return _refr_fwiFilterRow32f_16s_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize, pKernel, kernelSize, xAnchor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiLShiftC_16u_AC4IR( const Fw32u value[3], Fw16u *pSrcDst, int srcDstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiLShiftC_16u_AC4IR(value, pSrcDst, srcDstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiLShiftC_16u_AC4IR(value, pSrcDst, srcDstStep, roiSize);
    case DT_REFR:
        return _refr_fwiLShiftC_16u_AC4IR(value, pSrcDst, srcDstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiLShiftC_16u_AC4IR(value, pSrcDst, srcDstStep, roiSize);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiFilterGauss_32f_AC4R( const Fw32f * pSrc, int srcStep, Fw32f * pDst, int dstStep, FwiSize dstRoiSize, FwiMaskSize maskSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilterGauss_32f_AC4R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize);
    case DT_REFR:
        return _refr_fwiFilterGauss_32f_AC4R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize);
    default:
        assert(false);
        return _refr_fwiFilterGauss_32f_AC4R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize);
    }
}

OREFR OSSE2         FwStatus fwiYUV420ToRGB555_8u16u_P3C3R(const A8U* const pSrc[3], int srcStep[3], A16U* pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiYUV420ToRGB555_8u16u_P3C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiYUV420ToRGB555_8u16u_P3C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiYUV420ToRGB555_8u16u_P3C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2         FwStatus fwiMean_16s_C3R(const Fw16s* pSrc, int srcStep,FwiSize roiSize, Fw64f mean[3])
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiMean_16s_C3R(pSrc, srcStep, roiSize, mean);
    case DT_REFR:
        return _refr_fwiMean_16s_C3R(pSrc, srcStep, roiSize, mean);
    default:
        assert(false);
        return _refr_fwiMean_16s_C3R(pSrc, srcStep, roiSize, mean);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiSwapChannels_16u_AC4R(const Fw16u *pSrc,int srcStep, Fw16u *pDst, int dstStep, FwiSize roiSize,const int dstOrder[3])
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiSwapChannels_16u_AC4R(pSrc, srcStep, pDst, dstStep, roiSize, dstOrder);
    case DT_SSE2:
        return _sse2_fwiSwapChannels_16u_AC4R(pSrc, srcStep, pDst, dstStep, roiSize, dstOrder);
    case DT_REFR:
        return _refr_fwiSwapChannels_16u_AC4R(pSrc, srcStep, pDst, dstStep, roiSize, dstOrder);
    default:
        assert(false);
        return _refr_fwiSwapChannels_16u_AC4R(pSrc, srcStep, pDst, dstStep, roiSize, dstOrder);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiFilterSobelHoriz_8u_C4R( const Fw8u * pSrc, int srcStep, Fw8u * pDst, int dstStep, FwiSize dstRoiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilterSobelHoriz_8u_C4R(pSrc, srcStep, pDst, dstStep, dstRoiSize);
    case DT_REFR:
        return _refr_fwiFilterSobelHoriz_8u_C4R(pSrc, srcStep, pDst, dstStep, dstRoiSize);
    default:
        assert(false);
        return _refr_fwiFilterSobelHoriz_8u_C4R(pSrc, srcStep, pDst, dstStep, dstRoiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiConvert_16u32s_C1R( const Fw16u *pSrc, int srcStep, Fw32s *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiConvert_16u32s_C1R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiConvert_16u32s_C1R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiConvert_16u32s_C1R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiConvert_16u32s_C1R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiRShiftC_16u_C1R( const Fw16u  *pSrc, int srcStep,       Fw32u value,    Fw16u *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiRShiftC_16u_C1R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiRShiftC_16u_C1R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiRShiftC_16u_C1R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiRShiftC_16u_C1R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    }
}

OREFR               FwStatus fwiYCCToRGB_32f_C3R( const Fw32f* pSrc, int srcStep, Fw32f* pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiYCCToRGB_32f_C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiYCCToRGB_32f_C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiAdd_32f_C3IR( const Fw32f  *pSrc,  int srcStep,        Fw32f  *pSrcDst, int srcDstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiAdd_32f_C3IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiAdd_32f_C3IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    case DT_REFR:
        return _refr_fwiAdd_32f_C3IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiAdd_32f_C3IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    }
}

OREFR OSSE2 FwStatus STDCALL fwiWarpPerspective_32f_C1R( const Fw32f* pSrc, FwiSize srcSize, int srcStep,
								FwiRect srcRoi, Fw32f* pDst, int dstStep, FwiRect dstRoi,
								const double coeffs[3][3], int interpolation )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiWarpPerspective_32f_C1R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, coeffs, interpolation);
    case DT_REFR:
        return _refr_fwiWarpPerspective_32f_C1R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, coeffs, interpolation);
    default:
        assert(false);
        return _refr_fwiWarpPerspective_32f_C1R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, coeffs, interpolation);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiThreshold_GTVal_16s_AC4R( const Fw16s *pSrc, int srcStep, Fw16s *pDst, int dstStep, FwiSize roiSize, const Fw16s threshold[3], const Fw16s value[3])
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiThreshold_GTVal_16s_AC4R(pSrc, srcStep, pDst, dstStep, roiSize, threshold, value);
    case DT_SSE2:
        return _sse2_fwiThreshold_GTVal_16s_AC4R(pSrc, srcStep, pDst, dstStep, roiSize, threshold, value);
    case DT_REFR:
        return _refr_fwiThreshold_GTVal_16s_AC4R(pSrc, srcStep, pDst, dstStep, roiSize, threshold, value);
    default:
        assert(false);
        return _refr_fwiThreshold_GTVal_16s_AC4R(pSrc, srcStep, pDst, dstStep, roiSize, threshold, value);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiSqr_16u_C1RSfs( const Fw16u *pSrc,    int srcStep, Fw16u *pDst, int dstStep, FwiSize roiSize, int scaleFactor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiSqr_16u_C1RSfs(pSrc, srcStep, pDst, dstStep, roiSize, scaleFactor);
    case DT_SSE2:
        return _sse2_fwiSqr_16u_C1RSfs(pSrc, srcStep, pDst, dstStep, roiSize, scaleFactor);
    case DT_REFR:
        return _refr_fwiSqr_16u_C1RSfs(pSrc, srcStep, pDst, dstStep, roiSize, scaleFactor);
    default:
        assert(false);
        return _refr_fwiSqr_16u_C1RSfs(pSrc, srcStep, pDst, dstStep, roiSize, scaleFactor);
    }
}

OREFR OSSE2 FwStatus STDCALL fwiWarpAffine_16u_C1R( const Fw16u* pSrc, FwiSize srcSize, int srcStep,
								FwiRect srcRoi, Fw16u* pDst, int dstStep, FwiRect dstRoi,
								const double coeffs[2][3], int interpolation )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiWarpAffine_16u_C1R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, coeffs, interpolation);
    case DT_REFR:
        return _refr_fwiWarpAffine_16u_C1R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, coeffs, interpolation);
    default:
        assert(false);
        return _refr_fwiWarpAffine_16u_C1R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, coeffs, interpolation);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiSub_16sc_C3IRSfs( const Fw16sc *pSrc,  int srcStep,        Fw16sc *pSrcDst, int srcDstStep, FwiSize roiSize, int scaleFactor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiSub_16sc_C3IRSfs(pSrc, srcStep, pSrcDst, srcDstStep, roiSize, scaleFactor);
    case DT_SSE2:
        return _sse2_fwiSub_16sc_C3IRSfs(pSrc, srcStep, pSrcDst, srcDstStep, roiSize, scaleFactor);
    case DT_REFR:
        return _refr_fwiSub_16sc_C3IRSfs(pSrc, srcStep, pSrcDst, srcDstStep, roiSize, scaleFactor);
    default:
        assert(false);
        return _refr_fwiSub_16sc_C3IRSfs(pSrc, srcStep, pSrcDst, srcDstStep, roiSize, scaleFactor);
    }
}

OREFR               FwStatus fwiRGBToYUV420_8u_C3P3( const A8U* pSrc, A8U* const pDst[3], FwiSize imgSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiRGBToYUV420_8u_C3P3(pSrc, pDst, imgSize);
    default:
        assert(false);
        return _refr_fwiRGBToYUV420_8u_C3P3(pSrc, pDst, imgSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiSubC_8u_C4RSfs( const Fw8u *pSrc, int srcStep, const Fw8u value[4], Fw8u *pDst, int dstStep, FwiSize roiSize, int scaleFactor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiSubC_8u_C4RSfs(pSrc, srcStep, value, pDst, dstStep, roiSize, scaleFactor);
    case DT_SSE2:
        return _sse2_fwiSubC_8u_C4RSfs(pSrc, srcStep, value, pDst, dstStep, roiSize, scaleFactor);
    case DT_REFR:
        return _refr_fwiSubC_8u_C4RSfs(pSrc, srcStep, value, pDst, dstStep, roiSize, scaleFactor);
    default:
        assert(false);
        return _refr_fwiSubC_8u_C4RSfs(pSrc, srcStep, value, pDst, dstStep, roiSize, scaleFactor);
    }
}


OREFR OSSE2         FwStatus fwiColorToGray_8u_C3C1R(const Fw8u* pSrc, int srcStep, Fw8u* pDst, int dstStep, FwiSize roiSize, const Fw32f coeffs[3])
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiColorToGray_8u_C3C1R(pSrc, srcStep, pDst, dstStep, roiSize, coeffs);
    case DT_REFR:
        return _refr_fwiColorToGray_8u_C3C1R(pSrc, srcStep, pDst, dstStep, roiSize, coeffs);
    default:
        assert(false);
        return _refr_fwiColorToGray_8u_C3C1R(pSrc, srcStep, pDst, dstStep, roiSize, coeffs);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiFilterSobelVert_16s_C1R( const Fw16s * pSrc, int srcStep, Fw16s * pDst, int dstStep, FwiSize dstRoiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilterSobelVert_16s_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize);
    case DT_REFR:
        return _refr_fwiFilterSobelVert_16s_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize);
    default:
        assert(false);
        return _refr_fwiFilterSobelVert_16s_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize);
    }
}

OREFR               FwStatus fwiRGBToYCC_32f_AC4R( const Fw32f* pSrc, int srcStep, Fw32f* pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiRGBToYCC_32f_AC4R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiRGBToYCC_32f_AC4R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 FwStatus STDCALL fwiWarpAffineQuad_8u_P4R( const Fw8u* const pSrc[4], FwiSize srcSize, int srcStep, FwiRect srcRoi,
							        const double srcQuad[4][2], Fw8u* const pDst[4], int dstStep, FwiRect dstRoi,
									const double dstQuad[4][2], int interpolation )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiWarpAffineQuad_8u_P4R(pSrc, srcSize, srcStep, srcRoi, srcQuad, pDst, dstStep, dstRoi, dstQuad, interpolation);
    case DT_REFR:
        return _refr_fwiWarpAffineQuad_8u_P4R(pSrc, srcSize, srcStep, srcRoi, srcQuad, pDst, dstStep, dstRoi, dstQuad, interpolation);
    default:
        assert(false);
        return _refr_fwiWarpAffineQuad_8u_P4R(pSrc, srcSize, srcStep, srcRoi, srcQuad, pDst, dstStep, dstRoi, dstQuad, interpolation);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiFilterSobelVertMask_32f_C1R( const Fw32f * pSrc, int srcStep, Fw32f * pDst, int dstStep, FwiSize dstRoiSize, FwiMaskSize mask )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilterSobelVertMask_32f_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize, mask);
    case DT_REFR:
        return _refr_fwiFilterSobelVertMask_32f_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize, mask);
    default:
        assert(false);
        return _refr_fwiFilterSobelVertMask_32f_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize, mask);
    }
}


OREFR OSSE2       FwStatus STDCALL fwiFilterPrewittVert_8u_C1R( const Fw8u * pSrc, int srcStep, Fw8u * pDst, int dstStep, FwiSize dstRoiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilterPrewittVert_8u_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize);
    case DT_REFR:
        return _refr_fwiFilterPrewittVert_8u_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize);
    default:
        assert(false);
        return _refr_fwiFilterPrewittVert_8u_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize);
    }
}

OREFR OSSE2 FwStatus STDCALL fwiWarpPerspectiveQuad_8u_P3R( const Fw8u* const pSrc[3], FwiSize srcSize, int srcStep, FwiRect srcRoi,
							        const double srcQuad[4][2], Fw8u* const pDst[3], int dstStep, FwiRect dstRoi,
									const double dstQuad[4][2], int interpolation )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiWarpPerspectiveQuad_8u_P3R(pSrc, srcSize, srcStep, srcRoi, srcQuad, pDst, dstStep, dstRoi, dstQuad, interpolation);
    case DT_REFR:
        return _refr_fwiWarpPerspectiveQuad_8u_P3R(pSrc, srcSize, srcStep, srcRoi, srcQuad, pDst, dstStep, dstRoi, dstQuad, interpolation);
    default:
        assert(false);
        return _refr_fwiWarpPerspectiveQuad_8u_P3R(pSrc, srcSize, srcStep, srcRoi, srcQuad, pDst, dstStep, dstRoi, dstQuad, interpolation);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiFilterPrewittHoriz_8u_AC4R( const Fw8u * pSrc, int srcStep, Fw8u * pDst, int dstStep, FwiSize dstRoiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilterPrewittHoriz_8u_AC4R(pSrc, srcStep, pDst, dstStep, dstRoiSize);
    case DT_REFR:
        return _refr_fwiFilterPrewittHoriz_8u_AC4R(pSrc, srcStep, pDst, dstStep, dstRoiSize);
    default:
        assert(false);
        return _refr_fwiFilterPrewittHoriz_8u_AC4R(pSrc, srcStep, pDst, dstStep, dstRoiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiDiv_32fc_C3IR( const Fw32fc *pSrc,  int srcStep,        Fw32fc *pSrcDst, int srcDstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiDiv_32fc_C3IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiDiv_32fc_C3IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    case DT_REFR:
        return _refr_fwiDiv_32fc_C3IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiDiv_32fc_C3IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiFilterPrewittVert_8u_AC4R( const Fw8u * pSrc, int srcStep, Fw8u * pDst, int dstStep, FwiSize dstRoiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilterPrewittVert_8u_AC4R(pSrc, srcStep, pDst, dstStep, dstRoiSize);
    case DT_REFR:
        return _refr_fwiFilterPrewittVert_8u_AC4R(pSrc, srcStep, pDst, dstStep, dstRoiSize);
    default:
        assert(false);
        return _refr_fwiFilterPrewittVert_8u_AC4R(pSrc, srcStep, pDst, dstStep, dstRoiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiSub_32f_AC4R( const Fw32f  *pSrc1, int src1Step, const Fw32f  *pSrc2,   int src2Step, Fw32f  *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiSub_32f_AC4R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiSub_32f_AC4R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiSub_32f_AC4R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiSub_32f_AC4R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiCopy_16s_P4C4R( const Fw16s * const pSrc[4], int srcStep, Fw16s *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiCopy_16s_P4C4R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiCopy_16s_P4C4R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiCopy_16s_P4C4R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiCopy_16s_P4C4R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2         FwStatus fwiRGBToGray_16u_C3C1R(const Fw16u* pSrc, int srcStep,Fw16u* pDst, int dstStep, FwiSize roiSize)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiRGBToGray_16u_C3C1R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiRGBToGray_16u_C3C1R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiRGBToGray_16u_C3C1R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiSub_16sc_AC4RSfs( const Fw16sc *pSrc1, int src1Step, const Fw16sc *pSrc2,   int src2Step, Fw16sc *pDst, int dstStep, FwiSize roiSize, int scaleFactor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiSub_16sc_AC4RSfs(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, scaleFactor);
    case DT_SSE2:
        return _sse2_fwiSub_16sc_AC4RSfs(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, scaleFactor);
    case DT_REFR:
        return _refr_fwiSub_16sc_AC4RSfs(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, scaleFactor);
    default:
        assert(false);
        return _refr_fwiSub_16sc_AC4RSfs(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, scaleFactor);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiMirror_32s_AC4R( const Fw32s *pSrc, int srcStep, Fw32s *pDst, int dstStep, FwiSize roiSize, FwiAxis flip)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiMirror_32s_AC4R(pSrc, srcStep, pDst, dstStep, roiSize, flip);
    case DT_REFR:
        return _refr_fwiMirror_32s_AC4R(pSrc, srcStep, pDst, dstStep, roiSize, flip);
    default:
        assert(false);
        return _refr_fwiMirror_32s_AC4R(pSrc, srcStep, pDst, dstStep, roiSize, flip);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiAdd_8u32f_C1IMR( const Fw8u  *pSrc, int srcStep, const Fw8u *pMask, int maskStep, Fw32f *pSrcDst, int srcDstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiAdd_8u32f_C1IMR(pSrc, srcStep, pMask, maskStep, pSrcDst, srcDstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiAdd_8u32f_C1IMR(pSrc, srcStep, pMask, maskStep, pSrcDst, srcDstStep, roiSize);
    case DT_REFR:
        return _refr_fwiAdd_8u32f_C1IMR(pSrc, srcStep, pMask, maskStep, pSrcDst, srcDstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiAdd_8u32f_C1IMR(pSrc, srcStep, pMask, maskStep, pSrcDst, srcDstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiSub_16s_C3RSfs( const Fw16s  *pSrc1, int src1Step, const Fw16s  *pSrc2,   int src2Step, Fw16s *pDst, int dstStep, FwiSize roiSize, int scaleFactor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiSub_16s_C3RSfs(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, scaleFactor);
    case DT_SSE2:
        return _sse2_fwiSub_16s_C3RSfs(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, scaleFactor);
    case DT_REFR:
        return _refr_fwiSub_16s_C3RSfs(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, scaleFactor);
    default:
        assert(false);
        return _refr_fwiSub_16s_C3RSfs(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, scaleFactor);
    }
}

OREFR               FwStatus fwiYCbCrToBGR444_8u16u_C3R(const A8U* pSrc, int srcStep, A16U* pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiYCbCrToBGR444_8u16u_C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiYCbCrToBGR444_8u16u_C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}


OREFR OSSE2       FwStatus STDCALL fwiFilterRobertsDown_8u_C1R( const Fw8u * pSrc, int srcStep, Fw8u * pDst, int dstStep, FwiSize dstRoiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilterRobertsDown_8u_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize);
    case DT_REFR:
        return _refr_fwiFilterRobertsDown_8u_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize);
    default:
        assert(false);
        return _refr_fwiFilterRobertsDown_8u_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize);
    }
}

OREFR OSSE2         FwStatus fwiMean_8u_AC4R(const Fw8u* pSrc, int srcStep,FwiSize roiSize, Fw64f mean[3])
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiMean_8u_AC4R(pSrc, srcStep, roiSize, mean);
    case DT_REFR:
        return _refr_fwiMean_8u_AC4R(pSrc, srcStep, roiSize, mean);
    default:
        assert(false);
        return _refr_fwiMean_8u_AC4R(pSrc, srcStep, roiSize, mean);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiRotateCenter_16u_AC4R( const Fw16u* pSrc,FwiSize srcSize, int srcStep, FwiRect srcRoi, Fw16u* pDst, int dstStep, FwiRect dstRoi, double angle, double xCenter, double yCenter, int interpolation )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiRotateCenter_16u_AC4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, angle, xCenter, yCenter, interpolation);
    case DT_REFR:
        return _refr_fwiRotateCenter_16u_AC4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, angle, xCenter, yCenter, interpolation);
    default:
        assert(false);
        return _refr_fwiRotateCenter_16u_AC4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, angle, xCenter, yCenter, interpolation);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiFilterColumn_8u_AC4R( const Fw8u * pSrc, int srcStep,
                             Fw8u * pDst, int dstStep, FwiSize dstRoiSize,
                             const Fw32s * pKernel, int kernelSize,
                             int yAnchor, int divisor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilterColumn_8u_AC4R(pSrc, srcStep, pDst, dstStep, dstRoiSize, pKernel, kernelSize, yAnchor, divisor);
    case DT_REFR:
        return _refr_fwiFilterColumn_8u_AC4R(pSrc, srcStep, pDst, dstStep, dstRoiSize, pKernel, kernelSize, yAnchor, divisor);
    default:
        assert(false);
        return _refr_fwiFilterColumn_8u_AC4R(pSrc, srcStep, pDst, dstStep, dstRoiSize, pKernel, kernelSize, yAnchor, divisor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiMulC_32f_C4IR( const Fw32f value[4], Fw32f *pSrcDst, int srcDstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiMulC_32f_C4IR(value, pSrcDst, srcDstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiMulC_32f_C4IR(value, pSrcDst, srcDstStep, roiSize);
    case DT_REFR:
        return _refr_fwiMulC_32f_C4IR(value, pSrcDst, srcDstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiMulC_32f_C4IR(value, pSrcDst, srcDstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiRShiftC_8u_C3R( const Fw8u   *pSrc, int srcStep, const Fw32u value[3], Fw8u *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiRShiftC_8u_C3R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiRShiftC_8u_C3R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiRShiftC_8u_C3R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiRShiftC_8u_C3R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiExp_16s_C1IRSfs(       Fw16s *pSrcDst,  int srcDstStep, FwiSize roiSize, int scaleFactor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiExp_16s_C1IRSfs(pSrcDst, srcDstStep, roiSize, scaleFactor);
    case DT_SSE2:
        return _sse2_fwiExp_16s_C1IRSfs(pSrcDst, srcDstStep, roiSize, scaleFactor);
    case DT_REFR:
        return _refr_fwiExp_16s_C1IRSfs(pSrcDst, srcDstStep, roiSize, scaleFactor);
    default:
        assert(false);
        return _refr_fwiExp_16s_C1IRSfs(pSrcDst, srcDstStep, roiSize, scaleFactor);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiFilterPrewittHoriz_32f_C1R( const Fw32f * pSrc, int srcStep, Fw32f * pDst, int dstStep, FwiSize dstRoiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilterPrewittHoriz_32f_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize);
    case DT_REFR:
        return _refr_fwiFilterPrewittHoriz_32f_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize);
    default:
        assert(false);
        return _refr_fwiFilterPrewittHoriz_32f_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiCompare_16s_C1R( const Fw16s *pSrc1, int src1Step, const Fw16s *pSrc2, int src2Step, Fw8u *pDst, int dstStep, FwiSize roiSize, FwCmpOp fwCmpOp )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiCompare_16s_C1R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, fwCmpOp);
    case DT_SSE2:
        return _sse2_fwiCompare_16s_C1R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, fwCmpOp);
    case DT_REFR:
        return _refr_fwiCompare_16s_C1R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, fwCmpOp);
    default:
        assert(false);
        return _refr_fwiCompare_16s_C1R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, fwCmpOp);
    }
}

OREFR OSSE2 FwStatus STDCALL fwiResizeCenter_32f_P3R( const Fw32f* const pSrc[3], FwiSize srcSize, int srcStep, FwiRect srcRoi,
								   Fw32f* const pDst[3], int dstStep, FwiSize dstRoiSize,
								   double xFactor, double yFactor, double xCenter, double yCenter, int interpolation )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiResizeCenter_32f_P3R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoiSize, xFactor, yFactor, xCenter, yCenter, interpolation);
    case DT_REFR:
        return _refr_fwiResizeCenter_32f_P3R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoiSize, xFactor, yFactor, xCenter, yCenter, interpolation);
    default:
        assert(false);
        return _refr_fwiResizeCenter_32f_P3R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoiSize, xFactor, yFactor, xCenter, yCenter, interpolation);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiLShiftC_16u_C3R( const Fw16u  *pSrc, int srcStep, const Fw32u value[3], Fw16u *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiLShiftC_16u_C3R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiLShiftC_16u_C3R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiLShiftC_16u_C3R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiLShiftC_16u_C3R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiSqrt_8u_C3RSfs( const Fw8u *pSrc,    int srcStep, Fw8u *pDst, int dstStep, FwiSize roiSize, int scaleFactor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiSqrt_8u_C3RSfs(pSrc, srcStep, pDst, dstStep, roiSize, scaleFactor);
    case DT_SSE2:
        return _sse2_fwiSqrt_8u_C3RSfs(pSrc, srcStep, pDst, dstStep, roiSize, scaleFactor);
    case DT_REFR:
        return _refr_fwiSqrt_8u_C3RSfs(pSrc, srcStep, pDst, dstStep, roiSize, scaleFactor);
    default:
        assert(false);
        return _refr_fwiSqrt_8u_C3RSfs(pSrc, srcStep, pDst, dstStep, roiSize, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiRShiftC_16u_C3R( const Fw16u  *pSrc, int srcStep, const Fw32u value[3], Fw16u *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiRShiftC_16u_C3R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiRShiftC_16u_C3R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiRShiftC_16u_C3R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiRShiftC_16u_C3R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiLn_32f_C3IR(       Fw32f *pSrcDst, int srcDstStep,  FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiLn_32f_C3IR(pSrcDst, srcDstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiLn_32f_C3IR(pSrcDst, srcDstStep, roiSize);
    case DT_REFR:
        return _refr_fwiLn_32f_C3IR(pSrcDst, srcDstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiLn_32f_C3IR(pSrcDst, srcDstStep, roiSize);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiFilter32f_8u_AC4R( const Fw8u * pSrc, int srcStep,
                                Fw8u * pDst, int dstStep, FwiSize dstRoiSize,
                                const Fw32f * pKernel, FwiSize kernelSize,
                                FwiPoint anchor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilter32f_8u_AC4R(pSrc, srcStep, pDst, dstStep, dstRoiSize, pKernel, kernelSize, anchor);
    case DT_REFR:
        return _refr_fwiFilter32f_8u_AC4R(pSrc, srcStep, pDst, dstStep, dstRoiSize, pKernel, kernelSize, anchor);
    default:
        assert(false);
        return _refr_fwiFilter32f_8u_AC4R(pSrc, srcStep, pDst, dstStep, dstRoiSize, pKernel, kernelSize, anchor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiSqrt_16s_C3RSfs( const Fw16s *pSrc,    int srcStep, Fw16s *pDst, int dstStep, FwiSize roiSize, int scaleFactor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiSqrt_16s_C3RSfs(pSrc, srcStep, pDst, dstStep, roiSize, scaleFactor);
    case DT_SSE2:
        return _sse2_fwiSqrt_16s_C3RSfs(pSrc, srcStep, pDst, dstStep, roiSize, scaleFactor);
    case DT_REFR:
        return _refr_fwiSqrt_16s_C3RSfs(pSrc, srcStep, pDst, dstStep, roiSize, scaleFactor);
    default:
        assert(false);
        return _refr_fwiSqrt_16s_C3RSfs(pSrc, srcStep, pDst, dstStep, roiSize, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiSqrt_32f_C1IR(       Fw32f *pSrcDst, int srcDstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiSqrt_32f_C1IR(pSrcDst, srcDstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiSqrt_32f_C1IR(pSrcDst, srcDstStep, roiSize);
    case DT_REFR:
        return _refr_fwiSqrt_32f_C1IR(pSrcDst, srcDstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiSqrt_32f_C1IR(pSrcDst, srcDstStep, roiSize);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiFilterSobelVert_32f_AC4R( const Fw32f * pSrc, int srcStep, Fw32f * pDst, int dstStep, FwiSize dstRoiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilterSobelVert_32f_AC4R(pSrc, srcStep, pDst, dstStep, dstRoiSize);
    case DT_REFR:
        return _refr_fwiFilterSobelVert_32f_AC4R(pSrc, srcStep, pDst, dstStep, dstRoiSize);
    default:
        assert(false);
        return _refr_fwiFilterSobelVert_32f_AC4R(pSrc, srcStep, pDst, dstStep, dstRoiSize);
    }
}

OREFR OSSE2         FwStatus fwiSum_16s_C4R(const Fw16s* pSrc, int srcStep,FwiSize roiSize, Fw64f sum[4])
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiSum_16s_C4R(pSrc, srcStep, roiSize, sum);
    case DT_REFR:
        return _refr_fwiSum_16s_C4R(pSrc, srcStep, roiSize, sum);
    default:
        assert(false);
        return _refr_fwiSum_16s_C4R(pSrc, srcStep, roiSize, sum);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiFilterMin_16s_C4R( const Fw16s * pSrc, int srcStep,
                               Fw16s * pDst, int dstStep, FwiSize dstRoiSize,
                               FwiSize maskSize, FwiPoint anchor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilterMin_16s_C4R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize, anchor);
    case DT_REFR:
        return _refr_fwiFilterMin_16s_C4R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize, anchor);
    default:
        assert(false);
        return _refr_fwiFilterMin_16s_C4R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize, anchor);
    }
}

OREFR OSSE2         FwStatus fwiMin_16s_C1R(const Fw16s* pSrc, int srcStep,FwiSize roiSize, Fw16s* pMin)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiMin_16s_C1R(pSrc, srcStep, roiSize, pMin);
    case DT_REFR:
        return _refr_fwiMin_16s_C1R(pSrc, srcStep, roiSize, pMin);
    default:
        assert(false);
        return _refr_fwiMin_16s_C1R(pSrc, srcStep, roiSize, pMin);
    }
}

OREFR OSSE2 FwStatus STDCALL fwiWarpPerspectiveBack_8u_AC4R( const Fw8u* pSrc, FwiSize srcSize, int srcStep,
								FwiRect srcRoi, Fw8u* pDst, int dstStep, FwiRect dstRoi,
								const double coeffs[3][3], int interpolation )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiWarpPerspectiveBack_8u_AC4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, coeffs, interpolation);
    case DT_REFR:
        return _refr_fwiWarpPerspectiveBack_8u_AC4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, coeffs, interpolation);
    default:
        assert(false);
        return _refr_fwiWarpPerspectiveBack_8u_AC4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, coeffs, interpolation);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiCompare_32f_C3R( const Fw32f *pSrc1, int src1Step, const Fw32f *pSrc2, int src2Step, Fw8u *pDst, int dstStep, FwiSize roiSize, FwCmpOp fwCmpOp )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiCompare_32f_C3R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, fwCmpOp);
    case DT_SSE2:
        return _sse2_fwiCompare_32f_C3R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, fwCmpOp);
    case DT_REFR:
        return _refr_fwiCompare_32f_C3R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, fwCmpOp);
    default:
        assert(false);
        return _refr_fwiCompare_32f_C3R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, fwCmpOp);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiCompareC_32f_C1R( const Fw32f *pSrc, int srcStep, Fw32f value, Fw8u *pDst, int dstStep, FwiSize roiSize, FwCmpOp fwCmpOp )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiCompareC_32f_C1R(pSrc, srcStep, value, pDst, dstStep, roiSize, fwCmpOp);
    case DT_SSE2:
        return _sse2_fwiCompareC_32f_C1R(pSrc, srcStep, value, pDst, dstStep, roiSize, fwCmpOp);
    case DT_REFR:
        return _refr_fwiCompareC_32f_C1R(pSrc, srcStep, value, pDst, dstStep, roiSize, fwCmpOp);
    default:
        assert(false);
        return _refr_fwiCompareC_32f_C1R(pSrc, srcStep, value, pDst, dstStep, roiSize, fwCmpOp);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiDiv_32sc_AC4RSfs( const Fw32sc *pSrc1, int src1Step, const Fw32sc *pSrc2,   int src2Step, Fw32sc *pDst, int dstStep, FwiSize roiSize, int scaleFactor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiDiv_32sc_AC4RSfs(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, scaleFactor);
    case DT_SSE2:
        return _sse2_fwiDiv_32sc_AC4RSfs(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, scaleFactor);
    case DT_REFR:
        return _refr_fwiDiv_32sc_AC4RSfs(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, scaleFactor);
    default:
        assert(false);
        return _refr_fwiDiv_32sc_AC4RSfs(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, scaleFactor);
    }
}


OREFR OSSE2       FwStatus STDCALL fwiFilterBox_8u_C1R( const Fw8u * pSrc, int srcStep,
                                        Fw8u * pDst, int dstStep, FwiSize dstRoiSize,
                                        FwiSize maskSize, FwiPoint anchor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilterBox_8u_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize, anchor);
    case DT_REFR:
        return _refr_fwiFilterBox_8u_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize, anchor);
    default:
        assert(false);
        return _refr_fwiFilterBox_8u_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize, anchor);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiRotateCenter_32f_P4R( const Fw32f* const pSrc[4],FwiSize srcSize, int srcStep, FwiRect srcRoi, Fw32f* const pDst[4], int dstStep, FwiRect dstRoi, double angle, double xCenter, double yCenter, int interpolation )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiRotateCenter_32f_P4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, angle, xCenter, yCenter, interpolation);
    case DT_REFR:
        return _refr_fwiRotateCenter_32f_P4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, angle, xCenter, yCenter, interpolation);
    default:
        assert(false);
        return _refr_fwiRotateCenter_32f_P4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, angle, xCenter, yCenter, interpolation);
    }
}


OREFR OSSE2       FwStatus STDCALL fwiFilterMedianHoriz_8u_C1R( const Fw8u * pSrc, int srcStep,
                                               Fw8u * pDst, int dstStep, FwiSize dstRoiSize,
                                               FwiMaskSize maskSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilterMedianHoriz_8u_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize);
    case DT_REFR:
        return _refr_fwiFilterMedianHoriz_8u_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize);
    default:
        assert(false);
        return _refr_fwiFilterMedianHoriz_8u_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiMul_32sc_C1IRSfs( const Fw32sc *pSrc,  int srcStep,        Fw32sc *pSrcDst, int srcDstStep, FwiSize roiSize, int scaleFactor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiMul_32sc_C1IRSfs(pSrc, srcStep, pSrcDst, srcDstStep, roiSize, scaleFactor);
    case DT_SSE2:
        return _sse2_fwiMul_32sc_C1IRSfs(pSrc, srcStep, pSrcDst, srcDstStep, roiSize, scaleFactor);
    case DT_REFR:
        return _refr_fwiMul_32sc_C1IRSfs(pSrc, srcStep, pSrcDst, srcDstStep, roiSize, scaleFactor);
    default:
        assert(false);
        return _refr_fwiMul_32sc_C1IRSfs(pSrc, srcStep, pSrcDst, srcDstStep, roiSize, scaleFactor);
    }
}


OREFR OSSE2         FwStatus fwiYUV420ToBGR565_8u16u_P3C3R(const A8U* const pSrc[3], int srcStep[3], A16U* pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiYUV420ToBGR565_8u16u_P3C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiYUV420ToBGR565_8u16u_P3C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiYUV420ToBGR565_8u16u_P3C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR       FwStatus STDCALL fwiWarpBilinear_32f_P4R(const Fw32f* const pSrc[4], FwiSize srcSize, int srcStep,
								FwiRect srcRoi, Fw32f* const pDst[4], int dstStep, FwiRect dstRoi,
								const double coeffs[2][4], int interpolation)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiWarpBilinear_32f_P4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, coeffs, interpolation);
    default:
        assert(false);
        return _refr_fwiWarpBilinear_32f_P4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, coeffs, interpolation);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiSub_16sc_C1IRSfs( const Fw16sc *pSrc,  int srcStep,        Fw16sc *pSrcDst, int srcDstStep, FwiSize roiSize, int scaleFactor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiSub_16sc_C1IRSfs(pSrc, srcStep, pSrcDst, srcDstStep, roiSize, scaleFactor);
    case DT_SSE2:
        return _sse2_fwiSub_16sc_C1IRSfs(pSrc, srcStep, pSrcDst, srcDstStep, roiSize, scaleFactor);
    case DT_REFR:
        return _refr_fwiSub_16sc_C1IRSfs(pSrc, srcStep, pSrcDst, srcDstStep, roiSize, scaleFactor);
    default:
        assert(false);
        return _refr_fwiSub_16sc_C1IRSfs(pSrc, srcStep, pSrcDst, srcDstStep, roiSize, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiConvert_8s32f_C3R( const Fw8s *pSrc, int srcStep, Fw32f *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiConvert_8s32f_C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiConvert_8s32f_C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiConvert_8s32f_C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiConvert_8s32f_C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiMulCScale_8u_C3IR( const Fw8u value[3], Fw8u *pSrcDst, int srcDstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiMulCScale_8u_C3IR(value, pSrcDst, srcDstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiMulCScale_8u_C3IR(value, pSrcDst, srcDstStep, roiSize);
    case DT_REFR:
        return _refr_fwiMulCScale_8u_C3IR(value, pSrcDst, srcDstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiMulCScale_8u_C3IR(value, pSrcDst, srcDstStep, roiSize);
    }
}

OREFR       FwStatus STDCALL fwiResizeSqrPixel_16u_C4R(const Fw16u* pSrc, FwiSize srcSize, int srcStep, FwiRect srcRoi,
			Fw16u* pDst, int dstStep, FwiRect dstRoi, double xFactor, double yFactor,
			double xShift, double yShift, int interpolation, Fw8u* pBuffer)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiResizeSqrPixel_16u_C4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, xFactor, yFactor, xShift, yShift, interpolation, pBuffer);
    default:
        assert(false);
        return _refr_fwiResizeSqrPixel_16u_C4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, xFactor, yFactor, xShift, yShift, interpolation, pBuffer);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiCopy_32f_P3C3R( const Fw32f * const pSrc[3], int srcStep, Fw32f *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiCopy_32f_P3C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiCopy_32f_P3C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiCopy_32f_P3C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiCopy_32f_P3C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR       FwStatus STDCALL fwiWarpBilinear_8u_C3R(const Fw8u* pSrc, FwiSize srcSize, int srcStep,
								FwiRect srcRoi, Fw8u* pDst, int dstStep, FwiRect dstRoi,
								const double coeffs[2][4], int interpolation)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiWarpBilinear_8u_C3R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, coeffs, interpolation);
    default:
        assert(false);
        return _refr_fwiWarpBilinear_8u_C3R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, coeffs, interpolation);
    }
}

OREFR               FwStatus fwiCountInRange_32f_AC4R(const Fw32f* pSrc, int srcStep,FwiSize roiSize, int counts[3], Fw32f lowerBound[3],Fw32f upperBound[3])
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiCountInRange_32f_AC4R(pSrc, srcStep, roiSize, counts, lowerBound, upperBound);
    default:
        assert(false);
        return _refr_fwiCountInRange_32f_AC4R(pSrc, srcStep, roiSize, counts, lowerBound, upperBound);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiSqr_16u_C4IRSfs(       Fw16u *pSrcDst, int srcDstStep, FwiSize roiSize, int scaleFactor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiSqr_16u_C4IRSfs(pSrcDst, srcDstStep, roiSize, scaleFactor);
    case DT_SSE2:
        return _sse2_fwiSqr_16u_C4IRSfs(pSrcDst, srcDstStep, roiSize, scaleFactor);
    case DT_REFR:
        return _refr_fwiSqr_16u_C4IRSfs(pSrcDst, srcDstStep, roiSize, scaleFactor);
    default:
        assert(false);
        return _refr_fwiSqr_16u_C4IRSfs(pSrcDst, srcDstStep, roiSize, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiCompareC_8u_C3R( const Fw8u *pSrc, int srcStep, const Fw8u value[3], Fw8u *pDst, int dstStep, FwiSize roiSize, FwCmpOp fwCmpOp )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiCompareC_8u_C3R(pSrc, srcStep, value, pDst, dstStep, roiSize, fwCmpOp);
    case DT_SSE2:
        return _sse2_fwiCompareC_8u_C3R(pSrc, srcStep, value, pDst, dstStep, roiSize, fwCmpOp);
    case DT_REFR:
        return _refr_fwiCompareC_8u_C3R(pSrc, srcStep, value, pDst, dstStep, roiSize, fwCmpOp);
    default:
        assert(false);
        return _refr_fwiCompareC_8u_C3R(pSrc, srcStep, value, pDst, dstStep, roiSize, fwCmpOp);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiThreshold_8u_AC4R( const Fw8u *pSrc, int srcStep, Fw8u *pDst, int dstStep, FwiSize roiSize, const Fw8u threshold[3], FwCmpOp fwCmpOp)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiThreshold_8u_AC4R(pSrc, srcStep, pDst, dstStep, roiSize, threshold, fwCmpOp);
    case DT_SSE2:
        return _sse2_fwiThreshold_8u_AC4R(pSrc, srcStep, pDst, dstStep, roiSize, threshold, fwCmpOp);
    case DT_REFR:
        return _refr_fwiThreshold_8u_AC4R(pSrc, srcStep, pDst, dstStep, roiSize, threshold, fwCmpOp);
    default:
        assert(false);
        return _refr_fwiThreshold_8u_AC4R(pSrc, srcStep, pDst, dstStep, roiSize, threshold, fwCmpOp);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiAddProduct_32f_C1IR( const Fw32f *pSrc1, int src1Step, const Fw32f *pSrc2, int src2Step, Fw32f *pSrcDst, int srcDstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiAddProduct_32f_C1IR(pSrc1, src1Step, pSrc2, src2Step, pSrcDst, srcDstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiAddProduct_32f_C1IR(pSrc1, src1Step, pSrc2, src2Step, pSrcDst, srcDstStep, roiSize);
    case DT_REFR:
        return _refr_fwiAddProduct_32f_C1IR(pSrc1, src1Step, pSrc2, src2Step, pSrcDst, srcDstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiAddProduct_32f_C1IR(pSrc1, src1Step, pSrc2, src2Step, pSrcDst, srcDstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiRShiftC_16u_C1IR(       Fw32u value,    Fw16u *pSrcDst, int srcDstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiRShiftC_16u_C1IR(value, pSrcDst, srcDstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiRShiftC_16u_C1IR(value, pSrcDst, srcDstStep, roiSize);
    case DT_REFR:
        return _refr_fwiRShiftC_16u_C1IR(value, pSrcDst, srcDstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiRShiftC_16u_C1IR(value, pSrcDst, srcDstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiAndC_8u_C1R( const Fw8u   *pSrc, int srcStep,       Fw8u value,    Fw8u *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiAndC_8u_C1R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiAndC_8u_C1R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiAndC_8u_C1R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiAndC_8u_C1R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiLShiftC_32s_C4R( const Fw32s  *pSrc, int srcStep, const Fw32u value[4], Fw32s *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiLShiftC_32s_C4R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiLShiftC_32s_C4R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiLShiftC_32s_C4R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiLShiftC_32s_C4R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2         FwStatus fwiMin_16s_AC4R(const Fw16s* pSrc, int srcStep,FwiSize roiSize, Fw16s min[3])
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiMin_16s_AC4R(pSrc, srcStep, roiSize, min);
    case DT_REFR:
        return _refr_fwiMin_16s_AC4R(pSrc, srcStep, roiSize, min);
    default:
        assert(false);
        return _refr_fwiMin_16s_AC4R(pSrc, srcStep, roiSize, min);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiFilterSobelVert_16s_C4R( const Fw16s * pSrc, int srcStep, Fw16s * pDst, int dstStep, FwiSize dstRoiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilterSobelVert_16s_C4R(pSrc, srcStep, pDst, dstStep, dstRoiSize);
    case DT_REFR:
        return _refr_fwiFilterSobelVert_16s_C4R(pSrc, srcStep, pDst, dstStep, dstRoiSize);
    default:
        assert(false);
        return _refr_fwiFilterSobelVert_16s_C4R(pSrc, srcStep, pDst, dstStep, dstRoiSize);
    }
}

OREFR             FwStatus STDCALL fwiScale_8u16s_C3R( const Fw8u * pSrc, int srcStep, Fw16s * pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiScale_8u16s_C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiScale_8u16s_C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR               FwStatus fwiYCCToRGB_16u_C3R( const Fw16u* pSrc, int srcStep, Fw16u* pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiYCCToRGB_16u_C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiYCCToRGB_16u_C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiConvert_16u32s_C4R( const Fw16u *pSrc, int srcStep, Fw32s *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiConvert_16u32s_C4R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiConvert_16u32s_C4R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiConvert_16u32s_C4R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiConvert_16u32s_C4R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiAbs_32f_C4R( const Fw32f *pSrc, int srcStep, Fw32f *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiAbs_32f_C4R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiAbs_32f_C4R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiAbs_32f_C4R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiAbs_32f_C4R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 FwStatus STDCALL fwiFilterSharpen_8u_AC4R( const Fw8u * pSrc, int srcStep, Fw8u * pDst, int dstStep, FwiSize dstRoiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilterSharpen_8u_AC4R(pSrc, srcStep, pDst, dstStep, dstRoiSize);
    case DT_REFR:
        return _refr_fwiFilterSharpen_8u_AC4R(pSrc, srcStep, pDst, dstStep, dstRoiSize);
    default:
        assert(false);
        return _refr_fwiFilterSharpen_8u_AC4R(pSrc, srcStep, pDst, dstStep, dstRoiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiMulC_16s_C1RSfs( const Fw16s *pSrc, int srcStep,       Fw16s value,    Fw16s *pDst, int dstStep, FwiSize roiSize, int scaleFactor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiMulC_16s_C1RSfs(pSrc, srcStep, value, pDst, dstStep, roiSize, scaleFactor);
    case DT_SSE2:
        return _sse2_fwiMulC_16s_C1RSfs(pSrc, srcStep, value, pDst, dstStep, roiSize, scaleFactor);
    case DT_REFR:
        return _refr_fwiMulC_16s_C1RSfs(pSrc, srcStep, value, pDst, dstStep, roiSize, scaleFactor);
    default:
        assert(false);
        return _refr_fwiMulC_16s_C1RSfs(pSrc, srcStep, value, pDst, dstStep, roiSize, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiSubC_32fc_C3R( const Fw32fc *pSrc, int srcStep, const Fw32fc  value[3], Fw32fc *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiSubC_32fc_C3R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiSubC_32fc_C3R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiSubC_32fc_C3R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiSubC_32fc_C3R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    }
}

OREFR               FwStatus fwiRGBToYCC_16u_AC4R( const Fw16u* pSrc, int srcStep, Fw16u* pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiRGBToYCC_16u_AC4R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiRGBToYCC_16u_AC4R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiDiv_32f_C4R( const Fw32f  *pSrc1, int src1Step, const Fw32f  *pSrc2,   int src2Step, Fw32f  *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiDiv_32f_C4R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiDiv_32f_C4R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiDiv_32f_C4R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiDiv_32f_C4R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiMirror_8u_C4R( const Fw8u  *pSrc, int srcStep, Fw8u  *pDst, int dstStep, FwiSize roiSize, FwiAxis flip)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiMirror_8u_C4R(pSrc, srcStep, pDst, dstStep, roiSize, flip);
    case DT_REFR:
        return _refr_fwiMirror_8u_C4R(pSrc, srcStep, pDst, dstStep, roiSize, flip);
    default:
        assert(false);
        return _refr_fwiMirror_8u_C4R(pSrc, srcStep, pDst, dstStep, roiSize, flip);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiCompareC_16s_C1R( const Fw16s *pSrc, int srcStep, Fw16s value, Fw8u *pDst, int dstStep, FwiSize roiSize, FwCmpOp fwCmpOp )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiCompareC_16s_C1R(pSrc, srcStep, value, pDst, dstStep, roiSize, fwCmpOp);
    case DT_SSE2:
        return _sse2_fwiCompareC_16s_C1R(pSrc, srcStep, value, pDst, dstStep, roiSize, fwCmpOp);
    case DT_REFR:
        return _refr_fwiCompareC_16s_C1R(pSrc, srcStep, value, pDst, dstStep, roiSize, fwCmpOp);
    default:
        assert(false);
        return _refr_fwiCompareC_16s_C1R(pSrc, srcStep, value, pDst, dstStep, roiSize, fwCmpOp);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiFilterSobelHoriz_8u_C3R( const Fw8u * pSrc, int srcStep, Fw8u * pDst, int dstStep, FwiSize dstRoiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilterSobelHoriz_8u_C3R(pSrc, srcStep, pDst, dstStep, dstRoiSize);
    case DT_REFR:
        return _refr_fwiFilterSobelHoriz_8u_C3R(pSrc, srcStep, pDst, dstStep, dstRoiSize);
    default:
        assert(false);
        return _refr_fwiFilterSobelHoriz_8u_C3R(pSrc, srcStep, pDst, dstStep, dstRoiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiAbs_16s_C3IR( Fw16s *pSrcDst, int srcDstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiAbs_16s_C3IR(pSrcDst, srcDstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiAbs_16s_C3IR(pSrcDst, srcDstStep, roiSize);
    case DT_REFR:
        return _refr_fwiAbs_16s_C3IR(pSrcDst, srcDstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiAbs_16s_C3IR(pSrcDst, srcDstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiExp_8u_C3RSfs( const Fw8u  *pSrc, int srcStep, Fw8u  *pDst, int dstStep, FwiSize roiSize, int scaleFactor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiExp_8u_C3RSfs(pSrc, srcStep, pDst, dstStep, roiSize, scaleFactor);
    case DT_SSE2:
        return _sse2_fwiExp_8u_C3RSfs(pSrc, srcStep, pDst, dstStep, roiSize, scaleFactor);
    case DT_REFR:
        return _refr_fwiExp_8u_C3RSfs(pSrc, srcStep, pDst, dstStep, roiSize, scaleFactor);
    default:
        assert(false);
        return _refr_fwiExp_8u_C3RSfs(pSrc, srcStep, pDst, dstStep, roiSize, scaleFactor);
    }
}

OREFR             FwStatus STDCALL fwiScale_32s8u_C4R( const Fw32s * pSrc, int srcStep, Fw8u * pDst, int dstStep, FwiSize roiSize, FwHintAlgorithm hint )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiScale_32s8u_C4R(pSrc, srcStep, pDst, dstStep, roiSize, hint);
    default:
        assert(false);
        return _refr_fwiScale_32s8u_C4R(pSrc, srcStep, pDst, dstStep, roiSize, hint);
    }
}

OREFR             FwStatus STDCALL fwiScale_16u8u_AC4R( const Fw16u * pSrc, int srcStep, Fw8u * pDst, int dstStep, FwiSize roiSize, FwHintAlgorithm hint )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiScale_16u8u_AC4R(pSrc, srcStep, pDst, dstStep, roiSize, hint);
    default:
        assert(false);
        return _refr_fwiScale_16u8u_AC4R(pSrc, srcStep, pDst, dstStep, roiSize, hint);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiFilterPrewittHoriz_32f_AC4R( const Fw32f * pSrc, int srcStep, Fw32f * pDst, int dstStep, FwiSize dstRoiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilterPrewittHoriz_32f_AC4R(pSrc, srcStep, pDst, dstStep, dstRoiSize);
    case DT_REFR:
        return _refr_fwiFilterPrewittHoriz_32f_AC4R(pSrc, srcStep, pDst, dstStep, dstRoiSize);
    default:
        assert(false);
        return _refr_fwiFilterPrewittHoriz_32f_AC4R(pSrc, srcStep, pDst, dstStep, dstRoiSize);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiFilterPrewittVert_16s_AC4R( const Fw16s * pSrc, int srcStep, Fw16s * pDst, int dstStep, FwiSize dstRoiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilterPrewittVert_16s_AC4R(pSrc, srcStep, pDst, dstStep, dstRoiSize);
    case DT_REFR:
        return _refr_fwiFilterPrewittVert_16s_AC4R(pSrc, srcStep, pDst, dstStep, dstRoiSize);
    default:
        assert(false);
        return _refr_fwiFilterPrewittVert_16s_AC4R(pSrc, srcStep, pDst, dstStep, dstRoiSize);
    }
}


OREFR OSSE2 FwStatus STDCALL fwiWarpAffineQuad_8u_C1R( const Fw8u* pSrc, FwiSize srcSize, int srcStep, FwiRect srcRoi,
							        const double srcQuad[4][2], Fw8u* pDst, int dstStep, FwiRect dstRoi,
									const double dstQuad[4][2], int interpolation )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiWarpAffineQuad_8u_C1R(pSrc, srcSize, srcStep, srcRoi, srcQuad, pDst, dstStep, dstRoi, dstQuad, interpolation);
    case DT_REFR:
        return _refr_fwiWarpAffineQuad_8u_C1R(pSrc, srcSize, srcStep, srcRoi, srcQuad, pDst, dstStep, dstRoi, dstQuad, interpolation);
    default:
        assert(false);
        return _refr_fwiWarpAffineQuad_8u_C1R(pSrc, srcSize, srcStep, srcRoi, srcQuad, pDst, dstStep, dstRoi, dstQuad, interpolation);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiAdd_16s_C3IRSfs( const Fw16s  *pSrc,  int srcStep,        Fw16s  *pSrcDst, int srcDstStep, FwiSize roiSize, int scaleFactor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiAdd_16s_C3IRSfs(pSrc, srcStep, pSrcDst, srcDstStep, roiSize, scaleFactor);
    case DT_SSE2:
        return _sse2_fwiAdd_16s_C3IRSfs(pSrc, srcStep, pSrcDst, srcDstStep, roiSize, scaleFactor);
    case DT_REFR:
        return _refr_fwiAdd_16s_C3IRSfs(pSrc, srcStep, pSrcDst, srcDstStep, roiSize, scaleFactor);
    default:
        assert(false);
        return _refr_fwiAdd_16s_C3IRSfs(pSrc, srcStep, pSrcDst, srcDstStep, roiSize, scaleFactor);
    }
}

OREFR             FwStatus STDCALL fwiCopy_16s_C3AC4R( const Fw16s *pSrc, int srcStep, Fw16s *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiCopy_16s_C3AC4R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiCopy_16s_C3AC4R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiFilterHipass_16s_AC4R( const Fw16s * pSrc, int srcStep, Fw16s * pDst, int dstStep, FwiSize dstRoiSize, FwiMaskSize maskSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilterHipass_16s_AC4R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize);
    case DT_REFR:
        return _refr_fwiFilterHipass_16s_AC4R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize);
    default:
        assert(false);
        return _refr_fwiFilterHipass_16s_AC4R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiMul_32fc_C1R( const Fw32fc *pSrc1, int src1Step, const Fw32fc *pSrc2,   int src2Step, Fw32fc *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiMul_32fc_C1R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiMul_32fc_C1R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiMul_32fc_C1R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiMul_32fc_C1R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    }
}


OREFR OSSE2 OF10H   FwStatus fwiRGBToXYZ_8u_C3R( const Fw8u* pSrc, int srcStep, Fw8u* pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiRGBToXYZ_8u_C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiRGBToXYZ_8u_C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiRGBToXYZ_8u_C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiRGBToXYZ_8u_C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiRemap_8u_C3R( const Fw8u* pSrc, FwiSize srcSize, int srcStep, FwiRect srcRoi, const Fw32f* pxMap, int xMapStep, const Fw32f* pyMap, int yMapStep, Fw8u* pDst, int dstStep, FwiSize dstRoiSize, int interpolation )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiRemap_8u_C3R(pSrc, srcSize, srcStep, srcRoi, pxMap, xMapStep, pyMap, yMapStep, pDst, dstStep, dstRoiSize, interpolation);
    case DT_REFR:
        return _refr_fwiRemap_8u_C3R(pSrc, srcSize, srcStep, srcRoi, pxMap, xMapStep, pyMap, yMapStep, pDst, dstStep, dstRoiSize, interpolation);
    default:
        assert(false);
        return _refr_fwiRemap_8u_C3R(pSrc, srcSize, srcStep, srcRoi, pxMap, xMapStep, pyMap, yMapStep, pDst, dstStep, dstRoiSize, interpolation);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiThreshold_GTVal_8u_AC4IR( Fw8u *pSrcDst, int srcDstStep, FwiSize roiSize, const Fw8u threshold[3], const Fw8u value[3])
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiThreshold_GTVal_8u_AC4IR(pSrcDst, srcDstStep, roiSize, threshold, value);
    case DT_SSE2:
        return _sse2_fwiThreshold_GTVal_8u_AC4IR(pSrcDst, srcDstStep, roiSize, threshold, value);
    case DT_REFR:
        return _refr_fwiThreshold_GTVal_8u_AC4IR(pSrcDst, srcDstStep, roiSize, threshold, value);
    default:
        assert(false);
        return _refr_fwiThreshold_GTVal_8u_AC4IR(pSrcDst, srcDstStep, roiSize, threshold, value);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiDivC_32sc_AC4IRSfs( const Fw32sc value[3], Fw32sc *pSrcDst, int srcDstStep, FwiSize roiSize, int scaleFactor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiDivC_32sc_AC4IRSfs(value, pSrcDst, srcDstStep, roiSize, scaleFactor);
    case DT_SSE2:
        return _sse2_fwiDivC_32sc_AC4IRSfs(value, pSrcDst, srcDstStep, roiSize, scaleFactor);
    case DT_REFR:
        return _refr_fwiDivC_32sc_AC4IRSfs(value, pSrcDst, srcDstStep, roiSize, scaleFactor);
    default:
        assert(false);
        return _refr_fwiDivC_32sc_AC4IRSfs(value, pSrcDst, srcDstStep, roiSize, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiLn_32f_C1IR(       Fw32f *pSrcDst, int srcDstStep,  FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiLn_32f_C1IR(pSrcDst, srcDstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiLn_32f_C1IR(pSrcDst, srcDstStep, roiSize);
    case DT_REFR:
        return _refr_fwiLn_32f_C1IR(pSrcDst, srcDstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiLn_32f_C1IR(pSrcDst, srcDstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiAddC_32sc_C3RSfs( const Fw32sc *pSrc, int srcStep, const Fw32sc value[3], Fw32sc *pDst, int dstStep, FwiSize roiSize, int scaleFactor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiAddC_32sc_C3RSfs(pSrc, srcStep, value, pDst, dstStep, roiSize, scaleFactor);
    case DT_SSE2:
        return _sse2_fwiAddC_32sc_C3RSfs(pSrc, srcStep, value, pDst, dstStep, roiSize, scaleFactor);
    case DT_REFR:
        return _refr_fwiAddC_32sc_C3RSfs(pSrc, srcStep, value, pDst, dstStep, roiSize, scaleFactor);
    default:
        assert(false);
        return _refr_fwiAddC_32sc_C3RSfs(pSrc, srcStep, value, pDst, dstStep, roiSize, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiThreshold_GTVal_16s_C3R( const Fw16s *pSrc, int srcStep, Fw16s *pDst, int dstStep, FwiSize roiSize, const Fw16s threshold[3], const Fw16s value[3])
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiThreshold_GTVal_16s_C3R(pSrc, srcStep, pDst, dstStep, roiSize, threshold, value);
    case DT_SSE2:
        return _sse2_fwiThreshold_GTVal_16s_C3R(pSrc, srcStep, pDst, dstStep, roiSize, threshold, value);
    case DT_REFR:
        return _refr_fwiThreshold_GTVal_16s_C3R(pSrc, srcStep, pDst, dstStep, roiSize, threshold, value);
    default:
        assert(false);
        return _refr_fwiThreshold_GTVal_16s_C3R(pSrc, srcStep, pDst, dstStep, roiSize, threshold, value);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiAddC_8u_C3IRSfs( const Fw8u value[3], Fw8u *pSrcDst, int srcDstStep, FwiSize roiSize, int scaleFactor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiAddC_8u_C3IRSfs(value, pSrcDst, srcDstStep, roiSize, scaleFactor);
    case DT_SSE2:
        return _sse2_fwiAddC_8u_C3IRSfs(value, pSrcDst, srcDstStep, roiSize, scaleFactor);
    case DT_REFR:
        return _refr_fwiAddC_8u_C3IRSfs(value, pSrcDst, srcDstStep, roiSize, scaleFactor);
    default:
        assert(false);
        return _refr_fwiAddC_8u_C3IRSfs(value, pSrcDst, srcDstStep, roiSize, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiLShiftC_16u_C3IR( const Fw32u value[3], Fw16u *pSrcDst, int srcDstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiLShiftC_16u_C3IR(value, pSrcDst, srcDstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiLShiftC_16u_C3IR(value, pSrcDst, srcDstStep, roiSize);
    case DT_REFR:
        return _refr_fwiLShiftC_16u_C3IR(value, pSrcDst, srcDstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiLShiftC_16u_C3IR(value, pSrcDst, srcDstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiRShiftC_16s_AC4IR( const Fw32u value[3], Fw16s *pSrcDst, int srcDstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiRShiftC_16s_AC4IR(value, pSrcDst, srcDstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiRShiftC_16s_AC4IR(value, pSrcDst, srcDstStep, roiSize);
    case DT_REFR:
        return _refr_fwiRShiftC_16s_AC4IR(value, pSrcDst, srcDstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiRShiftC_16s_AC4IR(value, pSrcDst, srcDstStep, roiSize);
    }
}

OREFR OSSE2 FwStatus STDCALL fwiResizeShift_8u_P3R( const Fw8u* const pSrc[3], FwiSize srcSize, int srcStep, FwiRect srcRoi,
								 Fw8u* const pDst[3], int dstStep, FwiSize dstRoiSize,
								 double xFr, double yFr, double xShift, double yShift, int interpolation )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiResizeShift_8u_P3R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoiSize, xFr, yFr, xShift, yShift, interpolation);
    case DT_REFR:
        return _refr_fwiResizeShift_8u_P3R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoiSize, xFr, yFr, xShift, yShift, interpolation);
    default:
        assert(false);
        return _refr_fwiResizeShift_8u_P3R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoiSize, xFr, yFr, xShift, yShift, interpolation);
    }
}

OREFR OSSE2 FwStatus STDCALL fwiWarpPerspectiveQuad_32f_P4R( const Fw32f* const pSrc[4], FwiSize srcSize, int srcStep, FwiRect srcRoi,
							        const double srcQuad[4][2], Fw32f* const pDst[4], int dstStep, FwiRect dstRoi,
									const double dstQuad[4][2], int interpolation )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiWarpPerspectiveQuad_32f_P4R(pSrc, srcSize, srcStep, srcRoi, srcQuad, pDst, dstStep, dstRoi, dstQuad, interpolation);
    case DT_REFR:
        return _refr_fwiWarpPerspectiveQuad_32f_P4R(pSrc, srcSize, srcStep, srcRoi, srcQuad, pDst, dstStep, dstRoi, dstQuad, interpolation);
    default:
        assert(false);
        return _refr_fwiWarpPerspectiveQuad_32f_P4R(pSrc, srcSize, srcStep, srcRoi, srcQuad, pDst, dstStep, dstRoi, dstQuad, interpolation);
    }
}

OREFR       FwStatus STDCALL fwiWarpBilinearQuad_32f_C1R(const Fw32f* pSrc, FwiSize srcSize, int srcStep, FwiRect srcRoi,
							        const double srcQuad[4][2], Fw32f* pDst, int dstStep, FwiRect dstRoi,
									const double dstQuad[4][2], int interpolation)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiWarpBilinearQuad_32f_C1R(pSrc, srcSize, srcStep, srcRoi, srcQuad, pDst, dstStep, dstRoi, dstQuad, interpolation);
    default:
        assert(false);
        return _refr_fwiWarpBilinearQuad_32f_C1R(pSrc, srcSize, srcStep, srcRoi, srcQuad, pDst, dstStep, dstRoi, dstQuad, interpolation);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiFilterPrewittVert_32f_C3R( const Fw32f * pSrc, int srcStep, Fw32f * pDst, int dstStep, FwiSize dstRoiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilterPrewittVert_32f_C3R(pSrc, srcStep, pDst, dstStep, dstRoiSize);
    case DT_REFR:
        return _refr_fwiFilterPrewittVert_32f_C3R(pSrc, srcStep, pDst, dstStep, dstRoiSize);
    default:
        assert(false);
        return _refr_fwiFilterPrewittVert_32f_C3R(pSrc, srcStep, pDst, dstStep, dstRoiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiMul_32fc_AC4IR( const Fw32fc *pSrc,  int srcStep,        Fw32fc *pSrcDst, int srcDstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiMul_32fc_AC4IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiMul_32fc_AC4IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    case DT_REFR:
        return _refr_fwiMul_32fc_AC4IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiMul_32fc_AC4IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiDivC_16s_C1IRSfs(       Fw16s value,    Fw16s *pSrcDst, int srcDstStep, FwiSize roiSize, int scaleFactor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiDivC_16s_C1IRSfs(value, pSrcDst, srcDstStep, roiSize, scaleFactor);
    case DT_SSE2:
        return _sse2_fwiDivC_16s_C1IRSfs(value, pSrcDst, srcDstStep, roiSize, scaleFactor);
    case DT_REFR:
        return _refr_fwiDivC_16s_C1IRSfs(value, pSrcDst, srcDstStep, roiSize, scaleFactor);
    default:
        assert(false);
        return _refr_fwiDivC_16s_C1IRSfs(value, pSrcDst, srcDstStep, roiSize, scaleFactor);
    }
}

OREFR OSSE2 FwStatus STDCALL fwiWarpPerspectiveBack_32f_C4R( const Fw32f* pSrc, FwiSize srcSize, int srcStep,
								FwiRect srcRoi, Fw32f* pDst, int dstStep, FwiRect dstRoi,
								const double coeffs[3][3], int interpolation )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiWarpPerspectiveBack_32f_C4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, coeffs, interpolation);
    case DT_REFR:
        return _refr_fwiWarpPerspectiveBack_32f_C4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, coeffs, interpolation);
    default:
        assert(false);
        return _refr_fwiWarpPerspectiveBack_32f_C4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, coeffs, interpolation);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiOrC_8u_C3IR( const Fw8u value[3], Fw8u *pSrcDst, int srcDstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiOrC_8u_C3IR(value, pSrcDst, srcDstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiOrC_8u_C3IR(value, pSrcDst, srcDstStep, roiSize);
    case DT_REFR:
        return _refr_fwiOrC_8u_C3IR(value, pSrcDst, srcDstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiOrC_8u_C3IR(value, pSrcDst, srcDstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiSubC_8u_C1IRSfs(       Fw8u value,    Fw8u *pSrcDst, int srcDstStep, FwiSize roiSize, int scaleFactor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiSubC_8u_C1IRSfs(value, pSrcDst, srcDstStep, roiSize, scaleFactor);
    case DT_SSE2:
        return _sse2_fwiSubC_8u_C1IRSfs(value, pSrcDst, srcDstStep, roiSize, scaleFactor);
    case DT_REFR:
        return _refr_fwiSubC_8u_C1IRSfs(value, pSrcDst, srcDstStep, roiSize, scaleFactor);
    default:
        assert(false);
        return _refr_fwiSubC_8u_C1IRSfs(value, pSrcDst, srcDstStep, roiSize, scaleFactor);
    }
}

OREFR               FwStatus fwiHLSToRGB_32f_AC4R( const Fw32f* pSrc, int srcStep, Fw32f* pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiHLSToRGB_32f_AC4R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiHLSToRGB_32f_AC4R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 FwStatus STDCALL fwiFilterSharpen_16s_C3R( const Fw16s * pSrc, int srcStep, Fw16s * pDst, int dstStep, FwiSize dstRoiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilterSharpen_16s_C3R(pSrc, srcStep, pDst, dstStep, dstRoiSize);
    case DT_REFR:
        return _refr_fwiFilterSharpen_16s_C3R(pSrc, srcStep, pDst, dstStep, dstRoiSize);
    default:
        assert(false);
        return _refr_fwiFilterSharpen_16s_C3R(pSrc, srcStep, pDst, dstStep, dstRoiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiSub_8u_AC4IRSfs( const Fw8u   *pSrc,  int srcStep,        Fw8u   *pSrcDst, int srcDstStep, FwiSize roiSize, int scaleFactor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiSub_8u_AC4IRSfs(pSrc, srcStep, pSrcDst, srcDstStep, roiSize, scaleFactor);
    case DT_SSE2:
        return _sse2_fwiSub_8u_AC4IRSfs(pSrc, srcStep, pSrcDst, srcDstStep, roiSize, scaleFactor);
    case DT_REFR:
        return _refr_fwiSub_8u_AC4IRSfs(pSrc, srcStep, pSrcDst, srcDstStep, roiSize, scaleFactor);
    default:
        assert(false);
        return _refr_fwiSub_8u_AC4IRSfs(pSrc, srcStep, pSrcDst, srcDstStep, roiSize, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiThreshold_Val_8u_C1IR( Fw8u *pSrcDst, int srcDstStep, FwiSize roiSize, Fw8u threshold, Fw8u value, FwCmpOp fwCmpOp)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiThreshold_Val_8u_C1IR(pSrcDst, srcDstStep, roiSize, threshold, value, fwCmpOp);
    case DT_SSE2:
        return _sse2_fwiThreshold_Val_8u_C1IR(pSrcDst, srcDstStep, roiSize, threshold, value, fwCmpOp);
    case DT_REFR:
        return _refr_fwiThreshold_Val_8u_C1IR(pSrcDst, srcDstStep, roiSize, threshold, value, fwCmpOp);
    default:
        assert(false);
        return _refr_fwiThreshold_Val_8u_C1IR(pSrcDst, srcDstStep, roiSize, threshold, value, fwCmpOp);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiThreshold_LT_16s_AC4R( const Fw16s *pSrc, int srcStep, Fw16s *pDst, int dstStep, FwiSize roiSize, const Fw16s threshold[3])
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiThreshold_LT_16s_AC4R(pSrc, srcStep, pDst, dstStep, roiSize, threshold);
    case DT_SSE2:
        return _sse2_fwiThreshold_LT_16s_AC4R(pSrc, srcStep, pDst, dstStep, roiSize, threshold);
    case DT_REFR:
        return _refr_fwiThreshold_LT_16s_AC4R(pSrc, srcStep, pDst, dstStep, roiSize, threshold);
    default:
        assert(false);
        return _refr_fwiThreshold_LT_16s_AC4R(pSrc, srcStep, pDst, dstStep, roiSize, threshold);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiOr_8u_C3R( const Fw8u *pSrc1, int src1Step, const Fw8u *pSrc2,   int src2Step, Fw8u *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiOr_8u_C3R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiOr_8u_C3R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiOr_8u_C3R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiOr_8u_C3R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiAbsDiffC_8u_C1R( const Fw8u  *pSrc, int srcStep,  Fw8u  *pDst, int dstStep, FwiSize roiSize, int    value )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiAbsDiffC_8u_C1R(pSrc, srcStep, pDst, dstStep, roiSize, value);
    case DT_SSE2:
        return _sse2_fwiAbsDiffC_8u_C1R(pSrc, srcStep, pDst, dstStep, roiSize, value);
    case DT_REFR:
        return _refr_fwiAbsDiffC_8u_C1R(pSrc, srcStep, pDst, dstStep, roiSize, value);
    default:
        assert(false);
        return _refr_fwiAbsDiffC_8u_C1R(pSrc, srcStep, pDst, dstStep, roiSize, value);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiCompareEqualEpsC_32f_C1R( const Fw32f *pSrc, int srcStep, Fw32f value, Fw8u *pDst, int dstStep, FwiSize roiSize, Fw32f eps)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiCompareEqualEpsC_32f_C1R(pSrc, srcStep, value, pDst, dstStep, roiSize, eps);
    case DT_SSE2:
        return _sse2_fwiCompareEqualEpsC_32f_C1R(pSrc, srcStep, value, pDst, dstStep, roiSize, eps);
    case DT_REFR:
        return _refr_fwiCompareEqualEpsC_32f_C1R(pSrc, srcStep, value, pDst, dstStep, roiSize, eps);
    default:
        assert(false);
        return _refr_fwiCompareEqualEpsC_32f_C1R(pSrc, srcStep, value, pDst, dstStep, roiSize, eps);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiSubC_16s_AC4IRSfs( const Fw16s value[3], Fw16s *pSrcDst, int srcDstStep, FwiSize roiSize, int scaleFactor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiSubC_16s_AC4IRSfs(value, pSrcDst, srcDstStep, roiSize, scaleFactor);
    case DT_SSE2:
        return _sse2_fwiSubC_16s_AC4IRSfs(value, pSrcDst, srcDstStep, roiSize, scaleFactor);
    case DT_REFR:
        return _refr_fwiSubC_16s_AC4IRSfs(value, pSrcDst, srcDstStep, roiSize, scaleFactor);
    default:
        assert(false);
        return _refr_fwiSubC_16s_AC4IRSfs(value, pSrcDst, srcDstStep, roiSize, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiLShiftC_32s_AC4IR( const Fw32u value[3], Fw32s *pSrcDst, int srcDstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiLShiftC_32s_AC4IR(value, pSrcDst, srcDstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiLShiftC_32s_AC4IR(value, pSrcDst, srcDstStep, roiSize);
    case DT_REFR:
        return _refr_fwiLShiftC_32s_AC4IR(value, pSrcDst, srcDstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiLShiftC_32s_AC4IR(value, pSrcDst, srcDstStep, roiSize);
    }
}

OREFR OSSE2         FwStatus fwiMinMax_32f_C1R(const Fw32f* pSrc, int srcStep,FwiSize roiSize, Fw32f* pMin, Fw32f* pMax)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiMinMax_32f_C1R(pSrc, srcStep, roiSize, pMin, pMax);
    case DT_REFR:
        return _refr_fwiMinMax_32f_C1R(pSrc, srcStep, roiSize, pMin, pMax);
    default:
        assert(false);
        return _refr_fwiMinMax_32f_C1R(pSrc, srcStep, roiSize, pMin, pMax);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiXorC_8u_C3R( const Fw8u   *pSrc, int srcStep, const Fw8u value[3], Fw8u *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiXorC_8u_C3R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiXorC_8u_C3R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiXorC_8u_C3R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiXorC_8u_C3R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    }
}

OREFR       FwStatus STDCALL fwiShear_8u_C3R(const Fw8u* pSrc, FwiSize srcSize, int srcStep, FwiRect srcRoi, Fw8u* pDst, int dstStep, FwiRect dstRoi, double xShear, double yShear, double xShift, double yShift, int interpolation )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiShear_8u_C3R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, xShear, yShear, xShift, yShift, interpolation);
    default:
        assert(false);
        return _refr_fwiShear_8u_C3R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, xShear, yShear, xShift, yShift, interpolation);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiSet_32s_C4MR( const Fw32s  value[4], Fw32s  * pDst, int dstStep, FwiSize roiSize, const Fw8u * pMask, int maskStep )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiSet_32s_C4MR(value, pDst, dstStep, roiSize, pMask, maskStep);
    case DT_SSE2:
        return _sse2_fwiSet_32s_C4MR(value, pDst, dstStep, roiSize, pMask, maskStep);
    case DT_REFR:
        return _refr_fwiSet_32s_C4MR(value, pDst, dstStep, roiSize, pMask, maskStep);
    default:
        assert(false);
        return _refr_fwiSet_32s_C4MR(value, pDst, dstStep, roiSize, pMask, maskStep);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiAddC_32f_AC4R( const Fw32f *pSrc, int srcStep,const Fw32f value[3], Fw32f *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiAddC_32f_AC4R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiAddC_32f_AC4R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiAddC_32f_AC4R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiAddC_32f_AC4R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2         FwStatus fwiMinMax_16s_C3R(const Fw16s* pSrc, int srcStep,FwiSize roiSize, Fw16s min[3], Fw16s max[3])
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiMinMax_16s_C3R(pSrc, srcStep, roiSize, min, max);
    case DT_REFR:
        return _refr_fwiMinMax_16s_C3R(pSrc, srcStep, roiSize, min, max);
    default:
        assert(false);
        return _refr_fwiMinMax_16s_C3R(pSrc, srcStep, roiSize, min, max);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiSub_32f_C4IR( const Fw32f  *pSrc,  int srcStep,        Fw32f  *pSrcDst, int srcDstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiSub_32f_C4IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiSub_32f_C4IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    case DT_REFR:
        return _refr_fwiSub_32f_C4IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiSub_32f_C4IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    }
}

OREFR               FwStatus fwiRGBToYCbCr422_8u_P3C2R(const A8U* const pSrc[3], int srcStep, A8U* pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiRGBToYCbCr422_8u_P3C2R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiRGBToYCbCr422_8u_P3C2R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiFilterSobelHoriz_32f_C1R( const Fw32f * pSrc, int srcStep, Fw32f * pDst, int dstStep, FwiSize dstRoiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilterSobelHoriz_32f_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize);
    case DT_REFR:
        return _refr_fwiFilterSobelHoriz_32f_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize);
    default:
        assert(false);
        return _refr_fwiFilterSobelHoriz_32f_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiThreshold_LTVal_16s_AC4R( const Fw16s *pSrc, int srcStep, Fw16s *pDst, int dstStep, FwiSize roiSize, const Fw16s threshold[3], const Fw16s value[3])
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiThreshold_LTVal_16s_AC4R(pSrc, srcStep, pDst, dstStep, roiSize, threshold, value);
    case DT_SSE2:
        return _sse2_fwiThreshold_LTVal_16s_AC4R(pSrc, srcStep, pDst, dstStep, roiSize, threshold, value);
    case DT_REFR:
        return _refr_fwiThreshold_LTVal_16s_AC4R(pSrc, srcStep, pDst, dstStep, roiSize, threshold, value);
    default:
        assert(false);
        return _refr_fwiThreshold_LTVal_16s_AC4R(pSrc, srcStep, pDst, dstStep, roiSize, threshold, value);
    }
}

OREFR OSSE2 FwStatus STDCALL fwiWarpPerspective_8u_AC4R( const Fw8u* pSrc, FwiSize srcSize, int srcStep,
								FwiRect srcRoi, Fw8u* pDst, int dstStep, FwiRect dstRoi,
								const double coeffs[3][3], int interpolation )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiWarpPerspective_8u_AC4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, coeffs, interpolation);
    case DT_REFR:
        return _refr_fwiWarpPerspective_8u_AC4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, coeffs, interpolation);
    default:
        assert(false);
        return _refr_fwiWarpPerspective_8u_AC4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, coeffs, interpolation);
    }
}

OREFR       FwStatus STDCALL fwiWarpBilinearQuad_8u_C3R(const Fw8u* pSrc, FwiSize srcSize, int srcStep, FwiRect srcRoi,
							        const double srcQuad[4][2], Fw8u* pDst, int dstStep, FwiRect dstRoi,
									const double dstQuad[4][2], int interpolation)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiWarpBilinearQuad_8u_C3R(pSrc, srcSize, srcStep, srcRoi, srcQuad, pDst, dstStep, dstRoi, dstQuad, interpolation);
    default:
        assert(false);
        return _refr_fwiWarpBilinearQuad_8u_C3R(pSrc, srcSize, srcStep, srcRoi, srcQuad, pDst, dstStep, dstRoi, dstQuad, interpolation);
    }
}


OREFR OSSE2 OF10H   FwStatus fwiXYZToRGB_8u_C3R( const Fw8u* pSrc, int srcStep, Fw8u* pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiXYZToRGB_8u_C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiXYZToRGB_8u_C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiXYZToRGB_8u_C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiXYZToRGB_8u_C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiSet_16s_C1MR(       Fw16s  value,    Fw16s  * pDst, int dstStep, FwiSize roiSize, const Fw8u * pMask, int maskStep )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiSet_16s_C1MR(value, pDst, dstStep, roiSize, pMask, maskStep);
    case DT_SSE2:
        return _sse2_fwiSet_16s_C1MR(value, pDst, dstStep, roiSize, pMask, maskStep);
    case DT_REFR:
        return _refr_fwiSet_16s_C1MR(value, pDst, dstStep, roiSize, pMask, maskStep);
    default:
        assert(false);
        return _refr_fwiSet_16s_C1MR(value, pDst, dstStep, roiSize, pMask, maskStep);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiFilterMax_8u_C4R( const Fw8u * pSrc, int srcStep,
                               Fw8u * pDst, int dstStep, FwiSize dstRoiSize,
                               FwiSize maskSize, FwiPoint anchor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilterMax_8u_C4R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize, anchor);
    case DT_REFR:
        return _refr_fwiFilterMax_8u_C4R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize, anchor);
    default:
        assert(false);
        return _refr_fwiFilterMax_8u_C4R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize, anchor);
    }
}

OREFR OSSE2 FwStatus STDCALL fwiResizeShift_32f_AC4R( const Fw32f* pSrc, FwiSize srcSize, int srcStep, FwiRect srcRoi,
								   Fw32f* pDst, int dstStep, FwiSize dstRoiSize,
								   double xFr, double yFr, double xShift, double yShift, int interpolation )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiResizeShift_32f_AC4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoiSize, xFr, yFr, xShift, yShift, interpolation);
    case DT_REFR:
        return _refr_fwiResizeShift_32f_AC4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoiSize, xFr, yFr, xShift, yShift, interpolation);
    default:
        assert(false);
        return _refr_fwiResizeShift_32f_AC4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoiSize, xFr, yFr, xShift, yShift, interpolation);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiMirror_8u_C1IR(Fw8u  *pSrcDst, int srcDstStep, FwiSize roiSize, FwiAxis flip)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiMirror_8u_C1IR(pSrcDst, srcDstStep, roiSize, flip);
    case DT_REFR:
        return _refr_fwiMirror_8u_C1IR(pSrcDst, srcDstStep, roiSize, flip);
    default:
        assert(false);
        return _refr_fwiMirror_8u_C1IR(pSrcDst, srcDstStep, roiSize, flip);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiThreshold_LTVal_32f_C4R( const Fw32f *pSrc, int srcStep, Fw32f *pDst, int dstStep, FwiSize roiSize, const Fw32f threshold[4], const Fw32f value[4])
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiThreshold_LTVal_32f_C4R(pSrc, srcStep, pDst, dstStep, roiSize, threshold, value);
    case DT_SSE2:
        return _sse2_fwiThreshold_LTVal_32f_C4R(pSrc, srcStep, pDst, dstStep, roiSize, threshold, value);
    case DT_REFR:
        return _refr_fwiThreshold_LTVal_32f_C4R(pSrc, srcStep, pDst, dstStep, roiSize, threshold, value);
    default:
        assert(false);
        return _refr_fwiThreshold_LTVal_32f_C4R(pSrc, srcStep, pDst, dstStep, roiSize, threshold, value);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiCopy_32f_AC4MR( const Fw32f *pSrc, int srcStep, Fw32f *pDst, int dstStep, FwiSize roiSize, const Fw8u *pMask, int maskStep )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiCopy_32f_AC4MR(pSrc, srcStep, pDst, dstStep, roiSize, pMask, maskStep);
    case DT_SSE2:
        return _sse2_fwiCopy_32f_AC4MR(pSrc, srcStep, pDst, dstStep, roiSize, pMask, maskStep);
    case DT_REFR:
        return _refr_fwiCopy_32f_AC4MR(pSrc, srcStep, pDst, dstStep, roiSize, pMask, maskStep);
    default:
        assert(false);
        return _refr_fwiCopy_32f_AC4MR(pSrc, srcStep, pDst, dstStep, roiSize, pMask, maskStep);
    }
}

OREFR               FwStatus fwiYCCToRGB_16s_C3R( const Fw16s* pSrc, int srcStep, Fw16s* pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiYCCToRGB_16s_C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiYCCToRGB_16s_C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiConvert_32f16u_C4R( const Fw32f *pSrc, int srcStep, Fw16u *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiConvert_32f16u_C4R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiConvert_32f16u_C4R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiConvert_32f16u_C4R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiConvert_32f16u_C4R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiDivC_32sc_AC4RSfs( const Fw32sc *pSrc, int srcStep, const Fw32sc value[3], Fw32sc *pDst, int dstStep, FwiSize roiSize, int scaleFactor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiDivC_32sc_AC4RSfs(pSrc, srcStep, value, pDst, dstStep, roiSize, scaleFactor);
    case DT_SSE2:
        return _sse2_fwiDivC_32sc_AC4RSfs(pSrc, srcStep, value, pDst, dstStep, roiSize, scaleFactor);
    case DT_REFR:
        return _refr_fwiDivC_32sc_AC4RSfs(pSrc, srcStep, value, pDst, dstStep, roiSize, scaleFactor);
    default:
        assert(false);
        return _refr_fwiDivC_32sc_AC4RSfs(pSrc, srcStep, value, pDst, dstStep, roiSize, scaleFactor);
    }
}

OREFR OSSE2 FwStatus STDCALL fwiWarpPerspective_32f_AC4R( const Fw32f* pSrc, FwiSize srcSize, int srcStep,
								FwiRect srcRoi, Fw32f* pDst, int dstStep, FwiRect dstRoi,
								const double coeffs[3][3], int interpolation )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiWarpPerspective_32f_AC4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, coeffs, interpolation);
    case DT_REFR:
        return _refr_fwiWarpPerspective_32f_AC4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, coeffs, interpolation);
    default:
        assert(false);
        return _refr_fwiWarpPerspective_32f_AC4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, coeffs, interpolation);
    }
}

OREFR               FwStatus fwiLabToBGR_16u8u_C3R( const Fw16u* pSrc, int srcStep, Fw8u* pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiLabToBGR_16u8u_C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiLabToBGR_16u8u_C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiFilterColumn_32f_AC4R( const Fw32f * pSrc, int srcStep,
                              Fw32f * pDst, int dstStep, FwiSize dstRoiSize,
                              const Fw32f * pKernel, int kernelSize,
                              int yAnchor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilterColumn_32f_AC4R(pSrc, srcStep, pDst, dstStep, dstRoiSize, pKernel, kernelSize, yAnchor);
    case DT_REFR:
        return _refr_fwiFilterColumn_32f_AC4R(pSrc, srcStep, pDst, dstStep, dstRoiSize, pKernel, kernelSize, yAnchor);
    default:
        assert(false);
        return _refr_fwiFilterColumn_32f_AC4R(pSrc, srcStep, pDst, dstStep, dstRoiSize, pKernel, kernelSize, yAnchor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiSub_32sc_AC4IRSfs( const Fw32sc *pSrc,  int srcStep,        Fw32sc *pSrcDst, int srcDstStep, FwiSize roiSize, int scaleFactor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiSub_32sc_AC4IRSfs(pSrc, srcStep, pSrcDst, srcDstStep, roiSize, scaleFactor);
    case DT_SSE2:
        return _sse2_fwiSub_32sc_AC4IRSfs(pSrc, srcStep, pSrcDst, srcDstStep, roiSize, scaleFactor);
    case DT_REFR:
        return _refr_fwiSub_32sc_AC4IRSfs(pSrc, srcStep, pSrcDst, srcDstStep, roiSize, scaleFactor);
    default:
        assert(false);
        return _refr_fwiSub_32sc_AC4IRSfs(pSrc, srcStep, pSrcDst, srcDstStep, roiSize, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiCopy_16s_AC4MR( const Fw16s *pSrc, int srcStep, Fw16s *pDst, int dstStep, FwiSize roiSize, const Fw8u *pMask, int maskStep )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiCopy_16s_AC4MR(pSrc, srcStep, pDst, dstStep, roiSize, pMask, maskStep);
    case DT_SSE2:
        return _sse2_fwiCopy_16s_AC4MR(pSrc, srcStep, pDst, dstStep, roiSize, pMask, maskStep);
    case DT_REFR:
        return _refr_fwiCopy_16s_AC4MR(pSrc, srcStep, pDst, dstStep, roiSize, pMask, maskStep);
    default:
        assert(false);
        return _refr_fwiCopy_16s_AC4MR(pSrc, srcStep, pDst, dstStep, roiSize, pMask, maskStep);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiConvert_32s8u_C4R( const Fw32s *pSrc, int srcStep, Fw8u *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiConvert_32s8u_C4R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiConvert_32s8u_C4R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiConvert_32s8u_C4R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiConvert_32s8u_C4R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR               FwStatus fwiYCbCrToBGR555_8u16u_P3C3R(const A8U* const pSrc[3], int srcStep, A16U* pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiYCbCrToBGR555_8u16u_P3C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiYCbCrToBGR555_8u16u_P3C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiCopy_32f_P4C4R( const Fw32f * const pSrc[4], int srcStep, Fw32f *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiCopy_32f_P4C4R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiCopy_32f_P4C4R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiCopy_32f_P4C4R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiCopy_32f_P4C4R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiDivC_16s_C3IRSfs( const Fw16s value[3], Fw16s *pSrcDst, int srcDstStep, FwiSize roiSize, int scaleFactor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiDivC_16s_C3IRSfs(value, pSrcDst, srcDstStep, roiSize, scaleFactor);
    case DT_SSE2:
        return _sse2_fwiDivC_16s_C3IRSfs(value, pSrcDst, srcDstStep, roiSize, scaleFactor);
    case DT_REFR:
        return _refr_fwiDivC_16s_C3IRSfs(value, pSrcDst, srcDstStep, roiSize, scaleFactor);
    default:
        assert(false);
        return _refr_fwiDivC_16s_C3IRSfs(value, pSrcDst, srcDstStep, roiSize, scaleFactor);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiMirror_8u_C3IR(Fw8u  *pSrcDst, int srcDstStep, FwiSize roiSize, FwiAxis flip)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiMirror_8u_C3IR(pSrcDst, srcDstStep, roiSize, flip);
    case DT_REFR:
        return _refr_fwiMirror_8u_C3IR(pSrcDst, srcDstStep, roiSize, flip);
    default:
        assert(false);
        return _refr_fwiMirror_8u_C3IR(pSrcDst, srcDstStep, roiSize, flip);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiConvert_8s32s_C3R( const Fw8s *pSrc, int srcStep, Fw32s *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiConvert_8s32s_C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiConvert_8s32s_C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiConvert_8s32s_C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiConvert_8s32s_C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiMul_32f_C1R( const Fw32f  *pSrc1, int src1Step, const Fw32f  *pSrc2,   int src2Step, Fw32f  *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiMul_32f_C1R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiMul_32f_C1R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiMul_32f_C1R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiMul_32f_C1R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiRotate_32f_C4R( const Fw32f* pSrc, FwiSize srcSize, int srcStep, FwiRect srcRoi, Fw32f* pDst, int dstStep, FwiRect dstRoi, double angle, double xShift, double yShift, int interpolation )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiRotate_32f_C4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, angle, xShift, yShift, interpolation);
    case DT_REFR:
        return _refr_fwiRotate_32f_C4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, angle, xShift, yShift, interpolation);
    default:
        assert(false);
        return _refr_fwiRotate_32f_C4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, angle, xShift, yShift, interpolation);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiSub_32f_AC4IR( const Fw32f  *pSrc,  int srcStep,        Fw32f  *pSrcDst, int srcDstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiSub_32f_AC4IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiSub_32f_AC4IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    case DT_REFR:
        return _refr_fwiSub_32f_AC4IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiSub_32f_AC4IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    }
}

OREFR             FwStatus STDCALL fwiScale_8u16s_AC4R( const Fw8u * pSrc, int srcStep, Fw16s * pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiScale_8u16s_AC4R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiScale_8u16s_AC4R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR             FwStatus STDCALL fwiCopy_8u_C3AC4R( const Fw8u *pSrc, int srcStep, Fw8u *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiCopy_8u_C3AC4R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiCopy_8u_C3AC4R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiFilterBox_16s_C3R( const Fw16s * pSrc, int srcStep,
                               Fw16s * pDst, int dstStep, FwiSize dstRoiSize,
                               FwiSize maskSize, FwiPoint anchor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilterBox_16s_C3R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize, anchor);
    case DT_REFR:
        return _refr_fwiFilterBox_16s_C3R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize, anchor);
    default:
        assert(false);
        return _refr_fwiFilterBox_16s_C3R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize, anchor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiAddC_32fc_C3R( const Fw32fc  *pSrc, int srcStep,const Fw32fc  value[3], Fw32fc  *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiAddC_32fc_C3R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiAddC_32fc_C3R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiAddC_32fc_C3R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiAddC_32fc_C3R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiSqr_32f_AC4R( const Fw32f *pSrc,    int srcStep, Fw32f *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiSqr_32f_AC4R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiSqr_32f_AC4R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiSqr_32f_AC4R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiSqr_32f_AC4R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiCopy_32s_AC4C3R( const Fw32s *pSrc, int srcStep, Fw32s *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiCopy_32s_AC4C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiCopy_32s_AC4C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiCopy_32s_AC4C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiCopy_32s_AC4C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiSet_32s_C1R(       Fw32s  value,    Fw32s  * pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiSet_32s_C1R(value, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiSet_32s_C1R(value, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiSet_32s_C1R(value, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiSet_32s_C1R(value, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiAddWeighted_8u32f_C1IR( const Fw8u *pSrc,  int srcStep, Fw32f* pSrcDst, int srcDstStep, FwiSize roiSize, Fw32f alpha)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiAddWeighted_8u32f_C1IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize, alpha);
    case DT_SSE2:
        return _sse2_fwiAddWeighted_8u32f_C1IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize, alpha);
    case DT_REFR:
        return _refr_fwiAddWeighted_8u32f_C1IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize, alpha);
    default:
        assert(false);
        return _refr_fwiAddWeighted_8u32f_C1IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize, alpha);
    }
}

OREFR OSSE2 FwStatus STDCALL fwiResizeShift_8u_C3R( const Fw8u* pSrc, FwiSize srcSize, int srcStep, FwiRect srcRoi,
								 Fw8u* pDst, int dstStep, FwiSize dstRoiSize,
								 double xFr, double yFr, double xShift, double yShift, int interpolation )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiResizeShift_8u_C3R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoiSize, xFr, yFr, xShift, yShift, interpolation);
    case DT_REFR:
        return _refr_fwiResizeShift_8u_C3R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoiSize, xFr, yFr, xShift, yShift, interpolation);
    default:
        assert(false);
        return _refr_fwiResizeShift_8u_C3R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoiSize, xFr, yFr, xShift, yShift, interpolation);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiRotateCenter_32f_C1R( const Fw32f* pSrc,FwiSize srcSize, int srcStep, FwiRect srcRoi, Fw32f* pDst, int dstStep, FwiRect dstRoi, double angle, double xCenter, double yCenter, int interpolation )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiRotateCenter_32f_C1R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, angle, xCenter, yCenter, interpolation);
    case DT_REFR:
        return _refr_fwiRotateCenter_32f_C1R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, angle, xCenter, yCenter, interpolation);
    default:
        assert(false);
        return _refr_fwiRotateCenter_32f_C1R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, angle, xCenter, yCenter, interpolation);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiAddC_32sc_C1RSfs( const Fw32sc *pSrc, int srcStep,       Fw32sc value,    Fw32sc *pDst, int dstStep, FwiSize roiSize, int scaleFactor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiAddC_32sc_C1RSfs(pSrc, srcStep, value, pDst, dstStep, roiSize, scaleFactor);
    case DT_SSE2:
        return _sse2_fwiAddC_32sc_C1RSfs(pSrc, srcStep, value, pDst, dstStep, roiSize, scaleFactor);
    case DT_REFR:
        return _refr_fwiAddC_32sc_C1RSfs(pSrc, srcStep, value, pDst, dstStep, roiSize, scaleFactor);
    default:
        assert(false);
        return _refr_fwiAddC_32sc_C1RSfs(pSrc, srcStep, value, pDst, dstStep, roiSize, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiCopy_16s_AC4R( const Fw16s *pSrc, int srcStep, Fw16s *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiCopy_16s_AC4R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiCopy_16s_AC4R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiCopy_16s_AC4R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiCopy_16s_AC4R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiFilterMax_16s_AC4R( const Fw16s * pSrc, int srcStep,
                               Fw16s * pDst, int dstStep, FwiSize dstRoiSize,
                               FwiSize maskSize, FwiPoint anchor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilterMax_16s_AC4R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize, anchor);
    case DT_REFR:
        return _refr_fwiFilterMax_16s_AC4R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize, anchor);
    default:
        assert(false);
        return _refr_fwiFilterMax_16s_AC4R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize, anchor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiAddWeighted_16u32f_C1IMR( const Fw16u *pSrc, int srcStep, const Fw8u* pMask, int maskStep, Fw32f* pSrcDst, int srcDstStep, FwiSize roiSize, Fw32f alpha)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiAddWeighted_16u32f_C1IMR(pSrc, srcStep, pMask, maskStep, pSrcDst, srcDstStep, roiSize, alpha);
    case DT_SSE2:
        return _sse2_fwiAddWeighted_16u32f_C1IMR(pSrc, srcStep, pMask, maskStep, pSrcDst, srcDstStep, roiSize, alpha);
    case DT_REFR:
        return _refr_fwiAddWeighted_16u32f_C1IMR(pSrc, srcStep, pMask, maskStep, pSrcDst, srcDstStep, roiSize, alpha);
    default:
        assert(false);
        return _refr_fwiAddWeighted_16u32f_C1IMR(pSrc, srcStep, pMask, maskStep, pSrcDst, srcDstStep, roiSize, alpha);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiFilterPrewittHoriz_16s_AC4R( const Fw16s * pSrc, int srcStep, Fw16s * pDst, int dstStep, FwiSize dstRoiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilterPrewittHoriz_16s_AC4R(pSrc, srcStep, pDst, dstStep, dstRoiSize);
    case DT_REFR:
        return _refr_fwiFilterPrewittHoriz_16s_AC4R(pSrc, srcStep, pDst, dstStep, dstRoiSize);
    default:
        assert(false);
        return _refr_fwiFilterPrewittHoriz_16s_AC4R(pSrc, srcStep, pDst, dstStep, dstRoiSize);
    }
}

OREFR OSSE2 FwStatus STDCALL fwiFilterSharpen_32f_C4R( const Fw32f * pSrc, int srcStep, Fw32f * pDst, int dstStep, FwiSize dstRoiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilterSharpen_32f_C4R(pSrc, srcStep, pDst, dstStep, dstRoiSize);
    case DT_REFR:
        return _refr_fwiFilterSharpen_32f_C4R(pSrc, srcStep, pDst, dstStep, dstRoiSize);
    default:
        assert(false);
        return _refr_fwiFilterSharpen_32f_C4R(pSrc, srcStep, pDst, dstStep, dstRoiSize);
    }
}

OREFR               FwStatus fwiRGBToXYZ_16s_AC4R( const Fw16s* pSrc, int srcStep, Fw16s* pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiRGBToXYZ_16s_AC4R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiRGBToXYZ_16s_AC4R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiMirror_16u_AC4R( const Fw16u *pSrc, int srcStep, Fw16u *pDst, int dstStep, FwiSize roiSize, FwiAxis flip)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiMirror_16u_AC4R(pSrc, srcStep, pDst, dstStep, roiSize, flip);
    case DT_REFR:
        return _refr_fwiMirror_16u_AC4R(pSrc, srcStep, pDst, dstStep, roiSize, flip);
    default:
        assert(false);
        return _refr_fwiMirror_16u_AC4R(pSrc, srcStep, pDst, dstStep, roiSize, flip);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiThreshold_LTValGTVal_16s_C3IR( Fw16s *pSrcDst, int srcDstStep, FwiSize roiSize, const Fw16s thresholdLT[3], const Fw16s valueLT[3], const Fw16s thresholdGT[3], const Fw16s valueGT[3])
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiThreshold_LTValGTVal_16s_C3IR(pSrcDst, srcDstStep, roiSize, thresholdLT, valueLT, thresholdGT, valueGT);
    case DT_SSE2:
        return _sse2_fwiThreshold_LTValGTVal_16s_C3IR(pSrcDst, srcDstStep, roiSize, thresholdLT, valueLT, thresholdGT, valueGT);
    case DT_REFR:
        return _refr_fwiThreshold_LTValGTVal_16s_C3IR(pSrcDst, srcDstStep, roiSize, thresholdLT, valueLT, thresholdGT, valueGT);
    default:
        assert(false);
        return _refr_fwiThreshold_LTValGTVal_16s_C3IR(pSrcDst, srcDstStep, roiSize, thresholdLT, valueLT, thresholdGT, valueGT);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiFilterLaplace_32f_AC4R( const Fw32f * pSrc, int srcStep, Fw32f * pDst, int dstStep, FwiSize dstRoiSize, FwiMaskSize maskSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilterLaplace_32f_AC4R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize);
    case DT_REFR:
        return _refr_fwiFilterLaplace_32f_AC4R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize);
    default:
        assert(false);
        return _refr_fwiFilterLaplace_32f_AC4R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiAndC_16u_C3IR( const Fw16u value[3], Fw16u *pSrcDst, int srcDstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiAndC_16u_C3IR(value, pSrcDst, srcDstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiAndC_16u_C3IR(value, pSrcDst, srcDstStep, roiSize);
    case DT_REFR:
        return _refr_fwiAndC_16u_C3IR(value, pSrcDst, srcDstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiAndC_16u_C3IR(value, pSrcDst, srcDstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiOr_8u_AC4IR( const Fw8u	*pSrc,  int srcStep,        Fw8u *pSrcDst, int srcDstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiOr_8u_AC4IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiOr_8u_AC4IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    case DT_REFR:
        return _refr_fwiOr_8u_AC4IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiOr_8u_AC4IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiSqrt_16s_AC4RSfs( const Fw16s *pSrc,    int srcStep, Fw16s *pDst, int dstStep, FwiSize roiSize, int scaleFactor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiSqrt_16s_AC4RSfs(pSrc, srcStep, pDst, dstStep, roiSize, scaleFactor);
    case DT_SSE2:
        return _sse2_fwiSqrt_16s_AC4RSfs(pSrc, srcStep, pDst, dstStep, roiSize, scaleFactor);
    case DT_REFR:
        return _refr_fwiSqrt_16s_AC4RSfs(pSrc, srcStep, pDst, dstStep, roiSize, scaleFactor);
    default:
        assert(false);
        return _refr_fwiSqrt_16s_AC4RSfs(pSrc, srcStep, pDst, dstStep, roiSize, scaleFactor);
    }
}


OREFR OSSE2 FwStatus STDCALL fwiResizeCenter_8u_P3R( const Fw8u* const pSrc[3], FwiSize srcSize, int srcStep, FwiRect srcRoi,
								  Fw8u* const pDst[3], int dstStep, FwiSize dstRoiSize,
								  double xFactor, double yFactor, double xCenter, double yCenter, int interpolation )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiResizeCenter_8u_P3R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoiSize, xFactor, yFactor, xCenter, yCenter, interpolation);
    case DT_REFR:
        return _refr_fwiResizeCenter_8u_P3R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoiSize, xFactor, yFactor, xCenter, yCenter, interpolation);
    default:
        assert(false);
        return _refr_fwiResizeCenter_8u_P3R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoiSize, xFactor, yFactor, xCenter, yCenter, interpolation);
    }
}

OREFR       FwStatus STDCALL fwiWarpBilinearBack_32f_P4R(const Fw32f* const pSrc[4], FwiSize srcSize, int srcStep,
								FwiRect srcRoi, Fw32f* const pDst[4], int dstStep, FwiRect dstRoi,
								const double coeffs[2][4], int interpolation)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiWarpBilinearBack_32f_P4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, coeffs, interpolation);
    default:
        assert(false);
        return _refr_fwiWarpBilinearBack_32f_P4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, coeffs, interpolation);
    }
}

OREFR OSSE2         FwStatus fwiMinMax_8u_AC4R(const Fw8u* pSrc, int srcStep,FwiSize roiSize, Fw8u min[3], Fw8u max[3])
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiMinMax_8u_AC4R(pSrc, srcStep, roiSize, min, max);
    case DT_REFR:
        return _refr_fwiMinMax_8u_AC4R(pSrc, srcStep, roiSize, min, max);
    default:
        assert(false);
        return _refr_fwiMinMax_8u_AC4R(pSrc, srcStep, roiSize, min, max);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiThreshold_LTVal_32f_AC4IR( Fw32f *pSrcDst, int srcDstStep, FwiSize roiSize, const Fw32f threshold[3], const Fw32f value[3])
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiThreshold_LTVal_32f_AC4IR(pSrcDst, srcDstStep, roiSize, threshold, value);
    case DT_SSE2:
        return _sse2_fwiThreshold_LTVal_32f_AC4IR(pSrcDst, srcDstStep, roiSize, threshold, value);
    case DT_REFR:
        return _refr_fwiThreshold_LTVal_32f_AC4IR(pSrcDst, srcDstStep, roiSize, threshold, value);
    default:
        assert(false);
        return _refr_fwiThreshold_LTVal_32f_AC4IR(pSrcDst, srcDstStep, roiSize, threshold, value);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiThreshold_GTVal_32f_C3R( const Fw32f *pSrc, int srcStep, Fw32f *pDst, int dstStep, FwiSize roiSize, const Fw32f threshold[3], const Fw32f value[3])
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiThreshold_GTVal_32f_C3R(pSrc, srcStep, pDst, dstStep, roiSize, threshold, value);
    case DT_SSE2:
        return _sse2_fwiThreshold_GTVal_32f_C3R(pSrc, srcStep, pDst, dstStep, roiSize, threshold, value);
    case DT_REFR:
        return _refr_fwiThreshold_GTVal_32f_C3R(pSrc, srcStep, pDst, dstStep, roiSize, threshold, value);
    default:
        assert(false);
        return _refr_fwiThreshold_GTVal_32f_C3R(pSrc, srcStep, pDst, dstStep, roiSize, threshold, value);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiOrC_16u_C4IR( const Fw16u value[4], Fw16u *pSrcDst, int srcDstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiOrC_16u_C4IR(value, pSrcDst, srcDstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiOrC_16u_C4IR(value, pSrcDst, srcDstStep, roiSize);
    case DT_REFR:
        return _refr_fwiOrC_16u_C4IR(value, pSrcDst, srcDstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiOrC_16u_C4IR(value, pSrcDst, srcDstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiOrC_8u_C1IR(       Fw8u value,    Fw8u *pSrcDst, int srcDstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiOrC_8u_C1IR(value, pSrcDst, srcDstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiOrC_8u_C1IR(value, pSrcDst, srcDstStep, roiSize);
    case DT_REFR:
        return _refr_fwiOrC_8u_C1IR(value, pSrcDst, srcDstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiOrC_8u_C1IR(value, pSrcDst, srcDstStep, roiSize);
    }
}

OREFR               FwStatus fwiHLSToBGR_8u_P3R(const A8U* const pSrc[3], int srcStep, A8U* const pDst[3], int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiHLSToBGR_8u_P3R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiHLSToBGR_8u_P3R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiRShiftC_32s_C1R( const Fw32s  *pSrc, int srcStep,       Fw32u value,    Fw32s *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiRShiftC_32s_C1R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiRShiftC_32s_C1R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiRShiftC_32s_C1R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiRShiftC_32s_C1R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiAnd_16u_C4IR( const Fw16u *pSrc,  int srcStep,        Fw16u *pSrcDst, int srcDstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiAnd_16u_C4IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiAnd_16u_C4IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    case DT_REFR:
        return _refr_fwiAnd_16u_C4IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiAnd_16u_C4IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiFilter_32f_AC4R( const Fw32f * pSrc, int srcStep,
                              Fw32f * pDst, int dstStep, FwiSize dstRoiSize,
                              const Fw32f * pKernel, FwiSize kernelSize,
                              FwiPoint anchor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilter_32f_AC4R(pSrc, srcStep, pDst, dstStep, dstRoiSize, pKernel, kernelSize, anchor);
    case DT_REFR:
        return _refr_fwiFilter_32f_AC4R(pSrc, srcStep, pDst, dstStep, dstRoiSize, pKernel, kernelSize, anchor);
    default:
        assert(false);
        return _refr_fwiFilter_32f_AC4R(pSrc, srcStep, pDst, dstStep, dstRoiSize, pKernel, kernelSize, anchor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiThreshold_GTVal_16s_AC4IR( Fw16s *pSrcDst, int srcDstStep, FwiSize roiSize, const Fw16s threshold[3], const Fw16s value[3])
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiThreshold_GTVal_16s_AC4IR(pSrcDst, srcDstStep, roiSize, threshold, value);
    case DT_SSE2:
        return _sse2_fwiThreshold_GTVal_16s_AC4IR(pSrcDst, srcDstStep, roiSize, threshold, value);
    case DT_REFR:
        return _refr_fwiThreshold_GTVal_16s_AC4IR(pSrcDst, srcDstStep, roiSize, threshold, value);
    default:
        assert(false);
        return _refr_fwiThreshold_GTVal_16s_AC4IR(pSrcDst, srcDstStep, roiSize, threshold, value);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiConvert_16u32f_C1R( const Fw16u *pSrc, int srcStep, Fw32f *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiConvert_16u32f_C1R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiConvert_16u32f_C1R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiConvert_16u32f_C1R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiConvert_16u32f_C1R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiXor_32s_C1IR( const Fw32s *pSrc,  int srcStep,        Fw32s *pSrcDst, int srcDstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiXor_32s_C1IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiXor_32s_C1IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    case DT_REFR:
        return _refr_fwiXor_32s_C1IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiXor_32s_C1IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    }
}

OREFR       FwStatus STDCALL fwiWarpBilinearQuad_32f_P4R(const Fw32f* const pSrc[4], FwiSize srcSize, int srcStep, FwiRect srcRoi,
							        const double srcQuad[4][2], Fw32f* const pDst[4], int dstStep, FwiRect dstRoi,
									const double dstQuad[4][2], int interpolation)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiWarpBilinearQuad_32f_P4R(pSrc, srcSize, srcStep, srcRoi, srcQuad, pDst, dstStep, dstRoi, dstQuad, interpolation);
    default:
        assert(false);
        return _refr_fwiWarpBilinearQuad_32f_P4R(pSrc, srcSize, srcStep, srcRoi, srcQuad, pDst, dstStep, dstRoi, dstQuad, interpolation);
    }
}

OREFR               FwStatus fwiRGBToXYZ_16u_AC4R( const Fw16u* pSrc, int srcStep, Fw16u* pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiRGBToXYZ_16u_AC4R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiRGBToXYZ_16u_AC4R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR               FwStatus fwiHLSToRGB_16u_AC4R( const Fw16u* pSrc, int srcStep, Fw16u* pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiHLSToRGB_16u_AC4R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiHLSToRGB_16u_AC4R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiLn_8u_C1IRSfs(       Fw8u  *pSrcDst,  int srcDstStep, FwiSize roiSize, int scaleFactor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiLn_8u_C1IRSfs(pSrcDst, srcDstStep, roiSize, scaleFactor);
    case DT_SSE2:
        return _sse2_fwiLn_8u_C1IRSfs(pSrcDst, srcDstStep, roiSize, scaleFactor);
    case DT_REFR:
        return _refr_fwiLn_8u_C1IRSfs(pSrcDst, srcDstStep, roiSize, scaleFactor);
    default:
        assert(false);
        return _refr_fwiLn_8u_C1IRSfs(pSrcDst, srcDstStep, roiSize, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiCopy_8u_C4MR( const Fw8u *pSrc, int srcStep, Fw8u *pDst, int dstStep, FwiSize roiSize, const Fw8u *pMask, int maskStep )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiCopy_8u_C4MR(pSrc, srcStep, pDst, dstStep, roiSize, pMask, maskStep);
    case DT_SSE2:
        return _sse2_fwiCopy_8u_C4MR(pSrc, srcStep, pDst, dstStep, roiSize, pMask, maskStep);
    case DT_REFR:
        return _refr_fwiCopy_8u_C4MR(pSrc, srcStep, pDst, dstStep, roiSize, pMask, maskStep);
    default:
        assert(false);
        return _refr_fwiCopy_8u_C4MR(pSrc, srcStep, pDst, dstStep, roiSize, pMask, maskStep);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiThreshold_LT_16s_AC4IR( Fw16s *pSrcDst, int srcDstStep, FwiSize roiSize, const Fw16s threshold[3])
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiThreshold_LT_16s_AC4IR(pSrcDst, srcDstStep, roiSize, threshold);
    case DT_SSE2:
        return _sse2_fwiThreshold_LT_16s_AC4IR(pSrcDst, srcDstStep, roiSize, threshold);
    case DT_REFR:
        return _refr_fwiThreshold_LT_16s_AC4IR(pSrcDst, srcDstStep, roiSize, threshold);
    default:
        assert(false);
        return _refr_fwiThreshold_LT_16s_AC4IR(pSrcDst, srcDstStep, roiSize, threshold);
    }
}

OREFR             FwStatus STDCALL fwiConvert_8u16s_AC4R( const Fw8u *pSrc, int srcStep, Fw16s *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiConvert_8u16s_AC4R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiConvert_8u16s_AC4R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR       FwStatus STDCALL fwiWarpBilinearBack_8u_C4R(const Fw8u* pSrc, FwiSize srcSize, int srcStep,
								FwiRect srcRoi, Fw8u* pDst, int dstStep, FwiRect dstRoi,
								const double coeffs[2][4], int interpolation)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiWarpBilinearBack_8u_C4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, coeffs, interpolation);
    default:
        assert(false);
        return _refr_fwiWarpBilinearBack_8u_C4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, coeffs, interpolation);
    }
}

OREFR OSSE2         FwStatus fwiRGBToGray_32f_C3C1R(const Fw32f* pSrc, int srcStep,Fw32f* pDst, int dstStep, FwiSize roiSize)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiRGBToGray_32f_C3C1R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiRGBToGray_32f_C3C1R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiRGBToGray_32f_C3C1R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiFilterLaplace_32f_C3R( const Fw32f * pSrc, int srcStep, Fw32f * pDst, int dstStep, FwiSize dstRoiSize, FwiMaskSize maskSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilterLaplace_32f_C3R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize);
    case DT_REFR:
        return _refr_fwiFilterLaplace_32f_C3R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize);
    default:
        assert(false);
        return _refr_fwiFilterLaplace_32f_C3R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize);
    }
}

OREFR               FwStatus fwiYCbCrToBGR444_8u16u_P3C3R(const A8U* const pSrc[3], int srcStep, A16U* pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiYCbCrToBGR444_8u16u_P3C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiYCbCrToBGR444_8u16u_P3C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 FwStatus STDCALL fwiWarpAffine_32f_C4R( const Fw32f* pSrc, FwiSize srcSize, int srcStep,
								FwiRect srcRoi, Fw32f* pDst, int dstStep, FwiRect dstRoi,
								const double coeffs[2][3], int interpolation )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiWarpAffine_32f_C4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, coeffs, interpolation);
    case DT_REFR:
        return _refr_fwiWarpAffine_32f_C4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, coeffs, interpolation);
    default:
        assert(false);
        return _refr_fwiWarpAffine_32f_C4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, coeffs, interpolation);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiLShiftC_16u_C1IR(       Fw32u value,    Fw16u *pSrcDst, int srcDstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiLShiftC_16u_C1IR(value, pSrcDst, srcDstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiLShiftC_16u_C1IR(value, pSrcDst, srcDstStep, roiSize);
    case DT_REFR:
        return _refr_fwiLShiftC_16u_C1IR(value, pSrcDst, srcDstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiLShiftC_16u_C1IR(value, pSrcDst, srcDstStep, roiSize);
    }
}

OREFR OSSE2 FwStatus STDCALL fwiWarpAffineQuad_32f_C1R( const Fw32f* pSrc, FwiSize srcSize, int srcStep, FwiRect srcRoi,
							        const double srcQuad[4][2], Fw32f* pDst, int dstStep, FwiRect dstRoi,
									const double dstQuad[4][2], int interpolation )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiWarpAffineQuad_32f_C1R(pSrc, srcSize, srcStep, srcRoi, srcQuad, pDst, dstStep, dstRoi, dstQuad, interpolation);
    case DT_REFR:
        return _refr_fwiWarpAffineQuad_32f_C1R(pSrc, srcSize, srcStep, srcRoi, srcQuad, pDst, dstStep, dstRoi, dstQuad, interpolation);
    default:
        assert(false);
        return _refr_fwiWarpAffineQuad_32f_C1R(pSrc, srcSize, srcStep, srcRoi, srcQuad, pDst, dstStep, dstRoi, dstQuad, interpolation);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiXorC_16u_C3IR( const Fw16u value[3], Fw16u *pSrcDst, int srcDstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiXorC_16u_C3IR(value, pSrcDst, srcDstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiXorC_16u_C3IR(value, pSrcDst, srcDstStep, roiSize);
    case DT_REFR:
        return _refr_fwiXorC_16u_C3IR(value, pSrcDst, srcDstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiXorC_16u_C3IR(value, pSrcDst, srcDstStep, roiSize);
    }
}

OREFR               FwStatus fwiRGBToYUV420_8u_C3P3R( const A8U* pSrc, int srcStep, A8U* const pDst[3], int dstStep[3], FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiRGBToYUV420_8u_C3P3R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiRGBToYUV420_8u_C3P3R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiAndC_8u_C4IR( const Fw8u value[4], Fw8u *pSrcDst, int srcDstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiAndC_8u_C4IR(value, pSrcDst, srcDstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiAndC_8u_C4IR(value, pSrcDst, srcDstStep, roiSize);
    case DT_REFR:
        return _refr_fwiAndC_8u_C4IR(value, pSrcDst, srcDstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiAndC_8u_C4IR(value, pSrcDst, srcDstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiSqrt_8u_C1IRSfs(       Fw8u *pSrcDst, int srcDstStep, FwiSize roiSize, int scaleFactor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiSqrt_8u_C1IRSfs(pSrcDst, srcDstStep, roiSize, scaleFactor);
    case DT_SSE2:
        return _sse2_fwiSqrt_8u_C1IRSfs(pSrcDst, srcDstStep, roiSize, scaleFactor);
    case DT_REFR:
        return _refr_fwiSqrt_8u_C1IRSfs(pSrcDst, srcDstStep, roiSize, scaleFactor);
    default:
        assert(false);
        return _refr_fwiSqrt_8u_C1IRSfs(pSrcDst, srcDstStep, roiSize, scaleFactor);
    }
}

OREFR OSSE2 FwStatus STDCALL fwiWarpAffineQuad_32f_AC4R( const Fw32f* pSrc, FwiSize srcSize, int srcStep, FwiRect srcRoi,
							        const double srcQuad[4][2], Fw32f* pDst, int dstStep, FwiRect dstRoi,
									const double dstQuad[4][2], int interpolation )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiWarpAffineQuad_32f_AC4R(pSrc, srcSize, srcStep, srcRoi, srcQuad, pDst, dstStep, dstRoi, dstQuad, interpolation);
    case DT_REFR:
        return _refr_fwiWarpAffineQuad_32f_AC4R(pSrc, srcSize, srcStep, srcRoi, srcQuad, pDst, dstStep, dstRoi, dstQuad, interpolation);
    default:
        assert(false);
        return _refr_fwiWarpAffineQuad_32f_AC4R(pSrc, srcSize, srcStep, srcRoi, srcQuad, pDst, dstStep, dstRoi, dstQuad, interpolation);
    }
}

OREFR OSSE2 FwStatus STDCALL fwiResizeShift_16u_C4R( const Fw16u* pSrc, FwiSize srcSize, int srcStep, FwiRect srcRoi,
								  Fw16u* pDst, int dstStep, FwiSize dstRoiSize,
								  double xFr, double yFr, double xShift, double yShift, int interpolation )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiResizeShift_16u_C4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoiSize, xFr, yFr, xShift, yShift, interpolation);
    case DT_REFR:
        return _refr_fwiResizeShift_16u_C4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoiSize, xFr, yFr, xShift, yShift, interpolation);
    default:
        assert(false);
        return _refr_fwiResizeShift_16u_C4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoiSize, xFr, yFr, xShift, yShift, interpolation);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiGetRotateQuad(FwiRect srcRoi, double quad[4][2], double angle, double xShift, double yShift)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiGetRotateQuad(srcRoi, quad, angle, xShift, yShift);
    case DT_REFR:
        return _refr_fwiGetRotateQuad(srcRoi, quad, angle, xShift, yShift);
    default:
        assert(false);
        return _refr_fwiGetRotateQuad(srcRoi, quad, angle, xShift, yShift);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiOr_32s_C3IR( const Fw32s *pSrc,  int srcStep,        Fw32s *pSrcDst, int srcDstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiOr_32s_C3IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiOr_32s_C3IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    case DT_REFR:
        return _refr_fwiOr_32s_C3IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiOr_32s_C3IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    }
}

OREFR OSSE2 OF10H   FwStatus fwiXYZToRGB_8u_AC4R( const Fw8u*  pSrc, int srcStep, Fw8u*  pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiXYZToRGB_8u_AC4R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiXYZToRGB_8u_AC4R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiXYZToRGB_8u_AC4R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiXYZToRGB_8u_AC4R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}


OREFR OSSE2         FwStatus fwiMin_8u_C4R(const Fw8u* pSrc, int srcStep,FwiSize roiSize, Fw8u min[4])
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiMin_8u_C4R(pSrc, srcStep, roiSize, min);
    case DT_REFR:
        return _refr_fwiMin_8u_C4R(pSrc, srcStep, roiSize, min);
    default:
        assert(false);
        return _refr_fwiMin_8u_C4R(pSrc, srcStep, roiSize, min);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiXor_8u_C1R( const Fw8u *pSrc1, int src1Step, const Fw8u *pSrc2,   int src2Step, Fw8u *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiXor_8u_C1R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiXor_8u_C1R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiXor_8u_C1R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiXor_8u_C1R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiMulScale_16u_C4IR(  const Fw16u *pSrc,  int srcStep,        Fw16u *pSrcDst, int srcDstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiMulScale_16u_C4IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiMulScale_16u_C4IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    case DT_REFR:
        return _refr_fwiMulScale_16u_C4IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiMulScale_16u_C4IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    }
}

OREFR OSSE2 FwStatus STDCALL fwiWarpAffine_8u_P3R( const Fw8u* const pSrc[3], FwiSize srcSize, int srcStep,
								FwiRect srcRoi, Fw8u* const pDst[3], int dstStep, FwiRect dstRoi,
								const double coeffs[2][3], int interpolation )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiWarpAffine_8u_P3R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, coeffs, interpolation);
    case DT_REFR:
        return _refr_fwiWarpAffine_8u_P3R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, coeffs, interpolation);
    default:
        assert(false);
        return _refr_fwiWarpAffine_8u_P3R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, coeffs, interpolation);
    }
}

OREFR OSSE2         FwStatus fwiRGBToGray_16s_C3C1R(const Fw16s* pSrc, int srcStep,Fw16s* pDst, int dstStep, FwiSize roiSize)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiRGBToGray_16s_C3C1R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiRGBToGray_16s_C3C1R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiRGBToGray_16s_C3C1R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 FwStatus STDCALL fwiWarpAffine_32f_AC4R( const Fw32f* pSrc, FwiSize srcSize, int srcStep,
								FwiRect srcRoi, Fw32f* pDst, int dstStep, FwiRect dstRoi,
								const double coeffs[2][3], int interpolation )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiWarpAffine_32f_AC4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, coeffs, interpolation);
    case DT_REFR:
        return _refr_fwiWarpAffine_32f_AC4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, coeffs, interpolation);
    default:
        assert(false);
        return _refr_fwiWarpAffine_32f_AC4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, coeffs, interpolation);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiConvert_32f8s_C3R( const Fw32f *pSrc, int srcStep, Fw8s *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiConvert_32f8s_C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiConvert_32f8s_C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiConvert_32f8s_C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiConvert_32f8s_C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR       FwStatus STDCALL fwiWarpBilinear_8u_C4R(const Fw8u* pSrc, FwiSize srcSize, int srcStep,
								FwiRect srcRoi, Fw8u* pDst, int dstStep, FwiRect dstRoi,
								const double coeffs[2][4], int interpolation)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiWarpBilinear_8u_C4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, coeffs, interpolation);
    default:
        assert(false);
        return _refr_fwiWarpBilinear_8u_C4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, coeffs, interpolation);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiFilterRobertsDown_32f_C3R( const Fw32f * pSrc, int srcStep, Fw32f * pDst, int dstStep, FwiSize dstRoiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilterRobertsDown_32f_C3R(pSrc, srcStep, pDst, dstStep, dstRoiSize);
    case DT_REFR:
        return _refr_fwiFilterRobertsDown_32f_C3R(pSrc, srcStep, pDst, dstStep, dstRoiSize);
    default:
        assert(false);
        return _refr_fwiFilterRobertsDown_32f_C3R(pSrc, srcStep, pDst, dstStep, dstRoiSize);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiFilterLaplace_16s_C4R( const Fw16s * pSrc, int srcStep, Fw16s * pDst, int dstStep, FwiSize dstRoiSize, FwiMaskSize maskSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilterLaplace_16s_C4R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize);
    case DT_REFR:
        return _refr_fwiFilterLaplace_16s_C4R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize);
    default:
        assert(false);
        return _refr_fwiFilterLaplace_16s_C4R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiXor_32s_C4IR( const Fw32s *pSrc,  int srcStep,        Fw32s *pSrcDst, int srcDstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiXor_32s_C4IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiXor_32s_C4IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    case DT_REFR:
        return _refr_fwiXor_32s_C4IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiXor_32s_C4IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiSqr_16s_C4RSfs( const Fw16s *pSrc,    int srcStep, Fw16s *pDst, int dstStep, FwiSize roiSize, int scaleFactor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiSqr_16s_C4RSfs(pSrc, srcStep, pDst, dstStep, roiSize, scaleFactor);
    case DT_SSE2:
        return _sse2_fwiSqr_16s_C4RSfs(pSrc, srcStep, pDst, dstStep, roiSize, scaleFactor);
    case DT_REFR:
        return _refr_fwiSqr_16s_C4RSfs(pSrc, srcStep, pDst, dstStep, roiSize, scaleFactor);
    default:
        assert(false);
        return _refr_fwiSqr_16s_C4RSfs(pSrc, srcStep, pDst, dstStep, roiSize, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiCopy_16s_C1C4R( const Fw16s *pSrc, int srcStep, Fw16s *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiCopy_16s_C1C4R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiCopy_16s_C1C4R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiCopy_16s_C1C4R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiCopy_16s_C1C4R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiFilterRobertsUp_16s_C1R( const Fw16s * pSrc, int srcStep, Fw16s * pDst, int dstStep, FwiSize dstRoiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilterRobertsUp_16s_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize);
    case DT_REFR:
        return _refr_fwiFilterRobertsUp_16s_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize);
    default:
        assert(false);
        return _refr_fwiFilterRobertsUp_16s_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiFilterMedianVert_16s_AC4R( const Fw16s * pSrc, int srcStep,
                                               Fw16s * pDst, int dstStep, FwiSize dstRoiSize,
                                               FwiMaskSize maskSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilterMedianVert_16s_AC4R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize);
    case DT_REFR:
        return _refr_fwiFilterMedianVert_16s_AC4R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize);
    default:
        assert(false);
        return _refr_fwiFilterMedianVert_16s_AC4R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiDivC_32f_AC4IR( const Fw32f value[3], Fw32f *pSrcDst, int srcDstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiDivC_32f_AC4IR(value, pSrcDst, srcDstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiDivC_32f_AC4IR(value, pSrcDst, srcDstStep, roiSize);
    case DT_REFR:
        return _refr_fwiDivC_32f_AC4IR(value, pSrcDst, srcDstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiDivC_32f_AC4IR(value, pSrcDst, srcDstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiCompareEqualEps_32f_AC4R( const Fw32f *pSrc1, int src1Step, const Fw32f *pSrc2, int src2Step, Fw8u *pDst, int dstStep, FwiSize roiSize, Fw32f eps)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiCompareEqualEps_32f_AC4R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, eps);
    case DT_SSE2:
        return _sse2_fwiCompareEqualEps_32f_AC4R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, eps);
    case DT_REFR:
        return _refr_fwiCompareEqualEps_32f_AC4R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, eps);
    default:
        assert(false);
        return _refr_fwiCompareEqualEps_32f_AC4R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, eps);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiRemap_8u_AC4R( const Fw8u* pSrc, FwiSize srcSize, int srcStep, FwiRect srcRoi, const Fw32f* pxMap, int xMapStep, const Fw32f* pyMap, int yMapStep, Fw8u* pDst, int dstStep, FwiSize dstRoiSize, int interpolation )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiRemap_8u_AC4R(pSrc, srcSize, srcStep, srcRoi, pxMap, xMapStep, pyMap, yMapStep, pDst, dstStep, dstRoiSize, interpolation);
    case DT_REFR:
        return _refr_fwiRemap_8u_AC4R(pSrc, srcSize, srcStep, srcRoi, pxMap, xMapStep, pyMap, yMapStep, pDst, dstStep, dstRoiSize, interpolation);
    default:
        assert(false);
        return _refr_fwiRemap_8u_AC4R(pSrc, srcSize, srcStep, srcRoi, pxMap, xMapStep, pyMap, yMapStep, pDst, dstStep, dstRoiSize, interpolation);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiFilterMin_16s_C3R( const Fw16s * pSrc, int srcStep,
                               Fw16s * pDst, int dstStep, FwiSize dstRoiSize,
                               FwiSize maskSize, FwiPoint anchor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilterMin_16s_C3R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize, anchor);
    case DT_REFR:
        return _refr_fwiFilterMin_16s_C3R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize, anchor);
    default:
        assert(false);
        return _refr_fwiFilterMin_16s_C3R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize, anchor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiXor_16u_C3IR( const Fw16u *pSrc,  int srcStep,        Fw16u *pSrcDst, int srcDstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiXor_16u_C3IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiXor_16u_C3IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    case DT_REFR:
        return _refr_fwiXor_16u_C3IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiXor_16u_C3IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    }
}

OREFR OSSE2 FwStatus STDCALL fwiResize_16u_C1R( const Fw16u* pSrc, FwiSize srcSize, int srcStep, FwiRect srcRoi,
							 Fw16u* pDst, int dstStep, FwiSize dstRoiSize,
							 double xFactor, double yFactor, int interpolation )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiResize_16u_C1R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoiSize, xFactor, yFactor, interpolation);
    case DT_REFR:
        return _refr_fwiResize_16u_C1R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoiSize, xFactor, yFactor, interpolation);
    default:
        assert(false);
        return _refr_fwiResize_16u_C1R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoiSize, xFactor, yFactor, interpolation);
    }
}

OREFR             FwStatus STDCALL fwiScale_32s8u_AC4R( const Fw32s * pSrc, int srcStep, Fw8u * pDst, int dstStep, FwiSize roiSize, FwHintAlgorithm hint )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiScale_32s8u_AC4R(pSrc, srcStep, pDst, dstStep, roiSize, hint);
    default:
        assert(false);
        return _refr_fwiScale_32s8u_AC4R(pSrc, srcStep, pDst, dstStep, roiSize, hint);
    }
}


OREFR OSSE2         FwStatus fwiMin_8u_AC4R(const Fw8u* pSrc, int srcStep,FwiSize roiSize, Fw8u min[3])
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiMin_8u_AC4R(pSrc, srcStep, roiSize, min);
    case DT_REFR:
        return _refr_fwiMin_8u_AC4R(pSrc, srcStep, roiSize, min);
    default:
        assert(false);
        return _refr_fwiMin_8u_AC4R(pSrc, srcStep, roiSize, min);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiFilterRow32f_16s_C3R( const Fw16s * pSrc, int srcStep,
                                 Fw16s * pDst, int dstStep, FwiSize dstRoiSize,
                                const Fw32f * pKernel, int kernelSize,
                                int xAnchor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilterRow32f_16s_C3R(pSrc, srcStep, pDst, dstStep, dstRoiSize, pKernel, kernelSize, xAnchor);
    case DT_REFR:
        return _refr_fwiFilterRow32f_16s_C3R(pSrc, srcStep, pDst, dstStep, dstRoiSize, pKernel, kernelSize, xAnchor);
    default:
        assert(false);
        return _refr_fwiFilterRow32f_16s_C3R(pSrc, srcStep, pDst, dstStep, dstRoiSize, pKernel, kernelSize, xAnchor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiSet_32f_C3CR(		Fw32f  value,    Fw32f  * pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiSet_32f_C3CR(value, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiSet_32f_C3CR(value, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiSet_32f_C3CR(value, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiSet_32f_C3CR(value, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiCopy_32s_AC4R( const Fw32s *pSrc, int srcStep, Fw32s *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiCopy_32s_AC4R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiCopy_32s_AC4R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiCopy_32s_AC4R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiCopy_32s_AC4R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiDivC_16sc_C3RSfs( const Fw16sc *pSrc, int srcStep, const Fw16sc value[3], Fw16sc *pDst, int dstStep, FwiSize roiSize, int scaleFactor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiDivC_16sc_C3RSfs(pSrc, srcStep, value, pDst, dstStep, roiSize, scaleFactor);
    case DT_SSE2:
        return _sse2_fwiDivC_16sc_C3RSfs(pSrc, srcStep, value, pDst, dstStep, roiSize, scaleFactor);
    case DT_REFR:
        return _refr_fwiDivC_16sc_C3RSfs(pSrc, srcStep, value, pDst, dstStep, roiSize, scaleFactor);
    default:
        assert(false);
        return _refr_fwiDivC_16sc_C3RSfs(pSrc, srcStep, value, pDst, dstStep, roiSize, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiSqr_8u_AC4IRSfs(       Fw8u  *pSrcDst, int srcDstStep, FwiSize roiSize, int scaleFactor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiSqr_8u_AC4IRSfs(pSrcDst, srcDstStep, roiSize, scaleFactor);
    case DT_SSE2:
        return _sse2_fwiSqr_8u_AC4IRSfs(pSrcDst, srcDstStep, roiSize, scaleFactor);
    case DT_REFR:
        return _refr_fwiSqr_8u_AC4IRSfs(pSrcDst, srcDstStep, roiSize, scaleFactor);
    default:
        assert(false);
        return _refr_fwiSqr_8u_AC4IRSfs(pSrcDst, srcDstStep, roiSize, scaleFactor);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiFilterLowpass_16s_C1R( const Fw16s * pSrc, int srcStep, Fw16s * pDst, int dstStep, FwiSize dstRoiSize, FwiMaskSize maskSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilterLowpass_16s_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize);
    case DT_REFR:
        return _refr_fwiFilterLowpass_16s_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize);
    default:
        assert(false);
        return _refr_fwiFilterLowpass_16s_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize);
    }
}

OREFR               FwStatus fwiRGBToLUV_16u_C3R( const Fw16u* pSrc, int srcStep, Fw16u* pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiRGBToLUV_16u_C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiRGBToLUV_16u_C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiThreshold_LTValGTVal_32f_C1IR( Fw32f *pSrcDst, int srcDstStep, FwiSize roiSize, Fw32f thresholdLT, Fw32f valueLT, Fw32f thresholdGT, Fw32f valueGT)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiThreshold_LTValGTVal_32f_C1IR(pSrcDst, srcDstStep, roiSize, thresholdLT, valueLT, thresholdGT, valueGT);
    case DT_SSE2:
        return _sse2_fwiThreshold_LTValGTVal_32f_C1IR(pSrcDst, srcDstStep, roiSize, thresholdLT, valueLT, thresholdGT, valueGT);
    case DT_REFR:
        return _refr_fwiThreshold_LTValGTVal_32f_C1IR(pSrcDst, srcDstStep, roiSize, thresholdLT, valueLT, thresholdGT, valueGT);
    default:
        assert(false);
        return _refr_fwiThreshold_LTValGTVal_32f_C1IR(pSrcDst, srcDstStep, roiSize, thresholdLT, valueLT, thresholdGT, valueGT);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiThreshold_LTValGTVal_32f_C1R( const Fw32f *pSrc, int srcStep, Fw32f *pDst, int dstStep, FwiSize roiSize, Fw32f thresholdLT, Fw32f valueLT, Fw32f thresholdGT, Fw32f valueGT)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiThreshold_LTValGTVal_32f_C1R(pSrc, srcStep, pDst, dstStep, roiSize, thresholdLT, valueLT, thresholdGT, valueGT);
    case DT_SSE2:
        return _sse2_fwiThreshold_LTValGTVal_32f_C1R(pSrc, srcStep, pDst, dstStep, roiSize, thresholdLT, valueLT, thresholdGT, valueGT);
    case DT_REFR:
        return _refr_fwiThreshold_LTValGTVal_32f_C1R(pSrc, srcStep, pDst, dstStep, roiSize, thresholdLT, valueLT, thresholdGT, valueGT);
    default:
        assert(false);
        return _refr_fwiThreshold_LTValGTVal_32f_C1R(pSrc, srcStep, pDst, dstStep, roiSize, thresholdLT, valueLT, thresholdGT, valueGT);
    }
}

OREFR OSSE2 FwStatus STDCALL fwiResize_32f_AC4R( const Fw32f* pSrc, FwiSize srcSize, int srcStep, FwiRect srcRoi,
							  Fw32f* pDst, int dstStep, FwiSize dstRoiSize,
							  double xFactor, double yFactor, int interpolation )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiResize_32f_AC4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoiSize, xFactor, yFactor, interpolation);
    case DT_REFR:
        return _refr_fwiResize_32f_AC4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoiSize, xFactor, yFactor, interpolation);
    default:
        assert(false);
        return _refr_fwiResize_32f_AC4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoiSize, xFactor, yFactor, interpolation);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiSubC_8u_C3RSfs( const Fw8u *pSrc, int srcStep, const Fw8u value[3], Fw8u *pDst, int dstStep, FwiSize roiSize, int scaleFactor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiSubC_8u_C3RSfs(pSrc, srcStep, value, pDst, dstStep, roiSize, scaleFactor);
    case DT_SSE2:
        return _sse2_fwiSubC_8u_C3RSfs(pSrc, srcStep, value, pDst, dstStep, roiSize, scaleFactor);
    case DT_REFR:
        return _refr_fwiSubC_8u_C3RSfs(pSrc, srcStep, value, pDst, dstStep, roiSize, scaleFactor);
    default:
        assert(false);
        return _refr_fwiSubC_8u_C3RSfs(pSrc, srcStep, value, pDst, dstStep, roiSize, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiConvert_16u32s_C3R( const Fw16u *pSrc, int srcStep, Fw32s *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiConvert_16u32s_C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiConvert_16u32s_C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiConvert_16u32s_C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiConvert_16u32s_C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 FwStatus STDCALL fwiResizeCenter_32f_C1R( const Fw32f* pSrc, FwiSize srcSize, int srcStep, FwiRect srcRoi,
								   Fw32f* pDst, int dstStep, FwiSize dstRoiSize,
								   double xFactor, double yFactor, double xCenter, double yCenter, int interpolation )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiResizeCenter_32f_C1R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoiSize, xFactor, yFactor, xCenter, yCenter, interpolation);
    case DT_REFR:
        return _refr_fwiResizeCenter_32f_C1R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoiSize, xFactor, yFactor, xCenter, yCenter, interpolation);
    default:
        assert(false);
        return _refr_fwiResizeCenter_32f_C1R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoiSize, xFactor, yFactor, xCenter, yCenter, interpolation);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiThreshold_LTVal_16s_AC4IR( Fw16s *pSrcDst, int srcDstStep, FwiSize roiSize, const Fw16s threshold[3], const Fw16s value[3])
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiThreshold_LTVal_16s_AC4IR(pSrcDst, srcDstStep, roiSize, threshold, value);
    case DT_SSE2:
        return _sse2_fwiThreshold_LTVal_16s_AC4IR(pSrcDst, srcDstStep, roiSize, threshold, value);
    case DT_REFR:
        return _refr_fwiThreshold_LTVal_16s_AC4IR(pSrcDst, srcDstStep, roiSize, threshold, value);
    default:
        assert(false);
        return _refr_fwiThreshold_LTVal_16s_AC4IR(pSrcDst, srcDstStep, roiSize, threshold, value);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiOr_16u_C1IR( const Fw16u *pSrc,  int srcStep,        Fw16u *pSrcDst, int srcDstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiOr_16u_C1IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiOr_16u_C1IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    case DT_REFR:
        return _refr_fwiOr_16u_C1IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiOr_16u_C1IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    }
}

OREFR OSSE2         FwStatus fwiMean_16s_C1R(const Fw16s* pSrc, int srcStep,FwiSize roiSize, Fw64f* pMean)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiMean_16s_C1R(pSrc, srcStep, roiSize, pMean);
    case DT_REFR:
        return _refr_fwiMean_16s_C1R(pSrc, srcStep, roiSize, pMean);
    default:
        assert(false);
        return _refr_fwiMean_16s_C1R(pSrc, srcStep, roiSize, pMean);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiAdd_16s_C1RSfs( const Fw16s  *pSrc1, int src1Step, const Fw16s  *pSrc2,   int src2Step, Fw16s *pDst, int dstStep, FwiSize roiSize, int scaleFactor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiAdd_16s_C1RSfs(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, scaleFactor);
    case DT_SSE2:
        return _sse2_fwiAdd_16s_C1RSfs(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, scaleFactor);
    case DT_REFR:
        return _refr_fwiAdd_16s_C1RSfs(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, scaleFactor);
    default:
        assert(false);
        return _refr_fwiAdd_16s_C1RSfs(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, scaleFactor);
    }
}

OREFR OSSE2         FwStatus fwiYUV420ToBGR555_8u16u_P3C3R(const A8U* const pSrc[3], int srcStep[3], A16U* pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiYUV420ToBGR555_8u16u_P3C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiYUV420ToBGR555_8u16u_P3C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiYUV420ToBGR555_8u16u_P3C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR             FwStatus STDCALL fwiScale_16u8u_C4R( const Fw16u * pSrc, int srcStep, Fw8u * pDst, int dstStep, FwiSize roiSize, FwHintAlgorithm hint )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiScale_16u8u_C4R(pSrc, srcStep, pDst, dstStep, roiSize, hint);
    default:
        assert(false);
        return _refr_fwiScale_16u8u_C4R(pSrc, srcStep, pDst, dstStep, roiSize, hint);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiFilterBox_16s_C4R( const Fw16s * pSrc, int srcStep,
                               Fw16s * pDst, int dstStep, FwiSize dstRoiSize,
                               FwiSize maskSize, FwiPoint anchor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilterBox_16s_C4R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize, anchor);
    case DT_REFR:
        return _refr_fwiFilterBox_16s_C4R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize, anchor);
    default:
        assert(false);
        return _refr_fwiFilterBox_16s_C4R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize, anchor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiXorC_32s_C3R( const Fw32s  *pSrc, int srcStep, const Fw32s value[3], Fw32s *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiXorC_32s_C3R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiXorC_32s_C3R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiXorC_32s_C3R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiXorC_32s_C3R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiSubC_8u_C1RSfs( const Fw8u *pSrc, int srcStep,       Fw8u value,    Fw8u *pDst, int dstStep, FwiSize roiSize, int scaleFactor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiSubC_8u_C1RSfs(pSrc, srcStep, value, pDst, dstStep, roiSize, scaleFactor);
    case DT_SSE2:
        return _sse2_fwiSubC_8u_C1RSfs(pSrc, srcStep, value, pDst, dstStep, roiSize, scaleFactor);
    case DT_REFR:
        return _refr_fwiSubC_8u_C1RSfs(pSrc, srcStep, value, pDst, dstStep, roiSize, scaleFactor);
    default:
        assert(false);
        return _refr_fwiSubC_8u_C1RSfs(pSrc, srcStep, value, pDst, dstStep, roiSize, scaleFactor);
    }
}

OREFR OSSE2 FwStatus STDCALL fwiResize_16u_P3R( const Fw16u* const pSrc[3], FwiSize srcSize, int srcStep, FwiRect srcRoi,
							 Fw16u* const pDst[3], int dstStep, FwiSize dstRoiSize,
							 double xFactor, double yFactor, int interpolation )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiResize_16u_P3R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoiSize, xFactor, yFactor, interpolation);
    case DT_REFR:
        return _refr_fwiResize_16u_P3R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoiSize, xFactor, yFactor, interpolation);
    default:
        assert(false);
        return _refr_fwiResize_16u_P3R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoiSize, xFactor, yFactor, interpolation);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiFilterMin_8u_C4R( const Fw8u * pSrc, int srcStep,
                               Fw8u * pDst, int dstStep, FwiSize dstRoiSize,
                               FwiSize maskSize, FwiPoint anchor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilterMin_8u_C4R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize, anchor);
    case DT_REFR:
        return _refr_fwiFilterMin_8u_C4R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize, anchor);
    default:
        assert(false);
        return _refr_fwiFilterMin_8u_C4R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize, anchor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiDivC_8u_AC4IRSfs( const Fw8u value[3], Fw8u *pSrcDst, int srcDstStep, FwiSize roiSize, int scaleFactor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiDivC_8u_AC4IRSfs(value, pSrcDst, srcDstStep, roiSize, scaleFactor);
    case DT_SSE2:
        return _sse2_fwiDivC_8u_AC4IRSfs(value, pSrcDst, srcDstStep, roiSize, scaleFactor);
    case DT_REFR:
        return _refr_fwiDivC_8u_AC4IRSfs(value, pSrcDst, srcDstStep, roiSize, scaleFactor);
    default:
        assert(false);
        return _refr_fwiDivC_8u_AC4IRSfs(value, pSrcDst, srcDstStep, roiSize, scaleFactor);
    }
}

OREFR OSSE2 FwStatus STDCALL fwiWarpAffineBack_16u_P4R( const Fw16u* const pSrc[4], FwiSize srcSize, int srcStep,
								FwiRect srcRoi, Fw16u* const pDst[4], int dstStep, FwiRect dstRoi,
								const double coeffs[2][3], int interpolation )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiWarpAffineBack_16u_P4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, coeffs, interpolation);
    case DT_REFR:
        return _refr_fwiWarpAffineBack_16u_P4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, coeffs, interpolation);
    default:
        assert(false);
        return _refr_fwiWarpAffineBack_16u_P4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, coeffs, interpolation);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiAndC_16u_C4R( const Fw16u  *pSrc, int srcStep, const Fw16u value[4], Fw16u *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiAndC_16u_C4R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiAndC_16u_C4R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiAndC_16u_C4R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiAndC_16u_C4R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiThreshold_LT_8u_C3IR( Fw8u *pSrcDst, int srcDstStep, FwiSize roiSize, const Fw8u threshold[3])
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiThreshold_LT_8u_C3IR(pSrcDst, srcDstStep, roiSize, threshold);
    case DT_SSE2:
        return _sse2_fwiThreshold_LT_8u_C3IR(pSrcDst, srcDstStep, roiSize, threshold);
    case DT_REFR:
        return _refr_fwiThreshold_LT_8u_C3IR(pSrcDst, srcDstStep, roiSize, threshold);
    default:
        assert(false);
        return _refr_fwiThreshold_LT_8u_C3IR(pSrcDst, srcDstStep, roiSize, threshold);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiAddRotateShift(double xCenter, double yCenter, double angle, double* xShift, double* yShift)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiAddRotateShift(xCenter, yCenter, angle, xShift, yShift);
    case DT_REFR:
        return _refr_fwiAddRotateShift(xCenter, yCenter, angle, xShift, yShift);
    default:
        assert(false);
        return _refr_fwiAddRotateShift(xCenter, yCenter, angle, xShift, yShift);
    }
}

OREFR       FwStatus STDCALL fwiMirror_32f_C1IR(Fw32f *pSrcDst, int srcDstStep, FwiSize roiSize, FwiAxis flip)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiMirror_32f_C1IR(pSrcDst, srcDstStep, roiSize, flip);
    default:
        assert(false);
        return _refr_fwiMirror_32f_C1IR(pSrcDst, srcDstStep, roiSize, flip);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiCompare_16s_AC4R( const Fw16s *pSrc1, int src1Step, const Fw16s *pSrc2, int src2Step, Fw8u *pDst, int dstStep, FwiSize roiSize, FwCmpOp fwCmpOp )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiCompare_16s_AC4R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, fwCmpOp);
    case DT_SSE2:
        return _sse2_fwiCompare_16s_AC4R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, fwCmpOp);
    case DT_REFR:
        return _refr_fwiCompare_16s_AC4R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, fwCmpOp);
    default:
        assert(false);
        return _refr_fwiCompare_16s_AC4R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, fwCmpOp);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiXorC_8u_C4IR( const Fw8u value[4], Fw8u *pSrcDst, int srcDstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiXorC_8u_C4IR(value, pSrcDst, srcDstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiXorC_8u_C4IR(value, pSrcDst, srcDstStep, roiSize);
    case DT_REFR:
        return _refr_fwiXorC_8u_C4IR(value, pSrcDst, srcDstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiXorC_8u_C4IR(value, pSrcDst, srcDstStep, roiSize);
    }
}

OREFR OSSE2 FwStatus STDCALL fwiDCT8x8Fwd_16s_C1I(Fw16s* pSrcDst)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiDCT8x8Fwd_16s_C1I(pSrcDst);
    case DT_REFR:
        return _refr_fwiDCT8x8Fwd_16s_C1I(pSrcDst);
    default:
        assert(false);
        return _refr_fwiDCT8x8Fwd_16s_C1I(pSrcDst);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiMulCScale_8u_C3R( const Fw8u *pSrc, int srcStep, const Fw8u value[3], Fw8u *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiMulCScale_8u_C3R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiMulCScale_8u_C3R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiMulCScale_8u_C3R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiMulCScale_8u_C3R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiDiv_16sc_C3IRSfs( const Fw16sc *pSrc,  int srcStep,        Fw16sc *pSrcDst, int srcDstStep, FwiSize roiSize, int scaleFactor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiDiv_16sc_C3IRSfs(pSrc, srcStep, pSrcDst, srcDstStep, roiSize, scaleFactor);
    case DT_SSE2:
        return _sse2_fwiDiv_16sc_C3IRSfs(pSrc, srcStep, pSrcDst, srcDstStep, roiSize, scaleFactor);
    case DT_REFR:
        return _refr_fwiDiv_16sc_C3IRSfs(pSrc, srcStep, pSrcDst, srcDstStep, roiSize, scaleFactor);
    default:
        assert(false);
        return _refr_fwiDiv_16sc_C3IRSfs(pSrc, srcStep, pSrcDst, srcDstStep, roiSize, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiAnd_32s_C3IR( const Fw32s *pSrc,  int srcStep,        Fw32s *pSrcDst, int srcDstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiAnd_32s_C3IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiAnd_32s_C3IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    case DT_REFR:
        return _refr_fwiAnd_32s_C3IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiAnd_32s_C3IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiDiv_32sc_C3IRSfs( const Fw32sc *pSrc,  int srcStep,        Fw32sc *pSrcDst, int srcDstStep, FwiSize roiSize, int scaleFactor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiDiv_32sc_C3IRSfs(pSrc, srcStep, pSrcDst, srcDstStep, roiSize, scaleFactor);
    case DT_SSE2:
        return _sse2_fwiDiv_32sc_C3IRSfs(pSrc, srcStep, pSrcDst, srcDstStep, roiSize, scaleFactor);
    case DT_REFR:
        return _refr_fwiDiv_32sc_C3IRSfs(pSrc, srcStep, pSrcDst, srcDstStep, roiSize, scaleFactor);
    default:
        assert(false);
        return _refr_fwiDiv_32sc_C3IRSfs(pSrc, srcStep, pSrcDst, srcDstStep, roiSize, scaleFactor);
    }
}


OREFR OSSE2       FwStatus STDCALL fwiFilterScharrVert_8u16s_C1R( const Fw8u * pSrc, int srcStep, Fw16s * pDst, int dstStep, FwiSize dstRoiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilterScharrVert_8u16s_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize);
    case DT_REFR:
        return _refr_fwiFilterScharrVert_8u16s_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize);
    default:
        assert(false);
        return _refr_fwiFilterScharrVert_8u16s_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiFilterMedian_16s_C1R( const Fw16s * pSrc, int srcStep,
                                           Fw16s * pDst, int dstStep, FwiSize dstRoiSize,
                                           FwiSize maskSize, FwiPoint anchor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilterMedian_16s_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize, anchor);
    case DT_REFR:
        return _refr_fwiFilterMedian_16s_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize, anchor);
    default:
        assert(false);
        return _refr_fwiFilterMedian_16s_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize, anchor);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiRotateCenter_32f_P3R( const Fw32f* const pSrc[3],FwiSize srcSize, int srcStep, FwiRect srcRoi, Fw32f* const pDst[3], int dstStep, FwiRect dstRoi, double angle, double xCenter, double yCenter, int interpolation )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiRotateCenter_32f_P3R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, angle, xCenter, yCenter, interpolation);
    case DT_REFR:
        return _refr_fwiRotateCenter_32f_P3R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, angle, xCenter, yCenter, interpolation);
    default:
        assert(false);
        return _refr_fwiRotateCenter_32f_P3R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, angle, xCenter, yCenter, interpolation);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiSqrt_16u_C1IRSfs(       Fw16u *pSrcDst, int srcDstStep, FwiSize roiSize, int scaleFactor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiSqrt_16u_C1IRSfs(pSrcDst, srcDstStep, roiSize, scaleFactor);
    case DT_SSE2:
        return _sse2_fwiSqrt_16u_C1IRSfs(pSrcDst, srcDstStep, roiSize, scaleFactor);
    case DT_REFR:
        return _refr_fwiSqrt_16u_C1IRSfs(pSrcDst, srcDstStep, roiSize, scaleFactor);
    default:
        assert(false);
        return _refr_fwiSqrt_16u_C1IRSfs(pSrcDst, srcDstStep, roiSize, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiDiv_16sc_AC4RSfs( const Fw16sc *pSrc1, int src1Step, const Fw16sc *pSrc2,   int src2Step, Fw16sc *pDst, int dstStep, FwiSize roiSize, int scaleFactor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiDiv_16sc_AC4RSfs(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, scaleFactor);
    case DT_SSE2:
        return _sse2_fwiDiv_16sc_AC4RSfs(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, scaleFactor);
    case DT_REFR:
        return _refr_fwiDiv_16sc_AC4RSfs(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, scaleFactor);
    default:
        assert(false);
        return _refr_fwiDiv_16sc_AC4RSfs(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiConvert_32s8s_AC4R( const Fw32s *pSrc, int srcStep, Fw8s *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiConvert_32s8s_AC4R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiConvert_32s8s_AC4R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiConvert_32s8s_AC4R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiConvert_32s8s_AC4R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiCopy_16s_C4R( const Fw16s *pSrc, int srcStep, Fw16s *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiCopy_16s_C4R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiCopy_16s_C4R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiCopy_16s_C4R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiCopy_16s_C4R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiXorC_32s_C4IR( const Fw32s value[4], Fw32s *pSrcDst, int srcDstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiXorC_32s_C4IR(value, pSrcDst, srcDstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiXorC_32s_C4IR(value, pSrcDst, srcDstStep, roiSize);
    case DT_REFR:
        return _refr_fwiXorC_32s_C4IR(value, pSrcDst, srcDstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiXorC_32s_C4IR(value, pSrcDst, srcDstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiXorC_8u_C4R( const Fw8u   *pSrc, int srcStep, const Fw8u value[4], Fw8u *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiXorC_8u_C4R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiXorC_8u_C4R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiXorC_8u_C4R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiXorC_8u_C4R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiRShiftC_8u_C1R( const Fw8u   *pSrc, int srcStep,       Fw32u value,    Fw8u *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiRShiftC_8u_C1R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiRShiftC_8u_C1R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiRShiftC_8u_C1R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiRShiftC_8u_C1R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiSub_32sc_C3IRSfs( const Fw32sc *pSrc,  int srcStep,        Fw32sc *pSrcDst, int srcDstStep, FwiSize roiSize, int scaleFactor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiSub_32sc_C3IRSfs(pSrc, srcStep, pSrcDst, srcDstStep, roiSize, scaleFactor);
    case DT_SSE2:
        return _sse2_fwiSub_32sc_C3IRSfs(pSrc, srcStep, pSrcDst, srcDstStep, roiSize, scaleFactor);
    case DT_REFR:
        return _refr_fwiSub_32sc_C3IRSfs(pSrc, srcStep, pSrcDst, srcDstStep, roiSize, scaleFactor);
    default:
        assert(false);
        return _refr_fwiSub_32sc_C3IRSfs(pSrc, srcStep, pSrcDst, srcDstStep, roiSize, scaleFactor);
    }
}

OREFR OSSE2         FwStatus fwiYUV422ToRGB_8u_P3C3( const A8U* const pSrc[3], A8U* pDst, FwiSize imgSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiYUV422ToRGB_8u_P3C3(pSrc, pDst, imgSize);
    case DT_REFR:
        return _refr_fwiYUV422ToRGB_8u_P3C3(pSrc, pDst, imgSize);
    default:
        assert(false);
        return _refr_fwiYUV422ToRGB_8u_P3C3(pSrc, pDst, imgSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiDiv_32f_AC4R( const Fw32f  *pSrc1, int src1Step, const Fw32f  *pSrc2,   int src2Step, Fw32f  *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiDiv_32f_AC4R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiDiv_32f_AC4R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiDiv_32f_AC4R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiDiv_32f_AC4R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    }
}

OREFR               FwStatus fwiCbYCr422ToBGR_8u_C2C4R(const A8U* pSrc, int srcStep, A8U* pDst, int dstStep, FwiSize roiSize, A8U aval )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiCbYCr422ToBGR_8u_C2C4R(pSrc, srcStep, pDst, dstStep, roiSize, aval);
    default:
        assert(false);
        return _refr_fwiCbYCr422ToBGR_8u_C2C4R(pSrc, srcStep, pDst, dstStep, roiSize, aval);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiFilterSobelHoriz_16s_C1R( const Fw16s * pSrc, int srcStep, Fw16s * pDst, int dstStep, FwiSize dstRoiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilterSobelHoriz_16s_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize);
    case DT_REFR:
        return _refr_fwiFilterSobelHoriz_16s_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize);
    default:
        assert(false);
        return _refr_fwiFilterSobelHoriz_16s_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiAddC_16s_C3RSfs( const Fw16s  *pSrc, int srcStep, const Fw16s value[3], Fw16s *pDst, int dstStep, FwiSize roiSize, int scaleFactor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiAddC_16s_C3RSfs(pSrc, srcStep, value, pDst, dstStep, roiSize, scaleFactor);
    case DT_SSE2:
        return _sse2_fwiAddC_16s_C3RSfs(pSrc, srcStep, value, pDst, dstStep, roiSize, scaleFactor);
    case DT_REFR:
        return _refr_fwiAddC_16s_C3RSfs(pSrc, srcStep, value, pDst, dstStep, roiSize, scaleFactor);
    default:
        assert(false);
        return _refr_fwiAddC_16s_C3RSfs(pSrc, srcStep, value, pDst, dstStep, roiSize, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiAdd_32f_C1IR( const Fw32f  *pSrc,  int srcStep,        Fw32f  *pSrcDst, int srcDstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiAdd_32f_C1IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiAdd_32f_C1IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    case DT_REFR:
        return _refr_fwiAdd_32f_C1IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiAdd_32f_C1IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    }
}

OREFR               FwStatus fwiBGRToCbYCr422_8u_AC4C2R(const A8U* pSrc, int srcStep, A8U* pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiBGRToCbYCr422_8u_AC4C2R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiBGRToCbYCr422_8u_AC4C2R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiThreshold_GTVal_32f_C4R( const Fw32f *pSrc, int srcStep, Fw32f *pDst, int dstStep, FwiSize roiSize, const Fw32f threshold[4], const Fw32f value[4])
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiThreshold_GTVal_32f_C4R(pSrc, srcStep, pDst, dstStep, roiSize, threshold, value);
    case DT_SSE2:
        return _sse2_fwiThreshold_GTVal_32f_C4R(pSrc, srcStep, pDst, dstStep, roiSize, threshold, value);
    case DT_REFR:
        return _refr_fwiThreshold_GTVal_32f_C4R(pSrc, srcStep, pDst, dstStep, roiSize, threshold, value);
    default:
        assert(false);
        return _refr_fwiThreshold_GTVal_32f_C4R(pSrc, srcStep, pDst, dstStep, roiSize, threshold, value);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiFilterRow_16s_C1R( const Fw16s * pSrc, int srcStep,
                              Fw16s * pDst, int dstStep, FwiSize dstRoiSize,
                              const Fw32s * pKernel, int kernelSize,
                              int xAnchor, int divisor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilterRow_16s_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize, pKernel, kernelSize, xAnchor, divisor);
    case DT_REFR:
        return _refr_fwiFilterRow_16s_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize, pKernel, kernelSize, xAnchor, divisor);
    default:
        assert(false);
        return _refr_fwiFilterRow_16s_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize, pKernel, kernelSize, xAnchor, divisor);
    }
}

OREFR               FwStatus fwiYCbCrToRGB555_8u16u_P3C3R(const A8U* const pSrc[3], int srcStep, A16U* pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiYCbCrToRGB555_8u16u_P3C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiYCbCrToRGB555_8u16u_P3C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiAddC_16sc_C1IRSfs(       Fw16sc value,    Fw16sc *pSrcDst, int srcDstStep, FwiSize roiSize, int scaleFactor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiAddC_16sc_C1IRSfs(value, pSrcDst, srcDstStep, roiSize, scaleFactor);
    case DT_SSE2:
        return _sse2_fwiAddC_16sc_C1IRSfs(value, pSrcDst, srcDstStep, roiSize, scaleFactor);
    case DT_REFR:
        return _refr_fwiAddC_16sc_C1IRSfs(value, pSrcDst, srcDstStep, roiSize, scaleFactor);
    default:
        assert(false);
        return _refr_fwiAddC_16sc_C1IRSfs(value, pSrcDst, srcDstStep, roiSize, scaleFactor);
    }
}

OREFR               FwStatus fwiYCbCr422ToYCbCr420_8u_C2P3R(const Fw8u* pSrc, int srcStep, Fw8u* pDst[3], int dstStep[3], FwiSize roiSize)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiYCbCr422ToYCbCr420_8u_C2P3R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiYCbCr422ToYCbCr420_8u_C2P3R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR             FwStatus STDCALL fwiConvert_16s32f_AC4R( const Fw16s *pSrc, int srcStep, Fw32f *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiConvert_16s32f_AC4R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiConvert_16s32f_AC4R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiDiv_32f_C1IR( const Fw32f  *pSrc,  int srcStep,        Fw32f  *pSrcDst, int srcDstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiDiv_32f_C1IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiDiv_32f_C1IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    case DT_REFR:
        return _refr_fwiDiv_32f_C1IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiDiv_32f_C1IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiExp_32f_C3IR(       Fw32f *pSrcDst, int srcDstStep,  FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiExp_32f_C3IR(pSrcDst, srcDstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiExp_32f_C3IR(pSrcDst, srcDstStep, roiSize);
    case DT_REFR:
        return _refr_fwiExp_32f_C3IR(pSrcDst, srcDstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiExp_32f_C3IR(pSrcDst, srcDstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiThreshold_LTVal_32f_C3IR( Fw32f *pSrcDst, int srcDstStep, FwiSize roiSize, const Fw32f threshold[3], const Fw32f value[3])
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiThreshold_LTVal_32f_C3IR(pSrcDst, srcDstStep, roiSize, threshold, value);
    case DT_SSE2:
        return _sse2_fwiThreshold_LTVal_32f_C3IR(pSrcDst, srcDstStep, roiSize, threshold, value);
    case DT_REFR:
        return _refr_fwiThreshold_LTVal_32f_C3IR(pSrcDst, srcDstStep, roiSize, threshold, value);
    default:
        assert(false);
        return _refr_fwiThreshold_LTVal_32f_C3IR(pSrcDst, srcDstStep, roiSize, threshold, value);
    }
}

OREFR               FwStatus fwiBGRToYCbCr420_8u_C3P3R(const A8U* pSrc, int srcStep, A8U* const pDst[3], int dstStep[3], FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiBGRToYCbCr420_8u_C3P3R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiBGRToYCbCr420_8u_C3P3R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 FwStatus STDCALL fwiResizeShift_32f_C3R( const Fw32f* pSrc, FwiSize srcSize, int srcStep, FwiRect srcRoi,
								  Fw32f* pDst, int dstStep, FwiSize dstRoiSize,
								  double xFr, double yFr, double xShift, double yShift, int interpolation )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiResizeShift_32f_C3R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoiSize, xFr, yFr, xShift, yShift, interpolation);
    case DT_REFR:
        return _refr_fwiResizeShift_32f_C3R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoiSize, xFr, yFr, xShift, yShift, interpolation);
    default:
        assert(false);
        return _refr_fwiResizeShift_32f_C3R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoiSize, xFr, yFr, xShift, yShift, interpolation);
    }
}

OREFR OSSE2 FwStatus STDCALL fwiWarpPerspective_8u_C3R( const Fw8u* pSrc, FwiSize srcSize, int srcStep,
								FwiRect srcRoi, Fw8u* pDst, int dstStep, FwiRect dstRoi,
								const double coeffs[3][3], int interpolation )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiWarpPerspective_8u_C3R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, coeffs, interpolation);
    case DT_REFR:
        return _refr_fwiWarpPerspective_8u_C3R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, coeffs, interpolation);
    default:
        assert(false);
        return _refr_fwiWarpPerspective_8u_C3R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, coeffs, interpolation);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiFilterMedian_8u_C3R( const Fw8u * pSrc, int srcStep,
                                           Fw8u * pDst, int dstStep, FwiSize dstRoiSize,
                                           FwiSize maskSize, FwiPoint anchor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilterMedian_8u_C3R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize, anchor);
    case DT_REFR:
        return _refr_fwiFilterMedian_8u_C3R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize, anchor);
    default:
        assert(false);
        return _refr_fwiFilterMedian_8u_C3R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize, anchor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiMulC_32f_AC4IR( const Fw32f value[3], Fw32f *pSrcDst, int srcDstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiMulC_32f_AC4IR(value, pSrcDst, srcDstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiMulC_32f_AC4IR(value, pSrcDst, srcDstStep, roiSize);
    case DT_REFR:
        return _refr_fwiMulC_32f_AC4IR(value, pSrcDst, srcDstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiMulC_32f_AC4IR(value, pSrcDst, srcDstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiMulCScale_8u_C1IR(       Fw8u value,    Fw8u *pSrcDst, int srcDstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiMulCScale_8u_C1IR(value, pSrcDst, srcDstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiMulCScale_8u_C1IR(value, pSrcDst, srcDstStep, roiSize);
    case DT_REFR:
        return _refr_fwiMulCScale_8u_C1IR(value, pSrcDst, srcDstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiMulCScale_8u_C1IR(value, pSrcDst, srcDstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiOrC_32s_C1IR(       Fw32s value,    Fw32s *pSrcDst, int srcDstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiOrC_32s_C1IR(value, pSrcDst, srcDstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiOrC_32s_C1IR(value, pSrcDst, srcDstStep, roiSize);
    case DT_REFR:
        return _refr_fwiOrC_32s_C1IR(value, pSrcDst, srcDstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiOrC_32s_C1IR(value, pSrcDst, srcDstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiAdd_8s32f_C1IR( const Fw8s  *pSrc, int srcStep, Fw32f *pSrcDst, int srcDstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiAdd_8s32f_C1IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiAdd_8s32f_C1IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    case DT_REFR:
        return _refr_fwiAdd_8s32f_C1IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiAdd_8s32f_C1IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiXor_16u_C1IR( const Fw16u *pSrc,  int srcStep,        Fw16u *pSrcDst, int srcDstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiXor_16u_C1IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiXor_16u_C1IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    case DT_REFR:
        return _refr_fwiXor_16u_C1IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiXor_16u_C1IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiGetRotateShift(double xCenter, double yCenter, double angle, double* xShift, double* yShift)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiGetRotateShift(xCenter, yCenter, angle, xShift, yShift);
    case DT_REFR:
        return _refr_fwiGetRotateShift(xCenter, yCenter, angle, xShift, yShift);
    default:
        assert(false);
        return _refr_fwiGetRotateShift(xCenter, yCenter, angle, xShift, yShift);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiFilterMin_32f_C4R( const Fw32f * pSrc, int srcStep,
                               Fw32f * pDst, int dstStep, FwiSize dstRoiSize,
                               FwiSize maskSize, FwiPoint anchor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilterMin_32f_C4R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize, anchor);
    case DT_REFR:
        return _refr_fwiFilterMin_32f_C4R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize, anchor);
    default:
        assert(false);
        return _refr_fwiFilterMin_32f_C4R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize, anchor);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiFilterSobelVert_32f_C3R( const Fw32f * pSrc, int srcStep, Fw32f * pDst, int dstStep, FwiSize dstRoiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilterSobelVert_32f_C3R(pSrc, srcStep, pDst, dstStep, dstRoiSize);
    case DT_REFR:
        return _refr_fwiFilterSobelVert_32f_C3R(pSrc, srcStep, pDst, dstStep, dstRoiSize);
    default:
        assert(false);
        return _refr_fwiFilterSobelVert_32f_C3R(pSrc, srcStep, pDst, dstStep, dstRoiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiAdd_32sc_AC4IRSfs( const Fw32sc *pSrc,  int srcStep,        Fw32sc *pSrcDst, int srcDstStep, FwiSize roiSize, int scaleFactor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiAdd_32sc_AC4IRSfs(pSrc, srcStep, pSrcDst, srcDstStep, roiSize, scaleFactor);
    case DT_SSE2:
        return _sse2_fwiAdd_32sc_AC4IRSfs(pSrc, srcStep, pSrcDst, srcDstStep, roiSize, scaleFactor);
    case DT_REFR:
        return _refr_fwiAdd_32sc_AC4IRSfs(pSrc, srcStep, pSrcDst, srcDstStep, roiSize, scaleFactor);
    default:
        assert(false);
        return _refr_fwiAdd_32sc_AC4IRSfs(pSrc, srcStep, pSrcDst, srcDstStep, roiSize, scaleFactor);
    }
}

OREFR               FwStatus fwiRGBToYUV422_8u_P3( const A8U* const pSrc[3], A8U* pDst[3], FwiSize imgSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiRGBToYUV422_8u_P3(pSrc, pDst, imgSize);
    default:
        assert(false);
        return _refr_fwiRGBToYUV422_8u_P3(pSrc, pDst, imgSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiThreshold_8u_C3IR( Fw8u *pSrcDst, int srcDstStep, FwiSize roiSize, const Fw8u threshold[3], FwCmpOp fwCmpOp)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiThreshold_8u_C3IR(pSrcDst, srcDstStep, roiSize, threshold, fwCmpOp);
    case DT_SSE2:
        return _sse2_fwiThreshold_8u_C3IR(pSrcDst, srcDstStep, roiSize, threshold, fwCmpOp);
    case DT_REFR:
        return _refr_fwiThreshold_8u_C3IR(pSrcDst, srcDstStep, roiSize, threshold, fwCmpOp);
    default:
        assert(false);
        return _refr_fwiThreshold_8u_C3IR(pSrcDst, srcDstStep, roiSize, threshold, fwCmpOp);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiOr_32s_C1IR( const Fw32s *pSrc,  int srcStep,        Fw32s *pSrcDst, int srcDstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiOr_32s_C1IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiOr_32s_C1IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    case DT_REFR:
        return _refr_fwiOr_32s_C1IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiOr_32s_C1IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiOrC_8u_C1R( const Fw8u   *pSrc, int srcStep,       Fw8u value,    Fw8u *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiOrC_8u_C1R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiOrC_8u_C1R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiOrC_8u_C1R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiOrC_8u_C1R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 FwStatus STDCALL fwiWarpAffine_8u_P4R( const Fw8u* const pSrc[4], FwiSize srcSize, int srcStep,
								FwiRect srcRoi, Fw8u* const pDst[4], int dstStep, FwiRect dstRoi,
								const double coeffs[2][3], int interpolation )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiWarpAffine_8u_P4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, coeffs, interpolation);
    case DT_REFR:
        return _refr_fwiWarpAffine_8u_P4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, coeffs, interpolation);
    default:
        assert(false);
        return _refr_fwiWarpAffine_8u_P4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, coeffs, interpolation);
    }
}

OREFR               FwStatus fwiRGBToHLS_16s_AC4R( const Fw16s* pSrc, int srcStep, Fw16s* pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiRGBToHLS_16s_AC4R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiRGBToHLS_16s_AC4R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR               FwStatus fwiLUVToRGB_16u_C3R( const Fw16u* pSrc, int srcStep, Fw16u* pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiLUVToRGB_16u_C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiLUVToRGB_16u_C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiConvert_8s32f_C1R( const Fw8s *pSrc, int srcStep, Fw32f *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiConvert_8s32f_C1R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiConvert_8s32f_C1R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiConvert_8s32f_C1R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiConvert_8s32f_C1R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiDivC_16s_C3RSfs( const Fw16s *pSrc, int srcStep, const Fw16s value[3], Fw16s *pDst, int dstStep, FwiSize roiSize, int scaleFactor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiDivC_16s_C3RSfs(pSrc, srcStep, value, pDst, dstStep, roiSize, scaleFactor);
    case DT_SSE2:
        return _sse2_fwiDivC_16s_C3RSfs(pSrc, srcStep, value, pDst, dstStep, roiSize, scaleFactor);
    case DT_REFR:
        return _refr_fwiDivC_16s_C3RSfs(pSrc, srcStep, value, pDst, dstStep, roiSize, scaleFactor);
    default:
        assert(false);
        return _refr_fwiDivC_16s_C3RSfs(pSrc, srcStep, value, pDst, dstStep, roiSize, scaleFactor);
    }
}


OREFR               FwStatus fwiLabToBGR_8u_C3R( const Fw8u *pSrc, int srcStep, Fw8u *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiLabToBGR_8u_C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiLabToBGR_8u_C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiRShiftC_8u_C4IR( const Fw32u value[4], Fw8u *pSrcDst, int srcDstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiRShiftC_8u_C4IR(value, pSrcDst, srcDstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiRShiftC_8u_C4IR(value, pSrcDst, srcDstStep, roiSize);
    case DT_REFR:
        return _refr_fwiRShiftC_8u_C4IR(value, pSrcDst, srcDstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiRShiftC_8u_C4IR(value, pSrcDst, srcDstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiOrC_16u_AC4R( const Fw16u  *pSrc, int srcStep, const Fw16u value[3], Fw16u *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiOrC_16u_AC4R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiOrC_16u_AC4R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiOrC_16u_AC4R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiOrC_16u_AC4R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiCopy_16s_AC4C3R( const Fw16s *pSrc, int srcStep, Fw16s *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiCopy_16s_AC4C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiCopy_16s_AC4C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiCopy_16s_AC4C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiCopy_16s_AC4C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiAndC_8u_C3R( const Fw8u   *pSrc, int srcStep, const Fw8u value[3], Fw8u *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiAndC_8u_C3R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiAndC_8u_C3R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiAndC_8u_C3R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiAndC_8u_C3R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiFilterLaplace_16s_C3R( const Fw16s * pSrc, int srcStep, Fw16s * pDst, int dstStep, FwiSize dstRoiSize, FwiMaskSize maskSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilterLaplace_16s_C3R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize);
    case DT_REFR:
        return _refr_fwiFilterLaplace_16s_C3R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize);
    default:
        assert(false);
        return _refr_fwiFilterLaplace_16s_C3R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiCompare_8u_C3R( const Fw8u *pSrc1, int src1Step, const Fw8u *pSrc2, int src2Step, Fw8u *pDst, int dstStep, FwiSize roiSize, FwCmpOp fwCmpOp )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiCompare_8u_C3R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, fwCmpOp);
    case DT_SSE2:
        return _sse2_fwiCompare_8u_C3R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, fwCmpOp);
    case DT_REFR:
        return _refr_fwiCompare_8u_C3R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, fwCmpOp);
    default:
        assert(false);
        return _refr_fwiCompare_8u_C3R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, fwCmpOp);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiCompareC_8u_C1R( const Fw8u *pSrc, int srcStep, Fw8u value, Fw8u *pDst, int dstStep, FwiSize roiSize, FwCmpOp fwCmpOp )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiCompareC_8u_C1R(pSrc, srcStep, value, pDst, dstStep, roiSize, fwCmpOp);
    case DT_SSE2:
        return _sse2_fwiCompareC_8u_C1R(pSrc, srcStep, value, pDst, dstStep, roiSize, fwCmpOp);
    case DT_REFR:
        return _refr_fwiCompareC_8u_C1R(pSrc, srcStep, value, pDst, dstStep, roiSize, fwCmpOp);
    default:
        assert(false);
        return _refr_fwiCompareC_8u_C1R(pSrc, srcStep, value, pDst, dstStep, roiSize, fwCmpOp);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiFilterGauss_16s_C4R( const Fw16s * pSrc, int srcStep, Fw16s * pDst, int dstStep, FwiSize dstRoiSize, FwiMaskSize maskSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilterGauss_16s_C4R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize);
    case DT_REFR:
        return _refr_fwiFilterGauss_16s_C4R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize);
    default:
        assert(false);
        return _refr_fwiFilterGauss_16s_C4R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiSubC_16s_C4IRSfs( const Fw16s value[4], Fw16s *pSrcDst, int srcDstStep, FwiSize roiSize, int scaleFactor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiSubC_16s_C4IRSfs(value, pSrcDst, srcDstStep, roiSize, scaleFactor);
    case DT_SSE2:
        return _sse2_fwiSubC_16s_C4IRSfs(value, pSrcDst, srcDstStep, roiSize, scaleFactor);
    case DT_REFR:
        return _refr_fwiSubC_16s_C4IRSfs(value, pSrcDst, srcDstStep, roiSize, scaleFactor);
    default:
        assert(false);
        return _refr_fwiSubC_16s_C4IRSfs(value, pSrcDst, srcDstStep, roiSize, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiCopy_32f_C4MR( const Fw32f *pSrc, int srcStep, Fw32f *pDst, int dstStep, FwiSize roiSize, const Fw8u *pMask, int maskStep )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiCopy_32f_C4MR(pSrc, srcStep, pDst, dstStep, roiSize, pMask, maskStep);
    case DT_SSE2:
        return _sse2_fwiCopy_32f_C4MR(pSrc, srcStep, pDst, dstStep, roiSize, pMask, maskStep);
    case DT_REFR:
        return _refr_fwiCopy_32f_C4MR(pSrc, srcStep, pDst, dstStep, roiSize, pMask, maskStep);
    default:
        assert(false);
        return _refr_fwiCopy_32f_C4MR(pSrc, srcStep, pDst, dstStep, roiSize, pMask, maskStep);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiFilterGauss_32f_C3R( const Fw32f * pSrc, int srcStep, Fw32f * pDst, int dstStep, FwiSize dstRoiSize, FwiMaskSize maskSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilterGauss_32f_C3R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize);
    case DT_REFR:
        return _refr_fwiFilterGauss_32f_C3R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize);
    default:
        assert(false);
        return _refr_fwiFilterGauss_32f_C3R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiFilterMedianHoriz_16s_C4R( const Fw16s * pSrc, int srcStep,
                                               Fw16s * pDst, int dstStep, FwiSize dstRoiSize,
                                               FwiMaskSize maskSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilterMedianHoriz_16s_C4R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize);
    case DT_REFR:
        return _refr_fwiFilterMedianHoriz_16s_C4R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize);
    default:
        assert(false);
        return _refr_fwiFilterMedianHoriz_16s_C4R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiAdd_8u_C1IRSfs( const Fw8u   *pSrc,  int srcStep,		Fw8u   *pSrcDst, int srcDstStep, FwiSize roiSize, int scaleFactor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiAdd_8u_C1IRSfs(pSrc, srcStep, pSrcDst, srcDstStep, roiSize, scaleFactor);
    case DT_SSE2:
        return _sse2_fwiAdd_8u_C1IRSfs(pSrc, srcStep, pSrcDst, srcDstStep, roiSize, scaleFactor);
    case DT_REFR:
        return _refr_fwiAdd_8u_C1IRSfs(pSrc, srcStep, pSrcDst, srcDstStep, roiSize, scaleFactor);
    default:
        assert(false);
        return _refr_fwiAdd_8u_C1IRSfs(pSrc, srcStep, pSrcDst, srcDstStep, roiSize, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiThreshold_LTValGTVal_8u_AC4IR( Fw8u *pSrcDst, int srcDstStep, FwiSize roiSize, const Fw8u thresholdLT[3], const Fw8u valueLT[3], const Fw8u thresholdGT[3], const Fw8u valueGT[3])
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiThreshold_LTValGTVal_8u_AC4IR(pSrcDst, srcDstStep, roiSize, thresholdLT, valueLT, thresholdGT, valueGT);
    case DT_SSE2:
        return _sse2_fwiThreshold_LTValGTVal_8u_AC4IR(pSrcDst, srcDstStep, roiSize, thresholdLT, valueLT, thresholdGT, valueGT);
    case DT_REFR:
        return _refr_fwiThreshold_LTValGTVal_8u_AC4IR(pSrcDst, srcDstStep, roiSize, thresholdLT, valueLT, thresholdGT, valueGT);
    default:
        assert(false);
        return _refr_fwiThreshold_LTValGTVal_8u_AC4IR(pSrcDst, srcDstStep, roiSize, thresholdLT, valueLT, thresholdGT, valueGT);
    }
}


OREFR OSSE2 FwStatus STDCALL fwiDCT8x8Fwd_16s_C1(const Fw16s* pSrc, Fw16s* pDst)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiDCT8x8Fwd_16s_C1(pSrc, pDst);
    case DT_REFR:
        return _refr_fwiDCT8x8Fwd_16s_C1(pSrc, pDst);
    default:
        assert(false);
        return _refr_fwiDCT8x8Fwd_16s_C1(pSrc, pDst);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiFilter32f_16s_C1R( const Fw16s * pSrc, int srcStep,
                                 Fw16s * pDst, int dstStep, FwiSize dstRoiSize,
                                 const Fw32f * pKernel, FwiSize kernelSize,
                                 FwiPoint anchor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilter32f_16s_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize, pKernel, kernelSize, anchor);
    case DT_REFR:
        return _refr_fwiFilter32f_16s_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize, pKernel, kernelSize, anchor);
    default:
        assert(false);
        return _refr_fwiFilter32f_16s_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize, pKernel, kernelSize, anchor);
    }
}

OREFR             FwStatus STDCALL fwiScale_16s8u_C4R( const Fw16s * pSrc, int srcStep, Fw8u * pDst, int dstStep, FwiSize roiSize, FwHintAlgorithm hint )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiScale_16s8u_C4R(pSrc, srcStep, pDst, dstStep, roiSize, hint);
    default:
        assert(false);
        return _refr_fwiScale_16s8u_C4R(pSrc, srcStep, pDst, dstStep, roiSize, hint);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiSubC_32fc_C1R( const Fw32fc *pSrc, int srcStep,       Fw32fc value,     Fw32fc *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiSubC_32fc_C1R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiSubC_32fc_C1R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiSubC_32fc_C1R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiSubC_32fc_C1R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiFilterColumn_32f_C1R( const Fw32f * pSrc, int srcStep,
                              Fw32f * pDst, int dstStep, FwiSize dstRoiSize,
                              const Fw32f * pKernel, int kernelSize,
                              int yAnchor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilterColumn_32f_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize, pKernel, kernelSize, yAnchor);
    case DT_REFR:
        return _refr_fwiFilterColumn_32f_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize, pKernel, kernelSize, yAnchor);
    default:
        assert(false);
        return _refr_fwiFilterColumn_32f_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize, pKernel, kernelSize, yAnchor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiDiv_32f_C4IR( const Fw32f  *pSrc,  int srcStep,        Fw32f  *pSrcDst, int srcDstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiDiv_32f_C4IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiDiv_32f_C4IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    case DT_REFR:
        return _refr_fwiDiv_32f_C4IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiDiv_32f_C4IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    }
}


OREFR OSSE2       FwStatus STDCALL fwiFilterSobelHoriz_8u_C1R( const Fw8u * pSrc, int srcStep, Fw8u * pDst, int dstStep, FwiSize dstRoiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilterSobelHoriz_8u_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize);
    case DT_REFR:
        return _refr_fwiFilterSobelHoriz_8u_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize);
    default:
        assert(false);
        return _refr_fwiFilterSobelHoriz_8u_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiAdd_32sc_AC4RSfs( const Fw32sc *pSrc1, int src1Step, const Fw32sc *pSrc2,   int src2Step, Fw32sc *pDst, int dstStep, FwiSize roiSize, int scaleFactor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiAdd_32sc_AC4RSfs(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, scaleFactor);
    case DT_SSE2:
        return _sse2_fwiAdd_32sc_AC4RSfs(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, scaleFactor);
    case DT_REFR:
        return _refr_fwiAdd_32sc_AC4RSfs(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, scaleFactor);
    default:
        assert(false);
        return _refr_fwiAdd_32sc_AC4RSfs(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiAdd_16sc_C3IRSfs( const Fw16sc *pSrc,  int srcStep,        Fw16sc *pSrcDst, int srcDstStep, FwiSize roiSize, int scaleFactor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiAdd_16sc_C3IRSfs(pSrc, srcStep, pSrcDst, srcDstStep, roiSize, scaleFactor);
    case DT_SSE2:
        return _sse2_fwiAdd_16sc_C3IRSfs(pSrc, srcStep, pSrcDst, srcDstStep, roiSize, scaleFactor);
    case DT_REFR:
        return _refr_fwiAdd_16sc_C3IRSfs(pSrc, srcStep, pSrcDst, srcDstStep, roiSize, scaleFactor);
    default:
        assert(false);
        return _refr_fwiAdd_16sc_C3IRSfs(pSrc, srcStep, pSrcDst, srcDstStep, roiSize, scaleFactor);
    }
}

OREFR               FwStatus fwiYCbCrToRGB444_8u16u_P3C3R(const A8U* const pSrc[3], int srcStep, A16U* pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiYCbCrToRGB444_8u16u_P3C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiYCbCrToRGB444_8u16u_P3C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}


OREFR               FwStatus fwiRGBToYUV422_8u_C3C2R( const A8U* pSrc, int srcStep, A8U* pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiRGBToYUV422_8u_C3C2R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiRGBToYUV422_8u_C3C2R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiSqr_16s_AC4RSfs( const Fw16s *pSrc,    int srcStep, Fw16s *pDst, int dstStep, FwiSize roiSize, int scaleFactor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiSqr_16s_AC4RSfs(pSrc, srcStep, pDst, dstStep, roiSize, scaleFactor);
    case DT_SSE2:
        return _sse2_fwiSqr_16s_AC4RSfs(pSrc, srcStep, pDst, dstStep, roiSize, scaleFactor);
    case DT_REFR:
        return _refr_fwiSqr_16s_AC4RSfs(pSrc, srcStep, pDst, dstStep, roiSize, scaleFactor);
    default:
        assert(false);
        return _refr_fwiSqr_16s_AC4RSfs(pSrc, srcStep, pDst, dstStep, roiSize, scaleFactor);
    }
}

OREFR OSSE2 FwStatus STDCALL fwiWarpAffineQuad_8u_C3R( const Fw8u* pSrc, FwiSize srcSize, int srcStep, FwiRect srcRoi,
							        const double srcQuad[4][2], Fw8u* pDst, int dstStep, FwiRect dstRoi,
									const double dstQuad[4][2], int interpolation )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiWarpAffineQuad_8u_C3R(pSrc, srcSize, srcStep, srcRoi, srcQuad, pDst, dstStep, dstRoi, dstQuad, interpolation);
    case DT_REFR:
        return _refr_fwiWarpAffineQuad_8u_C3R(pSrc, srcSize, srcStep, srcRoi, srcQuad, pDst, dstStep, dstRoi, dstQuad, interpolation);
    default:
        assert(false);
        return _refr_fwiWarpAffineQuad_8u_C3R(pSrc, srcSize, srcStep, srcRoi, srcQuad, pDst, dstStep, dstRoi, dstQuad, interpolation);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiAbsDiffC_16u_C1R( const Fw16u *pSrc, int srcStep,  Fw16u *pDst, int dstStep, FwiSize roiSize, int    value )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiAbsDiffC_16u_C1R(pSrc, srcStep, pDst, dstStep, roiSize, value);
    case DT_SSE2:
        return _sse2_fwiAbsDiffC_16u_C1R(pSrc, srcStep, pDst, dstStep, roiSize, value);
    case DT_REFR:
        return _refr_fwiAbsDiffC_16u_C1R(pSrc, srcStep, pDst, dstStep, roiSize, value);
    default:
        assert(false);
        return _refr_fwiAbsDiffC_16u_C1R(pSrc, srcStep, pDst, dstStep, roiSize, value);
    }
}

OREFR               FwStatus fwiYCbCr422ToRGB555_8u16u_C2C3R(const A8U* pSrc, int srcStep, A16U* pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiYCbCr422ToRGB555_8u16u_C2C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiYCbCr422ToRGB555_8u16u_C2C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiXor_32s_C1R( const Fw32s *pSrc1, int src1Step, const Fw32s *pSrc2,   int src2Step, Fw32s *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiXor_32s_C1R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiXor_32s_C1R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiXor_32s_C1R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiXor_32s_C1R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    }
}

OREFR       FwStatus STDCALL fwiMirror_32f_AC4IR(Fw32f *pSrcDst, int srcDstStep, FwiSize roiSize, FwiAxis flip)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiMirror_32f_AC4IR(pSrcDst, srcDstStep, roiSize, flip);
    default:
        assert(false);
        return _refr_fwiMirror_32f_AC4IR(pSrcDst, srcDstStep, roiSize, flip);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiMul_32fc_C3R( const Fw32fc *pSrc1, int src1Step, const Fw32fc *pSrc2,   int src2Step, Fw32fc *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiMul_32fc_C3R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiMul_32fc_C3R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiMul_32fc_C3R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiMul_32fc_C3R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiAddC_16sc_AC4IRSfs( const Fw16sc value[3], Fw16sc *pSrcDst, int srcDstStep, FwiSize roiSize, int scaleFactor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiAddC_16sc_AC4IRSfs(value, pSrcDst, srcDstStep, roiSize, scaleFactor);
    case DT_SSE2:
        return _sse2_fwiAddC_16sc_AC4IRSfs(value, pSrcDst, srcDstStep, roiSize, scaleFactor);
    case DT_REFR:
        return _refr_fwiAddC_16sc_AC4IRSfs(value, pSrcDst, srcDstStep, roiSize, scaleFactor);
    default:
        assert(false);
        return _refr_fwiAddC_16sc_AC4IRSfs(value, pSrcDst, srcDstStep, roiSize, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiThreshold_Val_32f_C1R( const Fw32f *pSrc, int srcStep, Fw32f *pDst, int dstStep, FwiSize roiSize, Fw32f threshold, Fw32f value, FwCmpOp fwCmpOp)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiThreshold_Val_32f_C1R(pSrc, srcStep, pDst, dstStep, roiSize, threshold, value, fwCmpOp);
    case DT_SSE2:
        return _sse2_fwiThreshold_Val_32f_C1R(pSrc, srcStep, pDst, dstStep, roiSize, threshold, value, fwCmpOp);
    case DT_REFR:
        return _refr_fwiThreshold_Val_32f_C1R(pSrc, srcStep, pDst, dstStep, roiSize, threshold, value, fwCmpOp);
    default:
        assert(false);
        return _refr_fwiThreshold_Val_32f_C1R(pSrc, srcStep, pDst, dstStep, roiSize, threshold, value, fwCmpOp);
    }
}

OREFR               FwStatus fwiCountInRange_8u_C3R(const Fw8u* pSrc, int srcStep,FwiSize roiSize, int counts[3], Fw8u lowerBound[3],Fw8u upperBound[3])
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiCountInRange_8u_C3R(pSrc, srcStep, roiSize, counts, lowerBound, upperBound);
    default:
        assert(false);
        return _refr_fwiCountInRange_8u_C3R(pSrc, srcStep, roiSize, counts, lowerBound, upperBound);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiFilterRobertsDown_8u_AC4R( const Fw8u * pSrc, int srcStep, Fw8u * pDst, int dstStep, FwiSize dstRoiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilterRobertsDown_8u_AC4R(pSrc, srcStep, pDst, dstStep, dstRoiSize);
    case DT_REFR:
        return _refr_fwiFilterRobertsDown_8u_AC4R(pSrc, srcStep, pDst, dstStep, dstRoiSize);
    default:
        assert(false);
        return _refr_fwiFilterRobertsDown_8u_AC4R(pSrc, srcStep, pDst, dstStep, dstRoiSize);
    }
}

OREFR       FwStatus STDCALL fwiWarpBilinearBack_8u_AC4R(const Fw8u* pSrc, FwiSize srcSize, int srcStep,
								FwiRect srcRoi, Fw8u* pDst, int dstStep, FwiRect dstRoi,
								const double coeffs[2][4], int interpolation)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiWarpBilinearBack_8u_AC4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, coeffs, interpolation);
    default:
        assert(false);
        return _refr_fwiWarpBilinearBack_8u_AC4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, coeffs, interpolation);
    }
}

OREFR               FwStatus fwiRGBToYUV422_8u_C3P3R( const A8U* pSrc, int srcStep, A8U* pDst[3], int dstStep[3], FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiRGBToYUV422_8u_C3P3R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiRGBToYUV422_8u_C3P3R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR       FwStatus STDCALL fwiMirror_32f_C3IR(Fw32f *pSrcDst, int srcDstStep, FwiSize roiSize, FwiAxis flip)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiMirror_32f_C3IR(pSrcDst, srcDstStep, roiSize, flip);
    default:
        assert(false);
        return _refr_fwiMirror_32f_C3IR(pSrcDst, srcDstStep, roiSize, flip);
    }
}


OREFR               FwStatus fwiBGRToLab_8u_C3R( const Fw8u *pSrc, int srcStep, Fw8u *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiBGRToLab_8u_C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiBGRToLab_8u_C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiConvert_16s8u_C4R( const Fw16s *pSrc, int srcStep, Fw8u *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiConvert_16s8u_C4R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiConvert_16s8u_C4R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiConvert_16s8u_C4R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiConvert_16s8u_C4R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiSqr_16s_C4IRSfs(       Fw16s *pSrcDst, int srcDstStep, FwiSize roiSize, int scaleFactor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiSqr_16s_C4IRSfs(pSrcDst, srcDstStep, roiSize, scaleFactor);
    case DT_SSE2:
        return _sse2_fwiSqr_16s_C4IRSfs(pSrcDst, srcDstStep, roiSize, scaleFactor);
    case DT_REFR:
        return _refr_fwiSqr_16s_C4IRSfs(pSrcDst, srcDstStep, roiSize, scaleFactor);
    default:
        assert(false);
        return _refr_fwiSqr_16s_C4IRSfs(pSrcDst, srcDstStep, roiSize, scaleFactor);
    }
}

OREFR OSSE2 FwStatus STDCALL fwiWarpAffine_32f_C3R( const Fw32f* pSrc, FwiSize srcSize, int srcStep,
								FwiRect srcRoi, Fw32f* pDst, int dstStep, FwiRect dstRoi,
								const double coeffs[2][3], int interpolation )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiWarpAffine_32f_C3R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, coeffs, interpolation);
    case DT_REFR:
        return _refr_fwiWarpAffine_32f_C3R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, coeffs, interpolation);
    default:
        assert(false);
        return _refr_fwiWarpAffine_32f_C3R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, coeffs, interpolation);
    }
}

OREFR               FwStatus fwiHLSToRGB_16u_C3R( const Fw16u* pSrc, int srcStep, Fw16u* pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiHLSToRGB_16u_C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiHLSToRGB_16u_C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2         FwStatus fwiYUV422ToRGB_8u_P3R( const A8U* const pSrc[3], int srcStep[3], A8U* const pDst[3], int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiYUV422ToRGB_8u_P3R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiYUV422ToRGB_8u_P3R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiYUV422ToRGB_8u_P3R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiFilterGauss_8u_C4R( const Fw8u * pSrc, int srcStep, Fw8u * pDst, int dstStep, FwiSize dstRoiSize, FwiMaskSize maskSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilterGauss_8u_C4R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize);
    case DT_REFR:
        return _refr_fwiFilterGauss_8u_C4R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize);
    default:
        assert(false);
        return _refr_fwiFilterGauss_8u_C4R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize);
    }
}

OREFR OSSE2 FwStatus STDCALL fwiResizeCenter_16u_AC4R( const Fw16u* pSrc, FwiSize srcSize, int srcStep, FwiRect srcRoi,
								    Fw16u* pDst, int dstStep, FwiSize dstRoiSize,
								    double xFactor, double yFactor, double xCenter, double yCenter, int interpolation )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiResizeCenter_16u_AC4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoiSize, xFactor, yFactor, xCenter, yCenter, interpolation);
    case DT_REFR:
        return _refr_fwiResizeCenter_16u_AC4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoiSize, xFactor, yFactor, xCenter, yCenter, interpolation);
    default:
        assert(false);
        return _refr_fwiResizeCenter_16u_AC4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoiSize, xFactor, yFactor, xCenter, yCenter, interpolation);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiFilterPrewittVert_32f_C1R( const Fw32f * pSrc, int srcStep, Fw32f * pDst, int dstStep, FwiSize dstRoiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilterPrewittVert_32f_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize);
    case DT_REFR:
        return _refr_fwiFilterPrewittVert_32f_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize);
    default:
        assert(false);
        return _refr_fwiFilterPrewittVert_32f_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiAdd_32fc_AC4IR( const Fw32fc *pSrc,  int srcStep,        Fw32fc *pSrcDst, int srcDstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiAdd_32fc_AC4IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiAdd_32fc_AC4IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    case DT_REFR:
        return _refr_fwiAdd_32fc_AC4IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiAdd_32fc_AC4IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    }
}


OREFR OSSE2 FwStatus STDCALL fwiGetAffineQuad(FwiRect srcRoi, double quad[4][2], const double coeffs[2][3])
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiGetAffineQuad(srcRoi, quad, coeffs);
    case DT_REFR:
        return _refr_fwiGetAffineQuad(srcRoi, quad, coeffs);
    default:
        assert(false);
        return _refr_fwiGetAffineQuad(srcRoi, quad, coeffs);
    }
}


OREFR OSSE2         FwStatus fwiLookUp3DSpecInitAlloc(const Fw16u cubeDimensions, const Fw16u cubeMax, FwiLUTSpec** ppLUTSpec)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiLookUp3DSpecInitAlloc(cubeDimensions, cubeMax, ppLUTSpec);
    case DT_REFR:
        return _refr_fwiLookUp3DSpecInitAlloc(cubeDimensions, cubeMax, ppLUTSpec);
    default:
        assert(false);
        return _refr_fwiLookUp3DSpecInitAlloc(cubeDimensions, cubeMax, ppLUTSpec);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiThreshold_GTVal_8u_C4R( const Fw8u *pSrc, int srcStep, Fw8u *pDst, int dstStep, FwiSize roiSize, const Fw8u threshold[4], const Fw8u value[4])
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiThreshold_GTVal_8u_C4R(pSrc, srcStep, pDst, dstStep, roiSize, threshold, value);
    case DT_SSE2:
        return _sse2_fwiThreshold_GTVal_8u_C4R(pSrc, srcStep, pDst, dstStep, roiSize, threshold, value);
    case DT_REFR:
        return _refr_fwiThreshold_GTVal_8u_C4R(pSrc, srcStep, pDst, dstStep, roiSize, threshold, value);
    default:
        assert(false);
        return _refr_fwiThreshold_GTVal_8u_C4R(pSrc, srcStep, pDst, dstStep, roiSize, threshold, value);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiMul_8u_C1IRSfs( const Fw8u   *pSrc,  int srcStep,        Fw8u   *pSrcDst, int srcDstStep, FwiSize roiSize, int scaleFactor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiMul_8u_C1IRSfs(pSrc, srcStep, pSrcDst, srcDstStep, roiSize, scaleFactor);
    case DT_SSE2:
        return _sse2_fwiMul_8u_C1IRSfs(pSrc, srcStep, pSrcDst, srcDstStep, roiSize, scaleFactor);
    case DT_REFR:
        return _refr_fwiMul_8u_C1IRSfs(pSrc, srcStep, pSrcDst, srcDstStep, roiSize, scaleFactor);
    default:
        assert(false);
        return _refr_fwiMul_8u_C1IRSfs(pSrc, srcStep, pSrcDst, srcDstStep, roiSize, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiCopy_8u_C4P4R( const Fw8u *pSrc, int srcStep, Fw8u * const pDst[4], int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiCopy_8u_C4P4R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiCopy_8u_C4P4R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiCopy_8u_C4P4R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiCopy_8u_C4P4R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiOrC_32s_C4R( const Fw32s  *pSrc, int srcStep, const Fw32s value[4], Fw32s *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiOrC_32s_C4R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiOrC_32s_C4R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiOrC_32s_C4R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiOrC_32s_C4R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiCompareEqualEpsC_32f_C3R( const Fw32f *pSrc, int srcStep, const Fw32f value[3], Fw8u *pDst, int dstStep, FwiSize roiSize, Fw32f eps)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiCompareEqualEpsC_32f_C3R(pSrc, srcStep, value, pDst, dstStep, roiSize, eps);
    case DT_SSE2:
        return _sse2_fwiCompareEqualEpsC_32f_C3R(pSrc, srcStep, value, pDst, dstStep, roiSize, eps);
    case DT_REFR:
        return _refr_fwiCompareEqualEpsC_32f_C3R(pSrc, srcStep, value, pDst, dstStep, roiSize, eps);
    default:
        assert(false);
        return _refr_fwiCompareEqualEpsC_32f_C3R(pSrc, srcStep, value, pDst, dstStep, roiSize, eps);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiAndC_8u_C1IR(       Fw8u value,    Fw8u *pSrcDst, int srcDstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiAndC_8u_C1IR(value, pSrcDst, srcDstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiAndC_8u_C1IR(value, pSrcDst, srcDstStep, roiSize);
    case DT_REFR:
        return _refr_fwiAndC_8u_C1IR(value, pSrcDst, srcDstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiAndC_8u_C1IR(value, pSrcDst, srcDstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiAddSquare_32f_C1IMR( const Fw32f *pSrc, int srcStep, const Fw8u* pMask, int maskStep, Fw32f* pSrcDst, int srcDstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiAddSquare_32f_C1IMR(pSrc, srcStep, pMask, maskStep, pSrcDst, srcDstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiAddSquare_32f_C1IMR(pSrc, srcStep, pMask, maskStep, pSrcDst, srcDstStep, roiSize);
    case DT_REFR:
        return _refr_fwiAddSquare_32f_C1IMR(pSrc, srcStep, pMask, maskStep, pSrcDst, srcDstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiAddSquare_32f_C1IMR(pSrc, srcStep, pMask, maskStep, pSrcDst, srcDstStep, roiSize);
    }
}

OREFR       FwStatus STDCALL fwiShear_32f_AC4R(const Fw32f* pSrc, FwiSize srcSize, int srcStep, FwiRect srcRoi, Fw32f* pDst, int dstStep, FwiRect dstRoi, double xShear, double yShear, double xShift, double yShift, int interpolation )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiShear_32f_AC4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, xShear, yShear, xShift, yShift, interpolation);
    default:
        assert(false);
        return _refr_fwiShear_32f_AC4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, xShear, yShear, xShift, yShift, interpolation);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiDivC_8u_C1IRSfs(       Fw8u value,    Fw8u *pSrcDst, int srcDstStep, FwiSize roiSize, int scaleFactor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiDivC_8u_C1IRSfs(value, pSrcDst, srcDstStep, roiSize, scaleFactor);
    case DT_SSE2:
        return _sse2_fwiDivC_8u_C1IRSfs(value, pSrcDst, srcDstStep, roiSize, scaleFactor);
    case DT_REFR:
        return _refr_fwiDivC_8u_C1IRSfs(value, pSrcDst, srcDstStep, roiSize, scaleFactor);
    default:
        assert(false);
        return _refr_fwiDivC_8u_C1IRSfs(value, pSrcDst, srcDstStep, roiSize, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiMulC_16s_C3RSfs( const Fw16s *pSrc, int srcStep, const Fw16s value[3], Fw16s *pDst, int dstStep, FwiSize roiSize, int scaleFactor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiMulC_16s_C3RSfs(pSrc, srcStep, value, pDst, dstStep, roiSize, scaleFactor);
    case DT_SSE2:
        return _sse2_fwiMulC_16s_C3RSfs(pSrc, srcStep, value, pDst, dstStep, roiSize, scaleFactor);
    case DT_REFR:
        return _refr_fwiMulC_16s_C3RSfs(pSrc, srcStep, value, pDst, dstStep, roiSize, scaleFactor);
    default:
        assert(false);
        return _refr_fwiMulC_16s_C3RSfs(pSrc, srcStep, value, pDst, dstStep, roiSize, scaleFactor);
    }
}

OREFR               FwStatus fwiLUVToRGB_16s_C3R( const Fw16s* pSrc, int srcStep, Fw16s* pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiLUVToRGB_16s_C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiLUVToRGB_16s_C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiRotate_16u_AC4R( const Fw16u* pSrc, FwiSize srcSize, int srcStep, FwiRect srcRoi, Fw16u* pDst, int dstStep, FwiRect dstRoi, double angle, double xShift, double yShift, int interpolation )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiRotate_16u_AC4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, angle, xShift, yShift, interpolation);
    case DT_REFR:
        return _refr_fwiRotate_16u_AC4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, angle, xShift, yShift, interpolation);
    default:
        assert(false);
        return _refr_fwiRotate_16u_AC4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, angle, xShift, yShift, interpolation);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiSet_32s_C4CR(		Fw32s  value,    Fw32s  * pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiSet_32s_C4CR(value, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiSet_32s_C4CR(value, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiSet_32s_C4CR(value, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiSet_32s_C4CR(value, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 FwStatus STDCALL fwiFilterSharpen_16s_C1R( const Fw16s * pSrc, int srcStep, Fw16s * pDst, int dstStep, FwiSize dstRoiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilterSharpen_16s_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize);
    case DT_REFR:
        return _refr_fwiFilterSharpen_16s_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize);
    default:
        assert(false);
        return _refr_fwiFilterSharpen_16s_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize);
    }
}

OREFR OSSE2         FwStatus fwiMinMax_32f_C3R(const Fw32f* pSrc, int srcStep,FwiSize roiSize, Fw32f min[3], Fw32f max[3])
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiMinMax_32f_C3R(pSrc, srcStep, roiSize, min, max);
    case DT_REFR:
        return _refr_fwiMinMax_32f_C3R(pSrc, srcStep, roiSize, min, max);
    default:
        assert(false);
        return _refr_fwiMinMax_32f_C3R(pSrc, srcStep, roiSize, min, max);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiOrC_16u_C3IR( const Fw16u value[3], Fw16u *pSrcDst, int srcDstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiOrC_16u_C3IR(value, pSrcDst, srcDstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiOrC_16u_C3IR(value, pSrcDst, srcDstStep, roiSize);
    case DT_REFR:
        return _refr_fwiOrC_16u_C3IR(value, pSrcDst, srcDstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiOrC_16u_C3IR(value, pSrcDst, srcDstStep, roiSize);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiFilterSobelVert_16s_C3R( const Fw16s * pSrc, int srcStep, Fw16s * pDst, int dstStep, FwiSize dstRoiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilterSobelVert_16s_C3R(pSrc, srcStep, pDst, dstStep, dstRoiSize);
    case DT_REFR:
        return _refr_fwiFilterSobelVert_16s_C3R(pSrc, srcStep, pDst, dstStep, dstRoiSize);
    default:
        assert(false);
        return _refr_fwiFilterSobelVert_16s_C3R(pSrc, srcStep, pDst, dstStep, dstRoiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiSet_32f_C3R( const Fw32f  value[3], Fw32f  * pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiSet_32f_C3R(value, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiSet_32f_C3R(value, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiSet_32f_C3R(value, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiSet_32f_C3R(value, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiAddC_8u_C1IRSfs(       Fw8u value,    Fw8u *pSrcDst, int srcDstStep, FwiSize roiSize, int scaleFactor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiAddC_8u_C1IRSfs(value, pSrcDst, srcDstStep, roiSize, scaleFactor);
    case DT_SSE2:
        return _sse2_fwiAddC_8u_C1IRSfs(value, pSrcDst, srcDstStep, roiSize, scaleFactor);
    case DT_REFR:
        return _refr_fwiAddC_8u_C1IRSfs(value, pSrcDst, srcDstStep, roiSize, scaleFactor);
    default:
        assert(false);
        return _refr_fwiAddC_8u_C1IRSfs(value, pSrcDst, srcDstStep, roiSize, scaleFactor);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiFilterMedianHoriz_16s_AC4R( const Fw16s * pSrc, int srcStep,
                                               Fw16s * pDst, int dstStep, FwiSize dstRoiSize,
                                               FwiMaskSize maskSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilterMedianHoriz_16s_AC4R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize);
    case DT_REFR:
        return _refr_fwiFilterMedianHoriz_16s_AC4R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize);
    default:
        assert(false);
        return _refr_fwiFilterMedianHoriz_16s_AC4R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiDivC_32sc_C3IRSfs( const Fw32sc value[3], Fw32sc *pSrcDst, int srcDstStep, FwiSize roiSize, int scaleFactor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiDivC_32sc_C3IRSfs(value, pSrcDst, srcDstStep, roiSize, scaleFactor);
    case DT_SSE2:
        return _sse2_fwiDivC_32sc_C3IRSfs(value, pSrcDst, srcDstStep, roiSize, scaleFactor);
    case DT_REFR:
        return _refr_fwiDivC_32sc_C3IRSfs(value, pSrcDst, srcDstStep, roiSize, scaleFactor);
    default:
        assert(false);
        return _refr_fwiDivC_32sc_C3IRSfs(value, pSrcDst, srcDstStep, roiSize, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiCopy_32s_AC4MR( const Fw32s *pSrc, int srcStep, Fw32s *pDst, int dstStep, FwiSize roiSize, const Fw8u *pMask, int maskStep )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiCopy_32s_AC4MR(pSrc, srcStep, pDst, dstStep, roiSize, pMask, maskStep);
    case DT_SSE2:
        return _sse2_fwiCopy_32s_AC4MR(pSrc, srcStep, pDst, dstStep, roiSize, pMask, maskStep);
    case DT_REFR:
        return _refr_fwiCopy_32s_AC4MR(pSrc, srcStep, pDst, dstStep, roiSize, pMask, maskStep);
    default:
        assert(false);
        return _refr_fwiCopy_32s_AC4MR(pSrc, srcStep, pDst, dstStep, roiSize, pMask, maskStep);
    }
}

OREFR OSSE2 FwStatus STDCALL fwiResize_8u_AC4R( const Fw8u* pSrc, FwiSize srcSize, int srcStep, FwiRect srcRoi,
							 Fw8u* pDst, int dstStep, FwiSize dstRoiSize,
							 double xFactor, double yFactor, int interpolation )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiResize_8u_AC4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoiSize, xFactor, yFactor, interpolation);
    case DT_REFR:
        return _refr_fwiResize_8u_AC4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoiSize, xFactor, yFactor, interpolation);
    default:
        assert(false);
        return _refr_fwiResize_8u_AC4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoiSize, xFactor, yFactor, interpolation);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiAbs_32f_AC4R( const Fw32f *pSrc, int srcStep, Fw32f *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiAbs_32f_AC4R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiAbs_32f_AC4R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiAbs_32f_AC4R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiAbs_32f_AC4R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiFilterRow32f_16s_C4R( const Fw16s * pSrc, int srcStep,
                                 Fw16s * pDst, int dstStep, FwiSize dstRoiSize,
                                const Fw32f * pKernel, int kernelSize,
                                int xAnchor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilterRow32f_16s_C4R(pSrc, srcStep, pDst, dstStep, dstRoiSize, pKernel, kernelSize, xAnchor);
    case DT_REFR:
        return _refr_fwiFilterRow32f_16s_C4R(pSrc, srcStep, pDst, dstStep, dstRoiSize, pKernel, kernelSize, xAnchor);
    default:
        assert(false);
        return _refr_fwiFilterRow32f_16s_C4R(pSrc, srcStep, pDst, dstStep, dstRoiSize, pKernel, kernelSize, xAnchor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiLn_8u_C1RSfs( const Fw8u  *pSrc, int srcStep, Fw8u  *pDst, int dstStep, FwiSize roiSize, int scaleFactor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiLn_8u_C1RSfs(pSrc, srcStep, pDst, dstStep, roiSize, scaleFactor);
    case DT_SSE2:
        return _sse2_fwiLn_8u_C1RSfs(pSrc, srcStep, pDst, dstStep, roiSize, scaleFactor);
    case DT_REFR:
        return _refr_fwiLn_8u_C1RSfs(pSrc, srcStep, pDst, dstStep, roiSize, scaleFactor);
    default:
        assert(false);
        return _refr_fwiLn_8u_C1RSfs(pSrc, srcStep, pDst, dstStep, roiSize, scaleFactor);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiFilterSobelHoriz_32f_C3R( const Fw32f * pSrc, int srcStep, Fw32f * pDst, int dstStep, FwiSize dstRoiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilterSobelHoriz_32f_C3R(pSrc, srcStep, pDst, dstStep, dstRoiSize);
    case DT_REFR:
        return _refr_fwiFilterSobelHoriz_32f_C3R(pSrc, srcStep, pDst, dstStep, dstRoiSize);
    default:
        assert(false);
        return _refr_fwiFilterSobelHoriz_32f_C3R(pSrc, srcStep, pDst, dstStep, dstRoiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiSub_8u_C1RSfs( const Fw8u   *pSrc1, int src1Step, const Fw8u   *pSrc2,   int src2Step, Fw8u *pDst, int dstStep, FwiSize roiSize, int scaleFactor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiSub_8u_C1RSfs(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, scaleFactor);
    case DT_SSE2:
        return _sse2_fwiSub_8u_C1RSfs(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, scaleFactor);
    case DT_REFR:
        return _refr_fwiSub_8u_C1RSfs(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, scaleFactor);
    default:
        assert(false);
        return _refr_fwiSub_8u_C1RSfs(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, scaleFactor);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiFilterPrewittHoriz_8u_C3R( const Fw8u * pSrc, int srcStep, Fw8u * pDst, int dstStep, FwiSize dstRoiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilterPrewittHoriz_8u_C3R(pSrc, srcStep, pDst, dstStep, dstRoiSize);
    case DT_REFR:
        return _refr_fwiFilterPrewittHoriz_8u_C3R(pSrc, srcStep, pDst, dstStep, dstRoiSize);
    default:
        assert(false);
        return _refr_fwiFilterPrewittHoriz_8u_C3R(pSrc, srcStep, pDst, dstStep, dstRoiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiThreshold_LTValGTVal_16s_AC4IR( Fw16s *pSrcDst, int srcDstStep, FwiSize roiSize, const Fw16s thresholdLT[3], const Fw16s valueLT[3], const Fw16s thresholdGT[3], const Fw16s valueGT[3])
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiThreshold_LTValGTVal_16s_AC4IR(pSrcDst, srcDstStep, roiSize, thresholdLT, valueLT, thresholdGT, valueGT);
    case DT_SSE2:
        return _sse2_fwiThreshold_LTValGTVal_16s_AC4IR(pSrcDst, srcDstStep, roiSize, thresholdLT, valueLT, thresholdGT, valueGT);
    case DT_REFR:
        return _refr_fwiThreshold_LTValGTVal_16s_AC4IR(pSrcDst, srcDstStep, roiSize, thresholdLT, valueLT, thresholdGT, valueGT);
    default:
        assert(false);
        return _refr_fwiThreshold_LTValGTVal_16s_AC4IR(pSrcDst, srcDstStep, roiSize, thresholdLT, valueLT, thresholdGT, valueGT);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiThreshold_GT_32f_C1IR( Fw32f *pSrcDst, int srcDstStep, FwiSize roiSize, Fw32f threshold)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiThreshold_GT_32f_C1IR(pSrcDst, srcDstStep, roiSize, threshold);
    case DT_SSE2:
        return _sse2_fwiThreshold_GT_32f_C1IR(pSrcDst, srcDstStep, roiSize, threshold);
    case DT_REFR:
        return _refr_fwiThreshold_GT_32f_C1IR(pSrcDst, srcDstStep, roiSize, threshold);
    default:
        assert(false);
        return _refr_fwiThreshold_GT_32f_C1IR(pSrcDst, srcDstStep, roiSize, threshold);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiThreshold_LTValGTVal_16s_C1R( const Fw16s *pSrc, int srcStep, Fw16s *pDst, int dstStep, FwiSize roiSize, Fw16s thresholdLT, Fw16s valueLT, Fw16s thresholdGT, Fw16s valueGT)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiThreshold_LTValGTVal_16s_C1R(pSrc, srcStep, pDst, dstStep, roiSize, thresholdLT, valueLT, thresholdGT, valueGT);
    case DT_SSE2:
        return _sse2_fwiThreshold_LTValGTVal_16s_C1R(pSrc, srcStep, pDst, dstStep, roiSize, thresholdLT, valueLT, thresholdGT, valueGT);
    case DT_REFR:
        return _refr_fwiThreshold_LTValGTVal_16s_C1R(pSrc, srcStep, pDst, dstStep, roiSize, thresholdLT, valueLT, thresholdGT, valueGT);
    default:
        assert(false);
        return _refr_fwiThreshold_LTValGTVal_16s_C1R(pSrc, srcStep, pDst, dstStep, roiSize, thresholdLT, valueLT, thresholdGT, valueGT);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiRotateCenter_32f_C3R( const Fw32f* pSrc,FwiSize srcSize, int srcStep, FwiRect srcRoi, Fw32f* pDst, int dstStep, FwiRect dstRoi, double angle, double xCenter, double yCenter, int interpolation )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiRotateCenter_32f_C3R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, angle, xCenter, yCenter, interpolation);
    case DT_REFR:
        return _refr_fwiRotateCenter_32f_C3R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, angle, xCenter, yCenter, interpolation);
    default:
        assert(false);
        return _refr_fwiRotateCenter_32f_C3R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, angle, xCenter, yCenter, interpolation);
    }
}


OREFR OSSE2 FwStatus STDCALL fwiResizeShift_8u_C1R( const Fw8u * pSrc, FwiSize srcSize, int srcStep, FwiRect srcRoi,
								  Fw8u * pDst, int dstStep, FwiSize dstRoiSize,
								  double xFr, double yFr, double xShift, double yShift, int interpolation )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiResizeShift_8u_C1R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoiSize, xFr, yFr, xShift, yShift, interpolation);
    case DT_REFR:
        return _refr_fwiResizeShift_8u_C1R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoiSize, xFr, yFr, xShift, yShift, interpolation);
    default:
        assert(false);
        return _refr_fwiResizeShift_8u_C1R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoiSize, xFr, yFr, xShift, yShift, interpolation);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiSubC_32f_C4IR( const Fw32f value[4], Fw32f *pSrcDst, int srcDstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiSubC_32f_C4IR(value, pSrcDst, srcDstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiSubC_32f_C4IR(value, pSrcDst, srcDstStep, roiSize);
    case DT_REFR:
        return _refr_fwiSubC_32f_C4IR(value, pSrcDst, srcDstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiSubC_32f_C4IR(value, pSrcDst, srcDstStep, roiSize);
    }
}

OREFR             FwStatus STDCALL fwiScale_16s8u_AC4R( const Fw16s * pSrc, int srcStep, Fw8u * pDst, int dstStep, FwiSize roiSize, FwHintAlgorithm hint )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiScale_16s8u_AC4R(pSrc, srcStep, pDst, dstStep, roiSize, hint);
    default:
        assert(false);
        return _refr_fwiScale_16s8u_AC4R(pSrc, srcStep, pDst, dstStep, roiSize, hint);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiFilterBox_8u_AC4IR( Fw8u * pSrcDst, int srcDstStep,
                               FwiSize dstRoiSize, FwiSize maskSize, FwiPoint anchor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilterBox_8u_AC4IR(pSrcDst, srcDstStep, dstRoiSize, maskSize, anchor);
    case DT_REFR:
        return _refr_fwiFilterBox_8u_AC4IR(pSrcDst, srcDstStep, dstRoiSize, maskSize, anchor);
    default:
        assert(false);
        return _refr_fwiFilterBox_8u_AC4IR(pSrcDst, srcDstStep, dstRoiSize, maskSize, anchor);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiFilterMax_16s_C4R( const Fw16s * pSrc, int srcStep,
                               Fw16s * pDst, int dstStep, FwiSize dstRoiSize,
                               FwiSize maskSize, FwiPoint anchor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilterMax_16s_C4R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize, anchor);
    case DT_REFR:
        return _refr_fwiFilterMax_16s_C4R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize, anchor);
    default:
        assert(false);
        return _refr_fwiFilterMax_16s_C4R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize, anchor);
    }
}

OREFR       FwStatus STDCALL fwiResizeSqrPixel_32f_C1R(const Fw32f* pSrc, FwiSize srcSize, int srcStep, FwiRect srcRoi,
			Fw32f* pDst, int dstStep, FwiRect dstRoi, double xFactor, double yFactor,
			double xShift, double yShift, int interpolation, Fw8u* pBuffer)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiResizeSqrPixel_32f_C1R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, xFactor, yFactor, xShift, yShift, interpolation, pBuffer);
    default:
        assert(false);
        return _refr_fwiResizeSqrPixel_32f_C1R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, xFactor, yFactor, xShift, yShift, interpolation, pBuffer);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiAdd_8u_C1RSfs( const Fw8u   *pSrc1, int src1Step, const Fw8u   *pSrc2,   int src2Step, Fw8u *pDst, int dstStep, FwiSize roiSize, int scaleFactor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiAdd_8u_C1RSfs(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, scaleFactor);
    case DT_SSE2:
        return _sse2_fwiAdd_8u_C1RSfs(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, scaleFactor);
    case DT_REFR:
        return _refr_fwiAdd_8u_C1RSfs(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, scaleFactor);
    default:
        assert(false);
        return _refr_fwiAdd_8u_C1RSfs(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiLShiftC_8u_C4R( const Fw8u   *pSrc, int srcStep, const Fw32u value[4], Fw8u *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiLShiftC_8u_C4R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiLShiftC_8u_C4R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiLShiftC_8u_C4R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiLShiftC_8u_C4R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiCompare_32f_C4R( const Fw32f *pSrc1, int src1Step, const Fw32f *pSrc2, int src2Step, Fw8u *pDst, int dstStep, FwiSize roiSize, FwCmpOp fwCmpOp )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiCompare_32f_C4R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, fwCmpOp);
    case DT_SSE2:
        return _sse2_fwiCompare_32f_C4R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, fwCmpOp);
    case DT_REFR:
        return _refr_fwiCompare_32f_C4R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, fwCmpOp);
    default:
        assert(false);
        return _refr_fwiCompare_32f_C4R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, fwCmpOp);
    }
}

OREFR               FwStatus fwiCbYCr422ToRGB_8u_C2C3R(const A8U* pSrc, int srcStep, A8U* pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiCbYCr422ToRGB_8u_C2C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiCbYCr422ToRGB_8u_C2C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiCompareC_32f_C4R( const Fw32f *pSrc, int srcStep, const Fw32f value[4], Fw8u *pDst, int dstStep, FwiSize roiSize, FwCmpOp fwCmpOp )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiCompareC_32f_C4R(pSrc, srcStep, value, pDst, dstStep, roiSize, fwCmpOp);
    case DT_SSE2:
        return _sse2_fwiCompareC_32f_C4R(pSrc, srcStep, value, pDst, dstStep, roiSize, fwCmpOp);
    case DT_REFR:
        return _refr_fwiCompareC_32f_C4R(pSrc, srcStep, value, pDst, dstStep, roiSize, fwCmpOp);
    default:
        assert(false);
        return _refr_fwiCompareC_32f_C4R(pSrc, srcStep, value, pDst, dstStep, roiSize, fwCmpOp);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiMul_32f_C3R( const Fw32f  *pSrc1, int src1Step, const Fw32f  *pSrc2,   int src2Step, Fw32f  *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiMul_32f_C3R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiMul_32f_C3R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiMul_32f_C3R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiMul_32f_C3R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiFilter32f_16s_C4R( const Fw16s * pSrc, int srcStep,
                                 Fw16s * pDst, int dstStep, FwiSize dstRoiSize,
                                 const Fw32f * pKernel, FwiSize kernelSize,
                                 FwiPoint anchor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilter32f_16s_C4R(pSrc, srcStep, pDst, dstStep, dstRoiSize, pKernel, kernelSize, anchor);
    case DT_REFR:
        return _refr_fwiFilter32f_16s_C4R(pSrc, srcStep, pDst, dstStep, dstRoiSize, pKernel, kernelSize, anchor);
    default:
        assert(false);
        return _refr_fwiFilter32f_16s_C4R(pSrc, srcStep, pDst, dstStep, dstRoiSize, pKernel, kernelSize, anchor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiAdd_32f_C1R( const Fw32f  *pSrc1, int src1Step, const Fw32f  *pSrc2,   int src2Step, Fw32f *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiAdd_32f_C1R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiAdd_32f_C1R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiAdd_32f_C1R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiAdd_32f_C1R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiAdd_32fc_AC4R( const Fw32fc *pSrc1, int src1Step, const Fw32fc *pSrc2,   int src2Step, Fw32fc *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiAdd_32fc_AC4R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiAdd_32fc_AC4R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiAdd_32fc_AC4R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiAdd_32fc_AC4R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2         FwStatus fwiRGBToGray_8u_C3C1R(const Fw8u* pSrc, int srcStep,Fw8u* pDst, int dstStep, FwiSize roiSize)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiRGBToGray_8u_C3C1R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiRGBToGray_8u_C3C1R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiRGBToGray_8u_C3C1R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiSqr_8u_C4RSfs( const Fw8u  *pSrc,    int srcStep, Fw8u *pDst, int dstStep, FwiSize roiSize, int scaleFactor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiSqr_8u_C4RSfs(pSrc, srcStep, pDst, dstStep, roiSize, scaleFactor);
    case DT_SSE2:
        return _sse2_fwiSqr_8u_C4RSfs(pSrc, srcStep, pDst, dstStep, roiSize, scaleFactor);
    case DT_REFR:
        return _refr_fwiSqr_8u_C4RSfs(pSrc, srcStep, pDst, dstStep, roiSize, scaleFactor);
    default:
        assert(false);
        return _refr_fwiSqr_8u_C4RSfs(pSrc, srcStep, pDst, dstStep, roiSize, scaleFactor);
    }
}


OREFR       FwStatus STDCALL fwiWarpBilinearQuad_8u_C1R(const Fw8u* pSrc, FwiSize srcSize, int srcStep, FwiRect srcRoi,
							        const double srcQuad[4][2], Fw8u* pDst, int dstStep, FwiRect dstRoi,
									const double dstQuad[4][2], int interpolation)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiWarpBilinearQuad_8u_C1R(pSrc, srcSize, srcStep, srcRoi, srcQuad, pDst, dstStep, dstRoi, dstQuad, interpolation);
    default:
        assert(false);
        return _refr_fwiWarpBilinearQuad_8u_C1R(pSrc, srcSize, srcStep, srcRoi, srcQuad, pDst, dstStep, dstRoi, dstQuad, interpolation);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiAdd_8u_C4IRSfs( const Fw8u   *pSrc,  int srcStep,        Fw8u   *pSrcDst, int srcDstStep, FwiSize roiSize, int scaleFactor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiAdd_8u_C4IRSfs(pSrc, srcStep, pSrcDst, srcDstStep, roiSize, scaleFactor);
    case DT_SSE2:
        return _sse2_fwiAdd_8u_C4IRSfs(pSrc, srcStep, pSrcDst, srcDstStep, roiSize, scaleFactor);
    case DT_REFR:
        return _refr_fwiAdd_8u_C4IRSfs(pSrc, srcStep, pSrcDst, srcDstStep, roiSize, scaleFactor);
    default:
        assert(false);
        return _refr_fwiAdd_8u_C4IRSfs(pSrc, srcStep, pSrcDst, srcDstStep, roiSize, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiCopy_32s_P3C3R( const Fw32s * const pSrc[3], int srcStep, Fw32s *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiCopy_32s_P3C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiCopy_32s_P3C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiCopy_32s_P3C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiCopy_32s_P3C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR               FwStatus fwiRGBToHSV_16u_AC4R( const Fw16u* pSrc, int srcStep, Fw16u* pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiRGBToHSV_16u_AC4R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiRGBToHSV_16u_AC4R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR               FwStatus fwiHLSToRGB_32f_C3R( const Fw32f* pSrc, int srcStep, Fw32f* pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiHLSToRGB_32f_C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiHLSToRGB_32f_C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiCopy_32s_C3CR( const Fw32s *pSrc, int srcStep, Fw32s *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiCopy_32s_C3CR(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiCopy_32s_C3CR(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiCopy_32s_C3CR(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiCopy_32s_C3CR(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiSet_32s_C3R( const Fw32s  value[3], Fw32s  * pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiSet_32s_C3R(value, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiSet_32s_C3R(value, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiSet_32s_C3R(value, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiSet_32s_C3R(value, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiAdd_16s_C4RSfs( const Fw16s  *pSrc1, int src1Step, const Fw16s  *pSrc2,   int src2Step, Fw16s *pDst, int dstStep, FwiSize roiSize, int scaleFactor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiAdd_16s_C4RSfs(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, scaleFactor);
    case DT_SSE2:
        return _sse2_fwiAdd_16s_C4RSfs(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, scaleFactor);
    case DT_REFR:
        return _refr_fwiAdd_16s_C4RSfs(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, scaleFactor);
    default:
        assert(false);
        return _refr_fwiAdd_16s_C4RSfs(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, scaleFactor);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiFilterPrewittVert_8u_C4R( const Fw8u * pSrc, int srcStep, Fw8u * pDst, int dstStep, FwiSize dstRoiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilterPrewittVert_8u_C4R(pSrc, srcStep, pDst, dstStep, dstRoiSize);
    case DT_REFR:
        return _refr_fwiFilterPrewittVert_8u_C4R(pSrc, srcStep, pDst, dstStep, dstRoiSize);
    default:
        assert(false);
        return _refr_fwiFilterPrewittVert_8u_C4R(pSrc, srcStep, pDst, dstStep, dstRoiSize);
    }
}

OREFR OSSE2 FwStatus STDCALL fwiResize_8u_C4R( const Fw8u* pSrc, FwiSize srcSize, int srcStep, FwiRect srcRoi,
							 Fw8u* pDst, int dstStep, FwiSize dstRoiSize,
							 double xFactor, double yFactor, int interpolation )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiResize_8u_C4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoiSize, xFactor, yFactor, interpolation);
    case DT_REFR:
        return _refr_fwiResize_8u_C4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoiSize, xFactor, yFactor, interpolation);
    default:
        assert(false);
        return _refr_fwiResize_8u_C4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoiSize, xFactor, yFactor, interpolation);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiFilterRow32f_8u_AC4R( const Fw8u * pSrc, int srcStep,
                                Fw8u * pDst, int dstStep, FwiSize dstRoiSize,
                                const Fw32f * pKernel, int kernelSize,
                                int xAnchor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilterRow32f_8u_AC4R(pSrc, srcStep, pDst, dstStep, dstRoiSize, pKernel, kernelSize, xAnchor);
    case DT_REFR:
        return _refr_fwiFilterRow32f_8u_AC4R(pSrc, srcStep, pDst, dstStep, dstRoiSize, pKernel, kernelSize, xAnchor);
    default:
        assert(false);
        return _refr_fwiFilterRow32f_8u_AC4R(pSrc, srcStep, pDst, dstStep, dstRoiSize, pKernel, kernelSize, xAnchor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiAddSquare_8u32f_C1IMR( const Fw8u *pSrc,  int srcStep, const Fw8u* pMask, int maskStep, Fw32f* pSrcDst, int srcDstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiAddSquare_8u32f_C1IMR(pSrc, srcStep, pMask, maskStep, pSrcDst, srcDstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiAddSquare_8u32f_C1IMR(pSrc, srcStep, pMask, maskStep, pSrcDst, srcDstStep, roiSize);
    case DT_REFR:
        return _refr_fwiAddSquare_8u32f_C1IMR(pSrc, srcStep, pMask, maskStep, pSrcDst, srcDstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiAddSquare_8u32f_C1IMR(pSrc, srcStep, pMask, maskStep, pSrcDst, srcDstStep, roiSize);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiRotateCenter_16u_C4R( const Fw16u* pSrc,FwiSize srcSize, int srcStep, FwiRect srcRoi, Fw16u* pDst, int dstStep, FwiRect dstRoi, double angle, double xCenter, double yCenter, int interpolation )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiRotateCenter_16u_C4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, angle, xCenter, yCenter, interpolation);
    case DT_REFR:
        return _refr_fwiRotateCenter_16u_C4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, angle, xCenter, yCenter, interpolation);
    default:
        assert(false);
        return _refr_fwiRotateCenter_16u_C4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, angle, xCenter, yCenter, interpolation);
    }
}


OREFR OSSE2         FwStatus fwiYUV420ToRGB_8u_P3R(const A8U* const pSrc[3], int srcStep[3], A8U* const pDst[3], int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiYUV420ToRGB_8u_P3R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiYUV420ToRGB_8u_P3R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiYUV420ToRGB_8u_P3R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiOr_32s_C4IR( const Fw32s *pSrc,  int srcStep,        Fw32s *pSrcDst, int srcDstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiOr_32s_C4IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiOr_32s_C4IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    case DT_REFR:
        return _refr_fwiOr_32s_C4IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiOr_32s_C4IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiLShiftC_16u_C4IR( const Fw32u value[4], Fw16u *pSrcDst, int srcDstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiLShiftC_16u_C4IR(value, pSrcDst, srcDstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiLShiftC_16u_C4IR(value, pSrcDst, srcDstStep, roiSize);
    case DT_REFR:
        return _refr_fwiLShiftC_16u_C4IR(value, pSrcDst, srcDstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiLShiftC_16u_C4IR(value, pSrcDst, srcDstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiConvert_8u32s_C4R( const Fw8u *pSrc, int srcStep, Fw32s *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiConvert_8u32s_C4R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiConvert_8u32s_C4R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiConvert_8u32s_C4R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiConvert_8u32s_C4R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiFilterRobertsUp_32f_C1R( const Fw32f * pSrc, int srcStep, Fw32f * pDst, int dstStep, FwiSize dstRoiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilterRobertsUp_32f_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize);
    case DT_REFR:
        return _refr_fwiFilterRobertsUp_32f_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize);
    default:
        assert(false);
        return _refr_fwiFilterRobertsUp_32f_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiCopy_32f_C3C1R( const Fw32f *pSrc, int srcStep, Fw32f *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiCopy_32f_C3C1R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiCopy_32f_C3C1R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiCopy_32f_C3C1R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiCopy_32f_C3C1R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiAdd_16s_C1IRSfs( const Fw16s  *pSrc,  int srcStep,        Fw16s  *pSrcDst, int srcDstStep, FwiSize roiSize, int scaleFactor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiAdd_16s_C1IRSfs(pSrc, srcStep, pSrcDst, srcDstStep, roiSize, scaleFactor);
    case DT_SSE2:
        return _sse2_fwiAdd_16s_C1IRSfs(pSrc, srcStep, pSrcDst, srcDstStep, roiSize, scaleFactor);
    case DT_REFR:
        return _refr_fwiAdd_16s_C1IRSfs(pSrc, srcStep, pSrcDst, srcDstStep, roiSize, scaleFactor);
    default:
        assert(false);
        return _refr_fwiAdd_16s_C1IRSfs(pSrc, srcStep, pSrcDst, srcDstStep, roiSize, scaleFactor);
    }
}


OREFR OSSE2       FwStatus STDCALL fwiFilterMedianVert_8u_C1R( const Fw8u * pSrc, int srcStep,
                                               Fw8u * pDst, int dstStep, FwiSize dstRoiSize,
                                               FwiMaskSize maskSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilterMedianVert_8u_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize);
    case DT_REFR:
        return _refr_fwiFilterMedianVert_8u_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize);
    default:
        assert(false);
        return _refr_fwiFilterMedianVert_8u_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiAdd_16s_C3RSfs( const Fw16s  *pSrc1, int src1Step, const Fw16s  *pSrc2,   int src2Step, Fw16s *pDst, int dstStep, FwiSize roiSize, int scaleFactor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiAdd_16s_C3RSfs(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, scaleFactor);
    case DT_SSE2:
        return _sse2_fwiAdd_16s_C3RSfs(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, scaleFactor);
    case DT_REFR:
        return _refr_fwiAdd_16s_C3RSfs(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, scaleFactor);
    default:
        assert(false);
        return _refr_fwiAdd_16s_C3RSfs(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiMulC_8u_C1IRSfs(       Fw8u value,    Fw8u *pSrcDst, int srcDstStep, FwiSize roiSize, int scaleFactor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiMulC_8u_C1IRSfs(value, pSrcDst, srcDstStep, roiSize, scaleFactor);
    case DT_SSE2:
        return _sse2_fwiMulC_8u_C1IRSfs(value, pSrcDst, srcDstStep, roiSize, scaleFactor);
    case DT_REFR:
        return _refr_fwiMulC_8u_C1IRSfs(value, pSrcDst, srcDstStep, roiSize, scaleFactor);
    default:
        assert(false);
        return _refr_fwiMulC_8u_C1IRSfs(value, pSrcDst, srcDstStep, roiSize, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiDiv_32f_C1R( const Fw32f  *pSrc1, int src1Step, const Fw32f  *pSrc2,   int src2Step, Fw32f  *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiDiv_32f_C1R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiDiv_32f_C1R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiDiv_32f_C1R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiDiv_32f_C1R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiSub_8u_C1IRSfs( const Fw8u   *pSrc,  int srcStep,        Fw8u   *pSrcDst, int srcDstStep, FwiSize roiSize, int scaleFactor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiSub_8u_C1IRSfs(pSrc, srcStep, pSrcDst, srcDstStep, roiSize, scaleFactor);
    case DT_SSE2:
        return _sse2_fwiSub_8u_C1IRSfs(pSrc, srcStep, pSrcDst, srcDstStep, roiSize, scaleFactor);
    case DT_REFR:
        return _refr_fwiSub_8u_C1IRSfs(pSrc, srcStep, pSrcDst, srcDstStep, roiSize, scaleFactor);
    default:
        assert(false);
        return _refr_fwiSub_8u_C1IRSfs(pSrc, srcStep, pSrcDst, srcDstStep, roiSize, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiAddC_32fc_AC4R( const Fw32fc  *pSrc, int srcStep,const Fw32fc  value[3], Fw32fc  *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiAddC_32fc_AC4R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiAddC_32fc_AC4R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiAddC_32fc_AC4R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiAddC_32fc_AC4R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiDivC_16sc_AC4RSfs( const Fw16sc *pSrc, int srcStep, const Fw16sc value[3], Fw16sc *pDst, int dstStep, FwiSize roiSize, int scaleFactor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiDivC_16sc_AC4RSfs(pSrc, srcStep, value, pDst, dstStep, roiSize, scaleFactor);
    case DT_SSE2:
        return _sse2_fwiDivC_16sc_AC4RSfs(pSrc, srcStep, value, pDst, dstStep, roiSize, scaleFactor);
    case DT_REFR:
        return _refr_fwiDivC_16sc_AC4RSfs(pSrc, srcStep, value, pDst, dstStep, roiSize, scaleFactor);
    default:
        assert(false);
        return _refr_fwiDivC_16sc_AC4RSfs(pSrc, srcStep, value, pDst, dstStep, roiSize, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiLShiftC_32s_C3IR( const Fw32u value[3], Fw32s *pSrcDst, int srcDstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiLShiftC_32s_C3IR(value, pSrcDst, srcDstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiLShiftC_32s_C3IR(value, pSrcDst, srcDstStep, roiSize);
    case DT_REFR:
        return _refr_fwiLShiftC_32s_C3IR(value, pSrcDst, srcDstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiLShiftC_32s_C3IR(value, pSrcDst, srcDstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiMulC_8u_C4RSfs( const Fw8u *pSrc, int srcStep, const Fw8u value[4], Fw8u *pDst, int dstStep, FwiSize roiSize, int scaleFactor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiMulC_8u_C4RSfs(pSrc, srcStep, value, pDst, dstStep, roiSize, scaleFactor);
    case DT_SSE2:
        return _sse2_fwiMulC_8u_C4RSfs(pSrc, srcStep, value, pDst, dstStep, roiSize, scaleFactor);
    case DT_REFR:
        return _refr_fwiMulC_8u_C4RSfs(pSrc, srcStep, value, pDst, dstStep, roiSize, scaleFactor);
    default:
        assert(false);
        return _refr_fwiMulC_8u_C4RSfs(pSrc, srcStep, value, pDst, dstStep, roiSize, scaleFactor);
    }
}

OREFR OSSE2 FwStatus STDCALL fwiWarpPerspectiveQuad_32f_C1R( const Fw32f* pSrc, FwiSize srcSize, int srcStep, FwiRect srcRoi,
							        const double srcQuad[4][2], Fw32f* pDst, int dstStep, FwiRect dstRoi,
									const double dstQuad[4][2], int interpolation )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiWarpPerspectiveQuad_32f_C1R(pSrc, srcSize, srcStep, srcRoi, srcQuad, pDst, dstStep, dstRoi, dstQuad, interpolation);
    case DT_REFR:
        return _refr_fwiWarpPerspectiveQuad_32f_C1R(pSrc, srcSize, srcStep, srcRoi, srcQuad, pDst, dstStep, dstRoi, dstQuad, interpolation);
    default:
        assert(false);
        return _refr_fwiWarpPerspectiveQuad_32f_C1R(pSrc, srcSize, srcStep, srcRoi, srcQuad, pDst, dstStep, dstRoi, dstQuad, interpolation);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiAdd_8u_C3RSfs( const Fw8u   *pSrc1, int src1Step, const Fw8u   *pSrc2,   int src2Step, Fw8u *pDst, int dstStep, FwiSize roiSize, int scaleFactor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiAdd_8u_C3RSfs(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, scaleFactor);
    case DT_SSE2:
        return _sse2_fwiAdd_8u_C3RSfs(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, scaleFactor);
    case DT_REFR:
        return _refr_fwiAdd_8u_C3RSfs(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, scaleFactor);
    default:
        assert(false);
        return _refr_fwiAdd_8u_C3RSfs(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiMulScale_8u_C1IR(  const Fw8u  *pSrc,  int srcStep,        Fw8u  *pSrcDst, int srcDstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiMulScale_8u_C1IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiMulScale_8u_C1IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    case DT_REFR:
        return _refr_fwiMulScale_8u_C1IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiMulScale_8u_C1IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    }
}

OREFR OSSE2 FwStatus STDCALL fwiWarpAffine_32f_P3R( const Fw32f* const pSrc[3], FwiSize srcSize, int srcStep,
								FwiRect srcRoi, Fw32f* const pDst[3], int dstStep, FwiRect dstRoi,
								const double coeffs[2][3], int interpolation )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiWarpAffine_32f_P3R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, coeffs, interpolation);
    case DT_REFR:
        return _refr_fwiWarpAffine_32f_P3R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, coeffs, interpolation);
    default:
        assert(false);
        return _refr_fwiWarpAffine_32f_P3R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, coeffs, interpolation);
    }
}


OREFR OSSE2       FwStatus STDCALL fwiFilterRow_8u_C1R( const Fw8u * pSrc, int srcStep,
                             Fw8u * pDst, int dstStep, FwiSize dstRoiSize,
                             const Fw32s * pKernel, int kernelSize,
                             int xAnchor, int divisor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilterRow_8u_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize, pKernel, kernelSize, xAnchor, divisor);
    case DT_REFR:
        return _refr_fwiFilterRow_8u_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize, pKernel, kernelSize, xAnchor, divisor);
    default:
        assert(false);
        return _refr_fwiFilterRow_8u_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize, pKernel, kernelSize, xAnchor, divisor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiAddWeighted_8s32f_C1IR( const Fw8s *pSrc,  int srcStep, Fw32f* pSrcDst, int srcDstStep, FwiSize roiSize, Fw32f alpha)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiAddWeighted_8s32f_C1IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize, alpha);
    case DT_SSE2:
        return _sse2_fwiAddWeighted_8s32f_C1IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize, alpha);
    case DT_REFR:
        return _refr_fwiAddWeighted_8s32f_C1IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize, alpha);
    default:
        assert(false);
        return _refr_fwiAddWeighted_8s32f_C1IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize, alpha);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiFilterColumn32f_16s_C3R( const Fw16s * pSrc, int srcStep,
                                 Fw16s * pDst, int dstStep, FwiSize dstRoiSize,
                                const Fw32f * pKernel, int kernelSize,
                                int yAnchor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilterColumn32f_16s_C3R(pSrc, srcStep, pDst, dstStep, dstRoiSize, pKernel, kernelSize, yAnchor);
    case DT_REFR:
        return _refr_fwiFilterColumn32f_16s_C3R(pSrc, srcStep, pDst, dstStep, dstRoiSize, pKernel, kernelSize, yAnchor);
    default:
        assert(false);
        return _refr_fwiFilterColumn32f_16s_C3R(pSrc, srcStep, pDst, dstStep, dstRoiSize, pKernel, kernelSize, yAnchor);
    }
}

OREFR OSSE2         FwStatus fwiYUV420ToRGB_8u_P3AC4R(const A8U* const pSrc[3], int srcStep[3], A8U* pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiYUV420ToRGB_8u_P3AC4R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiYUV420ToRGB_8u_P3AC4R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiYUV420ToRGB_8u_P3AC4R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiSqr_8u_C1IRSfs(       Fw8u  *pSrcDst, int srcDstStep, FwiSize roiSize, int scaleFactor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiSqr_8u_C1IRSfs(pSrcDst, srcDstStep, roiSize, scaleFactor);
    case DT_SSE2:
        return _sse2_fwiSqr_8u_C1IRSfs(pSrcDst, srcDstStep, roiSize, scaleFactor);
    case DT_REFR:
        return _refr_fwiSqr_8u_C1IRSfs(pSrcDst, srcDstStep, roiSize, scaleFactor);
    default:
        assert(false);
        return _refr_fwiSqr_8u_C1IRSfs(pSrcDst, srcDstStep, roiSize, scaleFactor);
    }
}

OREFR OSSE2 FwStatus STDCALL fwiWarpAffineBack_8u_P3R( const Fw8u* const pSrc[3], FwiSize srcSize, int srcStep,
								FwiRect srcRoi, Fw8u* const pDst[3], int dstStep, FwiRect dstRoi,
								const double coeffs[2][3], int interpolation )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiWarpAffineBack_8u_P3R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, coeffs, interpolation);
    case DT_REFR:
        return _refr_fwiWarpAffineBack_8u_P3R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, coeffs, interpolation);
    default:
        assert(false);
        return _refr_fwiWarpAffineBack_8u_P3R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, coeffs, interpolation);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiSet_16s_AC4R( const Fw16s  value[3], Fw16s  * pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiSet_16s_AC4R(value, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiSet_16s_AC4R(value, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiSet_16s_AC4R(value, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiSet_16s_AC4R(value, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiFilterBox_32f_C4R( const Fw32f * pSrc, int srcStep,
                               Fw32f * pDst, int dstStep, FwiSize dstRoiSize,
                               FwiSize maskSize, FwiPoint anchor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilterBox_32f_C4R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize, anchor);
    case DT_REFR:
        return _refr_fwiFilterBox_32f_C4R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize, anchor);
    default:
        assert(false);
        return _refr_fwiFilterBox_32f_C4R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize, anchor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiMulC_8u_C4IRSfs( const Fw8u value[4], Fw8u *pSrcDst, int srcDstStep, FwiSize roiSize, int scaleFactor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiMulC_8u_C4IRSfs(value, pSrcDst, srcDstStep, roiSize, scaleFactor);
    case DT_SSE2:
        return _sse2_fwiMulC_8u_C4IRSfs(value, pSrcDst, srcDstStep, roiSize, scaleFactor);
    case DT_REFR:
        return _refr_fwiMulC_8u_C4IRSfs(value, pSrcDst, srcDstStep, roiSize, scaleFactor);
    default:
        assert(false);
        return _refr_fwiMulC_8u_C4IRSfs(value, pSrcDst, srcDstStep, roiSize, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiAdd_16s_AC4IRSfs( const Fw16s  *pSrc,  int srcStep,        Fw16s  *pSrcDst, int srcDstStep, FwiSize roiSize, int scaleFactor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiAdd_16s_AC4IRSfs(pSrc, srcStep, pSrcDst, srcDstStep, roiSize, scaleFactor);
    case DT_SSE2:
        return _sse2_fwiAdd_16s_AC4IRSfs(pSrc, srcStep, pSrcDst, srcDstStep, roiSize, scaleFactor);
    case DT_REFR:
        return _refr_fwiAdd_16s_AC4IRSfs(pSrc, srcStep, pSrcDst, srcDstStep, roiSize, scaleFactor);
    default:
        assert(false);
        return _refr_fwiAdd_16s_AC4IRSfs(pSrc, srcStep, pSrcDst, srcDstStep, roiSize, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiSubC_16s_C3RSfs( const Fw16s *pSrc, int srcStep, const Fw16s value[3], Fw16s *pDst, int dstStep, FwiSize roiSize, int scaleFactor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiSubC_16s_C3RSfs(pSrc, srcStep, value, pDst, dstStep, roiSize, scaleFactor);
    case DT_SSE2:
        return _sse2_fwiSubC_16s_C3RSfs(pSrc, srcStep, value, pDst, dstStep, roiSize, scaleFactor);
    case DT_REFR:
        return _refr_fwiSubC_16s_C3RSfs(pSrc, srcStep, value, pDst, dstStep, roiSize, scaleFactor);
    default:
        assert(false);
        return _refr_fwiSubC_16s_C3RSfs(pSrc, srcStep, value, pDst, dstStep, roiSize, scaleFactor);
    }
}

OREFR             FwStatus STDCALL fwiCopy_32f_C4C1R( const Fw32f *pSrc, int srcStep, Fw32f *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiCopy_32f_C4C1R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiCopy_32f_C4C1R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiThreshold_LTVal_32f_AC4R( const Fw32f *pSrc, int srcStep, Fw32f *pDst, int dstStep, FwiSize roiSize, const Fw32f threshold[3], const Fw32f value[3])
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiThreshold_LTVal_32f_AC4R(pSrc, srcStep, pDst, dstStep, roiSize, threshold, value);
    case DT_SSE2:
        return _sse2_fwiThreshold_LTVal_32f_AC4R(pSrc, srcStep, pDst, dstStep, roiSize, threshold, value);
    case DT_REFR:
        return _refr_fwiThreshold_LTVal_32f_AC4R(pSrc, srcStep, pDst, dstStep, roiSize, threshold, value);
    default:
        assert(false);
        return _refr_fwiThreshold_LTVal_32f_AC4R(pSrc, srcStep, pDst, dstStep, roiSize, threshold, value);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiMulScale_8u_C3IR(  const Fw8u  *pSrc,  int srcStep,        Fw8u  *pSrcDst, int srcDstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiMulScale_8u_C3IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiMulScale_8u_C3IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    case DT_REFR:
        return _refr_fwiMulScale_8u_C3IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiMulScale_8u_C3IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiLn_32f_C1R( const Fw32f *pSrc, int srcStep, Fw32f *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiLn_32f_C1R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiLn_32f_C1R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiLn_32f_C1R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiLn_32f_C1R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiConvert_32f16u_AC4R( const Fw32f *pSrc, int srcStep, Fw16u *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiConvert_32f16u_AC4R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiConvert_32f16u_AC4R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiConvert_32f16u_AC4R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiConvert_32f16u_AC4R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 FwStatus STDCALL fwiWarpPerspective_32f_P4R( const Fw32f* const pSrc[4], FwiSize srcSize, int srcStep,
								FwiRect srcRoi, Fw32f* const pDst[4], int dstStep, FwiRect dstRoi,
								const double coeffs[3][3], int interpolation )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiWarpPerspective_32f_P4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, coeffs, interpolation);
    case DT_REFR:
        return _refr_fwiWarpPerspective_32f_P4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, coeffs, interpolation);
    default:
        assert(false);
        return _refr_fwiWarpPerspective_32f_P4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, coeffs, interpolation);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiCopy_32f_C1MR( const Fw32f *pSrc, int srcStep, Fw32f *pDst, int dstStep, FwiSize roiSize, const Fw8u *pMask, int maskStep )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiCopy_32f_C1MR(pSrc, srcStep, pDst, dstStep, roiSize, pMask, maskStep);
    case DT_SSE2:
        return _sse2_fwiCopy_32f_C1MR(pSrc, srcStep, pDst, dstStep, roiSize, pMask, maskStep);
    case DT_REFR:
        return _refr_fwiCopy_32f_C1MR(pSrc, srcStep, pDst, dstStep, roiSize, pMask, maskStep);
    default:
        assert(false);
        return _refr_fwiCopy_32f_C1MR(pSrc, srcStep, pDst, dstStep, roiSize, pMask, maskStep);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiDiv_16s_C1IRSfs( const Fw16s  *pSrc,  int srcStep,        Fw16s  *pSrcDst, int srcDstStep, FwiSize roiSize, int scaleFactor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiDiv_16s_C1IRSfs(pSrc, srcStep, pSrcDst, srcDstStep, roiSize, scaleFactor);
    case DT_SSE2:
        return _sse2_fwiDiv_16s_C1IRSfs(pSrc, srcStep, pSrcDst, srcDstStep, roiSize, scaleFactor);
    case DT_REFR:
        return _refr_fwiDiv_16s_C1IRSfs(pSrc, srcStep, pSrcDst, srcDstStep, roiSize, scaleFactor);
    default:
        assert(false);
        return _refr_fwiDiv_16s_C1IRSfs(pSrc, srcStep, pSrcDst, srcDstStep, roiSize, scaleFactor);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiSumWindowRow_16s32f_C4R( const Fw16s * pSrc, int srcStep,
                               Fw32f * pDst, int dstStep, FwiSize dstRoiSize,
                               int maskSize, int anchor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiSumWindowRow_16s32f_C4R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize, anchor);
    case DT_REFR:
        return _refr_fwiSumWindowRow_16s32f_C4R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize, anchor);
    default:
        assert(false);
        return _refr_fwiSumWindowRow_16s32f_C4R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize, anchor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiMulC_16sc_C3IRSfs( const Fw16sc value[3], Fw16sc *pSrcDst, int srcDstStep, FwiSize roiSize, int scaleFactor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiMulC_16sc_C3IRSfs(value, pSrcDst, srcDstStep, roiSize, scaleFactor);
    case DT_SSE2:
        return _sse2_fwiMulC_16sc_C3IRSfs(value, pSrcDst, srcDstStep, roiSize, scaleFactor);
    case DT_REFR:
        return _refr_fwiMulC_16sc_C3IRSfs(value, pSrcDst, srcDstStep, roiSize, scaleFactor);
    default:
        assert(false);
        return _refr_fwiMulC_16sc_C3IRSfs(value, pSrcDst, srcDstStep, roiSize, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiMul_32f_AC4R( const Fw32f  *pSrc1, int src1Step, const Fw32f  *pSrc2,   int src2Step, Fw32f  *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiMul_32f_AC4R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiMul_32f_AC4R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiMul_32f_AC4R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiMul_32f_AC4R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiFilterColumn32f_16s_AC4R( const Fw16s * pSrc, int srcStep,
                                 Fw16s * pDst, int dstStep, FwiSize dstRoiSize,
                                const Fw32f * pKernel, int kernelSize,
                                int yAnchor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilterColumn32f_16s_AC4R(pSrc, srcStep, pDst, dstStep, dstRoiSize, pKernel, kernelSize, yAnchor);
    case DT_REFR:
        return _refr_fwiFilterColumn32f_16s_AC4R(pSrc, srcStep, pDst, dstStep, dstRoiSize, pKernel, kernelSize, yAnchor);
    default:
        assert(false);
        return _refr_fwiFilterColumn32f_16s_AC4R(pSrc, srcStep, pDst, dstStep, dstRoiSize, pKernel, kernelSize, yAnchor);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiFilterGauss_8u_C3R( const Fw8u * pSrc, int srcStep, Fw8u * pDst, int dstStep, FwiSize dstRoiSize, FwiMaskSize maskSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilterGauss_8u_C3R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize);
    case DT_REFR:
        return _refr_fwiFilterGauss_8u_C3R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize);
    default:
        assert(false);
        return _refr_fwiFilterGauss_8u_C3R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiMulC_32f_C4R( const Fw32f *pSrc, int srcStep, const Fw32f value[4], Fw32f *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiMulC_32f_C4R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiMulC_32f_C4R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiMulC_32f_C4R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiMulC_32f_C4R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    }
}

OREFR               FwStatus fwiRGBToHLS_16u_AC4R( const Fw16u* pSrc, int srcStep, Fw16u* pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiRGBToHLS_16u_AC4R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiRGBToHLS_16u_AC4R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiFilter_8u_AC4R( const Fw8u * pSrc, int srcStep,
                             Fw8u * pDst, int dstStep, FwiSize dstRoiSize,
                             const Fw32s * pKernel, FwiSize kernelSize,
                             FwiPoint anchor, int divisor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilter_8u_AC4R(pSrc, srcStep, pDst, dstStep, dstRoiSize, pKernel, kernelSize, anchor, divisor);
    case DT_REFR:
        return _refr_fwiFilter_8u_AC4R(pSrc, srcStep, pDst, dstStep, dstRoiSize, pKernel, kernelSize, anchor, divisor);
    default:
        assert(false);
        return _refr_fwiFilter_8u_AC4R(pSrc, srcStep, pDst, dstStep, dstRoiSize, pKernel, kernelSize, anchor, divisor);
    }
}

OREFR OSSE2 FwStatus STDCALL fwiWarpAffineQuad_32f_C3R( const Fw32f* pSrc, FwiSize srcSize, int srcStep, FwiRect srcRoi,
							        const double srcQuad[4][2], Fw32f* pDst, int dstStep, FwiRect dstRoi,
									const double dstQuad[4][2], int interpolation )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiWarpAffineQuad_32f_C3R(pSrc, srcSize, srcStep, srcRoi, srcQuad, pDst, dstStep, dstRoi, dstQuad, interpolation);
    case DT_REFR:
        return _refr_fwiWarpAffineQuad_32f_C3R(pSrc, srcSize, srcStep, srcRoi, srcQuad, pDst, dstStep, dstRoi, dstQuad, interpolation);
    default:
        assert(false);
        return _refr_fwiWarpAffineQuad_32f_C3R(pSrc, srcSize, srcStep, srcRoi, srcQuad, pDst, dstStep, dstRoi, dstQuad, interpolation);
    }
}

OREFR               FwStatus fwiRGBToXYZ_16u_C3R( const Fw16u* pSrc, int srcStep, Fw16u* pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiRGBToXYZ_16u_C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiRGBToXYZ_16u_C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}


OREFR       FwStatus STDCALL fwiGetPerspectiveBound(FwiRect srcRoi, double bound[2][2], const double coeffs[3][3])
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiGetPerspectiveBound(srcRoi, bound, coeffs);
    default:
        assert(false);
        return _refr_fwiGetPerspectiveBound(srcRoi, bound, coeffs);
    }
}

OREFR       FwStatus STDCALL fwiResizeSqrPixel_16u_AC4R(const Fw16u* pSrc, FwiSize srcSize, int srcStep, FwiRect srcRoi,
			Fw16u* pDst, int dstStep, FwiRect dstRoi, double xFactor, double yFactor,
			double xShift, double yShift, int interpolation, Fw8u* pBuffer)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiResizeSqrPixel_16u_AC4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, xFactor, yFactor, xShift, yShift, interpolation, pBuffer);
    default:
        assert(false);
        return _refr_fwiResizeSqrPixel_16u_AC4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, xFactor, yFactor, xShift, yShift, interpolation, pBuffer);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiRotate_8u_C4R( const Fw8u* pSrc, FwiSize srcSize, int srcStep, FwiRect srcRoi, Fw8u* pDst, int dstStep, FwiRect dstRoi, double angle, double xShift, double yShift, int interpolation )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiRotate_8u_C4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, angle, xShift, yShift, interpolation);
    case DT_REFR:
        return _refr_fwiRotate_8u_C4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, angle, xShift, yShift, interpolation);
    default:
        assert(false);
        return _refr_fwiRotate_8u_C4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, angle, xShift, yShift, interpolation);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiAddC_32sc_C1IRSfs(       Fw32sc value,    Fw32sc *pSrcDst, int srcDstStep, FwiSize roiSize, int scaleFactor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiAddC_32sc_C1IRSfs(value, pSrcDst, srcDstStep, roiSize, scaleFactor);
    case DT_SSE2:
        return _sse2_fwiAddC_32sc_C1IRSfs(value, pSrcDst, srcDstStep, roiSize, scaleFactor);
    case DT_REFR:
        return _refr_fwiAddC_32sc_C1IRSfs(value, pSrcDst, srcDstStep, roiSize, scaleFactor);
    default:
        assert(false);
        return _refr_fwiAddC_32sc_C1IRSfs(value, pSrcDst, srcDstStep, roiSize, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiConvert_32f8s_AC4R( const Fw32f *pSrc, int srcStep, Fw8s *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiConvert_32f8s_AC4R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiConvert_32f8s_AC4R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiConvert_32f8s_AC4R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiConvert_32f8s_AC4R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiLn_16s_C1RSfs( const Fw16s *pSrc, int srcStep, Fw16s *pDst, int dstStep, FwiSize roiSize, int scaleFactor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiLn_16s_C1RSfs(pSrc, srcStep, pDst, dstStep, roiSize, scaleFactor);
    case DT_SSE2:
        return _sse2_fwiLn_16s_C1RSfs(pSrc, srcStep, pDst, dstStep, roiSize, scaleFactor);
    case DT_REFR:
        return _refr_fwiLn_16s_C1RSfs(pSrc, srcStep, pDst, dstStep, roiSize, scaleFactor);
    default:
        assert(false);
        return _refr_fwiLn_16s_C1RSfs(pSrc, srcStep, pDst, dstStep, roiSize, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiXor_8u_C3R( const Fw8u *pSrc1, int src1Step, const Fw8u *pSrc2,   int src2Step, Fw8u *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiXor_8u_C3R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiXor_8u_C3R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiXor_8u_C3R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiXor_8u_C3R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiMul_8u_C4IRSfs( const Fw8u   *pSrc,  int srcStep,        Fw8u   *pSrcDst, int srcDstStep, FwiSize roiSize, int scaleFactor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiMul_8u_C4IRSfs(pSrc, srcStep, pSrcDst, srcDstStep, roiSize, scaleFactor);
    case DT_SSE2:
        return _sse2_fwiMul_8u_C4IRSfs(pSrc, srcStep, pSrcDst, srcDstStep, roiSize, scaleFactor);
    case DT_REFR:
        return _refr_fwiMul_8u_C4IRSfs(pSrc, srcStep, pSrcDst, srcDstStep, roiSize, scaleFactor);
    default:
        assert(false);
        return _refr_fwiMul_8u_C4IRSfs(pSrc, srcStep, pSrcDst, srcDstStep, roiSize, scaleFactor);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiFilter32f_16s_AC4R( const Fw16s * pSrc, int srcStep,
                                 Fw16s * pDst, int dstStep, FwiSize dstRoiSize,
                                 const Fw32f * pKernel, FwiSize kernelSize,
                                 FwiPoint anchor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilter32f_16s_AC4R(pSrc, srcStep, pDst, dstStep, dstRoiSize, pKernel, kernelSize, anchor);
    case DT_REFR:
        return _refr_fwiFilter32f_16s_AC4R(pSrc, srcStep, pDst, dstStep, dstRoiSize, pKernel, kernelSize, anchor);
    default:
        assert(false);
        return _refr_fwiFilter32f_16s_AC4R(pSrc, srcStep, pDst, dstStep, dstRoiSize, pKernel, kernelSize, anchor);
    }
}


OREFR               FwStatus fwiRGBToYCC_8u_C3R( const Fw8u *pSrc, int srcStep, Fw8u *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiRGBToYCC_8u_C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiRGBToYCC_8u_C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiSub_32fc_C3IR( const Fw32fc *pSrc,  int srcStep,        Fw32fc *pSrcDst, int srcDstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiSub_32fc_C3IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiSub_32fc_C3IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    case DT_REFR:
        return _refr_fwiSub_32fc_C3IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiSub_32fc_C3IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiSub_32f_C4R( const Fw32f  *pSrc1, int src1Step, const Fw32f  *pSrc2,   int src2Step, Fw32f  *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiSub_32f_C4R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiSub_32f_C4R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiSub_32f_C4R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiSub_32f_C4R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2         FwStatus fwiMinMax_32f_C4R(const Fw32f* pSrc, int srcStep,FwiSize roiSize,Fw32f min[4],Fw32f max[4])
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiMinMax_32f_C4R(pSrc, srcStep, roiSize, min, max);
    case DT_REFR:
        return _refr_fwiMinMax_32f_C4R(pSrc, srcStep, roiSize, min, max);
    default:
        assert(false);
        return _refr_fwiMinMax_32f_C4R(pSrc, srcStep, roiSize, min, max);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiFilterRobertsUp_32f_AC4R( const Fw32f * pSrc, int srcStep, Fw32f * pDst, int dstStep, FwiSize dstRoiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilterRobertsUp_32f_AC4R(pSrc, srcStep, pDst, dstStep, dstRoiSize);
    case DT_REFR:
        return _refr_fwiFilterRobertsUp_32f_AC4R(pSrc, srcStep, pDst, dstStep, dstRoiSize);
    default:
        assert(false);
        return _refr_fwiFilterRobertsUp_32f_AC4R(pSrc, srcStep, pDst, dstStep, dstRoiSize);
    }
}

OREFR OSSE2 FwStatus STDCALL fwiWarpAffineBack_32f_C1R( const Fw32f* pSrc, FwiSize srcSize, int srcStep,
								FwiRect srcRoi, Fw32f* pDst, int dstStep, FwiRect dstRoi,
								const double coeffs[2][3], int interpolation )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiWarpAffineBack_32f_C1R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, coeffs, interpolation);
    case DT_REFR:
        return _refr_fwiWarpAffineBack_32f_C1R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, coeffs, interpolation);
    default:
        assert(false);
        return _refr_fwiWarpAffineBack_32f_C1R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, coeffs, interpolation);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiAndC_8u_C4R( const Fw8u   *pSrc, int srcStep, const Fw8u value[4], Fw8u *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiAndC_8u_C4R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiAndC_8u_C4R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiAndC_8u_C4R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiAndC_8u_C4R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    }
}

OREFR             FwStatus STDCALL fwiCopy_32s_C4C1R( const Fw32s *pSrc, int srcStep, Fw32s *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiCopy_32s_C4C1R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiCopy_32s_C4C1R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2         FwStatus fwiMax_32f_C1R(const Fw32f* pSrc, int srcStep,FwiSize roiSize, Fw32f* pMax)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiMax_32f_C1R(pSrc, srcStep, roiSize, pMax);
    case DT_REFR:
        return _refr_fwiMax_32f_C1R(pSrc, srcStep, roiSize, pMax);
    default:
        assert(false);
        return _refr_fwiMax_32f_C1R(pSrc, srcStep, roiSize, pMax);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiAnd_8u_AC4R( const Fw8u *pSrc1, int src1Step, const Fw8u *pSrc2,   int src2Step, Fw8u *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiAnd_8u_AC4R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiAnd_8u_AC4R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiAnd_8u_AC4R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiAnd_8u_AC4R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiMulC_32fc_AC4R( const Fw32fc *pSrc, int srcStep, const Fw32fc value[3], Fw32fc *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiMulC_32fc_AC4R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiMulC_32fc_AC4R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiMulC_32fc_AC4R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiMulC_32fc_AC4R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiConvert_16u8u_C1R( const Fw16u *pSrc, int srcStep, Fw8u *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiConvert_16u8u_C1R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiConvert_16u8u_C1R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiConvert_16u8u_C1R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiConvert_16u8u_C1R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiFilter_16s_C3R( const Fw16s * pSrc, int srcStep,
                              Fw16s * pDst, int dstStep, FwiSize dstRoiSize,
                              const Fw32s * pKernel, FwiSize kernelSize,
                              FwiPoint anchor, int divisor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilter_16s_C3R(pSrc, srcStep, pDst, dstStep, dstRoiSize, pKernel, kernelSize, anchor, divisor);
    case DT_REFR:
        return _refr_fwiFilter_16s_C3R(pSrc, srcStep, pDst, dstStep, dstRoiSize, pKernel, kernelSize, anchor, divisor);
    default:
        assert(false);
        return _refr_fwiFilter_16s_C3R(pSrc, srcStep, pDst, dstStep, dstRoiSize, pKernel, kernelSize, anchor, divisor);
    }
}

OREFR OSSE2 FwStatus STDCALL fwiWarpAffine_16u_P3R( const Fw16u* const pSrc[3], FwiSize srcSize, int srcStep,
								FwiRect srcRoi, Fw16u* const pDst[3], int dstStep, FwiRect dstRoi,
								const double coeffs[2][3], int interpolation )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiWarpAffine_16u_P3R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, coeffs, interpolation);
    case DT_REFR:
        return _refr_fwiWarpAffine_16u_P3R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, coeffs, interpolation);
    default:
        assert(false);
        return _refr_fwiWarpAffine_16u_P3R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, coeffs, interpolation);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiDiv_16s_C3RSfs( const Fw16s  *pSrc1, int src1Step, const Fw16s  *pSrc2,   int src2Step, Fw16s  *pDst, int dstStep, FwiSize roiSize, int scaleFactor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiDiv_16s_C3RSfs(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, scaleFactor);
    case DT_SSE2:
        return _sse2_fwiDiv_16s_C3RSfs(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, scaleFactor);
    case DT_REFR:
        return _refr_fwiDiv_16s_C3RSfs(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, scaleFactor);
    default:
        assert(false);
        return _refr_fwiDiv_16s_C3RSfs(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiOrC_16u_AC4IR( const Fw16u value[3], Fw16u *pSrcDst, int srcDstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiOrC_16u_AC4IR(value, pSrcDst, srcDstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiOrC_16u_AC4IR(value, pSrcDst, srcDstStep, roiSize);
    case DT_REFR:
        return _refr_fwiOrC_16u_AC4IR(value, pSrcDst, srcDstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiOrC_16u_AC4IR(value, pSrcDst, srcDstStep, roiSize);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiMirror_16u_C3IR(Fw16u *pSrcDst, int srcDstStep, FwiSize roiSize, FwiAxis flip)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiMirror_16u_C3IR(pSrcDst, srcDstStep, roiSize, flip);
    case DT_REFR:
        return _refr_fwiMirror_16u_C3IR(pSrcDst, srcDstStep, roiSize, flip);
    default:
        assert(false);
        return _refr_fwiMirror_16u_C3IR(pSrcDst, srcDstStep, roiSize, flip);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiConvert_16s32f_C1R( const Fw16s *pSrc, int srcStep, Fw32f *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiConvert_16s32f_C1R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiConvert_16s32f_C1R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiConvert_16s32f_C1R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiConvert_16s32f_C1R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiThreshold_GT_32f_AC4R( const Fw32f *pSrc, int srcStep, Fw32f *pDst, int dstStep, FwiSize roiSize, const Fw32f threshold[3])
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiThreshold_GT_32f_AC4R(pSrc, srcStep, pDst, dstStep, roiSize, threshold);
    case DT_SSE2:
        return _sse2_fwiThreshold_GT_32f_AC4R(pSrc, srcStep, pDst, dstStep, roiSize, threshold);
    case DT_REFR:
        return _refr_fwiThreshold_GT_32f_AC4R(pSrc, srcStep, pDst, dstStep, roiSize, threshold);
    default:
        assert(false);
        return _refr_fwiThreshold_GT_32f_AC4R(pSrc, srcStep, pDst, dstStep, roiSize, threshold);
    }
}

OREFR OSSE2 FwStatus STDCALL fwiResize_16u_C3R( const Fw16u* pSrc, FwiSize srcSize, int srcStep, FwiRect srcRoi,
							 Fw16u* pDst, int dstStep, FwiSize dstRoiSize,
							 double xFactor, double yFactor, int interpolation )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiResize_16u_C3R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoiSize, xFactor, yFactor, interpolation);
    case DT_REFR:
        return _refr_fwiResize_16u_C3R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoiSize, xFactor, yFactor, interpolation);
    default:
        assert(false);
        return _refr_fwiResize_16u_C3R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoiSize, xFactor, yFactor, interpolation);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiThreshold_LTValGTVal_8u_C3IR( Fw8u *pSrcDst, int srcDstStep, FwiSize roiSize, const Fw8u thresholdLT[3], const Fw8u valueLT[3], const Fw8u thresholdGT[3], const Fw8u valueGT[3])
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiThreshold_LTValGTVal_8u_C3IR(pSrcDst, srcDstStep, roiSize, thresholdLT, valueLT, thresholdGT, valueGT);
    case DT_SSE2:
        return _sse2_fwiThreshold_LTValGTVal_8u_C3IR(pSrcDst, srcDstStep, roiSize, thresholdLT, valueLT, thresholdGT, valueGT);
    case DT_REFR:
        return _refr_fwiThreshold_LTValGTVal_8u_C3IR(pSrcDst, srcDstStep, roiSize, thresholdLT, valueLT, thresholdGT, valueGT);
    default:
        assert(false);
        return _refr_fwiThreshold_LTValGTVal_8u_C3IR(pSrcDst, srcDstStep, roiSize, thresholdLT, valueLT, thresholdGT, valueGT);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiSub_16s_C3IRSfs( const Fw16s  *pSrc,  int srcStep,        Fw16s  *pSrcDst, int srcDstStep, FwiSize roiSize, int scaleFactor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiSub_16s_C3IRSfs(pSrc, srcStep, pSrcDst, srcDstStep, roiSize, scaleFactor);
    case DT_SSE2:
        return _sse2_fwiSub_16s_C3IRSfs(pSrc, srcStep, pSrcDst, srcDstStep, roiSize, scaleFactor);
    case DT_REFR:
        return _refr_fwiSub_16s_C3IRSfs(pSrc, srcStep, pSrcDst, srcDstStep, roiSize, scaleFactor);
    default:
        assert(false);
        return _refr_fwiSub_16s_C3IRSfs(pSrc, srcStep, pSrcDst, srcDstStep, roiSize, scaleFactor);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiRotateCenter_8u_C3R( const Fw8u* pSrc,FwiSize srcSize, int srcStep, FwiRect srcRoi, Fw8u* pDst, int dstStep, FwiRect dstRoi, double angle, double xCenter, double yCenter, int interpolation )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiRotateCenter_8u_C3R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, angle, xCenter, yCenter, interpolation);
    case DT_REFR:
        return _refr_fwiRotateCenter_8u_C3R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, angle, xCenter, yCenter, interpolation);
    default:
        assert(false);
        return _refr_fwiRotateCenter_8u_C3R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, angle, xCenter, yCenter, interpolation);
    }
}



OREFR OSSE2         FwStatus fwiMax_8u_C1R(const Fw8u* pSrc, int srcStep,FwiSize roiSize, Fw8u* pMax)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiMax_8u_C1R(pSrc, srcStep, roiSize, pMax);
    case DT_REFR:
        return _refr_fwiMax_8u_C1R(pSrc, srcStep, roiSize, pMax);
    default:
        assert(false);
        return _refr_fwiMax_8u_C1R(pSrc, srcStep, roiSize, pMax);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiAnd_32s_AC4R( const Fw32s *pSrc1, int src1Step, const Fw32s *pSrc2,   int src2Step, Fw32s *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiAnd_32s_AC4R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiAnd_32s_AC4R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiAnd_32s_AC4R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiAnd_32s_AC4R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiDivC_32f_C3R( const Fw32f *pSrc, int srcStep, const Fw32f value[3], Fw32f *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiDivC_32f_C3R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiDivC_32f_C3R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiDivC_32f_C3R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiDivC_32f_C3R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiMul_8u_AC4RSfs( const Fw8u   *pSrc1, int src1Step, const Fw8u   *pSrc2,   int src2Step, Fw8u *pDst, int dstStep, FwiSize roiSize, int scaleFactor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiMul_8u_AC4RSfs(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, scaleFactor);
    case DT_SSE2:
        return _sse2_fwiMul_8u_AC4RSfs(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, scaleFactor);
    case DT_REFR:
        return _refr_fwiMul_8u_AC4RSfs(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, scaleFactor);
    default:
        assert(false);
        return _refr_fwiMul_8u_AC4RSfs(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiOr_32s_AC4R( const Fw32s *pSrc1, int src1Step, const Fw32s *pSrc2,   int src2Step, Fw32s *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiOr_32s_AC4R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiOr_32s_AC4R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiOr_32s_AC4R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiOr_32s_AC4R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    }
}

OREFR               FwStatus fwiYCbCr422ToRGB_8u_C2C3R(const A8U* pSrc, int srcStep, A8U* pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiYCbCr422ToRGB_8u_C2C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiYCbCr422ToRGB_8u_C2C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}


OREFR       FwStatus STDCALL fwiResizeSqrPixelGetBufSize(FwiSize dstSize, int nChannel,int interpolation, int* pBufferSize)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiResizeSqrPixelGetBufSize(dstSize, nChannel, interpolation, pBufferSize);
    default:
        assert(false);
        return _refr_fwiResizeSqrPixelGetBufSize(dstSize, nChannel, interpolation, pBufferSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiXor_16u_AC4R( const Fw16u *pSrc1, int src1Step, const Fw16u *pSrc2,   int src2Step, Fw16u *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiXor_16u_AC4R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiXor_16u_AC4R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiXor_16u_AC4R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiXor_16u_AC4R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiAddWeighted_16u32f_C1IR( const Fw16u *pSrc, int srcStep, Fw32f* pSrcDst, int srcDstStep, FwiSize roiSize, Fw32f alpha)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiAddWeighted_16u32f_C1IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize, alpha);
    case DT_SSE2:
        return _sse2_fwiAddWeighted_16u32f_C1IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize, alpha);
    case DT_REFR:
        return _refr_fwiAddWeighted_16u32f_C1IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize, alpha);
    default:
        assert(false);
        return _refr_fwiAddWeighted_16u32f_C1IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize, alpha);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiExp_16s_C1RSfs( const Fw16s *pSrc, int srcStep, Fw16s *pDst, int dstStep, FwiSize roiSize, int scaleFactor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiExp_16s_C1RSfs(pSrc, srcStep, pDst, dstStep, roiSize, scaleFactor);
    case DT_SSE2:
        return _sse2_fwiExp_16s_C1RSfs(pSrc, srcStep, pDst, dstStep, roiSize, scaleFactor);
    case DT_REFR:
        return _refr_fwiExp_16s_C1RSfs(pSrc, srcStep, pDst, dstStep, roiSize, scaleFactor);
    default:
        assert(false);
        return _refr_fwiExp_16s_C1RSfs(pSrc, srcStep, pDst, dstStep, roiSize, scaleFactor);
    }
}

OREFR               FwStatus fwiBGRToLab_8u16u_C3R( const Fw8u* pSrc, int srcStep, Fw16u* pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiBGRToLab_8u16u_C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiBGRToLab_8u16u_C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiFilterColumn_32f_C4R( const Fw32f * pSrc, int srcStep,
                              Fw32f * pDst, int dstStep, FwiSize dstRoiSize,
                              const Fw32f * pKernel, int kernelSize,
                              int yAnchor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilterColumn_32f_C4R(pSrc, srcStep, pDst, dstStep, dstRoiSize, pKernel, kernelSize, yAnchor);
    case DT_REFR:
        return _refr_fwiFilterColumn_32f_C4R(pSrc, srcStep, pDst, dstStep, dstRoiSize, pKernel, kernelSize, yAnchor);
    default:
        assert(false);
        return _refr_fwiFilterColumn_32f_C4R(pSrc, srcStep, pDst, dstStep, dstRoiSize, pKernel, kernelSize, yAnchor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiSub_32fc_AC4IR( const Fw32fc *pSrc,  int srcStep,        Fw32fc *pSrcDst, int srcDstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiSub_32fc_AC4IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiSub_32fc_AC4IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    case DT_REFR:
        return _refr_fwiSub_32fc_AC4IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiSub_32fc_AC4IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiCopy_8u_P4C4R( const Fw8u * const pSrc[4], int srcStep, Fw8u *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiCopy_8u_P4C4R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiCopy_8u_P4C4R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiCopy_8u_P4C4R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiCopy_8u_P4C4R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiMulScale_16u_AC4R(  const Fw16u *pSrc1, int src1Step, const Fw16u *pSrc2,   int src2Step, Fw16u *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiMulScale_16u_AC4R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiMulScale_16u_AC4R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiMulScale_16u_AC4R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiMulScale_16u_AC4R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    }
}

OREFR       FwStatus STDCALL fwiWarpBilinear_8u_AC4R(const Fw8u* pSrc, FwiSize srcSize, int srcStep,
								FwiRect srcRoi, Fw8u* pDst, int dstStep, FwiRect dstRoi,
								const double coeffs[2][4], int interpolation)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiWarpBilinear_8u_AC4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, coeffs, interpolation);
    default:
        assert(false);
        return _refr_fwiWarpBilinear_8u_AC4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, coeffs, interpolation);
    }
}

OREFR OSSE2 FwStatus STDCALL fwiWarpAffineQuad_8u_C4R( const Fw8u* pSrc, FwiSize srcSize, int srcStep, FwiRect srcRoi,
							        const double srcQuad[4][2], Fw8u* pDst, int dstStep, FwiRect dstRoi,
									const double dstQuad[4][2], int interpolation )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiWarpAffineQuad_8u_C4R(pSrc, srcSize, srcStep, srcRoi, srcQuad, pDst, dstStep, dstRoi, dstQuad, interpolation);
    case DT_REFR:
        return _refr_fwiWarpAffineQuad_8u_C4R(pSrc, srcSize, srcStep, srcRoi, srcQuad, pDst, dstStep, dstRoi, dstQuad, interpolation);
    default:
        assert(false);
        return _refr_fwiWarpAffineQuad_8u_C4R(pSrc, srcSize, srcStep, srcRoi, srcQuad, pDst, dstStep, dstRoi, dstQuad, interpolation);
    }
}

OREFR               FwStatus fwiYCbCrToBGR555_8u16u_C3R(const A8U* pSrc, int srcStep, A16U* pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiYCbCrToBGR555_8u16u_C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiYCbCrToBGR555_8u16u_C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiMirror_8u_C3R( const Fw8u  *pSrc, int srcStep, Fw8u  *pDst, int dstStep, FwiSize roiSize, FwiAxis flip)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiMirror_8u_C3R(pSrc, srcStep, pDst, dstStep, roiSize, flip);
    case DT_REFR:
        return _refr_fwiMirror_8u_C3R(pSrc, srcStep, pDst, dstStep, roiSize, flip);
    default:
        assert(false);
        return _refr_fwiMirror_8u_C3R(pSrc, srcStep, pDst, dstStep, roiSize, flip);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiThreshold_LTValGTVal_32f_C3R( const Fw32f *pSrc, int srcStep, Fw32f *pDst, int dstStep, FwiSize roiSize, const Fw32f thresholdLT[3], const Fw32f valueLT[3], const Fw32f thresholdGT[3], const Fw32f valueGT[3])
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiThreshold_LTValGTVal_32f_C3R(pSrc, srcStep, pDst, dstStep, roiSize, thresholdLT, valueLT, thresholdGT, valueGT);
    case DT_SSE2:
        return _sse2_fwiThreshold_LTValGTVal_32f_C3R(pSrc, srcStep, pDst, dstStep, roiSize, thresholdLT, valueLT, thresholdGT, valueGT);
    case DT_REFR:
        return _refr_fwiThreshold_LTValGTVal_32f_C3R(pSrc, srcStep, pDst, dstStep, roiSize, thresholdLT, valueLT, thresholdGT, valueGT);
    default:
        assert(false);
        return _refr_fwiThreshold_LTValGTVal_32f_C3R(pSrc, srcStep, pDst, dstStep, roiSize, thresholdLT, valueLT, thresholdGT, valueGT);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiRShiftC_8u_C1IR(       Fw32u value,    Fw8u *pSrcDst, int srcDstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiRShiftC_8u_C1IR(value, pSrcDst, srcDstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiRShiftC_8u_C1IR(value, pSrcDst, srcDstStep, roiSize);
    case DT_REFR:
        return _refr_fwiRShiftC_8u_C1IR(value, pSrcDst, srcDstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiRShiftC_8u_C1IR(value, pSrcDst, srcDstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiCopy_16s_C4MR( const Fw16s *pSrc, int srcStep, Fw16s *pDst, int dstStep, FwiSize roiSize, const Fw8u *pMask, int maskStep )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiCopy_16s_C4MR(pSrc, srcStep, pDst, dstStep, roiSize, pMask, maskStep);
    case DT_SSE2:
        return _sse2_fwiCopy_16s_C4MR(pSrc, srcStep, pDst, dstStep, roiSize, pMask, maskStep);
    case DT_REFR:
        return _refr_fwiCopy_16s_C4MR(pSrc, srcStep, pDst, dstStep, roiSize, pMask, maskStep);
    default:
        assert(false);
        return _refr_fwiCopy_16s_C4MR(pSrc, srcStep, pDst, dstStep, roiSize, pMask, maskStep);
    }
}

OREFR             FwStatus STDCALL fwiScale_8u32f_C4R( const Fw8u * pSrc, int srcStep, Fw32f * pDst, int dstStep, FwiSize roiSize, Fw32f vMin, Fw32f vMax )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiScale_8u32f_C4R(pSrc, srcStep, pDst, dstStep, roiSize, vMin, vMax);
    default:
        assert(false);
        return _refr_fwiScale_8u32f_C4R(pSrc, srcStep, pDst, dstStep, roiSize, vMin, vMax);
    }
}

OREFR               FwStatus fwiYCbCr422_8u_P3C2R(const Fw8u* const pSrc[3], int srcStep[3], Fw8u* pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiYCbCr422_8u_P3C2R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiYCbCr422_8u_P3C2R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiNot_8u_C1IR( Fw8u *pSrcDst, int srcDstStep, FwiSize roiSize)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiNot_8u_C1IR(pSrcDst, srcDstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiNot_8u_C1IR(pSrcDst, srcDstStep, roiSize);
    case DT_REFR:
        return _refr_fwiNot_8u_C1IR(pSrcDst, srcDstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiNot_8u_C1IR(pSrcDst, srcDstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiXor_16u_C4R( const Fw16u *pSrc1, int src1Step, const Fw16u *pSrc2,   int src2Step, Fw16u *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiXor_16u_C4R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiXor_16u_C4R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiXor_16u_C4R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiXor_16u_C4R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    }
}

OREFR             FwStatus STDCALL fwiScale_8u16s_C1R( const Fw8u * pSrc, int srcStep, Fw16s * pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiScale_8u16s_C1R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiScale_8u16s_C1R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR       FwStatus STDCALL fwiMirror_32f_AC4R( const Fw32f *pSrc, int srcStep, Fw32f *pDst, int dstStep, FwiSize roiSize, FwiAxis flip)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiMirror_32f_AC4R(pSrc, srcStep, pDst, dstStep, roiSize, flip);
    default:
        assert(false);
        return _refr_fwiMirror_32f_AC4R(pSrc, srcStep, pDst, dstStep, roiSize, flip);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiSqr_16s_C1RSfs( const Fw16s *pSrc,    int srcStep, Fw16s *pDst, int dstStep, FwiSize roiSize, int scaleFactor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiSqr_16s_C1RSfs(pSrc, srcStep, pDst, dstStep, roiSize, scaleFactor);
    case DT_SSE2:
        return _sse2_fwiSqr_16s_C1RSfs(pSrc, srcStep, pDst, dstStep, roiSize, scaleFactor);
    case DT_REFR:
        return _refr_fwiSqr_16s_C1RSfs(pSrc, srcStep, pDst, dstStep, roiSize, scaleFactor);
    default:
        assert(false);
        return _refr_fwiSqr_16s_C1RSfs(pSrc, srcStep, pDst, dstStep, roiSize, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiDivC_16sc_C1RSfs( const Fw16sc *pSrc, int srcStep,       Fw16sc value,    Fw16sc *pDst, int dstStep, FwiSize roiSize, int scaleFactor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiDivC_16sc_C1RSfs(pSrc, srcStep, value, pDst, dstStep, roiSize, scaleFactor);
    case DT_SSE2:
        return _sse2_fwiDivC_16sc_C1RSfs(pSrc, srcStep, value, pDst, dstStep, roiSize, scaleFactor);
    case DT_REFR:
        return _refr_fwiDivC_16sc_C1RSfs(pSrc, srcStep, value, pDst, dstStep, roiSize, scaleFactor);
    default:
        assert(false);
        return _refr_fwiDivC_16sc_C1RSfs(pSrc, srcStep, value, pDst, dstStep, roiSize, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiThreshold_GTVal_16s_C3IR( Fw16s *pSrcDst, int srcDstStep, FwiSize roiSize, const Fw16s threshold[3], const Fw16s value[3])
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiThreshold_GTVal_16s_C3IR(pSrcDst, srcDstStep, roiSize, threshold, value);
    case DT_SSE2:
        return _sse2_fwiThreshold_GTVal_16s_C3IR(pSrcDst, srcDstStep, roiSize, threshold, value);
    case DT_REFR:
        return _refr_fwiThreshold_GTVal_16s_C3IR(pSrcDst, srcDstStep, roiSize, threshold, value);
    default:
        assert(false);
        return _refr_fwiThreshold_GTVal_16s_C3IR(pSrcDst, srcDstStep, roiSize, threshold, value);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiOrC_8u_AC4IR( const Fw8u value[3], Fw8u *pSrcDst, int srcDstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiOrC_8u_AC4IR(value, pSrcDst, srcDstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiOrC_8u_AC4IR(value, pSrcDst, srcDstStep, roiSize);
    case DT_REFR:
        return _refr_fwiOrC_8u_AC4IR(value, pSrcDst, srcDstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiOrC_8u_AC4IR(value, pSrcDst, srcDstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiThreshold_8u_C3R( const Fw8u *pSrc, int srcStep, Fw8u *pDst, int dstStep, FwiSize roiSize, const Fw8u threshold[3], FwCmpOp fwCmpOp)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiThreshold_8u_C3R(pSrc, srcStep, pDst, dstStep, roiSize, threshold, fwCmpOp);
    case DT_SSE2:
        return _sse2_fwiThreshold_8u_C3R(pSrc, srcStep, pDst, dstStep, roiSize, threshold, fwCmpOp);
    case DT_REFR:
        return _refr_fwiThreshold_8u_C3R(pSrc, srcStep, pDst, dstStep, roiSize, threshold, fwCmpOp);
    default:
        assert(false);
        return _refr_fwiThreshold_8u_C3R(pSrc, srcStep, pDst, dstStep, roiSize, threshold, fwCmpOp);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiAdd_32sc_C3IRSfs( const Fw32sc *pSrc,  int srcStep,        Fw32sc *pSrcDst, int srcDstStep, FwiSize roiSize, int scaleFactor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiAdd_32sc_C3IRSfs(pSrc, srcStep, pSrcDst, srcDstStep, roiSize, scaleFactor);
    case DT_SSE2:
        return _sse2_fwiAdd_32sc_C3IRSfs(pSrc, srcStep, pSrcDst, srcDstStep, roiSize, scaleFactor);
    case DT_REFR:
        return _refr_fwiAdd_32sc_C3IRSfs(pSrc, srcStep, pSrcDst, srcDstStep, roiSize, scaleFactor);
    default:
        assert(false);
        return _refr_fwiAdd_32sc_C3IRSfs(pSrc, srcStep, pSrcDst, srcDstStep, roiSize, scaleFactor);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiFilterGauss_16s_AC4R( const Fw16s * pSrc, int srcStep, Fw16s * pDst, int dstStep, FwiSize dstRoiSize, FwiMaskSize maskSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilterGauss_16s_AC4R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize);
    case DT_REFR:
        return _refr_fwiFilterGauss_16s_AC4R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize);
    default:
        assert(false);
        return _refr_fwiFilterGauss_16s_AC4R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiDiv_16s_C3IRSfs( const Fw16s  *pSrc,  int srcStep,        Fw16s  *pSrcDst, int srcDstStep, FwiSize roiSize, int scaleFactor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiDiv_16s_C3IRSfs(pSrc, srcStep, pSrcDst, srcDstStep, roiSize, scaleFactor);
    case DT_SSE2:
        return _sse2_fwiDiv_16s_C3IRSfs(pSrc, srcStep, pSrcDst, srcDstStep, roiSize, scaleFactor);
    case DT_REFR:
        return _refr_fwiDiv_16s_C3IRSfs(pSrc, srcStep, pSrcDst, srcDstStep, roiSize, scaleFactor);
    default:
        assert(false);
        return _refr_fwiDiv_16s_C3IRSfs(pSrc, srcStep, pSrcDst, srcDstStep, roiSize, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiRShiftC_8u_C3IR( const Fw32u value[3], Fw8u *pSrcDst, int srcDstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiRShiftC_8u_C3IR(value, pSrcDst, srcDstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiRShiftC_8u_C3IR(value, pSrcDst, srcDstStep, roiSize);
    case DT_REFR:
        return _refr_fwiRShiftC_8u_C3IR(value, pSrcDst, srcDstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiRShiftC_8u_C3IR(value, pSrcDst, srcDstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiConvert_8u32s_C3R( const Fw8u *pSrc, int srcStep, Fw32s *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiConvert_8u32s_C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiConvert_8u32s_C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiConvert_8u32s_C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiConvert_8u32s_C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiComplement_32s_C1IR(Fw32s* pSrcDst, int srcDstStep,FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiComplement_32s_C1IR(pSrcDst, srcDstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiComplement_32s_C1IR(pSrcDst, srcDstStep, roiSize);
    case DT_REFR:
        return _refr_fwiComplement_32s_C1IR(pSrcDst, srcDstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiComplement_32s_C1IR(pSrcDst, srcDstStep, roiSize);
    }
}

OREFR OSSE2         FwStatus fwiRGBToGray_16u_AC4C1R(const Fw16u* pSrc, int srcStep,Fw16u* pDst, int dstStep, FwiSize roiSize)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiRGBToGray_16u_AC4C1R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiRGBToGray_16u_AC4C1R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiRGBToGray_16u_AC4C1R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiMulCScale_8u_C1R( const Fw8u *pSrc, int srcStep,       Fw8u value,    Fw8u *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiMulCScale_8u_C1R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiMulCScale_8u_C1R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiMulCScale_8u_C1R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiMulCScale_8u_C1R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiThreshold_GT_16s_C3IR( Fw16s *pSrcDst, int srcDstStep, FwiSize roiSize, const Fw16s threshold[3])
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiThreshold_GT_16s_C3IR(pSrcDst, srcDstStep, roiSize, threshold);
    case DT_SSE2:
        return _sse2_fwiThreshold_GT_16s_C3IR(pSrcDst, srcDstStep, roiSize, threshold);
    case DT_REFR:
        return _refr_fwiThreshold_GT_16s_C3IR(pSrcDst, srcDstStep, roiSize, threshold);
    default:
        assert(false);
        return _refr_fwiThreshold_GT_16s_C3IR(pSrcDst, srcDstStep, roiSize, threshold);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiConvert_32f16u_C1R( const Fw32f *pSrc, int srcStep, Fw16u *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiConvert_32f16u_C1R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiConvert_32f16u_C1R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiConvert_32f16u_C1R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiConvert_32f16u_C1R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiAbsDiffC_32f_C1R( const Fw32f *pSrc, int srcStep,  Fw32f *pDst, int dstStep, FwiSize roiSize, Fw32f value )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiAbsDiffC_32f_C1R(pSrc, srcStep, pDst, dstStep, roiSize, value);
    case DT_SSE2:
        return _sse2_fwiAbsDiffC_32f_C1R(pSrc, srcStep, pDst, dstStep, roiSize, value);
    case DT_REFR:
        return _refr_fwiAbsDiffC_32f_C1R(pSrc, srcStep, pDst, dstStep, roiSize, value);
    default:
        assert(false);
        return _refr_fwiAbsDiffC_32f_C1R(pSrc, srcStep, pDst, dstStep, roiSize, value);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiAndC_16u_AC4IR( const Fw16u value[3], Fw16u *pSrcDst, int srcDstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiAndC_16u_AC4IR(value, pSrcDst, srcDstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiAndC_16u_AC4IR(value, pSrcDst, srcDstStep, roiSize);
    case DT_REFR:
        return _refr_fwiAndC_16u_AC4IR(value, pSrcDst, srcDstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiAndC_16u_AC4IR(value, pSrcDst, srcDstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiSqrt_32f_AC4R( const Fw32f *pSrc, int srcStep, Fw32f *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiSqrt_32f_AC4R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiSqrt_32f_AC4R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiSqrt_32f_AC4R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiSqrt_32f_AC4R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiThreshold_LTVal_32f_C1R( const Fw32f *pSrc, int srcStep, Fw32f *pDst, int dstStep, FwiSize roiSize, Fw32f threshold, Fw32f value)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiThreshold_LTVal_32f_C1R(pSrc, srcStep, pDst, dstStep, roiSize, threshold, value);
    case DT_SSE2:
        return _sse2_fwiThreshold_LTVal_32f_C1R(pSrc, srcStep, pDst, dstStep, roiSize, threshold, value);
    case DT_REFR:
        return _refr_fwiThreshold_LTVal_32f_C1R(pSrc, srcStep, pDst, dstStep, roiSize, threshold, value);
    default:
        assert(false);
        return _refr_fwiThreshold_LTVal_32f_C1R(pSrc, srcStep, pDst, dstStep, roiSize, threshold, value);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiOrC_32s_C3R( const Fw32s  *pSrc, int srcStep, const Fw32s value[3], Fw32s *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiOrC_32s_C3R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiOrC_32s_C3R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiOrC_32s_C3R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiOrC_32s_C3R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiThreshold_LT_32f_C3IR( Fw32f *pSrcDst, int srcDstStep, FwiSize roiSize, const Fw32f threshold[3])
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiThreshold_LT_32f_C3IR(pSrcDst, srcDstStep, roiSize, threshold);
    case DT_SSE2:
        return _sse2_fwiThreshold_LT_32f_C3IR(pSrcDst, srcDstStep, roiSize, threshold);
    case DT_REFR:
        return _refr_fwiThreshold_LT_32f_C3IR(pSrcDst, srcDstStep, roiSize, threshold);
    default:
        assert(false);
        return _refr_fwiThreshold_LT_32f_C3IR(pSrcDst, srcDstStep, roiSize, threshold);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiAddC_16sc_AC4RSfs( const Fw16sc *pSrc, int srcStep, const Fw16sc value[3], Fw16sc *pDst, int dstStep, FwiSize roiSize, int scaleFactor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiAddC_16sc_AC4RSfs(pSrc, srcStep, value, pDst, dstStep, roiSize, scaleFactor);
    case DT_SSE2:
        return _sse2_fwiAddC_16sc_AC4RSfs(pSrc, srcStep, value, pDst, dstStep, roiSize, scaleFactor);
    case DT_REFR:
        return _refr_fwiAddC_16sc_AC4RSfs(pSrc, srcStep, value, pDst, dstStep, roiSize, scaleFactor);
    default:
        assert(false);
        return _refr_fwiAddC_16sc_AC4RSfs(pSrc, srcStep, value, pDst, dstStep, roiSize, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiOr_8u_C4R( const Fw8u *pSrc1, int src1Step, const Fw8u *pSrc2,   int src2Step, Fw8u *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiOr_8u_C4R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiOr_8u_C4R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiOr_8u_C4R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiOr_8u_C4R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiThreshold_GT_16s_AC4IR( Fw16s *pSrcDst, int srcDstStep, FwiSize roiSize, const Fw16s threshold[3])
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiThreshold_GT_16s_AC4IR(pSrcDst, srcDstStep, roiSize, threshold);
    case DT_SSE2:
        return _sse2_fwiThreshold_GT_16s_AC4IR(pSrcDst, srcDstStep, roiSize, threshold);
    case DT_REFR:
        return _refr_fwiThreshold_GT_16s_AC4IR(pSrcDst, srcDstStep, roiSize, threshold);
    default:
        assert(false);
        return _refr_fwiThreshold_GT_16s_AC4IR(pSrcDst, srcDstStep, roiSize, threshold);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiCompareEqualEpsC_32f_C4R( const Fw32f *pSrc, int srcStep, const Fw32f value[4], Fw8u *pDst, int dstStep, FwiSize roiSize, Fw32f eps)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiCompareEqualEpsC_32f_C4R(pSrc, srcStep, value, pDst, dstStep, roiSize, eps);
    case DT_SSE2:
        return _sse2_fwiCompareEqualEpsC_32f_C4R(pSrc, srcStep, value, pDst, dstStep, roiSize, eps);
    case DT_REFR:
        return _refr_fwiCompareEqualEpsC_32f_C4R(pSrc, srcStep, value, pDst, dstStep, roiSize, eps);
    default:
        assert(false);
        return _refr_fwiCompareEqualEpsC_32f_C4R(pSrc, srcStep, value, pDst, dstStep, roiSize, eps);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiThreshold_GT_32f_AC4IR( Fw32f *pSrcDst, int srcDstStep, FwiSize roiSize, const Fw32f threshold[3])
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiThreshold_GT_32f_AC4IR(pSrcDst, srcDstStep, roiSize, threshold);
    case DT_SSE2:
        return _sse2_fwiThreshold_GT_32f_AC4IR(pSrcDst, srcDstStep, roiSize, threshold);
    case DT_REFR:
        return _refr_fwiThreshold_GT_32f_AC4IR(pSrcDst, srcDstStep, roiSize, threshold);
    default:
        assert(false);
        return _refr_fwiThreshold_GT_32f_AC4IR(pSrcDst, srcDstStep, roiSize, threshold);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiFilterSobelHoriz_16s_C3R( const Fw16s * pSrc, int srcStep, Fw16s * pDst, int dstStep, FwiSize dstRoiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilterSobelHoriz_16s_C3R(pSrc, srcStep, pDst, dstStep, dstRoiSize);
    case DT_REFR:
        return _refr_fwiFilterSobelHoriz_16s_C3R(pSrc, srcStep, pDst, dstStep, dstRoiSize);
    default:
        assert(false);
        return _refr_fwiFilterSobelHoriz_16s_C3R(pSrc, srcStep, pDst, dstStep, dstRoiSize);
    }
}

OREFR               FwStatus fwiYCbCr422ToBGR555_8u16u_C2C3R(const A8U* pSrc, int srcStep, A16U* pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiYCbCr422ToBGR555_8u16u_C2C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiYCbCr422ToBGR555_8u16u_C2C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR       FwStatus STDCALL fwiShear_8u_C4R(const Fw8u* pSrc, FwiSize srcSize, int srcStep, FwiRect srcRoi, Fw8u* pDst, int dstStep, FwiRect dstRoi, double xShear, double yShear, double xShift, double yShift, int interpolation )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiShear_8u_C4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, xShear, yShear, xShift, yShift, interpolation);
    default:
        assert(false);
        return _refr_fwiShear_8u_C4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, xShear, yShear, xShift, yShift, interpolation);
    }
}

OREFR               FwStatus fwiYCbCr420ToBGR_8u_P3C3R(const A8U* const pSrc[3], int srcStep[3], A8U* pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiYCbCr420ToBGR_8u_P3C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiYCbCr420ToBGR_8u_P3C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiAddSquare_16u32f_C1IR( const Fw16u *pSrc, int srcStep, Fw32f* pSrcDst, int srcDstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiAddSquare_16u32f_C1IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiAddSquare_16u32f_C1IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    case DT_REFR:
        return _refr_fwiAddSquare_16u32f_C1IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiAddSquare_16u32f_C1IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiThreshold_GT_16s_C1IR( Fw16s *pSrcDst, int srcDstStep, FwiSize roiSize, Fw16s threshold)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiThreshold_GT_16s_C1IR(pSrcDst, srcDstStep, roiSize, threshold);
    case DT_SSE2:
        return _sse2_fwiThreshold_GT_16s_C1IR(pSrcDst, srcDstStep, roiSize, threshold);
    case DT_REFR:
        return _refr_fwiThreshold_GT_16s_C1IR(pSrcDst, srcDstStep, roiSize, threshold);
    default:
        assert(false);
        return _refr_fwiThreshold_GT_16s_C1IR(pSrcDst, srcDstStep, roiSize, threshold);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiFilterRow_16s_C3R( const Fw16s * pSrc, int srcStep,
                              Fw16s * pDst, int dstStep, FwiSize dstRoiSize,
                              const Fw32s * pKernel, int kernelSize,
                              int xAnchor, int divisor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilterRow_16s_C3R(pSrc, srcStep, pDst, dstStep, dstRoiSize, pKernel, kernelSize, xAnchor, divisor);
    case DT_REFR:
        return _refr_fwiFilterRow_16s_C3R(pSrc, srcStep, pDst, dstStep, dstRoiSize, pKernel, kernelSize, xAnchor, divisor);
    default:
        assert(false);
        return _refr_fwiFilterRow_16s_C3R(pSrc, srcStep, pDst, dstStep, dstRoiSize, pKernel, kernelSize, xAnchor, divisor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiSqrt_16s_AC4IRSfs(       Fw16s *pSrcDst, int srcDstStep, FwiSize roiSize, int scaleFactor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiSqrt_16s_AC4IRSfs(pSrcDst, srcDstStep, roiSize, scaleFactor);
    case DT_SSE2:
        return _sse2_fwiSqrt_16s_AC4IRSfs(pSrcDst, srcDstStep, roiSize, scaleFactor);
    case DT_REFR:
        return _refr_fwiSqrt_16s_AC4IRSfs(pSrcDst, srcDstStep, roiSize, scaleFactor);
    default:
        assert(false);
        return _refr_fwiSqrt_16s_AC4IRSfs(pSrcDst, srcDstStep, roiSize, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiThreshold_LT_32f_C1IR( Fw32f *pSrcDst, int srcDstStep, FwiSize roiSize, Fw32f threshold)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiThreshold_LT_32f_C1IR(pSrcDst, srcDstStep, roiSize, threshold);
    case DT_SSE2:
        return _sse2_fwiThreshold_LT_32f_C1IR(pSrcDst, srcDstStep, roiSize, threshold);
    case DT_REFR:
        return _refr_fwiThreshold_LT_32f_C1IR(pSrcDst, srcDstStep, roiSize, threshold);
    default:
        assert(false);
        return _refr_fwiThreshold_LT_32f_C1IR(pSrcDst, srcDstStep, roiSize, threshold);
    }
}

OREFR       FwStatus STDCALL fwiWarpBilinearQuad_8u_C4R(const Fw8u* pSrc, FwiSize srcSize, int srcStep, FwiRect srcRoi,
							        const double srcQuad[4][2], Fw8u* pDst, int dstStep, FwiRect dstRoi,
									const double dstQuad[4][2], int interpolation)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiWarpBilinearQuad_8u_C4R(pSrc, srcSize, srcStep, srcRoi, srcQuad, pDst, dstStep, dstRoi, dstQuad, interpolation);
    default:
        assert(false);
        return _refr_fwiWarpBilinearQuad_8u_C4R(pSrc, srcSize, srcStep, srcRoi, srcQuad, pDst, dstStep, dstRoi, dstQuad, interpolation);
    }
}


OREFR OSSE2       FwStatus STDCALL fwiFilter_8u_C1R( const Fw8u * pSrc, int srcStep,
                             Fw8u * pDst, int dstStep, FwiSize dstRoiSize,
                             const Fw32s * pKernel, FwiSize kernelSize,
                             FwiPoint anchor, int divisor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilter_8u_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize, pKernel, kernelSize, anchor, divisor);
    case DT_REFR:
        return _refr_fwiFilter_8u_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize, pKernel, kernelSize, anchor, divisor);
    default:
        assert(false);
        return _refr_fwiFilter_8u_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize, pKernel, kernelSize, anchor, divisor);
    }
}

OREFR OSSE2 FwStatus STDCALL fwiResizeCenter_16u_C1R( const Fw16u* pSrc, FwiSize srcSize, int srcStep, FwiRect srcRoi,
								   Fw16u* pDst, int dstStep, FwiSize dstRoiSize,
								   double xFactor, double yFactor, double xCenter, double yCenter, int interpolation )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiResizeCenter_16u_C1R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoiSize, xFactor, yFactor, xCenter, yCenter, interpolation);
    case DT_REFR:
        return _refr_fwiResizeCenter_16u_C1R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoiSize, xFactor, yFactor, xCenter, yCenter, interpolation);
    default:
        assert(false);
        return _refr_fwiResizeCenter_16u_C1R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoiSize, xFactor, yFactor, xCenter, yCenter, interpolation);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiAnd_32s_C1R( const Fw32s *pSrc1, int src1Step, const Fw32s *pSrc2,   int src2Step, Fw32s *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiAnd_32s_C1R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiAnd_32s_C1R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiAnd_32s_C1R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiAnd_32s_C1R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiThreshold_LTValGTVal_8u_C3R( const Fw8u *pSrc, int srcStep, Fw8u *pDst, int dstStep, FwiSize roiSize, const Fw8u thresholdLT[3], const Fw8u valueLT[3], const Fw8u thresholdGT[3], const Fw8u valueGT[3])
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiThreshold_LTValGTVal_8u_C3R(pSrc, srcStep, pDst, dstStep, roiSize, thresholdLT, valueLT, thresholdGT, valueGT);
    case DT_SSE2:
        return _sse2_fwiThreshold_LTValGTVal_8u_C3R(pSrc, srcStep, pDst, dstStep, roiSize, thresholdLT, valueLT, thresholdGT, valueGT);
    case DT_REFR:
        return _refr_fwiThreshold_LTValGTVal_8u_C3R(pSrc, srcStep, pDst, dstStep, roiSize, thresholdLT, valueLT, thresholdGT, valueGT);
    default:
        assert(false);
        return _refr_fwiThreshold_LTValGTVal_8u_C3R(pSrc, srcStep, pDst, dstStep, roiSize, thresholdLT, valueLT, thresholdGT, valueGT);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiLn_16s_C3RSfs( const Fw16s *pSrc, int srcStep, Fw16s *pDst, int dstStep, FwiSize roiSize, int scaleFactor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiLn_16s_C3RSfs(pSrc, srcStep, pDst, dstStep, roiSize, scaleFactor);
    case DT_SSE2:
        return _sse2_fwiLn_16s_C3RSfs(pSrc, srcStep, pDst, dstStep, roiSize, scaleFactor);
    case DT_REFR:
        return _refr_fwiLn_16s_C3RSfs(pSrc, srcStep, pDst, dstStep, roiSize, scaleFactor);
    default:
        assert(false);
        return _refr_fwiLn_16s_C3RSfs(pSrc, srcStep, pDst, dstStep, roiSize, scaleFactor);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiMirror_8u_AC4IR(Fw8u  *pSrcDst, int srcDstStep, FwiSize roiSize, FwiAxis flip)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiMirror_8u_AC4IR(pSrcDst, srcDstStep, roiSize, flip);
    case DT_REFR:
        return _refr_fwiMirror_8u_AC4IR(pSrcDst, srcDstStep, roiSize, flip);
    default:
        assert(false);
        return _refr_fwiMirror_8u_AC4IR(pSrcDst, srcDstStep, roiSize, flip);
    }
}

OREFR OSSE2         FwStatus fwiYUV420ToRGB444_8u16u_P3C3R(const A8U* const pSrc[3], int srcStep[3], A16U* pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiYUV420ToRGB444_8u16u_P3C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiYUV420ToRGB444_8u16u_P3C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiYUV420ToRGB444_8u16u_P3C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiThreshold_Val_8u_AC4IR( Fw8u *pSrcDst, int srcDstStep, FwiSize roiSize, const Fw8u threshold[3], const Fw8u value[3], FwCmpOp fwCmpOp)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiThreshold_Val_8u_AC4IR(pSrcDst, srcDstStep, roiSize, threshold, value, fwCmpOp);
    case DT_SSE2:
        return _sse2_fwiThreshold_Val_8u_AC4IR(pSrcDst, srcDstStep, roiSize, threshold, value, fwCmpOp);
    case DT_REFR:
        return _refr_fwiThreshold_Val_8u_AC4IR(pSrcDst, srcDstStep, roiSize, threshold, value, fwCmpOp);
    default:
        assert(false);
        return _refr_fwiThreshold_Val_8u_AC4IR(pSrcDst, srcDstStep, roiSize, threshold, value, fwCmpOp);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiRShiftC_16s_C1R( const Fw16s  *pSrc, int srcStep,       Fw32u value,    Fw16s *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiRShiftC_16s_C1R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiRShiftC_16s_C1R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiRShiftC_16s_C1R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiRShiftC_16s_C1R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiDiv_32fc_C3R( const Fw32fc *pSrc1, int src1Step, const Fw32fc *pSrc2,   int src2Step, Fw32fc *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiDiv_32fc_C3R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiDiv_32fc_C3R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiDiv_32fc_C3R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiDiv_32fc_C3R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    }
}


OREFR OSSE2 FwStatus STDCALL fwiWarpPerspective_8u_C1R( const Fw8u* pSrc, FwiSize srcSize, int srcStep,
								FwiRect srcRoi, Fw8u* pDst, int dstStep, FwiRect dstRoi,
								const double coeffs[3][3], int interpolation )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiWarpPerspective_8u_C1R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, coeffs, interpolation);
    case DT_REFR:
        return _refr_fwiWarpPerspective_8u_C1R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, coeffs, interpolation);
    default:
        assert(false);
        return _refr_fwiWarpPerspective_8u_C1R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, coeffs, interpolation);
    }
}

OREFR       FwStatus STDCALL fwiWarpBilinearBack_32f_C3R(const Fw32f* pSrc, FwiSize srcSize, int srcStep,
								FwiRect srcRoi, Fw32f* pDst, int dstStep, FwiRect dstRoi,
								const double coeffs[2][4], int interpolation)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiWarpBilinearBack_32f_C3R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, coeffs, interpolation);
    default:
        assert(false);
        return _refr_fwiWarpBilinearBack_32f_C3R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, coeffs, interpolation);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiFilterMax_16s_C3R( const Fw16s * pSrc, int srcStep,
                               Fw16s * pDst, int dstStep, FwiSize dstRoiSize,
                               FwiSize maskSize, FwiPoint anchor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilterMax_16s_C3R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize, anchor);
    case DT_REFR:
        return _refr_fwiFilterMax_16s_C3R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize, anchor);
    default:
        assert(false);
        return _refr_fwiFilterMax_16s_C3R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize, anchor);
    }
}

OREFR OSSE2 FwStatus STDCALL fwiResizeShift_32f_C1R( const Fw32f* pSrc, FwiSize srcSize, int srcStep, FwiRect srcRoi,
								  Fw32f* pDst, int dstStep, FwiSize dstRoiSize,
								  double xFr, double yFr, double xShift, double yShift, int interpolation )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiResizeShift_32f_C1R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoiSize, xFr, yFr, xShift, yShift, interpolation);
    case DT_REFR:
        return _refr_fwiResizeShift_32f_C1R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoiSize, xFr, yFr, xShift, yShift, interpolation);
    default:
        assert(false);
        return _refr_fwiResizeShift_32f_C1R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoiSize, xFr, yFr, xShift, yShift, interpolation);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiMul_32f_AC4IR( const Fw32f  *pSrc,  int srcStep,        Fw32f  *pSrcDst, int srcDstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiMul_32f_AC4IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiMul_32f_AC4IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    case DT_REFR:
        return _refr_fwiMul_32f_AC4IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiMul_32f_AC4IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiAnd_16u_AC4IR( const Fw16u *pSrc,  int srcStep,        Fw16u *pSrcDst, int srcDstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiAnd_16u_AC4IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiAnd_16u_AC4IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    case DT_REFR:
        return _refr_fwiAnd_16u_AC4IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiAnd_16u_AC4IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiMul_32fc_AC4R( const Fw32fc *pSrc1, int src1Step, const Fw32fc *pSrc2,   int src2Step, Fw32fc *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiMul_32fc_AC4R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiMul_32fc_AC4R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiMul_32fc_AC4R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiMul_32fc_AC4R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    }
}

OREFR               FwStatus fwiHLSToBGR_8u_AP4R(const A8U* const pSrc[4], int srcStep, A8U* const pDst[4], int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiHLSToBGR_8u_AP4R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiHLSToBGR_8u_AP4R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiThreshold_LT_16s_C3R( const Fw16s *pSrc, int srcStep, Fw16s *pDst, int dstStep, FwiSize roiSize, const Fw16s threshold[3])
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiThreshold_LT_16s_C3R(pSrc, srcStep, pDst, dstStep, roiSize, threshold);
    case DT_SSE2:
        return _sse2_fwiThreshold_LT_16s_C3R(pSrc, srcStep, pDst, dstStep, roiSize, threshold);
    case DT_REFR:
        return _refr_fwiThreshold_LT_16s_C3R(pSrc, srcStep, pDst, dstStep, roiSize, threshold);
    default:
        assert(false);
        return _refr_fwiThreshold_LT_16s_C3R(pSrc, srcStep, pDst, dstStep, roiSize, threshold);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiDiv_32sc_C3RSfs( const Fw32sc *pSrc1, int src1Step, const Fw32sc *pSrc2,   int src2Step, Fw32sc *pDst, int dstStep, FwiSize roiSize, int scaleFactor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiDiv_32sc_C3RSfs(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, scaleFactor);
    case DT_SSE2:
        return _sse2_fwiDiv_32sc_C3RSfs(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, scaleFactor);
    case DT_REFR:
        return _refr_fwiDiv_32sc_C3RSfs(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, scaleFactor);
    default:
        assert(false);
        return _refr_fwiDiv_32sc_C3RSfs(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiMul_32f_C4R( const Fw32f  *pSrc1, int src1Step, const Fw32f  *pSrc2,   int src2Step, Fw32f  *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiMul_32f_C4R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiMul_32f_C4R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiMul_32f_C4R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiMul_32f_C4R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiFilterLaplace_16s_AC4R( const Fw16s * pSrc, int srcStep, Fw16s * pDst, int dstStep, FwiSize dstRoiSize, FwiMaskSize maskSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilterLaplace_16s_AC4R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize);
    case DT_REFR:
        return _refr_fwiFilterLaplace_16s_AC4R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize);
    default:
        assert(false);
        return _refr_fwiFilterLaplace_16s_AC4R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiFilterMedianCross_8u_C3R( const Fw8u * pSrc, int srcStep,
                                                Fw8u * pDst, int dstStep, FwiSize dstRoiSize,
                                                FwiMaskSize maskSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilterMedianCross_8u_C3R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize);
    case DT_REFR:
        return _refr_fwiFilterMedianCross_8u_C3R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize);
    default:
        assert(false);
        return _refr_fwiFilterMedianCross_8u_C3R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiFilterRow32f_8u_C4R( const Fw8u * pSrc, int srcStep,
                                Fw8u * pDst, int dstStep, FwiSize dstRoiSize,
                                const Fw32f * pKernel, int kernelSize,
                                int xAnchor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilterRow32f_8u_C4R(pSrc, srcStep, pDst, dstStep, dstRoiSize, pKernel, kernelSize, xAnchor);
    case DT_REFR:
        return _refr_fwiFilterRow32f_8u_C4R(pSrc, srcStep, pDst, dstStep, dstRoiSize, pKernel, kernelSize, xAnchor);
    default:
        assert(false);
        return _refr_fwiFilterRow32f_8u_C4R(pSrc, srcStep, pDst, dstStep, dstRoiSize, pKernel, kernelSize, xAnchor);
    }
}

OREFR OSSE2 FwStatus STDCALL fwiWarpPerspectiveBack_8u_C4R( const Fw8u* pSrc, FwiSize srcSize, int srcStep,
								FwiRect srcRoi, Fw8u* pDst, int dstStep, FwiRect dstRoi,
								const double coeffs[3][3], int interpolation )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiWarpPerspectiveBack_8u_C4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, coeffs, interpolation);
    case DT_REFR:
        return _refr_fwiWarpPerspectiveBack_8u_C4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, coeffs, interpolation);
    default:
        assert(false);
        return _refr_fwiWarpPerspectiveBack_8u_C4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, coeffs, interpolation);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiFilterSobelVert_32f_C1R( const Fw32f * pSrc, int srcStep, Fw32f * pDst, int dstStep, FwiSize dstRoiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilterSobelVert_32f_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize);
    case DT_REFR:
        return _refr_fwiFilterSobelVert_32f_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize);
    default:
        assert(false);
        return _refr_fwiFilterSobelVert_32f_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize);
    }
}


OREFR OSSE2         FwStatus fwiMin_8u_C3R(const Fw8u* pSrc, int srcStep,FwiSize roiSize, Fw8u min[3])
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiMin_8u_C3R(pSrc, srcStep, roiSize, min);
    case DT_REFR:
        return _refr_fwiMin_8u_C3R(pSrc, srcStep, roiSize, min);
    default:
        assert(false);
        return _refr_fwiMin_8u_C3R(pSrc, srcStep, roiSize, min);
    }
}

OREFR               FwStatus fwiYCbCr420ToBGR565_8u16u_P3C3R(const A8U* const pSrc[3], int srcStep[3], A16U* pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiYCbCr420ToBGR565_8u16u_P3C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiYCbCr420ToBGR565_8u16u_P3C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiFilter32f_8u_C4R( const Fw8u * pSrc, int srcStep,
                                Fw8u * pDst, int dstStep, FwiSize dstRoiSize,
                                const Fw32f * pKernel, FwiSize kernelSize,
                                FwiPoint anchor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilter32f_8u_C4R(pSrc, srcStep, pDst, dstStep, dstRoiSize, pKernel, kernelSize, anchor);
    case DT_REFR:
        return _refr_fwiFilter32f_8u_C4R(pSrc, srcStep, pDst, dstStep, dstRoiSize, pKernel, kernelSize, anchor);
    default:
        assert(false);
        return _refr_fwiFilter32f_8u_C4R(pSrc, srcStep, pDst, dstStep, dstRoiSize, pKernel, kernelSize, anchor);
    }
}

OREFR               FwStatus fwiRGBToYUV422_8u_C3P3( const A8U* pSrc, A8U* pDst[3], FwiSize imgSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiRGBToYUV422_8u_C3P3(pSrc, pDst, imgSize);
    default:
        assert(false);
        return _refr_fwiRGBToYUV422_8u_C3P3(pSrc, pDst, imgSize);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiFilterLowpass_16s_AC4R( const Fw16s * pSrc, int srcStep, Fw16s * pDst, int dstStep, FwiSize dstRoiSize, FwiMaskSize maskSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilterLowpass_16s_AC4R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize);
    case DT_REFR:
        return _refr_fwiFilterLowpass_16s_AC4R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize);
    default:
        assert(false);
        return _refr_fwiFilterLowpass_16s_AC4R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiOrC_8u_C3R( const Fw8u   *pSrc, int srcStep, const Fw8u value[3], Fw8u *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiOrC_8u_C3R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiOrC_8u_C3R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiOrC_8u_C3R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiOrC_8u_C3R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiFilterLaplace_8s16s_C1R( const Fw8s * pSrc, int srcStep, Fw16s * pDst, int dstStep, FwiSize dstRoiSize, FwiMaskSize maskSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilterLaplace_8s16s_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize);
    case DT_REFR:
        return _refr_fwiFilterLaplace_8s16s_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize);
    default:
        assert(false);
        return _refr_fwiFilterLaplace_8s16s_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize);
    }
}

OREFR       FwStatus STDCALL fwiWarpBilinearBack_32f_P3R(const Fw32f* const pSrc[3], FwiSize srcSize, int srcStep,
								FwiRect srcRoi, Fw32f* const pDst[3], int dstStep, FwiRect dstRoi,
								const double coeffs[2][4], int interpolation)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiWarpBilinearBack_32f_P3R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, coeffs, interpolation);
    default:
        assert(false);
        return _refr_fwiWarpBilinearBack_32f_P3R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, coeffs, interpolation);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiAbs_16s_C4R( const Fw16s *pSrc, int srcStep, Fw16s *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiAbs_16s_C4R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiAbs_16s_C4R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiAbs_16s_C4R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiAbs_16s_C4R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiThreshold_GT_16s_AC4R( const Fw16s *pSrc, int srcStep, Fw16s *pDst, int dstStep, FwiSize roiSize, const Fw16s threshold[3])
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiThreshold_GT_16s_AC4R(pSrc, srcStep, pDst, dstStep, roiSize, threshold);
    case DT_SSE2:
        return _sse2_fwiThreshold_GT_16s_AC4R(pSrc, srcStep, pDst, dstStep, roiSize, threshold);
    case DT_REFR:
        return _refr_fwiThreshold_GT_16s_AC4R(pSrc, srcStep, pDst, dstStep, roiSize, threshold);
    default:
        assert(false);
        return _refr_fwiThreshold_GT_16s_AC4R(pSrc, srcStep, pDst, dstStep, roiSize, threshold);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiAnd_32s_AC4IR( const Fw32s *pSrc,  int srcStep,        Fw32s *pSrcDst, int srcDstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiAnd_32s_AC4IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiAnd_32s_AC4IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    case DT_REFR:
        return _refr_fwiAnd_32s_AC4IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiAnd_32s_AC4IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    }
}

OREFR       FwStatus STDCALL fwiWarpBilinearQuad_32f_P3R(const Fw32f* const pSrc[3], FwiSize srcSize, int srcStep, FwiRect srcRoi,
							        const double srcQuad[4][2], Fw32f* const pDst[3], int dstStep, FwiRect dstRoi,
									const double dstQuad[4][2], int interpolation)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiWarpBilinearQuad_32f_P3R(pSrc, srcSize, srcStep, srcRoi, srcQuad, pDst, dstStep, dstRoi, dstQuad, interpolation);
    default:
        assert(false);
        return _refr_fwiWarpBilinearQuad_32f_P3R(pSrc, srcSize, srcStep, srcRoi, srcQuad, pDst, dstStep, dstRoi, dstQuad, interpolation);
    }
}

OREFR OSSE2         FwStatus fwiMax_16s_C4R(const Fw16s* pSrc, int srcStep,FwiSize roiSize, Fw16s max[4])
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiMax_16s_C4R(pSrc, srcStep, roiSize, max);
    case DT_REFR:
        return _refr_fwiMax_16s_C4R(pSrc, srcStep, roiSize, max);
    default:
        assert(false);
        return _refr_fwiMax_16s_C4R(pSrc, srcStep, roiSize, max);
    }
}

OREFR               FwStatus fwiYCbCr422ToBGR444_8u16u_C2C3R(const A8U* pSrc, int srcStep, A16U* pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiYCbCr422ToBGR444_8u16u_C2C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiYCbCr422ToBGR444_8u16u_C2C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiFilterMin_16s_AC4R( const Fw16s * pSrc, int srcStep,
                               Fw16s * pDst, int dstStep, FwiSize dstRoiSize,
                               FwiSize maskSize, FwiPoint anchor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilterMin_16s_AC4R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize, anchor);
    case DT_REFR:
        return _refr_fwiFilterMin_16s_AC4R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize, anchor);
    default:
        assert(false);
        return _refr_fwiFilterMin_16s_AC4R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize, anchor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiXorC_16u_C3R( const Fw16u  *pSrc, int srcStep, const Fw16u value[3], Fw16u *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiXorC_16u_C3R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiXorC_16u_C3R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiXorC_16u_C3R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiXorC_16u_C3R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    }
}


OREFR               FwStatus fwiRGBToHSV_8u_C3R( const Fw8u *pSrc, int srcStep, Fw8u *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiRGBToHSV_8u_C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiRGBToHSV_8u_C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiCopy_8u_C1R( const Fw8u *pSrc, int srcStep, Fw8u *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiCopy_8u_C1R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiCopy_8u_C1R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiCopy_8u_C1R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiCopy_8u_C1R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiCompare_8u_C1R( const Fw8u *pSrc1, int src1Step, const Fw8u *pSrc2, int src2Step, Fw8u *pDst, int dstStep, FwiSize roiSize, FwCmpOp fwCmpOp )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiCompare_8u_C1R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, fwCmpOp);
    case DT_SSE2:
        return _sse2_fwiCompare_8u_C1R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, fwCmpOp);
    case DT_REFR:
        return _refr_fwiCompare_8u_C1R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, fwCmpOp);
    default:
        assert(false);
        return _refr_fwiCompare_8u_C1R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, fwCmpOp);
    }
}

OREFR OSSE2         FwStatus fwiMax_32f_C3R(const Fw32f* pSrc, int srcStep,FwiSize roiSize, Fw32f max[3])
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiMax_32f_C3R(pSrc, srcStep, roiSize, max);
    case DT_REFR:
        return _refr_fwiMax_32f_C3R(pSrc, srcStep, roiSize, max);
    default:
        assert(false);
        return _refr_fwiMax_32f_C3R(pSrc, srcStep, roiSize, max);
    }
}

OREFR OSSE2 FwStatus STDCALL fwiResizeShift_32f_P4R( const Fw32f* const pSrc[4], FwiSize srcSize, int srcStep, FwiRect srcRoi,
								  Fw32f* const pDst[4], int dstStep, FwiSize dstRoiSize,
								  double xFr, double yFr, double xShift, double yShift, int interpolation )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiResizeShift_32f_P4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoiSize, xFr, yFr, xShift, yShift, interpolation);
    case DT_REFR:
        return _refr_fwiResizeShift_32f_P4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoiSize, xFr, yFr, xShift, yShift, interpolation);
    default:
        assert(false);
        return _refr_fwiResizeShift_32f_P4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoiSize, xFr, yFr, xShift, yShift, interpolation);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiThreshold_LT_16s_C1IR( Fw16s *pSrcDst, int srcDstStep, FwiSize roiSize, Fw16s threshold)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiThreshold_LT_16s_C1IR(pSrcDst, srcDstStep, roiSize, threshold);
    case DT_SSE2:
        return _sse2_fwiThreshold_LT_16s_C1IR(pSrcDst, srcDstStep, roiSize, threshold);
    case DT_REFR:
        return _refr_fwiThreshold_LT_16s_C1IR(pSrcDst, srcDstStep, roiSize, threshold);
    default:
        assert(false);
        return _refr_fwiThreshold_LT_16s_C1IR(pSrcDst, srcDstStep, roiSize, threshold);
    }
}

OREFR OSSE2 FwStatus STDCALL fwiWarpPerspective_8u_P4R( const Fw8u* const pSrc[4], FwiSize srcSize, int srcStep,
								FwiRect srcRoi, Fw8u* const pDst[4], int dstStep, FwiRect dstRoi,
								const double coeffs[3][3], int interpolation )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiWarpPerspective_8u_P4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, coeffs, interpolation);
    case DT_REFR:
        return _refr_fwiWarpPerspective_8u_P4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, coeffs, interpolation);
    default:
        assert(false);
        return _refr_fwiWarpPerspective_8u_P4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, coeffs, interpolation);
    }
}

OREFR               FwStatus fwiRGBToHLS_32f_C3R( const Fw32f* pSrc, int srcStep, Fw32f* pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiRGBToHLS_32f_C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiRGBToHLS_32f_C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2         FwStatus fwiRGBToGray_32f_AC4C1R(const Fw32f* pSrc, int srcStep,Fw32f* pDst, int dstStep, FwiSize roiSize)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiRGBToGray_32f_AC4C1R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiRGBToGray_32f_AC4C1R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiRGBToGray_32f_AC4C1R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiSub_8u_C4RSfs( const Fw8u   *pSrc1, int src1Step, const Fw8u   *pSrc2,   int src2Step, Fw8u *pDst, int dstStep, FwiSize roiSize, int scaleFactor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiSub_8u_C4RSfs(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, scaleFactor);
    case DT_SSE2:
        return _sse2_fwiSub_8u_C4RSfs(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, scaleFactor);
    case DT_REFR:
        return _refr_fwiSub_8u_C4RSfs(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, scaleFactor);
    default:
        assert(false);
        return _refr_fwiSub_8u_C4RSfs(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, scaleFactor);
    }
}

OREFR               FwStatus fwiRGBToYCbCr422_8u_C3C2R(const A8U* pSrc, int srcStep, A8U* pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiRGBToYCbCr422_8u_C3C2R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiRGBToYCbCr422_8u_C3C2R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiFilterMedianColor_32f_C3R( const Fw32f * pSrc, int srcStep,
                                                 Fw32f * pDst, int dstStep, FwiSize dstRoiSize,
                                                 FwiMaskSize maskSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilterMedianColor_32f_C3R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize);
    case DT_REFR:
        return _refr_fwiFilterMedianColor_32f_C3R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize);
    default:
        assert(false);
        return _refr_fwiFilterMedianColor_32f_C3R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize);
    }
}

OREFR OSSE2         FwStatus fwiSum_32f_AC4R(const Fw32f* pSrc, int srcStep,FwiSize roiSize, Fw64f sum[3], FwHintAlgorithm hint)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiSum_32f_AC4R(pSrc, srcStep, roiSize, sum, hint);
    case DT_REFR:
        return _refr_fwiSum_32f_AC4R(pSrc, srcStep, roiSize, sum, hint);
    default:
        assert(false);
        return _refr_fwiSum_32f_AC4R(pSrc, srcStep, roiSize, sum, hint);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiAdd_16sc_AC4IRSfs( const Fw16sc *pSrc,  int srcStep,        Fw16sc *pSrcDst, int srcDstStep, FwiSize roiSize, int scaleFactor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiAdd_16sc_AC4IRSfs(pSrc, srcStep, pSrcDst, srcDstStep, roiSize, scaleFactor);
    case DT_SSE2:
        return _sse2_fwiAdd_16sc_AC4IRSfs(pSrc, srcStep, pSrcDst, srcDstStep, roiSize, scaleFactor);
    case DT_REFR:
        return _refr_fwiAdd_16sc_AC4IRSfs(pSrc, srcStep, pSrcDst, srcDstStep, roiSize, scaleFactor);
    default:
        assert(false);
        return _refr_fwiAdd_16sc_AC4IRSfs(pSrc, srcStep, pSrcDst, srcDstStep, roiSize, scaleFactor);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiRotate_32f_P3R( const Fw32f* const pSrc[3], FwiSize srcSize, int srcStep, FwiRect srcRoi, Fw32f* const pDst[3], int dstStep, FwiRect dstRoi, double angle, double xShift, double yShift, int interpolation )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiRotate_32f_P3R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, angle, xShift, yShift, interpolation);
    case DT_REFR:
        return _refr_fwiRotate_32f_P3R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, angle, xShift, yShift, interpolation);
    default:
        assert(false);
        return _refr_fwiRotate_32f_P3R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, angle, xShift, yShift, interpolation);
    }
}

OREFR               FwStatus fwiYCbCrToRGB555_8u16u_C3R( const Fw8u* pSrc, int srcStep, A16U* pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiYCbCrToRGB555_8u16u_C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiYCbCrToRGB555_8u16u_C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiAddC_32f_C1R( const Fw32f *pSrc, int srcStep,      Fw32f value,    Fw32f *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiAddC_32f_C1R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiAddC_32f_C1R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiAddC_32f_C1R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiAddC_32f_C1R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiAddC_16s_AC4RSfs( const Fw16s  *pSrc, int srcStep, const Fw16s value[3], Fw16s *pDst, int dstStep, FwiSize roiSize, int scaleFactor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiAddC_16s_AC4RSfs(pSrc, srcStep, value, pDst, dstStep, roiSize, scaleFactor);
    case DT_SSE2:
        return _sse2_fwiAddC_16s_AC4RSfs(pSrc, srcStep, value, pDst, dstStep, roiSize, scaleFactor);
    case DT_REFR:
        return _refr_fwiAddC_16s_AC4RSfs(pSrc, srcStep, value, pDst, dstStep, roiSize, scaleFactor);
    default:
        assert(false);
        return _refr_fwiAddC_16s_AC4RSfs(pSrc, srcStep, value, pDst, dstStep, roiSize, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiRShiftC_8u_AC4R( const Fw8u   *pSrc, int srcStep, const Fw32u value[3], Fw8u *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiRShiftC_8u_AC4R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiRShiftC_8u_AC4R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiRShiftC_8u_AC4R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiRShiftC_8u_AC4R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiDiv_32sc_C1RSfs( const Fw32sc *pSrc1, int src1Step, const Fw32sc *pSrc2,   int src2Step, Fw32sc *pDst, int dstStep, FwiSize roiSize, int scaleFactor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiDiv_32sc_C1RSfs(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, scaleFactor);
    case DT_SSE2:
        return _sse2_fwiDiv_32sc_C1RSfs(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, scaleFactor);
    case DT_REFR:
        return _refr_fwiDiv_32sc_C1RSfs(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, scaleFactor);
    default:
        assert(false);
        return _refr_fwiDiv_32sc_C1RSfs(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiXor_8u_C3IR( const Fw8u	*pSrc,  int srcStep,        Fw8u *pSrcDst, int srcDstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiXor_8u_C3IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiXor_8u_C3IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    case DT_REFR:
        return _refr_fwiXor_8u_C3IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiXor_8u_C3IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    }
}

OREFR             FwStatus STDCALL fwiScale_8u32f_AC4R( const Fw8u * pSrc, int srcStep, Fw32f * pDst, int dstStep, FwiSize roiSize, Fw32f vMin, Fw32f vMax )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiScale_8u32f_AC4R(pSrc, srcStep, pDst, dstStep, roiSize, vMin, vMax);
    default:
        assert(false);
        return _refr_fwiScale_8u32f_AC4R(pSrc, srcStep, pDst, dstStep, roiSize, vMin, vMax);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiXor_32s_AC4IR( const Fw32s *pSrc,  int srcStep,        Fw32s *pSrcDst, int srcDstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiXor_32s_AC4IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiXor_32s_AC4IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    case DT_REFR:
        return _refr_fwiXor_32s_AC4IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiXor_32s_AC4IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    }
}


OREFR OSSE2       FwStatus STDCALL fwiFilterSobelHorizSecond_32f_C1R( const Fw32f * pSrc, int srcStep, Fw32f * pDst, int dstStep, FwiSize dstRoiSize,  FwiMaskSize mask )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilterSobelHorizSecond_32f_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize, mask);
    case DT_REFR:
        return _refr_fwiFilterSobelHorizSecond_32f_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize, mask);
    default:
        assert(false);
        return _refr_fwiFilterSobelHorizSecond_32f_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize, mask);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiSet_16s_C4MR( const Fw16s  value[4], Fw16s  * pDst, int dstStep, FwiSize roiSize, const Fw8u * pMask, int maskStep )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiSet_16s_C4MR(value, pDst, dstStep, roiSize, pMask, maskStep);
    case DT_SSE2:
        return _sse2_fwiSet_16s_C4MR(value, pDst, dstStep, roiSize, pMask, maskStep);
    case DT_REFR:
        return _refr_fwiSet_16s_C4MR(value, pDst, dstStep, roiSize, pMask, maskStep);
    default:
        assert(false);
        return _refr_fwiSet_16s_C4MR(value, pDst, dstStep, roiSize, pMask, maskStep);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiXor_32s_C3R( const Fw32s *pSrc1, int src1Step, const Fw32s *pSrc2,   int src2Step, Fw32s *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiXor_32s_C3R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiXor_32s_C3R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiXor_32s_C3R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiXor_32s_C3R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiFilterMedianCross_16s_C3R( const Fw16s * pSrc, int srcStep,
                                                Fw16s * pDst, int dstStep, FwiSize dstRoiSize,
                                                FwiMaskSize maskSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilterMedianCross_16s_C3R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize);
    case DT_REFR:
        return _refr_fwiFilterMedianCross_16s_C3R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize);
    default:
        assert(false);
        return _refr_fwiFilterMedianCross_16s_C3R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiFilterSobelHoriz_8u16s_C1R( const Fw8u * pSrc, int srcStep, Fw16s * pDst, int dstStep, FwiSize dstRoiSize, FwiMaskSize mask )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilterSobelHoriz_8u16s_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize, mask);
    case DT_REFR:
        return _refr_fwiFilterSobelHoriz_8u16s_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize, mask);
    default:
        assert(false);
        return _refr_fwiFilterSobelHoriz_8u16s_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize, mask);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiCopy_8u_C3P3R( const Fw8u *pSrc, int srcStep, Fw8u * const pDst[3], int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiCopy_8u_C3P3R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiCopy_8u_C3P3R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiCopy_8u_C3P3R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiCopy_8u_C3P3R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}


OREFR OSSE2 FwStatus STDCALL fwiResize_8u_P3R( const Fw8u* const pSrc[3], FwiSize srcSize, int srcStep, FwiRect srcRoi,
							 Fw8u* const pDst[3], int dstStep, FwiSize dstRoiSize,
							 double xFactor, double yFactor, int interpolation )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiResize_8u_P3R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoiSize, xFactor, yFactor, interpolation);
    case DT_REFR:
        return _refr_fwiResize_8u_P3R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoiSize, xFactor, yFactor, interpolation);
    default:
        assert(false);
        return _refr_fwiResize_8u_P3R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoiSize, xFactor, yFactor, interpolation);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiThreshold_Val_8u_AC4R( const Fw8u *pSrc, int srcStep, Fw8u *pDst, int dstStep, FwiSize roiSize, const Fw8u threshold[3], const Fw8u value[3], FwCmpOp fwCmpOp)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiThreshold_Val_8u_AC4R(pSrc, srcStep, pDst, dstStep, roiSize, threshold, value, fwCmpOp);
    case DT_SSE2:
        return _sse2_fwiThreshold_Val_8u_AC4R(pSrc, srcStep, pDst, dstStep, roiSize, threshold, value, fwCmpOp);
    case DT_REFR:
        return _refr_fwiThreshold_Val_8u_AC4R(pSrc, srcStep, pDst, dstStep, roiSize, threshold, value, fwCmpOp);
    default:
        assert(false);
        return _refr_fwiThreshold_Val_8u_AC4R(pSrc, srcStep, pDst, dstStep, roiSize, threshold, value, fwCmpOp);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiMulC_16s_C1IRSfs(       Fw16s value,    Fw16s *pSrcDst, int srcDstStep, FwiSize roiSize, int scaleFactor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiMulC_16s_C1IRSfs(value, pSrcDst, srcDstStep, roiSize, scaleFactor);
    case DT_SSE2:
        return _sse2_fwiMulC_16s_C1IRSfs(value, pSrcDst, srcDstStep, roiSize, scaleFactor);
    case DT_REFR:
        return _refr_fwiMulC_16s_C1IRSfs(value, pSrcDst, srcDstStep, roiSize, scaleFactor);
    default:
        assert(false);
        return _refr_fwiMulC_16s_C1IRSfs(value, pSrcDst, srcDstStep, roiSize, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiOr_8u_C4IR( const Fw8u	*pSrc,  int srcStep,        Fw8u *pSrcDst, int srcDstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiOr_8u_C4IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiOr_8u_C4IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    case DT_REFR:
        return _refr_fwiOr_8u_C4IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiOr_8u_C4IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    }
}

OREFR OSSE2 FwStatus STDCALL fwiWarpAffineBack_16u_C3R( const Fw16u* pSrc, FwiSize srcSize, int srcStep,
								FwiRect srcRoi, Fw16u* pDst, int dstStep, FwiRect dstRoi,
								const double coeffs[2][3], int interpolation )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiWarpAffineBack_16u_C3R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, coeffs, interpolation);
    case DT_REFR:
        return _refr_fwiWarpAffineBack_16u_C3R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, coeffs, interpolation);
    default:
        assert(false);
        return _refr_fwiWarpAffineBack_16u_C3R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, coeffs, interpolation);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiDivC_16s_C1RSfs( const Fw16s *pSrc, int srcStep,       Fw16s value,    Fw16s *pDst, int dstStep, FwiSize roiSize, int scaleFactor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiDivC_16s_C1RSfs(pSrc, srcStep, value, pDst, dstStep, roiSize, scaleFactor);
    case DT_SSE2:
        return _sse2_fwiDivC_16s_C1RSfs(pSrc, srcStep, value, pDst, dstStep, roiSize, scaleFactor);
    case DT_REFR:
        return _refr_fwiDivC_16s_C1RSfs(pSrc, srcStep, value, pDst, dstStep, roiSize, scaleFactor);
    default:
        assert(false);
        return _refr_fwiDivC_16s_C1RSfs(pSrc, srcStep, value, pDst, dstStep, roiSize, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiOrC_32s_C4IR( const Fw32s value[4], Fw32s *pSrcDst, int srcDstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiOrC_32s_C4IR(value, pSrcDst, srcDstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiOrC_32s_C4IR(value, pSrcDst, srcDstStep, roiSize);
    case DT_REFR:
        return _refr_fwiOrC_32s_C4IR(value, pSrcDst, srcDstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiOrC_32s_C4IR(value, pSrcDst, srcDstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiXorC_16u_AC4IR( const Fw16u value[3], Fw16u *pSrcDst, int srcDstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiXorC_16u_AC4IR(value, pSrcDst, srcDstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiXorC_16u_AC4IR(value, pSrcDst, srcDstStep, roiSize);
    case DT_REFR:
        return _refr_fwiXorC_16u_AC4IR(value, pSrcDst, srcDstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiXorC_16u_AC4IR(value, pSrcDst, srcDstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiSqr_8u_C3RSfs( const Fw8u  *pSrc,    int srcStep, Fw8u *pDst, int dstStep, FwiSize roiSize, int scaleFactor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiSqr_8u_C3RSfs(pSrc, srcStep, pDst, dstStep, roiSize, scaleFactor);
    case DT_SSE2:
        return _sse2_fwiSqr_8u_C3RSfs(pSrc, srcStep, pDst, dstStep, roiSize, scaleFactor);
    case DT_REFR:
        return _refr_fwiSqr_8u_C3RSfs(pSrc, srcStep, pDst, dstStep, roiSize, scaleFactor);
    default:
        assert(false);
        return _refr_fwiSqr_8u_C3RSfs(pSrc, srcStep, pDst, dstStep, roiSize, scaleFactor);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiFilterLaplace_16s_C1R( const Fw16s * pSrc, int srcStep, Fw16s * pDst, int dstStep, FwiSize dstRoiSize, FwiMaskSize maskSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilterLaplace_16s_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize);
    case DT_REFR:
        return _refr_fwiFilterLaplace_16s_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize);
    default:
        assert(false);
        return _refr_fwiFilterLaplace_16s_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiSubC_32fc_AC4IR( const Fw32fc value[3], Fw32fc *pSrcDst, int srcDstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiSubC_32fc_AC4IR(value, pSrcDst, srcDstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiSubC_32fc_AC4IR(value, pSrcDst, srcDstStep, roiSize);
    case DT_REFR:
        return _refr_fwiSubC_32fc_AC4IR(value, pSrcDst, srcDstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiSubC_32fc_AC4IR(value, pSrcDst, srcDstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiLn_16s_C3IRSfs(       Fw16s *pSrcDst,  int srcDstStep, FwiSize roiSize, int scaleFactor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiLn_16s_C3IRSfs(pSrcDst, srcDstStep, roiSize, scaleFactor);
    case DT_SSE2:
        return _sse2_fwiLn_16s_C3IRSfs(pSrcDst, srcDstStep, roiSize, scaleFactor);
    case DT_REFR:
        return _refr_fwiLn_16s_C3IRSfs(pSrcDst, srcDstStep, roiSize, scaleFactor);
    default:
        assert(false);
        return _refr_fwiLn_16s_C3IRSfs(pSrcDst, srcDstStep, roiSize, scaleFactor);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiMirror_32s_C1IR(Fw32s *pSrcDst, int srcDstStep, FwiSize roiSize, FwiAxis flip)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiMirror_32s_C1IR(pSrcDst, srcDstStep, roiSize, flip);
    case DT_REFR:
        return _refr_fwiMirror_32s_C1IR(pSrcDst, srcDstStep, roiSize, flip);
    default:
        assert(false);
        return _refr_fwiMirror_32s_C1IR(pSrcDst, srcDstStep, roiSize, flip);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiFilterColumn_32f_C3R( const Fw32f * pSrc, int srcStep,
                              Fw32f * pDst, int dstStep, FwiSize dstRoiSize,
                              const Fw32f * pKernel, int kernelSize,
                              int yAnchor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilterColumn_32f_C3R(pSrc, srcStep, pDst, dstStep, dstRoiSize, pKernel, kernelSize, yAnchor);
    case DT_REFR:
        return _refr_fwiFilterColumn_32f_C3R(pSrc, srcStep, pDst, dstStep, dstRoiSize, pKernel, kernelSize, yAnchor);
    default:
        assert(false);
        return _refr_fwiFilterColumn_32f_C3R(pSrc, srcStep, pDst, dstStep, dstRoiSize, pKernel, kernelSize, yAnchor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiCopy_32f_AC4C3R( const Fw32f *pSrc, int srcStep, Fw32f *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiCopy_32f_AC4C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiCopy_32f_AC4C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiCopy_32f_AC4C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiCopy_32f_AC4C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiRotateCenter_8u_P3R( const Fw8u* const pSrc[3],FwiSize srcSize, int srcStep, FwiRect srcRoi, Fw8u* const pDst[3], int dstStep, FwiRect dstRoi, double angle, double xCenter, double yCenter, int interpolation )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiRotateCenter_8u_P3R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, angle, xCenter, yCenter, interpolation);
    case DT_REFR:
        return _refr_fwiRotateCenter_8u_P3R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, angle, xCenter, yCenter, interpolation);
    default:
        assert(false);
        return _refr_fwiRotateCenter_8u_P3R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, angle, xCenter, yCenter, interpolation);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiRShiftC_16u_C3IR( const Fw32u value[3], Fw16u *pSrcDst, int srcDstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiRShiftC_16u_C3IR(value, pSrcDst, srcDstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiRShiftC_16u_C3IR(value, pSrcDst, srcDstStep, roiSize);
    case DT_REFR:
        return _refr_fwiRShiftC_16u_C3IR(value, pSrcDst, srcDstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiRShiftC_16u_C3IR(value, pSrcDst, srcDstStep, roiSize);
    }
}


OREFR       FwStatus STDCALL fwiWarpBilinearBack_8u_C1R(const Fw8u* pSrc, FwiSize srcSize, int srcStep,
								FwiRect srcRoi, Fw8u* pDst, int dstStep, FwiRect dstRoi,
								const double coeffs[2][4], int interpolation)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiWarpBilinearBack_8u_C1R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, coeffs, interpolation);
    default:
        assert(false);
        return _refr_fwiWarpBilinearBack_8u_C1R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, coeffs, interpolation);
    }
}

OREFR               FwStatus fwiRGBToLUV_16s_AC4R( const Fw16s* pSrc, int srcStep, Fw16s* pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiRGBToLUV_16s_AC4R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiRGBToLUV_16s_AC4R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiThreshold_GTVal_8u_C3IR( Fw8u *pSrcDst, int srcDstStep, FwiSize roiSize, const Fw8u threshold[3], const Fw8u value[3])
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiThreshold_GTVal_8u_C3IR(pSrcDst, srcDstStep, roiSize, threshold, value);
    case DT_SSE2:
        return _sse2_fwiThreshold_GTVal_8u_C3IR(pSrcDst, srcDstStep, roiSize, threshold, value);
    case DT_REFR:
        return _refr_fwiThreshold_GTVal_8u_C3IR(pSrcDst, srcDstStep, roiSize, threshold, value);
    default:
        assert(false);
        return _refr_fwiThreshold_GTVal_8u_C3IR(pSrcDst, srcDstStep, roiSize, threshold, value);
    }
}

OREFR OSSE2 FwStatus STDCALL fwiWarpAffine_32f_C1R( const Fw32f* pSrc, FwiSize srcSize, int srcStep,
								FwiRect srcRoi, Fw32f* pDst, int dstStep, FwiRect dstRoi,
								const double coeffs[2][3], int interpolation )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiWarpAffine_32f_C1R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, coeffs, interpolation);
    case DT_REFR:
        return _refr_fwiWarpAffine_32f_C1R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, coeffs, interpolation);
    default:
        assert(false);
        return _refr_fwiWarpAffine_32f_C1R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, coeffs, interpolation);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiCopy_32s_C4CR( const Fw32s *pSrc, int srcStep, Fw32s *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiCopy_32s_C4CR(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiCopy_32s_C4CR(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiCopy_32s_C4CR(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiCopy_32s_C4CR(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 FwStatus STDCALL fwiFilterSharpen_8u_C4R( const Fw8u * pSrc, int srcStep, Fw8u * pDst, int dstStep, FwiSize dstRoiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilterSharpen_8u_C4R(pSrc, srcStep, pDst, dstStep, dstRoiSize);
    case DT_REFR:
        return _refr_fwiFilterSharpen_8u_C4R(pSrc, srcStep, pDst, dstStep, dstRoiSize);
    default:
        assert(false);
        return _refr_fwiFilterSharpen_8u_C4R(pSrc, srcStep, pDst, dstStep, dstRoiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiCopy_32s_C3P3R( const Fw32s *pSrc, int srcStep, Fw32s * const pDst[3], int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiCopy_32s_C3P3R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiCopy_32s_C3P3R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiCopy_32s_C3P3R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiCopy_32s_C3P3R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR       FwStatus STDCALL fwiShear_32f_P3R(const Fw32f* const pSrc[3], FwiSize srcSize, int srcStep, FwiRect srcRoi, Fw32f* const pDst[3], int dstStep, FwiRect dstRoi, double xShear, double yShear, double xShift, double yShift, int interpolation)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiShear_32f_P3R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, xShear, yShear, xShift, yShift, interpolation);
    default:
        assert(false);
        return _refr_fwiShear_32f_P3R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, xShear, yShear, xShift, yShift, interpolation);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiAdd_32fc_C3R( const Fw32fc *pSrc1, int src1Step, const Fw32fc *pSrc2,   int src2Step, Fw32fc *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiAdd_32fc_C3R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiAdd_32fc_C3R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiAdd_32fc_C3R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiAdd_32fc_C3R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    }
}

OREFR               FwStatus fwiHLSToRGB_8u_AC4R( const Fw8u *pSrc, int srcStep, Fw8u *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiHLSToRGB_8u_AC4R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiHLSToRGB_8u_AC4R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiAdd_32f_C1IMR( const Fw32f *pSrc, int srcStep, const Fw8u *pMask, int maskStep, Fw32f *pSrcDst, int srcDstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiAdd_32f_C1IMR(pSrc, srcStep, pMask, maskStep, pSrcDst, srcDstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiAdd_32f_C1IMR(pSrc, srcStep, pMask, maskStep, pSrcDst, srcDstStep, roiSize);
    case DT_REFR:
        return _refr_fwiAdd_32f_C1IMR(pSrc, srcStep, pMask, maskStep, pSrcDst, srcDstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiAdd_32f_C1IMR(pSrc, srcStep, pMask, maskStep, pSrcDst, srcDstStep, roiSize);
    }
}


OREFR OSSE2       FwStatus STDCALL fwiFilterPrewittHoriz_8u_C1R( const Fw8u * pSrc, int srcStep, Fw8u * pDst, int dstStep, FwiSize dstRoiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilterPrewittHoriz_8u_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize);
    case DT_REFR:
        return _refr_fwiFilterPrewittHoriz_8u_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize);
    default:
        assert(false);
        return _refr_fwiFilterPrewittHoriz_8u_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize);
    }
}

OREFR OSSE2 FwStatus STDCALL fwiResizeCenter_8u_C4R( const Fw8u* pSrc, FwiSize srcSize, int srcStep, FwiRect srcRoi,
								  Fw8u* pDst, int dstStep, FwiSize dstRoiSize,
							      double xFactor, double yFactor, double xCenter, double yCenter, int interpolation )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiResizeCenter_8u_C4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoiSize, xFactor, yFactor, xCenter, yCenter, interpolation);
    case DT_REFR:
        return _refr_fwiResizeCenter_8u_C4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoiSize, xFactor, yFactor, xCenter, yCenter, interpolation);
    default:
        assert(false);
        return _refr_fwiResizeCenter_8u_C4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoiSize, xFactor, yFactor, xCenter, yCenter, interpolation);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiMirror_32s_C3IR(Fw32s *pSrcDst, int srcDstStep, FwiSize roiSize, FwiAxis flip)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiMirror_32s_C3IR(pSrcDst, srcDstStep, roiSize, flip);
    case DT_REFR:
        return _refr_fwiMirror_32s_C3IR(pSrcDst, srcDstStep, roiSize, flip);
    default:
        assert(false);
        return _refr_fwiMirror_32s_C3IR(pSrcDst, srcDstStep, roiSize, flip);
    }
}


OREFR OSSE2 FwStatus STDCALL fwiWarpAffine_8u_C1R( const Fw8u* pSrc, FwiSize srcSize, int srcStep,
								FwiRect srcRoi, Fw8u* pDst, int dstStep, FwiRect dstRoi,
								const double coeffs[2][3], int interpolation )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiWarpAffine_8u_C1R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, coeffs, interpolation);
    case DT_REFR:
        return _refr_fwiWarpAffine_8u_C1R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, coeffs, interpolation);
    default:
        assert(false);
        return _refr_fwiWarpAffine_8u_C1R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, coeffs, interpolation);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiConvert_16s32f_C3R( const Fw16s *pSrc, int srcStep, Fw32f *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiConvert_16s32f_C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiConvert_16s32f_C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiConvert_16s32f_C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiConvert_16s32f_C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR               FwStatus fwiHSVToRGB_8u_AC4R( const Fw8u *pSrc, int srcStep, Fw8u *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiHSVToRGB_8u_AC4R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiHSVToRGB_8u_AC4R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiCopy_8u_P3C3R( const Fw8u * const pSrc[3], int srcStep, Fw8u *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiCopy_8u_P3C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiCopy_8u_P3C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiCopy_8u_P3C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiCopy_8u_P3C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiCopy_16s_C3R( const Fw16s *pSrc, int srcStep, Fw16s *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiCopy_16s_C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiCopy_16s_C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiCopy_16s_C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiCopy_16s_C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiFilterSobelHoriz_16s_C4R( const Fw16s * pSrc, int srcStep, Fw16s * pDst, int dstStep, FwiSize dstRoiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilterSobelHoriz_16s_C4R(pSrc, srcStep, pDst, dstStep, dstRoiSize);
    case DT_REFR:
        return _refr_fwiFilterSobelHoriz_16s_C4R(pSrc, srcStep, pDst, dstStep, dstRoiSize);
    default:
        assert(false);
        return _refr_fwiFilterSobelHoriz_16s_C4R(pSrc, srcStep, pDst, dstStep, dstRoiSize);
    }
}

OREFR             FwStatus STDCALL fwiScale_8u32s_C3R( const Fw8u * pSrc, int srcStep, Fw32s * pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiScale_8u32s_C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiScale_8u32s_C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}


OREFR               FwStatus fwiHSVToRGB_8u_C3R( const Fw8u *pSrc, int srcStep, Fw8u *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiHSVToRGB_8u_C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiHSVToRGB_8u_C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiFilterScharrHoriz_32f_C1R( const Fw32f * pSrc, int srcStep, Fw32f * pDst, int dstStep, FwiSize dstRoiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilterScharrHoriz_32f_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize);
    case DT_REFR:
        return _refr_fwiFilterScharrHoriz_32f_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize);
    default:
        assert(false);
        return _refr_fwiFilterScharrHoriz_32f_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiThreshold_Val_32f_C3R( const Fw32f *pSrc, int srcStep, Fw32f *pDst, int dstStep, FwiSize roiSize, const Fw32f threshold[3], const Fw32f value[3], FwCmpOp fwCmpOp)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiThreshold_Val_32f_C3R(pSrc, srcStep, pDst, dstStep, roiSize, threshold, value, fwCmpOp);
    case DT_SSE2:
        return _sse2_fwiThreshold_Val_32f_C3R(pSrc, srcStep, pDst, dstStep, roiSize, threshold, value, fwCmpOp);
    case DT_REFR:
        return _refr_fwiThreshold_Val_32f_C3R(pSrc, srcStep, pDst, dstStep, roiSize, threshold, value, fwCmpOp);
    default:
        assert(false);
        return _refr_fwiThreshold_Val_32f_C3R(pSrc, srcStep, pDst, dstStep, roiSize, threshold, value, fwCmpOp);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiSet_32f_C1R(       Fw32f  value,    Fw32f  * pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiSet_32f_C1R(value, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiSet_32f_C1R(value, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiSet_32f_C1R(value, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiSet_32f_C1R(value, pDst, dstStep, roiSize);
    }
}

OREFR               FwStatus fwiRGBToCbYCr422Gamma_8u_C3C2R(const A8U* pSrc, int srcStep, A8U* pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiRGBToCbYCr422Gamma_8u_C3C2R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiRGBToCbYCr422Gamma_8u_C3C2R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiAddC_32sc_AC4IRSfs( const Fw32sc value[3], Fw32sc *pSrcDst, int srcDstStep, FwiSize roiSize, int scaleFactor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiAddC_32sc_AC4IRSfs(value, pSrcDst, srcDstStep, roiSize, scaleFactor);
    case DT_SSE2:
        return _sse2_fwiAddC_32sc_AC4IRSfs(value, pSrcDst, srcDstStep, roiSize, scaleFactor);
    case DT_REFR:
        return _refr_fwiAddC_32sc_AC4IRSfs(value, pSrcDst, srcDstStep, roiSize, scaleFactor);
    default:
        assert(false);
        return _refr_fwiAddC_32sc_AC4IRSfs(value, pSrcDst, srcDstStep, roiSize, scaleFactor);
    }
}

OREFR               FwStatus fwiXYZToRGB_16u_C3R( const Fw16u* pSrc, int srcStep, Fw16u* pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiXYZToRGB_16u_C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiXYZToRGB_16u_C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiSwapChannels_32s_AC4R(const Fw32s *pSrc,int srcStep, Fw32s *pDst, int dstStep, FwiSize roiSize,const int dstOrder[3])
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiSwapChannels_32s_AC4R(pSrc, srcStep, pDst, dstStep, roiSize, dstOrder);
    case DT_SSE2:
        return _sse2_fwiSwapChannels_32s_AC4R(pSrc, srcStep, pDst, dstStep, roiSize, dstOrder);
    case DT_REFR:
        return _refr_fwiSwapChannels_32s_AC4R(pSrc, srcStep, pDst, dstStep, roiSize, dstOrder);
    default:
        assert(false);
        return _refr_fwiSwapChannels_32s_AC4R(pSrc, srcStep, pDst, dstStep, roiSize, dstOrder);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiThreshold_LTValGTVal_16s_C3R( const Fw16s *pSrc, int srcStep, Fw16s *pDst, int dstStep, FwiSize roiSize, const Fw16s thresholdLT[3], const Fw16s valueLT[3], const Fw16s thresholdGT[3], const Fw16s valueGT[3])
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiThreshold_LTValGTVal_16s_C3R(pSrc, srcStep, pDst, dstStep, roiSize, thresholdLT, valueLT, thresholdGT, valueGT);
    case DT_SSE2:
        return _sse2_fwiThreshold_LTValGTVal_16s_C3R(pSrc, srcStep, pDst, dstStep, roiSize, thresholdLT, valueLT, thresholdGT, valueGT);
    case DT_REFR:
        return _refr_fwiThreshold_LTValGTVal_16s_C3R(pSrc, srcStep, pDst, dstStep, roiSize, thresholdLT, valueLT, thresholdGT, valueGT);
    default:
        assert(false);
        return _refr_fwiThreshold_LTValGTVal_16s_C3R(pSrc, srcStep, pDst, dstStep, roiSize, thresholdLT, valueLT, thresholdGT, valueGT);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiThreshold_Val_16s_AC4R( const Fw16s *pSrc, int srcStep, Fw16s *pDst, int dstStep, FwiSize roiSize, const Fw16s threshold[3], const Fw16s value[3], FwCmpOp fwCmpOp)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiThreshold_Val_16s_AC4R(pSrc, srcStep, pDst, dstStep, roiSize, threshold, value, fwCmpOp);
    case DT_SSE2:
        return _sse2_fwiThreshold_Val_16s_AC4R(pSrc, srcStep, pDst, dstStep, roiSize, threshold, value, fwCmpOp);
    case DT_REFR:
        return _refr_fwiThreshold_Val_16s_AC4R(pSrc, srcStep, pDst, dstStep, roiSize, threshold, value, fwCmpOp);
    default:
        assert(false);
        return _refr_fwiThreshold_Val_16s_AC4R(pSrc, srcStep, pDst, dstStep, roiSize, threshold, value, fwCmpOp);
    }
}


OREFR OSSE2       FwStatus STDCALL fwiFilterLowpass_8u_C1R( const Fw8u * pSrc, int srcStep, Fw8u * pDst, int dstStep, FwiSize dstRoiSize, FwiMaskSize maskSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilterLowpass_8u_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize);
    case DT_REFR:
        return _refr_fwiFilterLowpass_8u_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize);
    default:
        assert(false);
        return _refr_fwiFilterLowpass_8u_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize);
    }
}

OREFR OSSE2         FwStatus fwiMin_16s_C4R(const Fw16s* pSrc, int srcStep,FwiSize roiSize, Fw16s min[4])
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiMin_16s_C4R(pSrc, srcStep, roiSize, min);
    case DT_REFR:
        return _refr_fwiMin_16s_C4R(pSrc, srcStep, roiSize, min);
    default:
        assert(false);
        return _refr_fwiMin_16s_C4R(pSrc, srcStep, roiSize, min);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiConvert_32f16s_AC4R( const Fw32f *pSrc, int srcStep, Fw16s *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiConvert_32f16s_AC4R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiConvert_32f16s_AC4R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiConvert_32f16s_AC4R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiConvert_32f16s_AC4R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiDiv_32sc_C1IRSfs( const Fw32sc *pSrc,  int srcStep,        Fw32sc *pSrcDst, int srcDstStep, FwiSize roiSize, int scaleFactor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiDiv_32sc_C1IRSfs(pSrc, srcStep, pSrcDst, srcDstStep, roiSize, scaleFactor);
    case DT_SSE2:
        return _sse2_fwiDiv_32sc_C1IRSfs(pSrc, srcStep, pSrcDst, srcDstStep, roiSize, scaleFactor);
    case DT_REFR:
        return _refr_fwiDiv_32sc_C1IRSfs(pSrc, srcStep, pSrcDst, srcDstStep, roiSize, scaleFactor);
    default:
        assert(false);
        return _refr_fwiDiv_32sc_C1IRSfs(pSrc, srcStep, pSrcDst, srcDstStep, roiSize, scaleFactor);
    }
}

OREFR OSSE2         FwStatus fwiMinMax_32f_AC4R(const Fw32f* pSrc, int srcStep,FwiSize roiSize, Fw32f min[3], Fw32f max[3])
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiMinMax_32f_AC4R(pSrc, srcStep, roiSize, min, max);
    case DT_REFR:
        return _refr_fwiMinMax_32f_AC4R(pSrc, srcStep, roiSize, min, max);
    default:
        assert(false);
        return _refr_fwiMinMax_32f_AC4R(pSrc, srcStep, roiSize, min, max);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiMulC_16sc_C1IRSfs(       Fw16sc value,    Fw16sc *pSrcDst, int srcDstStep, FwiSize roiSize, int scaleFactor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiMulC_16sc_C1IRSfs(value, pSrcDst, srcDstStep, roiSize, scaleFactor);
    case DT_SSE2:
        return _sse2_fwiMulC_16sc_C1IRSfs(value, pSrcDst, srcDstStep, roiSize, scaleFactor);
    case DT_REFR:
        return _refr_fwiMulC_16sc_C1IRSfs(value, pSrcDst, srcDstStep, roiSize, scaleFactor);
    default:
        assert(false);
        return _refr_fwiMulC_16sc_C1IRSfs(value, pSrcDst, srcDstStep, roiSize, scaleFactor);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiFilterRobertsUp_32f_C3R( const Fw32f * pSrc, int srcStep, Fw32f * pDst, int dstStep, FwiSize dstRoiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilterRobertsUp_32f_C3R(pSrc, srcStep, pDst, dstStep, dstRoiSize);
    case DT_REFR:
        return _refr_fwiFilterRobertsUp_32f_C3R(pSrc, srcStep, pDst, dstStep, dstRoiSize);
    default:
        assert(false);
        return _refr_fwiFilterRobertsUp_32f_C3R(pSrc, srcStep, pDst, dstStep, dstRoiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiSubC_32sc_C1IRSfs(       Fw32sc value,    Fw32sc *pSrcDst, int srcDstStep, FwiSize roiSize, int scaleFactor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiSubC_32sc_C1IRSfs(value, pSrcDst, srcDstStep, roiSize, scaleFactor);
    case DT_SSE2:
        return _sse2_fwiSubC_32sc_C1IRSfs(value, pSrcDst, srcDstStep, roiSize, scaleFactor);
    case DT_REFR:
        return _refr_fwiSubC_32sc_C1IRSfs(value, pSrcDst, srcDstStep, roiSize, scaleFactor);
    default:
        assert(false);
        return _refr_fwiSubC_32sc_C1IRSfs(value, pSrcDst, srcDstStep, roiSize, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiThreshold_GT_8u_C1IR( Fw8u *pSrcDst, int srcDstStep, FwiSize roiSize, Fw8u threshold)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiThreshold_GT_8u_C1IR(pSrcDst, srcDstStep, roiSize, threshold);
    case DT_SSE2:
        return _sse2_fwiThreshold_GT_8u_C1IR(pSrcDst, srcDstStep, roiSize, threshold);
    case DT_REFR:
        return _refr_fwiThreshold_GT_8u_C1IR(pSrcDst, srcDstStep, roiSize, threshold);
    default:
        assert(false);
        return _refr_fwiThreshold_GT_8u_C1IR(pSrcDst, srcDstStep, roiSize, threshold);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiOr_32s_C4R( const Fw32s *pSrc1, int src1Step, const Fw32s *pSrc2,   int src2Step, Fw32s *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiOr_32s_C4R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiOr_32s_C4R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiOr_32s_C4R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiOr_32s_C4R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiSqrt_32f_AC4IR(       Fw32f *pSrcDst, int srcDstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiSqrt_32f_AC4IR(pSrcDst, srcDstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiSqrt_32f_AC4IR(pSrcDst, srcDstStep, roiSize);
    case DT_REFR:
        return _refr_fwiSqrt_32f_AC4IR(pSrcDst, srcDstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiSqrt_32f_AC4IR(pSrcDst, srcDstStep, roiSize);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiFilterMax_32f_C4R( const Fw32f * pSrc, int srcStep,
                               Fw32f * pDst, int dstStep, FwiSize dstRoiSize,
                               FwiSize maskSize, FwiPoint anchor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilterMax_32f_C4R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize, anchor);
    case DT_REFR:
        return _refr_fwiFilterMax_32f_C4R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize, anchor);
    default:
        assert(false);
        return _refr_fwiFilterMax_32f_C4R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize, anchor);
    }
}


OREFR OSSE2         FwStatus fwiMinMax_8u_C1R(const Fw8u* pSrc, int srcStep,FwiSize roiSize, Fw8u* pMin,Fw8u* pMax)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiMinMax_8u_C1R(pSrc, srcStep, roiSize, pMin, pMax);
    case DT_REFR:
        return _refr_fwiMinMax_8u_C1R(pSrc, srcStep, roiSize, pMin, pMax);
    default:
        assert(false);
        return _refr_fwiMinMax_8u_C1R(pSrc, srcStep, roiSize, pMin, pMax);
    }
}

OREFR       FwStatus STDCALL fwiResizeSqrPixel_32f_C3R(const Fw32f* pSrc, FwiSize srcSize, int srcStep, FwiRect srcRoi,
			Fw32f* pDst, int dstStep, FwiRect dstRoi, double xFactor, double yFactor,
			double xShift, double yShift, int interpolation, Fw8u* pBuffer)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiResizeSqrPixel_32f_C3R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, xFactor, yFactor, xShift, yShift, interpolation, pBuffer);
    default:
        assert(false);
        return _refr_fwiResizeSqrPixel_32f_C3R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, xFactor, yFactor, xShift, yShift, interpolation, pBuffer);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiFilterRow32f_8u_C3R( const Fw8u * pSrc, int srcStep,
                                Fw8u * pDst, int dstStep, FwiSize dstRoiSize,
                                const Fw32f * pKernel, int kernelSize,
                                int xAnchor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilterRow32f_8u_C3R(pSrc, srcStep, pDst, dstStep, dstRoiSize, pKernel, kernelSize, xAnchor);
    case DT_REFR:
        return _refr_fwiFilterRow32f_8u_C3R(pSrc, srcStep, pDst, dstStep, dstRoiSize, pKernel, kernelSize, xAnchor);
    default:
        assert(false);
        return _refr_fwiFilterRow32f_8u_C3R(pSrc, srcStep, pDst, dstStep, dstRoiSize, pKernel, kernelSize, xAnchor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiAdd_32f_C3R( const Fw32f  *pSrc1, int src1Step, const Fw32f  *pSrc2,   int src2Step, Fw32f *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiAdd_32f_C3R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiAdd_32f_C3R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiAdd_32f_C3R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiAdd_32f_C3R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiMulCScale_8u_C4IR( const Fw8u value[4], Fw8u *pSrcDst, int srcDstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiMulCScale_8u_C4IR(value, pSrcDst, srcDstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiMulCScale_8u_C4IR(value, pSrcDst, srcDstStep, roiSize);
    case DT_REFR:
        return _refr_fwiMulCScale_8u_C4IR(value, pSrcDst, srcDstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiMulCScale_8u_C4IR(value, pSrcDst, srcDstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiThreshold_Val_8u_C3IR( Fw8u *pSrcDst, int srcDstStep, FwiSize roiSize, const Fw8u threshold[3], const Fw8u value[3], FwCmpOp fwCmpOp)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiThreshold_Val_8u_C3IR(pSrcDst, srcDstStep, roiSize, threshold, value, fwCmpOp);
    case DT_SSE2:
        return _sse2_fwiThreshold_Val_8u_C3IR(pSrcDst, srcDstStep, roiSize, threshold, value, fwCmpOp);
    case DT_REFR:
        return _refr_fwiThreshold_Val_8u_C3IR(pSrcDst, srcDstStep, roiSize, threshold, value, fwCmpOp);
    default:
        assert(false);
        return _refr_fwiThreshold_Val_8u_C3IR(pSrcDst, srcDstStep, roiSize, threshold, value, fwCmpOp);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiSub_32f_C1IR( const Fw32f  *pSrc,  int srcStep,        Fw32f  *pSrcDst, int srcDstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiSub_32f_C1IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiSub_32f_C1IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    case DT_REFR:
        return _refr_fwiSub_32f_C1IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiSub_32f_C1IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiXor_8u_C1IR( const Fw8u	*pSrc,  int srcStep,        Fw8u *pSrcDst, int srcDstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiXor_8u_C1IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiXor_8u_C1IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    case DT_REFR:
        return _refr_fwiXor_8u_C1IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiXor_8u_C1IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiAddC_32f_C3R( const Fw32f *pSrc, int srcStep,const Fw32f value[3], Fw32f *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiAddC_32f_C3R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiAddC_32f_C3R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiAddC_32f_C3R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiAddC_32f_C3R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiSet_32f_AC4R( const Fw32f  value[3], Fw32f  * pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiSet_32f_AC4R(value, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiSet_32f_AC4R(value, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiSet_32f_AC4R(value, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiSet_32f_AC4R(value, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiDivC_32f_AC4R( const Fw32f *pSrc, int srcStep, const Fw32f value[3], Fw32f *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiDivC_32f_AC4R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiDivC_32f_AC4R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiDivC_32f_AC4R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiDivC_32f_AC4R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 FwStatus STDCALL fwiWarpAffineBack_16u_P3R( const Fw16u* const pSrc[3], FwiSize srcSize, int srcStep,
								FwiRect srcRoi, Fw16u* const pDst[3], int dstStep, FwiRect dstRoi,
								const double coeffs[2][3], int interpolation )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiWarpAffineBack_16u_P3R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, coeffs, interpolation);
    case DT_REFR:
        return _refr_fwiWarpAffineBack_16u_P3R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, coeffs, interpolation);
    default:
        assert(false);
        return _refr_fwiWarpAffineBack_16u_P3R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, coeffs, interpolation);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiFilterColumn_16s_C1R( const Fw16s * pSrc, int srcStep,
                              Fw16s * pDst, int dstStep, FwiSize dstRoiSize,
                              const Fw32s * pKernel, int kernelSize,
                              int yAnchor, int divisor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilterColumn_16s_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize, pKernel, kernelSize, yAnchor, divisor);
    case DT_REFR:
        return _refr_fwiFilterColumn_16s_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize, pKernel, kernelSize, yAnchor, divisor);
    default:
        assert(false);
        return _refr_fwiFilterColumn_16s_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize, pKernel, kernelSize, yAnchor, divisor);
    }
}

OREFR             FwStatus STDCALL fwiScale_8u16u_AC4R( const Fw8u * pSrc, int srcStep, Fw16u * pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiScale_8u16u_AC4R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiScale_8u16u_AC4R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiXorC_8u_AC4R( const Fw8u   *pSrc, int srcStep, const Fw8u value[3], Fw8u *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiXorC_8u_AC4R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiXorC_8u_AC4R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiXorC_8u_AC4R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiXorC_8u_AC4R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 FwStatus STDCALL fwiResizeShift_32f_P3R( const Fw32f* const pSrc[3], FwiSize srcSize, int srcStep, FwiRect srcRoi,
								  Fw32f* const pDst[3], int dstStep, FwiSize dstRoiSize,
								  double xFr, double yFr, double xShift, double yShift, int interpolation )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiResizeShift_32f_P3R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoiSize, xFr, yFr, xShift, yShift, interpolation);
    case DT_REFR:
        return _refr_fwiResizeShift_32f_P3R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoiSize, xFr, yFr, xShift, yShift, interpolation);
    default:
        assert(false);
        return _refr_fwiResizeShift_32f_P3R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoiSize, xFr, yFr, xShift, yShift, interpolation);
    }
}


OREFR OSSE2         FwStatus fwiSum_8u_C3R(const Fw8u* pSrc, int srcStep,FwiSize roiSize, Fw64f sum[3])
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiSum_8u_C3R(pSrc, srcStep, roiSize, sum);
    case DT_REFR:
        return _refr_fwiSum_8u_C3R(pSrc, srcStep, roiSize, sum);
    default:
        assert(false);
        return _refr_fwiSum_8u_C3R(pSrc, srcStep, roiSize, sum);
    }
}

OREFR OSSE2 FwStatus STDCALL fwiResize_16u_AC4R( const Fw16u* pSrc, FwiSize srcSize, int srcStep, FwiRect srcRoi,
							  Fw16u* pDst, int dstStep, FwiSize dstRoiSize,
							  double xFactor, double yFactor, int interpolation )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiResize_16u_AC4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoiSize, xFactor, yFactor, interpolation);
    case DT_REFR:
        return _refr_fwiResize_16u_AC4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoiSize, xFactor, yFactor, interpolation);
    default:
        assert(false);
        return _refr_fwiResize_16u_AC4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoiSize, xFactor, yFactor, interpolation);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiMulC_16s_C4RSfs( const Fw16s *pSrc, int srcStep, const Fw16s value[4], Fw16s *pDst, int dstStep, FwiSize roiSize, int scaleFactor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiMulC_16s_C4RSfs(pSrc, srcStep, value, pDst, dstStep, roiSize, scaleFactor);
    case DT_SSE2:
        return _sse2_fwiMulC_16s_C4RSfs(pSrc, srcStep, value, pDst, dstStep, roiSize, scaleFactor);
    case DT_REFR:
        return _refr_fwiMulC_16s_C4RSfs(pSrc, srcStep, value, pDst, dstStep, roiSize, scaleFactor);
    default:
        assert(false);
        return _refr_fwiMulC_16s_C4RSfs(pSrc, srcStep, value, pDst, dstStep, roiSize, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiMul_16s_C4RSfs( const Fw16s  *pSrc1, int src1Step, const Fw16s  *pSrc2,   int src2Step, Fw16s *pDst, int dstStep, FwiSize roiSize, int scaleFactor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiMul_16s_C4RSfs(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, scaleFactor);
    case DT_SSE2:
        return _sse2_fwiMul_16s_C4RSfs(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, scaleFactor);
    case DT_REFR:
        return _refr_fwiMul_16s_C4RSfs(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, scaleFactor);
    default:
        assert(false);
        return _refr_fwiMul_16s_C4RSfs(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiMul_8u_AC4IRSfs( const Fw8u   *pSrc,  int srcStep,        Fw8u   *pSrcDst, int srcDstStep, FwiSize roiSize, int scaleFactor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiMul_8u_AC4IRSfs(pSrc, srcStep, pSrcDst, srcDstStep, roiSize, scaleFactor);
    case DT_SSE2:
        return _sse2_fwiMul_8u_AC4IRSfs(pSrc, srcStep, pSrcDst, srcDstStep, roiSize, scaleFactor);
    case DT_REFR:
        return _refr_fwiMul_8u_AC4IRSfs(pSrc, srcStep, pSrcDst, srcDstStep, roiSize, scaleFactor);
    default:
        assert(false);
        return _refr_fwiMul_8u_AC4IRSfs(pSrc, srcStep, pSrcDst, srcDstStep, roiSize, scaleFactor);
    }
}

OREFR OSSE2 FwStatus STDCALL fwiWarpPerspective_8u_P3R( const Fw8u* const pSrc[3], FwiSize srcSize, int srcStep,
								FwiRect srcRoi, Fw8u* const pDst[3], int dstStep, FwiRect dstRoi,
								const double coeffs[3][3], int interpolation )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiWarpPerspective_8u_P3R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, coeffs, interpolation);
    case DT_REFR:
        return _refr_fwiWarpPerspective_8u_P3R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, coeffs, interpolation);
    default:
        assert(false);
        return _refr_fwiWarpPerspective_8u_P3R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, coeffs, interpolation);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiFilterMedianHoriz_16s_C1R( const Fw16s * pSrc, int srcStep,
                                               Fw16s * pDst, int dstStep, FwiSize dstRoiSize,
                                               FwiMaskSize maskSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilterMedianHoriz_16s_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize);
    case DT_REFR:
        return _refr_fwiFilterMedianHoriz_16s_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize);
    default:
        assert(false);
        return _refr_fwiFilterMedianHoriz_16s_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiThreshold_LTValGTVal_16s_C1IR( Fw16s *pSrcDst, int srcDstStep, FwiSize roiSize, Fw16s thresholdLT, Fw16s valueLT, Fw16s thresholdGT, Fw16s valueGT)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiThreshold_LTValGTVal_16s_C1IR(pSrcDst, srcDstStep, roiSize, thresholdLT, valueLT, thresholdGT, valueGT);
    case DT_SSE2:
        return _sse2_fwiThreshold_LTValGTVal_16s_C1IR(pSrcDst, srcDstStep, roiSize, thresholdLT, valueLT, thresholdGT, valueGT);
    case DT_REFR:
        return _refr_fwiThreshold_LTValGTVal_16s_C1IR(pSrcDst, srcDstStep, roiSize, thresholdLT, valueLT, thresholdGT, valueGT);
    default:
        assert(false);
        return _refr_fwiThreshold_LTValGTVal_16s_C1IR(pSrcDst, srcDstStep, roiSize, thresholdLT, valueLT, thresholdGT, valueGT);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiSumWindowColumn_8u32f_C4R( const Fw8u * pSrc, int srcStep,
                               Fw32f * pDst, int dstStep, FwiSize dstRoiSize,
                               int maskSize, int anchor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiSumWindowColumn_8u32f_C4R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize, anchor);
    case DT_REFR:
        return _refr_fwiSumWindowColumn_8u32f_C4R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize, anchor);
    default:
        assert(false);
        return _refr_fwiSumWindowColumn_8u32f_C4R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize, anchor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiDiv_32f_C3R( const Fw32f  *pSrc1, int src1Step, const Fw32f  *pSrc2,   int src2Step, Fw32f  *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiDiv_32f_C3R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiDiv_32f_C3R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiDiv_32f_C3R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiDiv_32f_C3R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiRotateCenter_32f_AC4R( const Fw32f* pSrc,FwiSize srcSize, int srcStep, FwiRect srcRoi, Fw32f* pDst, int dstStep, FwiRect dstRoi, double angle, double xCenter, double yCenter, int interpolation )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiRotateCenter_32f_AC4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, angle, xCenter, yCenter, interpolation);
    case DT_REFR:
        return _refr_fwiRotateCenter_32f_AC4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, angle, xCenter, yCenter, interpolation);
    default:
        assert(false);
        return _refr_fwiRotateCenter_32f_AC4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, angle, xCenter, yCenter, interpolation);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiMulScale_8u_AC4IR(  const Fw8u  *pSrc,  int srcStep,        Fw8u  *pSrcDst, int srcDstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiMulScale_8u_AC4IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiMulScale_8u_AC4IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    case DT_REFR:
        return _refr_fwiMulScale_8u_AC4IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiMulScale_8u_AC4IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    }
}


OREFR OSSE2 FwStatus STDCALL fwiResizeYUV422_8u_C2R( const Fw8u* pSrc, FwiSize srcSize,
								  int srcStep, FwiRect srcRoi, Fw8u* pDst, int dstStep, FwiSize dstRoiSize,
								  double xFactor, double yFactor, int interpolation )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiResizeYUV422_8u_C2R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoiSize, xFactor, yFactor, interpolation);
    case DT_REFR:
        return _refr_fwiResizeYUV422_8u_C2R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoiSize, xFactor, yFactor, interpolation);
    default:
        assert(false);
        return _refr_fwiResizeYUV422_8u_C2R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoiSize, xFactor, yFactor, interpolation);
    }
}


OREFR OSSE2       FwStatus STDCALL fwiSumWindowColumn_8u32f_C1R( const Fw8u * pSrc, int srcStep,
                               Fw32f * pDst, int dstStep, FwiSize dstRoiSize,
                               int maskSize, int anchor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiSumWindowColumn_8u32f_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize, anchor);
    case DT_REFR:
        return _refr_fwiSumWindowColumn_8u32f_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize, anchor);
    default:
        assert(false);
        return _refr_fwiSumWindowColumn_8u32f_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize, anchor);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiFilterSobelHorizSecond_8s16s_C1R( const Fw8s * pSrc, int srcStep, Fw16s * pDst, int dstStep, FwiSize dstRoiSize, FwiMaskSize mask )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilterSobelHorizSecond_8s16s_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize, mask);
    case DT_REFR:
        return _refr_fwiFilterSobelHorizSecond_8s16s_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize, mask);
    default:
        assert(false);
        return _refr_fwiFilterSobelHorizSecond_8s16s_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize, mask);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiThreshold_Val_16s_C3IR( Fw16s *pSrcDst, int srcDstStep, FwiSize roiSize, const Fw16s threshold[3], const Fw16s value[3], FwCmpOp fwCmpOp)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiThreshold_Val_16s_C3IR(pSrcDst, srcDstStep, roiSize, threshold, value, fwCmpOp);
    case DT_SSE2:
        return _sse2_fwiThreshold_Val_16s_C3IR(pSrcDst, srcDstStep, roiSize, threshold, value, fwCmpOp);
    case DT_REFR:
        return _refr_fwiThreshold_Val_16s_C3IR(pSrcDst, srcDstStep, roiSize, threshold, value, fwCmpOp);
    default:
        assert(false);
        return _refr_fwiThreshold_Val_16s_C3IR(pSrcDst, srcDstStep, roiSize, threshold, value, fwCmpOp);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiDivC_16s_AC4RSfs( const Fw16s *pSrc, int srcStep, const Fw16s value[3], Fw16s *pDst, int dstStep, FwiSize roiSize, int scaleFactor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiDivC_16s_AC4RSfs(pSrc, srcStep, value, pDst, dstStep, roiSize, scaleFactor);
    case DT_SSE2:
        return _sse2_fwiDivC_16s_AC4RSfs(pSrc, srcStep, value, pDst, dstStep, roiSize, scaleFactor);
    case DT_REFR:
        return _refr_fwiDivC_16s_AC4RSfs(pSrc, srcStep, value, pDst, dstStep, roiSize, scaleFactor);
    default:
        assert(false);
        return _refr_fwiDivC_16s_AC4RSfs(pSrc, srcStep, value, pDst, dstStep, roiSize, scaleFactor);
    }
}

OREFR OSSE2 FwStatus STDCALL fwiWarpPerspectiveQuad_32f_C3R( const Fw32f* pSrc, FwiSize srcSize, int srcStep, FwiRect srcRoi,
							        const double srcQuad[4][2], Fw32f* pDst, int dstStep, FwiRect dstRoi,
									const double dstQuad[4][2], int interpolation )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiWarpPerspectiveQuad_32f_C3R(pSrc, srcSize, srcStep, srcRoi, srcQuad, pDst, dstStep, dstRoi, dstQuad, interpolation);
    case DT_REFR:
        return _refr_fwiWarpPerspectiveQuad_32f_C3R(pSrc, srcSize, srcStep, srcRoi, srcQuad, pDst, dstStep, dstRoi, dstQuad, interpolation);
    default:
        assert(false);
        return _refr_fwiWarpPerspectiveQuad_32f_C3R(pSrc, srcSize, srcStep, srcRoi, srcQuad, pDst, dstStep, dstRoi, dstQuad, interpolation);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiNot_8u_C1R( const Fw8u   *pSrc, int srcStep,    Fw8u *pDst, int dstStep, FwiSize roiSize)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiNot_8u_C1R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiNot_8u_C1R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiNot_8u_C1R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiNot_8u_C1R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiAbs_16s_C4IR( Fw16s *pSrcDst, int srcDstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiAbs_16s_C4IR(pSrcDst, srcDstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiAbs_16s_C4IR(pSrcDst, srcDstStep, roiSize);
    case DT_REFR:
        return _refr_fwiAbs_16s_C4IR(pSrcDst, srcDstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiAbs_16s_C4IR(pSrcDst, srcDstStep, roiSize);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiFilterLowpass_8u_C3R( const Fw8u * pSrc, int srcStep, Fw8u * pDst, int dstStep, FwiSize dstRoiSize, FwiMaskSize maskSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilterLowpass_8u_C3R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize);
    case DT_REFR:
        return _refr_fwiFilterLowpass_8u_C3R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize);
    default:
        assert(false);
        return _refr_fwiFilterLowpass_8u_C3R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize);
    }
}


OREFR OSSE2 OF10H   FwStatus fwiYUVToRGB_8u_C3R( const Fw8u *pSrc, int srcStep, Fw8u *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiYUVToRGB_8u_C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiYUVToRGB_8u_C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiYUVToRGB_8u_C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiYUVToRGB_8u_C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiMulC_8u_AC4RSfs( const Fw8u *pSrc, int srcStep, const Fw8u value[3], Fw8u *pDst, int dstStep, FwiSize roiSize, int scaleFactor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiMulC_8u_AC4RSfs(pSrc, srcStep, value, pDst, dstStep, roiSize, scaleFactor);
    case DT_SSE2:
        return _sse2_fwiMulC_8u_AC4RSfs(pSrc, srcStep, value, pDst, dstStep, roiSize, scaleFactor);
    case DT_REFR:
        return _refr_fwiMulC_8u_AC4RSfs(pSrc, srcStep, value, pDst, dstStep, roiSize, scaleFactor);
    default:
        assert(false);
        return _refr_fwiMulC_8u_AC4RSfs(pSrc, srcStep, value, pDst, dstStep, roiSize, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiMulCScale_16u_C3R( const Fw16u *pSrc, int srcStep, const Fw16u value[3], Fw16u *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiMulCScale_16u_C3R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiMulCScale_16u_C3R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiMulCScale_16u_C3R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiMulCScale_16u_C3R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    }
}

OREFR       FwStatus STDCALL fwiWarpBilinearBack_8u_P4R(const Fw8u* const pSrc[4], FwiSize srcSize, int srcStep,
								FwiRect srcRoi, Fw8u* const pDst[4], int dstStep, FwiRect dstRoi,
								const double coeffs[2][4], int interpolation)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiWarpBilinearBack_8u_P4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, coeffs, interpolation);
    default:
        assert(false);
        return _refr_fwiWarpBilinearBack_8u_P4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, coeffs, interpolation);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiThreshold_Val_32f_AC4R( const Fw32f *pSrc, int srcStep, Fw32f *pDst, int dstStep, FwiSize roiSize, const Fw32f threshold[3], const Fw32f value[3], FwCmpOp fwCmpOp)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiThreshold_Val_32f_AC4R(pSrc, srcStep, pDst, dstStep, roiSize, threshold, value, fwCmpOp);
    case DT_SSE2:
        return _sse2_fwiThreshold_Val_32f_AC4R(pSrc, srcStep, pDst, dstStep, roiSize, threshold, value, fwCmpOp);
    case DT_REFR:
        return _refr_fwiThreshold_Val_32f_AC4R(pSrc, srcStep, pDst, dstStep, roiSize, threshold, value, fwCmpOp);
    default:
        assert(false);
        return _refr_fwiThreshold_Val_32f_AC4R(pSrc, srcStep, pDst, dstStep, roiSize, threshold, value, fwCmpOp);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiFilterSobelHorizMask_32f_C1R( const Fw32f * pSrc, int srcStep, Fw32f * pDst, int dstStep, FwiSize dstRoiSize, FwiMaskSize mask )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilterSobelHorizMask_32f_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize, mask);
    case DT_REFR:
        return _refr_fwiFilterSobelHorizMask_32f_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize, mask);
    default:
        assert(false);
        return _refr_fwiFilterSobelHorizMask_32f_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize, mask);
    }
}


OREFR OSSE2       FwStatus STDCALL fwiFilterSobelCross_8u16s_C1R( const Fw8u * pSrc, int srcStep, Fw16s * pDst, int dstStep, FwiSize dstRoiSize, FwiMaskSize mask )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilterSobelCross_8u16s_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize, mask);
    case DT_REFR:
        return _refr_fwiFilterSobelCross_8u16s_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize, mask);
    default:
        assert(false);
        return _refr_fwiFilterSobelCross_8u16s_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize, mask);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiMulC_16s_AC4RSfs( const Fw16s *pSrc, int srcStep, const Fw16s value[3], Fw16s *pDst, int dstStep, FwiSize roiSize, int scaleFactor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiMulC_16s_AC4RSfs(pSrc, srcStep, value, pDst, dstStep, roiSize, scaleFactor);
    case DT_SSE2:
        return _sse2_fwiMulC_16s_AC4RSfs(pSrc, srcStep, value, pDst, dstStep, roiSize, scaleFactor);
    case DT_REFR:
        return _refr_fwiMulC_16s_AC4RSfs(pSrc, srcStep, value, pDst, dstStep, roiSize, scaleFactor);
    default:
        assert(false);
        return _refr_fwiMulC_16s_AC4RSfs(pSrc, srcStep, value, pDst, dstStep, roiSize, scaleFactor);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiFilterColumn32f_16s_C1R( const Fw16s * pSrc, int srcStep,
                                 Fw16s * pDst, int dstStep, FwiSize dstRoiSize,
                                const Fw32f * pKernel, int kernelSize,
                                int yAnchor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilterColumn32f_16s_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize, pKernel, kernelSize, yAnchor);
    case DT_REFR:
        return _refr_fwiFilterColumn32f_16s_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize, pKernel, kernelSize, yAnchor);
    default:
        assert(false);
        return _refr_fwiFilterColumn32f_16s_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize, pKernel, kernelSize, yAnchor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiSqr_16s_C3IRSfs(       Fw16s *pSrcDst, int srcDstStep, FwiSize roiSize, int scaleFactor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiSqr_16s_C3IRSfs(pSrcDst, srcDstStep, roiSize, scaleFactor);
    case DT_SSE2:
        return _sse2_fwiSqr_16s_C3IRSfs(pSrcDst, srcDstStep, roiSize, scaleFactor);
    case DT_REFR:
        return _refr_fwiSqr_16s_C3IRSfs(pSrcDst, srcDstStep, roiSize, scaleFactor);
    default:
        assert(false);
        return _refr_fwiSqr_16s_C3IRSfs(pSrcDst, srcDstStep, roiSize, scaleFactor);
    }
}

OREFR               FwStatus fwiYCbCr420ToRGB565_8u16u_P3C3R(const A8U* const pSrc[3], int srcStep[3], A16U* pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiYCbCr420ToRGB565_8u16u_P3C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiYCbCr420ToRGB565_8u16u_P3C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiAddSquare_16u32f_C1IMR( const Fw16u *pSrc, int srcStep, const Fw8u* pMask, int maskStep, Fw32f* pSrcDst, int srcDstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiAddSquare_16u32f_C1IMR(pSrc, srcStep, pMask, maskStep, pSrcDst, srcDstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiAddSquare_16u32f_C1IMR(pSrc, srcStep, pMask, maskStep, pSrcDst, srcDstStep, roiSize);
    case DT_REFR:
        return _refr_fwiAddSquare_16u32f_C1IMR(pSrc, srcStep, pMask, maskStep, pSrcDst, srcDstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiAddSquare_16u32f_C1IMR(pSrc, srcStep, pMask, maskStep, pSrcDst, srcDstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiAnd_16u_C4R( const Fw16u *pSrc1, int src1Step, const Fw16u *pSrc2,   int src2Step, Fw16u *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiAnd_16u_C4R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiAnd_16u_C4R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiAnd_16u_C4R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiAnd_16u_C4R(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiRemap_8u_C4R( const Fw8u* pSrc, FwiSize srcSize, int srcStep, FwiRect srcRoi, const Fw32f* pxMap, int xMapStep, const Fw32f* pyMap, int yMapStep, Fw8u* pDst, int dstStep, FwiSize dstRoiSize, int interpolation )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiRemap_8u_C4R(pSrc, srcSize, srcStep, srcRoi, pxMap, xMapStep, pyMap, yMapStep, pDst, dstStep, dstRoiSize, interpolation);
    case DT_REFR:
        return _refr_fwiRemap_8u_C4R(pSrc, srcSize, srcStep, srcRoi, pxMap, xMapStep, pyMap, yMapStep, pDst, dstStep, dstRoiSize, interpolation);
    default:
        assert(false);
        return _refr_fwiRemap_8u_C4R(pSrc, srcSize, srcStep, srcRoi, pxMap, xMapStep, pyMap, yMapStep, pDst, dstStep, dstRoiSize, interpolation);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiLn_32f_C3R( const Fw32f *pSrc, int srcStep, Fw32f *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiLn_32f_C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiLn_32f_C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiLn_32f_C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiLn_32f_C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 FwStatus STDCALL fwiFilterSharpen_32f_AC4R( const Fw32f * pSrc, int srcStep, Fw32f * pDst, int dstStep, FwiSize dstRoiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilterSharpen_32f_AC4R(pSrc, srcStep, pDst, dstStep, dstRoiSize);
    case DT_REFR:
        return _refr_fwiFilterSharpen_32f_AC4R(pSrc, srcStep, pDst, dstStep, dstRoiSize);
    default:
        assert(false);
        return _refr_fwiFilterSharpen_32f_AC4R(pSrc, srcStep, pDst, dstStep, dstRoiSize);
    }
}

OREFR             FwStatus STDCALL fwiScale_8u16u_C4R( const Fw8u * pSrc, int srcStep, Fw16u * pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiScale_8u16u_C4R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiScale_8u16u_C4R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiConvert_8u16s_C4R( const Fw8u *pSrc, int srcStep, Fw16s *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiConvert_8u16s_C4R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiConvert_8u16s_C4R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiConvert_8u16s_C4R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiConvert_8u16s_C4R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiThreshold_LTVal_32f_C4IR( Fw32f *pSrcDst, int srcDstStep, FwiSize roiSize, const Fw32f threshold[4], const Fw32f value[4])
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiThreshold_LTVal_32f_C4IR(pSrcDst, srcDstStep, roiSize, threshold, value);
    case DT_SSE2:
        return _sse2_fwiThreshold_LTVal_32f_C4IR(pSrcDst, srcDstStep, roiSize, threshold, value);
    case DT_REFR:
        return _refr_fwiThreshold_LTVal_32f_C4IR(pSrcDst, srcDstStep, roiSize, threshold, value);
    default:
        assert(false);
        return _refr_fwiThreshold_LTVal_32f_C4IR(pSrcDst, srcDstStep, roiSize, threshold, value);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiFilterLaplace_32f_C1R( const Fw32f * pSrc, int srcStep, Fw32f * pDst, int dstStep, FwiSize dstRoiSize, FwiMaskSize maskSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilterLaplace_32f_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize);
    case DT_REFR:
        return _refr_fwiFilterLaplace_32f_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize);
    default:
        assert(false);
        return _refr_fwiFilterLaplace_32f_C1R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize);
    }
}

OREFR OSSE2 FwStatus STDCALL fwiWarpAffine_16u_AC4R( const Fw16u* pSrc, FwiSize srcSize, int srcStep,
								FwiRect srcRoi, Fw16u* pDst, int dstStep, FwiRect dstRoi,
								const double coeffs[2][3], int interpolation )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiWarpAffine_16u_AC4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, coeffs, interpolation);
    case DT_REFR:
        return _refr_fwiWarpAffine_16u_AC4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, coeffs, interpolation);
    default:
        assert(false);
        return _refr_fwiWarpAffine_16u_AC4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, coeffs, interpolation);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiFilterColumn_16s_AC4R( const Fw16s * pSrc, int srcStep,
                              Fw16s * pDst, int dstStep, FwiSize dstRoiSize,
                              const Fw32s * pKernel, int kernelSize,
                              int yAnchor, int divisor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilterColumn_16s_AC4R(pSrc, srcStep, pDst, dstStep, dstRoiSize, pKernel, kernelSize, yAnchor, divisor);
    case DT_REFR:
        return _refr_fwiFilterColumn_16s_AC4R(pSrc, srcStep, pDst, dstStep, dstRoiSize, pKernel, kernelSize, yAnchor, divisor);
    default:
        assert(false);
        return _refr_fwiFilterColumn_16s_AC4R(pSrc, srcStep, pDst, dstStep, dstRoiSize, pKernel, kernelSize, yAnchor, divisor);
    }
}

OREFR             FwStatus STDCALL fwiScale_8u32s_AC4R( const Fw8u * pSrc, int srcStep, Fw32s * pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiScale_8u32s_AC4R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiScale_8u32s_AC4R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR               FwStatus fwiYCbCr422ToRGB444_8u16u_P3C3R(const A8U* const pSrc[3], int srcStep[3], A16U* pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiYCbCr422ToRGB444_8u16u_P3C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiYCbCr422ToRGB444_8u16u_P3C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiXor_8u_AC4IR( const Fw8u	*pSrc,  int srcStep,        Fw8u *pSrcDst, int srcDstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiXor_8u_AC4IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiXor_8u_AC4IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    case DT_REFR:
        return _refr_fwiXor_8u_AC4IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiXor_8u_AC4IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    }
}

OREFR       FwStatus STDCALL fwiWarpBilinear_32f_P3R(const Fw32f* const pSrc[3], FwiSize srcSize, int srcStep,
								FwiRect srcRoi, Fw32f* const pDst[3], int dstStep, FwiRect dstRoi,
								const double coeffs[2][4], int interpolation)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiWarpBilinear_32f_P3R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, coeffs, interpolation);
    default:
        assert(false);
        return _refr_fwiWarpBilinear_32f_P3R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, coeffs, interpolation);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiSub_16s_C1IRSfs( const Fw16s  *pSrc,  int srcStep,        Fw16s  *pSrcDst, int srcDstStep, FwiSize roiSize, int scaleFactor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiSub_16s_C1IRSfs(pSrc, srcStep, pSrcDst, srcDstStep, roiSize, scaleFactor);
    case DT_SSE2:
        return _sse2_fwiSub_16s_C1IRSfs(pSrc, srcStep, pSrcDst, srcDstStep, roiSize, scaleFactor);
    case DT_REFR:
        return _refr_fwiSub_16s_C1IRSfs(pSrc, srcStep, pSrcDst, srcDstStep, roiSize, scaleFactor);
    default:
        assert(false);
        return _refr_fwiSub_16s_C1IRSfs(pSrc, srcStep, pSrcDst, srcDstStep, roiSize, scaleFactor);
    }
}

OREFR OSSE2 FwStatus STDCALL fwiWarpAffineBack_32f_C3R( const Fw32f* pSrc, FwiSize srcSize, int srcStep,
								FwiRect srcRoi, Fw32f* pDst, int dstStep, FwiRect dstRoi,
								const double coeffs[2][3], int interpolation )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiWarpAffineBack_32f_C3R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, coeffs, interpolation);
    case DT_REFR:
        return _refr_fwiWarpAffineBack_32f_C3R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, coeffs, interpolation);
    default:
        assert(false);
        return _refr_fwiWarpAffineBack_32f_C3R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, coeffs, interpolation);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiFilterMax_32f_C3R( const Fw32f * pSrc, int srcStep,
                               Fw32f * pDst, int dstStep, FwiSize dstRoiSize,
                               FwiSize maskSize, FwiPoint anchor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilterMax_32f_C3R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize, anchor);
    case DT_REFR:
        return _refr_fwiFilterMax_32f_C3R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize, anchor);
    default:
        assert(false);
        return _refr_fwiFilterMax_32f_C3R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize, anchor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiCompareC_32f_AC4R( const Fw32f *pSrc, int srcStep, const Fw32f value[3], Fw8u *pDst, int dstStep, FwiSize roiSize, FwCmpOp fwCmpOp )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiCompareC_32f_AC4R(pSrc, srcStep, value, pDst, dstStep, roiSize, fwCmpOp);
    case DT_SSE2:
        return _sse2_fwiCompareC_32f_AC4R(pSrc, srcStep, value, pDst, dstStep, roiSize, fwCmpOp);
    case DT_REFR:
        return _refr_fwiCompareC_32f_AC4R(pSrc, srcStep, value, pDst, dstStep, roiSize, fwCmpOp);
    default:
        assert(false);
        return _refr_fwiCompareC_32f_AC4R(pSrc, srcStep, value, pDst, dstStep, roiSize, fwCmpOp);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiFilterMedianColor_16s_C3R( const Fw16s * pSrc, int srcStep,
                                                 Fw16s * pDst, int dstStep, FwiSize dstRoiSize,
                                                 FwiMaskSize maskSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilterMedianColor_16s_C3R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize);
    case DT_REFR:
        return _refr_fwiFilterMedianColor_16s_C3R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize);
    default:
        assert(false);
        return _refr_fwiFilterMedianColor_16s_C3R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiMulC_16sc_AC4RSfs( const Fw16sc *pSrc, int srcStep, const Fw16sc value[3], Fw16sc *pDst, int dstStep, FwiSize roiSize, int scaleFactor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiMulC_16sc_AC4RSfs(pSrc, srcStep, value, pDst, dstStep, roiSize, scaleFactor);
    case DT_SSE2:
        return _sse2_fwiMulC_16sc_AC4RSfs(pSrc, srcStep, value, pDst, dstStep, roiSize, scaleFactor);
    case DT_REFR:
        return _refr_fwiMulC_16sc_AC4RSfs(pSrc, srcStep, value, pDst, dstStep, roiSize, scaleFactor);
    default:
        assert(false);
        return _refr_fwiMulC_16sc_AC4RSfs(pSrc, srcStep, value, pDst, dstStep, roiSize, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiMulC_16s_AC4IRSfs( const Fw16s value[3], Fw16s *pSrcDst, int srcDstStep, FwiSize roiSize, int scaleFactor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiMulC_16s_AC4IRSfs(value, pSrcDst, srcDstStep, roiSize, scaleFactor);
    case DT_SSE2:
        return _sse2_fwiMulC_16s_AC4IRSfs(value, pSrcDst, srcDstStep, roiSize, scaleFactor);
    case DT_REFR:
        return _refr_fwiMulC_16s_AC4IRSfs(value, pSrcDst, srcDstStep, roiSize, scaleFactor);
    default:
        assert(false);
        return _refr_fwiMulC_16s_AC4IRSfs(value, pSrcDst, srcDstStep, roiSize, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiNot_8u_C3IR( Fw8u *pSrcDst, int srcDstStep, FwiSize roiSize)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiNot_8u_C3IR(pSrcDst, srcDstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiNot_8u_C3IR(pSrcDst, srcDstStep, roiSize);
    case DT_REFR:
        return _refr_fwiNot_8u_C3IR(pSrcDst, srcDstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiNot_8u_C3IR(pSrcDst, srcDstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiAddSquare_8u32f_C1IR( const Fw8u *pSrc,  int srcStep, Fw32f* pSrcDst, int srcDstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiAddSquare_8u32f_C1IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiAddSquare_8u32f_C1IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    case DT_REFR:
        return _refr_fwiAddSquare_8u32f_C1IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiAddSquare_8u32f_C1IR(pSrc, srcStep, pSrcDst, srcDstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiSubC_32f_C1R( const Fw32f *pSrc, int srcStep,       Fw32f value,    Fw32f *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiSubC_32f_C1R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiSubC_32f_C1R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiSubC_32f_C1R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiSubC_32f_C1R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    }
}

OREFR       FwStatus STDCALL fwiWarpBilinearBack_32f_AC4R(const Fw32f* pSrc, FwiSize srcSize, int srcStep,
								FwiRect srcRoi, Fw32f* pDst, int dstStep, FwiRect dstRoi,
								const double coeffs[2][4], int interpolation)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiWarpBilinearBack_32f_AC4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, coeffs, interpolation);
    default:
        assert(false);
        return _refr_fwiWarpBilinearBack_32f_AC4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, coeffs, interpolation);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiConvert_32f8u_AC4R( const Fw32f *pSrc, int srcStep, Fw8u *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiConvert_32f8u_AC4R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiConvert_32f8u_AC4R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiConvert_32f8u_AC4R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiConvert_32f8u_AC4R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR       FwStatus STDCALL fwiShear_32f_C4R(const Fw32f* pSrc, FwiSize srcSize, int srcStep, FwiRect srcRoi, Fw32f* pDst, int dstStep, FwiRect dstRoi, double xShear, double yShear, double xShift, double yShift, int interpolation )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiShear_32f_C4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, xShear, yShear, xShift, yShift, interpolation);
    default:
        assert(false);
        return _refr_fwiShear_32f_C4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, xShear, yShear, xShift, yShift, interpolation);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiConvert_16u8u_C3R( const Fw16u *pSrc, int srcStep, Fw8u *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiConvert_16u8u_C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiConvert_16u8u_C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiConvert_16u8u_C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiConvert_16u8u_C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR               FwStatus fwiBGRToHLS_8u_P3C3R( const A8U* const pSrc[3], int srcStep, A8U* pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiBGRToHLS_8u_P3C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiBGRToHLS_8u_P3C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiFilterHipass_16s_C4R( const Fw16s * pSrc, int srcStep, Fw16s * pDst, int dstStep, FwiSize dstRoiSize, FwiMaskSize maskSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilterHipass_16s_C4R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize);
    case DT_REFR:
        return _refr_fwiFilterHipass_16s_C4R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize);
    default:
        assert(false);
        return _refr_fwiFilterHipass_16s_C4R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize);
    }
}

OREFR OSSE2 OF10H   FwStatus fwiRGBToYUV_8u_C3P3R( const Fw8u *pSrc, int srcStep, Fw8u *pDst[3], int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiRGBToYUV_8u_C3P3R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiRGBToYUV_8u_C3P3R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiRGBToYUV_8u_C3P3R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiRGBToYUV_8u_C3P3R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiConvert_32f16s_C4R( const Fw32f *pSrc, int srcStep, Fw16s *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiConvert_32f16s_C4R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiConvert_32f16s_C4R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiConvert_32f16s_C4R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiConvert_32f16s_C4R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiSub_32sc_C3RSfs( const Fw32sc *pSrc1, int src1Step, const Fw32sc *pSrc2,   int src2Step, Fw32sc *pDst, int dstStep, FwiSize roiSize, int scaleFactor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiSub_32sc_C3RSfs(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, scaleFactor);
    case DT_SSE2:
        return _sse2_fwiSub_32sc_C3RSfs(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, scaleFactor);
    case DT_REFR:
        return _refr_fwiSub_32sc_C3RSfs(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, scaleFactor);
    default:
        assert(false);
        return _refr_fwiSub_32sc_C3RSfs(pSrc1, src1Step, pSrc2, src2Step, pDst, dstStep, roiSize, scaleFactor);
    }
}

OREFR       FwStatus STDCALL fwiResizeSqrPixel_16u_P4R(const Fw16u* const pSrc[4], FwiSize srcSize, int srcStep, FwiRect srcRoi,
			Fw16u* const pDst[4], int dstStep, FwiRect dstRoi, double xFactor, double yFactor,
			double xShift, double yShift, int interpolation, Fw8u* pBuffer)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiResizeSqrPixel_16u_P4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, xFactor, yFactor, xShift, yShift, interpolation, pBuffer);
    default:
        assert(false);
        return _refr_fwiResizeSqrPixel_16u_P4R(pSrc, srcSize, srcStep, srcRoi, pDst, dstStep, dstRoi, xFactor, yFactor, xShift, yShift, interpolation, pBuffer);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiFilterColumn32f_8u_C4R( const Fw8u * pSrc, int srcStep,
                                Fw8u * pDst, int dstStep, FwiSize dstRoiSize,
                                const Fw32f * pKernel, int kernelSize,
                                int yAnchor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilterColumn32f_8u_C4R(pSrc, srcStep, pDst, dstStep, dstRoiSize, pKernel, kernelSize, yAnchor);
    case DT_REFR:
        return _refr_fwiFilterColumn32f_8u_C4R(pSrc, srcStep, pDst, dstStep, dstRoiSize, pKernel, kernelSize, yAnchor);
    default:
        assert(false);
        return _refr_fwiFilterColumn32f_8u_C4R(pSrc, srcStep, pDst, dstStep, dstRoiSize, pKernel, kernelSize, yAnchor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiThreshold_LTVal_8u_C4R( const Fw8u *pSrc, int srcStep, Fw8u *pDst, int dstStep, FwiSize roiSize, const Fw8u threshold[4], const Fw8u value[4])
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiThreshold_LTVal_8u_C4R(pSrc, srcStep, pDst, dstStep, roiSize, threshold, value);
    case DT_SSE2:
        return _sse2_fwiThreshold_LTVal_8u_C4R(pSrc, srcStep, pDst, dstStep, roiSize, threshold, value);
    case DT_REFR:
        return _refr_fwiThreshold_LTVal_8u_C4R(pSrc, srcStep, pDst, dstStep, roiSize, threshold, value);
    default:
        assert(false);
        return _refr_fwiThreshold_LTVal_8u_C4R(pSrc, srcStep, pDst, dstStep, roiSize, threshold, value);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiAddProduct_8u32f_C1IR( const Fw8u *pSrc1, int src1Step, const Fw8u *pSrc2,   int src2Step, Fw32f *pSrcDst, int srcDstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiAddProduct_8u32f_C1IR(pSrc1, src1Step, pSrc2, src2Step, pSrcDst, srcDstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiAddProduct_8u32f_C1IR(pSrc1, src1Step, pSrc2, src2Step, pSrcDst, srcDstStep, roiSize);
    case DT_REFR:
        return _refr_fwiAddProduct_8u32f_C1IR(pSrc1, src1Step, pSrc2, src2Step, pSrcDst, srcDstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiAddProduct_8u32f_C1IR(pSrc1, src1Step, pSrc2, src2Step, pSrcDst, srcDstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiSqr_16s_C1IRSfs(       Fw16s *pSrcDst, int srcDstStep, FwiSize roiSize, int scaleFactor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiSqr_16s_C1IRSfs(pSrcDst, srcDstStep, roiSize, scaleFactor);
    case DT_SSE2:
        return _sse2_fwiSqr_16s_C1IRSfs(pSrcDst, srcDstStep, roiSize, scaleFactor);
    case DT_REFR:
        return _refr_fwiSqr_16s_C1IRSfs(pSrcDst, srcDstStep, roiSize, scaleFactor);
    default:
        assert(false);
        return _refr_fwiSqr_16s_C1IRSfs(pSrcDst, srcDstStep, roiSize, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiDivC_32f_C1R( const Fw32f *pSrc, int srcStep,       Fw32f value,    Fw32f *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiDivC_32f_C1R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiDivC_32f_C1R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiDivC_32f_C1R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiDivC_32f_C1R(pSrc, srcStep, value, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2       FwStatus STDCALL fwiFilterMedianColor_8u_AC4R( const Fw8u * pSrc, int srcStep,
                                                 Fw8u * pDst, int dstStep, FwiSize dstRoiSize,
                                                 FwiMaskSize maskSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilterMedianColor_8u_AC4R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize);
    case DT_REFR:
        return _refr_fwiFilterMedianColor_8u_AC4R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize);
    default:
        assert(false);
        return _refr_fwiFilterMedianColor_8u_AC4R(pSrc, srcStep, pDst, dstStep, dstRoiSize, maskSize);
    }
}


OREFR OSSE2         FwStatus fwiMax_8u_C3R(const Fw8u* pSrc, int srcStep,FwiSize roiSize, Fw8u max[3])
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiMax_8u_C3R(pSrc, srcStep, roiSize, max);
    case DT_REFR:
        return _refr_fwiMax_8u_C3R(pSrc, srcStep, roiSize, max);
    default:
        assert(false);
        return _refr_fwiMax_8u_C3R(pSrc, srcStep, roiSize, max);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiRShiftC_32s_C4IR( const Fw32u value[4], Fw32s *pSrcDst, int srcDstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiRShiftC_32s_C4IR(value, pSrcDst, srcDstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiRShiftC_32s_C4IR(value, pSrcDst, srcDstStep, roiSize);
    case DT_REFR:
        return _refr_fwiRShiftC_32s_C4IR(value, pSrcDst, srcDstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiRShiftC_32s_C4IR(value, pSrcDst, srcDstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiConvert_16s8u_AC4R( const Fw16s *pSrc, int srcStep, Fw8u *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiConvert_16s8u_AC4R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_SSE2:
        return _sse2_fwiConvert_16s8u_AC4R(pSrc, srcStep, pDst, dstStep, roiSize);
    case DT_REFR:
        return _refr_fwiConvert_16s8u_AC4R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiConvert_16s8u_AC4R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiThreshold_GT_8u_AC4R( const Fw8u *pSrc, int srcStep, Fw8u *pDst, int dstStep, FwiSize roiSize, const Fw8u threshold[3])
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiThreshold_GT_8u_AC4R(pSrc, srcStep, pDst, dstStep, roiSize, threshold);
    case DT_SSE2:
        return _sse2_fwiThreshold_GT_8u_AC4R(pSrc, srcStep, pDst, dstStep, roiSize, threshold);
    case DT_REFR:
        return _refr_fwiThreshold_GT_8u_AC4R(pSrc, srcStep, pDst, dstStep, roiSize, threshold);
    default:
        assert(false);
        return _refr_fwiThreshold_GT_8u_AC4R(pSrc, srcStep, pDst, dstStep, roiSize, threshold);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiMul_16s_C4IRSfs( const Fw16s  *pSrc,  int srcStep,        Fw16s  *pSrcDst, int srcDstStep, FwiSize roiSize, int scaleFactor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiMul_16s_C4IRSfs(pSrc, srcStep, pSrcDst, srcDstStep, roiSize, scaleFactor);
    case DT_SSE2:
        return _sse2_fwiMul_16s_C4IRSfs(pSrc, srcStep, pSrcDst, srcDstStep, roiSize, scaleFactor);
    case DT_REFR:
        return _refr_fwiMul_16s_C4IRSfs(pSrc, srcStep, pSrcDst, srcDstStep, roiSize, scaleFactor);
    default:
        assert(false);
        return _refr_fwiMul_16s_C4IRSfs(pSrc, srcStep, pSrcDst, srcDstStep, roiSize, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiCompareC_16s_C4R( const Fw16s *pSrc, int srcStep, const Fw16s value[4], Fw8u *pDst, int dstStep, FwiSize roiSize, FwCmpOp fwCmpOp )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiCompareC_16s_C4R(pSrc, srcStep, value, pDst, dstStep, roiSize, fwCmpOp);
    case DT_SSE2:
        return _sse2_fwiCompareC_16s_C4R(pSrc, srcStep, value, pDst, dstStep, roiSize, fwCmpOp);
    case DT_REFR:
        return _refr_fwiCompareC_16s_C4R(pSrc, srcStep, value, pDst, dstStep, roiSize, fwCmpOp);
    default:
        assert(false);
        return _refr_fwiCompareC_16s_C4R(pSrc, srcStep, value, pDst, dstStep, roiSize, fwCmpOp);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiSet_32f_C1MR(       Fw32f  value,    Fw32f  * pDst, int dstStep, FwiSize roiSize, const Fw8u * pMask, int maskStep )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiSet_32f_C1MR(value, pDst, dstStep, roiSize, pMask, maskStep);
    case DT_SSE2:
        return _sse2_fwiSet_32f_C1MR(value, pDst, dstStep, roiSize, pMask, maskStep);
    case DT_REFR:
        return _refr_fwiSet_32f_C1MR(value, pDst, dstStep, roiSize, pMask, maskStep);
    default:
        assert(false);
        return _refr_fwiSet_32f_C1MR(value, pDst, dstStep, roiSize, pMask, maskStep);
    }
}

OREFR             FwStatus STDCALL fwiConvert_16u32f_AC4R( const Fw16u *pSrc, int srcStep, Fw32f *pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiConvert_16u32f_AC4R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiConvert_16u32f_AC4R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}


OREFR       FwStatus STDCALL fwiGetResizeFract(FwiSize srcSize, FwiRect srcRoi, double xFactor, double yFactor,
							 double* xFr, double* yFr, int interpolation )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiGetResizeFract(srcSize, srcRoi, xFactor, yFactor, xFr, yFr, interpolation);
    default:
        assert(false);
        return _refr_fwiGetResizeFract(srcSize, srcRoi, xFactor, yFactor, xFr, yFr, interpolation);
    }
}

OREFR             FwStatus STDCALL fwiScale_32s8u_C1R( const Fw32s * pSrc, int srcStep, Fw8u * pDst, int dstStep, FwiSize roiSize, FwHintAlgorithm hint )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiScale_32s8u_C1R(pSrc, srcStep, pDst, dstStep, roiSize, hint);
    default:
        assert(false);
        return _refr_fwiScale_32s8u_C1R(pSrc, srcStep, pDst, dstStep, roiSize, hint);
    }
}

OREFR OSSE2 FwStatus STDCALL fwiFilterSharpen_16s_AC4R( const Fw16s * pSrc, int srcStep, Fw16s * pDst, int dstStep, FwiSize dstRoiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiFilterSharpen_16s_AC4R(pSrc, srcStep, pDst, dstStep, dstRoiSize);
    case DT_REFR:
        return _refr_fwiFilterSharpen_16s_AC4R(pSrc, srcStep, pDst, dstStep, dstRoiSize);
    default:
        assert(false);
        return _refr_fwiFilterSharpen_16s_AC4R(pSrc, srcStep, pDst, dstStep, dstRoiSize);
    }
}

OREFR               FwStatus fwiYCbCr422ToRGB555_8u16u_P3C3R(const A8U* const pSrc[3], int srcStep[3], A16U* pDst, int dstStep, FwiSize roiSize )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiYCbCr422ToRGB555_8u16u_P3C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    default:
        assert(false);
        return _refr_fwiYCbCr422ToRGB555_8u16u_P3C3R(pSrc, srcStep, pDst, dstStep, roiSize);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiThreshold_16s_AC4IR( Fw16s *pSrcDst, int srcDstStep, FwiSize roiSize, const Fw16s threshold[3], FwCmpOp fwCmpOp)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiThreshold_16s_AC4IR(pSrcDst, srcDstStep, roiSize, threshold, fwCmpOp);
    case DT_SSE2:
        return _sse2_fwiThreshold_16s_AC4IR(pSrcDst, srcDstStep, roiSize, threshold, fwCmpOp);
    case DT_REFR:
        return _refr_fwiThreshold_16s_AC4IR(pSrcDst, srcDstStep, roiSize, threshold, fwCmpOp);
    default:
        assert(false);
        return _refr_fwiThreshold_16s_AC4IR(pSrcDst, srcDstStep, roiSize, threshold, fwCmpOp);
    }
}

OREFR       FwStatus STDCALL fwiWarpBilinearQuad_32f_C3R(const Fw32f* pSrc, FwiSize srcSize, int srcStep, FwiRect srcRoi,
							        const double srcQuad[4][2], Fw32f* pDst, int dstStep, FwiRect dstRoi,
									const double dstQuad[4][2], int interpolation)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiWarpBilinearQuad_32f_C3R(pSrc, srcSize, srcStep, srcRoi, srcQuad, pDst, dstStep, dstRoi, dstQuad, interpolation);
    default:
        assert(false);
        return _refr_fwiWarpBilinearQuad_32f_C3R(pSrc, srcSize, srcStep, srcRoi, srcQuad, pDst, dstStep, dstRoi, dstQuad, interpolation);
    }
}


OREFR OSSE2       FwStatus STDCALL fwiMirror_8u_C1R( const Fw8u  *pSrc, int srcStep, Fw8u  *pDst, int dstStep, FwiSize roiSize, FwiAxis flip)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwiMirror_8u_C1R(pSrc, srcStep, pDst, dstStep, roiSize, flip);
    case DT_REFR:
        return _refr_fwiMirror_8u_C1R(pSrc, srcStep, pDst, dstStep, roiSize, flip);
    default:
        assert(false);
        return _refr_fwiMirror_8u_C1R(pSrc, srcStep, pDst, dstStep, roiSize, flip);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiThreshold_GT_32f_C1R( const Fw32f *pSrc, int srcStep, Fw32f *pDst, int dstStep, FwiSize roiSize, Fw32f threshold)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiThreshold_GT_32f_C1R(pSrc, srcStep, pDst, dstStep, roiSize, threshold);
    case DT_SSE2:
        return _sse2_fwiThreshold_GT_32f_C1R(pSrc, srcStep, pDst, dstStep, roiSize, threshold);
    case DT_REFR:
        return _refr_fwiThreshold_GT_32f_C1R(pSrc, srcStep, pDst, dstStep, roiSize, threshold);
    default:
        assert(false);
        return _refr_fwiThreshold_GT_32f_C1R(pSrc, srcStep, pDst, dstStep, roiSize, threshold);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiDiv_16sc_C1IRSfs( const Fw16sc *pSrc,  int srcStep,        Fw16sc *pSrcDst, int srcDstStep, FwiSize roiSize, int scaleFactor )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiDiv_16sc_C1IRSfs(pSrc, srcStep, pSrcDst, srcDstStep, roiSize, scaleFactor);
    case DT_SSE2:
        return _sse2_fwiDiv_16sc_C1IRSfs(pSrc, srcStep, pSrcDst, srcDstStep, roiSize, scaleFactor);
    case DT_REFR:
        return _refr_fwiDiv_16sc_C1IRSfs(pSrc, srcStep, pSrcDst, srcDstStep, roiSize, scaleFactor);
    default:
        assert(false);
        return _refr_fwiDiv_16sc_C1IRSfs(pSrc, srcStep, pSrcDst, srcDstStep, roiSize, scaleFactor);
    }
}

OREFR       FwStatus STDCALL fwiMirror_32f_C4R( const Fw32f *pSrc, int srcStep, Fw32f *pDst, int dstStep, FwiSize roiSize, FwiAxis flip)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwiMirror_32f_C4R(pSrc, srcStep, pDst, dstStep, roiSize, flip);
    default:
        assert(false);
        return _refr_fwiMirror_32f_C4R(pSrc, srcStep, pDst, dstStep, roiSize, flip);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwiThreshold_32f_C1R( const Fw32f *pSrc, int srcStep, Fw32f *pDst, int dstStep, FwiSize roiSize, Fw32f threshold, FwCmpOp fwCmpOp)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwiThreshold_32f_C1R(pSrc, srcStep, pDst, dstStep, roiSize, threshold, fwCmpOp);
    case DT_SSE2:
        return _sse2_fwiThreshold_32f_C1R(pSrc, srcStep, pDst, dstStep, roiSize, threshold, fwCmpOp);
    case DT_REFR:
        return _refr_fwiThreshold_32f_C1R(pSrc, srcStep, pDst, dstStep, roiSize, threshold, fwCmpOp);
    default:
        assert(false);
        return _refr_fwiThreshold_32f_C1R(pSrc, srcStep, pDst, dstStep, roiSize, threshold, fwCmpOp);
    }
}

