#define OPT_REFR
#define OPT_LEVEL REFR
#define OPT_PREFIX _refr_
#undef __FWSIGNAL_OPT_H__
#include "fwSignal_opt.h"
#undef OPT_REFR
#undef OPT_LEVEL
#undef OPT_PREFIX


#define OPT_SSE2
#define OPT_LEVEL SSE2
#define OPT_PREFIX _sse2_
#undef __FWSIGNAL_OPT_H__
#include "fwSignal_opt.h"
#undef OPT_SSE2
#undef OPT_LEVEL
#undef OPT_PREFIX


#define OPT_F10H
#define OPT_LEVEL F10H
#define OPT_PREFIX _f10h_
#undef __FWSIGNAL_OPT_H__
#include "fwSignal_opt.h"
#undef OPT_F10H
#undef OPT_LEVEL
#undef OPT_PREFIX


#define OPT_SSE3
#define OPT_LEVEL SSE3
#define OPT_PREFIX _sse3_
#undef __FWSIGNAL_OPT_H__
#include "fwSignal_opt.h"
#undef OPT_SSE3
#undef OPT_LEVEL
#undef OPT_PREFIX


using namespace REFR;
OREFR OSSE2 OF10H FwStatus STDCALL fwsSubCRev_32s_Sfs(const Fw32s* pSrc, Fw32s val, Fw32s* pDst, int len, int scaleFactor)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsSubCRev_32s_Sfs(pSrc, val, pDst, len, scaleFactor);
    case DT_SSE2:
        return _sse2_fwsSubCRev_32s_Sfs(pSrc, val, pDst, len, scaleFactor);
    case DT_REFR:
        return _refr_fwsSubCRev_32s_Sfs(pSrc, val, pDst, len, scaleFactor);
    default:
        assert(false);
        return _refr_fwsSubCRev_32s_Sfs(pSrc, val, pDst, len, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsThreshold_LT_64f_I(Fw64f* pSrcDst, int len, Fw64f level)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsThreshold_LT_64f_I(pSrcDst, len, level);
    case DT_SSE2:
        return _sse2_fwsThreshold_LT_64f_I(pSrcDst, len, level);
    case DT_REFR:
        return _refr_fwsThreshold_LT_64f_I(pSrcDst, len, level);
    default:
        assert(false);
        return _refr_fwsThreshold_LT_64f_I(pSrcDst, len, level);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsArctan_64f(const Fw64f* pSrc, Fw64f* pDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsArctan_64f(pSrc, pDst, len);
    case DT_SSE2:
        return _sse2_fwsArctan_64f(pSrc, pDst, len);
    case DT_REFR:
        return _refr_fwsArctan_64f(pSrc, pDst, len);
    default:
        assert(false);
        return _refr_fwsArctan_64f(pSrc, pDst, len);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsMagnitude_32sc_Sfs(const Fw32sc* pSrc, Fw32s* pDst, int len, int scaleFactor)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsMagnitude_32sc_Sfs(pSrc, pDst, len, scaleFactor);
    case DT_SSE2:
        return _sse2_fwsMagnitude_32sc_Sfs(pSrc, pDst, len, scaleFactor);
    case DT_REFR:
        return _refr_fwsMagnitude_32sc_Sfs(pSrc, pDst, len, scaleFactor);
    default:
        assert(false);
        return _refr_fwsMagnitude_32sc_Sfs(pSrc, pDst, len, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsAbs_64f_I(Fw64f* pSrcDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsAbs_64f_I(pSrcDst, len);
    case DT_SSE2:
        return _sse2_fwsAbs_64f_I(pSrcDst, len);
    case DT_REFR:
        return _refr_fwsAbs_64f_I(pSrcDst, len);
    default:
        assert(false);
        return _refr_fwsAbs_64f_I(pSrcDst, len);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsSqr_16sc_Sfs(const Fw16sc* pSrc, Fw16sc* pDst, int len,int scaleFactor)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsSqr_16sc_Sfs(pSrc, pDst, len, scaleFactor);
    case DT_SSE2:
        return _sse2_fwsSqr_16sc_Sfs(pSrc, pDst, len, scaleFactor);
    case DT_REFR:
        return _refr_fwsSqr_16sc_Sfs(pSrc, pDst, len, scaleFactor);
    default:
        assert(false);
        return _refr_fwsSqr_16sc_Sfs(pSrc, pDst, len, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsDivC_8u_Sfs(const Fw8u* pSrc, Fw8u val, Fw8u* pDst, int len,int scaleFactor)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsDivC_8u_Sfs(pSrc, val, pDst, len, scaleFactor);
    case DT_SSE2:
        return _sse2_fwsDivC_8u_Sfs(pSrc, val, pDst, len, scaleFactor);
    case DT_REFR:
        return _refr_fwsDivC_8u_Sfs(pSrc, val, pDst, len, scaleFactor);
    default:
        assert(false);
        return _refr_fwsDivC_8u_Sfs(pSrc, val, pDst, len, scaleFactor);
    }
}

OREFR OSSE2 FwStatus STDCALL fwsAutoCorr_NormB_32fc(const  Fw32fc*  pSrc,  int  srcLen,  Fw32fc*  pDst,  int  dstLen)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwsAutoCorr_NormB_32fc(pSrc, srcLen, pDst, dstLen);
    case DT_REFR:
        return _refr_fwsAutoCorr_NormB_32fc(pSrc, srcLen, pDst, dstLen);
    default:
        assert(false);
        return _refr_fwsAutoCorr_NormB_32fc(pSrc, srcLen, pDst, dstLen);
    }
}

OREFR OSSE2 FwStatus STDCALL fwsNormDiff_L1_16s32s_Sfs(const Fw16s* pSrc1, const Fw16s* pSrc2, int len, Fw32s* pNorm, int scaleFactor)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwsNormDiff_L1_16s32s_Sfs(pSrc1, pSrc2, len, pNorm, scaleFactor);
    case DT_REFR:
        return _refr_fwsNormDiff_L1_16s32s_Sfs(pSrc1, pSrc2, len, pNorm, scaleFactor);
    default:
        assert(false);
        return _refr_fwsNormDiff_L1_16s32s_Sfs(pSrc1, pSrc2, len, pNorm, scaleFactor);
    }
}

OREFR OSSE2 FwStatus STDCALL fwsNorm_L1_32f(const Fw32f* pSrc, int len, Fw32f* pNorm)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwsNorm_L1_32f(pSrc, len, pNorm);
    case DT_REFR:
        return _refr_fwsNorm_L1_32f(pSrc, len, pNorm);
    default:
        assert(false);
        return _refr_fwsNorm_L1_32f(pSrc, len, pNorm);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsThreshold_LT_16sc(const Fw16sc* pSrc, Fw16sc* pDst, int len, Fw16s level)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsThreshold_LT_16sc(pSrc, pDst, len, level);
    case DT_SSE2:
        return _sse2_fwsThreshold_LT_16sc(pSrc, pDst, len, level);
    case DT_REFR:
        return _refr_fwsThreshold_LT_16sc(pSrc, pDst, len, level);
    default:
        assert(false);
        return _refr_fwsThreshold_LT_16sc(pSrc, pDst, len, level);
    }
}

OREFR OSSE2 FwStatus STDCALL fwsMinMax_64f(const Fw64f* pSrc, int len, Fw64f* pMin, Fw64f* pMax)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwsMinMax_64f(pSrc, len, pMin, pMax);
    case DT_REFR:
        return _refr_fwsMinMax_64f(pSrc, len, pMin, pMax);
    default:
        assert(false);
        return _refr_fwsMinMax_64f(pSrc, len, pMin, pMax);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsAdd_64fc(const Fw64fc* pSrc1, const Fw64fc* pSrc2, Fw64fc* pDst,int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsAdd_64fc(pSrc1, pSrc2, pDst, len);
    case DT_SSE2:
        return _sse2_fwsAdd_64fc(pSrc1, pSrc2, pDst, len);
    case DT_REFR:
        return _refr_fwsAdd_64fc(pSrc1, pSrc2, pDst, len);
    default:
        assert(false);
        return _refr_fwsAdd_64fc(pSrc1, pSrc2, pDst, len);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsAddC_16s_Sfs(const Fw16s* pSrc, Fw16s val, Fw16s* pDst, int len, int scaleFactor)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsAddC_16s_Sfs(pSrc, val, pDst, len, scaleFactor);
    case DT_SSE2:
        return _sse2_fwsAddC_16s_Sfs(pSrc, val, pDst, len, scaleFactor);
    case DT_REFR:
        return _refr_fwsAddC_16s_Sfs(pSrc, val, pDst, len, scaleFactor);
    default:
        assert(false);
        return _refr_fwsAddC_16s_Sfs(pSrc, val, pDst, len, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsDiv_64fc_I(const Fw64fc* pSrc, Fw64fc* pSrcDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsDiv_64fc_I(pSrc, pSrcDst, len);
    case DT_SSE2:
        return _sse2_fwsDiv_64fc_I(pSrc, pSrcDst, len);
    case DT_REFR:
        return _refr_fwsDiv_64fc_I(pSrc, pSrcDst, len);
    default:
        assert(false);
        return _refr_fwsDiv_64fc_I(pSrc, pSrcDst, len);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsMul_16sc_ISfs(const Fw16sc* pSrc, Fw16sc* pSrcDst, int len, int scaleFactor)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsMul_16sc_ISfs(pSrc, pSrcDst, len, scaleFactor);
    case DT_SSE2:
        return _sse2_fwsMul_16sc_ISfs(pSrc, pSrcDst, len, scaleFactor);
    case DT_REFR:
        return _refr_fwsMul_16sc_ISfs(pSrc, pSrcDst, len, scaleFactor);
    default:
        assert(false);
        return _refr_fwsMul_16sc_ISfs(pSrc, pSrcDst, len, scaleFactor);
    }
}

OREFR OSSE2 FwStatus STDCALL fwsNorm_L1_16s32f(const Fw16s* pSrc, int len, Fw32f* pNorm)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwsNorm_L1_16s32f(pSrc, len, pNorm);
    case DT_REFR:
        return _refr_fwsNorm_L1_16s32f(pSrc, len, pNorm);
    default:
        assert(false);
        return _refr_fwsNorm_L1_16s32f(pSrc, len, pNorm);
    }
}

OREFR             FwStatus STDCALL fwsTan_32f_A21(const Fw32f* pSrc, Fw32f* pDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwsTan_32f_A21(pSrc, pDst, len);
    default:
        assert(false);
        return _refr_fwsTan_32f_A21(pSrc, pDst, len);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsCbrt_32f_A21(const Fw32f* pSrc, Fw32f* pDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsCbrt_32f_A21(pSrc, pDst, len);
    case DT_SSE2:
        return _sse2_fwsCbrt_32f_A21(pSrc, pDst, len);
    case DT_REFR:
        return _refr_fwsCbrt_32f_A21(pSrc, pDst, len);
    default:
        assert(false);
        return _refr_fwsCbrt_32f_A21(pSrc, pDst, len);
    }
}

OREFR             FwStatus STDCALL fwsTan_32f_A24(const Fw32f* pSrc, Fw32f* pDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwsTan_32f_A24(pSrc, pDst, len);
    default:
        assert(false);
        return _refr_fwsTan_32f_A24(pSrc, pDst, len);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsDiv_64f_A50(const Fw64f* pSrc1, const Fw64f* pSrc2, Fw64f* pDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsDiv_64f_A50(pSrc1, pSrc2, pDst, len);
    case DT_SSE2:
        return _sse2_fwsDiv_64f_A50(pSrc1, pSrc2, pDst, len);
    case DT_REFR:
        return _refr_fwsDiv_64f_A50(pSrc1, pSrc2, pDst, len);
    default:
        assert(false);
        return _refr_fwsDiv_64f_A50(pSrc1, pSrc2, pDst, len);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsDiv_64f_A53(const Fw64f* pSrc1, const Fw64f* pSrc2, Fw64f* pDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsDiv_64f_A53(pSrc1, pSrc2, pDst, len);
    case DT_SSE2:
        return _sse2_fwsDiv_64f_A53(pSrc1, pSrc2, pDst, len);
    case DT_REFR:
        return _refr_fwsDiv_64f_A53(pSrc1, pSrc2, pDst, len);
    default:
        assert(false);
        return _refr_fwsDiv_64f_A53(pSrc1, pSrc2, pDst, len);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsAddC_16sc_ISfs(Fw16sc val, Fw16sc* pSrcDst, int len, int scaleFactor)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsAddC_16sc_ISfs(val, pSrcDst, len, scaleFactor);
    case DT_SSE2:
        return _sse2_fwsAddC_16sc_ISfs(val, pSrcDst, len, scaleFactor);
    case DT_REFR:
        return _refr_fwsAddC_16sc_ISfs(val, pSrcDst, len, scaleFactor);
    default:
        assert(false);
        return _refr_fwsAddC_16sc_ISfs(val, pSrcDst, len, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsSub_16sc_Sfs(const Fw16sc* pSrc1, const Fw16sc* pSrc2, Fw16sc* pDst, int len, int scaleFactor)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsSub_16sc_Sfs(pSrc1, pSrc2, pDst, len, scaleFactor);
    case DT_SSE2:
        return _sse2_fwsSub_16sc_Sfs(pSrc1, pSrc2, pDst, len, scaleFactor);
    case DT_REFR:
        return _refr_fwsSub_16sc_Sfs(pSrc1, pSrc2, pDst, len, scaleFactor);
    default:
        assert(false);
        return _refr_fwsSub_16sc_Sfs(pSrc1, pSrc2, pDst, len, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsNormalize_16s_Sfs(const Fw16s* pSrc, Fw16s* pDst, int len, Fw16s vsub, int vdiv, int scaleFactor)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsNormalize_16s_Sfs(pSrc, pDst, len, vsub, vdiv, scaleFactor);
    case DT_SSE2:
        return _sse2_fwsNormalize_16s_Sfs(pSrc, pDst, len, vsub, vdiv, scaleFactor);
    case DT_REFR:
        return _refr_fwsNormalize_16s_Sfs(pSrc, pDst, len, vsub, vdiv, scaleFactor);
    default:
        assert(false);
        return _refr_fwsNormalize_16s_Sfs(pSrc, pDst, len, vsub, vdiv, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsSet_32fc(Fw32fc val, Fw32fc* pDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsSet_32fc(val, pDst, len);
    case DT_SSE2:
        return _sse2_fwsSet_32fc(val, pDst, len);
    case DT_REFR:
        return _refr_fwsSet_32fc(val, pDst, len);
    default:
        assert(false);
        return _refr_fwsSet_32fc(val, pDst, len);
    }
}

OREFR OSSE2 FwStatus STDCALL fwsDotProd_32f64f(const Fw32f* pSrc1, const Fw32f* pSrc2, int len,Fw64f* pDp)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwsDotProd_32f64f(pSrc1, pSrc2, len, pDp);
    case DT_REFR:
        return _refr_fwsDotProd_32f64f(pSrc1, pSrc2, len, pDp);
    default:
        assert(false);
        return _refr_fwsDotProd_32f64f(pSrc1, pSrc2, len, pDp);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsLShiftC_32s(const Fw32s* pSrc, int val, Fw32s* pDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsLShiftC_32s(pSrc, val, pDst, len);
    case DT_SSE2:
        return _sse2_fwsLShiftC_32s(pSrc, val, pDst, len);
    case DT_REFR:
        return _refr_fwsLShiftC_32s(pSrc, val, pDst, len);
    default:
        assert(false);
        return _refr_fwsLShiftC_32s(pSrc, val, pDst, len);
    }
}

OREFR OSSE2 FwStatus STDCALL fwsMax_32f(const Fw32f* pSrc, int len, Fw32f* pMax)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwsMax_32f(pSrc, len, pMax);
    case DT_REFR:
        return _refr_fwsMax_32f(pSrc, len, pMax);
    default:
        assert(false);
        return _refr_fwsMax_32f(pSrc, len, pMax);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsLShiftC_16u_I(int val, Fw16u* pSrcDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsLShiftC_16u_I(val, pSrcDst, len);
    case DT_SSE2:
        return _sse2_fwsLShiftC_16u_I(val, pSrcDst, len);
    case DT_REFR:
        return _refr_fwsLShiftC_16u_I(val, pSrcDst, len);
    default:
        assert(false);
        return _refr_fwsLShiftC_16u_I(val, pSrcDst, len);
    }
}

OREFR OSSE2 FwStatus STDCALL fwsMean_32fc(const Fw32fc* pSrc, int len, Fw32fc* pMean,FwHintAlgorithm hint)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwsMean_32fc(pSrc, len, pMean, hint);
    case DT_REFR:
        return _refr_fwsMean_32fc(pSrc, len, pMean, hint);
    default:
        assert(false);
        return _refr_fwsMean_32fc(pSrc, len, pMean, hint);
    }
}

OREFR OSSE2 FwStatus STDCALL fwsMax_32s(const Fw32s* pSrc, int len, Fw32s* pMax)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwsMax_32s(pSrc, len, pMax);
    case DT_REFR:
        return _refr_fwsMax_32s(pSrc, len, pMax);
    default:
        assert(false);
        return _refr_fwsMax_32s(pSrc, len, pMax);
    }
}

OREFR OSSE2 FwStatus STDCALL fwsNormDiff_L1_32f(const Fw32f* pSrc1, const Fw32f* pSrc2, int len,Fw32f* pNorm)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwsNormDiff_L1_32f(pSrc1, pSrc2, len, pNorm);
    case DT_REFR:
        return _refr_fwsNormDiff_L1_32f(pSrc1, pSrc2, len, pNorm);
    default:
        assert(false);
        return _refr_fwsNormDiff_L1_32f(pSrc1, pSrc2, len, pNorm);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsSubCRev_32s_ISfs(Fw32s val, Fw32s* pSrcDst, int len, int scaleFactor)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsSubCRev_32s_ISfs(val, pSrcDst, len, scaleFactor);
    case DT_SSE2:
        return _sse2_fwsSubCRev_32s_ISfs(val, pSrcDst, len, scaleFactor);
    case DT_REFR:
        return _refr_fwsSubCRev_32s_ISfs(val, pSrcDst, len, scaleFactor);
    default:
        assert(false);
        return _refr_fwsSubCRev_32s_ISfs(val, pSrcDst, len, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsThreshold_GT_64fc(const Fw64fc* pSrc, Fw64fc* pDst, int len, Fw64f level)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsThreshold_GT_64fc(pSrc, pDst, len, level);
    case DT_SSE2:
        return _sse2_fwsThreshold_GT_64fc(pSrc, pDst, len, level);
    case DT_REFR:
        return _refr_fwsThreshold_GT_64fc(pSrc, pDst, len, level);
    default:
        assert(false);
        return _refr_fwsThreshold_GT_64fc(pSrc, pDst, len, level);
    }
}

OREFR             FwStatus STDCALL fwsSin_32f_A21(const Fw32f* pSrc, Fw32f* pDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwsSin_32f_A21(pSrc, pDst, len);
    default:
        assert(false);
        return _refr_fwsSin_32f_A21(pSrc, pDst, len);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsSqrt_16s_Sfs(const Fw16s* pSrc, Fw16s* pDst, int len, int scaleFactor)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsSqrt_16s_Sfs(pSrc, pDst, len, scaleFactor);
    case DT_SSE2:
        return _sse2_fwsSqrt_16s_Sfs(pSrc, pDst, len, scaleFactor);
    case DT_REFR:
        return _refr_fwsSqrt_16s_Sfs(pSrc, pDst, len, scaleFactor);
    default:
        assert(false);
        return _refr_fwsSqrt_16s_Sfs(pSrc, pDst, len, scaleFactor);
    }
}

OREFR OSSE2 FwStatus STDCALL fwsMaxIndx_16s(const Fw16s* pSrc, int len, Fw16s* pMax, int* pIndx)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwsMaxIndx_16s(pSrc, len, pMax, pIndx);
    case DT_REFR:
        return _refr_fwsMaxIndx_16s(pSrc, len, pMax, pIndx);
    default:
        assert(false);
        return _refr_fwsMaxIndx_16s(pSrc, len, pMax, pIndx);
    }
}

OREFR OSSE2 FwStatus STDCALL fwsNorm_L2_32f(const Fw32f* pSrc, int len, Fw32f* pNorm)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwsNorm_L2_32f(pSrc, len, pNorm);
    case DT_REFR:
        return _refr_fwsNorm_L2_32f(pSrc, len, pNorm);
    default:
        assert(false);
        return _refr_fwsNorm_L2_32f(pSrc, len, pNorm);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsThreshold_32fc_I(Fw32fc* pSrcDst, int len, Fw32f level, FwCmpOp relOp)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsThreshold_32fc_I(pSrcDst, len, level, relOp);
    case DT_SSE2:
        return _sse2_fwsThreshold_32fc_I(pSrcDst, len, level, relOp);
    case DT_REFR:
        return _refr_fwsThreshold_32fc_I(pSrcDst, len, level, relOp);
    default:
        assert(false);
        return _refr_fwsThreshold_32fc_I(pSrcDst, len, level, relOp);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsThreshold_LT_16sc_I(Fw16sc* pSrcDst, int len, Fw16s level)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsThreshold_LT_16sc_I(pSrcDst, len, level);
    case DT_SSE2:
        return _sse2_fwsThreshold_LT_16sc_I(pSrcDst, len, level);
    case DT_REFR:
        return _refr_fwsThreshold_LT_16sc_I(pSrcDst, len, level);
    default:
        assert(false);
        return _refr_fwsThreshold_LT_16sc_I(pSrcDst, len, level);
    }
}

OREFR OSSE2     FwStatus STDCALL fwsMax_8s( const Fw8s  *pSrc, int len, Fw8s  *pMax )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwsMax_8s(pSrc, len, pMax);
    case DT_REFR:
        return _refr_fwsMax_8s(pSrc, len, pMax);
    default:
        assert(false);
        return _refr_fwsMax_8s(pSrc, len, pMax);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsThreshold_64f_I(Fw64f* pSrcDst, int len, Fw64f level, FwCmpOp relOp)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsThreshold_64f_I(pSrcDst, len, level, relOp);
    case DT_SSE2:
        return _sse2_fwsThreshold_64f_I(pSrcDst, len, level, relOp);
    case DT_REFR:
        return _refr_fwsThreshold_64f_I(pSrcDst, len, level, relOp);
    default:
        assert(false);
        return _refr_fwsThreshold_64f_I(pSrcDst, len, level, relOp);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsConvert_32f64f(const Fw32f* pSrc, Fw64f* pDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsConvert_32f64f(pSrc, pDst, len);
    case DT_SSE2:
        return _sse2_fwsConvert_32f64f(pSrc, pDst, len);
    case DT_REFR:
        return _refr_fwsConvert_32f64f(pSrc, pDst, len);
    default:
        assert(false);
        return _refr_fwsConvert_32f64f(pSrc, pDst, len);
    }
}

OREFR OSSE2 FwStatus STDCALL fwsMinAbs_16s(const Fw16s* pSrc, int len, Fw16s* pMinAbs)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwsMinAbs_16s(pSrc, len, pMinAbs);
    case DT_REFR:
        return _refr_fwsMinAbs_16s(pSrc, len, pMinAbs);
    default:
        assert(false);
        return _refr_fwsMinAbs_16s(pSrc, len, pMinAbs);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsZero_32f(Fw32f* pDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsZero_32f(pDst, len);
    case DT_SSE2:
        return _sse2_fwsZero_32f(pDst, len);
    case DT_REFR:
        return _refr_fwsZero_32f(pDst, len);
    default:
        assert(false);
        return _refr_fwsZero_32f(pDst, len);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsMul_16s(const Fw16s* pSrc1, const Fw16s* pSrc2, Fw16s *pDst,int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsMul_16s(pSrc1, pSrc2, pDst, len);
    case DT_SSE2:
        return _sse2_fwsMul_16s(pSrc1, pSrc2, pDst, len);
    case DT_REFR:
        return _refr_fwsMul_16s(pSrc1, pSrc2, pDst, len);
    default:
        assert(false);
        return _refr_fwsMul_16s(pSrc1, pSrc2, pDst, len);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsThreshold_LTVal_32f_I(Fw32f* pSrcDst, int len, Fw32f level, Fw32f value)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsThreshold_LTVal_32f_I(pSrcDst, len, level, value);
    case DT_SSE2:
        return _sse2_fwsThreshold_LTVal_32f_I(pSrcDst, len, level, value);
    case DT_REFR:
        return _refr_fwsThreshold_LTVal_32f_I(pSrcDst, len, level, value);
    default:
        assert(false);
        return _refr_fwsThreshold_LTVal_32f_I(pSrcDst, len, level, value);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsAbs_16s_I(Fw16s* pSrcDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsAbs_16s_I(pSrcDst, len);
    case DT_SSE2:
        return _sse2_fwsAbs_16s_I(pSrcDst, len);
    case DT_REFR:
        return _refr_fwsAbs_16s_I(pSrcDst, len);
    default:
        assert(false);
        return _refr_fwsAbs_16s_I(pSrcDst, len);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsConvert_64s32s_Sfs(const Fw64s* pSrc, Fw32s* pDst, int len, FwRoundMode rndMode, int scaleFactor)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsConvert_64s32s_Sfs(pSrc, pDst, len, rndMode, scaleFactor);
    case DT_SSE2:
        return _sse2_fwsConvert_64s32s_Sfs(pSrc, pDst, len, rndMode, scaleFactor);
    case DT_REFR:
        return _refr_fwsConvert_64s32s_Sfs(pSrc, pDst, len, rndMode, scaleFactor);
    default:
        assert(false);
        return _refr_fwsConvert_64s32s_Sfs(pSrc, pDst, len, rndMode, scaleFactor);
    }
}

OREFR             FwStatus STDCALL fwsSinh_32f_A11(const Fw32f* pSrc, Fw32f* pDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwsSinh_32f_A11(pSrc, pDst, len);
    default:
        assert(false);
        return _refr_fwsSinh_32f_A11(pSrc, pDst, len);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsCopy_32f(const Fw32f* pSrc, Fw32f* pDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsCopy_32f(pSrc, pDst, len);
    case DT_SSE2:
        return _sse2_fwsCopy_32f(pSrc, pDst, len);
    case DT_REFR:
        return _refr_fwsCopy_32f(pSrc, pDst, len);
    default:
        assert(false);
        return _refr_fwsCopy_32f(pSrc, pDst, len);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsOrC_16u(const Fw16u* pSrc, Fw16u val, Fw16u* pDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsOrC_16u(pSrc, val, pDst, len);
    case DT_SSE2:
        return _sse2_fwsOrC_16u(pSrc, val, pDst, len);
    case DT_REFR:
        return _refr_fwsOrC_16u(pSrc, val, pDst, len);
    default:
        assert(false);
        return _refr_fwsOrC_16u(pSrc, val, pDst, len);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsMul_16u16s_Sfs(const Fw16u* pSrc1, const Fw16s* pSrc2, Fw16s *pDst, int len, int scaleFactor)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsMul_16u16s_Sfs(pSrc1, pSrc2, pDst, len, scaleFactor);
    case DT_SSE2:
        return _sse2_fwsMul_16u16s_Sfs(pSrc1, pSrc2, pDst, len, scaleFactor);
    case DT_REFR:
        return _refr_fwsMul_16u16s_Sfs(pSrc1, pSrc2, pDst, len, scaleFactor);
    default:
        assert(false);
        return _refr_fwsMul_16u16s_Sfs(pSrc1, pSrc2, pDst, len, scaleFactor);
    }
}

OREFR OSSE2 FwStatus STDCALL fwsMean_16sc_Sfs(const Fw16sc* pSrc, int len, Fw16sc* pMean, int scaleFactor)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwsMean_16sc_Sfs(pSrc, len, pMean, scaleFactor);
    case DT_REFR:
        return _refr_fwsMean_16sc_Sfs(pSrc, len, pMean, scaleFactor);
    default:
        assert(false);
        return _refr_fwsMean_16sc_Sfs(pSrc, len, pMean, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsAddC_16sc_Sfs(const Fw16sc* pSrc, Fw16sc val, Fw16sc* pDst, int len, int scaleFactor)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsAddC_16sc_Sfs(pSrc, val, pDst, len, scaleFactor);
    case DT_SSE2:
        return _sse2_fwsAddC_16sc_Sfs(pSrc, val, pDst, len, scaleFactor);
    case DT_REFR:
        return _refr_fwsAddC_16sc_Sfs(pSrc, val, pDst, len, scaleFactor);
    default:
        assert(false);
        return _refr_fwsAddC_16sc_Sfs(pSrc, val, pDst, len, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsSubCRev_16s_Sfs(const Fw16s* pSrc, Fw16s val, Fw16s* pDst, int len, int scaleFactor)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsSubCRev_16s_Sfs(pSrc, val, pDst, len, scaleFactor);
    case DT_SSE2:
        return _sse2_fwsSubCRev_16s_Sfs(pSrc, val, pDst, len, scaleFactor);
    case DT_REFR:
        return _refr_fwsSubCRev_16s_Sfs(pSrc, val, pDst, len, scaleFactor);
    default:
        assert(false);
        return _refr_fwsSubCRev_16s_Sfs(pSrc, val, pDst, len, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsOrC_32u_I(Fw32u val, Fw32u* pSrcDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsOrC_32u_I(val, pSrcDst, len);
    case DT_SSE2:
        return _sse2_fwsOrC_32u_I(val, pSrcDst, len);
    case DT_REFR:
        return _refr_fwsOrC_32u_I(val, pSrcDst, len);
    default:
        assert(false);
        return _refr_fwsOrC_32u_I(val, pSrcDst, len);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsXor_8u_I(const Fw8u* pSrc, Fw8u* pSrcDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsXor_8u_I(pSrc, pSrcDst, len);
    case DT_SSE2:
        return _sse2_fwsXor_8u_I(pSrc, pSrcDst, len);
    case DT_REFR:
        return _refr_fwsXor_8u_I(pSrc, pSrcDst, len);
    default:
        assert(false);
        return _refr_fwsXor_8u_I(pSrc, pSrcDst, len);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsSqr_64fc(const Fw64fc* pSrc, Fw64fc* pDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsSqr_64fc(pSrc, pDst, len);
    case DT_SSE2:
        return _sse2_fwsSqr_64fc(pSrc, pDst, len);
    case DT_REFR:
        return _refr_fwsSqr_64fc(pSrc, pDst, len);
    default:
        assert(false);
        return _refr_fwsSqr_64fc(pSrc, pDst, len);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsLn_32s_Sfs(const Fw32s* pSrc, Fw32s* pDst, int len, int scaleFactor)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsLn_32s_Sfs(pSrc, pDst, len, scaleFactor);
    case DT_SSE2:
        return _sse2_fwsLn_32s_Sfs(pSrc, pDst, len, scaleFactor);
    case DT_REFR:
        return _refr_fwsLn_32s_Sfs(pSrc, pDst, len, scaleFactor);
    default:
        assert(false);
        return _refr_fwsLn_32s_Sfs(pSrc, pDst, len, scaleFactor);
    }
}

OREFR             FwStatus STDCALL fwsCos_32f_A11(const Fw32f* pSrc, Fw32f* pDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwsCos_32f_A11(pSrc, pDst, len);
    default:
        assert(false);
        return _refr_fwsCos_32f_A11(pSrc, pDst, len);
    }
}

OREFR             FwStatus STDCALL fwsTanh_32f_A11(const Fw32f* pSrc, Fw32f* pDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwsTanh_32f_A11(pSrc, pDst, len);
    default:
        assert(false);
        return _refr_fwsTanh_32f_A11(pSrc, pDst, len);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsThreshold_LTVal_16sc_I(Fw16sc* pSrcDst, int len, Fw16s level, Fw16sc value)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsThreshold_LTVal_16sc_I(pSrcDst, len, level, value);
    case DT_SSE2:
        return _sse2_fwsThreshold_LTVal_16sc_I(pSrcDst, len, level, value);
    case DT_REFR:
        return _refr_fwsThreshold_LTVal_16sc_I(pSrcDst, len, level, value);
    default:
        assert(false);
        return _refr_fwsThreshold_LTVal_16sc_I(pSrcDst, len, level, value);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsThreshold_LTInv_64f_I(Fw64f* pSrcDst, int len, Fw64f level)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsThreshold_LTInv_64f_I(pSrcDst, len, level);
    case DT_SSE2:
        return _sse2_fwsThreshold_LTInv_64f_I(pSrcDst, len, level);
    case DT_REFR:
        return _refr_fwsThreshold_LTInv_64f_I(pSrcDst, len, level);
    default:
        assert(false);
        return _refr_fwsThreshold_LTInv_64f_I(pSrcDst, len, level);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsAnd_16u_I(const Fw16u* pSrc, Fw16u* pSrcDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsAnd_16u_I(pSrc, pSrcDst, len);
    case DT_SSE2:
        return _sse2_fwsAnd_16u_I(pSrc, pSrcDst, len);
    case DT_REFR:
        return _refr_fwsAnd_16u_I(pSrc, pSrcDst, len);
    default:
        assert(false);
        return _refr_fwsAnd_16u_I(pSrc, pSrcDst, len);
    }
}

OREFR OSSE2 FwStatus STDCALL fwsDotProd_16s64s(const Fw16s* pSrc1, const Fw16s* pSrc2, int len,Fw64s* pDp)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwsDotProd_16s64s(pSrc1, pSrc2, len, pDp);
    case DT_REFR:
        return _refr_fwsDotProd_16s64s(pSrc1, pSrc2, len, pDp);
    default:
        assert(false);
        return _refr_fwsDotProd_16s64s(pSrc1, pSrc2, len, pDp);
    }
}

OREFR OSSE2 FwStatus STDCALL fwsDotProd_16sc32sc_Sfs(const Fw16sc* pSrc1, const Fw16sc* pSrc2,int len, Fw32sc* pDp, int scaleFactor)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwsDotProd_16sc32sc_Sfs(pSrc1, pSrc2, len, pDp, scaleFactor);
    case DT_REFR:
        return _refr_fwsDotProd_16sc32sc_Sfs(pSrc1, pSrc2, len, pDp, scaleFactor);
    default:
        assert(false);
        return _refr_fwsDotProd_16sc32sc_Sfs(pSrc1, pSrc2, len, pDp, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsMulC_16sc_Sfs(const Fw16sc* pSrc, Fw16sc val, Fw16sc* pDst, int len, int scaleFactor)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsMulC_16sc_Sfs(pSrc, val, pDst, len, scaleFactor);
    case DT_SSE2:
        return _sse2_fwsMulC_16sc_Sfs(pSrc, val, pDst, len, scaleFactor);
    case DT_REFR:
        return _refr_fwsMulC_16sc_Sfs(pSrc, val, pDst, len, scaleFactor);
    default:
        assert(false);
        return _refr_fwsMulC_16sc_Sfs(pSrc, val, pDst, len, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsDiv_64f(const Fw64f* pSrc1, const Fw64f* pSrc2, Fw64f* pDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsDiv_64f(pSrc1, pSrc2, pDst, len);
    case DT_SSE2:
        return _sse2_fwsDiv_64f(pSrc1, pSrc2, pDst, len);
    case DT_REFR:
        return _refr_fwsDiv_64f(pSrc1, pSrc2, pDst, len);
    default:
        assert(false);
        return _refr_fwsDiv_64f(pSrc1, pSrc2, pDst, len);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsThreshold_LTVal_64fc_I(Fw64fc* pSrcDst, int len, Fw64f level, Fw64fc value)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsThreshold_LTVal_64fc_I(pSrcDst, len, level, value);
    case DT_SSE2:
        return _sse2_fwsThreshold_LTVal_64fc_I(pSrcDst, len, level, value);
    case DT_REFR:
        return _refr_fwsThreshold_LTVal_64fc_I(pSrcDst, len, level, value);
    default:
        assert(false);
        return _refr_fwsThreshold_LTVal_64fc_I(pSrcDst, len, level, value);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsDiv_32s_ISfs(const Fw32s* pSrc, Fw32s* pSrcDst, int len, int scaleFactor)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsDiv_32s_ISfs(pSrc, pSrcDst, len, scaleFactor);
    case DT_SSE2:
        return _sse2_fwsDiv_32s_ISfs(pSrc, pSrcDst, len, scaleFactor);
    case DT_REFR:
        return _refr_fwsDiv_32s_ISfs(pSrc, pSrcDst, len, scaleFactor);
    default:
        assert(false);
        return _refr_fwsDiv_32s_ISfs(pSrc, pSrcDst, len, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsLn_16s_Sfs(const Fw16s* pSrc, Fw16s* pDst, int len, int scaleFactor)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsLn_16s_Sfs(pSrc, pDst, len, scaleFactor);
    case DT_SSE2:
        return _sse2_fwsLn_16s_Sfs(pSrc, pDst, len, scaleFactor);
    case DT_REFR:
        return _refr_fwsLn_16s_Sfs(pSrc, pDst, len, scaleFactor);
    default:
        assert(false);
        return _refr_fwsLn_16s_Sfs(pSrc, pDst, len, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsXorC_32u(const Fw32u* pSrc, Fw32u val, Fw32u* pDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsXorC_32u(pSrc, val, pDst, len);
    case DT_SSE2:
        return _sse2_fwsXorC_32u(pSrc, val, pDst, len);
    case DT_REFR:
        return _refr_fwsXorC_32u(pSrc, val, pDst, len);
    default:
        assert(false);
        return _refr_fwsXorC_32u(pSrc, val, pDst, len);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsMul_32s_ISfs(const Fw32s* pSrc, Fw32s* pSrcDst, int len, int scaleFactor)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsMul_32s_ISfs(pSrc, pSrcDst, len, scaleFactor);
    case DT_SSE2:
        return _sse2_fwsMul_32s_ISfs(pSrc, pSrcDst, len, scaleFactor);
    case DT_REFR:
        return _refr_fwsMul_32s_ISfs(pSrc, pSrcDst, len, scaleFactor);
    default:
        assert(false);
        return _refr_fwsMul_32s_ISfs(pSrc, pSrcDst, len, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsMove_64fc(const Fw64fc* pSrc, Fw64fc* pDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsMove_64fc(pSrc, pDst, len);
    case DT_SSE2:
        return _sse2_fwsMove_64fc(pSrc, pDst, len);
    case DT_REFR:
        return _refr_fwsMove_64fc(pSrc, pDst, len);
    default:
        assert(false);
        return _refr_fwsMove_64fc(pSrc, pDst, len);
    }
}

OREFR             FwStatus STDCALL fwsSin_32f_A11(const Fw32f* pSrc, Fw32f* pDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwsSin_32f_A11(pSrc, pDst, len);
    default:
        assert(false);
        return _refr_fwsSin_32f_A11(pSrc, pDst, len);
    }
}

OREFR FwStatus STDCALL fwsFindRev_16u(const Fw16u* pSrc, int len, const Fw16u* pFind, int lenFind, int* pIndex)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwsFindRev_16u(pSrc, len, pFind, lenFind, pIndex);
    default:
        assert(false);
        return _refr_fwsFindRev_16u(pSrc, len, pFind, lenFind, pIndex);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsExp_64f_I(Fw64f* pSrcDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsExp_64f_I(pSrcDst, len);
    case DT_SSE2:
        return _sse2_fwsExp_64f_I(pSrcDst, len);
    case DT_REFR:
        return _refr_fwsExp_64f_I(pSrcDst, len);
    default:
        assert(false);
        return _refr_fwsExp_64f_I(pSrcDst, len);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsDiv_32f_A21(const Fw32f* pSrc1, const Fw32f* pSrc2, Fw32f* pDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsDiv_32f_A21(pSrc1, pSrc2, pDst, len);
    case DT_SSE2:
        return _sse2_fwsDiv_32f_A21(pSrc1, pSrc2, pDst, len);
    case DT_REFR:
        return _refr_fwsDiv_32f_A21(pSrc1, pSrc2, pDst, len);
    default:
        assert(false);
        return _refr_fwsDiv_32f_A21(pSrc1, pSrc2, pDst, len);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsSub_8u_Sfs(const Fw8u* pSrc1, const Fw8u* pSrc2, Fw8u* pDst, int len, int scaleFactor)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsSub_8u_Sfs(pSrc1, pSrc2, pDst, len, scaleFactor);
    case DT_SSE2:
        return _sse2_fwsSub_8u_Sfs(pSrc1, pSrc2, pDst, len, scaleFactor);
    case DT_REFR:
        return _refr_fwsSub_8u_Sfs(pSrc1, pSrc2, pDst, len, scaleFactor);
    default:
        assert(false);
        return _refr_fwsSub_8u_Sfs(pSrc1, pSrc2, pDst, len, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsAddC_32fc_I(Fw32fc val, Fw32fc* pSrcDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsAddC_32fc_I(val, pSrcDst, len);
    case DT_SSE2:
        return _sse2_fwsAddC_32fc_I(val, pSrcDst, len);
    case DT_REFR:
        return _refr_fwsAddC_32fc_I(val, pSrcDst, len);
    default:
        assert(false);
        return _refr_fwsAddC_32fc_I(val, pSrcDst, len);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsThreshold_LTVal_64fc(const Fw64fc* pSrc, Fw64fc* pDst, int len, Fw64f level, Fw64fc value)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsThreshold_LTVal_64fc(pSrc, pDst, len, level, value);
    case DT_SSE2:
        return _sse2_fwsThreshold_LTVal_64fc(pSrc, pDst, len, level, value);
    case DT_REFR:
        return _refr_fwsThreshold_LTVal_64fc(pSrc, pDst, len, level, value);
    default:
        assert(false);
        return _refr_fwsThreshold_LTVal_64fc(pSrc, pDst, len, level, value);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsZero_16s(Fw16s* pDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsZero_16s(pDst, len);
    case DT_SSE2:
        return _sse2_fwsZero_16s(pDst, len);
    case DT_REFR:
        return _refr_fwsZero_16s(pDst, len);
    default:
        assert(false);
        return _refr_fwsZero_16s(pDst, len);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsLShiftC_16u(const Fw16u* pSrc, int val, Fw16u* pDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsLShiftC_16u(pSrc, val, pDst, len);
    case DT_SSE2:
        return _sse2_fwsLShiftC_16u(pSrc, val, pDst, len);
    case DT_REFR:
        return _refr_fwsLShiftC_16u(pSrc, val, pDst, len);
    default:
        assert(false);
        return _refr_fwsLShiftC_16u(pSrc, val, pDst, len);
    }
}


OREFR             FwStatus STDCALL fwsTan_32f_A11(const Fw32f* pSrc, Fw32f* pDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwsTan_32f_A11(pSrc, pDst, len);
    default:
        assert(false);
        return _refr_fwsTan_32f_A11(pSrc, pDst, len);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsLShiftC_16s(const Fw16s* pSrc, int val, Fw16s* pDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsLShiftC_16s(pSrc, val, pDst, len);
    case DT_SSE2:
        return _sse2_fwsLShiftC_16s(pSrc, val, pDst, len);
    case DT_REFR:
        return _refr_fwsLShiftC_16s(pSrc, val, pDst, len);
    default:
        assert(false);
        return _refr_fwsLShiftC_16s(pSrc, val, pDst, len);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsThreshold_GT_64fc_I(Fw64fc* pSrcDst, int len, Fw64f level)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsThreshold_GT_64fc_I(pSrcDst, len, level);
    case DT_SSE2:
        return _sse2_fwsThreshold_GT_64fc_I(pSrcDst, len, level);
    case DT_REFR:
        return _refr_fwsThreshold_GT_64fc_I(pSrcDst, len, level);
    default:
        assert(false);
        return _refr_fwsThreshold_GT_64fc_I(pSrcDst, len, level);
    }
}

OREFR FwStatus STDCALL fwsMin_64u( const Fw64u *pSrc, int len, Fw64u *pMin )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwsMin_64u(pSrc, len, pMin);
    default:
        assert(false);
        return _refr_fwsMin_64u(pSrc, len, pMin);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsAdd_32f(const Fw32f* pSrc1, const Fw32f* pSrc2, Fw32f* pDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsAdd_32f(pSrc1, pSrc2, pDst, len);
    case DT_SSE2:
        return _sse2_fwsAdd_32f(pSrc1, pSrc2, pDst, len);
    case DT_REFR:
        return _refr_fwsAdd_32f(pSrc1, pSrc2, pDst, len);
    default:
        assert(false);
        return _refr_fwsAdd_32f(pSrc1, pSrc2, pDst, len);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsSqr_16s_Sfs(const Fw16s* pSrc, Fw16s* pDst, int len,int scaleFactor)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsSqr_16s_Sfs(pSrc, pDst, len, scaleFactor);
    case DT_SSE2:
        return _sse2_fwsSqr_16s_Sfs(pSrc, pDst, len, scaleFactor);
    case DT_REFR:
        return _refr_fwsSqr_16s_Sfs(pSrc, pDst, len, scaleFactor);
    default:
        assert(false);
        return _refr_fwsSqr_16s_Sfs(pSrc, pDst, len, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsAdd_8u_ISfs(const Fw8u* pSrc, Fw8u* pSrcDst, int len, int scaleFactor)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsAdd_8u_ISfs(pSrc, pSrcDst, len, scaleFactor);
    case DT_SSE2:
        return _sse2_fwsAdd_8u_ISfs(pSrc, pSrcDst, len, scaleFactor);
    case DT_REFR:
        return _refr_fwsAdd_8u_ISfs(pSrc, pSrcDst, len, scaleFactor);
    default:
        assert(false);
        return _refr_fwsAdd_8u_ISfs(pSrc, pSrcDst, len, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsDiv_8u_Sfs(const Fw8u* pSrc1, const Fw8u* pSrc2, Fw8u* pDst, int len, int scaleFactor)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsDiv_8u_Sfs(pSrc1, pSrc2, pDst, len, scaleFactor);
    case DT_SSE2:
        return _sse2_fwsDiv_8u_Sfs(pSrc1, pSrc2, pDst, len, scaleFactor);
    case DT_REFR:
        return _refr_fwsDiv_8u_Sfs(pSrc1, pSrc2, pDst, len, scaleFactor);
    default:
        assert(false);
        return _refr_fwsDiv_8u_Sfs(pSrc1, pSrc2, pDst, len, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsThreshold_LT_32fc(const Fw32fc* pSrc, Fw32fc* pDst, int len, Fw32f level)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsThreshold_LT_32fc(pSrc, pDst, len, level);
    case DT_SSE2:
        return _sse2_fwsThreshold_LT_32fc(pSrc, pDst, len, level);
    case DT_REFR:
        return _refr_fwsThreshold_LT_32fc(pSrc, pDst, len, level);
    default:
        assert(false);
        return _refr_fwsThreshold_LT_32fc(pSrc, pDst, len, level);
    }
}

OREFR OSSE2 FwStatus STDCALL fwsMin_16s(const Fw16s* pSrc, int len, Fw16s* pMin)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwsMin_16s(pSrc, len, pMin);
    case DT_REFR:
        return _refr_fwsMin_16s(pSrc, len, pMin);
    default:
        assert(false);
        return _refr_fwsMin_16s(pSrc, len, pMin);
    }
}

OREFR OSSE2 FwStatus STDCALL fwsMinMax_8u(const Fw8u* pSrc, int len, Fw8u* pMin, Fw8u* pMax)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwsMinMax_8u(pSrc, len, pMin, pMax);
    case DT_REFR:
        return _refr_fwsMinMax_8u(pSrc, len, pMin, pMax);
    default:
        assert(false);
        return _refr_fwsMinMax_8u(pSrc, len, pMin, pMax);
    }
}

OREFR OSSE2 FwStatus STDCALL fwsMin_64f(const Fw64f* pSrc, int len, Fw64f* pMin)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwsMin_64f(pSrc, len, pMin);
    case DT_REFR:
        return _refr_fwsMin_64f(pSrc, len, pMin);
    default:
        assert(false);
        return _refr_fwsMin_64f(pSrc, len, pMin);
    }
}

OREFR OSSE2 FwStatus STDCALL fwsNormDiff_Inf_64f(const Fw64f* pSrc1, const Fw64f* pSrc2, int len,Fw64f* pNorm)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwsNormDiff_Inf_64f(pSrc1, pSrc2, len, pNorm);
    case DT_REFR:
        return _refr_fwsNormDiff_Inf_64f(pSrc1, pSrc2, len, pNorm);
    default:
        assert(false);
        return _refr_fwsNormDiff_Inf_64f(pSrc1, pSrc2, len, pNorm);
    }
}



OREFR             FwStatus STDCALL fwsAdd_32u(const Fw32u* pSrc1, const Fw32u* pSrc2, Fw32u* pDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwsAdd_32u(pSrc1, pSrc2, pDst, len);
    default:
        assert(false);
        return _refr_fwsAdd_32u(pSrc1, pSrc2, pDst, len);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsDiv_32s_Sfs(const Fw32s* pSrc1, const Fw32s* pSrc2, Fw32s* pDst,int len, int scaleFactor)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsDiv_32s_Sfs(pSrc1, pSrc2, pDst, len, scaleFactor);
    case DT_SSE2:
        return _sse2_fwsDiv_32s_Sfs(pSrc1, pSrc2, pDst, len, scaleFactor);
    case DT_REFR:
        return _refr_fwsDiv_32s_Sfs(pSrc1, pSrc2, pDst, len, scaleFactor);
    default:
        assert(false);
        return _refr_fwsDiv_32s_Sfs(pSrc1, pSrc2, pDst, len, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsXor_16u(const Fw16u* pSrc1, const Fw16u* pSrc2, Fw16u* pDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsXor_16u(pSrc1, pSrc2, pDst, len);
    case DT_SSE2:
        return _sse2_fwsXor_16u(pSrc1, pSrc2, pDst, len);
    case DT_REFR:
        return _refr_fwsXor_16u(pSrc1, pSrc2, pDst, len);
    default:
        assert(false);
        return _refr_fwsXor_16u(pSrc1, pSrc2, pDst, len);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsThreshold_64fc_I(Fw64fc* pSrcDst, int len, Fw64f level, FwCmpOp relOp)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsThreshold_64fc_I(pSrcDst, len, level, relOp);
    case DT_SSE2:
        return _sse2_fwsThreshold_64fc_I(pSrcDst, len, level, relOp);
    case DT_REFR:
        return _refr_fwsThreshold_64fc_I(pSrcDst, len, level, relOp);
    default:
        assert(false);
        return _refr_fwsThreshold_64fc_I(pSrcDst, len, level, relOp);
    }
}

OREFR OSSE2 FwStatus STDCALL fwsSum_32f(const Fw32f* pSrc, int len, Fw32f* pSum, FwHintAlgorithm hint)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwsSum_32f(pSrc, len, pSum, hint);
    case DT_REFR:
        return _refr_fwsSum_32f(pSrc, len, pSum, hint);
    default:
        assert(false);
        return _refr_fwsSum_32f(pSrc, len, pSum, hint);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsThreshold_GTVal_32f_I(Fw32f* pSrcDst, int len, Fw32f level, Fw32f value)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsThreshold_GTVal_32f_I(pSrcDst, len, level, value);
    case DT_SSE2:
        return _sse2_fwsThreshold_GTVal_32f_I(pSrcDst, len, level, value);
    case DT_REFR:
        return _refr_fwsThreshold_GTVal_32f_I(pSrcDst, len, level, value);
    default:
        assert(false);
        return _refr_fwsThreshold_GTVal_32f_I(pSrcDst, len, level, value);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsMulC_64f_I(Fw64f val, Fw64f* pSrcDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsMulC_64f_I(val, pSrcDst, len);
    case DT_SSE2:
        return _sse2_fwsMulC_64f_I(val, pSrcDst, len);
    case DT_REFR:
        return _refr_fwsMulC_64f_I(val, pSrcDst, len);
    default:
        assert(false);
        return _refr_fwsMulC_64f_I(val, pSrcDst, len);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsMulC_32sc_Sfs(const Fw32sc* pSrc, Fw32sc val, Fw32sc* pDst, int len, int scaleFactor)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsMulC_32sc_Sfs(pSrc, val, pDst, len, scaleFactor);
    case DT_SSE2:
        return _sse2_fwsMulC_32sc_Sfs(pSrc, val, pDst, len, scaleFactor);
    case DT_REFR:
        return _refr_fwsMulC_32sc_Sfs(pSrc, val, pDst, len, scaleFactor);
    default:
        assert(false);
        return _refr_fwsMulC_32sc_Sfs(pSrc, val, pDst, len, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsNot_8u_I(Fw8u* pSrcDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsNot_8u_I(pSrcDst, len);
    case DT_SSE2:
        return _sse2_fwsNot_8u_I(pSrcDst, len);
    case DT_REFR:
        return _refr_fwsNot_8u_I(pSrcDst, len);
    default:
        assert(false);
        return _refr_fwsNot_8u_I(pSrcDst, len);
    }
}

OREFR             FwStatus STDCALL fwsSinh_32f_A24(const Fw32f* pSrc, Fw32f* pDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwsSinh_32f_A24(pSrc, pDst, len);
    default:
        assert(false);
        return _refr_fwsSinh_32f_A24(pSrc, pDst, len);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsDiv_16sc_ISfs(const Fw16sc* pSrc, Fw16sc* pSrcDst, int len, int scaleFactor)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsDiv_16sc_ISfs(pSrc, pSrcDst, len, scaleFactor);
    case DT_SSE2:
        return _sse2_fwsDiv_16sc_ISfs(pSrc, pSrcDst, len, scaleFactor);
    case DT_REFR:
        return _refr_fwsDiv_16sc_ISfs(pSrc, pSrcDst, len, scaleFactor);
    default:
        assert(false);
        return _refr_fwsDiv_16sc_ISfs(pSrc, pSrcDst, len, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsInvSqrt_32f_A21(const Fw32f* pSrc, Fw32f* pDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsInvSqrt_32f_A21(pSrc, pDst, len);
    case DT_SSE2:
        return _sse2_fwsInvSqrt_32f_A21(pSrc, pDst, len);
    case DT_REFR:
        return _refr_fwsInvSqrt_32f_A21(pSrc, pDst, len);
    default:
        assert(false);
        return _refr_fwsInvSqrt_32f_A21(pSrc, pDst, len);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsPowx_32f_A11(const Fw32f* pSrc1, const Fw32f val, Fw32f* pDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsPowx_32f_A11(pSrc1, val, pDst, len);
    case DT_SSE2:
        return _sse2_fwsPowx_32f_A11(pSrc1, val, pDst, len);
    case DT_REFR:
        return _refr_fwsPowx_32f_A11(pSrc1, val, pDst, len);
    default:
        assert(false);
        return _refr_fwsPowx_32f_A11(pSrc1, val, pDst, len);
    }
}

OREFR OSSE2 FwStatus STDCALL fwsDotProd_32sc_Sfs(const Fw32sc* pSrc1, const Fw32sc* pSrc2, int len, Fw32sc* pDp, int scaleFactor)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwsDotProd_32sc_Sfs(pSrc1, pSrc2, len, pDp, scaleFactor);
    case DT_REFR:
        return _refr_fwsDotProd_32sc_Sfs(pSrc1, pSrc2, len, pDp, scaleFactor);
    default:
        assert(false);
        return _refr_fwsDotProd_32sc_Sfs(pSrc1, pSrc2, len, pDp, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsMagnitude_16s32f(const Fw16s* pSrcRe, const Fw16s* pSrcIm, Fw32f* pDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsMagnitude_16s32f(pSrcRe, pSrcIm, pDst, len);
    case DT_SSE2:
        return _sse2_fwsMagnitude_16s32f(pSrcRe, pSrcIm, pDst, len);
    case DT_REFR:
        return _refr_fwsMagnitude_16s32f(pSrcRe, pSrcIm, pDst, len);
    default:
        assert(false);
        return _refr_fwsMagnitude_16s32f(pSrcRe, pSrcIm, pDst, len);
    }
}

OREFR OSSE2 FwStatus STDCALL fwsNorm_L2_16s32s_Sfs(const Fw16s* pSrc, int len, Fw32s* pNorm, int scaleFactor)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwsNorm_L2_16s32s_Sfs(pSrc, len, pNorm, scaleFactor);
    case DT_REFR:
        return _refr_fwsNorm_L2_16s32s_Sfs(pSrc, len, pNorm, scaleFactor);
    default:
        assert(false);
        return _refr_fwsNorm_L2_16s32s_Sfs(pSrc, len, pNorm, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsSet_16sc(Fw16sc val, Fw16sc* pDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsSet_16sc(val, pDst, len);
    case DT_SSE2:
        return _sse2_fwsSet_16sc(val, pDst, len);
    case DT_REFR:
        return _refr_fwsSet_16sc(val, pDst, len);
    default:
        assert(false);
        return _refr_fwsSet_16sc(val, pDst, len);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsLog10_64f_A53(const Fw64f* pSrc, Fw64f* pDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsLog10_64f_A53(pSrc, pDst, len);
    case DT_SSE2:
        return _sse2_fwsLog10_64f_A53(pSrc, pDst, len);
    case DT_REFR:
        return _refr_fwsLog10_64f_A53(pSrc, pDst, len);
    default:
        assert(false);
        return _refr_fwsLog10_64f_A53(pSrc, pDst, len);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsMulC_Low_32f16s(const Fw32f* pSrc, Fw32f val, Fw16s* pDst,int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsMulC_Low_32f16s(pSrc, val, pDst, len);
    case DT_SSE2:
        return _sse2_fwsMulC_Low_32f16s(pSrc, val, pDst, len);
    case DT_REFR:
        return _refr_fwsMulC_Low_32f16s(pSrc, val, pDst, len);
    default:
        assert(false);
        return _refr_fwsMulC_Low_32f16s(pSrc, val, pDst, len);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsLog10_64f_A50(const Fw64f* pSrc, Fw64f* pDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsLog10_64f_A50(pSrc, pDst, len);
    case DT_SSE2:
        return _sse2_fwsLog10_64f_A50(pSrc, pDst, len);
    case DT_REFR:
        return _refr_fwsLog10_64f_A50(pSrc, pDst, len);
    default:
        assert(false);
        return _refr_fwsLog10_64f_A50(pSrc, pDst, len);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsMul_16sc_Sfs(const Fw16sc* pSrc1, const Fw16sc* pSrc2, Fw16sc *pDst, int len, int scaleFactor)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsMul_16sc_Sfs(pSrc1, pSrc2, pDst, len, scaleFactor);
    case DT_SSE2:
        return _sse2_fwsMul_16sc_Sfs(pSrc1, pSrc2, pDst, len, scaleFactor);
    case DT_REFR:
        return _refr_fwsMul_16sc_Sfs(pSrc1, pSrc2, pDst, len, scaleFactor);
    default:
        assert(false);
        return _refr_fwsMul_16sc_Sfs(pSrc1, pSrc2, pDst, len, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsDivC_16sc_ISfs(Fw16sc val, Fw16sc* pSrcDst, int len, int scaleFactor)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsDivC_16sc_ISfs(val, pSrcDst, len, scaleFactor);
    case DT_SSE2:
        return _sse2_fwsDivC_16sc_ISfs(val, pSrcDst, len, scaleFactor);
    case DT_REFR:
        return _refr_fwsDivC_16sc_ISfs(val, pSrcDst, len, scaleFactor);
    default:
        assert(false);
        return _refr_fwsDivC_16sc_ISfs(val, pSrcDst, len, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsLn_64f_I(Fw64f* pSrcDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsLn_64f_I(pSrcDst, len);
    case DT_SSE2:
        return _sse2_fwsLn_64f_I(pSrcDst, len);
    case DT_REFR:
        return _refr_fwsLn_64f_I(pSrcDst, len);
    default:
        assert(false);
        return _refr_fwsLn_64f_I(pSrcDst, len);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsSqr_64f(const Fw64f* pSrc, Fw64f* pDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsSqr_64f(pSrc, pDst, len);
    case DT_SSE2:
        return _sse2_fwsSqr_64f(pSrc, pDst, len);
    case DT_REFR:
        return _refr_fwsSqr_64f(pSrc, pDst, len);
    default:
        assert(false);
        return _refr_fwsSqr_64f(pSrc, pDst, len);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsAddProduct_16s32s_Sfs(const Fw16s* pSrc1, const Fw16s* pSrc2, Fw32s* pSrcDst, int len, int scaleFactor)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsAddProduct_16s32s_Sfs(pSrc1, pSrc2, pSrcDst, len, scaleFactor);
    case DT_SSE2:
        return _sse2_fwsAddProduct_16s32s_Sfs(pSrc1, pSrc2, pSrcDst, len, scaleFactor);
    case DT_REFR:
        return _refr_fwsAddProduct_16s32s_Sfs(pSrc1, pSrc2, pSrcDst, len, scaleFactor);
    default:
        assert(false);
        return _refr_fwsAddProduct_16s32s_Sfs(pSrc1, pSrc2, pSrcDst, len, scaleFactor);
    }
}

OREFR             FwStatus STDCALL fwsAcos_32f_A11(const Fw32f* pSrc, Fw32f* pDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwsAcos_32f_A11(pSrc, pDst, len);
    default:
        assert(false);
        return _refr_fwsAcos_32f_A11(pSrc, pDst, len);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsCbrt_32f_A24(const Fw32f* pSrc, Fw32f* pDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsCbrt_32f_A24(pSrc, pDst, len);
    case DT_SSE2:
        return _sse2_fwsCbrt_32f_A24(pSrc, pDst, len);
    case DT_REFR:
        return _refr_fwsCbrt_32f_A24(pSrc, pDst, len);
    default:
        assert(false);
        return _refr_fwsCbrt_32f_A24(pSrc, pDst, len);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsThreshold_32fc(const Fw32fc* pSrc, Fw32fc* pDst, int len, Fw32f level, FwCmpOp relOp)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsThreshold_32fc(pSrc, pDst, len, level, relOp);
    case DT_SSE2:
        return _sse2_fwsThreshold_32fc(pSrc, pDst, len, level, relOp);
    case DT_REFR:
        return _refr_fwsThreshold_32fc(pSrc, pDst, len, level, relOp);
    default:
        assert(false);
        return _refr_fwsThreshold_32fc(pSrc, pDst, len, level, relOp);
    }
}

OREFR             FwStatus STDCALL fwsAsinh_32f_A11(const Fw32f* pSrc, Fw32f* pDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwsAsinh_32f_A11(pSrc, pDst, len);
    default:
        assert(false);
        return _refr_fwsAsinh_32f_A11(pSrc, pDst, len);
    }
}

OREFR OSSE2 FwStatus STDCALL fwsMinEvery_16s_I(const Fw16s* pSrc, Fw16s* pSrcDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwsMinEvery_16s_I(pSrc, pSrcDst, len);
    case DT_REFR:
        return _refr_fwsMinEvery_16s_I(pSrc, pSrcDst, len);
    default:
        assert(false);
        return _refr_fwsMinEvery_16s_I(pSrc, pSrcDst, len);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsOr_16u_I(const Fw16u* pSrc, Fw16u* pSrcDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsOr_16u_I(pSrc, pSrcDst, len);
    case DT_SSE2:
        return _sse2_fwsOr_16u_I(pSrc, pSrcDst, len);
    case DT_REFR:
        return _refr_fwsOr_16u_I(pSrc, pSrcDst, len);
    default:
        assert(false);
        return _refr_fwsOr_16u_I(pSrc, pSrcDst, len);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsSub_32s_Sfs(const Fw32s* pSrc1, const Fw32s* pSrc2, Fw32s* pDst, int len, int scaleFactor)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsSub_32s_Sfs(pSrc1, pSrc2, pDst, len, scaleFactor);
    case DT_SSE2:
        return _sse2_fwsSub_32s_Sfs(pSrc1, pSrc2, pDst, len, scaleFactor);
    case DT_REFR:
        return _refr_fwsSub_32s_Sfs(pSrc1, pSrc2, pDst, len, scaleFactor);
    default:
        assert(false);
        return _refr_fwsSub_32s_Sfs(pSrc1, pSrc2, pDst, len, scaleFactor);
    }
}

OREFR OSSE2 FwStatus STDCALL fwsDotProd_32f32fc(const Fw32f* pSrc1, const Fw32fc* pSrc2, int len, Fw32fc* pDp)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwsDotProd_32f32fc(pSrc1, pSrc2, len, pDp);
    case DT_REFR:
        return _refr_fwsDotProd_32f32fc(pSrc1, pSrc2, len, pDp);
    default:
        assert(false);
        return _refr_fwsDotProd_32f32fc(pSrc1, pSrc2, len, pDp);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsAnd_8u_I(const Fw8u* pSrc, Fw8u* pSrcDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsAnd_8u_I(pSrc, pSrcDst, len);
    case DT_SSE2:
        return _sse2_fwsAnd_8u_I(pSrc, pSrcDst, len);
    case DT_REFR:
        return _refr_fwsAnd_8u_I(pSrc, pSrcDst, len);
    default:
        assert(false);
        return _refr_fwsAnd_8u_I(pSrc, pSrcDst, len);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsAbs_32f_I(Fw32f* pSrcDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsAbs_32f_I(pSrcDst, len);
    case DT_SSE2:
        return _sse2_fwsAbs_32f_I(pSrcDst, len);
    case DT_REFR:
        return _refr_fwsAbs_32f_I(pSrcDst, len);
    default:
        assert(false);
        return _refr_fwsAbs_32f_I(pSrcDst, len);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsSqr_64f_I(Fw64f* pSrcDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsSqr_64f_I(pSrcDst, len);
    case DT_SSE2:
        return _sse2_fwsSqr_64f_I(pSrcDst, len);
    case DT_REFR:
        return _refr_fwsSqr_64f_I(pSrcDst, len);
    default:
        assert(false);
        return _refr_fwsSqr_64f_I(pSrcDst, len);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsSubCRev_8u_Sfs(const Fw8u* pSrc, Fw8u val, Fw8u* pDst, int len, int scaleFactor)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsSubCRev_8u_Sfs(pSrc, val, pDst, len, scaleFactor);
    case DT_SSE2:
        return _sse2_fwsSubCRev_8u_Sfs(pSrc, val, pDst, len, scaleFactor);
    case DT_REFR:
        return _refr_fwsSubCRev_8u_Sfs(pSrc, val, pDst, len, scaleFactor);
    default:
        assert(false);
        return _refr_fwsSubCRev_8u_Sfs(pSrc, val, pDst, len, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsAddProduct_32fc(const Fw32fc* pSrc1, const Fw32fc* pSrc2, Fw32fc* pSrcDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsAddProduct_32fc(pSrc1, pSrc2, pSrcDst, len);
    case DT_SSE2:
        return _sse2_fwsAddProduct_32fc(pSrc1, pSrc2, pSrcDst, len);
    case DT_REFR:
        return _refr_fwsAddProduct_32fc(pSrc1, pSrc2, pSrcDst, len);
    default:
        assert(false);
        return _refr_fwsAddProduct_32fc(pSrc1, pSrc2, pSrcDst, len);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsThreshold_64fc(const Fw64fc* pSrc, Fw64fc* pDst, int len, Fw64f level, FwCmpOp relOp)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsThreshold_64fc(pSrc, pDst, len, level, relOp);
    case DT_SSE2:
        return _sse2_fwsThreshold_64fc(pSrc, pDst, len, level, relOp);
    case DT_REFR:
        return _refr_fwsThreshold_64fc(pSrc, pDst, len, level, relOp);
    default:
        assert(false);
        return _refr_fwsThreshold_64fc(pSrc, pDst, len, level, relOp);
    }
}

OREFR OSSE2 FwStatus STDCALL fwsMinAbsIndx_16s(const Fw16s* pSrc, int len, Fw16s* pMinAbs, int* pIndx)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwsMinAbsIndx_16s(pSrc, len, pMinAbs, pIndx);
    case DT_REFR:
        return _refr_fwsMinAbsIndx_16s(pSrc, len, pMinAbs, pIndx);
    default:
        assert(false);
        return _refr_fwsMinAbsIndx_16s(pSrc, len, pMinAbs, pIndx);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsDivC_64fc(const Fw64fc* pSrc, Fw64fc val, Fw64fc* pDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsDivC_64fc(pSrc, val, pDst, len);
    case DT_SSE2:
        return _sse2_fwsDivC_64fc(pSrc, val, pDst, len);
    case DT_REFR:
        return _refr_fwsDivC_64fc(pSrc, val, pDst, len);
    default:
        assert(false);
        return _refr_fwsDivC_64fc(pSrc, val, pDst, len);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsThreshold_LT_16s_I(Fw16s* pSrcDst, int len, Fw16s level)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsThreshold_LT_16s_I(pSrcDst, len, level);
    case DT_SSE2:
        return _sse2_fwsThreshold_LT_16s_I(pSrcDst, len, level);
    case DT_REFR:
        return _refr_fwsThreshold_LT_16s_I(pSrcDst, len, level);
    default:
        assert(false);
        return _refr_fwsThreshold_LT_16s_I(pSrcDst, len, level);
    }
}

OREFR OSSE2 FwStatus STDCALL fwsDotProd_32s_Sfs(const Fw32s* pSrc1, const Fw32s* pSrc2, int len, Fw32s* pDp, int scaleFactor)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwsDotProd_32s_Sfs(pSrc1, pSrc2, len, pDp, scaleFactor);
    case DT_REFR:
        return _refr_fwsDotProd_32s_Sfs(pSrc1, pSrc2, len, pDp, scaleFactor);
    default:
        assert(false);
        return _refr_fwsDotProd_32s_Sfs(pSrc1, pSrc2, len, pDp, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsSub_64f(const Fw64f* pSrc1, const Fw64f* pSrc2, Fw64f* pDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsSub_64f(pSrc1, pSrc2, pDst, len);
    case DT_SSE2:
        return _sse2_fwsSub_64f(pSrc1, pSrc2, pDst, len);
    case DT_REFR:
        return _refr_fwsSub_64f(pSrc1, pSrc2, pDst, len);
    default:
        assert(false);
        return _refr_fwsSub_64f(pSrc1, pSrc2, pDst, len);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsOrC_8u(const Fw8u* pSrc, Fw8u val, Fw8u* pDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsOrC_8u(pSrc, val, pDst, len);
    case DT_SSE2:
        return _sse2_fwsOrC_8u(pSrc, val, pDst, len);
    case DT_REFR:
        return _refr_fwsOrC_8u(pSrc, val, pDst, len);
    default:
        assert(false);
        return _refr_fwsOrC_8u(pSrc, val, pDst, len);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsDivC_64fc_I(Fw64fc val, Fw64fc* pSrcDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsDivC_64fc_I(val, pSrcDst, len);
    case DT_SSE2:
        return _sse2_fwsDivC_64fc_I(val, pSrcDst, len);
    case DT_REFR:
        return _refr_fwsDivC_64fc_I(val, pSrcDst, len);
    default:
        assert(false);
        return _refr_fwsDivC_64fc_I(val, pSrcDst, len);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsSub_64s(const Fw64s* pSrc1, const Fw64s* pSrc2, Fw64s* pDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsSub_64s(pSrc1, pSrc2, pDst, len);
    case DT_SSE2:
        return _sse2_fwsSub_64s(pSrc1, pSrc2, pDst, len);
    case DT_REFR:
        return _refr_fwsSub_64s(pSrc1, pSrc2, pDst, len);
    default:
        assert(false);
        return _refr_fwsSub_64s(pSrc1, pSrc2, pDst, len);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsMulC_8u_Sfs(const Fw8u* pSrc, Fw8u val, Fw8u* pDst, int len, int scaleFactor)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsMulC_8u_Sfs(pSrc, val, pDst, len, scaleFactor);
    case DT_SSE2:
        return _sse2_fwsMulC_8u_Sfs(pSrc, val, pDst, len, scaleFactor);
    case DT_REFR:
        return _refr_fwsMulC_8u_Sfs(pSrc, val, pDst, len, scaleFactor);
    default:
        assert(false);
        return _refr_fwsMulC_8u_Sfs(pSrc, val, pDst, len, scaleFactor);
    }
}

OREFR OSSE2 FwStatus STDCALL fwsMinIndx_16s(const Fw16s* pSrc, int len, Fw16s* pMin, int* pIndx)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwsMinIndx_16s(pSrc, len, pMin, pIndx);
    case DT_REFR:
        return _refr_fwsMinIndx_16s(pSrc, len, pMin, pIndx);
    default:
        assert(false);
        return _refr_fwsMinIndx_16s(pSrc, len, pMin, pIndx);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsMulC_32fc(const Fw32fc* pSrc, Fw32fc val, Fw32fc* pDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsMulC_32fc(pSrc, val, pDst, len);
    case DT_SSE2:
        return _sse2_fwsMulC_32fc(pSrc, val, pDst, len);
    case DT_REFR:
        return _refr_fwsMulC_32fc(pSrc, val, pDst, len);
    default:
        assert(false);
        return _refr_fwsMulC_32fc(pSrc, val, pDst, len);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsSqrt_16u_ISfs(Fw16u* pSrcDst, int len, int scaleFactor)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsSqrt_16u_ISfs(pSrcDst, len, scaleFactor);
    case DT_SSE2:
        return _sse2_fwsSqrt_16u_ISfs(pSrcDst, len, scaleFactor);
    case DT_REFR:
        return _refr_fwsSqrt_16u_ISfs(pSrcDst, len, scaleFactor);
    default:
        assert(false);
        return _refr_fwsSqrt_16u_ISfs(pSrcDst, len, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsInv_64f_A50(const Fw64f* pSrc, Fw64f* pDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsInv_64f_A50(pSrc, pDst, len);
    case DT_SSE2:
        return _sse2_fwsInv_64f_A50(pSrc, pDst, len);
    case DT_REFR:
        return _refr_fwsInv_64f_A50(pSrc, pDst, len);
    default:
        assert(false);
        return _refr_fwsInv_64f_A50(pSrc, pDst, len);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsSubCRev_16sc_ISfs(Fw16sc val, Fw16sc* pSrcDst, int len, int scaleFactor)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsSubCRev_16sc_ISfs(val, pSrcDst, len, scaleFactor);
    case DT_SSE2:
        return _sse2_fwsSubCRev_16sc_ISfs(val, pSrcDst, len, scaleFactor);
    case DT_REFR:
        return _refr_fwsSubCRev_16sc_ISfs(val, pSrcDst, len, scaleFactor);
    default:
        assert(false);
        return _refr_fwsSubCRev_16sc_ISfs(val, pSrcDst, len, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsOrC_16u_I(Fw16u val, Fw16u* pSrcDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsOrC_16u_I(val, pSrcDst, len);
    case DT_SSE2:
        return _sse2_fwsOrC_16u_I(val, pSrcDst, len);
    case DT_REFR:
        return _refr_fwsOrC_16u_I(val, pSrcDst, len);
    default:
        assert(false);
        return _refr_fwsOrC_16u_I(val, pSrcDst, len);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsAbs_32s_I(Fw32s* pSrcDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsAbs_32s_I(pSrcDst, len);
    case DT_SSE2:
        return _sse2_fwsAbs_32s_I(pSrcDst, len);
    case DT_REFR:
        return _refr_fwsAbs_32s_I(pSrcDst, len);
    default:
        assert(false);
        return _refr_fwsAbs_32s_I(pSrcDst, len);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsXorC_8u_I(Fw8u val, Fw8u* pSrcDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsXorC_8u_I(val, pSrcDst, len);
    case DT_SSE2:
        return _sse2_fwsXorC_8u_I(val, pSrcDst, len);
    case DT_REFR:
        return _refr_fwsXorC_8u_I(val, pSrcDst, len);
    default:
        assert(false);
        return _refr_fwsXorC_8u_I(val, pSrcDst, len);
    }
}

OREFR OSSE2 FwStatus STDCALL fwsDotProd_64f(const Fw64f* pSrc1, const Fw64f* pSrc2, int len,Fw64f* pDp)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwsDotProd_64f(pSrc1, pSrc2, len, pDp);
    case DT_REFR:
        return _refr_fwsDotProd_64f(pSrc1, pSrc2, len, pDp);
    default:
        assert(false);
        return _refr_fwsDotProd_64f(pSrc1, pSrc2, len, pDp);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsAtan_64f_A53(const Fw64f* pSrc, Fw64f* pDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsAtan_64f_A53(pSrc, pDst, len);
    case DT_SSE2:
        return _sse2_fwsAtan_64f_A53(pSrc, pDst, len);
    case DT_REFR:
        return _refr_fwsAtan_64f_A53(pSrc, pDst, len);
    default:
        assert(false);
        return _refr_fwsAtan_64f_A53(pSrc, pDst, len);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsMagnitude_64f(const Fw64f* pSrcRe, const Fw64f* pSrcIm, Fw64f* pDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsMagnitude_64f(pSrcRe, pSrcIm, pDst, len);
    case DT_SSE2:
        return _sse2_fwsMagnitude_64f(pSrcRe, pSrcIm, pDst, len);
    case DT_REFR:
        return _refr_fwsMagnitude_64f(pSrcRe, pSrcIm, pDst, len);
    default:
        assert(false);
        return _refr_fwsMagnitude_64f(pSrcRe, pSrcIm, pDst, len);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsThreshold_LTInv_64fc(const Fw64fc* pSrc, Fw64fc* pDst, int len, Fw64f level)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsThreshold_LTInv_64fc(pSrc, pDst, len, level);
    case DT_SSE2:
        return _sse2_fwsThreshold_LTInv_64fc(pSrc, pDst, len, level);
    case DT_REFR:
        return _refr_fwsThreshold_LTInv_64fc(pSrc, pDst, len, level);
    default:
        assert(false);
        return _refr_fwsThreshold_LTInv_64fc(pSrc, pDst, len, level);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsSqrt_32s16s_Sfs(const Fw32s* pSrc, Fw16s* pDst, int len, int scaleFactor)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsSqrt_32s16s_Sfs(pSrc, pDst, len, scaleFactor);
    case DT_SSE2:
        return _sse2_fwsSqrt_32s16s_Sfs(pSrc, pDst, len, scaleFactor);
    case DT_REFR:
        return _refr_fwsSqrt_32s16s_Sfs(pSrc, pDst, len, scaleFactor);
    default:
        assert(false);
        return _refr_fwsSqrt_32s16s_Sfs(pSrc, pDst, len, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsExp_16s_Sfs(const Fw16s* pSrc, Fw16s* pDst, int len, int scaleFactor)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsExp_16s_Sfs(pSrc, pDst, len, scaleFactor);
    case DT_SSE2:
        return _sse2_fwsExp_16s_Sfs(pSrc, pDst, len, scaleFactor);
    case DT_REFR:
        return _refr_fwsExp_16s_Sfs(pSrc, pDst, len, scaleFactor);
    default:
        assert(false);
        return _refr_fwsExp_16s_Sfs(pSrc, pDst, len, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsNormalize_64f(const Fw64f* pSrc, Fw64f* pDst, int len, Fw64f vsub,Fw64f vdiv)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsNormalize_64f(pSrc, pDst, len, vsub, vdiv);
    case DT_SSE2:
        return _sse2_fwsNormalize_64f(pSrc, pDst, len, vsub, vdiv);
    case DT_REFR:
        return _refr_fwsNormalize_64f(pSrc, pDst, len, vsub, vdiv);
    default:
        assert(false);
        return _refr_fwsNormalize_64f(pSrc, pDst, len, vsub, vdiv);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsCopy_16sc(const Fw16sc* pSrc, Fw16sc* pDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsCopy_16sc(pSrc, pDst, len);
    case DT_SSE2:
        return _sse2_fwsCopy_16sc(pSrc, pDst, len);
    case DT_REFR:
        return _refr_fwsCopy_16sc(pSrc, pDst, len);
    default:
        assert(false);
        return _refr_fwsCopy_16sc(pSrc, pDst, len);
    }
}

OREFR OSSE2 FwStatus STDCALL fwsMin_32f(const Fw32f* pSrc, int len, Fw32f* pMin)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwsMin_32f(pSrc, len, pMin);
    case DT_REFR:
        return _refr_fwsMin_32f(pSrc, len, pMin);
    default:
        assert(false);
        return _refr_fwsMin_32f(pSrc, len, pMin);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsExp_32s_ISfs(Fw32s* pSrcDst, int len, int scaleFactor)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsExp_32s_ISfs(pSrcDst, len, scaleFactor);
    case DT_SSE2:
        return _sse2_fwsExp_32s_ISfs(pSrcDst, len, scaleFactor);
    case DT_REFR:
        return _refr_fwsExp_32s_ISfs(pSrcDst, len, scaleFactor);
    default:
        assert(false);
        return _refr_fwsExp_32s_ISfs(pSrcDst, len, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsAdd_16s_Sfs(const Fw16s* pSrc1, const Fw16s* pSrc2, Fw16s*pDst, int len, int scaleFactor)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsAdd_16s_Sfs(pSrc1, pSrc2, pDst, len, scaleFactor);
    case DT_SSE2:
        return _sse2_fwsAdd_16s_Sfs(pSrc1, pSrc2, pDst, len, scaleFactor);
    case DT_REFR:
        return _refr_fwsAdd_16s_Sfs(pSrc1, pSrc2, pDst, len, scaleFactor);
    default:
        assert(false);
        return _refr_fwsAdd_16s_Sfs(pSrc1, pSrc2, pDst, len, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsSub_32fc_I(const Fw32fc* pSrc, Fw32fc* pSrcDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsSub_32fc_I(pSrc, pSrcDst, len);
    case DT_SSE2:
        return _sse2_fwsSub_32fc_I(pSrc, pSrcDst, len);
    case DT_REFR:
        return _refr_fwsSub_32fc_I(pSrc, pSrcDst, len);
    default:
        assert(false);
        return _refr_fwsSub_32fc_I(pSrc, pSrcDst, len);
    }
}

OREFR OSSE2 FwStatus STDCALL fwsDotProd_16s32f(const Fw16s* pSrc1, const Fw16s* pSrc2, int len,Fw32f* pDp)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwsDotProd_16s32f(pSrc1, pSrc2, len, pDp);
    case DT_REFR:
        return _refr_fwsDotProd_16s32f(pSrc1, pSrc2, len, pDp);
    default:
        assert(false);
        return _refr_fwsDotProd_16s32f(pSrc1, pSrc2, len, pDp);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsAnd_32u(const Fw32u* pSrc1, const Fw32u* pSrc2, Fw32u* pDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsAnd_32u(pSrc1, pSrc2, pDst, len);
    case DT_SSE2:
        return _sse2_fwsAnd_32u(pSrc1, pSrc2, pDst, len);
    case DT_REFR:
        return _refr_fwsAnd_32u(pSrc1, pSrc2, pDst, len);
    default:
        assert(false);
        return _refr_fwsAnd_32u(pSrc1, pSrc2, pDst, len);
    }
}

OREFR             FwStatus STDCALL fwsTan_64f_A50(const Fw64f* pSrc, Fw64f* pDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwsTan_64f_A50(pSrc, pDst, len);
    default:
        assert(false);
        return _refr_fwsTan_64f_A50(pSrc, pDst, len);
    }
}

OREFR             FwStatus STDCALL fwsTan_64f_A53(const Fw64f* pSrc, Fw64f* pDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwsTan_64f_A53(pSrc, pDst, len);
    default:
        assert(false);
        return _refr_fwsTan_64f_A53(pSrc, pDst, len);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsThreshold_GT_16s(const Fw16s* pSrc, Fw16s* pDst, int len, Fw16s level)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsThreshold_GT_16s(pSrc, pDst, len, level);
    case DT_SSE2:
        return _sse2_fwsThreshold_GT_16s(pSrc, pDst, len, level);
    case DT_REFR:
        return _refr_fwsThreshold_GT_16s(pSrc, pDst, len, level);
    default:
        assert(false);
        return _refr_fwsThreshold_GT_16s(pSrc, pDst, len, level);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsDiv_32fc(const Fw32fc* pSrc1, const Fw32fc* pSrc2, Fw32fc* pDst,int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsDiv_32fc(pSrc1, pSrc2, pDst, len);
    case DT_SSE2:
        return _sse2_fwsDiv_32fc(pSrc1, pSrc2, pDst, len);
    case DT_REFR:
        return _refr_fwsDiv_32fc(pSrc1, pSrc2, pDst, len);
    default:
        assert(false);
        return _refr_fwsDiv_32fc(pSrc1, pSrc2, pDst, len);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsThreshold_GT_32f_I(Fw32f* pSrcDst, int len, Fw32f level)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsThreshold_GT_32f_I(pSrcDst, len, level);
    case DT_SSE2:
        return _sse2_fwsThreshold_GT_32f_I(pSrcDst, len, level);
    case DT_REFR:
        return _refr_fwsThreshold_GT_32f_I(pSrcDst, len, level);
    default:
        assert(false);
        return _refr_fwsThreshold_GT_32f_I(pSrcDst, len, level);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsAddC_64f(const Fw64f* pSrc, Fw64f val, Fw64f* pDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsAddC_64f(pSrc, val, pDst, len);
    case DT_SSE2:
        return _sse2_fwsAddC_64f(pSrc, val, pDst, len);
    case DT_REFR:
        return _refr_fwsAddC_64f(pSrc, val, pDst, len);
    default:
        assert(false);
        return _refr_fwsAddC_64f(pSrc, val, pDst, len);
    }
}

OREFR OSSE2 FwStatus STDCALL fwsDotProd_16sc_Sfs(const Fw16sc* pSrc1, const Fw16sc* pSrc2, int len, Fw16sc* pDp, int scaleFactor)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwsDotProd_16sc_Sfs(pSrc1, pSrc2, len, pDp, scaleFactor);
    case DT_REFR:
        return _refr_fwsDotProd_16sc_Sfs(pSrc1, pSrc2, len, pDp, scaleFactor);
    default:
        assert(false);
        return _refr_fwsDotProd_16sc_Sfs(pSrc1, pSrc2, len, pDp, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsDiv_8u_ISfs(const Fw8u* pSrc, Fw8u* pSrcDst, int len, int scaleFactor)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsDiv_8u_ISfs(pSrc, pSrcDst, len, scaleFactor);
    case DT_SSE2:
        return _sse2_fwsDiv_8u_ISfs(pSrc, pSrcDst, len, scaleFactor);
    case DT_REFR:
        return _refr_fwsDiv_8u_ISfs(pSrc, pSrcDst, len, scaleFactor);
    default:
        assert(false);
        return _refr_fwsDiv_8u_ISfs(pSrc, pSrcDst, len, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsDivCRev_16u(const Fw16u* pSrc, Fw16u val, Fw16u* pDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsDivCRev_16u(pSrc, val, pDst, len);
    case DT_SSE2:
        return _sse2_fwsDivCRev_16u(pSrc, val, pDst, len);
    case DT_REFR:
        return _refr_fwsDivCRev_16u(pSrc, val, pDst, len);
    default:
        assert(false);
        return _refr_fwsDivCRev_16u(pSrc, val, pDst, len);
    }
}


OREFR OSSE2 FwStatus STDCALL fwsAutoCorr_32fc(const Fw32fc* pSrc, int srcLen, Fw32fc* pDst, int dstLen)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwsAutoCorr_32fc(pSrc, srcLen, pDst, dstLen);
    case DT_REFR:
        return _refr_fwsAutoCorr_32fc(pSrc, srcLen, pDst, dstLen);
    default:
        assert(false);
        return _refr_fwsAutoCorr_32fc(pSrc, srcLen, pDst, dstLen);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsAddProduct_64f(const Fw64f* pSrc1, const Fw64f* pSrc2, Fw64f* pSrcDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsAddProduct_64f(pSrc1, pSrc2, pSrcDst, len);
    case DT_SSE2:
        return _sse2_fwsAddProduct_64f(pSrc1, pSrc2, pSrcDst, len);
    case DT_REFR:
        return _refr_fwsAddProduct_64f(pSrc1, pSrc2, pSrcDst, len);
    default:
        assert(false);
        return _refr_fwsAddProduct_64f(pSrc1, pSrc2, pSrcDst, len);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsNormalize_32fc(const Fw32fc* pSrc, Fw32fc* pDst, int len, Fw32fc vsub, Fw32f vdiv)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsNormalize_32fc(pSrc, pDst, len, vsub, vdiv);
    case DT_SSE2:
        return _sse2_fwsNormalize_32fc(pSrc, pDst, len, vsub, vdiv);
    case DT_REFR:
        return _refr_fwsNormalize_32fc(pSrc, pDst, len, vsub, vdiv);
    default:
        assert(false);
        return _refr_fwsNormalize_32fc(pSrc, pDst, len, vsub, vdiv);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsDiv_64fc(const Fw64fc* pSrc1, const Fw64fc* pSrc2, Fw64fc* pDst,int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsDiv_64fc(pSrc1, pSrc2, pDst, len);
    case DT_SSE2:
        return _sse2_fwsDiv_64fc(pSrc1, pSrc2, pDst, len);
    case DT_REFR:
        return _refr_fwsDiv_64fc(pSrc1, pSrc2, pDst, len);
    default:
        assert(false);
        return _refr_fwsDiv_64fc(pSrc1, pSrc2, pDst, len);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsSqrt_32f_I(Fw32f* pSrcDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsSqrt_32f_I(pSrcDst, len);
    case DT_SSE2:
        return _sse2_fwsSqrt_32f_I(pSrcDst, len);
    case DT_REFR:
        return _refr_fwsSqrt_32f_I(pSrcDst, len);
    default:
        assert(false);
        return _refr_fwsSqrt_32f_I(pSrcDst, len);
    }
}

OREFR OSSE2 FwStatus STDCALL fwsNormDiff_Inf_32fc32f(const Fw32fc* pSrc1, const Fw32fc* pSrc2, int len, Fw32f* pNorm)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwsNormDiff_Inf_32fc32f(pSrc1, pSrc2, len, pNorm);
    case DT_REFR:
        return _refr_fwsNormDiff_Inf_32fc32f(pSrc1, pSrc2, len, pNorm);
    default:
        assert(false);
        return _refr_fwsNormDiff_Inf_32fc32f(pSrc1, pSrc2, len, pNorm);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsMul_32s32sc_Sfs(const Fw32s* pSrc1, const Fw32sc* pSrc2, Fw32sc *pDst, int len, int scaleFactor)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsMul_32s32sc_Sfs(pSrc1, pSrc2, pDst, len, scaleFactor);
    case DT_SSE2:
        return _sse2_fwsMul_32s32sc_Sfs(pSrc1, pSrc2, pDst, len, scaleFactor);
    case DT_REFR:
        return _refr_fwsMul_32s32sc_Sfs(pSrc1, pSrc2, pDst, len, scaleFactor);
    default:
        assert(false);
        return _refr_fwsMul_32s32sc_Sfs(pSrc1, pSrc2, pDst, len, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsNot_16u_I(Fw16u* pSrcDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsNot_16u_I(pSrcDst, len);
    case DT_SSE2:
        return _sse2_fwsNot_16u_I(pSrcDst, len);
    case DT_REFR:
        return _refr_fwsNot_16u_I(pSrcDst, len);
    default:
        assert(false);
        return _refr_fwsNot_16u_I(pSrcDst, len);
    }
}

OREFR OSSE2 FwStatus STDCALL fwsStdDev_16s32s_Sfs(const Fw16s* pSrc, int len, Fw32s* pStdDev,int scaleFactor)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwsStdDev_16s32s_Sfs(pSrc, len, pStdDev, scaleFactor);
    case DT_REFR:
        return _refr_fwsStdDev_16s32s_Sfs(pSrc, len, pStdDev, scaleFactor);
    default:
        assert(false);
        return _refr_fwsStdDev_16s32s_Sfs(pSrc, len, pStdDev, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsNormalize_64fc(const Fw64fc* pSrc, Fw64fc* pDst, int len, Fw64fc vsub, Fw64f vdiv)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsNormalize_64fc(pSrc, pDst, len, vsub, vdiv);
    case DT_SSE2:
        return _sse2_fwsNormalize_64fc(pSrc, pDst, len, vsub, vdiv);
    case DT_REFR:
        return _refr_fwsNormalize_64fc(pSrc, pDst, len, vsub, vdiv);
    default:
        assert(false);
        return _refr_fwsNormalize_64fc(pSrc, pDst, len, vsub, vdiv);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsNot_32u(const Fw32u* pSrc, Fw32u* pDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsNot_32u(pSrc, pDst, len);
    case DT_SSE2:
        return _sse2_fwsNot_32u(pSrc, pDst, len);
    case DT_REFR:
        return _refr_fwsNot_32u(pSrc, pDst, len);
    default:
        assert(false);
        return _refr_fwsNot_32u(pSrc, pDst, len);
    }
}

OREFR OSSE2 FwStatus STDCALL fwsMin_32s(const Fw32s* pSrc, int len, Fw32s* pMin)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwsMin_32s(pSrc, len, pMin);
    case DT_REFR:
        return _refr_fwsMin_32s(pSrc, len, pMin);
    default:
        assert(false);
        return _refr_fwsMin_32s(pSrc, len, pMin);
    }
}

OREFR             FwStatus STDCALL fwsAcosh_32f_A24(const Fw32f* pSrc, Fw32f* pDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwsAcosh_32f_A24(pSrc, pDst, len);
    default:
        assert(false);
        return _refr_fwsAcosh_32f_A24(pSrc, pDst, len);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsPow_32f_A11(const Fw32f* pSrc1, const Fw32f* pSrc2, Fw32f* pDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsPow_32f_A11(pSrc1, pSrc2, pDst, len);
    case DT_SSE2:
        return _sse2_fwsPow_32f_A11(pSrc1, pSrc2, pDst, len);
    case DT_REFR:
        return _refr_fwsPow_32f_A11(pSrc1, pSrc2, pDst, len);
    default:
        assert(false);
        return _refr_fwsPow_32f_A11(pSrc1, pSrc2, pDst, len);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsDivC_32fc_I(Fw32fc val, Fw32fc* pSrcDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsDivC_32fc_I(val, pSrcDst, len);
    case DT_SSE2:
        return _sse2_fwsDivC_32fc_I(val, pSrcDst, len);
    case DT_REFR:
        return _refr_fwsDivC_32fc_I(val, pSrcDst, len);
    default:
        assert(false);
        return _refr_fwsDivC_32fc_I(val, pSrcDst, len);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsOr_8u_I(const Fw8u* pSrc, Fw8u* pSrcDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsOr_8u_I(pSrc, pSrcDst, len);
    case DT_SSE2:
        return _sse2_fwsOr_8u_I(pSrc, pSrcDst, len);
    case DT_REFR:
        return _refr_fwsOr_8u_I(pSrc, pSrcDst, len);
    default:
        assert(false);
        return _refr_fwsOr_8u_I(pSrc, pSrcDst, len);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsThreshold_LTValGTVal_64f(const Fw64f* pSrc, Fw64f* pDst, int len, Fw64f levelLT, Fw64f valueLT, Fw64f levelGT, Fw64f valueGT)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsThreshold_LTValGTVal_64f(pSrc, pDst, len, levelLT, valueLT, levelGT, valueGT);
    case DT_SSE2:
        return _sse2_fwsThreshold_LTValGTVal_64f(pSrc, pDst, len, levelLT, valueLT, levelGT, valueGT);
    case DT_REFR:
        return _refr_fwsThreshold_LTValGTVal_64f(pSrc, pDst, len, levelLT, valueLT, levelGT, valueGT);
    default:
        assert(false);
        return _refr_fwsThreshold_LTValGTVal_64f(pSrc, pDst, len, levelLT, valueLT, levelGT, valueGT);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsAddC_32sc_ISfs(Fw32sc val, Fw32sc* pSrcDst, int len, int scaleFactor)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsAddC_32sc_ISfs(val, pSrcDst, len, scaleFactor);
    case DT_SSE2:
        return _sse2_fwsAddC_32sc_ISfs(val, pSrcDst, len, scaleFactor);
    case DT_REFR:
        return _refr_fwsAddC_32sc_ISfs(val, pSrcDst, len, scaleFactor);
    default:
        assert(false);
        return _refr_fwsAddC_32sc_ISfs(val, pSrcDst, len, scaleFactor);
    }
}

OREFR OSSE2 FwStatus STDCALL fwsAutoCorr_NormB_64fc(const  Fw64fc*  pSrc,  int  srcLen,  Fw64fc*  pDst,  int  dstLen)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwsAutoCorr_NormB_64fc(pSrc, srcLen, pDst, dstLen);
    case DT_REFR:
        return _refr_fwsAutoCorr_NormB_64fc(pSrc, srcLen, pDst, dstLen);
    default:
        assert(false);
        return _refr_fwsAutoCorr_NormB_64fc(pSrc, srcLen, pDst, dstLen);
    }
}

OREFR OSSE2 FwStatus STDCALL fwsDotProd_16s32s_Sfs(const Fw16s* pSrc1, const Fw16s* pSrc2, int len, Fw32s* pDp, int scaleFactor)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwsDotProd_16s32s_Sfs(pSrc1, pSrc2, len, pDp, scaleFactor);
    case DT_REFR:
        return _refr_fwsDotProd_16s32s_Sfs(pSrc1, pSrc2, len, pDp, scaleFactor);
    default:
        assert(false);
        return _refr_fwsDotProd_16s32s_Sfs(pSrc1, pSrc2, len, pDp, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsSet_64s(Fw64s val, Fw64s* pDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsSet_64s(val, pDst, len);
    case DT_SSE2:
        return _sse2_fwsSet_64s(val, pDst, len);
    case DT_REFR:
        return _refr_fwsSet_64s(val, pDst, len);
    default:
        assert(false);
        return _refr_fwsSet_64s(val, pDst, len);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsThreshold_LTValGTVal_32s_I(Fw32s* pSrcDst, int len, Fw32s levelLT, Fw32s valueLT, Fw32s levelGT, Fw32s valueGT)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsThreshold_LTValGTVal_32s_I(pSrcDst, len, levelLT, valueLT, levelGT, valueGT);
    case DT_SSE2:
        return _sse2_fwsThreshold_LTValGTVal_32s_I(pSrcDst, len, levelLT, valueLT, levelGT, valueGT);
    case DT_REFR:
        return _refr_fwsThreshold_LTValGTVal_32s_I(pSrcDst, len, levelLT, valueLT, levelGT, valueGT);
    default:
        assert(false);
        return _refr_fwsThreshold_LTValGTVal_32s_I(pSrcDst, len, levelLT, valueLT, levelGT, valueGT);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsConvert_32s32f(const Fw32s* pSrc, Fw32f* pDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsConvert_32s32f(pSrc, pDst, len);
    case DT_SSE2:
        return _sse2_fwsConvert_32s32f(pSrc, pDst, len);
    case DT_REFR:
        return _refr_fwsConvert_32s32f(pSrc, pDst, len);
    default:
        assert(false);
        return _refr_fwsConvert_32s32f(pSrc, pDst, len);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsSqrt_16sc_ISfs(Fw16sc* pSrcDst, int len, int scaleFactor)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsSqrt_16sc_ISfs(pSrcDst, len, scaleFactor);
    case DT_SSE2:
        return _sse2_fwsSqrt_16sc_ISfs(pSrcDst, len, scaleFactor);
    case DT_REFR:
        return _refr_fwsSqrt_16sc_ISfs(pSrcDst, len, scaleFactor);
    default:
        assert(false);
        return _refr_fwsSqrt_16sc_ISfs(pSrcDst, len, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsMulC_32f_I(Fw32f val, Fw32f* pSrcDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsMulC_32f_I(val, pSrcDst, len);
    case DT_SSE2:
        return _sse2_fwsMulC_32f_I(val, pSrcDst, len);
    case DT_REFR:
        return _refr_fwsMulC_32f_I(val, pSrcDst, len);
    default:
        assert(false);
        return _refr_fwsMulC_32f_I(val, pSrcDst, len);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsSub_8u_ISfs(const Fw8u* pSrc, Fw8u* pSrcDst, int len, int scaleFactor)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsSub_8u_ISfs(pSrc, pSrcDst, len, scaleFactor);
    case DT_SSE2:
        return _sse2_fwsSub_8u_ISfs(pSrc, pSrcDst, len, scaleFactor);
    case DT_REFR:
        return _refr_fwsSub_8u_ISfs(pSrc, pSrcDst, len, scaleFactor);
    default:
        assert(false);
        return _refr_fwsSub_8u_ISfs(pSrc, pSrcDst, len, scaleFactor);
    }
}

OREFR OSSE2 FwStatus STDCALL fwsDotProd_16s16sc64sc(const Fw16s* pSrc1, const Fw16sc* pSrc2,int len, Fw64sc* pDp)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwsDotProd_16s16sc64sc(pSrc1, pSrc2, len, pDp);
    case DT_REFR:
        return _refr_fwsDotProd_16s16sc64sc(pSrc1, pSrc2, len, pDp);
    default:
        assert(false);
        return _refr_fwsDotProd_16s16sc64sc(pSrc1, pSrc2, len, pDp);
    }
}

OREFR OSSE2 FwStatus STDCALL fwsMinMaxIndx_16s(const Fw16s* pSrc, int len, Fw16s* pMin, int* pMinIndx, Fw16s* pMax, int* pMaxIndx)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwsMinMaxIndx_16s(pSrc, len, pMin, pMinIndx, pMax, pMaxIndx);
    case DT_REFR:
        return _refr_fwsMinMaxIndx_16s(pSrc, len, pMin, pMinIndx, pMax, pMaxIndx);
    default:
        assert(false);
        return _refr_fwsMinMaxIndx_16s(pSrc, len, pMin, pMinIndx, pMax, pMaxIndx);
    }
}

OREFR OSSE2 FwStatus STDCALL fwsMinMaxIndx_16u(const Fw16u* pSrc, int len, Fw16u* pMin, int* pMinIndx, Fw16u* pMax, int* pMaxIndx)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwsMinMaxIndx_16u(pSrc, len, pMin, pMinIndx, pMax, pMaxIndx);
    case DT_REFR:
        return _refr_fwsMinMaxIndx_16u(pSrc, len, pMin, pMinIndx, pMax, pMaxIndx);
    default:
        assert(false);
        return _refr_fwsMinMaxIndx_16u(pSrc, len, pMin, pMinIndx, pMax, pMaxIndx);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsAnd_8u(const Fw8u* pSrc1, const Fw8u* pSrc2, Fw8u* pDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsAnd_8u(pSrc1, pSrc2, pDst, len);
    case DT_SSE2:
        return _sse2_fwsAnd_8u(pSrc1, pSrc2, pDst, len);
    case DT_REFR:
        return _refr_fwsAnd_8u(pSrc1, pSrc2, pDst, len);
    default:
        assert(false);
        return _refr_fwsAnd_8u(pSrc1, pSrc2, pDst, len);
    }
}

OREFR OSSE2 FwStatus STDCALL fwsDotProd_16s32s32s_Sfs(const Fw16s* pSrc1, const Fw32s* pSrc2,int len, Fw32s* pDp, int scaleFactor)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwsDotProd_16s32s32s_Sfs(pSrc1, pSrc2, len, pDp, scaleFactor);
    case DT_REFR:
        return _refr_fwsDotProd_16s32s32s_Sfs(pSrc1, pSrc2, len, pDp, scaleFactor);
    default:
        assert(false);
        return _refr_fwsDotProd_16s32s32s_Sfs(pSrc1, pSrc2, len, pDp, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsMul_16s32f(const Fw16s* pSrc1, const Fw16s* pSrc2, Fw32f *pDst,int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsMul_16s32f(pSrc1, pSrc2, pDst, len);
    case DT_SSE2:
        return _sse2_fwsMul_16s32f(pSrc1, pSrc2, pDst, len);
    case DT_REFR:
        return _refr_fwsMul_16s32f(pSrc1, pSrc2, pDst, len);
    default:
        assert(false);
        return _refr_fwsMul_16s32f(pSrc1, pSrc2, pDst, len);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsRShiftC_8u(const Fw8u* pSrc, int val, Fw8u* pDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsRShiftC_8u(pSrc, val, pDst, len);
    case DT_SSE2:
        return _sse2_fwsRShiftC_8u(pSrc, val, pDst, len);
    case DT_REFR:
        return _refr_fwsRShiftC_8u(pSrc, val, pDst, len);
    default:
        assert(false);
        return _refr_fwsRShiftC_8u(pSrc, val, pDst, len);
    }
}

OREFR             FwStatus STDCALL fwsTanh_32f_A21(const Fw32f* pSrc, Fw32f* pDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwsTanh_32f_A21(pSrc, pDst, len);
    default:
        assert(false);
        return _refr_fwsTanh_32f_A21(pSrc, pDst, len);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsMul_64f(const Fw64f* pSrc1, const Fw64f* pSrc2, Fw64f *pDst,int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsMul_64f(pSrc1, pSrc2, pDst, len);
    case DT_SSE2:
        return _sse2_fwsMul_64f(pSrc1, pSrc2, pDst, len);
    case DT_REFR:
        return _refr_fwsMul_64f(pSrc1, pSrc2, pDst, len);
    default:
        assert(false);
        return _refr_fwsMul_64f(pSrc1, pSrc2, pDst, len);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsArctan_32f(const Fw32f* pSrc, Fw32f* pDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsArctan_32f(pSrc, pDst, len);
    case DT_SSE2:
        return _sse2_fwsArctan_32f(pSrc, pDst, len);
    case DT_REFR:
        return _refr_fwsArctan_32f(pSrc, pDst, len);
    default:
        assert(false);
        return _refr_fwsArctan_32f(pSrc, pDst, len);
    }
}

OREFR OSSE2 FwStatus STDCALL fwsNormDiff_L2_64f(const Fw64f* pSrc1, const Fw64f* pSrc2, int len,Fw64f* pNorm)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwsNormDiff_L2_64f(pSrc1, pSrc2, len, pNorm);
    case DT_REFR:
        return _refr_fwsNormDiff_L2_64f(pSrc1, pSrc2, len, pNorm);
    default:
        assert(false);
        return _refr_fwsNormDiff_L2_64f(pSrc1, pSrc2, len, pNorm);
    }
}

OREFR			  FwStatus STDCALL fwsSqrt_64s_ISfs(Fw64s* pSrcDst, int len, int scaleFactor)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwsSqrt_64s_ISfs(pSrcDst, len, scaleFactor);
    default:
        assert(false);
        return _refr_fwsSqrt_64s_ISfs(pSrcDst, len, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsThreshold_GTVal_32f(const Fw32f* pSrc, Fw32f* pDst, int len, Fw32f level, Fw32f value)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsThreshold_GTVal_32f(pSrc, pDst, len, level, value);
    case DT_SSE2:
        return _sse2_fwsThreshold_GTVal_32f(pSrc, pDst, len, level, value);
    case DT_REFR:
        return _refr_fwsThreshold_GTVal_32f(pSrc, pDst, len, level, value);
    default:
        assert(false);
        return _refr_fwsThreshold_GTVal_32f(pSrc, pDst, len, level, value);
    }
}

OREFR             FwStatus STDCALL fwsAsin_32f_A21(const Fw32f* pSrc, Fw32f* pDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwsAsin_32f_A21(pSrc, pDst, len);
    default:
        assert(false);
        return _refr_fwsAsin_32f_A21(pSrc, pDst, len);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsConvert_32s16s(const Fw32s* pSrc, Fw16s* pDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsConvert_32s16s(pSrc, pDst, len);
    case DT_SSE2:
        return _sse2_fwsConvert_32s16s(pSrc, pDst, len);
    case DT_REFR:
        return _refr_fwsConvert_32s16s(pSrc, pDst, len);
    default:
        assert(false);
        return _refr_fwsConvert_32s16s(pSrc, pDst, len);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsConvert_16u32f(const Fw16u* pSrc, Fw32f* pDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsConvert_16u32f(pSrc, pDst, len);
    case DT_SSE2:
        return _sse2_fwsConvert_16u32f(pSrc, pDst, len);
    case DT_REFR:
        return _refr_fwsConvert_16u32f(pSrc, pDst, len);
    default:
        assert(false);
        return _refr_fwsConvert_16u32f(pSrc, pDst, len);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsMove_64f(const Fw64f* pSrc, Fw64f* pDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsMove_64f(pSrc, pDst, len);
    case DT_SSE2:
        return _sse2_fwsMove_64f(pSrc, pDst, len);
    case DT_REFR:
        return _refr_fwsMove_64f(pSrc, pDst, len);
    default:
        assert(false);
        return _refr_fwsMove_64f(pSrc, pDst, len);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fws10Log10_32s_ISfs(Fw32s* pSrcDst, int len, int scaleFactor)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fws10Log10_32s_ISfs(pSrcDst, len, scaleFactor);
    case DT_SSE2:
        return _sse2_fws10Log10_32s_ISfs(pSrcDst, len, scaleFactor);
    case DT_REFR:
        return _refr_fws10Log10_32s_ISfs(pSrcDst, len, scaleFactor);
    default:
        assert(false);
        return _refr_fws10Log10_32s_ISfs(pSrcDst, len, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsDiv_32f_I(const Fw32f* pSrc, Fw32f* pSrcDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsDiv_32f_I(pSrc, pSrcDst, len);
    case DT_SSE2:
        return _sse2_fwsDiv_32f_I(pSrc, pSrcDst, len);
    case DT_REFR:
        return _refr_fwsDiv_32f_I(pSrc, pSrcDst, len);
    default:
        assert(false);
        return _refr_fwsDiv_32f_I(pSrc, pSrcDst, len);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsAddC_64fc_I(Fw64fc val, Fw64fc* pSrcDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsAddC_64fc_I(val, pSrcDst, len);
    case DT_SSE2:
        return _sse2_fwsAddC_64fc_I(val, pSrcDst, len);
    case DT_REFR:
        return _refr_fwsAddC_64fc_I(val, pSrcDst, len);
    default:
        assert(false);
        return _refr_fwsAddC_64fc_I(val, pSrcDst, len);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsMulC_16sc_ISfs(Fw16sc val, Fw16sc* pSrcDst, int len, int scaleFactor)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsMulC_16sc_ISfs(val, pSrcDst, len, scaleFactor);
    case DT_SSE2:
        return _sse2_fwsMulC_16sc_ISfs(val, pSrcDst, len, scaleFactor);
    case DT_REFR:
        return _refr_fwsMulC_16sc_ISfs(val, pSrcDst, len, scaleFactor);
    default:
        assert(false);
        return _refr_fwsMulC_16sc_ISfs(val, pSrcDst, len, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsThreshold_LT_64f(const Fw64f* pSrc, Fw64f* pDst, int len, Fw64f level)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsThreshold_LT_64f(pSrc, pDst, len, level);
    case DT_SSE2:
        return _sse2_fwsThreshold_LT_64f(pSrc, pDst, len, level);
    case DT_REFR:
        return _refr_fwsThreshold_LT_64f(pSrc, pDst, len, level);
    default:
        assert(false);
        return _refr_fwsThreshold_LT_64f(pSrc, pDst, len, level);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsMul_16s_ISfs(const Fw16s* pSrc, Fw16s* pSrcDst, int len, int scaleFactor)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsMul_16s_ISfs(pSrc, pSrcDst, len, scaleFactor);
    case DT_SSE2:
        return _sse2_fwsMul_16s_ISfs(pSrc, pSrcDst, len, scaleFactor);
    case DT_REFR:
        return _refr_fwsMul_16s_ISfs(pSrc, pSrcDst, len, scaleFactor);
    default:
        assert(false);
        return _refr_fwsMul_16s_ISfs(pSrc, pSrcDst, len, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsSqr_16u_ISfs(Fw16u* pSrcDst, int len, int scaleFactor)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsSqr_16u_ISfs(pSrcDst, len, scaleFactor);
    case DT_SSE2:
        return _sse2_fwsSqr_16u_ISfs(pSrcDst, len, scaleFactor);
    case DT_REFR:
        return _refr_fwsSqr_16u_ISfs(pSrcDst, len, scaleFactor);
    default:
        assert(false);
        return _refr_fwsSqr_16u_ISfs(pSrcDst, len, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsAddC_8u_ISfs(Fw8u val, Fw8u* pSrcDst, int len, int scaleFactor)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsAddC_8u_ISfs(val, pSrcDst, len, scaleFactor);
    case DT_SSE2:
        return _sse2_fwsAddC_8u_ISfs(val, pSrcDst, len, scaleFactor);
    case DT_REFR:
        return _refr_fwsAddC_8u_ISfs(val, pSrcDst, len, scaleFactor);
    default:
        assert(false);
        return _refr_fwsAddC_8u_ISfs(val, pSrcDst, len, scaleFactor);
    }
}

OREFR OSSE2 FwStatus STDCALL fwsDotProd_16s16sc_Sfs(const Fw16s* pSrc1, const Fw16sc* pSrc2,int len, Fw16sc* pDp, int scaleFactor)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwsDotProd_16s16sc_Sfs(pSrc1, pSrc2, len, pDp, scaleFactor);
    case DT_REFR:
        return _refr_fwsDotProd_16s16sc_Sfs(pSrc1, pSrc2, len, pDp, scaleFactor);
    default:
        assert(false);
        return _refr_fwsDotProd_16s16sc_Sfs(pSrc1, pSrc2, len, pDp, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsThreshold_LTValGTVal_64f_I(Fw64f* pSrcDst, int len, Fw64f levelLT, Fw64f valueLT, Fw64f levelGT, Fw64f valueGT)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsThreshold_LTValGTVal_64f_I(pSrcDst, len, levelLT, valueLT, levelGT, valueGT);
    case DT_SSE2:
        return _sse2_fwsThreshold_LTValGTVal_64f_I(pSrcDst, len, levelLT, valueLT, levelGT, valueGT);
    case DT_REFR:
        return _refr_fwsThreshold_LTValGTVal_64f_I(pSrcDst, len, levelLT, valueLT, levelGT, valueGT);
    default:
        assert(false);
        return _refr_fwsThreshold_LTValGTVal_64f_I(pSrcDst, len, levelLT, valueLT, levelGT, valueGT);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsMul_32fc(const Fw32fc* pSrc1, const Fw32fc* pSrc2, Fw32fc *pDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsMul_32fc(pSrc1, pSrc2, pDst, len);
    case DT_SSE2:
        return _sse2_fwsMul_32fc(pSrc1, pSrc2, pDst, len);
    case DT_REFR:
        return _refr_fwsMul_32fc(pSrc1, pSrc2, pDst, len);
    default:
        assert(false);
        return _refr_fwsMul_32fc(pSrc1, pSrc2, pDst, len);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsSubCRev_32f(const Fw32f* pSrc, Fw32f val, Fw32f* pDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsSubCRev_32f(pSrc, val, pDst, len);
    case DT_SSE2:
        return _sse2_fwsSubCRev_32f(pSrc, val, pDst, len);
    case DT_REFR:
        return _refr_fwsSubCRev_32f(pSrc, val, pDst, len);
    default:
        assert(false);
        return _refr_fwsSubCRev_32f(pSrc, val, pDst, len);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsAddC_32f(const Fw32f* pSrc, Fw32f val, Fw32f* pDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsAddC_32f(pSrc, val, pDst, len);
    case DT_SSE2:
        return _sse2_fwsAddC_32f(pSrc, val, pDst, len);
    case DT_REFR:
        return _refr_fwsAddC_32f(pSrc, val, pDst, len);
    default:
        assert(false);
        return _refr_fwsAddC_32f(pSrc, val, pDst, len);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsLn_32f(const Fw32f* pSrc, Fw32f* pDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsLn_32f(pSrc, pDst, len);
    case DT_SSE2:
        return _sse2_fwsLn_32f(pSrc, pDst, len);
    case DT_REFR:
        return _refr_fwsLn_32f(pSrc, pDst, len);
    default:
        assert(false);
        return _refr_fwsLn_32f(pSrc, pDst, len);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsRShiftC_8u_I(int val, Fw8u* pSrcDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsRShiftC_8u_I(val, pSrcDst, len);
    case DT_SSE2:
        return _sse2_fwsRShiftC_8u_I(val, pSrcDst, len);
    case DT_REFR:
        return _refr_fwsRShiftC_8u_I(val, pSrcDst, len);
    default:
        assert(false);
        return _refr_fwsRShiftC_8u_I(val, pSrcDst, len);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsMul_32s32sc_ISfs(const Fw32s* pSrc, Fw32sc* pSrcDst, int len, int scaleFactor)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsMul_32s32sc_ISfs(pSrc, pSrcDst, len, scaleFactor);
    case DT_SSE2:
        return _sse2_fwsMul_32s32sc_ISfs(pSrc, pSrcDst, len, scaleFactor);
    case DT_REFR:
        return _refr_fwsMul_32s32sc_ISfs(pSrc, pSrcDst, len, scaleFactor);
    default:
        assert(false);
        return _refr_fwsMul_32s32sc_ISfs(pSrc, pSrcDst, len, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsSubC_16sc_ISfs(Fw16sc val, Fw16sc* pSrcDst, int len, int scaleFactor)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsSubC_16sc_ISfs(val, pSrcDst, len, scaleFactor);
    case DT_SSE2:
        return _sse2_fwsSubC_16sc_ISfs(val, pSrcDst, len, scaleFactor);
    case DT_REFR:
        return _refr_fwsSubC_16sc_ISfs(val, pSrcDst, len, scaleFactor);
    default:
        assert(false);
        return _refr_fwsSubC_16sc_ISfs(val, pSrcDst, len, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsAddC_16s_I(Fw16s val, Fw16s* pSrcDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsAddC_16s_I(val, pSrcDst, len);
    case DT_SSE2:
        return _sse2_fwsAddC_16s_I(val, pSrcDst, len);
    case DT_REFR:
        return _refr_fwsAddC_16s_I(val, pSrcDst, len);
    default:
        assert(false);
        return _refr_fwsAddC_16s_I(val, pSrcDst, len);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsDivC_64f(const Fw64f* pSrc, Fw64f val, Fw64f* pDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsDivC_64f(pSrc, val, pDst, len);
    case DT_SSE2:
        return _sse2_fwsDivC_64f(pSrc, val, pDst, len);
    case DT_REFR:
        return _refr_fwsDivC_64f(pSrc, val, pDst, len);
    default:
        assert(false);
        return _refr_fwsDivC_64f(pSrc, val, pDst, len);
    }
}


OREFR OSSE2 OF10H FwStatus STDCALL fwsInv_32f_A11(const Fw32f* pSrc, Fw32f* pDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsInv_32f_A11(pSrc, pDst, len);
    case DT_SSE2:
        return _sse2_fwsInv_32f_A11(pSrc, pDst, len);
    case DT_REFR:
        return _refr_fwsInv_32f_A11(pSrc, pDst, len);
    default:
        assert(false);
        return _refr_fwsInv_32f_A11(pSrc, pDst, len);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsArctan_32f_I(Fw32f* pSrcDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsArctan_32f_I(pSrcDst, len);
    case DT_SSE2:
        return _sse2_fwsArctan_32f_I(pSrcDst, len);
    case DT_REFR:
        return _refr_fwsArctan_32f_I(pSrcDst, len);
    default:
        assert(false);
        return _refr_fwsArctan_32f_I(pSrcDst, len);
    }
}

OREFR OSSE2 FwStatus STDCALL fwsMinIndx_64f(const Fw64f* pSrc, int len, Fw64f* pMin, int* pIndx)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwsMinIndx_64f(pSrc, len, pMin, pIndx);
    case DT_REFR:
        return _refr_fwsMinIndx_64f(pSrc, len, pMin, pIndx);
    default:
        assert(false);
        return _refr_fwsMinIndx_64f(pSrc, len, pMin, pIndx);
    }
}

OREFR OSSE2 FwStatus STDCALL fwsStdDev_32f(const Fw32f* pSrc, int len, Fw32f* pStdDev,FwHintAlgorithm hint)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwsStdDev_32f(pSrc, len, pStdDev, hint);
    case DT_REFR:
        return _refr_fwsStdDev_32f(pSrc, len, pStdDev, hint);
    default:
        assert(false);
        return _refr_fwsStdDev_32f(pSrc, len, pStdDev, hint);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsAndC_32u_I(Fw32u val, Fw32u* pSrcDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsAndC_32u_I(val, pSrcDst, len);
    case DT_SSE2:
        return _sse2_fwsAndC_32u_I(val, pSrcDst, len);
    case DT_REFR:
        return _refr_fwsAndC_32u_I(val, pSrcDst, len);
    default:
        assert(false);
        return _refr_fwsAndC_32u_I(val, pSrcDst, len);
    }
}

OREFR OSSE2 FwStatus STDCALL fwsNorm_L2_64fc64f(const Fw64fc* pSrc, int len, Fw64f* pNorm)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwsNorm_L2_64fc64f(pSrc, len, pNorm);
    case DT_REFR:
        return _refr_fwsNorm_L2_64fc64f(pSrc, len, pNorm);
    default:
        assert(false);
        return _refr_fwsNorm_L2_64fc64f(pSrc, len, pNorm);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsCbrt_32f_A11(const Fw32f* pSrc, Fw32f* pDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsCbrt_32f_A11(pSrc, pDst, len);
    case DT_SSE2:
        return _sse2_fwsCbrt_32f_A11(pSrc, pDst, len);
    case DT_REFR:
        return _refr_fwsCbrt_32f_A11(pSrc, pDst, len);
    default:
        assert(false);
        return _refr_fwsCbrt_32f_A11(pSrc, pDst, len);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsConvert_8s16s(const Fw8s* pSrc,Fw16s* pDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsConvert_8s16s(pSrc, pDst, len);
    case DT_SSE2:
        return _sse2_fwsConvert_8s16s(pSrc, pDst, len);
    case DT_REFR:
        return _refr_fwsConvert_8s16s(pSrc, pDst, len);
    default:
        assert(false);
        return _refr_fwsConvert_8s16s(pSrc, pDst, len);
    }
}

OREFR OSSE2 FwStatus STDCALL fwsMaxEvery_16s_I(const Fw16s* pSrc, Fw16s* pSrcDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwsMaxEvery_16s_I(pSrc, pSrcDst, len);
    case DT_REFR:
        return _refr_fwsMaxEvery_16s_I(pSrc, pSrcDst, len);
    default:
        assert(false);
        return _refr_fwsMaxEvery_16s_I(pSrc, pSrcDst, len);
    }
}

OREFR OSSE2 FwStatus STDCALL fwsMaxAbs_32s(const Fw32s* pSrc, int len, Fw32s* pMaxAbs)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwsMaxAbs_32s(pSrc, len, pMaxAbs);
    case DT_REFR:
        return _refr_fwsMaxAbs_32s(pSrc, len, pMaxAbs);
    default:
        assert(false);
        return _refr_fwsMaxAbs_32s(pSrc, len, pMaxAbs);
    }
}

OREFR OSSE2 FwStatus STDCALL fwsMean_32f(const Fw32f* pSrc, int len, Fw32f* pMean,FwHintAlgorithm hint)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwsMean_32f(pSrc, len, pMean, hint);
    case DT_REFR:
        return _refr_fwsMean_32f(pSrc, len, pMean, hint);
    default:
        assert(false);
        return _refr_fwsMean_32f(pSrc, len, pMean, hint);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsSubC_16s_I(Fw16s val, Fw16s* pSrcDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsSubC_16s_I(val, pSrcDst, len);
    case DT_SSE2:
        return _sse2_fwsSubC_16s_I(val, pSrcDst, len);
    case DT_REFR:
        return _refr_fwsSubC_16s_I(val, pSrcDst, len);
    default:
        assert(false);
        return _refr_fwsSubC_16s_I(val, pSrcDst, len);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsZero_8u(Fw8u* pDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsZero_8u(pDst, len);
    case DT_SSE2:
        return _sse2_fwsZero_8u(pDst, len);
    case DT_REFR:
        return _refr_fwsZero_8u(pDst, len);
    default:
        assert(false);
        return _refr_fwsZero_8u(pDst, len);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsAtan2_32f_A11(const Fw32f* pSrc1, const Fw32f* pSrc2, Fw32f* pDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsAtan2_32f_A11(pSrc1, pSrc2, pDst, len);
    case DT_SSE2:
        return _sse2_fwsAtan2_32f_A11(pSrc1, pSrc2, pDst, len);
    case DT_REFR:
        return _refr_fwsAtan2_32f_A11(pSrc1, pSrc2, pDst, len);
    default:
        assert(false);
        return _refr_fwsAtan2_32f_A11(pSrc1, pSrc2, pDst, len);
    }
}

OREFR OSSE2 FwStatus STDCALL fwsNorm_Inf_32fc32f(const Fw32fc* pSrc, int len, Fw32f* pNorm)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwsNorm_Inf_32fc32f(pSrc, len, pNorm);
    case DT_REFR:
        return _refr_fwsNorm_Inf_32fc32f(pSrc, len, pNorm);
    default:
        assert(false);
        return _refr_fwsNorm_Inf_32fc32f(pSrc, len, pNorm);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsAdd_64f_I(const Fw64f* pSrc, Fw64f* pSrcDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsAdd_64f_I(pSrc, pSrcDst, len);
    case DT_SSE2:
        return _sse2_fwsAdd_64f_I(pSrc, pSrcDst, len);
    case DT_REFR:
        return _refr_fwsAdd_64f_I(pSrc, pSrcDst, len);
    default:
        assert(false);
        return _refr_fwsAdd_64f_I(pSrc, pSrcDst, len);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsAdd_32fc(const Fw32fc* pSrc1, const Fw32fc* pSrc2, Fw32fc* pDst,int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsAdd_32fc(pSrc1, pSrc2, pDst, len);
    case DT_SSE2:
        return _sse2_fwsAdd_32fc(pSrc1, pSrc2, pDst, len);
    case DT_REFR:
        return _refr_fwsAdd_32fc(pSrc1, pSrc2, pDst, len);
    default:
        assert(false);
        return _refr_fwsAdd_32fc(pSrc1, pSrc2, pDst, len);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsMulC_64fc(const Fw64fc* pSrc, Fw64fc val, Fw64fc* pDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsMulC_64fc(pSrc, val, pDst, len);
    case DT_SSE2:
        return _sse2_fwsMulC_64fc(pSrc, val, pDst, len);
    case DT_REFR:
        return _refr_fwsMulC_64fc(pSrc, val, pDst, len);
    default:
        assert(false);
        return _refr_fwsMulC_64fc(pSrc, val, pDst, len);
    }
}

OREFR OSSE2 FwStatus STDCALL fwsNorm_L2_16s32f(const Fw16s* pSrc, int len, Fw32f* pNorm)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwsNorm_L2_16s32f(pSrc, len, pNorm);
    case DT_REFR:
        return _refr_fwsNorm_L2_16s32f(pSrc, len, pNorm);
    default:
        assert(false);
        return _refr_fwsNorm_L2_16s32f(pSrc, len, pNorm);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsSubCRev_64f_I(Fw64f val, Fw64f* pSrcDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsSubCRev_64f_I(val, pSrcDst, len);
    case DT_SSE2:
        return _sse2_fwsSubCRev_64f_I(val, pSrcDst, len);
    case DT_REFR:
        return _refr_fwsSubCRev_64f_I(val, pSrcDst, len);
    default:
        assert(false);
        return _refr_fwsSubCRev_64f_I(val, pSrcDst, len);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsMul_32s_Sfs(const Fw32s* pSrc1, const Fw32s* pSrc2, Fw32s* pDst,int len, int scaleFactor)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsMul_32s_Sfs(pSrc1, pSrc2, pDst, len, scaleFactor);
    case DT_SSE2:
        return _sse2_fwsMul_32s_Sfs(pSrc1, pSrc2, pDst, len, scaleFactor);
    case DT_REFR:
        return _refr_fwsMul_32s_Sfs(pSrc1, pSrc2, pDst, len, scaleFactor);
    default:
        assert(false);
        return _refr_fwsMul_32s_Sfs(pSrc1, pSrc2, pDst, len, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsThreshold_LTVal_16s(const Fw16s* pSrc, Fw16s* pDst, int len, Fw16s level, Fw16s value)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsThreshold_LTVal_16s(pSrc, pDst, len, level, value);
    case DT_SSE2:
        return _sse2_fwsThreshold_LTVal_16s(pSrc, pDst, len, level, value);
    case DT_REFR:
        return _refr_fwsThreshold_LTVal_16s(pSrc, pDst, len, level, value);
    default:
        assert(false);
        return _refr_fwsThreshold_LTVal_16s(pSrc, pDst, len, level, value);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsLShiftC_32s_I(int val, Fw32s* pSrcDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsLShiftC_32s_I(val, pSrcDst, len);
    case DT_SSE2:
        return _sse2_fwsLShiftC_32s_I(val, pSrcDst, len);
    case DT_REFR:
        return _refr_fwsLShiftC_32s_I(val, pSrcDst, len);
    default:
        assert(false);
        return _refr_fwsLShiftC_32s_I(val, pSrcDst, len);
    }
}

OREFR             FwStatus STDCALL fwsSin_32f_A24(const Fw32f* pSrc, Fw32f* pDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwsSin_32f_A24(pSrc, pDst, len);
    default:
        assert(false);
        return _refr_fwsSin_32f_A24(pSrc, pDst, len);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsSqr_32fc(const Fw32fc* pSrc, Fw32fc* pDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsSqr_32fc(pSrc, pDst, len);
    case DT_SSE2:
        return _sse2_fwsSqr_32fc(pSrc, pDst, len);
    case DT_REFR:
        return _refr_fwsSqr_32fc(pSrc, pDst, len);
    default:
        assert(false);
        return _refr_fwsSqr_32fc(pSrc, pDst, len);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsInvCbrt_32f_A11(const Fw32f* pSrc, Fw32f* pDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsInvCbrt_32f_A11(pSrc, pDst, len);
    case DT_SSE2:
        return _sse2_fwsInvCbrt_32f_A11(pSrc, pDst, len);
    case DT_REFR:
        return _refr_fwsInvCbrt_32f_A11(pSrc, pDst, len);
    default:
        assert(false);
        return _refr_fwsInvCbrt_32f_A11(pSrc, pDst, len);
    }
}

OREFR             FwStatus STDCALL fwsSinh_32f_A21(const Fw32f* pSrc, Fw32f* pDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwsSinh_32f_A21(pSrc, pDst, len);
    default:
        assert(false);
        return _refr_fwsSinh_32f_A21(pSrc, pDst, len);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsConvert_32u16s(const Fw32u* pSrc, Fw16s* pDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsConvert_32u16s(pSrc, pDst, len);
    case DT_SSE2:
        return _sse2_fwsConvert_32u16s(pSrc, pDst, len);
    case DT_REFR:
        return _refr_fwsConvert_32u16s(pSrc, pDst, len);
    default:
        assert(false);
        return _refr_fwsConvert_32u16s(pSrc, pDst, len);
    }
}

OREFR			  FwStatus STDCALL fwsSqrt_64s16s_Sfs(const Fw64s* pSrc, Fw16s* pDst, int len, int scaleFactor)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwsSqrt_64s16s_Sfs(pSrc, pDst, len, scaleFactor);
    default:
        assert(false);
        return _refr_fwsSqrt_64s16s_Sfs(pSrc, pDst, len, scaleFactor);
    }
}

OREFR OSSE2 FwStatus STDCALL fwsStdDev_64f(const Fw64f* pSrc, int len, Fw64f* pStdDev)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwsStdDev_64f(pSrc, len, pStdDev);
    case DT_REFR:
        return _refr_fwsStdDev_64f(pSrc, len, pStdDev);
    default:
        assert(false);
        return _refr_fwsStdDev_64f(pSrc, len, pStdDev);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsThreshold_GT_32s_I(Fw32s* pSrcDst, int len, Fw32s level)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsThreshold_GT_32s_I(pSrcDst, len, level);
    case DT_SSE2:
        return _sse2_fwsThreshold_GT_32s_I(pSrcDst, len, level);
    case DT_REFR:
        return _refr_fwsThreshold_GT_32s_I(pSrcDst, len, level);
    default:
        assert(false);
        return _refr_fwsThreshold_GT_32s_I(pSrcDst, len, level);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsConvert_32u64f(const Fw32u* pSrc, Fw64f* pDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsConvert_32u64f(pSrc, pDst, len);
    case DT_SSE2:
        return _sse2_fwsConvert_32u64f(pSrc, pDst, len);
    case DT_REFR:
        return _refr_fwsConvert_32u64f(pSrc, pDst, len);
    default:
        assert(false);
        return _refr_fwsConvert_32u64f(pSrc, pDst, len);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsExp_64f(const Fw64f* pSrc, Fw64f* pDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsExp_64f(pSrc, pDst, len);
    case DT_SSE2:
        return _sse2_fwsExp_64f(pSrc, pDst, len);
    case DT_REFR:
        return _refr_fwsExp_64f(pSrc, pDst, len);
    default:
        assert(false);
        return _refr_fwsExp_64f(pSrc, pDst, len);
    }
}

OREFR OSSE2 FwStatus STDCALL fwsMinMax_32s(const Fw32s* pSrc, int len, Fw32s* pMin, Fw32s* pMax)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwsMinMax_32s(pSrc, len, pMin, pMax);
    case DT_REFR:
        return _refr_fwsMinMax_32s(pSrc, len, pMin, pMax);
    default:
        assert(false);
        return _refr_fwsMinMax_32s(pSrc, len, pMin, pMax);
    }
}

OREFR             FwStatus STDCALL fwsAsinh_32f_A21(const Fw32f* pSrc, Fw32f* pDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwsAsinh_32f_A21(pSrc, pDst, len);
    default:
        assert(false);
        return _refr_fwsAsinh_32f_A21(pSrc, pDst, len);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsSet_16s(Fw16s val, Fw16s* pDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsSet_16s(val, pDst, len);
    case DT_SSE2:
        return _sse2_fwsSet_16s(val, pDst, len);
    case DT_REFR:
        return _refr_fwsSet_16s(val, pDst, len);
    default:
        assert(false);
        return _refr_fwsSet_16s(val, pDst, len);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsThreshold_LT_32s_I(Fw32s* pSrcDst, int len, Fw32s level)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsThreshold_LT_32s_I(pSrcDst, len, level);
    case DT_SSE2:
        return _sse2_fwsThreshold_LT_32s_I(pSrcDst, len, level);
    case DT_REFR:
        return _refr_fwsThreshold_LT_32s_I(pSrcDst, len, level);
    default:
        assert(false);
        return _refr_fwsThreshold_LT_32s_I(pSrcDst, len, level);
    }
}

OREFR OSSE2 FwStatus STDCALL fwsMinMax_32u(const Fw32u* pSrc, int len, Fw32u* pMin, Fw32u* pMax)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwsMinMax_32u(pSrc, len, pMin, pMax);
    case DT_REFR:
        return _refr_fwsMinMax_32u(pSrc, len, pMin, pMax);
    default:
        assert(false);
        return _refr_fwsMinMax_32u(pSrc, len, pMin, pMax);
    }
}

OREFR             FwStatus STDCALL fwsAsinh_32f_A24(const Fw32f* pSrc, Fw32f* pDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwsAsinh_32f_A24(pSrc, pDst, len);
    default:
        assert(false);
        return _refr_fwsAsinh_32f_A24(pSrc, pDst, len);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsCubrt_32f(const Fw32f* pSrc, Fw32f* pDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsCubrt_32f(pSrc, pDst, len);
    case DT_SSE2:
        return _sse2_fwsCubrt_32f(pSrc, pDst, len);
    case DT_REFR:
        return _refr_fwsCubrt_32f(pSrc, pDst, len);
    default:
        assert(false);
        return _refr_fwsCubrt_32f(pSrc, pDst, len);
    }
}

OREFR OSSE2 FwStatus STDCALL fwsMaxAbsIndx_16s(const Fw16s* pSrc, int len, Fw16s* pMaxAbs, int* pIndx)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwsMaxAbsIndx_16s(pSrc, len, pMaxAbs, pIndx);
    case DT_REFR:
        return _refr_fwsMaxAbsIndx_16s(pSrc, len, pMaxAbs, pIndx);
    default:
        assert(false);
        return _refr_fwsMaxAbsIndx_16s(pSrc, len, pMaxAbs, pIndx);
    }
}

OREFR             FwStatus STDCALL fwsAcosh_32f_A11(const Fw32f* pSrc, Fw32f* pDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwsAcosh_32f_A11(pSrc, pDst, len);
    default:
        assert(false);
        return _refr_fwsAcosh_32f_A11(pSrc, pDst, len);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsNot_8u(const Fw8u* pSrc, Fw8u* pDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsNot_8u(pSrc, pDst, len);
    case DT_SSE2:
        return _sse2_fwsNot_8u(pSrc, pDst, len);
    case DT_REFR:
        return _refr_fwsNot_8u(pSrc, pDst, len);
    default:
        assert(false);
        return _refr_fwsNot_8u(pSrc, pDst, len);
    }
}


OREFR OSSE2 OF10H FwStatus STDCALL fwsConvert_32s32f_Sfs(const Fw32s* pSrc, Fw32f* pDst, int len, int scaleFactor)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsConvert_32s32f_Sfs(pSrc, pDst, len, scaleFactor);
    case DT_SSE2:
        return _sse2_fwsConvert_32s32f_Sfs(pSrc, pDst, len, scaleFactor);
    case DT_REFR:
        return _refr_fwsConvert_32s32f_Sfs(pSrc, pDst, len, scaleFactor);
    default:
        assert(false);
        return _refr_fwsConvert_32s32f_Sfs(pSrc, pDst, len, scaleFactor);
    }
}

OREFR OSSE2 FwStatus STDCALL fwsNormDiff_L1_32fc64f(const Fw32fc* pSrc1, const Fw32fc* pSrc2, int len, Fw64f* pNorm)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwsNormDiff_L1_32fc64f(pSrc1, pSrc2, len, pNorm);
    case DT_REFR:
        return _refr_fwsNormDiff_L1_32fc64f(pSrc1, pSrc2, len, pNorm);
    default:
        assert(false);
        return _refr_fwsNormDiff_L1_32fc64f(pSrc1, pSrc2, len, pNorm);
    }
}

OREFR             FwStatus STDCALL fwsAcosh_64f_A50(const Fw64f* pSrc, Fw64f* pDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwsAcosh_64f_A50(pSrc, pDst, len);
    default:
        assert(false);
        return _refr_fwsAcosh_64f_A50(pSrc, pDst, len);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsExp_32f_A24(const Fw32f* pSrc, Fw32f* pDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsExp_32f_A24(pSrc, pDst, len);
    case DT_SSE2:
        return _sse2_fwsExp_32f_A24(pSrc, pDst, len);
    case DT_REFR:
        return _refr_fwsExp_32f_A24(pSrc, pDst, len);
    default:
        assert(false);
        return _refr_fwsExp_32f_A24(pSrc, pDst, len);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsCbrt_64f_A50(const Fw64f* pSrc, Fw64f* pDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsCbrt_64f_A50(pSrc, pDst, len);
    case DT_SSE2:
        return _sse2_fwsCbrt_64f_A50(pSrc, pDst, len);
    case DT_REFR:
        return _refr_fwsCbrt_64f_A50(pSrc, pDst, len);
    default:
        assert(false);
        return _refr_fwsCbrt_64f_A50(pSrc, pDst, len);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsExp_32f_A21(const Fw32f* pSrc, Fw32f* pDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsExp_32f_A21(pSrc, pDst, len);
    case DT_SSE2:
        return _sse2_fwsExp_32f_A21(pSrc, pDst, len);
    case DT_REFR:
        return _refr_fwsExp_32f_A21(pSrc, pDst, len);
    default:
        assert(false);
        return _refr_fwsExp_32f_A21(pSrc, pDst, len);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsSqrt_32f(const Fw32f* pSrc, Fw32f* pDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsSqrt_32f(pSrc, pDst, len);
    case DT_SSE2:
        return _sse2_fwsSqrt_32f(pSrc, pDst, len);
    case DT_REFR:
        return _refr_fwsSqrt_32f(pSrc, pDst, len);
    default:
        assert(false);
        return _refr_fwsSqrt_32f(pSrc, pDst, len);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsSub_32f_I(const Fw32f* pSrc, Fw32f* pSrcDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsSub_32f_I(pSrc, pSrcDst, len);
    case DT_SSE2:
        return _sse2_fwsSub_32f_I(pSrc, pSrcDst, len);
    case DT_REFR:
        return _refr_fwsSub_32f_I(pSrc, pSrcDst, len);
    default:
        assert(false);
        return _refr_fwsSub_32f_I(pSrc, pSrcDst, len);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsAddProduct_32f(const Fw32f* pSrc1, const Fw32f* pSrc2, Fw32f* pSrcDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsAddProduct_32f(pSrc1, pSrc2, pSrcDst, len);
    case DT_SSE2:
        return _sse2_fwsAddProduct_32f(pSrc1, pSrc2, pSrcDst, len);
    case DT_REFR:
        return _refr_fwsAddProduct_32f(pSrc1, pSrc2, pSrcDst, len);
    default:
        assert(false);
        return _refr_fwsAddProduct_32f(pSrc1, pSrc2, pSrcDst, len);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsMulC_8u_ISfs(Fw8u val, Fw8u* pSrcDst, int len, int scaleFactor)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsMulC_8u_ISfs(val, pSrcDst, len, scaleFactor);
    case DT_SSE2:
        return _sse2_fwsMulC_8u_ISfs(val, pSrcDst, len, scaleFactor);
    case DT_REFR:
        return _refr_fwsMulC_8u_ISfs(val, pSrcDst, len, scaleFactor);
    default:
        assert(false);
        return _refr_fwsMulC_8u_ISfs(val, pSrcDst, len, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsOr_8u(const Fw8u* pSrc1, const Fw8u* pSrc2, Fw8u* pDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsOr_8u(pSrc1, pSrc2, pDst, len);
    case DT_SSE2:
        return _sse2_fwsOr_8u(pSrc1, pSrc2, pDst, len);
    case DT_REFR:
        return _refr_fwsOr_8u(pSrc1, pSrc2, pDst, len);
    default:
        assert(false);
        return _refr_fwsOr_8u(pSrc1, pSrc2, pDst, len);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsAdd_8u16u(const Fw8u* pSrc1, const Fw8u* pSrc2, Fw16u* pDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsAdd_8u16u(pSrc1, pSrc2, pDst, len);
    case DT_SSE2:
        return _sse2_fwsAdd_8u16u(pSrc1, pSrc2, pDst, len);
    case DT_REFR:
        return _refr_fwsAdd_8u16u(pSrc1, pSrc2, pDst, len);
    default:
        assert(false);
        return _refr_fwsAdd_8u16u(pSrc1, pSrc2, pDst, len);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsXorC_8u(const Fw8u* pSrc, Fw8u val, Fw8u* pDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsXorC_8u(pSrc, val, pDst, len);
    case DT_SSE2:
        return _sse2_fwsXorC_8u(pSrc, val, pDst, len);
    case DT_REFR:
        return _refr_fwsXorC_8u(pSrc, val, pDst, len);
    default:
        assert(false);
        return _refr_fwsXorC_8u(pSrc, val, pDst, len);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsXor_32u_I(const Fw32u* pSrc, Fw32u* pSrcDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsXor_32u_I(pSrc, pSrcDst, len);
    case DT_SSE2:
        return _sse2_fwsXor_32u_I(pSrc, pSrcDst, len);
    case DT_REFR:
        return _refr_fwsXor_32u_I(pSrc, pSrcDst, len);
    default:
        assert(false);
        return _refr_fwsXor_32u_I(pSrc, pSrcDst, len);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsThreshold_GT_32fc_I(Fw32fc* pSrcDst, int len, Fw32f level)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsThreshold_GT_32fc_I(pSrcDst, len, level);
    case DT_SSE2:
        return _sse2_fwsThreshold_GT_32fc_I(pSrcDst, len, level);
    case DT_REFR:
        return _refr_fwsThreshold_GT_32fc_I(pSrcDst, len, level);
    default:
        assert(false);
        return _refr_fwsThreshold_GT_32fc_I(pSrcDst, len, level);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsThreshold_GT_32fc(const Fw32fc* pSrc, Fw32fc* pDst, int len, Fw32f level)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsThreshold_GT_32fc(pSrc, pDst, len, level);
    case DT_SSE2:
        return _sse2_fwsThreshold_GT_32fc(pSrc, pDst, len, level);
    case DT_REFR:
        return _refr_fwsThreshold_GT_32fc(pSrc, pDst, len, level);
    default:
        assert(false);
        return _refr_fwsThreshold_GT_32fc(pSrc, pDst, len, level);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsMul_64fc_I(const Fw64fc* pSrc, Fw64fc* pSrcDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsMul_64fc_I(pSrc, pSrcDst, len);
    case DT_SSE2:
        return _sse2_fwsMul_64fc_I(pSrc, pSrcDst, len);
    case DT_REFR:
        return _refr_fwsMul_64fc_I(pSrc, pSrcDst, len);
    default:
        assert(false);
        return _refr_fwsMul_64fc_I(pSrc, pSrcDst, len);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsSubCRev_16s_ISfs(Fw16s val, Fw16s* pSrcDst, int len, int scaleFactor)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsSubCRev_16s_ISfs(val, pSrcDst, len, scaleFactor);
    case DT_SSE2:
        return _sse2_fwsSubCRev_16s_ISfs(val, pSrcDst, len, scaleFactor);
    case DT_REFR:
        return _refr_fwsSubCRev_16s_ISfs(val, pSrcDst, len, scaleFactor);
    default:
        assert(false);
        return _refr_fwsSubCRev_16s_ISfs(val, pSrcDst, len, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsNormalize_32f(const Fw32f* pSrc, Fw32f* pDst, int len, Fw32f vsub,Fw32f vdiv)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsNormalize_32f(pSrc, pDst, len, vsub, vdiv);
    case DT_SSE2:
        return _sse2_fwsNormalize_32f(pSrc, pDst, len, vsub, vdiv);
    case DT_REFR:
        return _refr_fwsNormalize_32f(pSrc, pDst, len, vsub, vdiv);
    default:
        assert(false);
        return _refr_fwsNormalize_32f(pSrc, pDst, len, vsub, vdiv);
    }
}

OREFR OSSE2 FwStatus STDCALL fwsAutoCorr_NormA_32f(const  Fw32f*  pSrc,  int  srcLen,  Fw32f*  pDst,  int  dstLen)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwsAutoCorr_NormA_32f(pSrc, srcLen, pDst, dstLen);
    case DT_REFR:
        return _refr_fwsAutoCorr_NormA_32f(pSrc, srcLen, pDst, dstLen);
    default:
        assert(false);
        return _refr_fwsAutoCorr_NormA_32f(pSrc, srcLen, pDst, dstLen);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsRShiftC_32s(const Fw32s* pSrc, int val, Fw32s* pDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsRShiftC_32s(pSrc, val, pDst, len);
    case DT_SSE2:
        return _sse2_fwsRShiftC_32s(pSrc, val, pDst, len);
    case DT_REFR:
        return _refr_fwsRShiftC_32s(pSrc, val, pDst, len);
    default:
        assert(false);
        return _refr_fwsRShiftC_32s(pSrc, val, pDst, len);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsMulC_32fc_I(Fw32fc val, Fw32fc* pSrcDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsMulC_32fc_I(val, pSrcDst, len);
    case DT_SSE2:
        return _sse2_fwsMulC_32fc_I(val, pSrcDst, len);
    case DT_REFR:
        return _refr_fwsMulC_32fc_I(val, pSrcDst, len);
    default:
        assert(false);
        return _refr_fwsMulC_32fc_I(val, pSrcDst, len);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsRShiftC_32s_I(int val, Fw32s* pSrcDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsRShiftC_32s_I(val, pSrcDst, len);
    case DT_SSE2:
        return _sse2_fwsRShiftC_32s_I(val, pSrcDst, len);
    case DT_REFR:
        return _refr_fwsRShiftC_32s_I(val, pSrcDst, len);
    default:
        assert(false);
        return _refr_fwsRShiftC_32s_I(val, pSrcDst, len);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsDiv_16sc_Sfs(const Fw16sc* pSrc1, const Fw16sc* pSrc2, Fw16sc* pDst, int len, int scaleFactor)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsDiv_16sc_Sfs(pSrc1, pSrc2, pDst, len, scaleFactor);
    case DT_SSE2:
        return _sse2_fwsDiv_16sc_Sfs(pSrc1, pSrc2, pDst, len, scaleFactor);
    case DT_REFR:
        return _refr_fwsDiv_16sc_Sfs(pSrc1, pSrc2, pDst, len, scaleFactor);
    default:
        assert(false);
        return _refr_fwsDiv_16sc_Sfs(pSrc1, pSrc2, pDst, len, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsThreshold_LT_64fc(const Fw64fc* pSrc, Fw64fc* pDst, int len, Fw64f level)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsThreshold_LT_64fc(pSrc, pDst, len, level);
    case DT_SSE2:
        return _sse2_fwsThreshold_LT_64fc(pSrc, pDst, len, level);
    case DT_REFR:
        return _refr_fwsThreshold_LT_64fc(pSrc, pDst, len, level);
    default:
        assert(false);
        return _refr_fwsThreshold_LT_64fc(pSrc, pDst, len, level);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsSqrt_16sc_Sfs(const Fw16sc* pSrc, Fw16sc* pDst, int len, int scaleFactor)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsSqrt_16sc_Sfs(pSrc, pDst, len, scaleFactor);
    case DT_SSE2:
        return _sse2_fwsSqrt_16sc_Sfs(pSrc, pDst, len, scaleFactor);
    case DT_REFR:
        return _refr_fwsSqrt_16sc_Sfs(pSrc, pDst, len, scaleFactor);
    default:
        assert(false);
        return _refr_fwsSqrt_16sc_Sfs(pSrc, pDst, len, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsThreshold_LT_16s(const Fw16s* pSrc, Fw16s* pDst, int len, Fw16s level)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsThreshold_LT_16s(pSrc, pDst, len, level);
    case DT_SSE2:
        return _sse2_fwsThreshold_LT_16s(pSrc, pDst, len, level);
    case DT_REFR:
        return _refr_fwsThreshold_LT_16s(pSrc, pDst, len, level);
    default:
        assert(false);
        return _refr_fwsThreshold_LT_16s(pSrc, pDst, len, level);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsNormalize_16sc_Sfs(const Fw16sc* pSrc, Fw16sc* pDst, int len, Fw16sc vsub, int vdiv, int scaleFactor)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsNormalize_16sc_Sfs(pSrc, pDst, len, vsub, vdiv, scaleFactor);
    case DT_SSE2:
        return _sse2_fwsNormalize_16sc_Sfs(pSrc, pDst, len, vsub, vdiv, scaleFactor);
    case DT_REFR:
        return _refr_fwsNormalize_16sc_Sfs(pSrc, pDst, len, vsub, vdiv, scaleFactor);
    default:
        assert(false);
        return _refr_fwsNormalize_16sc_Sfs(pSrc, pDst, len, vsub, vdiv, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsMul_64f_I(const Fw64f* pSrc, Fw64f* pSrcDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsMul_64f_I(pSrc, pSrcDst, len);
    case DT_SSE2:
        return _sse2_fwsMul_64f_I(pSrc, pSrcDst, len);
    case DT_REFR:
        return _refr_fwsMul_64f_I(pSrc, pSrcDst, len);
    default:
        assert(false);
        return _refr_fwsMul_64f_I(pSrc, pSrcDst, len);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsThreshold_LTValGTVal_32f(const Fw32f* pSrc, Fw32f* pDst, int len, Fw32f levelLT, Fw32f valueLT, Fw32f levelGT, Fw32f valueGT)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsThreshold_LTValGTVal_32f(pSrc, pDst, len, levelLT, valueLT, levelGT, valueGT);
    case DT_SSE2:
        return _sse2_fwsThreshold_LTValGTVal_32f(pSrc, pDst, len, levelLT, valueLT, levelGT, valueGT);
    case DT_REFR:
        return _refr_fwsThreshold_LTValGTVal_32f(pSrc, pDst, len, levelLT, valueLT, levelGT, valueGT);
    default:
        assert(false);
        return _refr_fwsThreshold_LTValGTVal_32f(pSrc, pDst, len, levelLT, valueLT, levelGT, valueGT);
    }
}

OREFR OSSE2 FwStatus STDCALL fwsMinAbsIndx_32s(const Fw32s* pSrc, int len, Fw32s* pMinAbs, int* pIndx)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwsMinAbsIndx_32s(pSrc, len, pMinAbs, pIndx);
    case DT_REFR:
        return _refr_fwsMinAbsIndx_32s(pSrc, len, pMinAbs, pIndx);
    default:
        assert(false);
        return _refr_fwsMinAbsIndx_32s(pSrc, len, pMinAbs, pIndx);
    }
}

OREFR             FwStatus STDCALL fwsPowx_64f_A53(const Fw64f* pSrc1, const Fw64f val, Fw64f* pDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwsPowx_64f_A53(pSrc1, val, pDst, len);
    default:
        assert(false);
        return _refr_fwsPowx_64f_A53(pSrc1, val, pDst, len);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsMove_16sc(const Fw16sc* pSrc, Fw16sc* pDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsMove_16sc(pSrc, pDst, len);
    case DT_SSE2:
        return _sse2_fwsMove_16sc(pSrc, pDst, len);
    case DT_REFR:
        return _refr_fwsMove_16sc(pSrc, pDst, len);
    default:
        assert(false);
        return _refr_fwsMove_16sc(pSrc, pDst, len);
    }
}

OREFR             FwStatus STDCALL fwsPowx_64f_A50(const Fw64f* pSrc1, const Fw64f val, Fw64f* pDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwsPowx_64f_A50(pSrc1, val, pDst, len);
    default:
        assert(false);
        return _refr_fwsPowx_64f_A50(pSrc1, val, pDst, len);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsSub_64f_I(const Fw64f* pSrc, Fw64f* pSrcDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsSub_64f_I(pSrc, pSrcDst, len);
    case DT_SSE2:
        return _sse2_fwsSub_64f_I(pSrc, pSrcDst, len);
    case DT_REFR:
        return _refr_fwsSub_64f_I(pSrc, pSrcDst, len);
    default:
        assert(false);
        return _refr_fwsSub_64f_I(pSrc, pSrcDst, len);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsThreshold_LTInv_64f(const Fw64f* pSrc, Fw64f* pDst, int len, Fw64f level)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsThreshold_LTInv_64f(pSrc, pDst, len, level);
    case DT_SSE2:
        return _sse2_fwsThreshold_LTInv_64f(pSrc, pDst, len, level);
    case DT_REFR:
        return _refr_fwsThreshold_LTInv_64f(pSrc, pDst, len, level);
    default:
        assert(false);
        return _refr_fwsThreshold_LTInv_64f(pSrc, pDst, len, level);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsThreshold_LTVal_16s_I(Fw16s* pSrcDst, int len, Fw16s level, Fw16s value)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsThreshold_LTVal_16s_I(pSrcDst, len, level, value);
    case DT_SSE2:
        return _sse2_fwsThreshold_LTVal_16s_I(pSrcDst, len, level, value);
    case DT_REFR:
        return _refr_fwsThreshold_LTVal_16s_I(pSrcDst, len, level, value);
    default:
        assert(false);
        return _refr_fwsThreshold_LTVal_16s_I(pSrcDst, len, level, value);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsThreshold_LTValGTVal_32s(const Fw32s* pSrc, Fw32s* pDst, int len, Fw32s levelLT, Fw32s valueLT, Fw32s levelGT, Fw32s valueGT)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsThreshold_LTValGTVal_32s(pSrc, pDst, len, levelLT, valueLT, levelGT, valueGT);
    case DT_SSE2:
        return _sse2_fwsThreshold_LTValGTVal_32s(pSrc, pDst, len, levelLT, valueLT, levelGT, valueGT);
    case DT_REFR:
        return _refr_fwsThreshold_LTValGTVal_32s(pSrc, pDst, len, levelLT, valueLT, levelGT, valueGT);
    default:
        assert(false);
        return _refr_fwsThreshold_LTValGTVal_32s(pSrc, pDst, len, levelLT, valueLT, levelGT, valueGT);
    }
}


OREFR OSSE2 FwStatus STDCALL fwsAutoCorr_64f(const  Fw64f*  pSrc,  int  srcLen,  Fw64f*  pDst,  int  dstLen)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwsAutoCorr_64f(pSrc, srcLen, pDst, dstLen);
    case DT_REFR:
        return _refr_fwsAutoCorr_64f(pSrc, srcLen, pDst, dstLen);
    default:
        assert(false);
        return _refr_fwsAutoCorr_64f(pSrc, srcLen, pDst, dstLen);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsSubCRev_16sc_Sfs(const Fw16sc* pSrc, Fw16sc val, Fw16sc* pDst, int len, int scaleFactor)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsSubCRev_16sc_Sfs(pSrc, val, pDst, len, scaleFactor);
    case DT_SSE2:
        return _sse2_fwsSubCRev_16sc_Sfs(pSrc, val, pDst, len, scaleFactor);
    case DT_REFR:
        return _refr_fwsSubCRev_16sc_Sfs(pSrc, val, pDst, len, scaleFactor);
    default:
        assert(false);
        return _refr_fwsSubCRev_16sc_Sfs(pSrc, val, pDst, len, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsCopy_32fc(const Fw32fc* pSrc, Fw32fc* pDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsCopy_32fc(pSrc, pDst, len);
    case DT_SSE2:
        return _sse2_fwsCopy_32fc(pSrc, pDst, len);
    case DT_REFR:
        return _refr_fwsCopy_32fc(pSrc, pDst, len);
    default:
        assert(false);
        return _refr_fwsCopy_32fc(pSrc, pDst, len);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsMulC_32s_ISfs(Fw32s val, Fw32s* pSrcDst, int len, int scaleFactor)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsMulC_32s_ISfs(val, pSrcDst, len, scaleFactor);
    case DT_SSE2:
        return _sse2_fwsMulC_32s_ISfs(val, pSrcDst, len, scaleFactor);
    case DT_REFR:
        return _refr_fwsMulC_32s_ISfs(val, pSrcDst, len, scaleFactor);
    default:
        assert(false);
        return _refr_fwsMulC_32s_ISfs(val, pSrcDst, len, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsThreshold_LTVal_64f(const Fw64f* pSrc, Fw64f* pDst, int len, Fw64f level, Fw64f value)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsThreshold_LTVal_64f(pSrc, pDst, len, level, value);
    case DT_SSE2:
        return _sse2_fwsThreshold_LTVal_64f(pSrc, pDst, len, level, value);
    case DT_REFR:
        return _refr_fwsThreshold_LTVal_64f(pSrc, pDst, len, level, value);
    default:
        assert(false);
        return _refr_fwsThreshold_LTVal_64f(pSrc, pDst, len, level, value);
    }
}

OREFR             FwStatus STDCALL fwsAsinh_64f_A50(const Fw64f* pSrc, Fw64f* pDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwsAsinh_64f_A50(pSrc, pDst, len);
    default:
        assert(false);
        return _refr_fwsAsinh_64f_A50(pSrc, pDst, len);
    }
}

OREFR             FwStatus STDCALL fwsAsinh_64f_A53(const Fw64f* pSrc, Fw64f* pDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwsAsinh_64f_A53(pSrc, pDst, len);
    default:
        assert(false);
        return _refr_fwsAsinh_64f_A53(pSrc, pDst, len);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsMove_16s(const Fw16s* pSrc, Fw16s* pDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsMove_16s(pSrc, pDst, len);
    case DT_SSE2:
        return _sse2_fwsMove_16s(pSrc, pDst, len);
    case DT_REFR:
        return _refr_fwsMove_16s(pSrc, pDst, len);
    default:
        assert(false);
        return _refr_fwsMove_16s(pSrc, pDst, len);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsPowx_32f_A24(const Fw32f* pSrc1, const Fw32f val, Fw32f* pDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsPowx_32f_A24(pSrc1, val, pDst, len);
    case DT_SSE2:
        return _sse2_fwsPowx_32f_A24(pSrc1, val, pDst, len);
    case DT_REFR:
        return _refr_fwsPowx_32f_A24(pSrc1, val, pDst, len);
    default:
        assert(false);
        return _refr_fwsPowx_32f_A24(pSrc1, val, pDst, len);
    }
}

OREFR OSSE2 FwStatus STDCALL fwsMinMaxIndx_64f(const Fw64f* pSrc, int len, Fw64f* pMin, int* pMinIndx, Fw64f* pMax, int* pMaxIndx)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwsMinMaxIndx_64f(pSrc, len, pMin, pMinIndx, pMax, pMaxIndx);
    case DT_REFR:
        return _refr_fwsMinMaxIndx_64f(pSrc, len, pMin, pMinIndx, pMax, pMaxIndx);
    default:
        assert(false);
        return _refr_fwsMinMaxIndx_64f(pSrc, len, pMin, pMinIndx, pMax, pMaxIndx);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsPowx_32f_A21(const Fw32f* pSrc1, const Fw32f val, Fw32f* pDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsPowx_32f_A21(pSrc1, val, pDst, len);
    case DT_SSE2:
        return _sse2_fwsPowx_32f_A21(pSrc1, val, pDst, len);
    case DT_REFR:
        return _refr_fwsPowx_32f_A21(pSrc1, val, pDst, len);
    default:
        assert(false);
        return _refr_fwsPowx_32f_A21(pSrc1, val, pDst, len);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsMagnitude_32fc(const Fw32fc* pSrc, Fw32f* pDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsMagnitude_32fc(pSrc, pDst, len);
    case DT_SSE2:
        return _sse2_fwsMagnitude_32fc(pSrc, pDst, len);
    case DT_REFR:
        return _refr_fwsMagnitude_32fc(pSrc, pDst, len);
    default:
        assert(false);
        return _refr_fwsMagnitude_32fc(pSrc, pDst, len);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsInvSqrt_32f_A11(const Fw32f* pSrc, Fw32f* pDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsInvSqrt_32f_A11(pSrc, pDst, len);
    case DT_SSE2:
        return _sse2_fwsInvSqrt_32f_A11(pSrc, pDst, len);
    case DT_REFR:
        return _refr_fwsInvSqrt_32f_A11(pSrc, pDst, len);
    default:
        assert(false);
        return _refr_fwsInvSqrt_32f_A11(pSrc, pDst, len);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsSubC_64f(const Fw64f* pSrc, Fw64f val, Fw64f* pDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsSubC_64f(pSrc, val, pDst, len);
    case DT_SSE2:
        return _sse2_fwsSubC_64f(pSrc, val, pDst, len);
    case DT_REFR:
        return _refr_fwsSubC_64f(pSrc, val, pDst, len);
    default:
        assert(false);
        return _refr_fwsSubC_64f(pSrc, val, pDst, len);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsDiv_16s_ISfs(const Fw16s* pSrc, Fw16s* pSrcDst, int len, int scaleFactor)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsDiv_16s_ISfs(pSrc, pSrcDst, len, scaleFactor);
    case DT_SSE2:
        return _sse2_fwsDiv_16s_ISfs(pSrc, pSrcDst, len, scaleFactor);
    case DT_REFR:
        return _refr_fwsDiv_16s_ISfs(pSrc, pSrcDst, len, scaleFactor);
    default:
        assert(false);
        return _refr_fwsDiv_16s_ISfs(pSrc, pSrcDst, len, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsMul_16s_I(const Fw16s* pSrc, Fw16s* pSrcDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsMul_16s_I(pSrc, pSrcDst, len);
    case DT_SSE2:
        return _sse2_fwsMul_16s_I(pSrc, pSrcDst, len);
    case DT_REFR:
        return _refr_fwsMul_16s_I(pSrc, pSrcDst, len);
    default:
        assert(false);
        return _refr_fwsMul_16s_I(pSrc, pSrcDst, len);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsExp_16s_ISfs(Fw16s* pSrcDst, int len, int scaleFactor)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsExp_16s_ISfs(pSrcDst, len, scaleFactor);
    case DT_SSE2:
        return _sse2_fwsExp_16s_ISfs(pSrcDst, len, scaleFactor);
    case DT_REFR:
        return _refr_fwsExp_16s_ISfs(pSrcDst, len, scaleFactor);
    default:
        assert(false);
        return _refr_fwsExp_16s_ISfs(pSrcDst, len, scaleFactor);
    }
}

OREFR OSSE2 FwStatus STDCALL fwsMinEvery_32s_I(const Fw32s* pSrc, Fw32s* pSrcDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwsMinEvery_32s_I(pSrc, pSrcDst, len);
    case DT_REFR:
        return _refr_fwsMinEvery_32s_I(pSrc, pSrcDst, len);
    default:
        assert(false);
        return _refr_fwsMinEvery_32s_I(pSrc, pSrcDst, len);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsSubC_32s_ISfs(Fw32s val, Fw32s* pSrcDst, int len, int scaleFactor)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsSubC_32s_ISfs(val, pSrcDst, len, scaleFactor);
    case DT_SSE2:
        return _sse2_fwsSubC_32s_ISfs(val, pSrcDst, len, scaleFactor);
    case DT_REFR:
        return _refr_fwsSubC_32s_ISfs(val, pSrcDst, len, scaleFactor);
    default:
        assert(false);
        return _refr_fwsSubC_32s_ISfs(val, pSrcDst, len, scaleFactor);
    }
}

OREFR FwStatus STDCALL fwsMax_64u( const Fw64u *pSrc, int len, Fw64u *pMax )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwsMax_64u(pSrc, len, pMax);
    default:
        assert(false);
        return _refr_fwsMax_64u(pSrc, len, pMax);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsSubC_64f_I(Fw64f val, Fw64f* pSrcDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsSubC_64f_I(val, pSrcDst, len);
    case DT_SSE2:
        return _sse2_fwsSubC_64f_I(val, pSrcDst, len);
    case DT_REFR:
        return _refr_fwsSubC_64f_I(val, pSrcDst, len);
    default:
        assert(false);
        return _refr_fwsSubC_64f_I(val, pSrcDst, len);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsSubC_32sc_Sfs(const Fw32sc* pSrc, Fw32sc val, Fw32sc* pDst, int len, int scaleFactor)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsSubC_32sc_Sfs(pSrc, val, pDst, len, scaleFactor);
    case DT_SSE2:
        return _sse2_fwsSubC_32sc_Sfs(pSrc, val, pDst, len, scaleFactor);
    case DT_REFR:
        return _refr_fwsSubC_32sc_Sfs(pSrc, val, pDst, len, scaleFactor);
    default:
        assert(false);
        return _refr_fwsSubC_32sc_Sfs(pSrc, val, pDst, len, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsMulC_16s_Sfs(const Fw16s* pSrc, Fw16s val, Fw16s* pDst, int len,int scaleFactor)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsMulC_16s_Sfs(pSrc, val, pDst, len, scaleFactor);
    case DT_SSE2:
        return _sse2_fwsMulC_16s_Sfs(pSrc, val, pDst, len, scaleFactor);
    case DT_REFR:
        return _refr_fwsMulC_16s_Sfs(pSrc, val, pDst, len, scaleFactor);
    default:
        assert(false);
        return _refr_fwsMulC_16s_Sfs(pSrc, val, pDst, len, scaleFactor);
    }
}

OREFR             FwStatus STDCALL fwsAcos_32f_A24(const Fw32f* pSrc, Fw32f* pDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwsAcos_32f_A24(pSrc, pDst, len);
    default:
        assert(false);
        return _refr_fwsAcos_32f_A24(pSrc, pDst, len);
    }
}

OREFR             FwStatus STDCALL fwsAcos_32f_A21(const Fw32f* pSrc, Fw32f* pDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwsAcos_32f_A21(pSrc, pDst, len);
    default:
        assert(false);
        return _refr_fwsAcos_32f_A21(pSrc, pDst, len);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsXorC_16u(const Fw16u* pSrc, Fw16u val, Fw16u* pDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsXorC_16u(pSrc, val, pDst, len);
    case DT_SSE2:
        return _sse2_fwsXorC_16u(pSrc, val, pDst, len);
    case DT_REFR:
        return _refr_fwsXorC_16u(pSrc, val, pDst, len);
    default:
        assert(false);
        return _refr_fwsXorC_16u(pSrc, val, pDst, len);
    }
}

OREFR OSSE2 FwStatus STDCALL fwsMax_64f(const Fw64f* pSrc, int len, Fw64f* pMax)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwsMax_64f(pSrc, len, pMax);
    case DT_REFR:
        return _refr_fwsMax_64f(pSrc, len, pMax);
    default:
        assert(false);
        return _refr_fwsMax_64f(pSrc, len, pMax);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsSubCRev_32sc_Sfs(const Fw32sc* pSrc, Fw32sc val, Fw32sc* pDst, int len, int scaleFactor)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsSubCRev_32sc_Sfs(pSrc, val, pDst, len, scaleFactor);
    case DT_SSE2:
        return _sse2_fwsSubCRev_32sc_Sfs(pSrc, val, pDst, len, scaleFactor);
    case DT_REFR:
        return _refr_fwsSubCRev_32sc_Sfs(pSrc, val, pDst, len, scaleFactor);
    default:
        assert(false);
        return _refr_fwsSubCRev_32sc_Sfs(pSrc, val, pDst, len, scaleFactor);
    }
}

OREFR OSSE2 FwStatus STDCALL fwsNormDiff_Inf_16s32f(const Fw16s* pSrc1, const Fw16s* pSrc2, int len, Fw32f* pNorm)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwsNormDiff_Inf_16s32f(pSrc1, pSrc2, len, pNorm);
    case DT_REFR:
        return _refr_fwsNormDiff_Inf_16s32f(pSrc1, pSrc2, len, pNorm);
    default:
        assert(false);
        return _refr_fwsNormDiff_Inf_16s32f(pSrc1, pSrc2, len, pNorm);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsThreshold_LTInv_32fc(const Fw32fc* pSrc, Fw32fc* pDst, int len, Fw32f level)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsThreshold_LTInv_32fc(pSrc, pDst, len, level);
    case DT_SSE2:
        return _sse2_fwsThreshold_LTInv_32fc(pSrc, pDst, len, level);
    case DT_REFR:
        return _refr_fwsThreshold_LTInv_32fc(pSrc, pDst, len, level);
    default:
        assert(false);
        return _refr_fwsThreshold_LTInv_32fc(pSrc, pDst, len, level);
    }
}

OREFR             FwStatus STDCALL fwsAsin_32f_A11(const Fw32f* pSrc, Fw32f* pDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwsAsin_32f_A11(pSrc, pDst, len);
    default:
        assert(false);
        return _refr_fwsAsin_32f_A11(pSrc, pDst, len);
    }
}

OREFR OSSE2 FwStatus STDCALL fwsNormDiff_Inf_16s32s_Sfs(const Fw16s* pSrc1, const Fw16s* pSrc2,int len, Fw32s* pNorm, int scaleFactor)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwsNormDiff_Inf_16s32s_Sfs(pSrc1, pSrc2, len, pNorm, scaleFactor);
    case DT_REFR:
        return _refr_fwsNormDiff_Inf_16s32s_Sfs(pSrc1, pSrc2, len, pNorm, scaleFactor);
    default:
        assert(false);
        return _refr_fwsNormDiff_Inf_16s32s_Sfs(pSrc1, pSrc2, len, pNorm, scaleFactor);
    }
}

OREFR OSSE2 FwStatus STDCALL fwsMinIndx_32s(const Fw32s* pSrc, int len, Fw32s* pMin, int* pIndx)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwsMinIndx_32s(pSrc, len, pMin, pIndx);
    case DT_REFR:
        return _refr_fwsMinIndx_32s(pSrc, len, pMin, pIndx);
    default:
        assert(false);
        return _refr_fwsMinIndx_32s(pSrc, len, pMin, pIndx);
    }
}

OREFR OSSE2 FwStatus STDCALL fwsMaxIndx_32s(const Fw32s* pSrc, int len, Fw32s* pMax, int* pIndx)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwsMaxIndx_32s(pSrc, len, pMax, pIndx);
    case DT_REFR:
        return _refr_fwsMaxIndx_32s(pSrc, len, pMax, pIndx);
    default:
        assert(false);
        return _refr_fwsMaxIndx_32s(pSrc, len, pMax, pIndx);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsSet_64fc(Fw64fc val, Fw64fc* pDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsSet_64fc(val, pDst, len);
    case DT_SSE2:
        return _sse2_fwsSet_64fc(val, pDst, len);
    case DT_REFR:
        return _refr_fwsSet_64fc(val, pDst, len);
    default:
        assert(false);
        return _refr_fwsSet_64fc(val, pDst, len);
    }
}

OREFR OSSE2 FwStatus STDCALL fwsNorm_Inf_64f(const Fw64f* pSrc, int len, Fw64f* pNorm)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwsNorm_Inf_64f(pSrc, len, pNorm);
    case DT_REFR:
        return _refr_fwsNorm_Inf_64f(pSrc, len, pNorm);
    default:
        assert(false);
        return _refr_fwsNorm_Inf_64f(pSrc, len, pNorm);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsSqr_32f(const Fw32f* pSrc, Fw32f* pDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsSqr_32f(pSrc, pDst, len);
    case DT_SSE2:
        return _sse2_fwsSqr_32f(pSrc, pDst, len);
    case DT_REFR:
        return _refr_fwsSqr_32f(pSrc, pDst, len);
    default:
        assert(false);
        return _refr_fwsSqr_32f(pSrc, pDst, len);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsConvert_16s64f_Sfs(const Fw16s* pSrc, Fw64f* pDst, int len, int scaleFactor)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsConvert_16s64f_Sfs(pSrc, pDst, len, scaleFactor);
    case DT_SSE2:
        return _sse2_fwsConvert_16s64f_Sfs(pSrc, pDst, len, scaleFactor);
    case DT_REFR:
        return _refr_fwsConvert_16s64f_Sfs(pSrc, pDst, len, scaleFactor);
    default:
        assert(false);
        return _refr_fwsConvert_16s64f_Sfs(pSrc, pDst, len, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsLog10_32f_A24(const Fw32f* pSrc, Fw32f* pDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsLog10_32f_A24(pSrc, pDst, len);
    case DT_SSE2:
        return _sse2_fwsLog10_32f_A24(pSrc, pDst, len);
    case DT_REFR:
        return _refr_fwsLog10_32f_A24(pSrc, pDst, len);
    default:
        assert(false);
        return _refr_fwsLog10_32f_A24(pSrc, pDst, len);
    }
}

OREFR OSSE2 FwStatus STDCALL fwsMaxIndx_32f(const Fw32f* pSrc, int len, Fw32f* pMax, int* pIndx)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwsMaxIndx_32f(pSrc, len, pMax, pIndx);
    case DT_REFR:
        return _refr_fwsMaxIndx_32f(pSrc, len, pMax, pIndx);
    default:
        assert(false);
        return _refr_fwsMaxIndx_32f(pSrc, len, pMax, pIndx);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsLog10_32f_A21(const Fw32f* pSrc, Fw32f* pDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsLog10_32f_A21(pSrc, pDst, len);
    case DT_SSE2:
        return _sse2_fwsLog10_32f_A21(pSrc, pDst, len);
    case DT_REFR:
        return _refr_fwsLog10_32f_A21(pSrc, pDst, len);
    default:
        assert(false);
        return _refr_fwsLog10_32f_A21(pSrc, pDst, len);
    }
}

OREFR OSSE2 FwStatus STDCALL fwsMinIndx_32f(const Fw32f* pSrc, int len, Fw32f* pMin, int* pIndx)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwsMinIndx_32f(pSrc, len, pMin, pIndx);
    case DT_REFR:
        return _refr_fwsMinIndx_32f(pSrc, len, pMin, pIndx);
    default:
        assert(false);
        return _refr_fwsMinIndx_32f(pSrc, len, pMin, pIndx);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsSet_8u(Fw8u val, Fw8u* pDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsSet_8u(val, pDst, len);
    case DT_SSE2:
        return _sse2_fwsSet_8u(val, pDst, len);
    case DT_REFR:
        return _refr_fwsSet_8u(val, pDst, len);
    default:
        assert(false);
        return _refr_fwsSet_8u(val, pDst, len);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsXor_8u(const Fw8u* pSrc1, const Fw8u* pSrc2, Fw8u* pDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsXor_8u(pSrc1, pSrc2, pDst, len);
    case DT_SSE2:
        return _sse2_fwsXor_8u(pSrc1, pSrc2, pDst, len);
    case DT_REFR:
        return _refr_fwsXor_8u(pSrc1, pSrc2, pDst, len);
    default:
        assert(false);
        return _refr_fwsXor_8u(pSrc1, pSrc2, pDst, len);
    }
}

OREFR FwStatus STDCALL fwsFindC_16u(const Fw16u* pSrc, int len, Fw16u valFind, int* pIndex)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwsFindC_16u(pSrc, len, valFind, pIndex);
    default:
        assert(false);
        return _refr_fwsFindC_16u(pSrc, len, valFind, pIndex);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsSub_32sc_Sfs(const Fw32sc* pSrc1, const Fw32sc* pSrc2, Fw32sc* pDst, int len, int scaleFactor)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsSub_32sc_Sfs(pSrc1, pSrc2, pDst, len, scaleFactor);
    case DT_SSE2:
        return _sse2_fwsSub_32sc_Sfs(pSrc1, pSrc2, pDst, len, scaleFactor);
    case DT_REFR:
        return _refr_fwsSub_32sc_Sfs(pSrc1, pSrc2, pDst, len, scaleFactor);
    default:
        assert(false);
        return _refr_fwsSub_32sc_Sfs(pSrc1, pSrc2, pDst, len, scaleFactor);
    }
}

OREFR             FwStatus STDCALL fwsPow_64f_A50(const Fw64f* pSrc1, const Fw64f* pSrc2, Fw64f* pDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwsPow_64f_A50(pSrc1, pSrc2, pDst, len);
    default:
        assert(false);
        return _refr_fwsPow_64f_A50(pSrc1, pSrc2, pDst, len);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsSqrt_64fc(const Fw64fc* pSrc, Fw64fc* pDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsSqrt_64fc(pSrc, pDst, len);
    case DT_SSE2:
        return _sse2_fwsSqrt_64fc(pSrc, pDst, len);
    case DT_REFR:
        return _refr_fwsSqrt_64fc(pSrc, pDst, len);
    default:
        assert(false);
        return _refr_fwsSqrt_64fc(pSrc, pDst, len);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsMagnitude_64fc(const Fw64fc* pSrc, Fw64f* pDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsMagnitude_64fc(pSrc, pDst, len);
    case DT_SSE2:
        return _sse2_fwsMagnitude_64fc(pSrc, pDst, len);
    case DT_REFR:
        return _refr_fwsMagnitude_64fc(pSrc, pDst, len);
    default:
        assert(false);
        return _refr_fwsMagnitude_64fc(pSrc, pDst, len);
    }
}

OREFR OSSE2 FwStatus STDCALL fwsMinAbs_32s(const Fw32s* pSrc, int len, Fw32s* pMinAbs)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwsMinAbs_32s(pSrc, len, pMinAbs);
    case DT_REFR:
        return _refr_fwsMinAbs_32s(pSrc, len, pMinAbs);
    default:
        assert(false);
        return _refr_fwsMinAbs_32s(pSrc, len, pMinAbs);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsLn_32f_A11(const Fw32f* pSrc, Fw32f* pDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsLn_32f_A11(pSrc, pDst, len);
    case DT_SSE2:
        return _sse2_fwsLn_32f_A11(pSrc, pDst, len);
    case DT_REFR:
        return _refr_fwsLn_32f_A11(pSrc, pDst, len);
    default:
        assert(false);
        return _refr_fwsLn_32f_A11(pSrc, pDst, len);
    }
}

OREFR             FwStatus STDCALL fwsAtanh_32f_A11(const Fw32f* pSrc, Fw32f* pDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwsAtanh_32f_A11(pSrc, pDst, len);
    default:
        assert(false);
        return _refr_fwsAtanh_32f_A11(pSrc, pDst, len);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsSet_32f(Fw32f val, Fw32f* pDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsSet_32f(val, pDst, len);
    case DT_SSE2:
        return _sse2_fwsSet_32f(val, pDst, len);
    case DT_REFR:
        return _refr_fwsSet_32f(val, pDst, len);
    default:
        assert(false);
        return _refr_fwsSet_32f(val, pDst, len);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsMulC_16s_ISfs(Fw16s val, Fw16s* pSrcDst, int len, int scaleFactor)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsMulC_16s_ISfs(val, pSrcDst, len, scaleFactor);
    case DT_SSE2:
        return _sse2_fwsMulC_16s_ISfs(val, pSrcDst, len, scaleFactor);
    case DT_REFR:
        return _refr_fwsMulC_16s_ISfs(val, pSrcDst, len, scaleFactor);
    default:
        assert(false);
        return _refr_fwsMulC_16s_ISfs(val, pSrcDst, len, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsMul_8u16u(const Fw8u* pSrc1, const Fw8u* pSrc2,Fw16u *pDst,int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsMul_8u16u(pSrc1, pSrc2, pDst, len);
    case DT_SSE2:
        return _sse2_fwsMul_8u16u(pSrc1, pSrc2, pDst, len);
    case DT_REFR:
        return _refr_fwsMul_8u16u(pSrc1, pSrc2, pDst, len);
    default:
        assert(false);
        return _refr_fwsMul_8u16u(pSrc1, pSrc2, pDst, len);
    }
}

OREFR OSSE2 FwStatus STDCALL fwsMinMax_16u(const Fw16u* pSrc, int len, Fw16u* pMin, Fw16u* pMax)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwsMinMax_16u(pSrc, len, pMin, pMax);
    case DT_REFR:
        return _refr_fwsMinMax_16u(pSrc, len, pMin, pMax);
    default:
        assert(false);
        return _refr_fwsMinMax_16u(pSrc, len, pMin, pMax);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsAtan2_32f_A21(const Fw32f* pSrc1, const Fw32f* pSrc2, Fw32f* pDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsAtan2_32f_A21(pSrc1, pSrc2, pDst, len);
    case DT_SSE2:
        return _sse2_fwsAtan2_32f_A21(pSrc1, pSrc2, pDst, len);
    case DT_REFR:
        return _refr_fwsAtan2_32f_A21(pSrc1, pSrc2, pDst, len);
    default:
        assert(false);
        return _refr_fwsAtan2_32f_A21(pSrc1, pSrc2, pDst, len);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsAtan2_32f_A24(const Fw32f* pSrc1, const Fw32f* pSrc2, Fw32f* pDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsAtan2_32f_A24(pSrc1, pSrc2, pDst, len);
    case DT_SSE2:
        return _sse2_fwsAtan2_32f_A24(pSrc1, pSrc2, pDst, len);
    case DT_REFR:
        return _refr_fwsAtan2_32f_A24(pSrc1, pSrc2, pDst, len);
    default:
        assert(false);
        return _refr_fwsAtan2_32f_A24(pSrc1, pSrc2, pDst, len);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsDiv_32f(const Fw32f* pSrc1, const Fw32f* pSrc2, Fw32f* pDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsDiv_32f(pSrc1, pSrc2, pDst, len);
    case DT_SSE2:
        return _sse2_fwsDiv_32f(pSrc1, pSrc2, pDst, len);
    case DT_REFR:
        return _refr_fwsDiv_32f(pSrc1, pSrc2, pDst, len);
    default:
        assert(false);
        return _refr_fwsDiv_32f(pSrc1, pSrc2, pDst, len);
    }
}

OREFR OSSE2 FwStatus STDCALL fwsMinMax_16s(const Fw16s* pSrc, int len, Fw16s* pMin, Fw16s* pMax)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwsMinMax_16s(pSrc, len, pMin, pMax);
    case DT_REFR:
        return _refr_fwsMinMax_16s(pSrc, len, pMin, pMax);
    default:
        assert(false);
        return _refr_fwsMinMax_16s(pSrc, len, pMin, pMax);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsMove_32fc(const Fw32fc* pSrc, Fw32fc* pDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsMove_32fc(pSrc, pDst, len);
    case DT_SSE2:
        return _sse2_fwsMove_32fc(pSrc, pDst, len);
    case DT_REFR:
        return _refr_fwsMove_32fc(pSrc, pDst, len);
    default:
        assert(false);
        return _refr_fwsMove_32fc(pSrc, pDst, len);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsMove_8u(const Fw8u* pSrc, Fw8u* pDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsMove_8u(pSrc, pDst, len);
    case DT_SSE2:
        return _sse2_fwsMove_8u(pSrc, pDst, len);
    case DT_REFR:
        return _refr_fwsMove_8u(pSrc, pDst, len);
    default:
        assert(false);
        return _refr_fwsMove_8u(pSrc, pDst, len);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsSet_32s(Fw32s val, Fw32s* pDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsSet_32s(val, pDst, len);
    case DT_SSE2:
        return _sse2_fwsSet_32s(val, pDst, len);
    case DT_REFR:
        return _refr_fwsSet_32s(val, pDst, len);
    default:
        assert(false);
        return _refr_fwsSet_32s(val, pDst, len);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsDivC_32f_I(Fw32f val, Fw32f* pSrcDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsDivC_32f_I(val, pSrcDst, len);
    case DT_SSE2:
        return _sse2_fwsDivC_32f_I(val, pSrcDst, len);
    case DT_REFR:
        return _refr_fwsDivC_32f_I(val, pSrcDst, len);
    default:
        assert(false);
        return _refr_fwsDivC_32f_I(val, pSrcDst, len);
    }
}

OREFR OSSE2     FwStatus STDCALL fwsMin_8s( const Fw8s  *pSrc, int len, Fw8s  *pMin )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwsMin_8s(pSrc, len, pMin);
    case DT_REFR:
        return _refr_fwsMin_8s(pSrc, len, pMin);
    default:
        assert(false);
        return _refr_fwsMin_8s(pSrc, len, pMin);
    }
}

OREFR             FwStatus STDCALL fwsExp_64s_ISfs(Fw64s* pSrcDst, int len, int scaleFactor)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwsExp_64s_ISfs(pSrcDst, len, scaleFactor);
    default:
        assert(false);
        return _refr_fwsExp_64s_ISfs(pSrcDst, len, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsInvCbrt_32f_A24(const Fw32f* pSrc, Fw32f* pDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsInvCbrt_32f_A24(pSrc, pDst, len);
    case DT_SSE2:
        return _sse2_fwsInvCbrt_32f_A24(pSrc, pDst, len);
    case DT_REFR:
        return _refr_fwsInvCbrt_32f_A24(pSrc, pDst, len);
    default:
        assert(false);
        return _refr_fwsInvCbrt_32f_A24(pSrc, pDst, len);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsInvCbrt_32f_A21(const Fw32f* pSrc, Fw32f* pDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsInvCbrt_32f_A21(pSrc, pDst, len);
    case DT_SSE2:
        return _sse2_fwsInvCbrt_32f_A21(pSrc, pDst, len);
    case DT_REFR:
        return _refr_fwsInvCbrt_32f_A21(pSrc, pDst, len);
    default:
        assert(false);
        return _refr_fwsInvCbrt_32f_A21(pSrc, pDst, len);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsThreshold_LTVal_64f_I(Fw64f* pSrcDst, int len, Fw64f level, Fw64f value)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsThreshold_LTVal_64f_I(pSrcDst, len, level, value);
    case DT_SSE2:
        return _sse2_fwsThreshold_LTVal_64f_I(pSrcDst, len, level, value);
    case DT_REFR:
        return _refr_fwsThreshold_LTVal_64f_I(pSrcDst, len, level, value);
    default:
        assert(false);
        return _refr_fwsThreshold_LTVal_64f_I(pSrcDst, len, level, value);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsAddC_16s_ISfs(Fw16s val, Fw16s* pSrcDst, int len, int scaleFactor)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsAddC_16s_ISfs(val, pSrcDst, len, scaleFactor);
    case DT_SSE2:
        return _sse2_fwsAddC_16s_ISfs(val, pSrcDst, len, scaleFactor);
    case DT_REFR:
        return _refr_fwsAddC_16s_ISfs(val, pSrcDst, len, scaleFactor);
    default:
        assert(false);
        return _refr_fwsAddC_16s_ISfs(val, pSrcDst, len, scaleFactor);
    }
}

OREFR       FwStatus STDCALL fwsMaxAbsIndx_32s(const Fw32s* pSrc, int len, Fw32s* pMaxAbs, int* pIndx)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwsMaxAbsIndx_32s(pSrc, len, pMaxAbs, pIndx);
    default:
        assert(false);
        return _refr_fwsMaxAbsIndx_32s(pSrc, len, pMaxAbs, pIndx);
    }
}

OREFR OSSE2 FwStatus STDCALL fwsSum_16sc32sc_Sfs(const Fw16sc* pSrc, int len, Fw32sc* pSum, int scaleFactor)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwsSum_16sc32sc_Sfs(pSrc, len, pSum, scaleFactor);
    case DT_REFR:
        return _refr_fwsSum_16sc32sc_Sfs(pSrc, len, pSum, scaleFactor);
    default:
        assert(false);
        return _refr_fwsSum_16sc32sc_Sfs(pSrc, len, pSum, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsSub_32s_ISfs(const Fw32s* pSrc, Fw32s* pSrcDst, int len, int scaleFactor)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsSub_32s_ISfs(pSrc, pSrcDst, len, scaleFactor);
    case DT_SSE2:
        return _sse2_fwsSub_32s_ISfs(pSrc, pSrcDst, len, scaleFactor);
    case DT_REFR:
        return _refr_fwsSub_32s_ISfs(pSrc, pSrcDst, len, scaleFactor);
    default:
        assert(false);
        return _refr_fwsSub_32s_ISfs(pSrc, pSrcDst, len, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsDiv_32f_A24(const Fw32f* pSrc1, const Fw32f* pSrc2, Fw32f* pDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsDiv_32f_A24(pSrc1, pSrc2, pDst, len);
    case DT_SSE2:
        return _sse2_fwsDiv_32f_A24(pSrc1, pSrc2, pDst, len);
    case DT_REFR:
        return _refr_fwsDiv_32f_A24(pSrc1, pSrc2, pDst, len);
    default:
        assert(false);
        return _refr_fwsDiv_32f_A24(pSrc1, pSrc2, pDst, len);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsSqrt_32fc_I(Fw32fc* pSrcDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsSqrt_32fc_I(pSrcDst, len);
    case DT_SSE2:
        return _sse2_fwsSqrt_32fc_I(pSrcDst, len);
    case DT_REFR:
        return _refr_fwsSqrt_32fc_I(pSrcDst, len);
    default:
        assert(false);
        return _refr_fwsSqrt_32fc_I(pSrcDst, len);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsAndC_32u(const Fw32u* pSrc, Fw32u val, Fw32u* pDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsAndC_32u(pSrc, val, pDst, len);
    case DT_SSE2:
        return _sse2_fwsAndC_32u(pSrc, val, pDst, len);
    case DT_REFR:
        return _refr_fwsAndC_32u(pSrc, val, pDst, len);
    default:
        assert(false);
        return _refr_fwsAndC_32u(pSrc, val, pDst, len);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsConvert_32f8u_Sfs(const Fw32f* pSrc, Fw8u* pDst, int len, FwRoundMode rndMode, int scaleFactor)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsConvert_32f8u_Sfs(pSrc, pDst, len, rndMode, scaleFactor);
    case DT_SSE2:
        return _sse2_fwsConvert_32f8u_Sfs(pSrc, pDst, len, rndMode, scaleFactor);
    case DT_REFR:
        return _refr_fwsConvert_32f8u_Sfs(pSrc, pDst, len, rndMode, scaleFactor);
    default:
        assert(false);
        return _refr_fwsConvert_32f8u_Sfs(pSrc, pDst, len, rndMode, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsAdd_32sc_ISfs(const Fw32sc* pSrc, Fw32sc* pSrcDst, int len, int scaleFactor)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsAdd_32sc_ISfs(pSrc, pSrcDst, len, scaleFactor);
    case DT_SSE2:
        return _sse2_fwsAdd_32sc_ISfs(pSrc, pSrcDst, len, scaleFactor);
    case DT_REFR:
        return _refr_fwsAdd_32sc_ISfs(pSrc, pSrcDst, len, scaleFactor);
    default:
        assert(false);
        return _refr_fwsAdd_32sc_ISfs(pSrc, pSrcDst, len, scaleFactor);
    }
}

OREFR OSSE2 FwStatus STDCALL fwsNorm_L2_32fc64f(const Fw32fc* pSrc, int len, Fw64f* pNorm)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwsNorm_L2_32fc64f(pSrc, len, pNorm);
    case DT_REFR:
        return _refr_fwsNorm_L2_32fc64f(pSrc, len, pNorm);
    default:
        assert(false);
        return _refr_fwsNorm_L2_32fc64f(pSrc, len, pNorm);
    }
}

OREFR OSSE2 FwStatus STDCALL fwsAutoCorr_NormA_64fc(const  Fw64fc*  pSrc,  int  srcLen,  Fw64fc*  pDst,  int  dstLen)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwsAutoCorr_NormA_64fc(pSrc, srcLen, pDst, dstLen);
    case DT_REFR:
        return _refr_fwsAutoCorr_NormA_64fc(pSrc, srcLen, pDst, dstLen);
    default:
        assert(false);
        return _refr_fwsAutoCorr_NormA_64fc(pSrc, srcLen, pDst, dstLen);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsSub_32f(const Fw32f* pSrc1, const Fw32f* pSrc2, Fw32f* pDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsSub_32f(pSrc1, pSrc2, pDst, len);
    case DT_SSE2:
        return _sse2_fwsSub_32f(pSrc1, pSrc2, pDst, len);
    case DT_REFR:
        return _refr_fwsSub_32f(pSrc1, pSrc2, pDst, len);
    default:
        assert(false);
        return _refr_fwsSub_32f(pSrc1, pSrc2, pDst, len);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsThreshold_LT_32fc_I(Fw32fc* pSrcDst, int len, Fw32f level)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsThreshold_LT_32fc_I(pSrcDst, len, level);
    case DT_SSE2:
        return _sse2_fwsThreshold_LT_32fc_I(pSrcDst, len, level);
    case DT_REFR:
        return _refr_fwsThreshold_LT_32fc_I(pSrcDst, len, level);
    default:
        assert(false);
        return _refr_fwsThreshold_LT_32fc_I(pSrcDst, len, level);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsAdd_16s32s_I(const Fw16s* pSrc, Fw32s* pSrcDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsAdd_16s32s_I(pSrc, pSrcDst, len);
    case DT_SSE2:
        return _sse2_fwsAdd_16s32s_I(pSrc, pSrcDst, len);
    case DT_REFR:
        return _refr_fwsAdd_16s32s_I(pSrc, pSrcDst, len);
    default:
        assert(false);
        return _refr_fwsAdd_16s32s_I(pSrc, pSrcDst, len);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsMul_32sc_ISfs(const Fw32sc* pSrc, Fw32sc* pSrcDst, int len, int scaleFactor)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsMul_32sc_ISfs(pSrc, pSrcDst, len, scaleFactor);
    case DT_SSE2:
        return _sse2_fwsMul_32sc_ISfs(pSrc, pSrcDst, len, scaleFactor);
    case DT_REFR:
        return _refr_fwsMul_32sc_ISfs(pSrc, pSrcDst, len, scaleFactor);
    default:
        assert(false);
        return _refr_fwsMul_32sc_ISfs(pSrc, pSrcDst, len, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsXor_32u(const Fw32u* pSrc1, const Fw32u* pSrc2, Fw32u* pDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsXor_32u(pSrc1, pSrc2, pDst, len);
    case DT_SSE2:
        return _sse2_fwsXor_32u(pSrc1, pSrc2, pDst, len);
    case DT_REFR:
        return _refr_fwsXor_32u(pSrc1, pSrc2, pDst, len);
    default:
        assert(false);
        return _refr_fwsXor_32u(pSrc1, pSrc2, pDst, len);
    }
}


OREFR OSSE2 FwStatus STDCALL fwsAutoCorr_64fc(const  Fw64fc*  pSrc,  int  srcLen,  Fw64fc*  pDst,  int  dstLen)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwsAutoCorr_64fc(pSrc, srcLen, pDst, dstLen);
    case DT_REFR:
        return _refr_fwsAutoCorr_64fc(pSrc, srcLen, pDst, dstLen);
    default:
        assert(false);
        return _refr_fwsAutoCorr_64fc(pSrc, srcLen, pDst, dstLen);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsLn_64f32f(const Fw64f* pSrc, Fw32f* pDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsLn_64f32f(pSrc, pDst, len);
    case DT_SSE2:
        return _sse2_fwsLn_64f32f(pSrc, pDst, len);
    case DT_REFR:
        return _refr_fwsLn_64f32f(pSrc, pDst, len);
    default:
        assert(false);
        return _refr_fwsLn_64f32f(pSrc, pDst, len);
    }
}

OREFR OSSE2 FwStatus STDCALL fwsAutoCorr_NormA_64f(const  Fw64f*  pSrc,  int  srcLen,  Fw64f*  pDst,  int  dstLen)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwsAutoCorr_NormA_64f(pSrc, srcLen, pDst, dstLen);
    case DT_REFR:
        return _refr_fwsAutoCorr_NormA_64f(pSrc, srcLen, pDst, dstLen);
    default:
        assert(false);
        return _refr_fwsAutoCorr_NormA_64f(pSrc, srcLen, pDst, dstLen);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsThreshold_LTValGTVal_16s_I(Fw16s* pSrcDst, int len, Fw16s levelLT, Fw16s valueLT, Fw16s levelGT, Fw16s valueGT)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsThreshold_LTValGTVal_16s_I(pSrcDst, len, levelLT, valueLT, levelGT, valueGT);
    case DT_SSE2:
        return _sse2_fwsThreshold_LTValGTVal_16s_I(pSrcDst, len, levelLT, valueLT, levelGT, valueGT);
    case DT_REFR:
        return _refr_fwsThreshold_LTValGTVal_16s_I(pSrcDst, len, levelLT, valueLT, levelGT, valueGT);
    default:
        assert(false);
        return _refr_fwsThreshold_LTValGTVal_16s_I(pSrcDst, len, levelLT, valueLT, levelGT, valueGT);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsSubCRev_8u_ISfs(Fw8u val, Fw8u* pSrcDst, int len, int scaleFactor)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsSubCRev_8u_ISfs(val, pSrcDst, len, scaleFactor);
    case DT_SSE2:
        return _sse2_fwsSubCRev_8u_ISfs(val, pSrcDst, len, scaleFactor);
    case DT_REFR:
        return _refr_fwsSubCRev_8u_ISfs(val, pSrcDst, len, scaleFactor);
    default:
        assert(false);
        return _refr_fwsSubCRev_8u_ISfs(val, pSrcDst, len, scaleFactor);
    }
}

OREFR OSSE2 FwStatus STDCALL fwsSum_16s_Sfs(const Fw16s* pSrc, int len, Fw16s* pSum, int scaleFactor)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwsSum_16s_Sfs(pSrc, len, pSum, scaleFactor);
    case DT_REFR:
        return _refr_fwsSum_16s_Sfs(pSrc, len, pSum, scaleFactor);
    default:
        assert(false);
        return _refr_fwsSum_16s_Sfs(pSrc, len, pSum, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsExp_32f_A11(const Fw32f* pSrc, Fw32f* pDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsExp_32f_A11(pSrc, pDst, len);
    case DT_SSE2:
        return _sse2_fwsExp_32f_A11(pSrc, pDst, len);
    case DT_REFR:
        return _refr_fwsExp_32f_A11(pSrc, pDst, len);
    default:
        assert(false);
        return _refr_fwsExp_32f_A11(pSrc, pDst, len);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsDivC_32f(const Fw32f* pSrc, Fw32f val, Fw32f* pDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsDivC_32f(pSrc, val, pDst, len);
    case DT_SSE2:
        return _sse2_fwsDivC_32f(pSrc, val, pDst, len);
    case DT_REFR:
        return _refr_fwsDivC_32f(pSrc, val, pDst, len);
    default:
        assert(false);
        return _refr_fwsDivC_32f(pSrc, val, pDst, len);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsPow_32f_A21(const Fw32f* pSrc1, const Fw32f* pSrc2, Fw32f* pDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsPow_32f_A21(pSrc1, pSrc2, pDst, len);
    case DT_SSE2:
        return _sse2_fwsPow_32f_A21(pSrc1, pSrc2, pDst, len);
    case DT_REFR:
        return _refr_fwsPow_32f_A21(pSrc1, pSrc2, pDst, len);
    default:
        assert(false);
        return _refr_fwsPow_32f_A21(pSrc1, pSrc2, pDst, len);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsPow_32f_A24(const Fw32f* pSrc1, const Fw32f* pSrc2, Fw32f* pDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsPow_32f_A24(pSrc1, pSrc2, pDst, len);
    case DT_SSE2:
        return _sse2_fwsPow_32f_A24(pSrc1, pSrc2, pDst, len);
    case DT_REFR:
        return _refr_fwsPow_32f_A24(pSrc1, pSrc2, pDst, len);
    default:
        assert(false);
        return _refr_fwsPow_32f_A24(pSrc1, pSrc2, pDst, len);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsThreshold_LTValGTVal_32f_I(Fw32f* pSrcDst, int len, Fw32f levelLT, Fw32f valueLT, Fw32f levelGT, Fw32f valueGT)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsThreshold_LTValGTVal_32f_I(pSrcDst, len, levelLT, valueLT, levelGT, valueGT);
    case DT_SSE2:
        return _sse2_fwsThreshold_LTValGTVal_32f_I(pSrcDst, len, levelLT, valueLT, levelGT, valueGT);
    case DT_REFR:
        return _refr_fwsThreshold_LTValGTVal_32f_I(pSrcDst, len, levelLT, valueLT, levelGT, valueGT);
    default:
        assert(false);
        return _refr_fwsThreshold_LTValGTVal_32f_I(pSrcDst, len, levelLT, valueLT, levelGT, valueGT);
    }
}

OREFR OSSE2 FwStatus STDCALL fwsNorm_L1_16s32s_Sfs(const Fw16s* pSrc, int len, Fw32s* pNorm,int scaleFactor)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwsNorm_L1_16s32s_Sfs(pSrc, len, pNorm, scaleFactor);
    case DT_REFR:
        return _refr_fwsNorm_L1_16s32s_Sfs(pSrc, len, pNorm, scaleFactor);
    default:
        assert(false);
        return _refr_fwsNorm_L1_16s32s_Sfs(pSrc, len, pNorm, scaleFactor);
    }
}

OREFR OSSE2 FwStatus STDCALL fwsNormDiff_L1_64f(const Fw64f* pSrc1, const Fw64f* pSrc2, int len,Fw64f* pNorm)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwsNormDiff_L1_64f(pSrc1, pSrc2, len, pNorm);
    case DT_REFR:
        return _refr_fwsNormDiff_L1_64f(pSrc1, pSrc2, len, pNorm);
    default:
        assert(false);
        return _refr_fwsNormDiff_L1_64f(pSrc1, pSrc2, len, pNorm);
    }
}

OREFR OSSE2 FwStatus STDCALL fwsMinEvery_32f_I(const Fw32f* pSrc, Fw32f* pSrcDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwsMinEvery_32f_I(pSrc, pSrcDst, len);
    case DT_REFR:
        return _refr_fwsMinEvery_32f_I(pSrc, pSrcDst, len);
    default:
        assert(false);
        return _refr_fwsMinEvery_32f_I(pSrc, pSrcDst, len);
    }
}

OREFR OSSE2 FwStatus STDCALL fwsDotProd_16s16sc32sc_Sfs(const Fw16s* pSrc1, const Fw16sc* pSrc2, int len, Fw32sc* pDp, int scaleFactor)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwsDotProd_16s16sc32sc_Sfs(pSrc1, pSrc2, len, pDp, scaleFactor);
    case DT_REFR:
        return _refr_fwsDotProd_16s16sc32sc_Sfs(pSrc1, pSrc2, len, pDp, scaleFactor);
    default:
        assert(false);
        return _refr_fwsDotProd_16s16sc32sc_Sfs(pSrc1, pSrc2, len, pDp, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsThreshold_LTInv_32f(const Fw32f* pSrc, Fw32f* pDst, int len, Fw32f level)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsThreshold_LTInv_32f(pSrc, pDst, len, level);
    case DT_SSE2:
        return _sse2_fwsThreshold_LTInv_32f(pSrc, pDst, len, level);
    case DT_REFR:
        return _refr_fwsThreshold_LTInv_32f(pSrc, pDst, len, level);
    default:
        assert(false);
        return _refr_fwsThreshold_LTInv_32f(pSrc, pDst, len, level);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsOrC_8u_I(Fw8u val, Fw8u* pSrcDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsOrC_8u_I(val, pSrcDst, len);
    case DT_SSE2:
        return _sse2_fwsOrC_8u_I(val, pSrcDst, len);
    case DT_REFR:
        return _refr_fwsOrC_8u_I(val, pSrcDst, len);
    default:
        assert(false);
        return _refr_fwsOrC_8u_I(val, pSrcDst, len);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsSubC_16s_Sfs(const Fw16s* pSrc, Fw16s val, Fw16s* pDst, int len, int scaleFactor)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsSubC_16s_Sfs(pSrc, val, pDst, len, scaleFactor);
    case DT_SSE2:
        return _sse2_fwsSubC_16s_Sfs(pSrc, val, pDst, len, scaleFactor);
    case DT_REFR:
        return _refr_fwsSubC_16s_Sfs(pSrc, val, pDst, len, scaleFactor);
    default:
        assert(false);
        return _refr_fwsSubC_16s_Sfs(pSrc, val, pDst, len, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsSub_32sc_ISfs(const Fw32sc* pSrc, Fw32sc* pSrcDst, int len, int scaleFactor)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsSub_32sc_ISfs(pSrc, pSrcDst, len, scaleFactor);
    case DT_SSE2:
        return _sse2_fwsSub_32sc_ISfs(pSrc, pSrcDst, len, scaleFactor);
    case DT_REFR:
        return _refr_fwsSub_32sc_ISfs(pSrc, pSrcDst, len, scaleFactor);
    default:
        assert(false);
        return _refr_fwsSub_32sc_ISfs(pSrc, pSrcDst, len, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsSqr_16s_ISfs(Fw16s* pSrcDst, int len, int scaleFactor)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsSqr_16s_ISfs(pSrcDst, len, scaleFactor);
    case DT_SSE2:
        return _sse2_fwsSqr_16s_ISfs(pSrcDst, len, scaleFactor);
    case DT_REFR:
        return _refr_fwsSqr_16s_ISfs(pSrcDst, len, scaleFactor);
    default:
        assert(false);
        return _refr_fwsSqr_16s_ISfs(pSrcDst, len, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsSet_64sc(Fw64sc val, Fw64sc* pDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsSet_64sc(val, pDst, len);
    case DT_SSE2:
        return _sse2_fwsSet_64sc(val, pDst, len);
    case DT_REFR:
        return _refr_fwsSet_64sc(val, pDst, len);
    default:
        assert(false);
        return _refr_fwsSet_64sc(val, pDst, len);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsAdd_32s_ISfs(const Fw32s* pSrc, Fw32s* pSrcDst, int len, int scaleFactor)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsAdd_32s_ISfs(pSrc, pSrcDst, len, scaleFactor);
    case DT_SSE2:
        return _sse2_fwsAdd_32s_ISfs(pSrc, pSrcDst, len, scaleFactor);
    case DT_REFR:
        return _refr_fwsAdd_32s_ISfs(pSrc, pSrcDst, len, scaleFactor);
    default:
        assert(false);
        return _refr_fwsAdd_32s_ISfs(pSrc, pSrcDst, len, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsExp_32f(const Fw32f* pSrc, Fw32f* pDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsExp_32f(pSrc, pDst, len);
    case DT_SSE2:
        return _sse2_fwsExp_32f(pSrc, pDst, len);
    case DT_REFR:
        return _refr_fwsExp_32f(pSrc, pDst, len);
    default:
        assert(false);
        return _refr_fwsExp_32f(pSrc, pDst, len);
    }
}

OREFR OSSE2 FwStatus STDCALL fwsNormDiff_L2_16s32s_Sfs(const Fw16s* pSrc1, const Fw16s* pSrc2, int len, Fw32s* pNorm, int scaleFactor)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwsNormDiff_L2_16s32s_Sfs(pSrc1, pSrc2, len, pNorm, scaleFactor);
    case DT_REFR:
        return _refr_fwsNormDiff_L2_16s32s_Sfs(pSrc1, pSrc2, len, pNorm, scaleFactor);
    default:
        assert(false);
        return _refr_fwsNormDiff_L2_16s32s_Sfs(pSrc1, pSrc2, len, pNorm, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsThreshold_32f_I(Fw32f* pSrcDst, int len, Fw32f level, FwCmpOp relOp)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsThreshold_32f_I(pSrcDst, len, level, relOp);
    case DT_SSE2:
        return _sse2_fwsThreshold_32f_I(pSrcDst, len, level, relOp);
    case DT_REFR:
        return _refr_fwsThreshold_32f_I(pSrcDst, len, level, relOp);
    default:
        assert(false);
        return _refr_fwsThreshold_32f_I(pSrcDst, len, level, relOp);
    }
}

OREFR OSSE2 FwStatus STDCALL fwsSum_32s_Sfs(const Fw32s* pSrc, int len, Fw32s* pSum, int scaleFactor)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwsSum_32s_Sfs(pSrc, len, pSum, scaleFactor);
    case DT_REFR:
        return _refr_fwsSum_32s_Sfs(pSrc, len, pSum, scaleFactor);
    default:
        assert(false);
        return _refr_fwsSum_32s_Sfs(pSrc, len, pSum, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsThreshold_16s(const Fw16s* pSrc, Fw16s* pDst, int len, Fw16s level, FwCmpOp relOp)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsThreshold_16s(pSrc, pDst, len, level, relOp);
    case DT_SSE2:
        return _sse2_fwsThreshold_16s(pSrc, pDst, len, level, relOp);
    case DT_REFR:
        return _refr_fwsThreshold_16s(pSrc, pDst, len, level, relOp);
    default:
        assert(false);
        return _refr_fwsThreshold_16s(pSrc, pDst, len, level, relOp);
    }
}

OREFR FwStatus STDCALL fwsFind_16u(const Fw16u* pSrc, int len, const Fw16u* pFind, int lenFind, int* pIndex)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwsFind_16u(pSrc, len, pFind, lenFind, pIndex);
    default:
        assert(false);
        return _refr_fwsFind_16u(pSrc, len, pFind, lenFind, pIndex);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsThreshold_GTVal_64fc_I(Fw64fc* pSrcDst, int len, Fw64f level, Fw64fc value)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsThreshold_GTVal_64fc_I(pSrcDst, len, level, value);
    case DT_SSE2:
        return _sse2_fwsThreshold_GTVal_64fc_I(pSrcDst, len, level, value);
    case DT_REFR:
        return _refr_fwsThreshold_GTVal_64fc_I(pSrcDst, len, level, value);
    default:
        assert(false);
        return _refr_fwsThreshold_GTVal_64fc_I(pSrcDst, len, level, value);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsThreshold_GTVal_64f(const Fw64f* pSrc, Fw64f* pDst, int len, Fw64f level, Fw64f value)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsThreshold_GTVal_64f(pSrc, pDst, len, level, value);
    case DT_SSE2:
        return _sse2_fwsThreshold_GTVal_64f(pSrc, pDst, len, level, value);
    case DT_REFR:
        return _refr_fwsThreshold_GTVal_64f(pSrc, pDst, len, level, value);
    default:
        assert(false);
        return _refr_fwsThreshold_GTVal_64f(pSrc, pDst, len, level, value);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsAdd_16s32f(const Fw16s* pSrc1, const Fw16s* pSrc2, Fw32f* pDst,int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsAdd_16s32f(pSrc1, pSrc2, pDst, len);
    case DT_SSE2:
        return _sse2_fwsAdd_16s32f(pSrc1, pSrc2, pDst, len);
    case DT_REFR:
        return _refr_fwsAdd_16s32f(pSrc1, pSrc2, pDst, len);
    default:
        assert(false);
        return _refr_fwsAdd_16s32f(pSrc1, pSrc2, pDst, len);
    }
}

OREFR             FwStatus STDCALL fwsPow_64f_A53(const Fw64f* pSrc1, const Fw64f* pSrc2, Fw64f* pDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwsPow_64f_A53(pSrc1, pSrc2, pDst, len);
    default:
        assert(false);
        return _refr_fwsPow_64f_A53(pSrc1, pSrc2, pDst, len);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsDivCRev_32f(const Fw32f* pSrc, Fw32f val, Fw32f* pDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsDivCRev_32f(pSrc, val, pDst, len);
    case DT_SSE2:
        return _sse2_fwsDivCRev_32f(pSrc, val, pDst, len);
    case DT_REFR:
        return _refr_fwsDivCRev_32f(pSrc, val, pDst, len);
    default:
        assert(false);
        return _refr_fwsDivCRev_32f(pSrc, val, pDst, len);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsSqr_16sc_ISfs(Fw16sc* pSrcDst, int len, int scaleFactor)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsSqr_16sc_ISfs(pSrcDst, len, scaleFactor);
    case DT_SSE2:
        return _sse2_fwsSqr_16sc_ISfs(pSrcDst, len, scaleFactor);
    case DT_REFR:
        return _refr_fwsSqr_16sc_ISfs(pSrcDst, len, scaleFactor);
    default:
        assert(false);
        return _refr_fwsSqr_16sc_ISfs(pSrcDst, len, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsSqrt_16u_Sfs(const Fw16u* pSrc, Fw16u* pDst, int len, int scaleFactor)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsSqrt_16u_Sfs(pSrc, pDst, len, scaleFactor);
    case DT_SSE2:
        return _sse2_fwsSqrt_16u_Sfs(pSrc, pDst, len, scaleFactor);
    case DT_REFR:
        return _refr_fwsSqrt_16u_Sfs(pSrc, pDst, len, scaleFactor);
    default:
        assert(false);
        return _refr_fwsSqrt_16u_Sfs(pSrc, pDst, len, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsSubC_16s_ISfs(Fw16s val, Fw16s* pSrcDst, int len, int scaleFactor)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsSubC_16s_ISfs(val, pSrcDst, len, scaleFactor);
    case DT_SSE2:
        return _sse2_fwsSubC_16s_ISfs(val, pSrcDst, len, scaleFactor);
    case DT_REFR:
        return _refr_fwsSubC_16s_ISfs(val, pSrcDst, len, scaleFactor);
    default:
        assert(false);
        return _refr_fwsSubC_16s_ISfs(val, pSrcDst, len, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsThreshold_GTVal_16sc_I(Fw16sc* pSrcDst, int len, Fw16s level, Fw16sc value)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsThreshold_GTVal_16sc_I(pSrcDst, len, level, value);
    case DT_SSE2:
        return _sse2_fwsThreshold_GTVal_16sc_I(pSrcDst, len, level, value);
    case DT_REFR:
        return _refr_fwsThreshold_GTVal_16sc_I(pSrcDst, len, level, value);
    default:
        assert(false);
        return _refr_fwsThreshold_GTVal_16sc_I(pSrcDst, len, level, value);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsMul_32fc_I(const Fw32fc* pSrc, Fw32fc* pSrcDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsMul_32fc_I(pSrc, pSrcDst, len);
    case DT_SSE2:
        return _sse2_fwsMul_32fc_I(pSrc, pSrcDst, len);
    case DT_REFR:
        return _refr_fwsMul_32fc_I(pSrc, pSrcDst, len);
    default:
        assert(false);
        return _refr_fwsMul_32fc_I(pSrc, pSrcDst, len);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsThreshold_LT_32f_I(Fw32f* pSrcDst, int len, Fw32f level)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsThreshold_LT_32f_I(pSrcDst, len, level);
    case DT_SSE2:
        return _sse2_fwsThreshold_LT_32f_I(pSrcDst, len, level);
    case DT_REFR:
        return _refr_fwsThreshold_LT_32f_I(pSrcDst, len, level);
    default:
        assert(false);
        return _refr_fwsThreshold_LT_32f_I(pSrcDst, len, level);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsThreshold_16sc_I(Fw16sc* pSrcDst, int len, Fw16s level, FwCmpOp relOp)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsThreshold_16sc_I(pSrcDst, len, level, relOp);
    case DT_SSE2:
        return _sse2_fwsThreshold_16sc_I(pSrcDst, len, level, relOp);
    case DT_REFR:
        return _refr_fwsThreshold_16sc_I(pSrcDst, len, level, relOp);
    default:
        assert(false);
        return _refr_fwsThreshold_16sc_I(pSrcDst, len, level, relOp);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsOr_16u(const Fw16u* pSrc1, const Fw16u* pSrc2, Fw16u* pDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsOr_16u(pSrc1, pSrc2, pDst, len);
    case DT_SSE2:
        return _sse2_fwsOr_16u(pSrc1, pSrc2, pDst, len);
    case DT_REFR:
        return _refr_fwsOr_16u(pSrc1, pSrc2, pDst, len);
    default:
        assert(false);
        return _refr_fwsOr_16u(pSrc1, pSrc2, pDst, len);
    }
}

OREFR OSSE2 FwStatus STDCALL fwsDotProd_32f32fc64fc(const Fw32f* pSrc1, const Fw32fc* pSrc2,int len, Fw64fc* pDp)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwsDotProd_32f32fc64fc(pSrc1, pSrc2, len, pDp);
    case DT_REFR:
        return _refr_fwsDotProd_32f32fc64fc(pSrc1, pSrc2, len, pDp);
    default:
        assert(false);
        return _refr_fwsDotProd_32f32fc64fc(pSrc1, pSrc2, len, pDp);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsSqr_16u_Sfs(const Fw16u* pSrc, Fw16u* pDst, int len,int scaleFactor)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsSqr_16u_Sfs(pSrc, pDst, len, scaleFactor);
    case DT_SSE2:
        return _sse2_fwsSqr_16u_Sfs(pSrc, pDst, len, scaleFactor);
    case DT_REFR:
        return _refr_fwsSqr_16u_Sfs(pSrc, pDst, len, scaleFactor);
    default:
        assert(false);
        return _refr_fwsSqr_16u_Sfs(pSrc, pDst, len, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsDivC_8u_ISfs(Fw8u val, Fw8u* pSrcDst, int len, int scaleFactor)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsDivC_8u_ISfs(val, pSrcDst, len, scaleFactor);
    case DT_SSE2:
        return _sse2_fwsDivC_8u_ISfs(val, pSrcDst, len, scaleFactor);
    case DT_REFR:
        return _refr_fwsDivC_8u_ISfs(val, pSrcDst, len, scaleFactor);
    default:
        assert(false);
        return _refr_fwsDivC_8u_ISfs(val, pSrcDst, len, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsThreshold_64f(const Fw64f* pSrc, Fw64f* pDst, int len, Fw64f level, FwCmpOp relOp)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsThreshold_64f(pSrc, pDst, len, level, relOp);
    case DT_SSE2:
        return _sse2_fwsThreshold_64f(pSrc, pDst, len, level, relOp);
    case DT_REFR:
        return _refr_fwsThreshold_64f(pSrc, pDst, len, level, relOp);
    default:
        assert(false);
        return _refr_fwsThreshold_64f(pSrc, pDst, len, level, relOp);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsThreshold_GT_16sc_I(Fw16sc* pSrcDst, int len, Fw16s level)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsThreshold_GT_16sc_I(pSrcDst, len, level);
    case DT_SSE2:
        return _sse2_fwsThreshold_GT_16sc_I(pSrcDst, len, level);
    case DT_REFR:
        return _refr_fwsThreshold_GT_16sc_I(pSrcDst, len, level);
    default:
        assert(false);
        return _refr_fwsThreshold_GT_16sc_I(pSrcDst, len, level);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsAnd_16u(const Fw16u* pSrc1, const Fw16u* pSrc2, Fw16u* pDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsAnd_16u(pSrc1, pSrc2, pDst, len);
    case DT_SSE2:
        return _sse2_fwsAnd_16u(pSrc1, pSrc2, pDst, len);
    case DT_REFR:
        return _refr_fwsAnd_16u(pSrc1, pSrc2, pDst, len);
    default:
        assert(false);
        return _refr_fwsAnd_16u(pSrc1, pSrc2, pDst, len);
    }
}

OREFR OSSE2 FwStatus STDCALL fwsMinMaxIndx_8u(const Fw8u* pSrc, int len, Fw8u* pMin, int* pMinIndx, Fw8u* pMax, int* pMaxIndx)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwsMinMaxIndx_8u(pSrc, len, pMin, pMinIndx, pMax, pMaxIndx);
    case DT_REFR:
        return _refr_fwsMinMaxIndx_8u(pSrc, len, pMin, pMinIndx, pMax, pMaxIndx);
    default:
        assert(false);
        return _refr_fwsMinMaxIndx_8u(pSrc, len, pMin, pMinIndx, pMax, pMaxIndx);
    }
}

OREFR OSSE2 FwStatus STDCALL fwsMaxEvery_32f_I(const Fw32f* pSrc, Fw32f* pSrcDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwsMaxEvery_32f_I(pSrc, pSrcDst, len);
    case DT_REFR:
        return _refr_fwsMaxEvery_32f_I(pSrc, pSrcDst, len);
    default:
        assert(false);
        return _refr_fwsMaxEvery_32f_I(pSrc, pSrcDst, len);
    }
}

OREFR OSSE2 FwStatus STDCALL fwsAutoCorr_NormB_64f(const  Fw64f*  pSrc,  int  srcLen,  Fw64f*  pDst,  int  dstLen)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwsAutoCorr_NormB_64f(pSrc, srcLen, pDst, dstLen);
    case DT_REFR:
        return _refr_fwsAutoCorr_NormB_64f(pSrc, srcLen, pDst, dstLen);
    default:
        assert(false);
        return _refr_fwsAutoCorr_NormB_64f(pSrc, srcLen, pDst, dstLen);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsMul_16s32s_Sfs(const Fw16s* pSrc1, const Fw16s* pSrc2, Fw32s *pDst, int len, int scaleFactor)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsMul_16s32s_Sfs(pSrc1, pSrc2, pDst, len, scaleFactor);
    case DT_SSE2:
        return _sse2_fwsMul_16s32s_Sfs(pSrc1, pSrc2, pDst, len, scaleFactor);
    case DT_REFR:
        return _refr_fwsMul_16s32s_Sfs(pSrc1, pSrc2, pDst, len, scaleFactor);
    default:
        assert(false);
        return _refr_fwsMul_16s32s_Sfs(pSrc1, pSrc2, pDst, len, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsSubC_32sc_ISfs(Fw32sc val, Fw32sc* pSrcDst, int len, int scaleFactor)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsSubC_32sc_ISfs(val, pSrcDst, len, scaleFactor);
    case DT_SSE2:
        return _sse2_fwsSubC_32sc_ISfs(val, pSrcDst, len, scaleFactor);
    case DT_REFR:
        return _refr_fwsSubC_32sc_ISfs(val, pSrcDst, len, scaleFactor);
    default:
        assert(false);
        return _refr_fwsSubC_32sc_ISfs(val, pSrcDst, len, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsAddC_64fc(const Fw64fc* pSrc, Fw64fc val, Fw64fc* pDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsAddC_64fc(pSrc, val, pDst, len);
    case DT_SSE2:
        return _sse2_fwsAddC_64fc(pSrc, val, pDst, len);
    case DT_REFR:
        return _refr_fwsAddC_64fc(pSrc, val, pDst, len);
    default:
        assert(false);
        return _refr_fwsAddC_64fc(pSrc, val, pDst, len);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsCubrt_32s16s_Sfs(const Fw32s* pSrc, Fw16s* pDst, int len, int scaleFactor)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsCubrt_32s16s_Sfs(pSrc, pDst, len, scaleFactor);
    case DT_SSE2:
        return _sse2_fwsCubrt_32s16s_Sfs(pSrc, pDst, len, scaleFactor);
    case DT_REFR:
        return _refr_fwsCubrt_32s16s_Sfs(pSrc, pDst, len, scaleFactor);
    default:
        assert(false);
        return _refr_fwsCubrt_32s16s_Sfs(pSrc, pDst, len, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsMulC_32s_Sfs(const Fw32s* pSrc, Fw32s val, Fw32s* pDst, int len,int scaleFactor)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsMulC_32s_Sfs(pSrc, val, pDst, len, scaleFactor);
    case DT_SSE2:
        return _sse2_fwsMulC_32s_Sfs(pSrc, val, pDst, len, scaleFactor);
    case DT_REFR:
        return _refr_fwsMulC_32s_Sfs(pSrc, val, pDst, len, scaleFactor);
    default:
        assert(false);
        return _refr_fwsMulC_32s_Sfs(pSrc, val, pDst, len, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsSqr_64fc_I(Fw64fc* pSrcDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsSqr_64fc_I(pSrcDst, len);
    case DT_SSE2:
        return _sse2_fwsSqr_64fc_I(pSrcDst, len);
    case DT_REFR:
        return _refr_fwsSqr_64fc_I(pSrcDst, len);
    default:
        assert(false);
        return _refr_fwsSqr_64fc_I(pSrcDst, len);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsSubC_32fc_I(Fw32fc val, Fw32fc* pSrcDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsSubC_32fc_I(val, pSrcDst, len);
    case DT_SSE2:
        return _sse2_fwsSubC_32fc_I(val, pSrcDst, len);
    case DT_REFR:
        return _refr_fwsSubC_32fc_I(val, pSrcDst, len);
    default:
        assert(false);
        return _refr_fwsSubC_32fc_I(val, pSrcDst, len);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsLShiftC_8u_I(int val, Fw8u* pSrcDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsLShiftC_8u_I(val, pSrcDst, len);
    case DT_SSE2:
        return _sse2_fwsLShiftC_8u_I(val, pSrcDst, len);
    case DT_REFR:
        return _refr_fwsLShiftC_8u_I(val, pSrcDst, len);
    default:
        assert(false);
        return _refr_fwsLShiftC_8u_I(val, pSrcDst, len);
    }
}

OREFR             FwStatus STDCALL fwsAsin_64f_A50(const Fw64f* pSrc, Fw64f* pDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwsAsin_64f_A50(pSrc, pDst, len);
    default:
        assert(false);
        return _refr_fwsAsin_64f_A50(pSrc, pDst, len);
    }
}

OREFR             FwStatus STDCALL fwsAsin_64f_A53(const Fw64f* pSrc, Fw64f* pDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwsAsin_64f_A53(pSrc, pDst, len);
    default:
        assert(false);
        return _refr_fwsAsin_64f_A53(pSrc, pDst, len);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsAddProduct_16s_Sfs(const Fw16s* pSrc1, const Fw16s* pSrc2, Fw16s* pSrcDst, int len, int scaleFactor)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsAddProduct_16s_Sfs(pSrc1, pSrc2, pSrcDst, len, scaleFactor);
    case DT_SSE2:
        return _sse2_fwsAddProduct_16s_Sfs(pSrc1, pSrc2, pSrcDst, len, scaleFactor);
    case DT_REFR:
        return _refr_fwsAddProduct_16s_Sfs(pSrc1, pSrc2, pSrcDst, len, scaleFactor);
    default:
        assert(false);
        return _refr_fwsAddProduct_16s_Sfs(pSrc1, pSrc2, pSrcDst, len, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsSet_64f(Fw64f val, Fw64f* pDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsSet_64f(val, pDst, len);
    case DT_SSE2:
        return _sse2_fwsSet_64f(val, pDst, len);
    case DT_REFR:
        return _refr_fwsSet_64f(val, pDst, len);
    default:
        assert(false);
        return _refr_fwsSet_64f(val, pDst, len);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsThreshold_LTInv_32f_I(Fw32f* pSrcDst, int len, Fw32f level)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsThreshold_LTInv_32f_I(pSrcDst, len, level);
    case DT_SSE2:
        return _sse2_fwsThreshold_LTInv_32f_I(pSrcDst, len, level);
    case DT_REFR:
        return _refr_fwsThreshold_LTInv_32f_I(pSrcDst, len, level);
    default:
        assert(false);
        return _refr_fwsThreshold_LTInv_32f_I(pSrcDst, len, level);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsLog10_32f_A11(const Fw32f* pSrc, Fw32f* pDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsLog10_32f_A11(pSrc, pDst, len);
    case DT_SSE2:
        return _sse2_fwsLog10_32f_A11(pSrc, pDst, len);
    case DT_REFR:
        return _refr_fwsLog10_32f_A11(pSrc, pDst, len);
    default:
        assert(false);
        return _refr_fwsLog10_32f_A11(pSrc, pDst, len);
    }
}

OREFR OSSE2 FwStatus STDCALL fwsNorm_Inf_32f(const Fw32f* pSrc, int len, Fw32f* pNorm)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwsNorm_Inf_32f(pSrc, len, pNorm);
    case DT_REFR:
        return _refr_fwsNorm_Inf_32f(pSrc, len, pNorm);
    default:
        assert(false);
        return _refr_fwsNorm_Inf_32f(pSrc, len, pNorm);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsMulC_64f(const Fw64f* pSrc, Fw64f val, Fw64f* pDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsMulC_64f(pSrc, val, pDst, len);
    case DT_SSE2:
        return _sse2_fwsMulC_64f(pSrc, val, pDst, len);
    case DT_REFR:
        return _refr_fwsMulC_64f(pSrc, val, pDst, len);
    default:
        assert(false);
        return _refr_fwsMulC_64f(pSrc, val, pDst, len);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsAddProduct_64fc(const Fw64fc* pSrc1, const Fw64fc* pSrc2, Fw64fc* pSrcDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsAddProduct_64fc(pSrc1, pSrc2, pSrcDst, len);
    case DT_SSE2:
        return _sse2_fwsAddProduct_64fc(pSrc1, pSrc2, pSrcDst, len);
    case DT_REFR:
        return _refr_fwsAddProduct_64fc(pSrc1, pSrc2, pSrcDst, len);
    default:
        assert(false);
        return _refr_fwsAddProduct_64fc(pSrc1, pSrc2, pSrcDst, len);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsZero_16sc(Fw16sc* pDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsZero_16sc(pDst, len);
    case DT_SSE2:
        return _sse2_fwsZero_16sc(pDst, len);
    case DT_REFR:
        return _refr_fwsZero_16sc(pDst, len);
    default:
        assert(false);
        return _refr_fwsZero_16sc(pDst, len);
    }
}

OREFR OSSE2 FwStatus STDCALL fwsSum_16s32s_Sfs(const Fw16s* pSrc, int len, Fw32s* pSum, int scaleFactor)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwsSum_16s32s_Sfs(pSrc, len, pSum, scaleFactor);
    case DT_REFR:
        return _refr_fwsSum_16s32s_Sfs(pSrc, len, pSum, scaleFactor);
    default:
        assert(false);
        return _refr_fwsSum_16s32s_Sfs(pSrc, len, pSum, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsOr_32u_I(const Fw32u* pSrc, Fw32u* pSrcDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsOr_32u_I(pSrc, pSrcDst, len);
    case DT_SSE2:
        return _sse2_fwsOr_32u_I(pSrc, pSrcDst, len);
    case DT_REFR:
        return _refr_fwsOr_32u_I(pSrc, pSrcDst, len);
    default:
        assert(false);
        return _refr_fwsOr_32u_I(pSrc, pSrcDst, len);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsMulC_32f(const Fw32f* pSrc, Fw32f val, Fw32f* pDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsMulC_32f(pSrc, val, pDst, len);
    case DT_SSE2:
        return _sse2_fwsMulC_32f(pSrc, val, pDst, len);
    case DT_REFR:
        return _refr_fwsMulC_32f(pSrc, val, pDst, len);
    default:
        assert(false);
        return _refr_fwsMulC_32f(pSrc, val, pDst, len);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsDivC_32fc(const Fw32fc* pSrc, Fw32fc val, Fw32fc* pDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsDivC_32fc(pSrc, val, pDst, len);
    case DT_SSE2:
        return _sse2_fwsDivC_32fc(pSrc, val, pDst, len);
    case DT_REFR:
        return _refr_fwsDivC_32fc(pSrc, val, pDst, len);
    default:
        assert(false);
        return _refr_fwsDivC_32fc(pSrc, val, pDst, len);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsInvCbrt_64f_A50(const Fw64f* pSrc, Fw64f* pDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsInvCbrt_64f_A50(pSrc, pDst, len);
    case DT_SSE2:
        return _sse2_fwsInvCbrt_64f_A50(pSrc, pDst, len);
    case DT_REFR:
        return _refr_fwsInvCbrt_64f_A50(pSrc, pDst, len);
    default:
        assert(false);
        return _refr_fwsInvCbrt_64f_A50(pSrc, pDst, len);
    }
}

OREFR FwStatus STDCALL fwsFindC_8u(const Fw8u* pSrc, int len, Fw8u valFind, int* pIndex)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwsFindC_8u(pSrc, len, valFind, pIndex);
    default:
        assert(false);
        return _refr_fwsFindC_8u(pSrc, len, valFind, pIndex);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsDiv_16s_Sfs(const Fw16s* pSrc1, const Fw16s* pSrc2, Fw16s* pDst,int len, int scaleFactor)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsDiv_16s_Sfs(pSrc1, pSrc2, pDst, len, scaleFactor);
    case DT_SSE2:
        return _sse2_fwsDiv_16s_Sfs(pSrc1, pSrc2, pDst, len, scaleFactor);
    case DT_REFR:
        return _refr_fwsDiv_16s_Sfs(pSrc1, pSrc2, pDst, len, scaleFactor);
    default:
        assert(false);
        return _refr_fwsDiv_16s_Sfs(pSrc1, pSrc2, pDst, len, scaleFactor);
    }
}

OREFR OSSE2 FwStatus STDCALL fwsNormDiff_Inf_32f(const Fw32f* pSrc1, const Fw32f* pSrc2, int len,Fw32f* pNorm)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwsNormDiff_Inf_32f(pSrc1, pSrc2, len, pNorm);
    case DT_REFR:
        return _refr_fwsNormDiff_Inf_32f(pSrc1, pSrc2, len, pNorm);
    default:
        assert(false);
        return _refr_fwsNormDiff_Inf_32f(pSrc1, pSrc2, len, pNorm);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsAdd_32s_Sfs(const Fw32s* pSrc1, const Fw32s* pSrc2, Fw32s*pDst, int len, int scaleFactor)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsAdd_32s_Sfs(pSrc1, pSrc2, pDst, len, scaleFactor);
    case DT_SSE2:
        return _sse2_fwsAdd_32s_Sfs(pSrc1, pSrc2, pDst, len, scaleFactor);
    case DT_REFR:
        return _refr_fwsAdd_32s_Sfs(pSrc1, pSrc2, pDst, len, scaleFactor);
    default:
        assert(false);
        return _refr_fwsAdd_32s_Sfs(pSrc1, pSrc2, pDst, len, scaleFactor);
    }
}

OREFR			  FwStatus STDCALL fwsSqrt_64s_Sfs(const Fw64s* pSrc, Fw64s* pDst, int len, int scaleFactor)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwsSqrt_64s_Sfs(pSrc, pDst, len, scaleFactor);
    default:
        assert(false);
        return _refr_fwsSqrt_64s_Sfs(pSrc, pDst, len, scaleFactor);
    }
}

OREFR OSSE2 FwStatus STDCALL fwsDotProd_16s16sc32fc(const Fw16s* pSrc1, const Fw16sc* pSrc2,int len, Fw32fc* pDp)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwsDotProd_16s16sc32fc(pSrc1, pSrc2, len, pDp);
    case DT_REFR:
        return _refr_fwsDotProd_16s16sc32fc(pSrc1, pSrc2, len, pDp);
    default:
        assert(false);
        return _refr_fwsDotProd_16s16sc32fc(pSrc1, pSrc2, len, pDp);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsConvert_16s32f(const Fw16s* pSrc, Fw32f* pDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsConvert_16s32f(pSrc, pDst, len);
    case DT_SSE2:
        return _sse2_fwsConvert_16s32f(pSrc, pDst, len);
    case DT_REFR:
        return _refr_fwsConvert_16s32f(pSrc, pDst, len);
    default:
        assert(false);
        return _refr_fwsConvert_16s32f(pSrc, pDst, len);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsExp_32f64f(const Fw32f* pSrc, Fw64f* pDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsExp_32f64f(pSrc, pDst, len);
    case DT_SSE2:
        return _sse2_fwsExp_32f64f(pSrc, pDst, len);
    case DT_REFR:
        return _refr_fwsExp_32f64f(pSrc, pDst, len);
    default:
        assert(false);
        return _refr_fwsExp_32f64f(pSrc, pDst, len);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsThreshold_LTInv_64fc_I(Fw64fc* pSrcDst, int len, Fw64f level)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsThreshold_LTInv_64fc_I(pSrcDst, len, level);
    case DT_SSE2:
        return _sse2_fwsThreshold_LTInv_64fc_I(pSrcDst, len, level);
    case DT_REFR:
        return _refr_fwsThreshold_LTInv_64fc_I(pSrcDst, len, level);
    default:
        assert(false);
        return _refr_fwsThreshold_LTInv_64fc_I(pSrcDst, len, level);
    }
}

OREFR             FwStatus STDCALL fwsAcosh_32f_A21(const Fw32f* pSrc, Fw32f* pDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwsAcosh_32f_A21(pSrc, pDst, len);
    default:
        assert(false);
        return _refr_fwsAcosh_32f_A21(pSrc, pDst, len);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsThreshold_GT_16sc(const Fw16sc* pSrc, Fw16sc* pDst, int len, Fw16s level)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsThreshold_GT_16sc(pSrc, pDst, len, level);
    case DT_SSE2:
        return _sse2_fwsThreshold_GT_16sc(pSrc, pDst, len, level);
    case DT_REFR:
        return _refr_fwsThreshold_GT_16sc(pSrc, pDst, len, level);
    default:
        assert(false);
        return _refr_fwsThreshold_GT_16sc(pSrc, pDst, len, level);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsLn_16s_ISfs(Fw16s* pSrcDst, int len, int scaleFactor)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsLn_16s_ISfs(pSrcDst, len, scaleFactor);
    case DT_SSE2:
        return _sse2_fwsLn_16s_ISfs(pSrcDst, len, scaleFactor);
    case DT_REFR:
        return _refr_fwsLn_16s_ISfs(pSrcDst, len, scaleFactor);
    default:
        assert(false);
        return _refr_fwsLn_16s_ISfs(pSrcDst, len, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsConvert_16s32s(const Fw16s* pSrc, Fw32s* pDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsConvert_16s32s(pSrc, pDst, len);
    case DT_SSE2:
        return _sse2_fwsConvert_16s32s(pSrc, pDst, len);
    case DT_REFR:
        return _refr_fwsConvert_16s32s(pSrc, pDst, len);
    default:
        assert(false);
        return _refr_fwsConvert_16s32s(pSrc, pDst, len);
    }
}

OREFR OSSE2 FwStatus STDCALL fwsNormDiff_L2_32f(const Fw32f* pSrc1, const Fw32f* pSrc2, int len,Fw32f* pNorm)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwsNormDiff_L2_32f(pSrc1, pSrc2, len, pNorm);
    case DT_REFR:
        return _refr_fwsNormDiff_L2_32f(pSrc1, pSrc2, len, pNorm);
    default:
        assert(false);
        return _refr_fwsNormDiff_L2_32f(pSrc1, pSrc2, len, pNorm);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsThreshold_GT_16s_I(Fw16s* pSrcDst, int len, Fw16s level)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsThreshold_GT_16s_I(pSrcDst, len, level);
    case DT_SSE2:
        return _sse2_fwsThreshold_GT_16s_I(pSrcDst, len, level);
    case DT_REFR:
        return _refr_fwsThreshold_GT_16s_I(pSrcDst, len, level);
    default:
        assert(false);
        return _refr_fwsThreshold_GT_16s_I(pSrcDst, len, level);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsAddC_32f_I(Fw32f val, Fw32f* pSrcDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsAddC_32f_I(val, pSrcDst, len);
    case DT_SSE2:
        return _sse2_fwsAddC_32f_I(val, pSrcDst, len);
    case DT_REFR:
        return _refr_fwsAddC_32f_I(val, pSrcDst, len);
    default:
        assert(false);
        return _refr_fwsAddC_32f_I(val, pSrcDst, len);
    }
}

OREFR             FwStatus STDCALL fwsCosh_32f_A21(const Fw32f* pSrc, Fw32f* pDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwsCosh_32f_A21(pSrc, pDst, len);
    default:
        assert(false);
        return _refr_fwsCosh_32f_A21(pSrc, pDst, len);
    }
}

OREFR OSSE2 FwStatus STDCALL fwsSum_64fc(const Fw64fc* pSrc, int len, Fw64fc* pSum)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwsSum_64fc(pSrc, len, pSum);
    case DT_REFR:
        return _refr_fwsSum_64fc(pSrc, len, pSum);
    default:
        assert(false);
        return _refr_fwsSum_64fc(pSrc, len, pSum);
    }
}

OREFR OSSE2 FwStatus STDCALL fwsMaxEvery_32s_I(const Fw32s* pSrc, Fw32s* pSrcDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwsMaxEvery_32s_I(pSrc, pSrcDst, len);
    case DT_REFR:
        return _refr_fwsMaxEvery_32s_I(pSrc, pSrcDst, len);
    default:
        assert(false);
        return _refr_fwsMaxEvery_32s_I(pSrc, pSrcDst, len);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsConvert_8u32f(const Fw8u* pSrc, Fw32f* pDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsConvert_8u32f(pSrc, pDst, len);
    case DT_SSE2:
        return _sse2_fwsConvert_8u32f(pSrc, pDst, len);
    case DT_REFR:
        return _refr_fwsConvert_8u32f(pSrc, pDst, len);
    default:
        assert(false);
        return _refr_fwsConvert_8u32f(pSrc, pDst, len);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsSub_16s(const Fw16s* pSrc1, const Fw16s* pSrc2, Fw16s* pDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsSub_16s(pSrc1, pSrc2, pDst, len);
    case DT_SSE2:
        return _sse2_fwsSub_16s(pSrc1, pSrc2, pDst, len);
    case DT_REFR:
        return _refr_fwsSub_16s(pSrc1, pSrc2, pDst, len);
    default:
        assert(false);
        return _refr_fwsSub_16s(pSrc1, pSrc2, pDst, len);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsMulC_64fc_I(Fw64fc val, Fw64fc* pSrcDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsMulC_64fc_I(val, pSrcDst, len);
    case DT_SSE2:
        return _sse2_fwsMulC_64fc_I(val, pSrcDst, len);
    case DT_REFR:
        return _refr_fwsMulC_64fc_I(val, pSrcDst, len);
    default:
        assert(false);
        return _refr_fwsMulC_64fc_I(val, pSrcDst, len);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsSub_64fc_I(const Fw64fc* pSrc, Fw64fc* pSrcDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsSub_64fc_I(pSrc, pSrcDst, len);
    case DT_SSE2:
        return _sse2_fwsSub_64fc_I(pSrc, pSrcDst, len);
    case DT_REFR:
        return _refr_fwsSub_64fc_I(pSrc, pSrcDst, len);
    default:
        assert(false);
        return _refr_fwsSub_64fc_I(pSrc, pSrcDst, len);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsCopy_64f(const Fw64f* pSrc, Fw64f* pDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsCopy_64f(pSrc, pDst, len);
    case DT_SSE2:
        return _sse2_fwsCopy_64f(pSrc, pDst, len);
    case DT_REFR:
        return _refr_fwsCopy_64f(pSrc, pDst, len);
    default:
        assert(false);
        return _refr_fwsCopy_64f(pSrc, pDst, len);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsXorC_32u_I(Fw32u val, Fw32u* pSrcDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsXorC_32u_I(val, pSrcDst, len);
    case DT_SSE2:
        return _sse2_fwsXorC_32u_I(val, pSrcDst, len);
    case DT_REFR:
        return _refr_fwsXorC_32u_I(val, pSrcDst, len);
    default:
        assert(false);
        return _refr_fwsXorC_32u_I(val, pSrcDst, len);
    }
}

OREFR OSSE2 FwStatus STDCALL fwsNormDiff_Inf_64fc64f(const Fw64fc* pSrc1, const Fw64fc* pSrc2, int len, Fw64f* pNorm)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwsNormDiff_Inf_64fc64f(pSrc1, pSrc2, len, pNorm);
    case DT_REFR:
        return _refr_fwsNormDiff_Inf_64fc64f(pSrc1, pSrc2, len, pNorm);
    default:
        assert(false);
        return _refr_fwsNormDiff_Inf_64fc64f(pSrc1, pSrc2, len, pNorm);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsSubC_32f_I(Fw32f val, Fw32f* pSrcDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsSubC_32f_I(val, pSrcDst, len);
    case DT_SSE2:
        return _sse2_fwsSubC_32f_I(val, pSrcDst, len);
    case DT_REFR:
        return _refr_fwsSubC_32f_I(val, pSrcDst, len);
    default:
        assert(false);
        return _refr_fwsSubC_32f_I(val, pSrcDst, len);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsSub_16s_I(const Fw16s* pSrc, Fw16s* pSrcDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsSub_16s_I(pSrc, pSrcDst, len);
    case DT_SSE2:
        return _sse2_fwsSub_16s_I(pSrc, pSrcDst, len);
    case DT_REFR:
        return _refr_fwsSub_16s_I(pSrc, pSrcDst, len);
    default:
        assert(false);
        return _refr_fwsSub_16s_I(pSrc, pSrcDst, len);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsDiv_32f_A11(const Fw32f* pSrc1, const Fw32f* pSrc2, Fw32f* pDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsDiv_32f_A11(pSrc1, pSrc2, pDst, len);
    case DT_SSE2:
        return _sse2_fwsDiv_32f_A11(pSrc1, pSrc2, pDst, len);
    case DT_REFR:
        return _refr_fwsDiv_32f_A11(pSrc1, pSrc2, pDst, len);
    default:
        assert(false);
        return _refr_fwsDiv_32f_A11(pSrc1, pSrc2, pDst, len);
    }
}

OREFR             FwStatus STDCALL fwsTanh_64f_A53(const Fw64f* pSrc, Fw64f* pDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwsTanh_64f_A53(pSrc, pDst, len);
    default:
        assert(false);
        return _refr_fwsTanh_64f_A53(pSrc, pDst, len);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsMul_16s_Sfs(const Fw16s* pSrc1, const Fw16s* pSrc2, Fw16s* pDst,int len, int scaleFactor)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsMul_16s_Sfs(pSrc1, pSrc2, pDst, len, scaleFactor);
    case DT_SSE2:
        return _sse2_fwsMul_16s_Sfs(pSrc1, pSrc2, pDst, len, scaleFactor);
    case DT_REFR:
        return _refr_fwsMul_16s_Sfs(pSrc1, pSrc2, pDst, len, scaleFactor);
    default:
        assert(false);
        return _refr_fwsMul_16s_Sfs(pSrc1, pSrc2, pDst, len, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsSubC_8u_Sfs(const Fw8u* pSrc, Fw8u val, Fw8u* pDst, int len, int scaleFactor)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsSubC_8u_Sfs(pSrc, val, pDst, len, scaleFactor);
    case DT_SSE2:
        return _sse2_fwsSubC_8u_Sfs(pSrc, val, pDst, len, scaleFactor);
    case DT_REFR:
        return _refr_fwsSubC_8u_Sfs(pSrc, val, pDst, len, scaleFactor);
    default:
        assert(false);
        return _refr_fwsSubC_8u_Sfs(pSrc, val, pDst, len, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsExp_32s_Sfs(const Fw32s* pSrc, Fw32s* pDst, int len, int scaleFactor)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsExp_32s_Sfs(pSrc, pDst, len, scaleFactor);
    case DT_SSE2:
        return _sse2_fwsExp_32s_Sfs(pSrc, pDst, len, scaleFactor);
    case DT_REFR:
        return _refr_fwsExp_32s_Sfs(pSrc, pDst, len, scaleFactor);
    default:
        assert(false);
        return _refr_fwsExp_32s_Sfs(pSrc, pDst, len, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsExp_32f_I(Fw32f* pSrcDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsExp_32f_I(pSrcDst, len);
    case DT_SSE2:
        return _sse2_fwsExp_32f_I(pSrcDst, len);
    case DT_REFR:
        return _refr_fwsExp_32f_I(pSrcDst, len);
    default:
        assert(false);
        return _refr_fwsExp_32f_I(pSrcDst, len);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsDiv_32s16s_Sfs(const Fw16s* pSrc1, const Fw32s* pSrc2, Fw16s* pDst,int len, int scaleFactor)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsDiv_32s16s_Sfs(pSrc1, pSrc2, pDst, len, scaleFactor);
    case DT_SSE2:
        return _sse2_fwsDiv_32s16s_Sfs(pSrc1, pSrc2, pDst, len, scaleFactor);
    case DT_REFR:
        return _refr_fwsDiv_32s16s_Sfs(pSrc1, pSrc2, pDst, len, scaleFactor);
    default:
        assert(false);
        return _refr_fwsDiv_32s16s_Sfs(pSrc1, pSrc2, pDst, len, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsThreshold_LTVal_32f(const Fw32f* pSrc, Fw32f* pDst, int len, Fw32f level, Fw32f value)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsThreshold_LTVal_32f(pSrc, pDst, len, level, value);
    case DT_SSE2:
        return _sse2_fwsThreshold_LTVal_32f(pSrc, pDst, len, level, value);
    case DT_REFR:
        return _refr_fwsThreshold_LTVal_32f(pSrc, pDst, len, level, value);
    default:
        assert(false);
        return _refr_fwsThreshold_LTVal_32f(pSrc, pDst, len, level, value);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsThreshold_GT_64f(const Fw64f* pSrc, Fw64f* pDst, int len, Fw64f level)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsThreshold_GT_64f(pSrc, pDst, len, level);
    case DT_SSE2:
        return _sse2_fwsThreshold_GT_64f(pSrc, pDst, len, level);
    case DT_REFR:
        return _refr_fwsThreshold_GT_64f(pSrc, pDst, len, level);
    default:
        assert(false);
        return _refr_fwsThreshold_GT_64f(pSrc, pDst, len, level);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsThreshold_GTVal_16s_I(Fw16s* pSrcDst, int len, Fw16s level, Fw16s value)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsThreshold_GTVal_16s_I(pSrcDst, len, level, value);
    case DT_SSE2:
        return _sse2_fwsThreshold_GTVal_16s_I(pSrcDst, len, level, value);
    case DT_REFR:
        return _refr_fwsThreshold_GTVal_16s_I(pSrcDst, len, level, value);
    default:
        assert(false);
        return _refr_fwsThreshold_GTVal_16s_I(pSrcDst, len, level, value);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsConvert_32s64f_Sfs(const Fw32s* pSrc, Fw64f* pDst, int len, int scaleFactor)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsConvert_32s64f_Sfs(pSrc, pDst, len, scaleFactor);
    case DT_SSE2:
        return _sse2_fwsConvert_32s64f_Sfs(pSrc, pDst, len, scaleFactor);
    case DT_REFR:
        return _refr_fwsConvert_32s64f_Sfs(pSrc, pDst, len, scaleFactor);
    default:
        assert(false);
        return _refr_fwsConvert_32s64f_Sfs(pSrc, pDst, len, scaleFactor);
    }
}

OREFR             FwStatus STDCALL fwsCos_32f_A21(const Fw32f* pSrc, Fw32f* pDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwsCos_32f_A21(pSrc, pDst, len);
    default:
        assert(false);
        return _refr_fwsCos_32f_A21(pSrc, pDst, len);
    }
}

OREFR OSSE2 FwStatus STDCALL fwsMinMaxIndx_32u(const Fw32u* pSrc, int len, Fw32u* pMin, int* pMinIndx, Fw32u* pMax, int* pMaxIndx)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwsMinMaxIndx_32u(pSrc, len, pMin, pMinIndx, pMax, pMaxIndx);
    case DT_REFR:
        return _refr_fwsMinMaxIndx_32u(pSrc, len, pMin, pMinIndx, pMax, pMaxIndx);
    default:
        assert(false);
        return _refr_fwsMinMaxIndx_32u(pSrc, len, pMin, pMinIndx, pMax, pMaxIndx);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsRShiftC_16s_I(int val, Fw16s* pSrcDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsRShiftC_16s_I(val, pSrcDst, len);
    case DT_SSE2:
        return _sse2_fwsRShiftC_16s_I(val, pSrcDst, len);
    case DT_REFR:
        return _refr_fwsRShiftC_16s_I(val, pSrcDst, len);
    default:
        assert(false);
        return _refr_fwsRShiftC_16s_I(val, pSrcDst, len);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsDivC_64f_I(Fw64f val, Fw64f* pSrcDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsDivC_64f_I(val, pSrcDst, len);
    case DT_SSE2:
        return _sse2_fwsDivC_64f_I(val, pSrcDst, len);
    case DT_REFR:
        return _refr_fwsDivC_64f_I(val, pSrcDst, len);
    default:
        assert(false);
        return _refr_fwsDivC_64f_I(val, pSrcDst, len);
    }
}

OREFR OSSE2 FwStatus STDCALL fwsMinMaxIndx_32s(const Fw32s* pSrc, int len, Fw32s* pMin, int* pMinIndx, Fw32s* pMax, int* pMaxIndx)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwsMinMaxIndx_32s(pSrc, len, pMin, pMinIndx, pMax, pMaxIndx);
    case DT_REFR:
        return _refr_fwsMinMaxIndx_32s(pSrc, len, pMin, pMinIndx, pMax, pMaxIndx);
    default:
        assert(false);
        return _refr_fwsMinMaxIndx_32s(pSrc, len, pMin, pMinIndx, pMax, pMaxIndx);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsSubC_64fc_I(Fw64fc val, Fw64fc* pSrcDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsSubC_64fc_I(val, pSrcDst, len);
    case DT_SSE2:
        return _sse2_fwsSubC_64fc_I(val, pSrcDst, len);
    case DT_REFR:
        return _refr_fwsSubC_64fc_I(val, pSrcDst, len);
    default:
        assert(false);
        return _refr_fwsSubC_64fc_I(val, pSrcDst, len);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsConvert_32u32f(const Fw32u* pSrc, Fw32f* pDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsConvert_32u32f(pSrc, pDst, len);
    case DT_SSE2:
        return _sse2_fwsConvert_32u32f(pSrc, pDst, len);
    case DT_REFR:
        return _refr_fwsConvert_32u32f(pSrc, pDst, len);
    default:
        assert(false);
        return _refr_fwsConvert_32u32f(pSrc, pDst, len);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsAbs_64f(const Fw64f* pSrc, Fw64f* pDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsAbs_64f(pSrc, pDst, len);
    case DT_SSE2:
        return _sse2_fwsAbs_64f(pSrc, pDst, len);
    case DT_REFR:
        return _refr_fwsAbs_64f(pSrc, pDst, len);
    default:
        assert(false);
        return _refr_fwsAbs_64f(pSrc, pDst, len);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsMagnitude_32f(const Fw32f* pSrcRe, const Fw32f* pSrcIm, Fw32f* pDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsMagnitude_32f(pSrcRe, pSrcIm, pDst, len);
    case DT_SSE2:
        return _sse2_fwsMagnitude_32f(pSrcRe, pSrcIm, pDst, len);
    case DT_REFR:
        return _refr_fwsMagnitude_32f(pSrcRe, pSrcIm, pDst, len);
    default:
        assert(false);
        return _refr_fwsMagnitude_32f(pSrcRe, pSrcIm, pDst, len);
    }
}

OREFR OSSE2 FwStatus STDCALL fwsNorm_L1_64f(const Fw64f* pSrc, int len, Fw64f* pNorm)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwsNorm_L1_64f(pSrc, len, pNorm);
    case DT_REFR:
        return _refr_fwsNorm_L1_64f(pSrc, len, pNorm);
    default:
        assert(false);
        return _refr_fwsNorm_L1_64f(pSrc, len, pNorm);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsThreshold_LTInv_32fc_I(Fw32fc* pSrcDst, int len, Fw32f level)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsThreshold_LTInv_32fc_I(pSrcDst, len, level);
    case DT_SSE2:
        return _sse2_fwsThreshold_LTInv_32fc_I(pSrcDst, len, level);
    case DT_REFR:
        return _refr_fwsThreshold_LTInv_32fc_I(pSrcDst, len, level);
    default:
        assert(false);
        return _refr_fwsThreshold_LTInv_32fc_I(pSrcDst, len, level);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsAtan_32f_A11(const Fw32f* pSrc, Fw32f* pDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsAtan_32f_A11(pSrc, pDst, len);
    case DT_SSE2:
        return _sse2_fwsAtan_32f_A11(pSrc, pDst, len);
    case DT_REFR:
        return _refr_fwsAtan_32f_A11(pSrc, pDst, len);
    default:
        assert(false);
        return _refr_fwsAtan_32f_A11(pSrc, pDst, len);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsConvert_16u32s(const Fw16u* pSrc, Fw32s* pDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsConvert_16u32s(pSrc, pDst, len);
    case DT_SSE2:
        return _sse2_fwsConvert_16u32s(pSrc, pDst, len);
    case DT_REFR:
        return _refr_fwsConvert_16u32s(pSrc, pDst, len);
    default:
        assert(false);
        return _refr_fwsConvert_16u32s(pSrc, pDst, len);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsMulC_32f16s_Sfs(const Fw32f* pSrc, Fw32f val, Fw16s* pDst,int len, int scaleFactor)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsMulC_32f16s_Sfs(pSrc, val, pDst, len, scaleFactor);
    case DT_SSE2:
        return _sse2_fwsMulC_32f16s_Sfs(pSrc, val, pDst, len, scaleFactor);
    case DT_REFR:
        return _refr_fwsMulC_32f16s_Sfs(pSrc, val, pDst, len, scaleFactor);
    default:
        assert(false);
        return _refr_fwsMulC_32f16s_Sfs(pSrc, val, pDst, len, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsConvert_32f8s_Sfs(const Fw32f* pSrc, Fw8s* pDst, int len, FwRoundMode rndMode, int scaleFactor)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsConvert_32f8s_Sfs(pSrc, pDst, len, rndMode, scaleFactor);
    case DT_SSE2:
        return _sse2_fwsConvert_32f8s_Sfs(pSrc, pDst, len, rndMode, scaleFactor);
    case DT_REFR:
        return _refr_fwsConvert_32f8s_Sfs(pSrc, pDst, len, rndMode, scaleFactor);
    default:
        assert(false);
        return _refr_fwsConvert_32f8s_Sfs(pSrc, pDst, len, rndMode, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsSubCRev_32f_I(Fw32f val, Fw32f* pSrcDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsSubCRev_32f_I(val, pSrcDst, len);
    case DT_SSE2:
        return _sse2_fwsSubCRev_32f_I(val, pSrcDst, len);
    case DT_REFR:
        return _refr_fwsSubCRev_32f_I(val, pSrcDst, len);
    default:
        assert(false);
        return _refr_fwsSubCRev_32f_I(val, pSrcDst, len);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsMagnitude_16s_Sfs(const Fw16s* pSrcRe, const Fw16s* pSrcIm, Fw16s* pDst, int len, int scaleFactor)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsMagnitude_16s_Sfs(pSrcRe, pSrcIm, pDst, len, scaleFactor);
    case DT_SSE2:
        return _sse2_fwsMagnitude_16s_Sfs(pSrcRe, pSrcIm, pDst, len, scaleFactor);
    case DT_REFR:
        return _refr_fwsMagnitude_16s_Sfs(pSrcRe, pSrcIm, pDst, len, scaleFactor);
    default:
        assert(false);
        return _refr_fwsMagnitude_16s_Sfs(pSrcRe, pSrcIm, pDst, len, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsSubCRev_64fc_I(Fw64fc val, Fw64fc* pSrcDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsSubCRev_64fc_I(val, pSrcDst, len);
    case DT_SSE2:
        return _sse2_fwsSubCRev_64fc_I(val, pSrcDst, len);
    case DT_REFR:
        return _refr_fwsSubCRev_64fc_I(val, pSrcDst, len);
    default:
        assert(false);
        return _refr_fwsSubCRev_64fc_I(val, pSrcDst, len);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsInv_64f_A53(const Fw64f* pSrc, Fw64f* pDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsInv_64f_A53(pSrc, pDst, len);
    case DT_SSE2:
        return _sse2_fwsInv_64f_A53(pSrc, pDst, len);
    case DT_REFR:
        return _refr_fwsInv_64f_A53(pSrc, pDst, len);
    default:
        assert(false);
        return _refr_fwsInv_64f_A53(pSrc, pDst, len);
    }
}

OREFR OSSE2 FwStatus STDCALL fwsMean_64fc(const Fw64fc* pSrc, int len, Fw64fc* pMean)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwsMean_64fc(pSrc, len, pMean);
    case DT_REFR:
        return _refr_fwsMean_64fc(pSrc, len, pMean);
    default:
        assert(false);
        return _refr_fwsMean_64fc(pSrc, len, pMean);
    }
}

OREFR OSSE2 FwStatus STDCALL fwsNorm_L1_32fc64f(const Fw32fc* pSrc, int len, Fw64f* pNorm)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwsNorm_L1_32fc64f(pSrc, len, pNorm);
    case DT_REFR:
        return _refr_fwsNorm_L1_32fc64f(pSrc, len, pNorm);
    default:
        assert(false);
        return _refr_fwsNorm_L1_32fc64f(pSrc, len, pNorm);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsConvert_32f16s_Sfs(const Fw32f* pSrc, Fw16s* pDst, int len, FwRoundMode rndMode, int scaleFactor)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsConvert_32f16s_Sfs(pSrc, pDst, len, rndMode, scaleFactor);
    case DT_SSE2:
        return _sse2_fwsConvert_32f16s_Sfs(pSrc, pDst, len, rndMode, scaleFactor);
    case DT_REFR:
        return _refr_fwsConvert_32f16s_Sfs(pSrc, pDst, len, rndMode, scaleFactor);
    default:
        assert(false);
        return _refr_fwsConvert_32f16s_Sfs(pSrc, pDst, len, rndMode, scaleFactor);
    }
}


OREFR FwStatus STDCALL fwsFind_8u(const Fw8u* pSrc, int len, const Fw8u* pFind, int lenFind, int* pIndex)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwsFind_8u(pSrc, len, pFind, lenFind, pIndex);
    default:
        assert(false);
        return _refr_fwsFind_8u(pSrc, len, pFind, lenFind, pIndex);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsSubC_8u_ISfs(Fw8u val, Fw8u* pSrcDst, int len, int scaleFactor)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsSubC_8u_ISfs(val, pSrcDst, len, scaleFactor);
    case DT_SSE2:
        return _sse2_fwsSubC_8u_ISfs(val, pSrcDst, len, scaleFactor);
    case DT_REFR:
        return _refr_fwsSubC_8u_ISfs(val, pSrcDst, len, scaleFactor);
    default:
        assert(false);
        return _refr_fwsSubC_8u_ISfs(val, pSrcDst, len, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsCopy_64fc(const Fw64fc* pSrc, Fw64fc* pDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsCopy_64fc(pSrc, pDst, len);
    case DT_SSE2:
        return _sse2_fwsCopy_64fc(pSrc, pDst, len);
    case DT_REFR:
        return _refr_fwsCopy_64fc(pSrc, pDst, len);
    default:
        assert(false);
        return _refr_fwsCopy_64fc(pSrc, pDst, len);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsMul_64fc(const Fw64fc* pSrc1, const Fw64fc* pSrc2, Fw64fc *pDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsMul_64fc(pSrc1, pSrc2, pDst, len);
    case DT_SSE2:
        return _sse2_fwsMul_64fc(pSrc1, pSrc2, pDst, len);
    case DT_REFR:
        return _refr_fwsMul_64fc(pSrc1, pSrc2, pDst, len);
    default:
        assert(false);
        return _refr_fwsMul_64fc(pSrc1, pSrc2, pDst, len);
    }
}

OREFR             FwStatus STDCALL fwsAsin_32f_A24(const Fw32f* pSrc, Fw32f* pDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwsAsin_32f_A24(pSrc, pDst, len);
    default:
        assert(false);
        return _refr_fwsAsin_32f_A24(pSrc, pDst, len);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsAdd_16sc_Sfs(const Fw16sc* pSrc1, const Fw16sc* pSrc2, Fw16sc* pDst, int len, int scaleFactor)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsAdd_16sc_Sfs(pSrc1, pSrc2, pDst, len, scaleFactor);
    case DT_SSE2:
        return _sse2_fwsAdd_16sc_Sfs(pSrc1, pSrc2, pDst, len, scaleFactor);
    case DT_REFR:
        return _refr_fwsAdd_16sc_Sfs(pSrc1, pSrc2, pDst, len, scaleFactor);
    default:
        assert(false);
        return _refr_fwsAdd_16sc_Sfs(pSrc1, pSrc2, pDst, len, scaleFactor);
    }
}


OREFR OSSE2 FwStatus STDCALL fwsMax_16s(const Fw16s* pSrc, int len, Fw16s* pMax)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwsMax_16s(pSrc, len, pMax);
    case DT_REFR:
        return _refr_fwsMax_16s(pSrc, len, pMax);
    default:
        assert(false);
        return _refr_fwsMax_16s(pSrc, len, pMax);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsLn_32f_I(Fw32f* pSrcDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsLn_32f_I(pSrcDst, len);
    case DT_SSE2:
        return _sse2_fwsLn_32f_I(pSrcDst, len);
    case DT_REFR:
        return _refr_fwsLn_32f_I(pSrcDst, len);
    default:
        assert(false);
        return _refr_fwsLn_32f_I(pSrcDst, len);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsConvert_8s32f(const Fw8s* pSrc, Fw32f* pDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsConvert_8s32f(pSrc, pDst, len);
    case DT_SSE2:
        return _sse2_fwsConvert_8s32f(pSrc, pDst, len);
    case DT_REFR:
        return _refr_fwsConvert_8s32f(pSrc, pDst, len);
    default:
        assert(false);
        return _refr_fwsConvert_8s32f(pSrc, pDst, len);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsSqrt_8u_ISfs(Fw8u* pSrcDst, int len, int scaleFactor)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsSqrt_8u_ISfs(pSrcDst, len, scaleFactor);
    case DT_SSE2:
        return _sse2_fwsSqrt_8u_ISfs(pSrcDst, len, scaleFactor);
    case DT_REFR:
        return _refr_fwsSqrt_8u_ISfs(pSrcDst, len, scaleFactor);
    default:
        assert(false);
        return _refr_fwsSqrt_8u_ISfs(pSrcDst, len, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsNot_16u(const Fw16u* pSrc, Fw16u* pDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsNot_16u(pSrc, pDst, len);
    case DT_SSE2:
        return _sse2_fwsNot_16u(pSrc, pDst, len);
    case DT_REFR:
        return _refr_fwsNot_16u(pSrc, pDst, len);
    default:
        assert(false);
        return _refr_fwsNot_16u(pSrc, pDst, len);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsMulC_16s_I(Fw16s val, Fw16s* pSrcDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsMulC_16s_I(val, pSrcDst, len);
    case DT_SSE2:
        return _sse2_fwsMulC_16s_I(val, pSrcDst, len);
    case DT_REFR:
        return _refr_fwsMulC_16s_I(val, pSrcDst, len);
    default:
        assert(false);
        return _refr_fwsMulC_16s_I(val, pSrcDst, len);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsThreshold_LTValGTVal_16s(const Fw16s* pSrc, Fw16s* pDst, int len, Fw16s levelLT, Fw16s valueLT, Fw16s levelGT, Fw16s valueGT)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsThreshold_LTValGTVal_16s(pSrc, pDst, len, levelLT, valueLT, levelGT, valueGT);
    case DT_SSE2:
        return _sse2_fwsThreshold_LTValGTVal_16s(pSrc, pDst, len, levelLT, valueLT, levelGT, valueGT);
    case DT_REFR:
        return _refr_fwsThreshold_LTValGTVal_16s(pSrc, pDst, len, levelLT, valueLT, levelGT, valueGT);
    default:
        assert(false);
        return _refr_fwsThreshold_LTValGTVal_16s(pSrc, pDst, len, levelLT, valueLT, levelGT, valueGT);
    }
}

OREFR OSSE2 FwStatus STDCALL fwsAutoCorr_NormA_32fc(const  Fw32fc*  pSrc,  int  srcLen,  Fw32fc*  pDst,  int  dstLen)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwsAutoCorr_NormA_32fc(pSrc, srcLen, pDst, dstLen);
    case DT_REFR:
        return _refr_fwsAutoCorr_NormA_32fc(pSrc, srcLen, pDst, dstLen);
    default:
        assert(false);
        return _refr_fwsAutoCorr_NormA_32fc(pSrc, srcLen, pDst, dstLen);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsSub_64fc(const Fw64fc* pSrc1, const Fw64fc* pSrc2, Fw64fc* pDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsSub_64fc(pSrc1, pSrc2, pDst, len);
    case DT_SSE2:
        return _sse2_fwsSub_64fc(pSrc1, pSrc2, pDst, len);
    case DT_REFR:
        return _refr_fwsSub_64fc(pSrc1, pSrc2, pDst, len);
    default:
        assert(false);
        return _refr_fwsSub_64fc(pSrc1, pSrc2, pDst, len);
    }
}

OREFR OSSE2 FwStatus STDCALL fwsSum_64f(const Fw64f* pSrc, int len, Fw64f* pSum)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwsSum_64f(pSrc, len, pSum);
    case DT_REFR:
        return _refr_fwsSum_64f(pSrc, len, pSum);
    default:
        assert(false);
        return _refr_fwsSum_64f(pSrc, len, pSum);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsSubC_32fc(const Fw32fc* pSrc, Fw32fc val, Fw32fc* pDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsSubC_32fc(pSrc, val, pDst, len);
    case DT_SSE2:
        return _sse2_fwsSubC_32fc(pSrc, val, pDst, len);
    case DT_REFR:
        return _refr_fwsSubC_32fc(pSrc, val, pDst, len);
    default:
        assert(false);
        return _refr_fwsSubC_32fc(pSrc, val, pDst, len);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsAdd_8u_Sfs(const Fw8u* pSrc1, const Fw8u* pSrc2, Fw8u* pDst,int len, int scaleFactor)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsAdd_8u_Sfs(pSrc1, pSrc2, pDst, len, scaleFactor);
    case DT_SSE2:
        return _sse2_fwsAdd_8u_Sfs(pSrc1, pSrc2, pDst, len, scaleFactor);
    case DT_REFR:
        return _refr_fwsAdd_8u_Sfs(pSrc1, pSrc2, pDst, len, scaleFactor);
    default:
        assert(false);
        return _refr_fwsAdd_8u_Sfs(pSrc1, pSrc2, pDst, len, scaleFactor);
    }
}

OREFR             FwStatus STDCALL fwsSinh_64f_A53(const Fw64f* pSrc, Fw64f* pDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwsSinh_64f_A53(pSrc, pDst, len);
    default:
        assert(false);
        return _refr_fwsSinh_64f_A53(pSrc, pDst, len);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsThreshold_GTVal_64fc(const Fw64fc* pSrc, Fw64fc* pDst, int len, Fw64f level, Fw64fc value)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsThreshold_GTVal_64fc(pSrc, pDst, len, level, value);
    case DT_SSE2:
        return _sse2_fwsThreshold_GTVal_64fc(pSrc, pDst, len, level, value);
    case DT_REFR:
        return _refr_fwsThreshold_GTVal_64fc(pSrc, pDst, len, level, value);
    default:
        assert(false);
        return _refr_fwsThreshold_GTVal_64fc(pSrc, pDst, len, level, value);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsMove_32f(const Fw32f* pSrc, Fw32f* pDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsMove_32f(pSrc, pDst, len);
    case DT_SSE2:
        return _sse2_fwsMove_32f(pSrc, pDst, len);
    case DT_REFR:
        return _refr_fwsMove_32f(pSrc, pDst, len);
    default:
        assert(false);
        return _refr_fwsMove_32f(pSrc, pDst, len);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsLn_32f_A21(const Fw32f* pSrc, Fw32f* pDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsLn_32f_A21(pSrc, pDst, len);
    case DT_SSE2:
        return _sse2_fwsLn_32f_A21(pSrc, pDst, len);
    case DT_REFR:
        return _refr_fwsLn_32f_A21(pSrc, pDst, len);
    default:
        assert(false);
        return _refr_fwsLn_32f_A21(pSrc, pDst, len);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsLn_32f_A24(const Fw32f* pSrc, Fw32f* pDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsLn_32f_A24(pSrc, pDst, len);
    case DT_SSE2:
        return _sse2_fwsLn_32f_A24(pSrc, pDst, len);
    case DT_REFR:
        return _refr_fwsLn_32f_A24(pSrc, pDst, len);
    default:
        assert(false);
        return _refr_fwsLn_32f_A24(pSrc, pDst, len);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsMagnitude_16sc_Sfs(const Fw16sc* pSrc, Fw16s* pDst, int len, int scaleFactor)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsMagnitude_16sc_Sfs(pSrc, pDst, len, scaleFactor);
    case DT_SSE2:
        return _sse2_fwsMagnitude_16sc_Sfs(pSrc, pDst, len, scaleFactor);
    case DT_REFR:
        return _refr_fwsMagnitude_16sc_Sfs(pSrc, pDst, len, scaleFactor);
    default:
        assert(false);
        return _refr_fwsMagnitude_16sc_Sfs(pSrc, pDst, len, scaleFactor);
    }
}

OREFR             FwStatus STDCALL fwsSinh_64f_A50(const Fw64f* pSrc, Fw64f* pDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwsSinh_64f_A50(pSrc, pDst, len);
    default:
        assert(false);
        return _refr_fwsSinh_64f_A50(pSrc, pDst, len);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsSub_16s_ISfs(const Fw16s* pSrc, Fw16s* pSrcDst, int len, int scaleFactor)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsSub_16s_ISfs(pSrc, pSrcDst, len, scaleFactor);
    case DT_SSE2:
        return _sse2_fwsSub_16s_ISfs(pSrc, pSrcDst, len, scaleFactor);
    case DT_REFR:
        return _refr_fwsSub_16s_ISfs(pSrc, pSrcDst, len, scaleFactor);
    default:
        assert(false);
        return _refr_fwsSub_16s_ISfs(pSrc, pSrcDst, len, scaleFactor);
    }
}

OREFR OSSE2 FwStatus STDCALL fwsNorm_Inf_64fc64f(const Fw64fc* pSrc, int len, Fw64f* pNorm)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwsNorm_Inf_64fc64f(pSrc, len, pNorm);
    case DT_REFR:
        return _refr_fwsNorm_Inf_64fc64f(pSrc, len, pNorm);
    default:
        assert(false);
        return _refr_fwsNorm_Inf_64fc64f(pSrc, len, pNorm);
    }
}

OREFR OSSE2 FwStatus STDCALL fwsDotProd_32fc(const Fw32fc* pSrc1, const Fw32fc* pSrc2, int len,Fw32fc* pDp)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwsDotProd_32fc(pSrc1, pSrc2, len, pDp);
    case DT_REFR:
        return _refr_fwsDotProd_32fc(pSrc1, pSrc2, len, pDp);
    default:
        assert(false);
        return _refr_fwsDotProd_32fc(pSrc1, pSrc2, len, pDp);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsSqr_8u_Sfs(const Fw8u* pSrc, Fw8u* pDst, int len,int scaleFactor)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsSqr_8u_Sfs(pSrc, pDst, len, scaleFactor);
    case DT_SSE2:
        return _sse2_fwsSqr_8u_Sfs(pSrc, pDst, len, scaleFactor);
    case DT_REFR:
        return _refr_fwsSqr_8u_Sfs(pSrc, pDst, len, scaleFactor);
    default:
        assert(false);
        return _refr_fwsSqr_8u_Sfs(pSrc, pDst, len, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsConvert_32s64f(const Fw32s* pSrc, Fw64f* pDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsConvert_32s64f(pSrc, pDst, len);
    case DT_SSE2:
        return _sse2_fwsConvert_32s64f(pSrc, pDst, len);
    case DT_REFR:
        return _refr_fwsConvert_32s64f(pSrc, pDst, len);
    default:
        assert(false);
        return _refr_fwsConvert_32s64f(pSrc, pDst, len);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsSqrt_32f_A21( const Fw32f* pSrc, Fw32f* pDst, int len )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsSqrt_32f_A21(pSrc, pDst, len);
    case DT_SSE2:
        return _sse2_fwsSqrt_32f_A21(pSrc, pDst, len);
    case DT_REFR:
        return _refr_fwsSqrt_32f_A21(pSrc, pDst, len);
    default:
        assert(false);
        return _refr_fwsSqrt_32f_A21(pSrc, pDst, len);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsInvCbrt_64f_A53(const Fw64f* pSrc, Fw64f* pDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsInvCbrt_64f_A53(pSrc, pDst, len);
    case DT_SSE2:
        return _sse2_fwsInvCbrt_64f_A53(pSrc, pDst, len);
    case DT_REFR:
        return _refr_fwsInvCbrt_64f_A53(pSrc, pDst, len);
    default:
        assert(false);
        return _refr_fwsInvCbrt_64f_A53(pSrc, pDst, len);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsSqrt_32f_A24( const Fw32f* pSrc, Fw32f* pDst, int len )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsSqrt_32f_A24(pSrc, pDst, len);
    case DT_SSE2:
        return _sse2_fwsSqrt_32f_A24(pSrc, pDst, len);
    case DT_REFR:
        return _refr_fwsSqrt_32f_A24(pSrc, pDst, len);
    default:
        assert(false);
        return _refr_fwsSqrt_32f_A24(pSrc, pDst, len);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsInvSqrt_64f_A53(const Fw64f* pSrc, Fw64f* pDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsInvSqrt_64f_A53(pSrc, pDst, len);
    case DT_SSE2:
        return _sse2_fwsInvSqrt_64f_A53(pSrc, pDst, len);
    case DT_REFR:
        return _refr_fwsInvSqrt_64f_A53(pSrc, pDst, len);
    default:
        assert(false);
        return _refr_fwsInvSqrt_64f_A53(pSrc, pDst, len);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsLn_32s_ISfs(Fw32s* pSrcDst, int len, int scaleFactor)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsLn_32s_ISfs(pSrcDst, len, scaleFactor);
    case DT_SSE2:
        return _sse2_fwsLn_32s_ISfs(pSrcDst, len, scaleFactor);
    case DT_REFR:
        return _refr_fwsLn_32s_ISfs(pSrcDst, len, scaleFactor);
    default:
        assert(false);
        return _refr_fwsLn_32s_ISfs(pSrcDst, len, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsSubC_32f(const Fw32f* pSrc, Fw32f val, Fw32f* pDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsSubC_32f(pSrc, val, pDst, len);
    case DT_SSE2:
        return _sse2_fwsSubC_32f(pSrc, val, pDst, len);
    case DT_REFR:
        return _refr_fwsSubC_32f(pSrc, val, pDst, len);
    default:
        assert(false);
        return _refr_fwsSubC_32f(pSrc, val, pDst, len);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsSqrt_64f(const Fw64f* pSrc, Fw64f* pDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsSqrt_64f(pSrc, pDst, len);
    case DT_SSE2:
        return _sse2_fwsSqrt_64f(pSrc, pDst, len);
    case DT_REFR:
        return _refr_fwsSqrt_64f(pSrc, pDst, len);
    default:
        assert(false);
        return _refr_fwsSqrt_64f(pSrc, pDst, len);
    }
}

OREFR             FwStatus STDCALL fwsExp_64s_Sfs(const Fw64s* pSrc, Fw64s* pDst, int len, int scaleFactor)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwsExp_64s_Sfs(pSrc, pDst, len, scaleFactor);
    default:
        assert(false);
        return _refr_fwsExp_64s_Sfs(pSrc, pDst, len, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsConvert_8u16s(const Fw8u* pSrc,Fw16s* pDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsConvert_8u16s(pSrc, pDst, len);
    case DT_SSE2:
        return _sse2_fwsConvert_8u16s(pSrc, pDst, len);
    case DT_REFR:
        return _refr_fwsConvert_8u16s(pSrc, pDst, len);
    default:
        assert(false);
        return _refr_fwsConvert_8u16s(pSrc, pDst, len);
    }
}

OREFR OSSE2 FwStatus STDCALL fwsMaxAbs_16s(const Fw16s* pSrc, int len, Fw16s* pMaxAbs)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwsMaxAbs_16s(pSrc, len, pMaxAbs);
    case DT_REFR:
        return _refr_fwsMaxAbs_16s(pSrc, len, pMaxAbs);
    default:
        assert(false);
        return _refr_fwsMaxAbs_16s(pSrc, len, pMaxAbs);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsInvSqrt_64f_A50(const Fw64f* pSrc, Fw64f* pDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsInvSqrt_64f_A50(pSrc, pDst, len);
    case DT_SSE2:
        return _sse2_fwsInvSqrt_64f_A50(pSrc, pDst, len);
    case DT_REFR:
        return _refr_fwsInvSqrt_64f_A50(pSrc, pDst, len);
    default:
        assert(false);
        return _refr_fwsInvSqrt_64f_A50(pSrc, pDst, len);
    }
}

OREFR FwStatus STDCALL fwsFindRevC_8u(const Fw8u* pSrc, int len, Fw8u valFind, int* pIndex)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwsFindRevC_8u(pSrc, len, valFind, pIndex);
    default:
        assert(false);
        return _refr_fwsFindRevC_8u(pSrc, len, valFind, pIndex);
    }
}

OREFR OSSE2 FwStatus STDCALL fwsMinMaxIndx_32f(const Fw32f* pSrc, int len, Fw32f* pMin, int* pMinIndx, Fw32f* pMax, int* pMaxIndx)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwsMinMaxIndx_32f(pSrc, len, pMin, pMinIndx, pMax, pMaxIndx);
    case DT_REFR:
        return _refr_fwsMinMaxIndx_32f(pSrc, len, pMin, pMinIndx, pMax, pMaxIndx);
    default:
        assert(false);
        return _refr_fwsMinMaxIndx_32f(pSrc, len, pMin, pMinIndx, pMax, pMaxIndx);
    }
}

OREFR OSSE2 FwStatus STDCALL fwsMean_64f(const Fw64f* pSrc, int len, Fw64f* pMean)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwsMean_64f(pSrc, len, pMean);
    case DT_REFR:
        return _refr_fwsMean_64f(pSrc, len, pMean);
    default:
        assert(false);
        return _refr_fwsMean_64f(pSrc, len, pMean);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsMul_8u_Sfs(const Fw8u* pSrc1, const Fw8u* pSrc2, Fw8u* pDst, int len, int scaleFactor)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsMul_8u_Sfs(pSrc1, pSrc2, pDst, len, scaleFactor);
    case DT_SSE2:
        return _sse2_fwsMul_8u_Sfs(pSrc1, pSrc2, pDst, len, scaleFactor);
    case DT_REFR:
        return _refr_fwsMul_8u_Sfs(pSrc1, pSrc2, pDst, len, scaleFactor);
    default:
        assert(false);
        return _refr_fwsMul_8u_Sfs(pSrc1, pSrc2, pDst, len, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsSqrt_32fc(const Fw32fc* pSrc, Fw32fc* pDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsSqrt_32fc(pSrc, pDst, len);
    case DT_SSE2:
        return _sse2_fwsSqrt_32fc(pSrc, pDst, len);
    case DT_REFR:
        return _refr_fwsSqrt_32fc(pSrc, pDst, len);
    default:
        assert(false);
        return _refr_fwsSqrt_32fc(pSrc, pDst, len);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsXorC_16u_I(Fw16u val, Fw16u* pSrcDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsXorC_16u_I(val, pSrcDst, len);
    case DT_SSE2:
        return _sse2_fwsXorC_16u_I(val, pSrcDst, len);
    case DT_REFR:
        return _refr_fwsXorC_16u_I(val, pSrcDst, len);
    default:
        assert(false);
        return _refr_fwsXorC_16u_I(val, pSrcDst, len);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsMul_32f(const Fw32f* pSrc1, const Fw32f* pSrc2, Fw32f *pDst,int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsMul_32f(pSrc1, pSrc2, pDst, len);
    case DT_SSE2:
        return _sse2_fwsMul_32f(pSrc1, pSrc2, pDst, len);
    case DT_REFR:
        return _refr_fwsMul_32f(pSrc1, pSrc2, pDst, len);
    default:
        assert(false);
        return _refr_fwsMul_32f(pSrc1, pSrc2, pDst, len);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsSub_16s32f(const Fw16s* pSrc1, const Fw16s* pSrc2, Fw32f* pDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsSub_16s32f(pSrc1, pSrc2, pDst, len);
    case DT_SSE2:
        return _sse2_fwsSub_16s32f(pSrc1, pSrc2, pDst, len);
    case DT_REFR:
        return _refr_fwsSub_16s32f(pSrc1, pSrc2, pDst, len);
    default:
        assert(false);
        return _refr_fwsSub_16s32f(pSrc1, pSrc2, pDst, len);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsRShiftC_16u(const Fw16u* pSrc, int val, Fw16u* pDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsRShiftC_16u(pSrc, val, pDst, len);
    case DT_SSE2:
        return _sse2_fwsRShiftC_16u(pSrc, val, pDst, len);
    case DT_REFR:
        return _refr_fwsRShiftC_16u(pSrc, val, pDst, len);
    default:
        assert(false);
        return _refr_fwsRShiftC_16u(pSrc, val, pDst, len);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsAdd_32f_I(const Fw32f* pSrc, Fw32f* pSrcDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsAdd_32f_I(pSrc, pSrcDst, len);
    case DT_SSE2:
        return _sse2_fwsAdd_32f_I(pSrc, pSrcDst, len);
    case DT_REFR:
        return _refr_fwsAdd_32f_I(pSrc, pSrcDst, len);
    default:
        assert(false);
        return _refr_fwsAdd_32f_I(pSrc, pSrcDst, len);
    }
}

OREFR OSSE2 FwStatus STDCALL fwsNorm_L2_64f(const Fw64f* pSrc, int len, Fw64f* pNorm)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwsNorm_L2_64f(pSrc, len, pNorm);
    case DT_REFR:
        return _refr_fwsNorm_L2_64f(pSrc, len, pNorm);
    default:
        assert(false);
        return _refr_fwsNorm_L2_64f(pSrc, len, pNorm);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsRShiftC_16s(const Fw16s* pSrc, int val, Fw16s* pDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsRShiftC_16s(pSrc, val, pDst, len);
    case DT_SSE2:
        return _sse2_fwsRShiftC_16s(pSrc, val, pDst, len);
    case DT_REFR:
        return _refr_fwsRShiftC_16s(pSrc, val, pDst, len);
    default:
        assert(false);
        return _refr_fwsRShiftC_16s(pSrc, val, pDst, len);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsCopy_16s(const Fw16s* pSrc, Fw16s* pDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsCopy_16s(pSrc, pDst, len);
    case DT_SSE2:
        return _sse2_fwsCopy_16s(pSrc, pDst, len);
    case DT_REFR:
        return _refr_fwsCopy_16s(pSrc, pDst, len);
    default:
        assert(false);
        return _refr_fwsCopy_16s(pSrc, pDst, len);
    }
}

OREFR OSSE2 FwStatus STDCALL fwsNormDiff_L2_16s32f(const Fw16s* pSrc1, const Fw16s* pSrc2, int len,Fw32f* pNorm)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwsNormDiff_L2_16s32f(pSrc1, pSrc2, len, pNorm);
    case DT_REFR:
        return _refr_fwsNormDiff_L2_16s32f(pSrc1, pSrc2, len, pNorm);
    default:
        assert(false);
        return _refr_fwsNormDiff_L2_16s32f(pSrc1, pSrc2, len, pNorm);
    }
}

OREFR OSSE2 FwStatus STDCALL fwsDotProd_32f(const Fw32f* pSrc1, const Fw32f* pSrc2, int len,Fw32f* pDp)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwsDotProd_32f(pSrc1, pSrc2, len, pDp);
    case DT_REFR:
        return _refr_fwsDotProd_32f(pSrc1, pSrc2, len, pDp);
    default:
        assert(false);
        return _refr_fwsDotProd_32f(pSrc1, pSrc2, len, pDp);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsConvert_16u32f_Sfs(const Fw16u* pSrc, Fw32f* pDst, int len, int scaleFactor)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsConvert_16u32f_Sfs(pSrc, pDst, len, scaleFactor);
    case DT_SSE2:
        return _sse2_fwsConvert_16u32f_Sfs(pSrc, pDst, len, scaleFactor);
    case DT_REFR:
        return _refr_fwsConvert_16u32f_Sfs(pSrc, pDst, len, scaleFactor);
    default:
        assert(false);
        return _refr_fwsConvert_16u32f_Sfs(pSrc, pDst, len, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsDiv_64f_I(const Fw64f* pSrc, Fw64f* pSrcDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsDiv_64f_I(pSrc, pSrcDst, len);
    case DT_SSE2:
        return _sse2_fwsDiv_64f_I(pSrc, pSrcDst, len);
    case DT_REFR:
        return _refr_fwsDiv_64f_I(pSrc, pSrcDst, len);
    default:
        assert(false);
        return _refr_fwsDiv_64f_I(pSrc, pSrcDst, len);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsThreshold_GTVal_32fc_I(Fw32fc* pSrcDst, int len, Fw32f level, Fw32fc value)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsThreshold_GTVal_32fc_I(pSrcDst, len, level, value);
    case DT_SSE2:
        return _sse2_fwsThreshold_GTVal_32fc_I(pSrcDst, len, level, value);
    case DT_REFR:
        return _refr_fwsThreshold_GTVal_32fc_I(pSrcDst, len, level, value);
    default:
        assert(false);
        return _refr_fwsThreshold_GTVal_32fc_I(pSrcDst, len, level, value);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsThreshold_GTVal_64f_I(Fw64f* pSrcDst, int len, Fw64f level, Fw64f value)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsThreshold_GTVal_64f_I(pSrcDst, len, level, value);
    case DT_SSE2:
        return _sse2_fwsThreshold_GTVal_64f_I(pSrcDst, len, level, value);
    case DT_REFR:
        return _refr_fwsThreshold_GTVal_64f_I(pSrcDst, len, level, value);
    default:
        assert(false);
        return _refr_fwsThreshold_GTVal_64f_I(pSrcDst, len, level, value);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fws10Log10_32s_Sfs(const Fw32s* pSrc, Fw32s* pDst, int len, int scaleFactor)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fws10Log10_32s_Sfs(pSrc, pDst, len, scaleFactor);
    case DT_SSE2:
        return _sse2_fws10Log10_32s_Sfs(pSrc, pDst, len, scaleFactor);
    case DT_REFR:
        return _refr_fws10Log10_32s_Sfs(pSrc, pDst, len, scaleFactor);
    default:
        assert(false);
        return _refr_fws10Log10_32s_Sfs(pSrc, pDst, len, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsAddC_32fc(const Fw32fc* pSrc, Fw32fc val,Fw32fc* pDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsAddC_32fc(pSrc, val, pDst, len);
    case DT_SSE2:
        return _sse2_fwsAddC_32fc(pSrc, val, pDst, len);
    case DT_REFR:
        return _refr_fwsAddC_32fc(pSrc, val, pDst, len);
    default:
        assert(false);
        return _refr_fwsAddC_32fc(pSrc, val, pDst, len);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsAbs_16s(const Fw16s* pSrc, Fw16s* pDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsAbs_16s(pSrc, pDst, len);
    case DT_SSE2:
        return _sse2_fwsAbs_16s(pSrc, pDst, len);
    case DT_REFR:
        return _refr_fwsAbs_16s(pSrc, pDst, len);
    default:
        assert(false);
        return _refr_fwsAbs_16s(pSrc, pDst, len);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsAddC_32s_ISfs(Fw32s val, Fw32s* pSrcDst, int len, int scaleFactor)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsAddC_32s_ISfs(val, pSrcDst, len, scaleFactor);
    case DT_SSE2:
        return _sse2_fwsAddC_32s_ISfs(val, pSrcDst, len, scaleFactor);
    case DT_REFR:
        return _refr_fwsAddC_32s_ISfs(val, pSrcDst, len, scaleFactor);
    default:
        assert(false);
        return _refr_fwsAddC_32s_ISfs(val, pSrcDst, len, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsSub_16sc_ISfs(const Fw16sc* pSrc, Fw16sc* pSrcDst, int len, int scaleFactor)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsSub_16sc_ISfs(pSrc, pSrcDst, len, scaleFactor);
    case DT_SSE2:
        return _sse2_fwsSub_16sc_ISfs(pSrc, pSrcDst, len, scaleFactor);
    case DT_REFR:
        return _refr_fwsSub_16sc_ISfs(pSrc, pSrcDst, len, scaleFactor);
    default:
        assert(false);
        return _refr_fwsSub_16sc_ISfs(pSrc, pSrcDst, len, scaleFactor);
    }
}

OREFR OSSE2 FwStatus STDCALL fwsNormDiff_L1_64fc64f(const Fw64fc* pSrc1, const Fw64fc* pSrc2, int len, Fw64f* pNorm)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwsNormDiff_L1_64fc64f(pSrc1, pSrc2, len, pNorm);
    case DT_REFR:
        return _refr_fwsNormDiff_L1_64fc64f(pSrc1, pSrc2, len, pNorm);
    default:
        assert(false);
        return _refr_fwsNormDiff_L1_64fc64f(pSrc1, pSrc2, len, pNorm);
    }
}

OREFR FwStatus STDCALL fwsFindRev_8u(const Fw8u* pSrc, int len, const Fw8u* pFind, int lenFind, int* pIndex)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwsFindRev_8u(pSrc, len, pFind, lenFind, pIndex);
    default:
        assert(false);
        return _refr_fwsFindRev_8u(pSrc, len, pFind, lenFind, pIndex);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsAndC_16u(const Fw16u* pSrc, Fw16u val, Fw16u* pDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsAndC_16u(pSrc, val, pDst, len);
    case DT_SSE2:
        return _sse2_fwsAndC_16u(pSrc, val, pDst, len);
    case DT_REFR:
        return _refr_fwsAndC_16u(pSrc, val, pDst, len);
    default:
        assert(false);
        return _refr_fwsAndC_16u(pSrc, val, pDst, len);
    }
}

OREFR OSSE2 FwStatus STDCALL fwsNormDiff_L2_32fc64f(const Fw32fc* pSrc1, const Fw32fc* pSrc2, int len, Fw64f* pNorm)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwsNormDiff_L2_32fc64f(pSrc1, pSrc2, len, pNorm);
    case DT_REFR:
        return _refr_fwsNormDiff_L2_32fc64f(pSrc1, pSrc2, len, pNorm);
    default:
        assert(false);
        return _refr_fwsNormDiff_L2_32fc64f(pSrc1, pSrc2, len, pNorm);
    }
}

OREFR OSSE2 FwStatus STDCALL fwsMinMax_32f(const Fw32f* pSrc, int len, Fw32f* pMin, Fw32f* pMax)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwsMinMax_32f(pSrc, len, pMin, pMax);
    case DT_REFR:
        return _refr_fwsMinMax_32f(pSrc, len, pMin, pMax);
    default:
        assert(false);
        return _refr_fwsMinMax_32f(pSrc, len, pMin, pMax);
    }
}

OREFR             FwStatus STDCALL fwsTanh_32f_A24(const Fw32f* pSrc, Fw32f* pDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwsTanh_32f_A24(pSrc, pDst, len);
    default:
        assert(false);
        return _refr_fwsTanh_32f_A24(pSrc, pDst, len);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsConvert_16s32f_Sfs(const Fw16s* pSrc, Fw32f* pDst, int len, int scaleFactor)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsConvert_16s32f_Sfs(pSrc, pDst, len, scaleFactor);
    case DT_SSE2:
        return _sse2_fwsConvert_16s32f_Sfs(pSrc, pDst, len, scaleFactor);
    case DT_REFR:
        return _refr_fwsConvert_16s32f_Sfs(pSrc, pDst, len, scaleFactor);
    default:
        assert(false);
        return _refr_fwsConvert_16s32f_Sfs(pSrc, pDst, len, scaleFactor);
    }
}

OREFR             FwStatus STDCALL fwsCos_64f_A50(const Fw64f* pSrc, Fw64f* pDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwsCos_64f_A50(pSrc, pDst, len);
    default:
        assert(false);
        return _refr_fwsCos_64f_A50(pSrc, pDst, len);
    }
}

OREFR             FwStatus STDCALL fwsCos_64f_A53(const Fw64f* pSrc, Fw64f* pDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwsCos_64f_A53(pSrc, pDst, len);
    default:
        assert(false);
        return _refr_fwsCos_64f_A53(pSrc, pDst, len);
    }
}

OREFR             FwStatus STDCALL fwsSin_64f_A53(const Fw64f* pSrc, Fw64f* pDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwsSin_64f_A53(pSrc, pDst, len);
    default:
        assert(false);
        return _refr_fwsSin_64f_A53(pSrc, pDst, len);
    }
}

OREFR             FwStatus STDCALL fwsSin_64f_A50(const Fw64f* pSrc, Fw64f* pDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwsSin_64f_A50(pSrc, pDst, len);
    default:
        assert(false);
        return _refr_fwsSin_64f_A50(pSrc, pDst, len);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsSqrt_8u_Sfs(const Fw8u* pSrc, Fw8u* pDst, int len, int scaleFactor)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsSqrt_8u_Sfs(pSrc, pDst, len, scaleFactor);
    case DT_SSE2:
        return _sse2_fwsSqrt_8u_Sfs(pSrc, pDst, len, scaleFactor);
    case DT_REFR:
        return _refr_fwsSqrt_8u_Sfs(pSrc, pDst, len, scaleFactor);
    default:
        assert(false);
        return _refr_fwsSqrt_8u_Sfs(pSrc, pDst, len, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsLn_64f_A53(const Fw64f* pSrc, Fw64f* pDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsLn_64f_A53(pSrc, pDst, len);
    case DT_SSE2:
        return _sse2_fwsLn_64f_A53(pSrc, pDst, len);
    case DT_REFR:
        return _refr_fwsLn_64f_A53(pSrc, pDst, len);
    default:
        assert(false);
        return _refr_fwsLn_64f_A53(pSrc, pDst, len);
    }
}

OREFR OSSE2 FwStatus STDCALL fwsDotProd_32s32sc_Sfs(const Fw32s* pSrc1, const Fw32sc* pSrc2,int len, Fw32sc* pDp, int scaleFactor)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwsDotProd_32s32sc_Sfs(pSrc1, pSrc2, len, pDp, scaleFactor);
    case DT_REFR:
        return _refr_fwsDotProd_32s32sc_Sfs(pSrc1, pSrc2, len, pDp, scaleFactor);
    default:
        assert(false);
        return _refr_fwsDotProd_32s32sc_Sfs(pSrc1, pSrc2, len, pDp, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsLn_32s16s_Sfs(const Fw32s* pSrc, Fw16s* pDst, int len, int scaleFactor)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsLn_32s16s_Sfs(pSrc, pDst, len, scaleFactor);
    case DT_SSE2:
        return _sse2_fwsLn_32s16s_Sfs(pSrc, pDst, len, scaleFactor);
    case DT_REFR:
        return _refr_fwsLn_32s16s_Sfs(pSrc, pDst, len, scaleFactor);
    default:
        assert(false);
        return _refr_fwsLn_32s16s_Sfs(pSrc, pDst, len, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsThreshold_GT_32f(const Fw32f* pSrc, Fw32f* pDst, int len, Fw32f level)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsThreshold_GT_32f(pSrc, pDst, len, level);
    case DT_SSE2:
        return _sse2_fwsThreshold_GT_32f(pSrc, pDst, len, level);
    case DT_REFR:
        return _refr_fwsThreshold_GT_32f(pSrc, pDst, len, level);
    default:
        assert(false);
        return _refr_fwsThreshold_GT_32f(pSrc, pDst, len, level);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsDivC_16sc_Sfs(const Fw16sc* pSrc, Fw16sc val, Fw16sc* pDst,int len, int scaleFactor)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsDivC_16sc_Sfs(pSrc, val, pDst, len, scaleFactor);
    case DT_SSE2:
        return _sse2_fwsDivC_16sc_Sfs(pSrc, val, pDst, len, scaleFactor);
    case DT_REFR:
        return _refr_fwsDivC_16sc_Sfs(pSrc, val, pDst, len, scaleFactor);
    default:
        assert(false);
        return _refr_fwsDivC_16sc_Sfs(pSrc, val, pDst, len, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsSub_32fc(const Fw32fc* pSrc1, const Fw32fc* pSrc2, Fw32fc* pDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsSub_32fc(pSrc1, pSrc2, pDst, len);
    case DT_SSE2:
        return _sse2_fwsSub_32fc(pSrc1, pSrc2, pDst, len);
    case DT_REFR:
        return _refr_fwsSub_32fc(pSrc1, pSrc2, pDst, len);
    default:
        assert(false);
        return _refr_fwsSub_32fc(pSrc1, pSrc2, pDst, len);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsLn_64f(const Fw64f* pSrc, Fw64f* pDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsLn_64f(pSrc, pDst, len);
    case DT_SSE2:
        return _sse2_fwsLn_64f(pSrc, pDst, len);
    case DT_REFR:
        return _refr_fwsLn_64f(pSrc, pDst, len);
    default:
        assert(false);
        return _refr_fwsLn_64f(pSrc, pDst, len);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsAtan_32f_A24(const Fw32f* pSrc, Fw32f* pDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsAtan_32f_A24(pSrc, pDst, len);
    case DT_SSE2:
        return _sse2_fwsAtan_32f_A24(pSrc, pDst, len);
    case DT_REFR:
        return _refr_fwsAtan_32f_A24(pSrc, pDst, len);
    default:
        assert(false);
        return _refr_fwsAtan_32f_A24(pSrc, pDst, len);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsThreshold_GT_32s(const Fw32s* pSrc, Fw32s* pDst, int len, Fw32s level)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsThreshold_GT_32s(pSrc, pDst, len, level);
    case DT_SSE2:
        return _sse2_fwsThreshold_GT_32s(pSrc, pDst, len, level);
    case DT_REFR:
        return _refr_fwsThreshold_GT_32s(pSrc, pDst, len, level);
    default:
        assert(false);
        return _refr_fwsThreshold_GT_32s(pSrc, pDst, len, level);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsAdd_16sc_ISfs(const Fw16sc* pSrc, Fw16sc* pSrcDst, int len, int scaleFactor)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsAdd_16sc_ISfs(pSrc, pSrcDst, len, scaleFactor);
    case DT_SSE2:
        return _sse2_fwsAdd_16sc_ISfs(pSrc, pSrcDst, len, scaleFactor);
    case DT_REFR:
        return _refr_fwsAdd_16sc_ISfs(pSrc, pSrcDst, len, scaleFactor);
    default:
        assert(false);
        return _refr_fwsAdd_16sc_ISfs(pSrc, pSrcDst, len, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsSqr_32fc_I(Fw32fc* pSrcDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsSqr_32fc_I(pSrcDst, len);
    case DT_SSE2:
        return _sse2_fwsSqr_32fc_I(pSrcDst, len);
    case DT_REFR:
        return _refr_fwsSqr_32fc_I(pSrcDst, len);
    default:
        assert(false);
        return _refr_fwsSqr_32fc_I(pSrcDst, len);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsAdd_16s_I(const Fw16s* pSrc, Fw16s* pSrcDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsAdd_16s_I(pSrc, pSrcDst, len);
    case DT_SSE2:
        return _sse2_fwsAdd_16s_I(pSrc, pSrcDst, len);
    case DT_REFR:
        return _refr_fwsAdd_16s_I(pSrc, pSrcDst, len);
    default:
        assert(false);
        return _refr_fwsAdd_16s_I(pSrc, pSrcDst, len);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsThreshold_LT_64fc_I(Fw64fc* pSrcDst, int len, Fw64f level)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsThreshold_LT_64fc_I(pSrcDst, len, level);
    case DT_SSE2:
        return _sse2_fwsThreshold_LT_64fc_I(pSrcDst, len, level);
    case DT_REFR:
        return _refr_fwsThreshold_LT_64fc_I(pSrcDst, len, level);
    default:
        assert(false);
        return _refr_fwsThreshold_LT_64fc_I(pSrcDst, len, level);
    }
}

OREFR OSSE2 FwStatus STDCALL fwsMean_16s_Sfs(const Fw16s* pSrc, int len, Fw16s* pMean, int scaleFactor)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwsMean_16s_Sfs(pSrc, len, pMean, scaleFactor);
    case DT_REFR:
        return _refr_fwsMean_16s_Sfs(pSrc, len, pMean, scaleFactor);
    default:
        assert(false);
        return _refr_fwsMean_16s_Sfs(pSrc, len, pMean, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsSet_32sc(Fw32sc val, Fw32sc* pDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsSet_32sc(val, pDst, len);
    case DT_SSE2:
        return _sse2_fwsSet_32sc(val, pDst, len);
    case DT_REFR:
        return _refr_fwsSet_32sc(val, pDst, len);
    default:
        assert(false);
        return _refr_fwsSet_32sc(val, pDst, len);
    }
}

OREFR             FwStatus STDCALL fwsAtanh_64f_A50(const Fw64f* pSrc, Fw64f* pDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwsAtanh_64f_A50(pSrc, pDst, len);
    default:
        assert(false);
        return _refr_fwsAtanh_64f_A50(pSrc, pDst, len);
    }
}

OREFR             FwStatus STDCALL fwsAtanh_64f_A53(const Fw64f* pSrc, Fw64f* pDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwsAtanh_64f_A53(pSrc, pDst, len);
    default:
        assert(false);
        return _refr_fwsAtanh_64f_A53(pSrc, pDst, len);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsZero_64f(Fw64f* pDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsZero_64f(pDst, len);
    case DT_SSE2:
        return _sse2_fwsZero_64f(pDst, len);
    case DT_REFR:
        return _refr_fwsZero_64f(pDst, len);
    default:
        assert(false);
        return _refr_fwsZero_64f(pDst, len);
    }
}

OREFR OSSE2 FwStatus STDCALL fwsAutoCorr_32f(const  Fw32f*  pSrc,  int  srcLen,  Fw32f*  pDst,  int  dstLen)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwsAutoCorr_32f(pSrc, srcLen, pDst, dstLen);
    case DT_REFR:
        return _refr_fwsAutoCorr_32f(pSrc, srcLen, pDst, dstLen);
    default:
        assert(false);
        return _refr_fwsAutoCorr_32f(pSrc, srcLen, pDst, dstLen);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsConvert_64f32s_Sfs(const Fw64f* pSrc, Fw32s* pDst, int len, FwRoundMode rndMode, int scaleFactor)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsConvert_64f32s_Sfs(pSrc, pDst, len, rndMode, scaleFactor);
    case DT_SSE2:
        return _sse2_fwsConvert_64f32s_Sfs(pSrc, pDst, len, rndMode, scaleFactor);
    case DT_REFR:
        return _refr_fwsConvert_64f32s_Sfs(pSrc, pDst, len, rndMode, scaleFactor);
    default:
        assert(false);
        return _refr_fwsConvert_64f32s_Sfs(pSrc, pDst, len, rndMode, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsAtan2_64f_A53(const Fw64f* pSrc1, const Fw64f* pSrc2, Fw64f* pDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsAtan2_64f_A53(pSrc1, pSrc2, pDst, len);
    case DT_SSE2:
        return _sse2_fwsAtan2_64f_A53(pSrc1, pSrc2, pDst, len);
    case DT_REFR:
        return _refr_fwsAtan2_64f_A53(pSrc1, pSrc2, pDst, len);
    default:
        assert(false);
        return _refr_fwsAtan2_64f_A53(pSrc1, pSrc2, pDst, len);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsAtan2_64f_A50(const Fw64f* pSrc1, const Fw64f* pSrc2, Fw64f* pDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsAtan2_64f_A50(pSrc1, pSrc2, pDst, len);
    case DT_SSE2:
        return _sse2_fwsAtan2_64f_A50(pSrc1, pSrc2, pDst, len);
    case DT_REFR:
        return _refr_fwsAtan2_64f_A50(pSrc1, pSrc2, pDst, len);
    default:
        assert(false);
        return _refr_fwsAtan2_64f_A50(pSrc1, pSrc2, pDst, len);
    }
}

OREFR OSSE2 FwStatus STDCALL fwsSum_32fc(const Fw32fc* pSrc, int len, Fw32fc* pSum, FwHintAlgorithm hint)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwsSum_32fc(pSrc, len, pSum, hint);
    case DT_REFR:
        return _refr_fwsSum_32fc(pSrc, len, pSum, hint);
    default:
        assert(false);
        return _refr_fwsSum_32fc(pSrc, len, pSum, hint);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsSubC_16sc_Sfs(const Fw16sc* pSrc, Fw16sc val, Fw16sc* pDst, int len, int scaleFactor)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsSubC_16sc_Sfs(pSrc, val, pDst, len, scaleFactor);
    case DT_SSE2:
        return _sse2_fwsSubC_16sc_Sfs(pSrc, val, pDst, len, scaleFactor);
    case DT_REFR:
        return _refr_fwsSubC_16sc_Sfs(pSrc, val, pDst, len, scaleFactor);
    default:
        assert(false);
        return _refr_fwsSubC_16sc_Sfs(pSrc, val, pDst, len, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsAddC_64f_I(Fw64f val, Fw64f* pSrcDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsAddC_64f_I(val, pSrcDst, len);
    case DT_SSE2:
        return _sse2_fwsAddC_64f_I(val, pSrcDst, len);
    case DT_REFR:
        return _refr_fwsAddC_64f_I(val, pSrcDst, len);
    default:
        assert(false);
        return _refr_fwsAddC_64f_I(val, pSrcDst, len);
    }
}

OREFR OSSE2 FwStatus STDCALL fwsAutoCorr_NormB_32f(const  Fw32f*  pSrc,  int  srcLen,  Fw32f*  pDst,  int  dstLen)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwsAutoCorr_NormB_32f(pSrc, srcLen, pDst, dstLen);
    case DT_REFR:
        return _refr_fwsAutoCorr_NormB_32f(pSrc, srcLen, pDst, dstLen);
    default:
        assert(false);
        return _refr_fwsAutoCorr_NormB_32f(pSrc, srcLen, pDst, dstLen);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsThreshold_LTVal_16sc(const Fw16sc* pSrc, Fw16sc* pDst, int len, Fw16s level, Fw16sc value)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsThreshold_LTVal_16sc(pSrc, pDst, len, level, value);
    case DT_SSE2:
        return _sse2_fwsThreshold_LTVal_16sc(pSrc, pDst, len, level, value);
    case DT_REFR:
        return _refr_fwsThreshold_LTVal_16sc(pSrc, pDst, len, level, value);
    default:
        assert(false);
        return _refr_fwsThreshold_LTVal_16sc(pSrc, pDst, len, level, value);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsThreshold_LTVal_32fc(const Fw32fc* pSrc, Fw32fc* pDst, int len, Fw32f level, Fw32fc value)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsThreshold_LTVal_32fc(pSrc, pDst, len, level, value);
    case DT_SSE2:
        return _sse2_fwsThreshold_LTVal_32fc(pSrc, pDst, len, level, value);
    case DT_REFR:
        return _refr_fwsThreshold_LTVal_32fc(pSrc, pDst, len, level, value);
    default:
        assert(false);
        return _refr_fwsThreshold_LTVal_32fc(pSrc, pDst, len, level, value);
    }
}

OREFR             FwStatus STDCALL fwsAtanh_32f_A21(const Fw32f* pSrc, Fw32f* pDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwsAtanh_32f_A21(pSrc, pDst, len);
    default:
        assert(false);
        return _refr_fwsAtanh_32f_A21(pSrc, pDst, len);
    }
}

OREFR             FwStatus STDCALL fwsAtanh_32f_A24(const Fw32f* pSrc, Fw32f* pDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwsAtanh_32f_A24(pSrc, pDst, len);
    default:
        assert(false);
        return _refr_fwsAtanh_32f_A24(pSrc, pDst, len);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsConvert_32s16s_Sfs(const Fw32s* pSrc, Fw16s* pDst, int len, int scaleFactor)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsConvert_32s16s_Sfs(pSrc, pDst, len, scaleFactor);
    case DT_SSE2:
        return _sse2_fwsConvert_32s16s_Sfs(pSrc, pDst, len, scaleFactor);
    case DT_REFR:
        return _refr_fwsConvert_32s16s_Sfs(pSrc, pDst, len, scaleFactor);
    default:
        assert(false);
        return _refr_fwsConvert_32s16s_Sfs(pSrc, pDst, len, scaleFactor);
    }
}

OREFR OSSE2 FwStatus STDCALL fwsNormDiff_L1_16s32f(const Fw16s* pSrc1, const Fw16s* pSrc2, int len,Fw32f* pNorm)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwsNormDiff_L1_16s32f(pSrc1, pSrc2, len, pNorm);
    case DT_REFR:
        return _refr_fwsNormDiff_L1_16s32f(pSrc1, pSrc2, len, pNorm);
    default:
        assert(false);
        return _refr_fwsNormDiff_L1_16s32f(pSrc1, pSrc2, len, pNorm);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsAdd_64fc_I(const Fw64fc* pSrc, Fw64fc* pSrcDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsAdd_64fc_I(pSrc, pSrcDst, len);
    case DT_SSE2:
        return _sse2_fwsAdd_64fc_I(pSrc, pSrcDst, len);
    case DT_REFR:
        return _refr_fwsAdd_64fc_I(pSrc, pSrcDst, len);
    default:
        assert(false);
        return _refr_fwsAdd_64fc_I(pSrc, pSrcDst, len);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsThreshold_16sc(const Fw16sc* pSrc, Fw16sc* pDst, int len, Fw16s level, FwCmpOp relOp)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsThreshold_16sc(pSrc, pDst, len, level, relOp);
    case DT_SSE2:
        return _sse2_fwsThreshold_16sc(pSrc, pDst, len, level, relOp);
    case DT_REFR:
        return _refr_fwsThreshold_16sc(pSrc, pDst, len, level, relOp);
    default:
        assert(false);
        return _refr_fwsThreshold_16sc(pSrc, pDst, len, level, relOp);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsArctan_64f_I(Fw64f* pSrcDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsArctan_64f_I(pSrcDst, len);
    case DT_SSE2:
        return _sse2_fwsArctan_64f_I(pSrcDst, len);
    case DT_REFR:
        return _refr_fwsArctan_64f_I(pSrcDst, len);
    default:
        assert(false);
        return _refr_fwsArctan_64f_I(pSrcDst, len);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsLShiftC_8u(const Fw8u* pSrc, int val, Fw8u* pDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsLShiftC_8u(pSrc, val, pDst, len);
    case DT_SSE2:
        return _sse2_fwsLShiftC_8u(pSrc, val, pDst, len);
    case DT_REFR:
        return _refr_fwsLShiftC_8u(pSrc, val, pDst, len);
    default:
        assert(false);
        return _refr_fwsLShiftC_8u(pSrc, val, pDst, len);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsSubCRev_64fc(const Fw64fc* pSrc, Fw64fc val, Fw64fc* pDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsSubCRev_64fc(pSrc, val, pDst, len);
    case DT_SSE2:
        return _sse2_fwsSubCRev_64fc(pSrc, val, pDst, len);
    case DT_REFR:
        return _refr_fwsSubCRev_64fc(pSrc, val, pDst, len);
    default:
        assert(false);
        return _refr_fwsSubCRev_64fc(pSrc, val, pDst, len);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsSqr_8u_ISfs(Fw8u* pSrcDst, int len, int scaleFactor)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsSqr_8u_ISfs(pSrcDst, len, scaleFactor);
    case DT_SSE2:
        return _sse2_fwsSqr_8u_ISfs(pSrcDst, len, scaleFactor);
    case DT_REFR:
        return _refr_fwsSqr_8u_ISfs(pSrcDst, len, scaleFactor);
    default:
        assert(false);
        return _refr_fwsSqr_8u_ISfs(pSrcDst, len, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsSqrt_16s_ISfs(Fw16s* pSrcDst, int len, int scaleFactor)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsSqrt_16s_ISfs(pSrcDst, len, scaleFactor);
    case DT_SSE2:
        return _sse2_fwsSqrt_16s_ISfs(pSrcDst, len, scaleFactor);
    case DT_REFR:
        return _refr_fwsSqrt_16s_ISfs(pSrcDst, len, scaleFactor);
    default:
        assert(false);
        return _refr_fwsSqrt_16s_ISfs(pSrcDst, len, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsDivCRev_32f_I(Fw32f val, Fw32f* pSrcDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsDivCRev_32f_I(val, pSrcDst, len);
    case DT_SSE2:
        return _sse2_fwsDivCRev_32f_I(val, pSrcDst, len);
    case DT_REFR:
        return _refr_fwsDivCRev_32f_I(val, pSrcDst, len);
    default:
        assert(false);
        return _refr_fwsDivCRev_32f_I(val, pSrcDst, len);
    }
}

OREFR OSSE2 FwStatus STDCALL fwsStdDev_16s_Sfs(const Fw16s* pSrc, int len, Fw16s* pStdDev, int scaleFactor)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwsStdDev_16s_Sfs(pSrc, len, pStdDev, scaleFactor);
    case DT_REFR:
        return _refr_fwsStdDev_16s_Sfs(pSrc, len, pStdDev, scaleFactor);
    default:
        assert(false);
        return _refr_fwsStdDev_16s_Sfs(pSrc, len, pStdDev, scaleFactor);
    }
}

OREFR OSSE2 FwStatus STDCALL fwsDotProd_64fc(const Fw64fc* pSrc1, const Fw64fc* pSrc2, int len,Fw64fc* pDp)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwsDotProd_64fc(pSrc1, pSrc2, len, pDp);
    case DT_REFR:
        return _refr_fwsDotProd_64fc(pSrc1, pSrc2, len, pDp);
    default:
        assert(false);
        return _refr_fwsDotProd_64fc(pSrc1, pSrc2, len, pDp);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsAddProduct_32s_Sfs(const Fw32s* pSrc1, const Fw32s* pSrc2, Fw32s* pSrcDst, int len, int scaleFactor)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsAddProduct_32s_Sfs(pSrc1, pSrc2, pSrcDst, len, scaleFactor);
    case DT_SSE2:
        return _sse2_fwsAddProduct_32s_Sfs(pSrc1, pSrc2, pSrcDst, len, scaleFactor);
    case DT_REFR:
        return _refr_fwsAddProduct_32s_Sfs(pSrc1, pSrc2, pSrcDst, len, scaleFactor);
    default:
        assert(false);
        return _refr_fwsAddProduct_32s_Sfs(pSrc1, pSrc2, pSrcDst, len, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsSub_16s_Sfs(const Fw16s* pSrc1, const Fw16s* pSrc2, Fw16s* pDst, int len, int scaleFactor)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsSub_16s_Sfs(pSrc1, pSrc2, pDst, len, scaleFactor);
    case DT_SSE2:
        return _sse2_fwsSub_16s_Sfs(pSrc1, pSrc2, pDst, len, scaleFactor);
    case DT_REFR:
        return _refr_fwsSub_16s_Sfs(pSrc1, pSrc2, pDst, len, scaleFactor);
    default:
        assert(false);
        return _refr_fwsSub_16s_Sfs(pSrc1, pSrc2, pDst, len, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsAdd_16s_ISfs(const Fw16s* pSrc, Fw16s* pSrcDst, int len, int scaleFactor)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsAdd_16s_ISfs(pSrc, pSrcDst, len, scaleFactor);
    case DT_SSE2:
        return _sse2_fwsAdd_16s_ISfs(pSrc, pSrcDst, len, scaleFactor);
    case DT_REFR:
        return _refr_fwsAdd_16s_ISfs(pSrc, pSrcDst, len, scaleFactor);
    default:
        assert(false);
        return _refr_fwsAdd_16s_ISfs(pSrc, pSrcDst, len, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsSqr_32f_I(Fw32f* pSrcDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsSqr_32f_I(pSrcDst, len);
    case DT_SSE2:
        return _sse2_fwsSqr_32f_I(pSrcDst, len);
    case DT_REFR:
        return _refr_fwsSqr_32f_I(pSrcDst, len);
    default:
        assert(false);
        return _refr_fwsSqr_32f_I(pSrcDst, len);
    }
}

OREFR             FwStatus STDCALL fwsAcosh_64f_A53(const Fw64f* pSrc, Fw64f* pDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwsAcosh_64f_A53(pSrc, pDst, len);
    default:
        assert(false);
        return _refr_fwsAcosh_64f_A53(pSrc, pDst, len);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsSubC_64fc(const Fw64fc* pSrc, Fw64fc val, Fw64fc* pDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsSubC_64fc(pSrc, val, pDst, len);
    case DT_SSE2:
        return _sse2_fwsSubC_64fc(pSrc, val, pDst, len);
    case DT_REFR:
        return _refr_fwsSubC_64fc(pSrc, val, pDst, len);
    default:
        assert(false);
        return _refr_fwsSubC_64fc(pSrc, val, pDst, len);
    }
}

OREFR             FwStatus STDCALL fwsCosh_64f_A53(const Fw64f* pSrc, Fw64f* pDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwsCosh_64f_A53(pSrc, pDst, len);
    default:
        assert(false);
        return _refr_fwsCosh_64f_A53(pSrc, pDst, len);
    }
}

OREFR             FwStatus STDCALL fwsCosh_64f_A50(const Fw64f* pSrc, Fw64f* pDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwsCosh_64f_A50(pSrc, pDst, len);
    default:
        assert(false);
        return _refr_fwsCosh_64f_A50(pSrc, pDst, len);
    }
}

OREFR OSSE2 FwStatus STDCALL fwsDotProd_16sc64sc(const Fw16sc* pSrc1, const Fw16sc* pSrc2, int len, Fw64sc* pDp)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwsDotProd_16sc64sc(pSrc1, pSrc2, len, pDp);
    case DT_REFR:
        return _refr_fwsDotProd_16sc64sc(pSrc1, pSrc2, len, pDp);
    default:
        assert(false);
        return _refr_fwsDotProd_16sc64sc(pSrc1, pSrc2, len, pDp);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsThreshold_32f(const Fw32f* pSrc, Fw32f* pDst, int len, Fw32f level, FwCmpOp relOp)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsThreshold_32f(pSrc, pDst, len, level, relOp);
    case DT_SSE2:
        return _sse2_fwsThreshold_32f(pSrc, pDst, len, level, relOp);
    case DT_REFR:
        return _refr_fwsThreshold_32f(pSrc, pDst, len, level, relOp);
    default:
        assert(false);
        return _refr_fwsThreshold_32f(pSrc, pDst, len, level, relOp);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsSqrt_64f_I(Fw64f* pSrcDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsSqrt_64f_I(pSrcDst, len);
    case DT_SSE2:
        return _sse2_fwsSqrt_64f_I(pSrcDst, len);
    case DT_REFR:
        return _refr_fwsSqrt_64f_I(pSrcDst, len);
    default:
        assert(false);
        return _refr_fwsSqrt_64f_I(pSrcDst, len);
    }
}

OREFR OSSE2 FwStatus STDCALL fwsDotProd_32fc64fc(const Fw32fc* pSrc1, const Fw32fc* pSrc2, int len, Fw64fc* pDp)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwsDotProd_32fc64fc(pSrc1, pSrc2, len, pDp);
    case DT_REFR:
        return _refr_fwsDotProd_32fc64fc(pSrc1, pSrc2, len, pDp);
    default:
        assert(false);
        return _refr_fwsDotProd_32fc64fc(pSrc1, pSrc2, len, pDp);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsSubCRev_32fc(const Fw32fc* pSrc, Fw32fc val, Fw32fc* pDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsSubCRev_32fc(pSrc, val, pDst, len);
    case DT_SSE2:
        return _sse2_fwsSubCRev_32fc(pSrc, val, pDst, len);
    case DT_REFR:
        return _refr_fwsSubCRev_32fc(pSrc, val, pDst, len);
    default:
        assert(false);
        return _refr_fwsSubCRev_32fc(pSrc, val, pDst, len);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsDiv_32fc_I(const Fw32fc* pSrc, Fw32fc* pSrcDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsDiv_32fc_I(pSrc, pSrcDst, len);
    case DT_SSE2:
        return _sse2_fwsDiv_32fc_I(pSrc, pSrcDst, len);
    case DT_REFR:
        return _refr_fwsDiv_32fc_I(pSrc, pSrcDst, len);
    default:
        assert(false);
        return _refr_fwsDiv_32fc_I(pSrc, pSrcDst, len);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsSqrt_64fc_I(Fw64fc* pSrcDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsSqrt_64fc_I(pSrcDst, len);
    case DT_SSE2:
        return _sse2_fwsSqrt_64fc_I(pSrcDst, len);
    case DT_REFR:
        return _refr_fwsSqrt_64fc_I(pSrcDst, len);
    default:
        assert(false);
        return _refr_fwsSqrt_64fc_I(pSrcDst, len);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsAddC_32sc_Sfs(const Fw32sc* pSrc, Fw32sc val, Fw32sc* pDst, int len, int scaleFactor)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsAddC_32sc_Sfs(pSrc, val, pDst, len, scaleFactor);
    case DT_SSE2:
        return _sse2_fwsAddC_32sc_Sfs(pSrc, val, pDst, len, scaleFactor);
    case DT_REFR:
        return _refr_fwsAddC_32sc_Sfs(pSrc, val, pDst, len, scaleFactor);
    default:
        assert(false);
        return _refr_fwsAddC_32sc_Sfs(pSrc, val, pDst, len, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsDivCRev_16u_I(Fw16u val, Fw16u* pSrcDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsDivCRev_16u_I(val, pSrcDst, len);
    case DT_SSE2:
        return _sse2_fwsDivCRev_16u_I(val, pSrcDst, len);
    case DT_REFR:
        return _refr_fwsDivCRev_16u_I(val, pSrcDst, len);
    default:
        assert(false);
        return _refr_fwsDivCRev_16u_I(val, pSrcDst, len);
    }
}

OREFR OSSE2 FwStatus STDCALL fwsDotProd_16s_Sfs(const Fw16s* pSrc1, const Fw16s* pSrc2, int len, Fw16s* pDp, int scaleFactor)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwsDotProd_16s_Sfs(pSrc1, pSrc2, len, pDp, scaleFactor);
    case DT_REFR:
        return _refr_fwsDotProd_16s_Sfs(pSrc1, pSrc2, len, pDp, scaleFactor);
    default:
        assert(false);
        return _refr_fwsDotProd_16s_Sfs(pSrc1, pSrc2, len, pDp, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsAndC_8u_I(Fw8u val, Fw8u* pSrcDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsAndC_8u_I(val, pSrcDst, len);
    case DT_SSE2:
        return _sse2_fwsAndC_8u_I(val, pSrcDst, len);
    case DT_REFR:
        return _refr_fwsAndC_8u_I(val, pSrcDst, len);
    default:
        assert(false);
        return _refr_fwsAndC_8u_I(val, pSrcDst, len);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsThreshold_16s_I(Fw16s* pSrcDst, int len, Fw16s level, FwCmpOp relOp)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsThreshold_16s_I(pSrcDst, len, level, relOp);
    case DT_SSE2:
        return _sse2_fwsThreshold_16s_I(pSrcDst, len, level, relOp);
    case DT_REFR:
        return _refr_fwsThreshold_16s_I(pSrcDst, len, level, relOp);
    default:
        assert(false);
        return _refr_fwsThreshold_16s_I(pSrcDst, len, level, relOp);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsAbs_32f(const Fw32f* pSrc, Fw32f* pDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsAbs_32f(pSrc, pDst, len);
    case DT_SSE2:
        return _sse2_fwsAbs_32f(pSrc, pDst, len);
    case DT_REFR:
        return _refr_fwsAbs_32f(pSrc, pDst, len);
    default:
        assert(false);
        return _refr_fwsAbs_32f(pSrc, pDst, len);
    }
}

OREFR OSSE2 FwStatus STDCALL fwsNorm_Inf_16s32s_Sfs(const Fw16s* pSrc, int len, Fw32s* pNorm,int scaleFactor)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwsNorm_Inf_16s32s_Sfs(pSrc, len, pNorm, scaleFactor);
    case DT_REFR:
        return _refr_fwsNorm_Inf_16s32s_Sfs(pSrc, len, pNorm, scaleFactor);
    default:
        assert(false);
        return _refr_fwsNorm_Inf_16s32s_Sfs(pSrc, len, pNorm, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsInvSqrt_32f_A24(const Fw32f* pSrc, Fw32f* pDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsInvSqrt_32f_A24(pSrc, pDst, len);
    case DT_SSE2:
        return _sse2_fwsInvSqrt_32f_A24(pSrc, pDst, len);
    case DT_REFR:
        return _refr_fwsInvSqrt_32f_A24(pSrc, pDst, len);
    default:
        assert(false);
        return _refr_fwsInvSqrt_32f_A24(pSrc, pDst, len);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsXor_16u_I(const Fw16u* pSrc, Fw16u* pSrcDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsXor_16u_I(pSrc, pSrcDst, len);
    case DT_SSE2:
        return _sse2_fwsXor_16u_I(pSrc, pSrcDst, len);
    case DT_REFR:
        return _refr_fwsXor_16u_I(pSrc, pSrcDst, len);
    default:
        assert(false);
        return _refr_fwsXor_16u_I(pSrc, pSrcDst, len);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsAdd_32fc_I(const Fw32fc* pSrc, Fw32fc* pSrcDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsAdd_32fc_I(pSrc, pSrcDst, len);
    case DT_SSE2:
        return _sse2_fwsAdd_32fc_I(pSrc, pSrcDst, len);
    case DT_REFR:
        return _refr_fwsAdd_32fc_I(pSrc, pSrcDst, len);
    default:
        assert(false);
        return _refr_fwsAdd_32fc_I(pSrc, pSrcDst, len);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsAnd_32u_I(const Fw32u* pSrc, Fw32u* pSrcDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsAnd_32u_I(pSrc, pSrcDst, len);
    case DT_SSE2:
        return _sse2_fwsAnd_32u_I(pSrc, pSrcDst, len);
    case DT_REFR:
        return _refr_fwsAnd_32u_I(pSrc, pSrcDst, len);
    default:
        assert(false);
        return _refr_fwsAnd_32u_I(pSrc, pSrcDst, len);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsAddC_32s_Sfs(const Fw32s* pSrc, Fw32s val, Fw32s* pDst, int len, int scaleFactor)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsAddC_32s_Sfs(pSrc, val, pDst, len, scaleFactor);
    case DT_SSE2:
        return _sse2_fwsAddC_32s_Sfs(pSrc, val, pDst, len, scaleFactor);
    case DT_REFR:
        return _refr_fwsAddC_32s_Sfs(pSrc, val, pDst, len, scaleFactor);
    default:
        assert(false);
        return _refr_fwsAddC_32s_Sfs(pSrc, val, pDst, len, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsAbs_32s(const Fw32s* pSrc, Fw32s* pDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsAbs_32s(pSrc, pDst, len);
    case DT_SSE2:
        return _sse2_fwsAbs_32s(pSrc, pDst, len);
    case DT_REFR:
        return _refr_fwsAbs_32s(pSrc, pDst, len);
    default:
        assert(false);
        return _refr_fwsAbs_32s(pSrc, pDst, len);
    }
}

OREFR       FwStatus STDCALL fwsMaxIndx_64f(const Fw64f* pSrc, int len, Fw64f* pMax, int* pIndx)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwsMaxIndx_64f(pSrc, len, pMax, pIndx);
    default:
        assert(false);
        return _refr_fwsMaxIndx_64f(pSrc, len, pMax, pIndx);
    }
}


OREFR OSSE2 OF10H FwStatus STDCALL fwsCopy_8u(const Fw8u* pSrc, Fw8u* pDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsCopy_8u(pSrc, pDst, len);
    case DT_SSE2:
        return _sse2_fwsCopy_8u(pSrc, pDst, len);
    case DT_REFR:
        return _refr_fwsCopy_8u(pSrc, pDst, len);
    default:
        assert(false);
        return _refr_fwsCopy_8u(pSrc, pDst, len);
    }
}

OREFR             FwStatus STDCALL fwsCosh_32f_A11(const Fw32f* pSrc, Fw32f* pDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwsCosh_32f_A11(pSrc, pDst, len);
    default:
        assert(false);
        return _refr_fwsCosh_32f_A11(pSrc, pDst, len);
    }
}

OREFR             FwStatus STDCALL fwsTanh_64f_A50(const Fw64f* pSrc, Fw64f* pDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwsTanh_64f_A50(pSrc, pDst, len);
    default:
        assert(false);
        return _refr_fwsTanh_64f_A50(pSrc, pDst, len);
    }
}

OREFR             FwStatus STDCALL fwsAcos_64f_A53(const Fw64f* pSrc, Fw64f* pDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwsAcos_64f_A53(pSrc, pDst, len);
    default:
        assert(false);
        return _refr_fwsAcos_64f_A53(pSrc, pDst, len);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsInv_32f_A21(const Fw32f* pSrc, Fw32f* pDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsInv_32f_A21(pSrc, pDst, len);
    case DT_SSE2:
        return _sse2_fwsInv_32f_A21(pSrc, pDst, len);
    case DT_REFR:
        return _refr_fwsInv_32f_A21(pSrc, pDst, len);
    default:
        assert(false);
        return _refr_fwsInv_32f_A21(pSrc, pDst, len);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsRShiftC_16u_I(int val, Fw16u* pSrcDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsRShiftC_16u_I(val, pSrcDst, len);
    case DT_SSE2:
        return _sse2_fwsRShiftC_16u_I(val, pSrcDst, len);
    case DT_REFR:
        return _refr_fwsRShiftC_16u_I(val, pSrcDst, len);
    default:
        assert(false);
        return _refr_fwsRShiftC_16u_I(val, pSrcDst, len);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsInv_32f_A24(const Fw32f* pSrc, Fw32f* pDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsInv_32f_A24(pSrc, pDst, len);
    case DT_SSE2:
        return _sse2_fwsInv_32f_A24(pSrc, pDst, len);
    case DT_REFR:
        return _refr_fwsInv_32f_A24(pSrc, pDst, len);
    default:
        assert(false);
        return _refr_fwsInv_32f_A24(pSrc, pDst, len);
    }
}

OREFR OSSE2 FwStatus STDCALL fwsNorm_Inf_16s32f(const Fw16s* pSrc, int len, Fw32f* pNorm)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwsNorm_Inf_16s32f(pSrc, len, pNorm);
    case DT_REFR:
        return _refr_fwsNorm_Inf_16s32f(pSrc, len, pNorm);
    default:
        assert(false);
        return _refr_fwsNorm_Inf_16s32f(pSrc, len, pNorm);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsSubCRev_32fc_I(Fw32fc val, Fw32fc* pSrcDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsSubCRev_32fc_I(val, pSrcDst, len);
    case DT_SSE2:
        return _sse2_fwsSubCRev_32fc_I(val, pSrcDst, len);
    case DT_REFR:
        return _refr_fwsSubCRev_32fc_I(val, pSrcDst, len);
    default:
        assert(false);
        return _refr_fwsSubCRev_32fc_I(val, pSrcDst, len);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsSubC_32s_Sfs(const Fw32s* pSrc, Fw32s val, Fw32s* pDst, int len, int scaleFactor)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsSubC_32s_Sfs(pSrc, val, pDst, len, scaleFactor);
    case DT_SSE2:
        return _sse2_fwsSubC_32s_Sfs(pSrc, val, pDst, len, scaleFactor);
    case DT_REFR:
        return _refr_fwsSubC_32s_Sfs(pSrc, val, pDst, len, scaleFactor);
    default:
        assert(false);
        return _refr_fwsSubC_32s_Sfs(pSrc, val, pDst, len, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsLn_64f_A50(const Fw64f* pSrc, Fw64f* pDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsLn_64f_A50(pSrc, pDst, len);
    case DT_SSE2:
        return _sse2_fwsLn_64f_A50(pSrc, pDst, len);
    case DT_REFR:
        return _refr_fwsLn_64f_A50(pSrc, pDst, len);
    default:
        assert(false);
        return _refr_fwsLn_64f_A50(pSrc, pDst, len);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsOrC_32u(const Fw32u* pSrc, Fw32u val, Fw32u* pDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsOrC_32u(pSrc, val, pDst, len);
    case DT_SSE2:
        return _sse2_fwsOrC_32u(pSrc, val, pDst, len);
    case DT_REFR:
        return _refr_fwsOrC_32u(pSrc, val, pDst, len);
    default:
        assert(false);
        return _refr_fwsOrC_32u(pSrc, val, pDst, len);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsSqrt_64f_A53( const Fw64f* pSrc, Fw64f* pDst, int len )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsSqrt_64f_A53(pSrc, pDst, len);
    case DT_SSE2:
        return _sse2_fwsSqrt_64f_A53(pSrc, pDst, len);
    case DT_REFR:
        return _refr_fwsSqrt_64f_A53(pSrc, pDst, len);
    default:
        assert(false);
        return _refr_fwsSqrt_64f_A53(pSrc, pDst, len);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsConvert_32f32s_Sfs(const Fw32f* pSrc, Fw32s* pDst, int len, FwRoundMode rndMode, int scaleFactor)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsConvert_32f32s_Sfs(pSrc, pDst, len, rndMode, scaleFactor);
    case DT_SSE2:
        return _sse2_fwsConvert_32f32s_Sfs(pSrc, pDst, len, rndMode, scaleFactor);
    case DT_REFR:
        return _refr_fwsConvert_32f32s_Sfs(pSrc, pDst, len, rndMode, scaleFactor);
    default:
        assert(false);
        return _refr_fwsConvert_32f32s_Sfs(pSrc, pDst, len, rndMode, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsZero_32fc(Fw32fc* pDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsZero_32fc(pDst, len);
    case DT_SSE2:
        return _sse2_fwsZero_32fc(pDst, len);
    case DT_REFR:
        return _refr_fwsZero_32fc(pDst, len);
    default:
        assert(false);
        return _refr_fwsZero_32fc(pDst, len);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsMagnitude_16sc32f(const Fw16sc* pSrc, Fw32f* pDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsMagnitude_16sc32f(pSrc, pDst, len);
    case DT_SSE2:
        return _sse2_fwsMagnitude_16sc32f(pSrc, pDst, len);
    case DT_REFR:
        return _refr_fwsMagnitude_16sc32f(pSrc, pDst, len);
    default:
        assert(false);
        return _refr_fwsMagnitude_16sc32f(pSrc, pDst, len);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsMul_32sc_Sfs(const Fw32sc* pSrc1, const Fw32sc* pSrc2, Fw32sc *pDst, int len, int scaleFactor)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsMul_32sc_Sfs(pSrc1, pSrc2, pDst, len, scaleFactor);
    case DT_SSE2:
        return _sse2_fwsMul_32sc_Sfs(pSrc1, pSrc2, pDst, len, scaleFactor);
    case DT_REFR:
        return _refr_fwsMul_32sc_Sfs(pSrc1, pSrc2, pDst, len, scaleFactor);
    default:
        assert(false);
        return _refr_fwsMul_32sc_Sfs(pSrc1, pSrc2, pDst, len, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsConvert_64f32f(const Fw64f* pSrc, Fw32f* pDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsConvert_64f32f(pSrc, pDst, len);
    case DT_SSE2:
        return _sse2_fwsConvert_64f32f(pSrc, pDst, len);
    case DT_REFR:
        return _refr_fwsConvert_64f32f(pSrc, pDst, len);
    default:
        assert(false);
        return _refr_fwsConvert_64f32f(pSrc, pDst, len);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsMul_8u_ISfs(const Fw8u* pSrc, Fw8u* pSrcDst, int len, int scaleFactor)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsMul_8u_ISfs(pSrc, pSrcDst, len, scaleFactor);
    case DT_SSE2:
        return _sse2_fwsMul_8u_ISfs(pSrc, pSrcDst, len, scaleFactor);
    case DT_REFR:
        return _refr_fwsMul_8u_ISfs(pSrc, pSrcDst, len, scaleFactor);
    default:
        assert(false);
        return _refr_fwsMul_8u_ISfs(pSrc, pSrcDst, len, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsNot_32u_I(Fw32u* pSrcDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsNot_32u_I(pSrcDst, len);
    case DT_SSE2:
        return _sse2_fwsNot_32u_I(pSrcDst, len);
    case DT_REFR:
        return _refr_fwsNot_32u_I(pSrcDst, len);
    default:
        assert(false);
        return _refr_fwsNot_32u_I(pSrcDst, len);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsSubCRev_64f(const Fw64f* pSrc, Fw64f val, Fw64f* pDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsSubCRev_64f(pSrc, val, pDst, len);
    case DT_SSE2:
        return _sse2_fwsSubCRev_64f(pSrc, val, pDst, len);
    case DT_REFR:
        return _refr_fwsSubCRev_64f(pSrc, val, pDst, len);
    default:
        assert(false);
        return _refr_fwsSubCRev_64f(pSrc, val, pDst, len);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsThreshold_GTVal_32fc(const Fw32fc* pSrc, Fw32fc* pDst, int len, Fw32f level, Fw32fc value)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsThreshold_GTVal_32fc(pSrc, pDst, len, level, value);
    case DT_SSE2:
        return _sse2_fwsThreshold_GTVal_32fc(pSrc, pDst, len, level, value);
    case DT_REFR:
        return _refr_fwsThreshold_GTVal_32fc(pSrc, pDst, len, level, value);
    default:
        assert(false);
        return _refr_fwsThreshold_GTVal_32fc(pSrc, pDst, len, level, value);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsAtan_32f_A21(const Fw32f* pSrc, Fw32f* pDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsAtan_32f_A21(pSrc, pDst, len);
    case DT_SSE2:
        return _sse2_fwsAtan_32f_A21(pSrc, pDst, len);
    case DT_REFR:
        return _refr_fwsAtan_32f_A21(pSrc, pDst, len);
    default:
        assert(false);
        return _refr_fwsAtan_32f_A21(pSrc, pDst, len);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsSubCRev_32sc_ISfs(Fw32sc val, Fw32sc* pSrcDst, int len, int scaleFactor)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsSubCRev_32sc_ISfs(val, pSrcDst, len, scaleFactor);
    case DT_SSE2:
        return _sse2_fwsSubCRev_32sc_ISfs(val, pSrcDst, len, scaleFactor);
    case DT_REFR:
        return _refr_fwsSubCRev_32sc_ISfs(val, pSrcDst, len, scaleFactor);
    default:
        assert(false);
        return _refr_fwsSubCRev_32sc_ISfs(val, pSrcDst, len, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsExp_64f_A50(const Fw64f* pSrc, Fw64f* pDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsExp_64f_A50(pSrc, pDst, len);
    case DT_SSE2:
        return _sse2_fwsExp_64f_A50(pSrc, pDst, len);
    case DT_REFR:
        return _refr_fwsExp_64f_A50(pSrc, pDst, len);
    default:
        assert(false);
        return _refr_fwsExp_64f_A50(pSrc, pDst, len);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsExp_64f_A53(const Fw64f* pSrc, Fw64f* pDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsExp_64f_A53(pSrc, pDst, len);
    case DT_SSE2:
        return _sse2_fwsExp_64f_A53(pSrc, pDst, len);
    case DT_REFR:
        return _refr_fwsExp_64f_A53(pSrc, pDst, len);
    default:
        assert(false);
        return _refr_fwsExp_64f_A53(pSrc, pDst, len);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsSqrt_32f_A11( const Fw32f* pSrc, Fw32f* pDst, int len )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsSqrt_32f_A11(pSrc, pDst, len);
    case DT_SSE2:
        return _sse2_fwsSqrt_32f_A11(pSrc, pDst, len);
    case DT_REFR:
        return _refr_fwsSqrt_32f_A11(pSrc, pDst, len);
    default:
        assert(false);
        return _refr_fwsSqrt_32f_A11(pSrc, pDst, len);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsAdd_32sc_Sfs(const Fw32sc* pSrc1, const Fw32sc* pSrc2, Fw32sc* pDst, int len, int scaleFactor)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsAdd_32sc_Sfs(pSrc1, pSrc2, pDst, len, scaleFactor);
    case DT_SSE2:
        return _sse2_fwsAdd_32sc_Sfs(pSrc1, pSrc2, pDst, len, scaleFactor);
    case DT_REFR:
        return _refr_fwsAdd_32sc_Sfs(pSrc1, pSrc2, pDst, len, scaleFactor);
    default:
        assert(false);
        return _refr_fwsAdd_32sc_Sfs(pSrc1, pSrc2, pDst, len, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsAndC_8u(const Fw8u* pSrc, Fw8u val, Fw8u* pDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsAndC_8u(pSrc, val, pDst, len);
    case DT_SSE2:
        return _sse2_fwsAndC_8u(pSrc, val, pDst, len);
    case DT_REFR:
        return _refr_fwsAndC_8u(pSrc, val, pDst, len);
    default:
        assert(false);
        return _refr_fwsAndC_8u(pSrc, val, pDst, len);
    }
}

OREFR OSSE2 FwStatus STDCALL fwsDotProd_64f64fc(const Fw64f* pSrc1, const Fw64fc* pSrc2, int len, Fw64fc* pDp)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwsDotProd_64f64fc(pSrc1, pSrc2, len, pDp);
    case DT_REFR:
        return _refr_fwsDotProd_64f64fc(pSrc1, pSrc2, len, pDp);
    default:
        assert(false);
        return _refr_fwsDotProd_64f64fc(pSrc1, pSrc2, len, pDp);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsAndC_16u_I(Fw16u val, Fw16u* pSrcDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsAndC_16u_I(val, pSrcDst, len);
    case DT_SSE2:
        return _sse2_fwsAndC_16u_I(val, pSrcDst, len);
    case DT_REFR:
        return _refr_fwsAndC_16u_I(val, pSrcDst, len);
    default:
        assert(false);
        return _refr_fwsAndC_16u_I(val, pSrcDst, len);
    }
}

OREFR             FwStatus STDCALL fwsCosh_32f_A24(const Fw32f* pSrc, Fw32f* pDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwsCosh_32f_A24(pSrc, pDst, len);
    default:
        assert(false);
        return _refr_fwsCosh_32f_A24(pSrc, pDst, len);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsDivC_16s_Sfs(const Fw16s* pSrc, Fw16s val, Fw16s* pDst, int len, int scaleFactor)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsDivC_16s_Sfs(pSrc, val, pDst, len, scaleFactor);
    case DT_SSE2:
        return _sse2_fwsDivC_16s_Sfs(pSrc, val, pDst, len, scaleFactor);
    case DT_REFR:
        return _refr_fwsDivC_16s_Sfs(pSrc, val, pDst, len, scaleFactor);
    default:
        assert(false);
        return _refr_fwsDivC_16s_Sfs(pSrc, val, pDst, len, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsAdd_64f(const Fw64f* pSrc1, const Fw64f* pSrc2, Fw64f* pDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsAdd_64f(pSrc1, pSrc2, pDst, len);
    case DT_SSE2:
        return _sse2_fwsAdd_64f(pSrc1, pSrc2, pDst, len);
    case DT_REFR:
        return _refr_fwsAdd_64f(pSrc1, pSrc2, pDst, len);
    default:
        assert(false);
        return _refr_fwsAdd_64f(pSrc1, pSrc2, pDst, len);
    }
}

OREFR FwStatus STDCALL fwsFindRevC_16u(const Fw16u* pSrc, int len, Fw16u valFind, int* pIndex)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwsFindRevC_16u(pSrc, len, valFind, pIndex);
    default:
        assert(false);
        return _refr_fwsFindRevC_16u(pSrc, len, valFind, pIndex);
    }
}

OREFR OSSE2 FwStatus STDCALL fwsNormDiff_L2_64fc64f(const Fw64fc* pSrc1, const Fw64fc* pSrc2, int len, Fw64f* pNorm)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwsNormDiff_L2_64fc64f(pSrc1, pSrc2, len, pNorm);
    case DT_REFR:
        return _refr_fwsNormDiff_L2_64fc64f(pSrc1, pSrc2, len, pNorm);
    default:
        assert(false);
        return _refr_fwsNormDiff_L2_64fc64f(pSrc1, pSrc2, len, pNorm);
    }
}

OREFR OSSE2 FwStatus STDCALL fwsDotProd_16sc32fc(const Fw16sc* pSrc1, const Fw16sc* pSrc2, int len, Fw32fc* pDp)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwsDotProd_16sc32fc(pSrc1, pSrc2, len, pDp);
    case DT_REFR:
        return _refr_fwsDotProd_16sc32fc(pSrc1, pSrc2, len, pDp);
    default:
        assert(false);
        return _refr_fwsDotProd_16sc32fc(pSrc1, pSrc2, len, pDp);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsThreshold_GT_64f_I(Fw64f* pSrcDst, int len, Fw64f level)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsThreshold_GT_64f_I(pSrcDst, len, level);
    case DT_SSE2:
        return _sse2_fwsThreshold_GT_64f_I(pSrcDst, len, level);
    case DT_REFR:
        return _refr_fwsThreshold_GT_64f_I(pSrcDst, len, level);
    default:
        assert(false);
        return _refr_fwsThreshold_GT_64f_I(pSrcDst, len, level);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsLShiftC_16s_I(int val, Fw16s* pSrcDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsLShiftC_16s_I(val, pSrcDst, len);
    case DT_SSE2:
        return _sse2_fwsLShiftC_16s_I(val, pSrcDst, len);
    case DT_REFR:
        return _refr_fwsLShiftC_16s_I(val, pSrcDst, len);
    default:
        assert(false);
        return _refr_fwsLShiftC_16s_I(val, pSrcDst, len);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsAdd_64s(const Fw64s* pSrc1, const Fw64s* pSrc2, Fw64s* pDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsAdd_64s(pSrc1, pSrc2, pDst, len);
    case DT_SSE2:
        return _sse2_fwsAdd_64s(pSrc1, pSrc2, pDst, len);
    case DT_REFR:
        return _refr_fwsAdd_64s(pSrc1, pSrc2, pDst, len);
    default:
        assert(false);
        return _refr_fwsAdd_64s(pSrc1, pSrc2, pDst, len);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsConvert_32f16u_Sfs(const Fw32f* pSrc, Fw16u* pDst, int len, FwRoundMode rndMode, int scaleFactor)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsConvert_32f16u_Sfs(pSrc, pDst, len, rndMode, scaleFactor);
    case DT_SSE2:
        return _sse2_fwsConvert_32f16u_Sfs(pSrc, pDst, len, rndMode, scaleFactor);
    case DT_REFR:
        return _refr_fwsConvert_32f16u_Sfs(pSrc, pDst, len, rndMode, scaleFactor);
    default:
        assert(false);
        return _refr_fwsConvert_32f16u_Sfs(pSrc, pDst, len, rndMode, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsOr_32u(const Fw32u* pSrc1, const Fw32u* pSrc2, Fw32u* pDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsOr_32u(pSrc1, pSrc2, pDst, len);
    case DT_SSE2:
        return _sse2_fwsOr_32u(pSrc1, pSrc2, pDst, len);
    case DT_REFR:
        return _refr_fwsOr_32u(pSrc1, pSrc2, pDst, len);
    default:
        assert(false);
        return _refr_fwsOr_32u(pSrc1, pSrc2, pDst, len);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsCbrt_64f_A53(const Fw64f* pSrc, Fw64f* pDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsCbrt_64f_A53(pSrc, pDst, len);
    case DT_SSE2:
        return _sse2_fwsCbrt_64f_A53(pSrc, pDst, len);
    case DT_REFR:
        return _refr_fwsCbrt_64f_A53(pSrc, pDst, len);
    default:
        assert(false);
        return _refr_fwsCbrt_64f_A53(pSrc, pDst, len);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsThreshold_GTVal_16sc(const Fw16sc* pSrc, Fw16sc* pDst, int len, Fw16s level, Fw16sc value)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsThreshold_GTVal_16sc(pSrc, pDst, len, level, value);
    case DT_SSE2:
        return _sse2_fwsThreshold_GTVal_16sc(pSrc, pDst, len, level, value);
    case DT_REFR:
        return _refr_fwsThreshold_GTVal_16sc(pSrc, pDst, len, level, value);
    default:
        assert(false);
        return _refr_fwsThreshold_GTVal_16sc(pSrc, pDst, len, level, value);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsMul_32f_I(const Fw32f* pSrc, Fw32f* pSrcDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsMul_32f_I(pSrc, pSrcDst, len);
    case DT_SSE2:
        return _sse2_fwsMul_32f_I(pSrc, pSrcDst, len);
    case DT_REFR:
        return _refr_fwsMul_32f_I(pSrc, pSrcDst, len);
    default:
        assert(false);
        return _refr_fwsMul_32f_I(pSrc, pSrcDst, len);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsThreshold_LT_32f(const Fw32f* pSrc, Fw32f* pDst, int len, Fw32f level)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsThreshold_LT_32f(pSrc, pDst, len, level);
    case DT_SSE2:
        return _sse2_fwsThreshold_LT_32f(pSrc, pDst, len, level);
    case DT_REFR:
        return _refr_fwsThreshold_LT_32f(pSrc, pDst, len, level);
    default:
        assert(false);
        return _refr_fwsThreshold_LT_32f(pSrc, pDst, len, level);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsThreshold_GTVal_16s(const Fw16s* pSrc, Fw16s* pDst, int len, Fw16s level, Fw16s value)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsThreshold_GTVal_16s(pSrc, pDst, len, level, value);
    case DT_SSE2:
        return _sse2_fwsThreshold_GTVal_16s(pSrc, pDst, len, level, value);
    case DT_REFR:
        return _refr_fwsThreshold_GTVal_16s(pSrc, pDst, len, level, value);
    default:
        assert(false);
        return _refr_fwsThreshold_GTVal_16s(pSrc, pDst, len, level, value);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsAtan_64f_A50(const Fw64f* pSrc, Fw64f* pDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsAtan_64f_A50(pSrc, pDst, len);
    case DT_SSE2:
        return _sse2_fwsAtan_64f_A50(pSrc, pDst, len);
    case DT_REFR:
        return _refr_fwsAtan_64f_A50(pSrc, pDst, len);
    default:
        assert(false);
        return _refr_fwsAtan_64f_A50(pSrc, pDst, len);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsAddC_8u_Sfs(const Fw8u* pSrc, Fw8u val, Fw8u* pDst, int len, int scaleFactor)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsAddC_8u_Sfs(pSrc, val, pDst, len, scaleFactor);
    case DT_SSE2:
        return _sse2_fwsAddC_8u_Sfs(pSrc, val, pDst, len, scaleFactor);
    case DT_REFR:
        return _refr_fwsAddC_8u_Sfs(pSrc, val, pDst, len, scaleFactor);
    default:
        assert(false);
        return _refr_fwsAddC_8u_Sfs(pSrc, val, pDst, len, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsMulC_32sc_ISfs(Fw32sc val, Fw32sc* pSrcDst, int len, int scaleFactor)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsMulC_32sc_ISfs(val, pSrcDst, len, scaleFactor);
    case DT_SSE2:
        return _sse2_fwsMulC_32sc_ISfs(val, pSrcDst, len, scaleFactor);
    case DT_REFR:
        return _refr_fwsMulC_32sc_ISfs(val, pSrcDst, len, scaleFactor);
    default:
        assert(false);
        return _refr_fwsMulC_32sc_ISfs(val, pSrcDst, len, scaleFactor);
    }
}

OREFR             FwStatus STDCALL fwsAcos_64f_A50(const Fw64f* pSrc, Fw64f* pDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwsAcos_64f_A50(pSrc, pDst, len);
    default:
        assert(false);
        return _refr_fwsAcos_64f_A50(pSrc, pDst, len);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsThreshold_LT_32s(const Fw32s* pSrc, Fw32s* pDst, int len, Fw32s level)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsThreshold_LT_32s(pSrc, pDst, len, level);
    case DT_SSE2:
        return _sse2_fwsThreshold_LT_32s(pSrc, pDst, len, level);
    case DT_REFR:
        return _refr_fwsThreshold_LT_32s(pSrc, pDst, len, level);
    default:
        assert(false);
        return _refr_fwsThreshold_LT_32s(pSrc, pDst, len, level);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsSqrt_64f_A50( const Fw64f* pSrc, Fw64f* pDst, int len )
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsSqrt_64f_A50(pSrc, pDst, len);
    case DT_SSE2:
        return _sse2_fwsSqrt_64f_A50(pSrc, pDst, len);
    case DT_REFR:
        return _refr_fwsSqrt_64f_A50(pSrc, pDst, len);
    default:
        assert(false);
        return _refr_fwsSqrt_64f_A50(pSrc, pDst, len);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsDivC_16s_ISfs(Fw16s val, Fw16s* pSrcDst, int len, int scaleFactor)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsDivC_16s_ISfs(val, pSrcDst, len, scaleFactor);
    case DT_SSE2:
        return _sse2_fwsDivC_16s_ISfs(val, pSrcDst, len, scaleFactor);
    case DT_REFR:
        return _refr_fwsDivC_16s_ISfs(val, pSrcDst, len, scaleFactor);
    default:
        assert(false);
        return _refr_fwsDivC_16s_ISfs(val, pSrcDst, len, scaleFactor);
    }
}

OREFR OSSE2 FwStatus STDCALL fwsNorm_L1_64fc64f(const Fw64fc* pSrc, int len, Fw64f* pNorm)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwsNorm_L1_64fc64f(pSrc, len, pNorm);
    case DT_REFR:
        return _refr_fwsNorm_L1_64fc64f(pSrc, len, pNorm);
    default:
        assert(false);
        return _refr_fwsNorm_L1_64fc64f(pSrc, len, pNorm);
    }
}

OREFR OSSE2 FwStatus STDCALL fwsSum_16sc_Sfs(const Fw16sc* pSrc, int len, Fw16sc* pSum, int scaleFactor)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
        return _sse2_fwsSum_16sc_Sfs(pSrc, len, pSum, scaleFactor);
    case DT_REFR:
        return _refr_fwsSum_16sc_Sfs(pSrc, len, pSum, scaleFactor);
    default:
        assert(false);
        return _refr_fwsSum_16sc_Sfs(pSrc, len, pSum, scaleFactor);
    }
}

OREFR OSSE2 OF10H FwStatus STDCALL fwsThreshold_LTVal_32fc_I(Fw32fc* pSrcDst, int len, Fw32f level, Fw32fc value)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
        return _f10h_fwsThreshold_LTVal_32fc_I(pSrcDst, len, level, value);
    case DT_SSE2:
        return _sse2_fwsThreshold_LTVal_32fc_I(pSrcDst, len, level, value);
    case DT_REFR:
        return _refr_fwsThreshold_LTVal_32fc_I(pSrcDst, len, level, value);
    default:
        assert(false);
        return _refr_fwsThreshold_LTVal_32fc_I(pSrcDst, len, level, value);
    }
}

OREFR             FwStatus STDCALL fwsCos_32f_A24(const Fw32f* pSrc, Fw32f* pDst, int len)
{
    switch( Dispatch::Type<DT_COUNT>() )
    {
    case DT_SSE3:
    case DT_F10H:
    case DT_SSE2:
    case DT_REFR:
        return _refr_fwsCos_32f_A24(pSrc, pDst, len);
    default:
        assert(false);
        return _refr_fwsCos_32f_A24(pSrc, pDst, len);
    }
}

